/* Box.c generated by valac 0.10.3, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
void box_from_rectangle (GdkRectangle* rect, Box* result);
void box_from_allocation (GtkAllocation* alloc, Box* result);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self, Box* box);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void box_get_dimensions (Box *self, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_get_rectangle (Box *self, GdkRectangle* result);
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result);
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result);
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result);
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result);
gboolean box_intersects (Box *self, Box* compare);
void box_get_reduced (Box *self, gint amount, Box* result);
void box_get_expanded (Box *self, gint amount, Box* result);
gboolean box_contains (Box *self, GdkPoint* point);
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted);
void box_rubber_band (Box *self, GdkPoint* point, Box* result);
char* box_to_string (Box *self);
char* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (double pos, gint zone);
static gboolean box_in_between (double pos, gint top, gint bottom);
static gboolean box_near_in_between (double pos, gint top, gint bottom);
BoxLocation box_approx_location (Box *self, gint x, gint y);



GType box_location_get_type (void) {
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


#line 26 "Box.vala"
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement) {
#line 126 "Box.c"
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
#line 27 "Box.vala"
	if (horizontal_complement) {
#line 27 "Box.vala"
		_tmp0_ = vertical_complement;
#line 133 "Box.c"
	} else {
#line 27 "Box.vala"
		_tmp0_ = FALSE;
#line 137 "Box.c"
	}
#line 27 "Box.vala"
	if (_tmp0_) {
#line 141 "Box.c"
		result = BOX_COMPLEMENTS_BOTH;
#line 28 "Box.vala"
		return result;
#line 145 "Box.c"
	} else {
#line 29 "Box.vala"
		if (horizontal_complement) {
#line 149 "Box.c"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 30 "Box.vala"
			return result;
#line 153 "Box.c"
		} else {
#line 31 "Box.vala"
			if (vertical_complement) {
#line 157 "Box.c"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 32 "Box.vala"
				return result;
#line 161 "Box.c"
			}
		}
	}
	result = BOX_COMPLEMENTS_NONE;
#line 34 "Box.vala"
	return result;
#line 168 "Box.c"
}


GType box_complements_get_type (void) {
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


#line 46 "Box.vala"
void box_init (Box *self, gint left, gint top, gint right, gint bottom) {
#line 186 "Box.c"
	memset (self, 0, sizeof (Box));
#line 47 "Box.vala"
	g_assert (left >= 0);
#line 48 "Box.vala"
	g_assert (top >= 0);
#line 49 "Box.vala"
	g_assert (right >= left);
#line 50 "Box.vala"
	g_assert (bottom >= top);
#line 52 "Box.vala"
	(*self).left = left;
#line 53 "Box.vala"
	(*self).top = top;
#line 54 "Box.vala"
	(*self).right = right;
#line 55 "Box.vala"
	(*self).bottom = bottom;
#line 204 "Box.c"
}


#line 58 "Box.vala"
void box_from_rectangle (GdkRectangle* rect, Box* result) {
#line 210 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*rect).x, (*rect).y, ((*rect).x + (*rect).width) - 1, ((*rect).y + (*rect).height) - 1), _tmp0_);
#line 59 "Box.vala"
	return;
#line 215 "Box.c"
}


#line 62 "Box.vala"
void box_from_allocation (GtkAllocation* alloc, Box* result) {
#line 221 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*alloc).x, (*alloc).y, ((*alloc).x + (*alloc).width) - 1, ((*alloc).y + (*alloc).height) - 1), _tmp0_);
#line 63 "Box.vala"
	return;
#line 226 "Box.c"
}


#line 68 "Box.vala"
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result) {
#line 232 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, MIN ((*corner1).x, (*corner2).x), MIN ((*corner1).y, (*corner2).y), MAX ((*corner1).x, (*corner2).x), MAX ((*corner1).y, (*corner2).y)), _tmp0_);
#line 69 "Box.vala"
	return;
#line 237 "Box.c"
}


#line 73 "Box.vala"
gint box_get_width (Box *self) {
#line 243 "Box.c"
	gint result = 0;
#line 74 "Box.vala"
	g_assert ((*self).right >= (*self).left);
#line 247 "Box.c"
	result = ((*self).right - (*self).left) + 1;
#line 76 "Box.vala"
	return result;
#line 251 "Box.c"
}


#line 79 "Box.vala"
gint box_get_height (Box *self) {
#line 257 "Box.c"
	gint result = 0;
#line 80 "Box.vala"
	g_assert ((*self).bottom >= (*self).top);
#line 261 "Box.c"
	result = ((*self).bottom - (*self).top) + 1;
#line 82 "Box.vala"
	return result;
#line 265 "Box.c"
}


#line 85 "Box.vala"
gboolean box_is_valid (Box *self) {
#line 271 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 86 "Box.vala"
	if ((*self).left >= 0) {
#line 86 "Box.vala"
		_tmp2_ = (*self).top >= 0;
#line 280 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp2_ = FALSE;
#line 284 "Box.c"
	}
#line 86 "Box.vala"
	if (_tmp2_) {
#line 86 "Box.vala"
		_tmp1_ = (*self).right >= (*self).left;
#line 290 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp1_ = FALSE;
#line 294 "Box.c"
	}
#line 86 "Box.vala"
	if (_tmp1_) {
#line 86 "Box.vala"
		_tmp0_ = (*self).bottom >= (*self).top;
#line 300 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp0_ = FALSE;
#line 304 "Box.c"
	}
	result = _tmp0_;
#line 86 "Box.vala"
	return result;
#line 309 "Box.c"
}


#line 89 "Box.vala"
gboolean box_equals (Box *self, Box* box) {
#line 315 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 90 "Box.vala"
	if ((*self).left == (*box).left) {
#line 90 "Box.vala"
		_tmp2_ = (*self).top == (*box).top;
#line 324 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp2_ = FALSE;
#line 328 "Box.c"
	}
#line 90 "Box.vala"
	if (_tmp2_) {
#line 90 "Box.vala"
		_tmp1_ = (*self).right == (*box).right;
#line 334 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp1_ = FALSE;
#line 338 "Box.c"
	}
#line 90 "Box.vala"
	if (_tmp1_) {
#line 90 "Box.vala"
		_tmp0_ = (*self).bottom == (*box).bottom;
#line 344 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp0_ = FALSE;
#line 348 "Box.c"
	}
	result = _tmp0_;
#line 90 "Box.vala"
	return result;
#line 353 "Box.c"
}


#line 93 "Box.vala"
void box_get_scaled (Box *self, Dimensions* scaled, Box* result) {
#line 359 "Box.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gint l;
	gint t;
	gint r;
	gint b;
	Box box = {0};
	gboolean _tmp2_ = FALSE;
#line 95 "Box.vala"
	dimensions_get_scale_ratios ((_tmp1_ = (box_get_dimensions (&(*self), &_tmp0_), _tmp0_), &_tmp1_), scaled, &x_scale, &y_scale);
#line 97 "Box.vala"
	l = (gint) round (((double) (*self).left) * x_scale);
#line 98 "Box.vala"
	t = (gint) round (((double) (*self).top) * y_scale);
#line 101 "Box.vala"
	r = (l + (*scaled).width) - 1;
#line 102 "Box.vala"
	b = (t + (*scaled).height) - 1;
#line 380 "Box.c"
	box_init (&box, l, t, r, b);
#line 105 "Box.vala"
	if (box_get_width (&box) == (*scaled).width) {
#line 105 "Box.vala"
		_tmp2_ = TRUE;
#line 386 "Box.c"
	} else {
#line 105 "Box.vala"
		_tmp2_ = box_get_height (&box) == (*scaled).height;
#line 390 "Box.c"
	}
#line 105 "Box.vala"
	g_assert (_tmp2_);
#line 394 "Box.c"
	*result = box;
#line 107 "Box.vala"
	return;
#line 398 "Box.c"
}


#line 110 "Box.vala"
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result) {
#line 404 "Box.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 112 "Box.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 114 "Box.vala"
	l = (gint) round (((double) (*self).left) * x_scale);
#line 115 "Box.vala"
	t = (gint) round (((double) (*self).top) * y_scale);
#line 116 "Box.vala"
	r = (gint) round (((double) (*self).right) * x_scale);
#line 117 "Box.vala"
	b = (gint) round (((double) (*self).bottom) * y_scale);
#line 120 "Box.vala"
	if (r >= (*scaled).width) {
#line 121 "Box.vala"
		r = (*scaled).width - 1;
#line 426 "Box.c"
	}
#line 123 "Box.vala"
	if (b >= (*scaled).height) {
#line 124 "Box.vala"
		b = (*scaled).height - 1;
#line 432 "Box.c"
	}
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 126 "Box.vala"
	return;
#line 437 "Box.c"
}


#line 129 "Box.vala"
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result) {
#line 443 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left + xofs, (*self).top + yofs, (*self).right + xofs, (*self).bottom + yofs), _tmp0_);
#line 130 "Box.vala"
	return;
#line 448 "Box.c"
}


#line 133 "Box.vala"
void box_get_dimensions (Box *self, Dimensions* result) {
#line 454 "Box.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, box_get_width (&(*self)), box_get_height (&(*self))), _tmp0_);
#line 134 "Box.vala"
	return;
#line 459 "Box.c"
}


#line 137 "Box.vala"
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right) {
#line 138 "Box.vala"
	(*top_left).x = (*self).left;
#line 139 "Box.vala"
	(*top_left).y = (*self).top;
#line 141 "Box.vala"
	(*bottom_right).x = (*self).right;
#line 142 "Box.vala"
	(*bottom_right).y = (*self).bottom;
#line 473 "Box.c"
}


#line 145 "Box.vala"
void box_get_rectangle (Box *self, GdkRectangle* result) {
#line 479 "Box.c"
	GdkRectangle rect = {0};
	memset (&rect, 0, sizeof (GdkRectangle));
#line 147 "Box.vala"
	rect.x = (*self).left;
#line 148 "Box.vala"
	rect.y = (*self).top;
#line 149 "Box.vala"
	rect.width = box_get_width (&(*self));
#line 150 "Box.vala"
	rect.height = box_get_height (&(*self));
#line 490 "Box.c"
	*result = rect;
#line 152 "Box.vala"
	return;
#line 494 "Box.c"
}


#line 155 "Box.vala"
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result) {
#line 500 "Box.c"
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 156 "Box.vala"
	l = ((*space).width - (*self).bottom) - 1;
#line 157 "Box.vala"
	t = (*self).left;
#line 158 "Box.vala"
	r = ((*space).width - (*self).top) - 1;
#line 159 "Box.vala"
	b = (*self).right;
#line 514 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 161 "Box.vala"
	return;
#line 518 "Box.c"
}


#line 164 "Box.vala"
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result) {
#line 524 "Box.c"
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 165 "Box.vala"
	l = (*self).top;
#line 166 "Box.vala"
	t = ((*space).height - (*self).right) - 1;
#line 167 "Box.vala"
	r = (*self).bottom;
#line 168 "Box.vala"
	b = ((*space).height - (*self).left) - 1;
#line 538 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 170 "Box.vala"
	return;
#line 542 "Box.c"
}


#line 173 "Box.vala"
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result) {
#line 548 "Box.c"
	gint l;
	gint r;
	Box _tmp0_ = {0};
#line 174 "Box.vala"
	l = ((*space).width - (*self).right) - 1;
#line 175 "Box.vala"
	r = ((*space).width - (*self).left) - 1;
#line 556 "Box.c"
	*result = (box_init (&_tmp0_, l, (*self).top, r, (*self).bottom), _tmp0_);
#line 177 "Box.vala"
	return;
#line 560 "Box.c"
}


#line 180 "Box.vala"
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result) {
#line 566 "Box.c"
	gint t;
	gint b;
	Box _tmp0_ = {0};
#line 181 "Box.vala"
	t = ((*space).height - (*self).bottom) - 1;
#line 182 "Box.vala"
	b = ((*space).height - (*self).top) - 1;
#line 574 "Box.c"
	*result = (box_init (&_tmp0_, (*self).left, t, (*self).right, b), _tmp0_);
#line 184 "Box.vala"
	return;
#line 578 "Box.c"
}


#line 187 "Box.vala"
gboolean box_intersects (Box *self, Box* compare) {
#line 584 "Box.c"
	gboolean result = FALSE;
	gint left_intersect;
	gint top_intersect;
	gint right_intersect;
	gint bottom_intersect;
	gboolean _tmp0_ = FALSE;
#line 188 "Box.vala"
	left_intersect = MAX ((*self).left, (*compare).left);
#line 189 "Box.vala"
	top_intersect = MAX ((*self).top, (*compare).top);
#line 190 "Box.vala"
	right_intersect = MIN ((*self).right, (*compare).right);
#line 191 "Box.vala"
	bottom_intersect = MIN ((*self).bottom, (*compare).bottom);
#line 193 "Box.vala"
	if (right_intersect >= left_intersect) {
#line 193 "Box.vala"
		_tmp0_ = bottom_intersect >= top_intersect;
#line 603 "Box.c"
	} else {
#line 193 "Box.vala"
		_tmp0_ = FALSE;
#line 607 "Box.c"
	}
	result = _tmp0_;
#line 193 "Box.vala"
	return result;
#line 612 "Box.c"
}


#line 196 "Box.vala"
void box_get_reduced (Box *self, gint amount, Box* result) {
#line 618 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left + amount, (*self).top + amount, (*self).right - amount, (*self).bottom - amount), _tmp0_);
#line 197 "Box.vala"
	return;
#line 623 "Box.c"
}


#line 200 "Box.vala"
void box_get_expanded (Box *self, gint amount, Box* result) {
#line 629 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left - amount, (*self).top - amount, (*self).right + amount, (*self).bottom + amount), _tmp0_);
#line 201 "Box.vala"
	return;
#line 634 "Box.c"
}


#line 204 "Box.vala"
gboolean box_contains (Box *self, GdkPoint* point) {
#line 640 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 205 "Box.vala"
	if ((*point).x >= (*self).left) {
#line 205 "Box.vala"
		_tmp2_ = (*point).x <= (*self).right;
#line 649 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp2_ = FALSE;
#line 653 "Box.c"
	}
#line 205 "Box.vala"
	if (_tmp2_) {
#line 205 "Box.vala"
		_tmp1_ = (*point).y >= (*self).top;
#line 659 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp1_ = FALSE;
#line 663 "Box.c"
	}
#line 205 "Box.vala"
	if (_tmp1_) {
#line 205 "Box.vala"
		_tmp0_ = (*point).y <= (*self).bottom;
#line 669 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp0_ = FALSE;
#line 673 "Box.c"
	}
	result = _tmp0_;
#line 205 "Box.vala"
	return result;
#line 678 "Box.c"
}


#line 211 "Box.vala"
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged) {
#line 684 "Box.c"
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean horizontal_complement;
	gboolean vertical_complement;
#line 213 "Box.vala"
	if (box_get_width (&(*self)) != box_get_width (resized)) {
#line 213 "Box.vala"
		_tmp0_ = TRUE;
#line 693 "Box.c"
	} else {
#line 213 "Box.vala"
		_tmp0_ = box_get_height (&(*self)) != box_get_height (resized);
#line 697 "Box.c"
	}
#line 213 "Box.vala"
	g_assert (_tmp0_);
#line 215 "Box.vala"
	horizontal_complement = TRUE;
#line 216 "Box.vala"
	if ((*resized).top < (*self).top) {
#line 705 "Box.c"
		Box _tmp1_ = {0};
#line 218 "Box.vala"
		*horizontal = (box_init (&_tmp1_, (*resized).left, (*resized).top, (*resized).right, (*self).top), _tmp1_);
#line 219 "Box.vala"
		*horizontal_enlarged = TRUE;
#line 711 "Box.c"
	} else {
#line 220 "Box.vala"
		if ((*resized).top > (*self).top) {
#line 715 "Box.c"
			Box _tmp2_ = {0};
#line 222 "Box.vala"
			*horizontal = (box_init (&_tmp2_, (*self).left, (*self).top, (*self).right, (*resized).top), _tmp2_);
#line 223 "Box.vala"
			*horizontal_enlarged = FALSE;
#line 721 "Box.c"
		} else {
#line 224 "Box.vala"
			if ((*resized).bottom < (*self).bottom) {
#line 725 "Box.c"
				Box _tmp3_ = {0};
#line 226 "Box.vala"
				*horizontal = (box_init (&_tmp3_, (*self).left, (*resized).bottom, (*self).right, (*self).bottom), _tmp3_);
#line 227 "Box.vala"
				*horizontal_enlarged = FALSE;
#line 731 "Box.c"
			} else {
#line 228 "Box.vala"
				if ((*resized).bottom > (*self).bottom) {
#line 735 "Box.c"
					Box _tmp4_ = {0};
#line 230 "Box.vala"
					*horizontal = (box_init (&_tmp4_, (*resized).left, (*self).bottom, (*resized).right, (*resized).bottom), _tmp4_);
#line 231 "Box.vala"
					*horizontal_enlarged = TRUE;
#line 741 "Box.c"
				} else {
#line 233 "Box.vala"
					horizontal_complement = FALSE;
#line 745 "Box.c"
				}
			}
		}
	}
#line 236 "Box.vala"
	vertical_complement = TRUE;
#line 237 "Box.vala"
	if ((*resized).left < (*self).left) {
#line 754 "Box.c"
		Box _tmp5_ = {0};
#line 239 "Box.vala"
		*vertical = (box_init (&_tmp5_, (*resized).left, (*resized).top, (*self).left, (*resized).bottom), _tmp5_);
#line 240 "Box.vala"
		*vertical_enlarged = TRUE;
#line 760 "Box.c"
	} else {
#line 241 "Box.vala"
		if ((*resized).left > (*self).left) {
#line 764 "Box.c"
			Box _tmp6_ = {0};
#line 243 "Box.vala"
			*vertical = (box_init (&_tmp6_, (*self).left, (*self).top, (*resized).left, (*self).bottom), _tmp6_);
#line 244 "Box.vala"
			*vertical_enlarged = FALSE;
#line 770 "Box.c"
		} else {
#line 245 "Box.vala"
			if ((*resized).right < (*self).right) {
#line 774 "Box.c"
				Box _tmp7_ = {0};
#line 247 "Box.vala"
				*vertical = (box_init (&_tmp7_, (*resized).right, (*self).top, (*self).right, (*self).bottom), _tmp7_);
#line 248 "Box.vala"
				*vertical_enlarged = FALSE;
#line 780 "Box.c"
			} else {
#line 249 "Box.vala"
				if ((*resized).right > (*self).right) {
#line 784 "Box.c"
					Box _tmp8_ = {0};
#line 251 "Box.vala"
					*vertical = (box_init (&_tmp8_, (*self).right, (*resized).top, (*resized).right, (*resized).bottom), _tmp8_);
#line 252 "Box.vala"
					*vertical_enlarged = TRUE;
#line 790 "Box.c"
				} else {
#line 254 "Box.vala"
					vertical_complement = FALSE;
#line 794 "Box.c"
				}
			}
		}
	}
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 257 "Box.vala"
	return result;
#line 802 "Box.c"
}


#line 263 "Box.vala"
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted) {
#line 808 "Box.c"
	BoxComplements result = 0;
	gboolean horizontal_complement;
	gboolean _tmp0_ = FALSE;
	gboolean vertical_complement;
	gboolean _tmp6_ = FALSE;
#line 265 "Box.vala"
	g_assert (box_get_width (&(*self)) == box_get_width (shifted));
#line 266 "Box.vala"
	g_assert (box_get_height (&(*self)) == box_get_height (shifted));
#line 268 "Box.vala"
	horizontal_complement = TRUE;
#line 269 "Box.vala"
	if ((*shifted).top < (*self).top) {
#line 269 "Box.vala"
		_tmp0_ = (*shifted).bottom > (*self).top;
#line 824 "Box.c"
	} else {
#line 269 "Box.vala"
		_tmp0_ = FALSE;
#line 828 "Box.c"
	}
#line 269 "Box.vala"
	if (_tmp0_) {
#line 832 "Box.c"
		Box _tmp1_ = {0};
		Box _tmp2_ = {0};
#line 271 "Box.vala"
		*horizontal_this = (box_init (&_tmp1_, (*self).left, (*shifted).bottom, (*self).right, (*self).bottom), _tmp1_);
#line 272 "Box.vala"
		*horizontal_shifted = (box_init (&_tmp2_, (*shifted).left, (*shifted).top, (*shifted).right, (*self).top), _tmp2_);
#line 839 "Box.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 273 "Box.vala"
		if ((*shifted).top > (*self).top) {
#line 273 "Box.vala"
			_tmp3_ = (*shifted).top < (*self).bottom;
#line 846 "Box.c"
		} else {
#line 273 "Box.vala"
			_tmp3_ = FALSE;
#line 850 "Box.c"
		}
#line 273 "Box.vala"
		if (_tmp3_) {
#line 854 "Box.c"
			Box _tmp4_ = {0};
			Box _tmp5_ = {0};
#line 275 "Box.vala"
			*horizontal_this = (box_init (&_tmp4_, (*self).left, (*self).top, (*self).right, (*shifted).top), _tmp4_);
#line 276 "Box.vala"
			*horizontal_shifted = (box_init (&_tmp5_, (*shifted).left, (*self).bottom, (*shifted).right, (*shifted).bottom), _tmp5_);
#line 861 "Box.c"
		} else {
#line 279 "Box.vala"
			horizontal_complement = FALSE;
#line 865 "Box.c"
		}
	}
#line 282 "Box.vala"
	vertical_complement = TRUE;
#line 283 "Box.vala"
	if ((*shifted).left < (*self).left) {
#line 283 "Box.vala"
		_tmp6_ = (*shifted).right > (*self).left;
#line 874 "Box.c"
	} else {
#line 283 "Box.vala"
		_tmp6_ = FALSE;
#line 878 "Box.c"
	}
#line 283 "Box.vala"
	if (_tmp6_) {
#line 882 "Box.c"
		Box _tmp7_ = {0};
		Box _tmp8_ = {0};
#line 285 "Box.vala"
		*vertical_this = (box_init (&_tmp7_, (*shifted).right, (*self).top, (*self).right, (*self).bottom), _tmp7_);
#line 286 "Box.vala"
		*vertical_shifted = (box_init (&_tmp8_, (*shifted).left, (*shifted).top, (*self).left, (*shifted).bottom), _tmp8_);
#line 889 "Box.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 287 "Box.vala"
		if ((*shifted).left > (*self).left) {
#line 287 "Box.vala"
			_tmp9_ = (*shifted).left < (*self).right;
#line 896 "Box.c"
		} else {
#line 287 "Box.vala"
			_tmp9_ = FALSE;
#line 900 "Box.c"
		}
#line 287 "Box.vala"
		if (_tmp9_) {
#line 904 "Box.c"
			Box _tmp10_ = {0};
			Box _tmp11_ = {0};
#line 289 "Box.vala"
			*vertical_this = (box_init (&_tmp10_, (*self).left, (*self).top, (*shifted).left, (*self).bottom), _tmp10_);
#line 290 "Box.vala"
			*vertical_shifted = (box_init (&_tmp11_, (*self).right, (*shifted).top, (*shifted).right, (*shifted).bottom), _tmp11_);
#line 911 "Box.c"
		} else {
#line 293 "Box.vala"
			vertical_complement = FALSE;
#line 915 "Box.c"
		}
	}
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 296 "Box.vala"
	return result;
#line 921 "Box.c"
}


#line 299 "Box.vala"
void box_rubber_band (Box *self, GdkPoint* point, Box* result) {
#line 927 "Box.c"
	gint t;
	gint b;
	gint l;
	gint r;
	Box _tmp0_ = {0};
#line 300 "Box.vala"
	g_assert ((*point).x >= 0);
#line 301 "Box.vala"
	g_assert ((*point).y >= 0);
#line 303 "Box.vala"
	t = MIN ((*self).top, (*point).y);
#line 304 "Box.vala"
	b = MAX ((*self).bottom, (*point).y);
#line 305 "Box.vala"
	l = MIN ((*self).left, (*point).x);
#line 306 "Box.vala"
	r = MAX ((*self).right, (*point).x);
#line 945 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 308 "Box.vala"
	return;
#line 949 "Box.c"
}


#line 311 "Box.vala"
char* box_to_string (Box *self) {
#line 955 "Box.c"
	char* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	result = (_tmp3_ = g_strdup_printf ("%d,%d %d,%d (%s)", (*self).left, (*self).top, (*self).right, (*self).bottom, _tmp2_ = dimensions_to_string ((_tmp1_ = (box_get_dimensions (&(*self), &_tmp0_), _tmp0_), &_tmp1_))), _g_free0 (_tmp2_), _tmp3_);
#line 312 "Box.vala"
	return result;
#line 964 "Box.c"
}


#line 315 "Box.vala"
static gboolean box_in_zone (double pos, gint zone) {
#line 970 "Box.c"
	gboolean result = FALSE;
	gint top_zone;
	gint bottom_zone;
#line 316 "Box.vala"
	top_zone = zone - BOX_HAND_GRENADES;
#line 317 "Box.vala"
	bottom_zone = zone + BOX_HAND_GRENADES;
#line 978 "Box.c"
	result = box_in_between (pos, top_zone, bottom_zone);
#line 319 "Box.vala"
	return result;
#line 982 "Box.c"
}


#line 322 "Box.vala"
static gboolean box_in_between (double pos, gint top, gint bottom) {
#line 988 "Box.c"
	gboolean result = FALSE;
	gint ipos;
	gboolean _tmp0_ = FALSE;
#line 323 "Box.vala"
	ipos = (gint) pos;
#line 325 "Box.vala"
	if (ipos > top) {
#line 325 "Box.vala"
		_tmp0_ = ipos < bottom;
#line 998 "Box.c"
	} else {
#line 325 "Box.vala"
		_tmp0_ = FALSE;
#line 1002 "Box.c"
	}
	result = _tmp0_;
#line 325 "Box.vala"
	return result;
#line 1007 "Box.c"
}


#line 328 "Box.vala"
static gboolean box_near_in_between (double pos, gint top, gint bottom) {
#line 1013 "Box.c"
	gboolean result = FALSE;
	gint ipos;
	gint top_zone;
	gint bottom_zone;
	gboolean _tmp0_ = FALSE;
#line 329 "Box.vala"
	ipos = (gint) pos;
#line 330 "Box.vala"
	top_zone = top - BOX_HAND_GRENADES;
#line 331 "Box.vala"
	bottom_zone = bottom + BOX_HAND_GRENADES;
#line 333 "Box.vala"
	if (ipos > top_zone) {
#line 333 "Box.vala"
		_tmp0_ = ipos < bottom_zone;
#line 1029 "Box.c"
	} else {
#line 333 "Box.vala"
		_tmp0_ = FALSE;
#line 1033 "Box.c"
	}
	result = _tmp0_;
#line 333 "Box.vala"
	return result;
#line 1038 "Box.c"
}


#line 336 "Box.vala"
BoxLocation box_approx_location (Box *self, gint x, gint y) {
#line 1044 "Box.c"
	BoxLocation result = 0;
	gboolean near_width;
	gboolean near_height;
	gboolean _tmp0_ = FALSE;
#line 337 "Box.vala"
	near_width = box_near_in_between ((double) x, (*self).left, (*self).right);
#line 338 "Box.vala"
	near_height = box_near_in_between ((double) y, (*self).top, (*self).bottom);
#line 340 "Box.vala"
	if (box_in_zone ((double) x, (*self).left)) {
#line 340 "Box.vala"
		_tmp0_ = near_height;
#line 1057 "Box.c"
	} else {
#line 340 "Box.vala"
		_tmp0_ = FALSE;
#line 1061 "Box.c"
	}
#line 340 "Box.vala"
	if (_tmp0_) {
#line 341 "Box.vala"
		if (box_in_zone ((double) y, (*self).top)) {
#line 1067 "Box.c"
			result = BOX_LOCATION_TOP_LEFT;
#line 342 "Box.vala"
			return result;
#line 1071 "Box.c"
		} else {
#line 343 "Box.vala"
			if (box_in_zone ((double) y, (*self).bottom)) {
#line 1075 "Box.c"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 344 "Box.vala"
				return result;
#line 1079 "Box.c"
			} else {
				result = BOX_LOCATION_LEFT_SIDE;
#line 346 "Box.vala"
				return result;
#line 1084 "Box.c"
			}
		}
	} else {
		gboolean _tmp1_ = FALSE;
#line 348 "Box.vala"
		if (box_in_zone ((double) x, (*self).right)) {
#line 348 "Box.vala"
			_tmp1_ = near_height;
#line 1093 "Box.c"
		} else {
#line 348 "Box.vala"
			_tmp1_ = FALSE;
#line 1097 "Box.c"
		}
#line 348 "Box.vala"
		if (_tmp1_) {
#line 349 "Box.vala"
			if (box_in_zone ((double) y, (*self).top)) {
#line 1103 "Box.c"
				result = BOX_LOCATION_TOP_RIGHT;
#line 350 "Box.vala"
				return result;
#line 1107 "Box.c"
			} else {
#line 351 "Box.vala"
				if (box_in_zone ((double) y, (*self).bottom)) {
#line 1111 "Box.c"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 352 "Box.vala"
					return result;
#line 1115 "Box.c"
				} else {
					result = BOX_LOCATION_RIGHT_SIDE;
#line 354 "Box.vala"
					return result;
#line 1120 "Box.c"
				}
			}
		} else {
			gboolean _tmp2_ = FALSE;
#line 356 "Box.vala"
			if (box_in_zone ((double) y, (*self).top)) {
#line 356 "Box.vala"
				_tmp2_ = near_width;
#line 1129 "Box.c"
			} else {
#line 356 "Box.vala"
				_tmp2_ = FALSE;
#line 1133 "Box.c"
			}
#line 356 "Box.vala"
			if (_tmp2_) {
#line 1137 "Box.c"
				result = BOX_LOCATION_TOP_SIDE;
#line 358 "Box.vala"
				return result;
#line 1141 "Box.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 359 "Box.vala"
				if (box_in_zone ((double) y, (*self).bottom)) {
#line 359 "Box.vala"
					_tmp3_ = near_width;
#line 1148 "Box.c"
				} else {
#line 359 "Box.vala"
					_tmp3_ = FALSE;
#line 1152 "Box.c"
				}
#line 359 "Box.vala"
				if (_tmp3_) {
#line 1156 "Box.c"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 361 "Box.vala"
					return result;
#line 1160 "Box.c"
				} else {
					gboolean _tmp4_ = FALSE;
#line 362 "Box.vala"
					if (box_in_between ((double) x, (*self).left, (*self).right)) {
#line 362 "Box.vala"
						_tmp4_ = box_in_between ((double) y, (*self).top, (*self).bottom);
#line 1167 "Box.c"
					} else {
#line 362 "Box.vala"
						_tmp4_ = FALSE;
#line 1171 "Box.c"
					}
#line 362 "Box.vala"
					if (_tmp4_) {
#line 1175 "Box.c"
						result = BOX_LOCATION_INSIDE;
#line 363 "Box.vala"
						return result;
#line 1179 "Box.c"
					} else {
						result = BOX_LOCATION_OUTSIDE;
#line 365 "Box.vala"
						return result;
#line 1184 "Box.c"
					}
				}
			}
		}
	}
}


Box* box_dup (const Box* self) {
	Box* dup;
	dup = g_new0 (Box, 1);
	memcpy (dup, self, sizeof (Box));
	return dup;
}


void box_free (Box* self) {
	g_free (self);
}


GType box_get_type (void) {
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}




