/* Config.c generated by valac 0.10.3, the Vala compiler
 * generated from Config.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gconf/gconf-client.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gconf/gconf.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
typedef struct _ConfigPrivate ConfigPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define _gconf_value_free0(var) ((var == NULL) ? NULL : (var = (gconf_value_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_RATING_FILTER (rating_filter_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define MEDIA_PAGE_TYPE_SORT_BY (media_page_sort_by_get_type ())

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
typedef struct _ParamSpecConfig ParamSpecConfig;

struct _Config {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigPrivate * priv;
};

struct _ConfigClass {
	GTypeClass parent_class;
	void (*finalize) (Config *self);
};

struct _ConfigPrivate {
	char* bg_color;
	char* selected_color;
	char* unselected_color;
	char* unfocused_selected_color;
	char* border_color;
	GConfClient* client;
	GeeMap* bool_defaults;
};

typedef enum  {
	RATING_FILTER_NO_FILTER = 0,
	RATING_FILTER_REJECTED_OR_HIGHER = 1,
	RATING_FILTER_UNRATED_OR_HIGHER = 2,
	RATING_FILTER_ONE_OR_HIGHER = 3,
	RATING_FILTER_TWO_OR_HIGHER = 4,
	RATING_FILTER_THREE_OR_HIGHER = 5,
	RATING_FILTER_FOUR_OR_HIGHER = 6,
	RATING_FILTER_FIVE_OR_HIGHER = 7,
	RATING_FILTER_REJECTED_ONLY = 8,
	RATING_FILTER_UNRATED_ONLY = 9,
	RATING_FILTER_ONE_ONLY = 10,
	RATING_FILTER_TWO_ONLY = 11,
	RATING_FILTER_THREE_ONLY = 12,
	RATING_FILTER_FOUR_ONLY = 13,
	RATING_FILTER_FIVE_ONLY = 14
} RatingFilter;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	MEDIA_PAGE_SORT_BY_MIN = 1,
	MEDIA_PAGE_SORT_BY_TITLE = 1,
	MEDIA_PAGE_SORT_BY_EXPOSURE_DATE = 2,
	MEDIA_PAGE_SORT_BY_RATING = 3,
	MEDIA_PAGE_SORT_BY_MAX = 3
} MediaPageSortBy;

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ParamSpecConfig {
	GParamSpec parent_instance;
};


static Config* config_instance;
static Config* config_instance = NULL;
static gpointer config_parent_class = NULL;

gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
#define CONFIG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONFIG, ConfigPrivate))
enum  {
	CONFIG_DUMMY_PROPERTY
};
#define CONFIG_PATH_SHOTWELL "/apps/shotwell/preferences"
#define CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS CONFIG_PATH_SHOTWELL "/files/commit_metadata"
#define CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY CONFIG_PATH_SHOTWELL "/files/auto_import"
#define CONFIG_STRING_IMPORT_DIRECTORY CONFIG_PATH_SHOTWELL "/files/import_dir"
#define CONFIG_SLIDESHOW_DELAY_MAX 30.0
#define CONFIG_SLIDESHOW_DELAY_MIN 1.0
#define CONFIG_SLIDESHOW_DELAY_DEFAULT 3.0
#define CONFIG_WIDTH_DEFAULT 1024
#define CONFIG_HEIGHT_DEFAULT 768
#define CONFIG_SIDEBAR_MIN_POSITION 180
#define CONFIG_SIDEBAR_MAX_POSITION 1000
#define CONFIG_DEFAULT_BG_COLOR "#444"
#define CONFIG_NO_VIDEO_INTERPRETER_STATE (-1)
#define CONFIG_BLACK_THRESHOLD ((guint) 40000)
#define CONFIG_DARK_SELECTED_COLOR "#0AD"
#define CONFIG_LIGHT_SELECTED_COLOR "#2DF"
#define CONFIG_DARK_UNSELECTED_COLOR "#000"
#define CONFIG_LIGHT_UNSELECTED_COLOR "#FFF"
#define CONFIG_DARK_BORDER_COLOR "#666"
#define CONFIG_LIGHT_BORDER_COLOR "#AAA"
#define CONFIG_DARK_UNFOCUSED_SELECTED_COLOR "#6fc4dd"
#define CONFIG_LIGHT_UNFOCUSED_SELECTED_COLOR "#99efff"
static Config* config_new (void);
static Config* config_construct (GType object_type);
static void config_register_bool (Config* self, const char* path, gboolean def);
Config* config_get_instance (void);
static void config_report_get_error (Config* self, const char* path, GError* err);
static void config_report_set_error (Config* self, const char* path, GError* err);
static gboolean config_get_bool (Config* self, const char* path, gboolean def);
static gboolean config_set_bool (Config* self, const char* path, gboolean value);
static gboolean config_is_registered_bool (Config* self, const char* path);
static gboolean config_get_registered_bool (Config* self, const char* path);
static gint config_get_int (Config* self, const char* path, gint def);
static gboolean config_set_int (Config* self, const char* path, gint value);
static double config_get_double (Config* self, const char* path, double def);
static gboolean config_set_double (Config* self, const char* path, double value);
static char* config_get_string (Config* self, const char* path, const char* def);
gboolean is_string_empty (const char* s);
static gboolean config_set_string (Config* self, const char* path, const char* value);
gboolean config_clear_flickr_auth_token (Config* self);
gboolean config_set_flickr_auth_token (Config* self, const char* token);
char* config_get_flickr_auth_token (Config* self);
gboolean config_clear_flickr_username (Config* self);
gboolean config_set_flickr_username (Config* self, const char* username);
char* config_get_flickr_username (Config* self);
gboolean config_set_flickr_default_size (Config* self, gint sizecode);
gint config_get_flickr_default_size (Config* self);
gboolean config_set_flickr_visibility (Config* self, gint viscode);
gint config_get_flickr_visibility (Config* self);
gboolean config_set_last_used_service (Config* self, const char* service_name);
char* config_get_last_used_service (Config* self);
gboolean config_clear_facebook_session_key (Config* self);
gboolean config_set_facebook_session_key (Config* self, const char* key);
char* config_get_facebook_session_key (Config* self);
gboolean config_clear_facebook_session_secret (Config* self);
gboolean config_set_facebook_session_secret (Config* self, const char* secret);
char* config_get_facebook_session_secret (Config* self);
gboolean config_clear_facebook_uid (Config* self);
gboolean config_set_facebook_uid (Config* self, const char* uid);
char* config_get_facebook_uid (Config* self);
gboolean config_clear_facebook_user_name (Config* self);
gboolean config_set_facebook_user_name (Config* self, const char* user_name);
char* config_get_facebook_user_name (Config* self);
gboolean config_set_picasa_default_size (Config* self, gint default_size);
gint config_get_picasa_default_size (Config* self);
char* config_get_publishing_string (Config* self, const char* id, const char* key);
void config_set_publishing_string (Config* self, const char* id, const char* key, const char* value);
void config_unset_publishing_string (Config* self, const char* id, const char* key);
gboolean config_set_printing_content_layout (Config* self, gint layout_code);
gint config_get_printing_content_layout (Config* self);
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi);
gint config_get_printing_content_ppi (Config* self);
gboolean config_set_printing_content_width (Config* self, double content_width);
double config_get_printing_content_width (Config* self);
gboolean config_set_printing_content_height (Config* self, double content_height);
double config_get_printing_content_height (Config* self);
gboolean config_set_printing_content_units (Config* self, gint units_code);
gint config_get_printing_content_units (Config* self);
gboolean config_set_printing_size_selection (Config* self, gint size_code);
gint config_get_printing_size_selection (Config* self);
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio);
gboolean config_get_printing_match_aspect_ratio (Config* self);
gboolean config_set_display_basic_properties (Config* self, gboolean display);
gboolean config_get_display_basic_properties (Config* self);
gboolean config_set_display_extended_properties (Config* self, gboolean display);
gboolean config_get_display_extended_properties (Config* self);
gboolean config_set_display_photo_titles (Config* self, gboolean display);
gboolean config_get_display_photo_titles (Config* self);
gboolean config_get_display_photo_tags (Config* self);
gboolean config_set_display_photo_tags (Config* self, gboolean display);
gboolean config_get_display_photo_ratings (Config* self);
gboolean config_set_display_photo_ratings (Config* self, gboolean display);
gboolean config_set_slideshow_delay (Config* self, double delay);
double config_get_slideshow_delay (Config* self);
GType rating_filter_get_type (void) G_GNUC_CONST;
RatingFilter config_get_photo_rating_filter (Config* self);
gboolean config_set_photo_rating_filter (Config* self, RatingFilter filter);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
void dimensions_init (Dimensions *self, gint width, gint height);
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
gint config_get_sidebar_position (Config* self);
gboolean config_set_sidebar_position (Config* self, gint position);
gboolean config_get_events_sort_ascending (Config* self);
gboolean config_set_events_sort_ascending (Config* self, gboolean sort);
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
GType media_page_sort_by_get_type (void) G_GNUC_CONST;
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by);
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by);
gboolean config_get_24_hr_time (Config* self);
gboolean is_twentyfour_hr_time_system (void);
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time);
gboolean config_get_keep_relativity (Config* self);
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity);
gboolean config_get_modify_originals (Config* self);
gboolean config_set_modify_originals (Config* self, gboolean modify_originals);
gboolean config_set_video_interpreter_state_cookie (Config* self, gint state_cookie);
gint config_get_video_interpreter_state_cookie (Config* self);
char* config_get_background (Config* self);
gboolean config_set_background (Config* self, const char* filename);
gboolean config_get_show_welcome_dialog (Config* self);
gboolean config_set_show_welcome_dialog (Config* self, gboolean show);
gboolean config_set_photo_thumbnail_scale (Config* self, gint scale);
gint config_get_photo_thumbnail_scale (Config* self);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
gint thumbnail_cache_size_get_scale (ThumbnailCacheSize self);
#define THUMBNAIL_DEFAULT_SCALE thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_MEDIUM)
#define THUMBNAIL_MIN_SCALE 72
#define THUMBNAIL_MAX_SCALE thumbnail_cache_size_get_scale (THUMBNAIL_CACHE_SIZE_LARGEST)
static void config_get_colors (Config* self);
gboolean is_color_parsable (const char* spec);
static void config_set_text_colors (Config* self, GdkColor* bg_color);
void parse_color (const char* spec, GdkColor* result);
void config_get_bg_color (Config* self, GdkColor* result);
void config_get_selected_color (Config* self, gboolean in_focus, GdkColor* result);
void config_get_unselected_color (Config* self, GdkColor* result);
void config_get_border_color (Config* self, GdkColor* result);
void config_set_bg_color (Config* self, GdkColor* color);
gboolean config_commit_bg_color (Config* self);
char* config_get_import_dir (Config* self);
void config_set_import_dir (Config* self, const char* import_dir);
char* config_get_external_photo_app (Config* self);
GAppInfo* desktop_integration_get_default_app_for_mime_types (char** mime_types, int mime_types_length1, GeeArrayList* preferred_apps);
char** photo_file_format_get_editable_mime_types (int* result_length1);
char* desktop_integration_get_app_open_command (GAppInfo* app_info);
void config_set_external_photo_app (Config* self, const char* external_photo_app);
char* config_get_external_raw_app (Config* self);
GType photo_file_format_get_type (void) G_GNUC_CONST;
char** photo_file_format_get_mime_types (PhotoFileFormat self, int* result_length1);
void config_set_external_raw_app (Config* self, const char* external_raw_app);
gboolean config_get_auto_import_from_library (Config* self);
void config_set_auto_import_from_library (Config* self, gboolean auto_import);
gboolean config_get_commit_metadata_to_masters (Config* self);
void config_set_commit_metadata_to_masters (Config* self, gboolean commit_metadata);
static void config_finalize (Config* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 53 "Config.vala"
static Config* config_construct (GType object_type) {
#line 315 "Config.c"
	Config* self = (Config*) g_type_create_instance (object_type);
	GConfClient* _tmp0_;
#line 54 "Config.vala"
	self->priv->client = (_tmp0_ = _g_object_ref0 (gconf_client_get_default ()), _g_object_unref0 (self->priv->client), _tmp0_);
#line 55 "Config.vala"
	g_assert (self->priv->client != NULL);
#line 58 "Config.vala"
	config_register_bool (self, CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS, FALSE);
#line 59 "Config.vala"
	config_register_bool (self, CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY, FALSE);
#line 326 "Config.c"
	return self;
}


#line 53 "Config.vala"
static Config* config_new (void) {
#line 53 "Config.vala"
	return config_construct (TYPE_CONFIG);
#line 335 "Config.c"
}


static gpointer _config_ref0 (gpointer self) {
	return self ? config_ref (self) : NULL;
}


#line 62 "Config.vala"
Config* config_get_instance (void) {
#line 346 "Config.c"
	Config* result = NULL;
#line 63 "Config.vala"
	if (config_instance == NULL) {
#line 350 "Config.c"
		Config* _tmp0_;
#line 64 "Config.vala"
		config_instance = (_tmp0_ = config_new (), _config_unref0 (config_instance), _tmp0_);
#line 354 "Config.c"
	}
	result = _config_ref0 (config_instance);
#line 66 "Config.vala"
	return result;
#line 359 "Config.c"
}


#line 69 "Config.vala"
static void config_report_get_error (Config* self, const char* path, GError* err) {
#line 69 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 69 "Config.vala"
	g_return_if_fail (path != NULL);
#line 70 "Config.vala"
	g_warning ("Config.vala:70: Unable to get GConf value at %s: %s", path, err->message);
#line 371 "Config.c"
}


#line 73 "Config.vala"
static void config_report_set_error (Config* self, const char* path, GError* err) {
#line 73 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 73 "Config.vala"
	g_return_if_fail (path != NULL);
#line 74 "Config.vala"
	g_warning ("Config.vala:74: Unable to set GConf value at %s: %s", path, err->message);
#line 383 "Config.c"
}


#line 77 "Config.vala"
static gboolean config_get_bool (Config* self, const char* path, gboolean def) {
#line 389 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 77 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 77 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 396 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 79 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 404 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch200_g_error;
		}
#line 79 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 410 "Config.c"
			result = def;
#line 80 "Config.vala"
			return result;
#line 414 "Config.c"
		}
#line 82 "Config.vala"
		_tmp3_ = gconf_client_get_bool (self->priv->client, path, &_inner_error_);
#line 418 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch200_g_error;
		}
		result = _tmp3_;
#line 82 "Config.vala"
		return result;
#line 425 "Config.c"
	}
	goto __finally200;
	__catch200_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 84 "Config.vala"
			config_report_get_error (self, path, err);
#line 436 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 86 "Config.vala"
			return result;
#line 441 "Config.c"
		}
	}
	__finally200:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 90 "Config.vala"
static gboolean config_set_bool (Config* self, const char* path, gboolean value) {
#line 455 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 90 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 90 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 462 "Config.c"
	{
#line 92 "Config.vala"
		gconf_client_set_bool (self->priv->client, path, value, &_inner_error_);
#line 466 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch201_g_error;
		}
#line 94 "Config.vala"
		g_signal_emit_by_name (self, "bool-changed", path, value);
#line 472 "Config.c"
		result = TRUE;
#line 96 "Config.vala"
		return result;
#line 476 "Config.c"
	}
	goto __finally201;
	__catch201_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 98 "Config.vala"
			config_report_set_error (self, path, err);
#line 487 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 100 "Config.vala"
			return result;
#line 492 "Config.c"
		}
	}
	__finally201:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 104 "Config.vala"
static gboolean config_is_registered_bool (Config* self, const char* path) {
#line 506 "Config.c"
	gboolean result = FALSE;
#line 104 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 104 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 512 "Config.c"
	result = gee_map_has_key (self->priv->bool_defaults, path);
#line 105 "Config.vala"
	return result;
#line 516 "Config.c"
}


#line 108 "Config.vala"
static gboolean config_get_registered_bool (Config* self, const char* path) {
#line 522 "Config.c"
	gboolean result = FALSE;
#line 108 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 108 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 109 "Config.vala"
	g_assert (config_is_registered_bool (self, path));
#line 530 "Config.c"
	result = config_get_bool (self, path, GPOINTER_TO_INT (gee_map_get (self->priv->bool_defaults, path)));
#line 111 "Config.vala"
	return result;
#line 534 "Config.c"
}


#line 114 "Config.vala"
static void config_register_bool (Config* self, const char* path, gboolean def) {
#line 114 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 114 "Config.vala"
	g_return_if_fail (path != NULL);
#line 115 "Config.vala"
	gee_map_set (self->priv->bool_defaults, path, GINT_TO_POINTER (def));
#line 546 "Config.c"
}


#line 118 "Config.vala"
static gint config_get_int (Config* self, const char* path, gint def) {
#line 552 "Config.c"
	gint result = 0;
	GError * _inner_error_ = NULL;
#line 118 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 118 "Config.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 559 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gint value;
		gint _tmp3_ = 0;
#line 120 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 568 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch202_g_error;
		}
#line 120 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 574 "Config.c"
			result = def;
#line 121 "Config.vala"
			return result;
#line 578 "Config.c"
		}
#line 123 "Config.vala"
		value = gconf_client_get_int (self->priv->client, path, &_inner_error_);
#line 582 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch202_g_error;
		}
#line 125 "Config.vala"
		if (value != 0.0) {
#line 125 "Config.vala"
			_tmp3_ = value;
#line 590 "Config.c"
		} else {
#line 125 "Config.vala"
			_tmp3_ = def;
#line 594 "Config.c"
		}
		result = _tmp3_;
#line 125 "Config.vala"
		return result;
#line 599 "Config.c"
	}
	goto __finally202;
	__catch202_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 127 "Config.vala"
			config_report_get_error (self, path, err);
#line 610 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 129 "Config.vala"
			return result;
#line 615 "Config.c"
		}
	}
	__finally202:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


#line 133 "Config.vala"
static gboolean config_set_int (Config* self, const char* path, gint value) {
#line 629 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 133 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 133 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 636 "Config.c"
	{
#line 135 "Config.vala"
		gconf_client_set_int (self->priv->client, path, value, &_inner_error_);
#line 640 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch203_g_error;
		}
		result = TRUE;
#line 137 "Config.vala"
		return result;
#line 647 "Config.c"
	}
	goto __finally203;
	__catch203_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 139 "Config.vala"
			config_report_set_error (self, path, err);
#line 658 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 141 "Config.vala"
			return result;
#line 663 "Config.c"
		}
	}
	__finally203:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 145 "Config.vala"
static double config_get_double (Config* self, const char* path, double def) {
#line 677 "Config.c"
	double result = 0.0;
	GError * _inner_error_ = NULL;
#line 145 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 145 "Config.vala"
	g_return_val_if_fail (path != NULL, 0.0);
#line 684 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		double value;
		double _tmp3_ = 0.0;
#line 147 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 693 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch204_g_error;
		}
#line 147 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 699 "Config.c"
			result = def;
#line 148 "Config.vala"
			return result;
#line 703 "Config.c"
		}
#line 150 "Config.vala"
		value = gconf_client_get_float (self->priv->client, path, &_inner_error_);
#line 707 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch204_g_error;
		}
#line 152 "Config.vala"
		if (value != 0.0) {
#line 152 "Config.vala"
			_tmp3_ = value;
#line 715 "Config.c"
		} else {
#line 152 "Config.vala"
			_tmp3_ = def;
#line 719 "Config.c"
		}
		result = _tmp3_;
#line 152 "Config.vala"
		return result;
#line 724 "Config.c"
	}
	goto __finally204;
	__catch204_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 154 "Config.vala"
			config_report_get_error (self, path, err);
#line 735 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 156 "Config.vala"
			return result;
#line 740 "Config.c"
		}
	}
	__finally204:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
}


#line 160 "Config.vala"
static gboolean config_set_double (Config* self, const char* path, double value) {
#line 754 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 160 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 160 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 761 "Config.c"
	{
#line 162 "Config.vala"
		gconf_client_set_float (self->priv->client, path, value, &_inner_error_);
#line 765 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch205_g_error;
		}
		result = TRUE;
#line 164 "Config.vala"
		return result;
#line 772 "Config.c"
	}
	goto __finally205;
	__catch205_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 166 "Config.vala"
			config_report_set_error (self, path, err);
#line 783 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 168 "Config.vala"
			return result;
#line 788 "Config.c"
		}
	}
	__finally205:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 172 "Config.vala"
static char* config_get_string (Config* self, const char* path, const char* def) {
#line 802 "Config.c"
	char* result = NULL;
	GError * _inner_error_ = NULL;
#line 172 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 172 "Config.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 809 "Config.c"
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		char* stored;
		const char* _tmp3_;
#line 174 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 818 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch206_g_error;
		}
#line 174 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 824 "Config.c"
			result = g_strdup (def);
#line 175 "Config.vala"
			return result;
#line 828 "Config.c"
		}
#line 177 "Config.vala"
		stored = gconf_client_get_string (self->priv->client, path, &_inner_error_);
#line 832 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch206_g_error;
		}
		_tmp3_ = NULL;
#line 179 "Config.vala"
		if (is_string_empty (stored)) {
#line 179 "Config.vala"
			_tmp3_ = NULL;
#line 841 "Config.c"
		} else {
#line 179 "Config.vala"
			_tmp3_ = stored;
#line 845 "Config.c"
		}
		result = g_strdup (_tmp3_);
		_g_free0 (stored);
#line 179 "Config.vala"
		return result;
#line 851 "Config.c"
	}
	goto __finally206;
	__catch206_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 181 "Config.vala"
			config_report_get_error (self, path, err);
#line 862 "Config.c"
			result = g_strdup (def);
			_g_error_free0 (err);
#line 183 "Config.vala"
			return result;
#line 867 "Config.c"
		}
	}
	__finally206:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 187 "Config.vala"
static gboolean config_set_string (Config* self, const char* path, const char* value) {
#line 881 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 187 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 187 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 187 "Config.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 890 "Config.c"
	{
#line 189 "Config.vala"
		gconf_client_set_string (self->priv->client, path, value, &_inner_error_);
#line 894 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch207_g_error;
		}
#line 191 "Config.vala"
		g_signal_emit_by_name (self, "string-changed", path, value);
#line 900 "Config.c"
		result = TRUE;
#line 193 "Config.vala"
		return result;
#line 904 "Config.c"
	}
	goto __finally207;
	__catch207_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 195 "Config.vala"
			config_report_set_error (self, path, err);
#line 915 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 197 "Config.vala"
			return result;
#line 920 "Config.c"
		}
	}
	__finally207:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 201 "Config.vala"
gboolean config_clear_flickr_auth_token (Config* self) {
#line 934 "Config.c"
	gboolean result = FALSE;
#line 201 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 938 "Config.c"
	result = config_set_flickr_auth_token (self, "");
#line 202 "Config.vala"
	return result;
#line 942 "Config.c"
}


#line 205 "Config.vala"
gboolean config_set_flickr_auth_token (Config* self, const char* token) {
#line 948 "Config.c"
	gboolean result = FALSE;
#line 205 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 205 "Config.vala"
	g_return_val_if_fail (token != NULL, FALSE);
#line 954 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/auth_token", token);
#line 206 "Config.vala"
	return result;
#line 958 "Config.c"
}


#line 209 "Config.vala"
char* config_get_flickr_auth_token (Config* self) {
#line 964 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 209 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 210 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/auth_token", NULL);
#line 972 "Config.c"
	_tmp0_ = NULL;
#line 211 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 211 "Config.vala"
		_tmp0_ = stored_value;
#line 978 "Config.c"
	} else {
#line 211 "Config.vala"
		_tmp0_ = NULL;
#line 982 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 211 "Config.vala"
	return result;
#line 988 "Config.c"
}


#line 214 "Config.vala"
gboolean config_clear_flickr_username (Config* self) {
#line 994 "Config.c"
	gboolean result = FALSE;
#line 214 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 998 "Config.c"
	result = config_set_flickr_username (self, "");
#line 215 "Config.vala"
	return result;
#line 1002 "Config.c"
}


#line 218 "Config.vala"
gboolean config_set_flickr_username (Config* self, const char* username) {
#line 1008 "Config.c"
	gboolean result = FALSE;
#line 218 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 218 "Config.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 1014 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/username", username);
#line 219 "Config.vala"
	return result;
#line 1018 "Config.c"
}


#line 222 "Config.vala"
char* config_get_flickr_username (Config* self) {
#line 1024 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 222 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 223 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/username", NULL);
#line 1032 "Config.c"
	_tmp0_ = NULL;
#line 224 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 224 "Config.vala"
		_tmp0_ = stored_value;
#line 1038 "Config.c"
	} else {
#line 224 "Config.vala"
		_tmp0_ = NULL;
#line 1042 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 224 "Config.vala"
	return result;
#line 1048 "Config.c"
}


#line 227 "Config.vala"
gboolean config_set_flickr_default_size (Config* self, gint sizecode) {
#line 1054 "Config.c"
	gboolean result = FALSE;
#line 227 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1058 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/default_size", sizecode + 1);
#line 228 "Config.vala"
	return result;
#line 1062 "Config.c"
}


#line 231 "Config.vala"
gint config_get_flickr_default_size (Config* self) {
#line 1068 "Config.c"
	gint result = 0;
#line 231 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1072 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/default_size", 2) - 1;
#line 232 "Config.vala"
	return result;
#line 1076 "Config.c"
}


#line 235 "Config.vala"
gboolean config_set_flickr_visibility (Config* self, gint viscode) {
#line 1082 "Config.c"
	gboolean result = FALSE;
#line 235 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1086 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/visibility", viscode + 1);
#line 236 "Config.vala"
	return result;
#line 1090 "Config.c"
}


#line 239 "Config.vala"
gint config_get_flickr_visibility (Config* self) {
#line 1096 "Config.c"
	gint result = 0;
#line 239 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1100 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/visibility", 1) - 1;
#line 240 "Config.vala"
	return result;
#line 1104 "Config.c"
}


#line 243 "Config.vala"
gboolean config_set_last_used_service (Config* self, const char* service_name) {
#line 1110 "Config.c"
	gboolean result = FALSE;
#line 243 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 243 "Config.vala"
	g_return_val_if_fail (service_name != NULL, FALSE);
#line 1116 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/last_used_service", service_name);
#line 244 "Config.vala"
	return result;
#line 1120 "Config.c"
}


#line 247 "Config.vala"
char* config_get_last_used_service (Config* self) {
#line 1126 "Config.c"
	char* result = NULL;
#line 247 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1130 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/last_used_service", NULL);
#line 248 "Config.vala"
	return result;
#line 1134 "Config.c"
}


#line 251 "Config.vala"
gboolean config_clear_facebook_session_key (Config* self) {
#line 1140 "Config.c"
	gboolean result = FALSE;
#line 251 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1144 "Config.c"
	result = config_set_facebook_session_key (self, "");
#line 252 "Config.vala"
	return result;
#line 1148 "Config.c"
}


#line 255 "Config.vala"
gboolean config_set_facebook_session_key (Config* self, const char* key) {
#line 1154 "Config.c"
	gboolean result = FALSE;
#line 255 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 255 "Config.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 1160 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_key", key);
#line 256 "Config.vala"
	return result;
#line 1164 "Config.c"
}


#line 259 "Config.vala"
char* config_get_facebook_session_key (Config* self) {
#line 1170 "Config.c"
	char* result = NULL;
#line 259 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1174 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_key", NULL);
#line 260 "Config.vala"
	return result;
#line 1178 "Config.c"
}


#line 263 "Config.vala"
gboolean config_clear_facebook_session_secret (Config* self) {
#line 1184 "Config.c"
	gboolean result = FALSE;
#line 263 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1188 "Config.c"
	result = config_set_facebook_session_secret (self, "");
#line 264 "Config.vala"
	return result;
#line 1192 "Config.c"
}


#line 267 "Config.vala"
gboolean config_set_facebook_session_secret (Config* self, const char* secret) {
#line 1198 "Config.c"
	gboolean result = FALSE;
#line 267 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 267 "Config.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 1204 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_secret", secret);
#line 268 "Config.vala"
	return result;
#line 1208 "Config.c"
}


#line 271 "Config.vala"
char* config_get_facebook_session_secret (Config* self) {
#line 1214 "Config.c"
	char* result = NULL;
#line 271 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1218 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_secret", NULL);
#line 272 "Config.vala"
	return result;
#line 1222 "Config.c"
}


#line 275 "Config.vala"
gboolean config_clear_facebook_uid (Config* self) {
#line 1228 "Config.c"
	gboolean result = FALSE;
#line 275 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1232 "Config.c"
	result = config_set_facebook_uid (self, "");
#line 276 "Config.vala"
	return result;
#line 1236 "Config.c"
}


#line 279 "Config.vala"
gboolean config_set_facebook_uid (Config* self, const char* uid) {
#line 1242 "Config.c"
	gboolean result = FALSE;
#line 279 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 279 "Config.vala"
	g_return_val_if_fail (uid != NULL, FALSE);
#line 1248 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/uid", uid);
#line 280 "Config.vala"
	return result;
#line 1252 "Config.c"
}


#line 283 "Config.vala"
char* config_get_facebook_uid (Config* self) {
#line 1258 "Config.c"
	char* result = NULL;
#line 283 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1262 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/uid", NULL);
#line 284 "Config.vala"
	return result;
#line 1266 "Config.c"
}


#line 287 "Config.vala"
gboolean config_clear_facebook_user_name (Config* self) {
#line 1272 "Config.c"
	gboolean result = FALSE;
#line 287 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1276 "Config.c"
	result = config_set_facebook_user_name (self, "");
#line 288 "Config.vala"
	return result;
#line 1280 "Config.c"
}


#line 291 "Config.vala"
gboolean config_set_facebook_user_name (Config* self, const char* user_name) {
#line 1286 "Config.c"
	gboolean result = FALSE;
#line 291 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 291 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1292 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/user_name", user_name);
#line 292 "Config.vala"
	return result;
#line 1296 "Config.c"
}


#line 295 "Config.vala"
char* config_get_facebook_user_name (Config* self) {
#line 1302 "Config.c"
	char* result = NULL;
#line 295 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1306 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/user_name", NULL);
#line 296 "Config.vala"
	return result;
#line 1310 "Config.c"
}


#line 299 "Config.vala"
gboolean config_set_picasa_default_size (Config* self, gint default_size) {
#line 1316 "Config.c"
	gboolean result = FALSE;
#line 299 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1320 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/picasa/default_size", default_size + 1);
#line 300 "Config.vala"
	return result;
#line 1324 "Config.c"
}


#line 303 "Config.vala"
gint config_get_picasa_default_size (Config* self) {
#line 1330 "Config.c"
	gint result = 0;
#line 303 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1334 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/picasa/default_size", 3) - 1;
#line 304 "Config.vala"
	return result;
#line 1338 "Config.c"
}


#line 307 "Config.vala"
char* config_get_publishing_string (Config* self, const char* id, const char* key) {
#line 1344 "Config.c"
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
#line 307 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 307 "Config.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 307 "Config.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 1354 "Config.c"
	result = (_tmp1_ = config_get_string (self, _tmp0_ = g_strdup_printf (_ ("/apps/shotwell/sharing/%s/%s"), id, key), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 308 "Config.vala"
	return result;
#line 1358 "Config.c"
}


#line 311 "Config.vala"
void config_set_publishing_string (Config* self, const char* id, const char* key, const char* value) {
#line 1364 "Config.c"
	char* _tmp0_;
#line 311 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 311 "Config.vala"
	g_return_if_fail (id != NULL);
#line 311 "Config.vala"
	g_return_if_fail (key != NULL);
#line 311 "Config.vala"
	g_return_if_fail (value != NULL);
#line 312 "Config.vala"
	config_set_string (self, _tmp0_ = g_strdup_printf (_ ("/apps/shotwell/sharing/%s/%s"), id, key), value);
#line 1376 "Config.c"
	_g_free0 (_tmp0_);
}


#line 315 "Config.vala"
void config_unset_publishing_string (Config* self, const char* id, const char* key) {
#line 1383 "Config.c"
	GError * _inner_error_ = NULL;
#line 315 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 315 "Config.vala"
	g_return_if_fail (id != NULL);
#line 315 "Config.vala"
	g_return_if_fail (key != NULL);
#line 1391 "Config.c"
	{
		char* _tmp0_;
#line 317 "Config.vala"
		gconf_client_recursive_unset (self->priv->client, _tmp0_ = g_strdup_printf (_ ("/apps/shotwell/sharing/%s/%s"), id, key), GCONF_UNSET_INCLUDING_SCHEMA_NAMES, &_inner_error_);
#line 1396 "Config.c"
		_g_free0 (_tmp0_);
		if (_inner_error_ != NULL) {
			goto __catch208_g_error;
		}
	}
	goto __finally208;
	__catch208_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (err);
		}
	}
	__finally208:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 322 "Config.vala"
gboolean config_set_printing_content_layout (Config* self, gint layout_code) {
#line 1423 "Config.c"
	gboolean result = FALSE;
#line 322 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1427 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_layout", layout_code + 1);
#line 323 "Config.vala"
	return result;
#line 1431 "Config.c"
}


#line 326 "Config.vala"
gint config_get_printing_content_layout (Config* self) {
#line 1437 "Config.c"
	gint result = 0;
#line 326 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1441 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_layout", 1) - 1;
#line 327 "Config.vala"
	return result;
#line 1445 "Config.c"
}


#line 330 "Config.vala"
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi) {
#line 1451 "Config.c"
	gboolean result = FALSE;
#line 330 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1455 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_ppi", content_ppi);
#line 331 "Config.vala"
	return result;
#line 1459 "Config.c"
}


#line 334 "Config.vala"
gint config_get_printing_content_ppi (Config* self) {
#line 1465 "Config.c"
	gint result = 0;
#line 334 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1469 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_ppi", 600);
#line 335 "Config.vala"
	return result;
#line 1473 "Config.c"
}


#line 338 "Config.vala"
gboolean config_set_printing_content_width (Config* self, double content_width) {
#line 1479 "Config.c"
	gboolean result = FALSE;
#line 338 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1483 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_width", content_width);
#line 339 "Config.vala"
	return result;
#line 1487 "Config.c"
}


#line 342 "Config.vala"
double config_get_printing_content_width (Config* self) {
#line 1493 "Config.c"
	double result = 0.0;
#line 342 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1497 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_width", 7.0);
#line 343 "Config.vala"
	return result;
#line 1501 "Config.c"
}


#line 346 "Config.vala"
gboolean config_set_printing_content_height (Config* self, double content_height) {
#line 1507 "Config.c"
	gboolean result = FALSE;
#line 346 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1511 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_height", content_height);
#line 347 "Config.vala"
	return result;
#line 1515 "Config.c"
}


#line 350 "Config.vala"
double config_get_printing_content_height (Config* self) {
#line 1521 "Config.c"
	double result = 0.0;
#line 350 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1525 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_height", 5.0);
#line 351 "Config.vala"
	return result;
#line 1529 "Config.c"
}


#line 354 "Config.vala"
gboolean config_set_printing_content_units (Config* self, gint units_code) {
#line 1535 "Config.c"
	gboolean result = FALSE;
#line 354 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1539 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_units", units_code + 1);
#line 355 "Config.vala"
	return result;
#line 1543 "Config.c"
}


#line 358 "Config.vala"
gint config_get_printing_content_units (Config* self) {
#line 1549 "Config.c"
	gint result = 0;
#line 358 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1553 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_units", 1) - 1;
#line 359 "Config.vala"
	return result;
#line 1557 "Config.c"
}


#line 362 "Config.vala"
gboolean config_set_printing_size_selection (Config* self, gint size_code) {
#line 1563 "Config.c"
	gboolean result = FALSE;
#line 362 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1567 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/size_selection", size_code + 1);
#line 363 "Config.vala"
	return result;
#line 1571 "Config.c"
}


#line 366 "Config.vala"
gint config_get_printing_size_selection (Config* self) {
#line 1577 "Config.c"
	gint result = 0;
#line 366 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1581 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/size_selection", 1) - 1;
#line 367 "Config.vala"
	return result;
#line 1585 "Config.c"
}


#line 370 "Config.vala"
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio) {
#line 1591 "Config.c"
	gboolean result = FALSE;
#line 370 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1595 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/printing/match_aspect_ratio", match_aspect_ratio);
#line 371 "Config.vala"
	return result;
#line 1599 "Config.c"
}


#line 374 "Config.vala"
gboolean config_get_printing_match_aspect_ratio (Config* self) {
#line 1605 "Config.c"
	gboolean result = FALSE;
#line 374 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1609 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/printing/match_aspect_ratio", TRUE);
#line 375 "Config.vala"
	return result;
#line 1613 "Config.c"
}


#line 378 "Config.vala"
gboolean config_set_display_basic_properties (Config* self, gboolean display) {
#line 1619 "Config.c"
	gboolean result = FALSE;
#line 378 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1623 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", display);
#line 379 "Config.vala"
	return result;
#line 1627 "Config.c"
}


#line 382 "Config.vala"
gboolean config_get_display_basic_properties (Config* self) {
#line 1633 "Config.c"
	gboolean result = FALSE;
#line 382 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1637 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", TRUE);
#line 383 "Config.vala"
	return result;
#line 1641 "Config.c"
}


#line 386 "Config.vala"
gboolean config_set_display_extended_properties (Config* self, gboolean display) {
#line 1647 "Config.c"
	gboolean result = FALSE;
#line 386 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1651 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", display);
#line 387 "Config.vala"
	return result;
#line 1655 "Config.c"
}


#line 390 "Config.vala"
gboolean config_get_display_extended_properties (Config* self) {
#line 1661 "Config.c"
	gboolean result = FALSE;
#line 390 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1665 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", FALSE);
#line 391 "Config.vala"
	return result;
#line 1669 "Config.c"
}


#line 394 "Config.vala"
gboolean config_set_display_photo_titles (Config* self, gboolean display) {
#line 1675 "Config.c"
	gboolean result = FALSE;
#line 394 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1679 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", display);
#line 395 "Config.vala"
	return result;
#line 1683 "Config.c"
}


#line 398 "Config.vala"
gboolean config_get_display_photo_titles (Config* self) {
#line 1689 "Config.c"
	gboolean result = FALSE;
#line 398 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1693 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", FALSE);
#line 399 "Config.vala"
	return result;
#line 1697 "Config.c"
}


#line 402 "Config.vala"
gboolean config_get_display_photo_tags (Config* self) {
#line 1703 "Config.c"
	gboolean result = FALSE;
#line 402 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1707 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", TRUE);
#line 403 "Config.vala"
	return result;
#line 1711 "Config.c"
}


#line 406 "Config.vala"
gboolean config_set_display_photo_tags (Config* self, gboolean display) {
#line 1717 "Config.c"
	gboolean result = FALSE;
#line 406 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1721 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", display);
#line 407 "Config.vala"
	return result;
#line 1725 "Config.c"
}


#line 410 "Config.vala"
gboolean config_get_display_photo_ratings (Config* self) {
#line 1731 "Config.c"
	gboolean result = FALSE;
#line 410 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1735 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_ratings", TRUE);
#line 411 "Config.vala"
	return result;
#line 1739 "Config.c"
}


#line 414 "Config.vala"
gboolean config_set_display_photo_ratings (Config* self, gboolean display) {
#line 1745 "Config.c"
	gboolean result = FALSE;
#line 414 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1749 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_ratings", display);
#line 415 "Config.vala"
	return result;
#line 1753 "Config.c"
}


#line 418 "Config.vala"
gboolean config_set_slideshow_delay (Config* self, double delay) {
#line 1759 "Config.c"
	gboolean result = FALSE;
#line 418 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1763 "Config.c"
	result = config_set_double (self, "/apps/shotwell/preferences/slideshow/delay", delay);
#line 419 "Config.vala"
	return result;
#line 1767 "Config.c"
}


#line 422 "Config.vala"
double config_get_slideshow_delay (Config* self) {
#line 1773 "Config.c"
	double result = 0.0;
#line 422 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1777 "Config.c"
	result = CLAMP (config_get_double (self, "/apps/shotwell/preferences/slideshow/delay", CONFIG_SLIDESHOW_DELAY_DEFAULT), CONFIG_SLIDESHOW_DELAY_MIN, CONFIG_SLIDESHOW_DELAY_MAX);
#line 423 "Config.vala"
	return result;
#line 1781 "Config.c"
}


#line 427 "Config.vala"
RatingFilter config_get_photo_rating_filter (Config* self) {
#line 1787 "Config.c"
	RatingFilter result = 0;
#line 427 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1791 "Config.c"
	result = (RatingFilter) config_get_int (self, "/apps/shotwell/preferences/ui/photo_rating_filter", (gint) RATING_FILTER_UNRATED_OR_HIGHER);
#line 428 "Config.vala"
	return result;
#line 1795 "Config.c"
}


#line 432 "Config.vala"
gboolean config_set_photo_rating_filter (Config* self, RatingFilter filter) {
#line 1801 "Config.c"
	gboolean result = FALSE;
#line 432 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1805 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/ui/photo_rating_filter", (gint) filter);
#line 433 "Config.vala"
	return result;
#line 1809 "Config.c"
}


#line 436 "Config.vala"
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1815 "Config.c"
	Dimensions _tmp0_ = {0};
#line 436 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 437 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/library_maximize", FALSE);
#line 438 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/library_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/library_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1823 "Config.c"
}


#line 443 "Config.vala"
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1829 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 443 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 444 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/library_maximize", maximize)) {
#line 445 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/library_width", (*dimensions).width);
#line 1839 "Config.c"
	} else {
#line 444 "Config.vala"
		_tmp1_ = FALSE;
#line 1843 "Config.c"
	}
#line 444 "Config.vala"
	if (_tmp1_) {
#line 446 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/library_height", (*dimensions).height);
#line 1849 "Config.c"
	} else {
#line 444 "Config.vala"
		_tmp0_ = FALSE;
#line 1853 "Config.c"
	}
	result = _tmp0_;
#line 444 "Config.vala"
	return result;
#line 1858 "Config.c"
}


#line 449 "Config.vala"
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1864 "Config.c"
	Dimensions _tmp0_ = {0};
#line 449 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 450 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/direct_maximize", FALSE);
#line 451 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/direct_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/direct_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1872 "Config.c"
}


#line 456 "Config.vala"
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1878 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 456 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 457 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/direct_maximize", maximize)) {
#line 458 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_width", (*dimensions).width);
#line 1888 "Config.c"
	} else {
#line 457 "Config.vala"
		_tmp1_ = FALSE;
#line 1892 "Config.c"
	}
#line 457 "Config.vala"
	if (_tmp1_) {
#line 459 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_height", (*dimensions).height);
#line 1898 "Config.c"
	} else {
#line 457 "Config.vala"
		_tmp0_ = FALSE;
#line 1902 "Config.c"
	}
	result = _tmp0_;
#line 457 "Config.vala"
	return result;
#line 1907 "Config.c"
}


#line 462 "Config.vala"
gint config_get_sidebar_position (Config* self) {
#line 1913 "Config.c"
	gint result = 0;
#line 462 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1917 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/window/pane_position", CONFIG_SIDEBAR_MIN_POSITION), CONFIG_SIDEBAR_MIN_POSITION, CONFIG_SIDEBAR_MAX_POSITION);
#line 463 "Config.vala"
	return result;
#line 1921 "Config.c"
}


#line 466 "Config.vala"
gboolean config_set_sidebar_position (Config* self, gint position) {
#line 1927 "Config.c"
	gboolean result = FALSE;
#line 466 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1931 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/window/pane_position", position);
#line 467 "Config.vala"
	return result;
#line 1935 "Config.c"
}


#line 470 "Config.vala"
gboolean config_get_events_sort_ascending (Config* self) {
#line 1941 "Config.c"
	gboolean result = FALSE;
#line 470 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1945 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", FALSE);
#line 471 "Config.vala"
	return result;
#line 1949 "Config.c"
}


#line 474 "Config.vala"
gboolean config_set_events_sort_ascending (Config* self, gboolean sort) {
#line 1955 "Config.c"
	gboolean result = FALSE;
#line 474 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1959 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", sort);
#line 475 "Config.vala"
	return result;
#line 1963 "Config.c"
}


#line 478 "Config.vala"
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 478 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 479 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", FALSE);
#line 480 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", (gint) MEDIA_PAGE_SORT_BY_EXPOSURE_DATE);
#line 481 "Config.vala"
	*sort_by = CLAMP (*sort_by, (gint) MEDIA_PAGE_SORT_BY_MIN, (gint) MEDIA_PAGE_SORT_BY_MAX);
#line 1977 "Config.c"
}


#line 484 "Config.vala"
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1983 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 484 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 485 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", sort_order)) {
#line 486 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", sort_by);
#line 1992 "Config.c"
	} else {
#line 485 "Config.vala"
		_tmp0_ = FALSE;
#line 1996 "Config.c"
	}
	result = _tmp0_;
#line 485 "Config.vala"
	return result;
#line 2001 "Config.c"
}


#line 489 "Config.vala"
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 489 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 490 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", TRUE);
#line 491 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", (gint) MEDIA_PAGE_SORT_BY_EXPOSURE_DATE);
#line 492 "Config.vala"
	*sort_by = CLAMP (*sort_by, (gint) MEDIA_PAGE_SORT_BY_MIN, (gint) MEDIA_PAGE_SORT_BY_MAX);
#line 2015 "Config.c"
}


#line 495 "Config.vala"
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 2021 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 495 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 496 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", sort_order)) {
#line 497 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", sort_by);
#line 2030 "Config.c"
	} else {
#line 496 "Config.vala"
		_tmp0_ = FALSE;
#line 2034 "Config.c"
	}
	result = _tmp0_;
#line 496 "Config.vala"
	return result;
#line 2039 "Config.c"
}


#line 500 "Config.vala"
gboolean config_get_24_hr_time (Config* self) {
#line 2045 "Config.c"
	gboolean result = FALSE;
#line 500 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2049 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", is_twentyfour_hr_time_system ());
#line 501 "Config.vala"
	return result;
#line 2053 "Config.c"
}


#line 505 "Config.vala"
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time) {
#line 2059 "Config.c"
	gboolean result = FALSE;
#line 505 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2063 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", twentyfour_hr_time);
#line 506 "Config.vala"
	return result;
#line 2067 "Config.c"
}


#line 509 "Config.vala"
gboolean config_get_keep_relativity (Config* self) {
#line 2073 "Config.c"
	gboolean result = FALSE;
#line 509 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2077 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", TRUE);
#line 510 "Config.vala"
	return result;
#line 2081 "Config.c"
}


#line 513 "Config.vala"
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity) {
#line 2087 "Config.c"
	gboolean result = FALSE;
#line 513 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2091 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", keep_relativity);
#line 514 "Config.vala"
	return result;
#line 2095 "Config.c"
}


#line 517 "Config.vala"
gboolean config_get_modify_originals (Config* self) {
#line 2101 "Config.c"
	gboolean result = FALSE;
#line 517 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2105 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/modify_originals", FALSE);
#line 518 "Config.vala"
	return result;
#line 2109 "Config.c"
}


#line 521 "Config.vala"
gboolean config_set_modify_originals (Config* self, gboolean modify_originals) {
#line 2115 "Config.c"
	gboolean result = FALSE;
#line 521 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2119 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/modify_originals", modify_originals);
#line 522 "Config.vala"
	return result;
#line 2123 "Config.c"
}


#line 525 "Config.vala"
gboolean config_set_video_interpreter_state_cookie (Config* self, gint state_cookie) {
#line 2129 "Config.c"
	gboolean result = FALSE;
#line 525 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2133 "Config.c"
	result = config_set_int (self, "/apps/shotwell/video/interpreter_state_cookie", state_cookie);
#line 526 "Config.vala"
	return result;
#line 2137 "Config.c"
}


#line 529 "Config.vala"
gint config_get_video_interpreter_state_cookie (Config* self) {
#line 2143 "Config.c"
	gint result = 0;
#line 529 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 2147 "Config.c"
	result = config_get_int (self, "/apps/shotwell/video/interpreter_state_cookie", CONFIG_NO_VIDEO_INTERPRETER_STATE);
#line 530 "Config.vala"
	return result;
#line 2151 "Config.c"
}


#line 533 "Config.vala"
char* config_get_background (Config* self) {
#line 2157 "Config.c"
	char* result = NULL;
#line 533 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 2161 "Config.c"
	result = config_get_string (self, "/desktop/gnome/background/picture_filename", NULL);
#line 534 "Config.vala"
	return result;
#line 2165 "Config.c"
}


#line 537 "Config.vala"
gboolean config_set_background (Config* self, const char* filename) {
#line 2171 "Config.c"
	gboolean result = FALSE;
#line 537 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 537 "Config.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 538 "Config.vala"
	if (!config_set_string (self, "/desktop/gnome/background/picture_options", "zoom")) {
#line 2179 "Config.c"
		result = FALSE;
#line 539 "Config.vala"
		return result;
#line 2183 "Config.c"
	}
	result = config_set_string (self, "/desktop/gnome/background/picture_filename", filename);
#line 540 "Config.vala"
	return result;
#line 2188 "Config.c"
}


#line 543 "Config.vala"
gboolean config_get_show_welcome_dialog (Config* self) {
#line 2194 "Config.c"
	gboolean result = FALSE;
#line 543 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2198 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", TRUE);
#line 544 "Config.vala"
	return result;
#line 2202 "Config.c"
}


#line 547 "Config.vala"
gboolean config_set_show_welcome_dialog (Config* self, gboolean show) {
#line 2208 "Config.c"
	gboolean result = FALSE;
#line 547 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2212 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", show);
#line 548 "Config.vala"
	return result;
#line 2216 "Config.c"
}


#line 551 "Config.vala"
gboolean config_set_photo_thumbnail_scale (Config* self, gint scale) {
#line 2222 "Config.c"
	gboolean result = FALSE;
#line 551 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2226 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/ui/photo_thumbnail_scale", scale);
#line 552 "Config.vala"
	return result;
#line 2230 "Config.c"
}


#line 555 "Config.vala"
gint config_get_photo_thumbnail_scale (Config* self) {
#line 2236 "Config.c"
	gint result = 0;
#line 555 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 2240 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/ui/photo_thumbnail_scale", THUMBNAIL_DEFAULT_SCALE), THUMBNAIL_MIN_SCALE, THUMBNAIL_MAX_SCALE);
#line 556 "Config.vala"
	return result;
#line 2244 "Config.c"
}


#line 561 "Config.vala"
static void config_get_colors (Config* self) {
#line 2250 "Config.c"
	char* _tmp0_;
	GdkColor _tmp2_ = {0};
	GdkColor _tmp3_;
#line 561 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 562 "Config.vala"
	self->priv->bg_color = (_tmp0_ = config_get_string (self, "/apps/shotwell/preferences/ui/background_color", CONFIG_DEFAULT_BG_COLOR), _g_free0 (self->priv->bg_color), _tmp0_);
#line 564 "Config.vala"
	if (!is_color_parsable (self->priv->bg_color)) {
#line 2260 "Config.c"
		char* _tmp1_;
#line 565 "Config.vala"
		self->priv->bg_color = (_tmp1_ = g_strdup (CONFIG_DEFAULT_BG_COLOR), _g_free0 (self->priv->bg_color), _tmp1_);
#line 2264 "Config.c"
	}
#line 567 "Config.vala"
	config_set_text_colors (self, (_tmp3_ = (parse_color (self->priv->bg_color, &_tmp2_), _tmp2_), &_tmp3_));
#line 2268 "Config.c"
}


#line 570 "Config.vala"
void config_get_bg_color (Config* self, GdkColor* result) {
#line 2274 "Config.c"
	GdkColor _tmp0_ = {0};
#line 570 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 571 "Config.vala"
	if (is_string_empty (self->priv->bg_color)) {
#line 572 "Config.vala"
		config_get_colors (self);
#line 2282 "Config.c"
	}
	*result = (parse_color (self->priv->bg_color, &_tmp0_), _tmp0_);
#line 574 "Config.vala"
	return;
#line 2287 "Config.c"
}


#line 577 "Config.vala"
void config_get_selected_color (Config* self, gboolean in_focus, GdkColor* result) {
#line 577 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 578 "Config.vala"
	if (in_focus) {
#line 2297 "Config.c"
		GdkColor _tmp0_ = {0};
#line 579 "Config.vala"
		if (is_string_empty (self->priv->selected_color)) {
#line 580 "Config.vala"
			config_get_colors (self);
#line 2303 "Config.c"
		}
		*result = (parse_color (self->priv->selected_color, &_tmp0_), _tmp0_);
#line 582 "Config.vala"
		return;
#line 2308 "Config.c"
	} else {
		GdkColor _tmp1_ = {0};
#line 584 "Config.vala"
		if (is_string_empty (self->priv->unfocused_selected_color)) {
#line 585 "Config.vala"
			config_get_colors (self);
#line 2315 "Config.c"
		}
		*result = (parse_color (self->priv->unfocused_selected_color, &_tmp1_), _tmp1_);
#line 587 "Config.vala"
		return;
#line 2320 "Config.c"
	}
}


#line 591 "Config.vala"
void config_get_unselected_color (Config* self, GdkColor* result) {
#line 2327 "Config.c"
	GdkColor _tmp0_ = {0};
#line 591 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 592 "Config.vala"
	if (is_string_empty (self->priv->unselected_color)) {
#line 593 "Config.vala"
		config_get_colors (self);
#line 2335 "Config.c"
	}
	*result = (parse_color (self->priv->unselected_color, &_tmp0_), _tmp0_);
#line 595 "Config.vala"
	return;
#line 2340 "Config.c"
}


#line 598 "Config.vala"
void config_get_border_color (Config* self, GdkColor* result) {
#line 2346 "Config.c"
	GdkColor _tmp0_ = {0};
#line 598 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 599 "Config.vala"
	if (is_string_empty (self->priv->border_color)) {
#line 600 "Config.vala"
		config_get_colors (self);
#line 2354 "Config.c"
	}
	*result = (parse_color (self->priv->border_color, &_tmp0_), _tmp0_);
#line 602 "Config.vala"
	return;
#line 2359 "Config.c"
}


#line 605 "Config.vala"
static void config_set_text_colors (Config* self, GdkColor* bg_color) {
#line 605 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 609 "Config.vala"
	if ((*bg_color).red > CONFIG_BLACK_THRESHOLD) {
#line 2369 "Config.c"
		char* _tmp0_;
		char* _tmp1_;
		char* _tmp2_;
		char* _tmp3_;
#line 610 "Config.vala"
		self->priv->selected_color = (_tmp0_ = g_strdup (CONFIG_DARK_SELECTED_COLOR), _g_free0 (self->priv->selected_color), _tmp0_);
#line 611 "Config.vala"
		self->priv->unselected_color = (_tmp1_ = g_strdup (CONFIG_DARK_UNSELECTED_COLOR), _g_free0 (self->priv->unselected_color), _tmp1_);
#line 612 "Config.vala"
		self->priv->unfocused_selected_color = (_tmp2_ = g_strdup (CONFIG_DARK_UNFOCUSED_SELECTED_COLOR), _g_free0 (self->priv->unfocused_selected_color), _tmp2_);
#line 613 "Config.vala"
		self->priv->border_color = (_tmp3_ = g_strdup (CONFIG_DARK_BORDER_COLOR), _g_free0 (self->priv->border_color), _tmp3_);
#line 2382 "Config.c"
	} else {
		char* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
		char* _tmp7_;
#line 615 "Config.vala"
		self->priv->selected_color = (_tmp4_ = g_strdup (CONFIG_LIGHT_SELECTED_COLOR), _g_free0 (self->priv->selected_color), _tmp4_);
#line 616 "Config.vala"
		self->priv->unselected_color = (_tmp5_ = g_strdup (CONFIG_LIGHT_UNSELECTED_COLOR), _g_free0 (self->priv->unselected_color), _tmp5_);
#line 617 "Config.vala"
		self->priv->unfocused_selected_color = (_tmp6_ = g_strdup (CONFIG_LIGHT_UNFOCUSED_SELECTED_COLOR), _g_free0 (self->priv->unfocused_selected_color), _tmp6_);
#line 618 "Config.vala"
		self->priv->border_color = (_tmp7_ = g_strdup (CONFIG_LIGHT_BORDER_COLOR), _g_free0 (self->priv->border_color), _tmp7_);
#line 2396 "Config.c"
	}
}


#line 622 "Config.vala"
void config_set_bg_color (Config* self, GdkColor* color) {
#line 2403 "Config.c"
	char* _tmp0_;
#line 622 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 623 "Config.vala"
	self->priv->bg_color = (_tmp0_ = gdk_color_to_string (color), _g_free0 (self->priv->bg_color), _tmp0_);
#line 625 "Config.vala"
	config_set_text_colors (self, color);
#line 627 "Config.vala"
	g_signal_emit_by_name (self, "colors-changed");
#line 2413 "Config.c"
}


#line 630 "Config.vala"
gboolean config_commit_bg_color (Config* self) {
#line 2419 "Config.c"
	gboolean result = FALSE;
#line 630 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2423 "Config.c"
	result = config_set_string (self, "/apps/shotwell/preferences/ui/background_color", self->priv->bg_color);
#line 631 "Config.vala"
	return result;
#line 2427 "Config.c"
}


#line 634 "Config.vala"
char* config_get_import_dir (Config* self) {
#line 2433 "Config.c"
	char* result = NULL;
#line 634 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 2437 "Config.c"
	result = config_get_string (self, CONFIG_STRING_IMPORT_DIRECTORY, NULL);
#line 635 "Config.vala"
	return result;
#line 2441 "Config.c"
}


#line 638 "Config.vala"
void config_set_import_dir (Config* self, const char* import_dir) {
#line 638 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 638 "Config.vala"
	g_return_if_fail (import_dir != NULL);
#line 639 "Config.vala"
	config_set_string (self, CONFIG_STRING_IMPORT_DIRECTORY, import_dir);
#line 2453 "Config.c"
}


#line 642 "Config.vala"
char* config_get_external_photo_app (Config* self) {
#line 2459 "Config.c"
	char* result = NULL;
	char* external_app;
	GeeArrayList* preferred_apps;
	gint _tmp0_;
	char** _tmp1_;
	gint _tmp1__length1;
	char** _tmp2_;
	GAppInfo* _tmp3_;
	GAppInfo* app;
	char* _tmp4_;
#line 642 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 643 "Config.vala"
	external_app = config_get_string (self, "/apps/shotwell/preferences/editing/external_photo_editor", "");
#line 645 "Config.vala"
	if (!is_string_empty (external_app)) {
#line 2476 "Config.c"
		result = external_app;
#line 646 "Config.vala"
		return result;
#line 2480 "Config.c"
	}
#line 648 "Config.vala"
	preferred_apps = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 649 "Config.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (preferred_apps), "GIMP");
#line 651 "Config.vala"
	app = (_tmp3_ = (_tmp2_ = (_tmp1_ = photo_file_format_get_editable_mime_types (&_tmp0_), _tmp1__length1 = _tmp0_, _tmp1_), desktop_integration_get_default_app_for_mime_types (_tmp2_, _tmp0_, preferred_apps)), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp3_);
#line 2488 "Config.c"
	_tmp4_ = NULL;
#line 654 "Config.vala"
	if (app != NULL) {
#line 2492 "Config.c"
		char* _tmp5_;
#line 654 "Config.vala"
		_tmp4_ = (_tmp5_ = desktop_integration_get_app_open_command (app), _g_free0 (_tmp4_), _tmp5_);
#line 2496 "Config.c"
	} else {
		char* _tmp6_;
#line 654 "Config.vala"
		_tmp4_ = (_tmp6_ = g_strdup (""), _g_free0 (_tmp4_), _tmp6_);
#line 2501 "Config.c"
	}
	result = _tmp4_;
	_g_object_unref0 (app);
	_g_object_unref0 (preferred_apps);
	_g_free0 (external_app);
#line 654 "Config.vala"
	return result;
#line 2509 "Config.c"
}


#line 657 "Config.vala"
void config_set_external_photo_app (Config* self, const char* external_photo_app) {
#line 657 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 657 "Config.vala"
	g_return_if_fail (external_photo_app != NULL);
#line 658 "Config.vala"
	config_set_string (self, "/apps/shotwell/preferences/editing/external_photo_editor", external_photo_app);
#line 660 "Config.vala"
	g_signal_emit_by_name (self, "external-app-changed");
#line 2523 "Config.c"
}


#line 663 "Config.vala"
char* config_get_external_raw_app (Config* self) {
#line 2529 "Config.c"
	char* result = NULL;
	char* external_app;
	GeeArrayList* preferred_apps;
	gint _tmp0_;
	char** _tmp1_;
	gint _tmp1__length1;
	char** _tmp2_;
	GAppInfo* _tmp3_;
	GAppInfo* app;
	char* _tmp4_;
#line 663 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 664 "Config.vala"
	external_app = config_get_string (self, "/apps/shotwell/preferences/editing/external_raw_editor", "");
#line 666 "Config.vala"
	if (!is_string_empty (external_app)) {
#line 2546 "Config.c"
		result = external_app;
#line 667 "Config.vala"
		return result;
#line 2550 "Config.c"
	}
#line 669 "Config.vala"
	preferred_apps = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 670 "Config.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (preferred_apps), "UFRaw");
#line 672 "Config.vala"
	app = (_tmp3_ = (_tmp2_ = (_tmp1_ = photo_file_format_get_mime_types (PHOTO_FILE_FORMAT_RAW, &_tmp0_), _tmp1__length1 = _tmp0_, _tmp1_), desktop_integration_get_default_app_for_mime_types (_tmp2_, _tmp0_, preferred_apps)), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp3_);
#line 2558 "Config.c"
	_tmp4_ = NULL;
#line 675 "Config.vala"
	if (app != NULL) {
#line 2562 "Config.c"
		char* _tmp5_;
#line 675 "Config.vala"
		_tmp4_ = (_tmp5_ = desktop_integration_get_app_open_command (app), _g_free0 (_tmp4_), _tmp5_);
#line 2566 "Config.c"
	} else {
		char* _tmp6_;
#line 675 "Config.vala"
		_tmp4_ = (_tmp6_ = g_strdup (""), _g_free0 (_tmp4_), _tmp6_);
#line 2571 "Config.c"
	}
	result = _tmp4_;
	_g_object_unref0 (app);
	_g_object_unref0 (preferred_apps);
	_g_free0 (external_app);
#line 675 "Config.vala"
	return result;
#line 2579 "Config.c"
}


#line 678 "Config.vala"
void config_set_external_raw_app (Config* self, const char* external_raw_app) {
#line 678 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 678 "Config.vala"
	g_return_if_fail (external_raw_app != NULL);
#line 679 "Config.vala"
	config_set_string (self, "/apps/shotwell/preferences/editing/external_raw_editor", external_raw_app);
#line 680 "Config.vala"
	g_signal_emit_by_name (self, "external-app-changed");
#line 2593 "Config.c"
}


#line 683 "Config.vala"
gboolean config_get_auto_import_from_library (Config* self) {
#line 2599 "Config.c"
	gboolean result = FALSE;
#line 683 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2603 "Config.c"
	result = config_get_registered_bool (self, CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY);
#line 684 "Config.vala"
	return result;
#line 2607 "Config.c"
}


#line 687 "Config.vala"
void config_set_auto_import_from_library (Config* self, gboolean auto_import) {
#line 687 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 688 "Config.vala"
	config_set_bool (self, CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY, auto_import);
#line 2617 "Config.c"
}


#line 691 "Config.vala"
gboolean config_get_commit_metadata_to_masters (Config* self) {
#line 2623 "Config.c"
	gboolean result = FALSE;
#line 691 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2627 "Config.c"
	result = config_get_registered_bool (self, CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS);
#line 692 "Config.vala"
	return result;
#line 2631 "Config.c"
}


#line 695 "Config.vala"
void config_set_commit_metadata_to_masters (Config* self, gboolean commit_metadata) {
#line 695 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 696 "Config.vala"
	config_set_bool (self, CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS, commit_metadata);
#line 2641 "Config.c"
}


static void value_config_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_config_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		config_unref (value->data[0].v_pointer);
	}
}


static void value_config_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = config_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_config_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_config_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Config* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = config_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_config_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Config** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = config_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecConfig* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIG), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_config (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG), NULL);
	return value->data[0].v_pointer;
}


void value_set_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		config_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


void value_take_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


static void config_class_init (ConfigClass * klass) {
	config_parent_class = g_type_class_peek_parent (klass);
	CONFIG_CLASS (klass)->finalize = config_finalize;
	g_type_class_add_private (klass, sizeof (ConfigPrivate));
	g_signal_new ("colors_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("external_app_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("bool_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	g_signal_new ("string_changed", TYPE_CONFIG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}


static void config_instance_init (Config * self) {
	self->priv = CONFIG_GET_PRIVATE (self);
	self->priv->bg_color = NULL;
	self->priv->selected_color = NULL;
	self->priv->unselected_color = NULL;
	self->priv->unfocused_selected_color = NULL;
	self->priv->border_color = NULL;
	self->priv->bool_defaults = GEE_MAP (gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL));
	self->ref_count = 1;
}


static void config_finalize (Config* obj) {
	Config * self;
	self = CONFIG (obj);
	_g_free0 (self->priv->bg_color);
	_g_free0 (self->priv->selected_color);
	_g_free0 (self->priv->unselected_color);
	_g_free0 (self->priv->unfocused_selected_color);
	_g_free0 (self->priv->border_color);
	_g_object_unref0 (self->priv->client);
	_g_object_unref0 (self->priv->bool_defaults);
}


GType config_get_type (void) {
	static volatile gsize config_type_id__volatile = 0;
	if (g_once_init_enter (&config_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_config_init, value_config_free_value, value_config_copy_value, value_config_peek_pointer, "p", value_config_collect_value, "p", value_config_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Config), 0, (GInstanceInitFunc) config_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType config_type_id;
		config_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Config", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&config_type_id__volatile, config_type_id);
	}
	return config_type_id__volatile;
}


gpointer config_ref (gpointer instance) {
	Config* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void config_unref (gpointer instance) {
	Config* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CONFIG_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOOLEAN) (gpointer data1, const char* arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}



