/* Debug.c generated by valac 0.10.3, the Vala compiler
 * generated from Debug.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gio/gio.h>
#include <time.h>
#include <unistd.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))


extern GLogLevelFlags debug_log_mask;
GLogLevelFlags debug_log_mask = 0;
extern char* debug_log_app_version_prefix;
char* debug_log_app_version_prefix = NULL;
extern FILE* debug_log_out;
FILE* debug_log_out = NULL;
extern FILE* debug_log_err;
FILE* debug_log_err = NULL;
extern FILE* debug_log_file_stream;
FILE* debug_log_file_stream = NULL;

#define DEBUG_DEFAULT_LOG_MASK ((G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING) | G_LOG_LEVEL_MESSAGE)
#define DEBUG_VIEWER_PREFIX "V"
#define DEBUG_LIBRARY_PREFIX "L"
void debug_init (const char* app_version_prefix);
GFile* app_dirs_get_log_file (void);
void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_terminate (void);
gboolean debug_is_enabled (GLogLevelFlags flag);
void debug_log (FILE* stream, const char* prefix, const char* message);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 118 "Debug.vala"
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 66 "Debug.c"
	debug_info_handler (log_domain, log_levels, message);
}


#line 123 "Debug.vala"
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 73 "Debug.c"
	debug_debug_handler (log_domain, log_levels, message);
}


#line 128 "Debug.vala"
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 80 "Debug.c"
	debug_message_handler (log_domain, log_levels, message);
}


#line 133 "Debug.vala"
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 87 "Debug.c"
	debug_warning_handler (log_domain, log_levels, message);
}


#line 138 "Debug.vala"
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 94 "Debug.c"
	debug_critical_handler (log_domain, log_levels, message);
}


#line 27 "Debug.vala"
void debug_init (const char* app_version_prefix) {
#line 101 "Debug.c"
	char* _tmp0_;
	char* log_file_error_msg;
	GFile* _tmp1_;
	GFile* log_file;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 27 "Debug.vala"
	g_return_if_fail (app_version_prefix != NULL);
#line 28 "Debug.vala"
	debug_log_app_version_prefix = (_tmp0_ = g_strdup (app_version_prefix), _g_free0 (debug_log_app_version_prefix), _tmp0_);
#line 31 "Debug.vala"
	debug_log_out = stdout;
#line 32 "Debug.vala"
	debug_log_err = stderr;
#line 34 "Debug.vala"
	log_file_error_msg = NULL;
#line 118 "Debug.c"
	_tmp1_ = NULL;
#line 37 "Debug.vala"
	if (_vala_strcmp0 (debug_log_app_version_prefix, DEBUG_LIBRARY_PREFIX) == 0) {
#line 122 "Debug.c"
		GFile* _tmp2_;
#line 37 "Debug.vala"
		_tmp1_ = (_tmp2_ = app_dirs_get_log_file (), _g_object_unref0 (_tmp1_), _tmp2_);
#line 126 "Debug.c"
	} else {
		GFile* _tmp3_;
#line 37 "Debug.vala"
		_tmp1_ = (_tmp3_ = NULL, _g_object_unref0 (_tmp1_), _tmp3_);
#line 131 "Debug.c"
	}
#line 37 "Debug.vala"
	log_file = _g_object_ref0 (_tmp1_);
#line 38 "Debug.vala"
	if (log_file != NULL) {
#line 137 "Debug.c"
		GFile* log_dir;
		char* _tmp8_;
		FILE* _tmp9_;
#line 39 "Debug.vala"
		log_dir = g_file_get_parent (log_file);
#line 143 "Debug.c"
		{
#line 41 "Debug.vala"
			if (g_file_query_exists (log_dir, NULL) == FALSE) {
#line 147 "Debug.c"
				gboolean _tmp4_;
#line 42 "Debug.vala"
				_tmp4_ = g_file_make_directory_with_parents (log_dir, NULL, &_inner_error_);
#line 151 "Debug.c"
				if (_inner_error_ != NULL) {
					goto __catch187_g_error;
				}
#line 42 "Debug.vala"
				if (!_tmp4_) {
#line 157 "Debug.c"
					char* _tmp5_;
					char* _tmp6_;
#line 43 "Debug.vala"
					log_file_error_msg = (_tmp6_ = g_strdup_printf ("Unable to create data directory %s", _tmp5_ = g_file_get_path (log_dir)), _g_free0 (log_file_error_msg), _tmp6_);
#line 162 "Debug.c"
					_g_free0 (_tmp5_);
				}
			}
		}
		goto __finally187;
		__catch187_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp7_;
#line 47 "Debug.vala"
				log_file_error_msg = (_tmp7_ = g_strdup (err->message), _g_free0 (log_file_error_msg), _tmp7_);
#line 177 "Debug.c"
				_g_error_free0 (err);
			}
		}
		__finally187:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (log_dir);
			_g_object_unref0 (log_file);
			_g_object_unref0 (_tmp1_);
			_g_free0 (log_file_error_msg);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
#line 53 "Debug.vala"
		debug_log_file_stream = (_tmp9_ = fopen (_tmp8_ = g_file_get_path (log_file), "w"), _fclose0 (debug_log_file_stream), _tmp9_);
#line 193 "Debug.c"
		_g_free0 (_tmp8_);
#line 54 "Debug.vala"
		if (debug_log_file_stream != NULL) {
#line 55 "Debug.vala"
			debug_log_out = debug_log_file_stream;
#line 56 "Debug.vala"
			debug_log_err = debug_log_file_stream;
#line 201 "Debug.c"
		} else {
			char* _tmp10_;
			char* _tmp11_;
#line 58 "Debug.vala"
			log_file_error_msg = (_tmp11_ = g_strdup_printf ("Unable to open or create log file %s", _tmp10_ = g_file_get_path (log_file)), _g_free0 (log_file_error_msg), _tmp11_);
#line 207 "Debug.c"
			_g_free0 (_tmp10_);
		}
		_g_object_unref0 (log_dir);
	}
#line 62 "Debug.vala"
	if (g_getenv ("SHOTWELL_LOG") != NULL) {
#line 63 "Debug.vala"
		debug_log_mask = G_LOG_LEVEL_MASK;
#line 216 "Debug.c"
	} else {
		GLogLevelFlags _tmp12_ = 0;
		GLogLevelFlags _tmp13_ = 0;
		GLogLevelFlags _tmp14_ = 0;
		GLogLevelFlags _tmp15_ = 0;
		GLogLevelFlags _tmp16_ = 0;
#line 65 "Debug.vala"
		if (g_getenv ("SHOTWELL_INFO") != NULL) {
#line 66 "Debug.vala"
			_tmp12_ = debug_log_mask | G_LOG_LEVEL_INFO;
#line 227 "Debug.c"
		} else {
#line 67 "Debug.vala"
			_tmp12_ = debug_log_mask;
#line 231 "Debug.c"
		}
#line 65 "Debug.vala"
		debug_log_mask = _tmp12_;
#line 68 "Debug.vala"
		if (g_getenv ("SHOTWELL_DEBUG") != NULL) {
#line 69 "Debug.vala"
			_tmp13_ = debug_log_mask | G_LOG_LEVEL_DEBUG;
#line 239 "Debug.c"
		} else {
#line 70 "Debug.vala"
			_tmp13_ = debug_log_mask;
#line 243 "Debug.c"
		}
#line 68 "Debug.vala"
		debug_log_mask = _tmp13_;
#line 71 "Debug.vala"
		if (g_getenv ("SHOTWELL_MESSAGE") != NULL) {
#line 72 "Debug.vala"
			_tmp14_ = debug_log_mask | G_LOG_LEVEL_MESSAGE;
#line 251 "Debug.c"
		} else {
#line 73 "Debug.vala"
			_tmp14_ = debug_log_mask;
#line 255 "Debug.c"
		}
#line 71 "Debug.vala"
		debug_log_mask = _tmp14_;
#line 74 "Debug.vala"
		if (g_getenv ("SHOTWELL_WARNING") != NULL) {
#line 75 "Debug.vala"
			_tmp15_ = debug_log_mask | G_LOG_LEVEL_WARNING;
#line 263 "Debug.c"
		} else {
#line 76 "Debug.vala"
			_tmp15_ = debug_log_mask;
#line 267 "Debug.c"
		}
#line 74 "Debug.vala"
		debug_log_mask = _tmp15_;
#line 77 "Debug.vala"
		if (g_getenv ("SHOTWELL_CRITICAL") != NULL) {
#line 78 "Debug.vala"
			_tmp16_ = debug_log_mask | G_LOG_LEVEL_CRITICAL;
#line 275 "Debug.c"
		} else {
#line 79 "Debug.vala"
			_tmp16_ = debug_log_mask;
#line 279 "Debug.c"
		}
#line 77 "Debug.vala"
		debug_log_mask = _tmp16_;
#line 283 "Debug.c"
	}
#line 82 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_INFO, _debug_info_handler_glog_func, NULL);
#line 83 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_DEBUG, _debug_debug_handler_glog_func, NULL);
#line 84 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_MESSAGE, _debug_message_handler_glog_func, NULL);
#line 85 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_WARNING, _debug_warning_handler_glog_func, NULL);
#line 86 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_CRITICAL, _debug_critical_handler_glog_func, NULL);
#line 88 "Debug.vala"
	if (debug_log_mask == 0) {
#line 88 "Debug.vala"
		_tmp17_ = log_file != NULL;
#line 299 "Debug.c"
	} else {
#line 88 "Debug.vala"
		_tmp17_ = FALSE;
#line 303 "Debug.c"
	}
#line 88 "Debug.vala"
	if (_tmp17_) {
#line 91 "Debug.vala"
		debug_log_mask = DEBUG_DEFAULT_LOG_MASK;
#line 309 "Debug.c"
	}
#line 94 "Debug.vala"
	if (log_file_error_msg != NULL) {
#line 95 "Debug.vala"
		g_warning ("Debug.vala:95: %s", log_file_error_msg);
#line 315 "Debug.c"
	}
	_g_object_unref0 (log_file);
	_g_object_unref0 (_tmp1_);
	_g_free0 (log_file_error_msg);
}


#line 99 "Debug.vala"
void debug_terminate (void) {
#line 325 "Debug.c"
}


#line 102 "Debug.vala"
gboolean debug_is_enabled (GLogLevelFlags flag) {
#line 331 "Debug.c"
	gboolean result = FALSE;
	result = (debug_log_mask & flag) > 0;
#line 103 "Debug.vala"
	return result;
#line 336 "Debug.c"
}


#line 2221 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 342 "Debug.c"
	struct tm _result_ = {0};
#line 2223 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 346 "Debug.c"
	*result = _result_;
#line 2224 "glib-2.0.vapi"
	return;
#line 350 "Debug.c"
}


#line 2227 "glib-2.0.vapi"
static char* g_time_to_string (struct tm *self) {
#line 356 "Debug.c"
	char* result = NULL;
	result = g_strdup_printf ("%04d-%02d-%02d %02d:%02d:%02d", (*self).tm_year + 1900, (*self).tm_mon + 1, (*self).tm_mday, (*self).tm_hour, (*self).tm_min, (*self).tm_sec);
#line 2228 "glib-2.0.vapi"
	return result;
#line 361 "Debug.c"
}


#line 106 "Debug.vala"
void debug_log (FILE* stream, const char* prefix, const char* message) {
#line 367 "Debug.c"
	time_t now;
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	char* _tmp2_;
#line 106 "Debug.vala"
	g_return_if_fail (stream != NULL);
#line 106 "Debug.vala"
	g_return_if_fail (prefix != NULL);
#line 106 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 107 "Debug.vala"
	now = time (NULL);
#line 108 "Debug.vala"
	fprintf (stream, "%s %d %s [%s] %s\n", debug_log_app_version_prefix, (gint) getpid (), _tmp2_ = g_time_to_string ((_tmp1_ = (g_time_local (now, &_tmp0_), _tmp0_), &_tmp1_)), prefix, message);
#line 382 "Debug.c"
	_g_free0 (_tmp2_);
#line 115 "Debug.vala"
	fflush (stream);
#line 386 "Debug.c"
}


#line 118 "Debug.vala"
void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 118 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 119 "Debug.vala"
	if (debug_is_enabled (G_LOG_LEVEL_INFO)) {
#line 120 "Debug.vala"
		debug_log (debug_log_out, "INF", message);
#line 398 "Debug.c"
	}
}


#line 123 "Debug.vala"
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 123 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 124 "Debug.vala"
	if (debug_is_enabled (G_LOG_LEVEL_DEBUG)) {
#line 125 "Debug.vala"
		debug_log (debug_log_out, "DBG", message);
#line 411 "Debug.c"
	}
}


#line 128 "Debug.vala"
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 128 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 129 "Debug.vala"
	if (debug_is_enabled (G_LOG_LEVEL_MESSAGE)) {
#line 130 "Debug.vala"
		debug_log (debug_log_err, "MSG", message);
#line 424 "Debug.c"
	}
}


#line 133 "Debug.vala"
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 133 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 134 "Debug.vala"
	if (debug_is_enabled (G_LOG_LEVEL_WARNING)) {
#line 135 "Debug.vala"
		debug_log (debug_log_err, "WRN", message);
#line 437 "Debug.c"
	}
}


#line 138 "Debug.vala"
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 138 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 139 "Debug.vala"
	if (debug_is_enabled (G_LOG_LEVEL_CRITICAL)) {
#line 140 "Debug.vala"
		debug_log (debug_log_err, "CRT", message);
#line 450 "Debug.c"
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




