/* Dimensions.c generated by valac 0.10.3, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	double zoom_factor;
	double interpolation_factor;
	double min_factor;
	double max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
char* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
char* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
double dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
void scaling_to_fill_screen (GtkWindow* window, Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
char* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, double slider_val, GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, double new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing);
void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
double zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result);
double zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result);
char* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self, ZoomState* other);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 14 "Dimensions.vala"
char* scale_constraint_to_string (ScaleConstraint self) {
#line 152 "Dimensions.c"
	char* result = NULL;
#line 15 "Dimensions.vala"
	switch (self) {
#line 156 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			result = g_strdup (_ ("Original size"));
#line 17 "Dimensions.vala"
			return result;
#line 162 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			result = g_strdup (_ ("Width or height"));
#line 20 "Dimensions.vala"
			return result;
#line 169 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			result = g_strdup (_ ("Width"));
#line 23 "Dimensions.vala"
			return result;
#line 176 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			result = g_strdup (_ ("Height"));
#line 26 "Dimensions.vala"
			return result;
#line 183 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = g_strdup ("Fill Viewport");
#line 30 "Dimensions.vala"
			return result;
#line 190 "Dimensions.c"
		}
	}
#line 33 "Dimensions.vala"
	g_warn_if_reached ();
#line 195 "Dimensions.c"
	result = NULL;
#line 35 "Dimensions.vala"
	return result;
#line 199 "Dimensions.c"
}


GType scale_constraint_get_type (void) {
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


#line 43 "Dimensions.vala"
void dimensions_init (Dimensions *self, gint width, gint height) {
#line 217 "Dimensions.c"
	memset (self, 0, sizeof (Dimensions));
#line 44 "Dimensions.vala"
	g_assert ((width >= 0) && (height >= 0));
#line 46 "Dimensions.vala"
	(*self).width = width;
#line 47 "Dimensions.vala"
	(*self).height = height;
#line 225 "Dimensions.c"
}


#line 50 "Dimensions.vala"
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
#line 231 "Dimensions.c"
	Dimensions _tmp0_ = {0};
#line 50 "Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 235 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf)), _tmp0_);
#line 51 "Dimensions.vala"
	return;
#line 239 "Dimensions.c"
}


#line 54 "Dimensions.vala"
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
#line 245 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*allocation).width, (*allocation).height), _tmp0_);
#line 55 "Dimensions.vala"
	return;
#line 250 "Dimensions.c"
}


#line 58 "Dimensions.vala"
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
#line 256 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*rect).width, (*rect).height), _tmp0_);
#line 59 "Dimensions.vala"
	return;
#line 261 "Dimensions.c"
}


#line 62 "Dimensions.vala"
gboolean dimensions_has_area (Dimensions *self) {
#line 267 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 63 "Dimensions.vala"
	if ((*self).width > 0) {
#line 63 "Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 274 "Dimensions.c"
	} else {
#line 63 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 278 "Dimensions.c"
	}
	result = _tmp0_;
#line 63 "Dimensions.vala"
	return result;
#line 283 "Dimensions.c"
}


#line 66 "Dimensions.vala"
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
#line 289 "Dimensions.c"
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
#line 67 "Dimensions.vala"
	if ((*self).width > (*min).width) {
#line 67 "Dimensions.vala"
		_tmp0_ = (*self).width;
#line 297 "Dimensions.c"
	} else {
#line 67 "Dimensions.vala"
		_tmp0_ = (*min).width;
#line 301 "Dimensions.c"
	}
#line 68 "Dimensions.vala"
	if ((*self).height > (*min).height) {
#line 68 "Dimensions.vala"
		_tmp1_ = (*self).height;
#line 307 "Dimensions.c"
	} else {
#line 68 "Dimensions.vala"
		_tmp1_ = (*min).height;
#line 311 "Dimensions.c"
	}
	*result = (dimensions_init (&_tmp2_, _tmp0_, _tmp1_), _tmp2_);
#line 67 "Dimensions.vala"
	return;
#line 316 "Dimensions.c"
}


#line 71 "Dimensions.vala"
char* dimensions_to_string (Dimensions *self) {
#line 322 "Dimensions.c"
	char* result = NULL;
	result = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 72 "Dimensions.vala"
	return result;
#line 327 "Dimensions.c"
}


#line 75 "Dimensions.vala"
gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
#line 333 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 76 "Dimensions.vala"
	if ((*self).width == (*dim).width) {
#line 76 "Dimensions.vala"
		_tmp0_ = (*self).height == (*dim).height;
#line 340 "Dimensions.c"
	} else {
#line 76 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 344 "Dimensions.c"
	}
	result = _tmp0_;
#line 76 "Dimensions.vala"
	return result;
#line 349 "Dimensions.c"
}


#line 80 "Dimensions.vala"
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
#line 355 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 81 "Dimensions.vala"
	if (abs ((*self).width - (*dim).width) <= fudge) {
#line 81 "Dimensions.vala"
		_tmp0_ = abs ((*self).height - (*dim).height) <= fudge;
#line 362 "Dimensions.c"
	} else {
#line 81 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 366 "Dimensions.c"
	}
	result = _tmp0_;
#line 81 "Dimensions.vala"
	return result;
#line 371 "Dimensions.c"
}


#line 84 "Dimensions.vala"
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge) {
#line 377 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 85 "Dimensions.vala"
	if ((*self).width <= (scale + fudge)) {
#line 85 "Dimensions.vala"
		_tmp0_ = (*self).height <= (scale + fudge);
#line 384 "Dimensions.c"
	} else {
#line 85 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 388 "Dimensions.c"
	}
	result = _tmp0_;
#line 85 "Dimensions.vala"
	return result;
#line 393 "Dimensions.c"
}


#line 88 "Dimensions.vala"
gint dimensions_major_axis (Dimensions *self) {
#line 399 "Dimensions.c"
	gint result = 0;
	result = MAX ((*self).width, (*self).height);
#line 89 "Dimensions.vala"
	return result;
#line 404 "Dimensions.c"
}


#line 92 "Dimensions.vala"
gint dimensions_minor_axis (Dimensions *self) {
#line 410 "Dimensions.c"
	gint result = 0;
	result = MIN ((*self).width, (*self).height);
#line 93 "Dimensions.vala"
	return result;
#line 415 "Dimensions.c"
}


#line 96 "Dimensions.vala"
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result) {
#line 421 "Dimensions.c"
	Dimensions min = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	dimensions_init (&min, 0, 0);
#line 98 "Dimensions.vala"
	if ((*self).width > min_width) {
#line 98 "Dimensions.vala"
		_tmp0_ = (*self).width;
#line 430 "Dimensions.c"
	} else {
#line 98 "Dimensions.vala"
		_tmp0_ = min_width;
#line 434 "Dimensions.c"
	}
#line 98 "Dimensions.vala"
	min.width = _tmp0_;
#line 99 "Dimensions.vala"
	if ((*self).height > min_height) {
#line 99 "Dimensions.vala"
		_tmp1_ = (*self).height;
#line 442 "Dimensions.c"
	} else {
#line 99 "Dimensions.vala"
		_tmp1_ = min_height;
#line 446 "Dimensions.c"
	}
#line 99 "Dimensions.vala"
	min.height = _tmp1_;
#line 450 "Dimensions.c"
	*result = min;
#line 101 "Dimensions.vala"
	return;
#line 454 "Dimensions.c"
}


#line 104 "Dimensions.vala"
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
#line 460 "Dimensions.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 105 "Dimensions.vala"
	g_assert (scale > 0);
#line 108 "Dimensions.vala"
	if ((*self).width == scale) {
#line 108 "Dimensions.vala"
		_tmp1_ = (*self).height < scale;
#line 470 "Dimensions.c"
	} else {
#line 108 "Dimensions.vala"
		_tmp1_ = FALSE;
#line 474 "Dimensions.c"
	}
#line 108 "Dimensions.vala"
	if (_tmp1_) {
#line 108 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 480 "Dimensions.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 108 "Dimensions.vala"
		if ((*self).height == scale) {
#line 108 "Dimensions.vala"
			_tmp2_ = (*self).width < scale;
#line 487 "Dimensions.c"
		} else {
#line 108 "Dimensions.vala"
			_tmp2_ = FALSE;
#line 491 "Dimensions.c"
		}
#line 108 "Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 495 "Dimensions.c"
	}
#line 108 "Dimensions.vala"
	if (_tmp0_) {
#line 499 "Dimensions.c"
		Dimensions _tmp3_ = {0};
		*result = (dimensions_init (&_tmp3_, (*self).width, (*self).height), _tmp3_);
#line 109 "Dimensions.vala"
		return;
#line 504 "Dimensions.c"
	}
#line 112 "Dimensions.vala"
	if (!scale_up) {
#line 508 "Dimensions.c"
		gboolean _tmp5_ = FALSE;
#line 112 "Dimensions.vala"
		if ((*self).width < scale) {
#line 112 "Dimensions.vala"
			_tmp5_ = (*self).height < scale;
#line 514 "Dimensions.c"
		} else {
#line 112 "Dimensions.vala"
			_tmp5_ = FALSE;
#line 518 "Dimensions.c"
		}
#line 112 "Dimensions.vala"
		_tmp4_ = _tmp5_;
#line 522 "Dimensions.c"
	} else {
#line 112 "Dimensions.vala"
		_tmp4_ = FALSE;
#line 526 "Dimensions.c"
	}
#line 112 "Dimensions.vala"
	if (_tmp4_) {
#line 530 "Dimensions.c"
		Dimensions _tmp6_ = {0};
		*result = (dimensions_init (&_tmp6_, (*self).width, (*self).height), _tmp6_);
#line 113 "Dimensions.vala"
		return;
#line 535 "Dimensions.c"
	}
#line 115 "Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 539 "Dimensions.c"
		Dimensions _tmp7_ = {0};
		*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp7_), _tmp7_);
#line 116 "Dimensions.vala"
		return;
#line 544 "Dimensions.c"
	} else {
		Dimensions _tmp8_ = {0};
		*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp8_), _tmp8_);
#line 118 "Dimensions.vala"
		return;
#line 550 "Dimensions.c"
	}
}


#line 121 "Dimensions.vala"
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio) {
#line 122 "Dimensions.vala"
	*width_ratio = ((double) (*scaled).width) / ((double) (*self).width);
#line 123 "Dimensions.vala"
	*height_ratio = ((double) (*scaled).height) / ((double) (*self).height);
#line 561 "Dimensions.c"
}


#line 126 "Dimensions.vala"
double dimensions_get_aspect_ratio (Dimensions *self) {
#line 567 "Dimensions.c"
	double result = 0.0;
	result = ((double) (*self).width) / (*self).height;
#line 127 "Dimensions.vala"
	return result;
#line 572 "Dimensions.c"
}


#line 130 "Dimensions.vala"
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 578 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions scaled;
#line 132 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 135 "Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 136 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 137 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 597 "Dimensions.c"
	} else {
#line 139 "Dimensions.vala"
		scaled_width = ((double) (*self).width) * height_ratio;
#line 140 "Dimensions.vala"
		scaled_height = (double) (*viewport).height;
#line 603 "Dimensions.c"
	}
#line 143 "Dimensions.vala"
	scaled = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 145 "Dimensions.vala"
	g_assert (scaled.height <= (*viewport).height);
#line 146 "Dimensions.vala"
	g_assert (scaled.width <= (*viewport).width);
#line 611 "Dimensions.c"
	*result = scaled;
#line 148 "Dimensions.vala"
	return;
#line 615 "Dimensions.c"
}


#line 151 "Dimensions.vala"
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 621 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_;
	Dimensions _tmp5_;
	Dimensions _tmp6_ = {0};
#line 153 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 156 "Dimensions.vala"
	if ((*self).width < (*viewport).width) {
#line 156 "Dimensions.vala"
		_tmp0_ = (*self).height >= (*viewport).height;
#line 638 "Dimensions.c"
	} else {
#line 156 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 642 "Dimensions.c"
	}
#line 156 "Dimensions.vala"
	if (_tmp0_) {
#line 158 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 159 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 650 "Dimensions.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 160 "Dimensions.vala"
		if ((*self).width >= (*viewport).width) {
#line 160 "Dimensions.vala"
			_tmp1_ = (*self).height < (*viewport).height;
#line 657 "Dimensions.c"
		} else {
#line 160 "Dimensions.vala"
			_tmp1_ = FALSE;
#line 661 "Dimensions.c"
		}
#line 160 "Dimensions.vala"
		if (_tmp1_) {
#line 162 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * height_ratio;
#line 163 "Dimensions.vala"
			scaled_height = (double) (*viewport).height;
#line 669 "Dimensions.c"
		} else {
			double ratio;
#line 166 "Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 168 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * ratio;
#line 169 "Dimensions.vala"
			scaled_height = ((double) (*self).height) * ratio;
#line 678 "Dimensions.c"
		}
	}
	*result = (dimensions_floor ((_tmp4_ = (dimensions_init (&_tmp2_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp2_), &_tmp4_), (_tmp5_ = (dimensions_init (&_tmp3_, 1, 1), _tmp3_), &_tmp5_), &_tmp6_), _tmp6_);
#line 172 "Dimensions.vala"
	return;
#line 684 "Dimensions.c"
}


#line 175 "Dimensions.vala"
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
#line 690 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	GdkRectangle scaled_rect = {0};
#line 177 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), scaled, &x_scale, &y_scale);
#line 696 "Dimensions.c"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 180 "Dimensions.vala"
	scaled_rect.x = (gint) round (((double) (*rect).x) * x_scale);
#line 181 "Dimensions.vala"
	scaled_rect.y = (gint) round (((double) (*rect).y) * y_scale);
#line 182 "Dimensions.vala"
	scaled_rect.width = (gint) round (((double) (*rect).width) * x_scale);
#line 183 "Dimensions.vala"
	scaled_rect.height = (gint) round (((double) (*rect).height) * y_scale);
#line 185 "Dimensions.vala"
	if (scaled_rect.width <= 0) {
#line 186 "Dimensions.vala"
		scaled_rect.width = 1;
#line 710 "Dimensions.c"
	}
#line 188 "Dimensions.vala"
	if (scaled_rect.height <= 0) {
#line 189 "Dimensions.vala"
		scaled_rect.height = 1;
#line 716 "Dimensions.c"
	}
	*result = scaled_rect;
#line 191 "Dimensions.vala"
	return;
#line 721 "Dimensions.c"
}


#line 195 "Dimensions.vala"
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
#line 727 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	double scale;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_ = {0};
#line 197 "Dimensions.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 199 "Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 740 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * scale), (gint) round (((double) (*self).height) * scale)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 201 "Dimensions.vala"
	return;
#line 744 "Dimensions.c"
}


#line 205 "Dimensions.vala"
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
#line 750 "Dimensions.c"
	double ratio;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_ = {0};
#line 206 "Dimensions.vala"
	g_assert (scale > 0);
#line 208 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).width);
#line 761 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, scale, (gint) round (((double) (*self).height) * ratio)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 210 "Dimensions.vala"
	return;
#line 765 "Dimensions.c"
}


#line 213 "Dimensions.vala"
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
#line 771 "Dimensions.c"
	double ratio;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_ = {0};
#line 214 "Dimensions.vala"
	g_assert (scale > 0);
#line 216 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).height);
#line 782 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * ratio), scale), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 218 "Dimensions.vala"
	return;
#line 786 "Dimensions.c"
}


#line 221 "Dimensions.vala"
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
#line 222 "Dimensions.vala"
	switch (constraint) {
#line 794 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*self).width, (*self).height), _tmp0_);
#line 224 "Dimensions.vala"
			return;
#line 801 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			Dimensions _tmp1_ = {0};
#line 227 "Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 808 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 227 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_), _tmp2_);
#line 812 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 227 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_), _tmp3_);
#line 817 "Dimensions.c"
			}
			*result = _tmp1_;
#line 227 "Dimensions.vala"
			return;
#line 822 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			Dimensions _tmp4_ = {0};
			*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_), _tmp4_);
#line 230 "Dimensions.vala"
			return;
#line 830 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			Dimensions _tmp5_ = {0};
			*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_), _tmp5_);
#line 233 "Dimensions.vala"
			return;
#line 838 "Dimensions.c"
		}
		default:
		{
#line 236 "Dimensions.vala"
			g_error ("Dimensions.vala:236: Bad constraint: %d", (gint) constraint);
#line 844 "Dimensions.c"
		}
	}
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
	dup = g_new0 (Dimensions, 1);
	memcpy (dup, self, sizeof (Dimensions));
	return dup;
}


void dimensions_free (Dimensions* self) {
	g_free (self);
}


GType dimensions_get_type (void) {
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


#line 249 "Dimensions.vala"
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
#line 876 "Dimensions.c"
	memset (self, 0, sizeof (Scaling));
#line 250 "Dimensions.vala"
	(*self).constraint = constraint;
#line 251 "Dimensions.vala"
	(*self).scale = scale;
#line 252 "Dimensions.vala"
	(*self).viewport = *viewport;
#line 253 "Dimensions.vala"
	(*self).scale_up = scale_up;
#line 886 "Dimensions.c"
}


#line 256 "Dimensions.vala"
void scaling_for_original (Scaling* result) {
#line 892 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	Dimensions _tmp2_;
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), FALSE), _tmp1_);
#line 257 "Dimensions.vala"
	return;
#line 899 "Dimensions.c"
}


#line 260 "Dimensions.vala"
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
#line 905 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	Scaling _tmp2_ = {0};
#line 260 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 911 "Dimensions.c"
	*result = (scaling_for_viewport ((_tmp1_ = (scaling_get_screen_dimensions (window, &_tmp0_), _tmp0_), &_tmp1_), scale_up, &_tmp2_), _tmp2_);
#line 261 "Dimensions.vala"
	return;
#line 915 "Dimensions.c"
}


#line 264 "Dimensions.vala"
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
#line 921 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	Dimensions _tmp2_;
#line 265 "Dimensions.vala"
	g_assert (pixels > 0);
#line 927 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), scale_up), _tmp1_);
#line 267 "Dimensions.vala"
	return;
#line 931 "Dimensions.c"
}


#line 270 "Dimensions.vala"
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
#line 937 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 271 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 941 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, viewport, scale_up), _tmp0_);
#line 273 "Dimensions.vala"
	return;
#line 945 "Dimensions.c"
}


#line 276 "Dimensions.vala"
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
#line 951 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Dimensions viewport;
	Scaling _tmp1_ = {0};
#line 276 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 277 "Dimensions.vala"
	viewport = (dimensions_for_allocation (&widget->allocation, &_tmp0_), _tmp0_);
#line 278 "Dimensions.vala"
	g_assert (dimensions_has_area (&viewport));
#line 961 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &viewport, scale_up), _tmp1_);
#line 280 "Dimensions.vala"
	return;
#line 965 "Dimensions.c"
}


#line 283 "Dimensions.vala"
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
#line 971 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 284 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 975 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, viewport, TRUE), _tmp0_);
#line 286 "Dimensions.vala"
	return;
#line 979 "Dimensions.c"
}


#line 289 "Dimensions.vala"
void scaling_to_fill_screen (GtkWindow* window, Scaling* result) {
#line 985 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	Scaling _tmp2_ = {0};
#line 289 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 991 "Dimensions.c"
	*result = (scaling_to_fill_viewport ((_tmp1_ = (scaling_get_screen_dimensions (window, &_tmp0_), _tmp0_), &_tmp1_), &_tmp2_), _tmp2_);
#line 290 "Dimensions.vala"
	return;
#line 995 "Dimensions.c"
}


#line 293 "Dimensions.vala"
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result) {
#line 1001 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	Dimensions _tmp2_;
	*result = (scaling_init (&_tmp1_, constraint, scale, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), scale_up), _tmp1_);
#line 294 "Dimensions.vala"
	return;
#line 1008 "Dimensions.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 297 "Dimensions.vala"
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
#line 1019 "Dimensions.c"
	GdkScreen* screen;
	Dimensions _tmp0_ = {0};
#line 297 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 298 "Dimensions.vala"
	screen = _g_object_ref0 (gtk_window_get_screen (window));
#line 1026 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_screen_get_width (screen), gdk_screen_get_height (screen)), _tmp0_);
	_g_object_unref0 (screen);
#line 300 "Dimensions.vala"
	return;
#line 1031 "Dimensions.c"
	_g_object_unref0 (screen);
}


#line 303 "Dimensions.vala"
static gint scaling_scale_to_pixels (Scaling *self) {
#line 1038 "Dimensions.c"
	gint result = 0;
	gint _tmp0_ = 0;
#line 304 "Dimensions.vala"
	if ((*self).scale >= 0) {
#line 304 "Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 1045 "Dimensions.c"
	} else {
#line 304 "Dimensions.vala"
		_tmp0_ = 0;
#line 1049 "Dimensions.c"
	}
	result = _tmp0_;
#line 304 "Dimensions.vala"
	return result;
#line 1054 "Dimensions.c"
}


#line 307 "Dimensions.vala"
gboolean scaling_is_unscaled (Scaling *self) {
#line 1060 "Dimensions.c"
	gboolean result = FALSE;
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
#line 308 "Dimensions.vala"
	return result;
#line 1065 "Dimensions.c"
}


#line 311 "Dimensions.vala"
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
#line 1071 "Dimensions.c"
	gboolean result = FALSE;
#line 312 "Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 1075 "Dimensions.c"
		result = FALSE;
#line 313 "Dimensions.vala"
		return result;
#line 1079 "Dimensions.c"
	}
#line 315 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1083 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 318 "Dimensions.vala"
			return result;
#line 1090 "Dimensions.c"
		}
		default:
		{
#line 321 "Dimensions.vala"
			*pixels = scaling_scale_to_pixels (&(*self));
#line 322 "Dimensions.vala"
			g_assert ((*pixels) > 0);
#line 1098 "Dimensions.c"
			result = TRUE;
#line 324 "Dimensions.vala"
			return result;
#line 1102 "Dimensions.c"
		}
	}
}


#line 328 "Dimensions.vala"
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1110 "Dimensions.c"
	gboolean result = FALSE;
#line 329 "Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 1114 "Dimensions.c"
		result = FALSE;
#line 330 "Dimensions.vala"
		return result;
#line 1118 "Dimensions.c"
	}
#line 332 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1122 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 335 "Dimensions.vala"
			return result;
#line 1129 "Dimensions.c"
		}
		default:
		{
			gint pixels;
			Dimensions _tmp0_ = {0};
#line 338 "Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 339 "Dimensions.vala"
			g_assert (pixels > 0);
#line 341 "Dimensions.vala"
			*scaled = (dimensions_get_scaled_by_constraint (original, pixels, (*self).constraint, &_tmp0_), _tmp0_);
#line 1141 "Dimensions.c"
			result = TRUE;
#line 343 "Dimensions.vala"
			return result;
#line 1145 "Dimensions.c"
		}
	}
}


#line 347 "Dimensions.vala"
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1153 "Dimensions.c"
	gboolean result = FALSE;
#line 348 "Dimensions.vala"
	if ((*self).scale != SCALING_NO_SCALE) {
#line 1157 "Dimensions.c"
		result = FALSE;
#line 349 "Dimensions.vala"
		return result;
#line 1161 "Dimensions.c"
	}
#line 351 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1165 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 354 "Dimensions.vala"
			return result;
#line 1172 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 357 "Dimensions.vala"
			g_assert (dimensions_has_area (&(*self).viewport));
#line 359 "Dimensions.vala"
			if (!(*self).scale_up) {
#line 359 "Dimensions.vala"
				_tmp1_ = (*original).width < (*self).viewport.width;
#line 1184 "Dimensions.c"
			} else {
#line 359 "Dimensions.vala"
				_tmp1_ = FALSE;
#line 1188 "Dimensions.c"
			}
#line 359 "Dimensions.vala"
			if (_tmp1_) {
#line 359 "Dimensions.vala"
				_tmp0_ = (*original).height < (*self).viewport.height;
#line 1194 "Dimensions.c"
			} else {
#line 359 "Dimensions.vala"
				_tmp0_ = FALSE;
#line 1198 "Dimensions.c"
			}
#line 359 "Dimensions.vala"
			if (_tmp0_) {
#line 360 "Dimensions.vala"
				*scaled = *original;
#line 1204 "Dimensions.c"
			} else {
				Dimensions _tmp2_ = {0};
#line 362 "Dimensions.vala"
				*scaled = (dimensions_get_scaled_proportional (original, &(*self).viewport, &_tmp2_), _tmp2_);
#line 1209 "Dimensions.c"
			}
			result = TRUE;
#line 364 "Dimensions.vala"
			return result;
#line 1214 "Dimensions.c"
		}
	}
}


#line 368 "Dimensions.vala"
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1222 "Dimensions.c"
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
#line 369 "Dimensions.vala"
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1227 "Dimensions.c"
		result = FALSE;
#line 370 "Dimensions.vala"
		return result;
#line 1231 "Dimensions.c"
	}
#line 372 "Dimensions.vala"
	g_assert (dimensions_has_area (&(*self).viewport));
#line 373 "Dimensions.vala"
	*scaled = (dimensions_get_scaled_to_fill_viewport (original, &(*self).viewport, &_tmp0_), _tmp0_);
#line 1237 "Dimensions.c"
	result = TRUE;
#line 375 "Dimensions.vala"
	return result;
#line 1241 "Dimensions.c"
}


#line 378 "Dimensions.vala"
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
#line 1247 "Dimensions.c"
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 379 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1252 "Dimensions.c"
		*result = *original;
#line 380 "Dimensions.vala"
		return;
#line 1256 "Dimensions.c"
	}
#line 383 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), original, &scaled)) {
#line 1260 "Dimensions.c"
		*result = scaled;
#line 384 "Dimensions.vala"
		return;
#line 1264 "Dimensions.c"
	}
#line 386 "Dimensions.vala"
	if (scaling_is_best_fit_dimensions (&(*self), original, &scaled)) {
#line 1268 "Dimensions.c"
		*result = scaled;
#line 387 "Dimensions.vala"
		return;
#line 1272 "Dimensions.c"
	}
#line 389 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), original, &scaled);
#line 390 "Dimensions.vala"
	g_assert (is_viewport);
#line 1278 "Dimensions.c"
	*result = scaled;
#line 392 "Dimensions.vala"
	return;
#line 1282 "Dimensions.c"
}


#line 395 "Dimensions.vala"
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
#line 1288 "Dimensions.c"
	GdkPixbuf* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions pixbuf_dim;
	gint pixels = 0;
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 395 "Dimensions.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 396 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1299 "Dimensions.c"
		result = _g_object_ref0 (pixbuf);
#line 397 "Dimensions.vala"
		return result;
#line 1303 "Dimensions.c"
	}
#line 399 "Dimensions.vala"
	pixbuf_dim = (dimensions_for_pixbuf (pixbuf, &_tmp0_), _tmp0_);
#line 402 "Dimensions.vala"
	if (scaling_is_best_fit (&(*self), &pixbuf_dim, &pixels)) {
#line 1309 "Dimensions.c"
		result = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 403 "Dimensions.vala"
		return result;
#line 1313 "Dimensions.c"
	}
#line 406 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), &pixbuf_dim, &scaled)) {
#line 1317 "Dimensions.c"
		result = resize_pixbuf (pixbuf, &scaled, interp);
#line 407 "Dimensions.vala"
		return result;
#line 1321 "Dimensions.c"
	}
#line 409 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), &pixbuf_dim, &scaled);
#line 410 "Dimensions.vala"
	g_assert (is_viewport);
#line 1327 "Dimensions.c"
	result = resize_pixbuf (pixbuf, &scaled, interp);
#line 412 "Dimensions.vala"
	return result;
#line 1331 "Dimensions.c"
}


#line 415 "Dimensions.vala"
char* scaling_to_string (Scaling *self) {
#line 1337 "Dimensions.c"
	char* result = NULL;
#line 416 "Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 1341 "Dimensions.c"
		result = g_strdup ("scaling: UNSCALED");
#line 417 "Dimensions.vala"
		return result;
#line 1345 "Dimensions.c"
	} else {
#line 418 "Dimensions.vala"
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1349 "Dimensions.c"
			char* _tmp0_;
			char* _tmp1_;
			result = (_tmp1_ = g_strdup_printf ("scaling: fill viewport %s", _tmp0_ = dimensions_to_string (&(*self).viewport)), _g_free0 (_tmp0_), _tmp1_);
#line 419 "Dimensions.vala"
			return result;
#line 1355 "Dimensions.c"
		} else {
#line 420 "Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 1359 "Dimensions.c"
				const char* _tmp2_;
				char* _tmp3_;
				char* _tmp4_;
				_tmp2_ = NULL;
#line 422 "Dimensions.vala"
				if ((*self).scale_up) {
#line 422 "Dimensions.vala"
					_tmp2_ = "scaled up";
#line 1368 "Dimensions.c"
				} else {
#line 422 "Dimensions.vala"
					_tmp2_ = "not scaled up";
#line 1372 "Dimensions.c"
				}
				result = (_tmp4_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp3_ = scale_constraint_to_string ((*self).constraint), scaling_scale_to_pixels (&(*self)), _tmp2_), _g_free0 (_tmp3_), _tmp4_);
#line 421 "Dimensions.vala"
				return result;
#line 1377 "Dimensions.c"
			} else {
				const char* _tmp5_;
				char* _tmp6_;
				char* _tmp7_;
				_tmp5_ = NULL;
#line 425 "Dimensions.vala"
				if ((*self).scale_up) {
#line 425 "Dimensions.vala"
					_tmp5_ = "scaled up";
#line 1387 "Dimensions.c"
				} else {
#line 425 "Dimensions.vala"
					_tmp5_ = "not scaled up";
#line 1391 "Dimensions.c"
				}
				result = (_tmp7_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp6_ = dimensions_to_string (&(*self).viewport), _tmp5_), _g_free0 (_tmp6_), _tmp7_);
#line 424 "Dimensions.vala"
				return result;
#line 1396 "Dimensions.c"
			}
		}
	}
}


#line 428 "Dimensions.vala"
gboolean scaling_equals (Scaling *self, Scaling* scaling) {
#line 1405 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 429 "Dimensions.vala"
	if ((*self).constraint == (*scaling).constraint) {
#line 429 "Dimensions.vala"
		_tmp1_ = (*self).scale == (*scaling).scale;
#line 1413 "Dimensions.c"
	} else {
#line 429 "Dimensions.vala"
		_tmp1_ = FALSE;
#line 1417 "Dimensions.c"
	}
#line 429 "Dimensions.vala"
	if (_tmp1_) {
#line 430 "Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &(*scaling).viewport);
#line 1423 "Dimensions.c"
	} else {
#line 429 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 1427 "Dimensions.c"
	}
	result = _tmp0_;
#line 429 "Dimensions.vala"
	return result;
#line 1432 "Dimensions.c"
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
	dup = g_new0 (Scaling, 1);
	memcpy (dup, self, sizeof (Scaling));
	return dup;
}


void scaling_free (Scaling* self) {
	g_free (self);
}


GType scaling_get_type (void) {
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


#line 443 "Dimensions.vala"
void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, double slider_val, GdkPoint* viewport_center) {
#line 1462 "Dimensions.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	memset (self, 0, sizeof (ZoomState));
#line 445 "Dimensions.vala"
	(*self).content_dimensions = *content_dimensions;
#line 446 "Dimensions.vala"
	(*self).viewport_dimensions = *viewport_dimensions;
#line 447 "Dimensions.vala"
	(*self).interpolation_factor = slider_val;
#line 449 "Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 451 "Dimensions.vala"
	if (viewport_center == NULL) {
#line 451 "Dimensions.vala"
		_tmp1_ = TRUE;
#line 1478 "Dimensions.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 451 "Dimensions.vala"
		if ((*viewport_center).x == 0) {
#line 451 "Dimensions.vala"
			_tmp2_ = (*viewport_center).y == 0;
#line 1485 "Dimensions.c"
		} else {
#line 451 "Dimensions.vala"
			_tmp2_ = FALSE;
#line 1489 "Dimensions.c"
		}
#line 451 "Dimensions.vala"
		_tmp1_ = _tmp2_;
#line 1493 "Dimensions.c"
	}
#line 451 "Dimensions.vala"
	if (_tmp1_) {
#line 451 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 1499 "Dimensions.c"
	} else {
#line 452 "Dimensions.vala"
		_tmp0_ = slider_val == 0.0;
#line 1503 "Dimensions.c"
	}
#line 451 "Dimensions.vala"
	if (_tmp0_) {
#line 453 "Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 1509 "Dimensions.c"
	} else {
#line 455 "Dimensions.vala"
		(*self).viewport_center = *viewport_center;
#line 456 "Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 1515 "Dimensions.c"
	}
}


#line 460 "Dimensions.vala"
void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, double new_slider_val) {
#line 1522 "Dimensions.c"
	memset (self, 0, sizeof (ZoomState));
#line 461 "Dimensions.vala"
	(*self).content_dimensions = (*existing).content_dimensions;
#line 462 "Dimensions.vala"
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
#line 463 "Dimensions.vala"
	(*self).interpolation_factor = new_slider_val;
#line 465 "Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 467 "Dimensions.vala"
	if (new_slider_val == 0.0) {
#line 468 "Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 1536 "Dimensions.c"
	} else {
#line 470 "Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * ((*existing).viewport_center.x / (*existing).zoom_factor));
#line 472 "Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * ((*existing).viewport_center.y / (*existing).zoom_factor));
#line 474 "Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 1544 "Dimensions.c"
	}
}


#line 478 "Dimensions.vala"
void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing) {
#line 1551 "Dimensions.c"
	memset (self, 0, sizeof (ZoomState));
#line 479 "Dimensions.vala"
	(*self).content_dimensions = (*existing).content_dimensions;
#line 480 "Dimensions.vala"
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
#line 481 "Dimensions.vala"
	(*self).interpolation_factor = log (1.0 / (*existing).min_factor) / log ((*existing).max_factor / (*existing).min_factor);
#line 484 "Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 486 "Dimensions.vala"
	if ((*self).interpolation_factor == 0.0) {
#line 487 "Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 1565 "Dimensions.c"
	} else {
#line 489 "Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * ((*existing).viewport_center.x / (*existing).zoom_factor));
#line 491 "Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * ((*existing).viewport_center.y / (*existing).zoom_factor));
#line 493 "Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 1573 "Dimensions.c"
	}
}


#line 497 "Dimensions.vala"
void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center) {
#line 1580 "Dimensions.c"
	memset (self, 0, sizeof (ZoomState));
#line 498 "Dimensions.vala"
	(*self).content_dimensions = (*existing).content_dimensions;
#line 499 "Dimensions.vala"
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
#line 500 "Dimensions.vala"
	(*self).interpolation_factor = (*existing).interpolation_factor;
#line 502 "Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 504 "Dimensions.vala"
	(*self).viewport_center = *new_viewport_center;
#line 506 "Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 1594 "Dimensions.c"
}


#line 509 "Dimensions.vala"
static void zoom_state_clamp_viewport_center (ZoomState *self) {
#line 1600 "Dimensions.c"
	gint zoomed_width;
	gint zoomed_height;
#line 510 "Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 511 "Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 513 "Dimensions.vala"
	(*self).viewport_center.x = CLAMP ((*self).viewport_center.x, (*self).viewport_dimensions.width / 2, (zoomed_width - ((*self).viewport_dimensions.width / 2)) - 1);
#line 515 "Dimensions.vala"
	(*self).viewport_center.y = CLAMP ((*self).viewport_center.y, (*self).viewport_dimensions.height / 2, (zoomed_height - ((*self).viewport_dimensions.height / 2)) - 1);
#line 1611 "Dimensions.c"
}


#line 519 "Dimensions.vala"
static void zoom_state_center_viewport (ZoomState *self) {
#line 520 "Dimensions.vala"
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
#line 521 "Dimensions.vala"
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
#line 1621 "Dimensions.c"
}


#line 524 "Dimensions.vala"
static void zoom_state_compute_zoom_factors (ZoomState *self) {
#line 1627 "Dimensions.c"
	double viewport_to_content_x = 0.0;
	double viewport_to_content_y = 0.0;
#line 525 "Dimensions.vala"
	(*self).max_factor = 2.0;
#line 529 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &(*self).viewport_dimensions, &viewport_to_content_x, &viewport_to_content_y);
#line 531 "Dimensions.vala"
	(*self).min_factor = MIN (viewport_to_content_x, viewport_to_content_y);
#line 532 "Dimensions.vala"
	if ((*self).min_factor > 1.0) {
#line 533 "Dimensions.vala"
		(*self).min_factor = 1.0;
#line 1640 "Dimensions.c"
	}
#line 535 "Dimensions.vala"
	(*self).zoom_factor = (*self).min_factor * pow ((*self).max_factor / (*self).min_factor, (*self).interpolation_factor);
#line 1644 "Dimensions.c"
}


#line 538 "Dimensions.vala"
double zoom_state_get_interpolation_factor (ZoomState *self) {
#line 1650 "Dimensions.c"
	double result = 0.0;
	result = (*self).interpolation_factor;
#line 539 "Dimensions.vala"
	return result;
#line 1655 "Dimensions.c"
}


#line 543 "Dimensions.vala"
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result) {
#line 1661 "Dimensions.c"
	gint zoomed_width;
	gint zoomed_height;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_;
	gint right;
	gint bottom;
#line 544 "Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 545 "Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 547 "Dimensions.vala"
	_result_ = (_tmp0_.x = 0, _tmp0_);
#line 549 "Dimensions.vala"
	if ((*self).viewport_dimensions.width < zoomed_width) {
#line 550 "Dimensions.vala"
		_result_.x = (*self).viewport_center.x - ((*self).viewport_dimensions.width / 2);
#line 1678 "Dimensions.c"
	} else {
#line 552 "Dimensions.vala"
		_result_.x = (zoomed_width - (*self).viewport_dimensions.width) / 2;
#line 1682 "Dimensions.c"
	}
#line 554 "Dimensions.vala"
	if (_result_.x < 0) {
#line 555 "Dimensions.vala"
		_result_.x = 0;
#line 1688 "Dimensions.c"
	}
#line 557 "Dimensions.vala"
	if ((*self).viewport_dimensions.height < zoomed_height) {
#line 558 "Dimensions.vala"
		_result_.y = (*self).viewport_center.y - ((*self).viewport_dimensions.height / 2);
#line 1694 "Dimensions.c"
	} else {
#line 560 "Dimensions.vala"
		_result_.y = (zoomed_height - (*self).viewport_dimensions.height) / 2;
#line 1698 "Dimensions.c"
	}
#line 562 "Dimensions.vala"
	if (_result_.y < 0) {
#line 563 "Dimensions.vala"
		_result_.y = 0;
#line 1704 "Dimensions.c"
	}
#line 565 "Dimensions.vala"
	right = _result_.x + (*self).viewport_dimensions.width;
#line 566 "Dimensions.vala"
	if (right > zoomed_width) {
#line 567 "Dimensions.vala"
		right = zoomed_width;
#line 1712 "Dimensions.c"
	}
#line 568 "Dimensions.vala"
	_result_.width = right - _result_.x;
#line 570 "Dimensions.vala"
	bottom = _result_.y + (*self).viewport_dimensions.height;
#line 571 "Dimensions.vala"
	if (bottom > zoomed_height) {
#line 572 "Dimensions.vala"
		bottom = zoomed_height;
#line 1722 "Dimensions.c"
	}
#line 573 "Dimensions.vala"
	_result_.height = bottom - _result_.y;
#line 1726 "Dimensions.c"
	*result = _result_;
#line 575 "Dimensions.vala"
	return;
#line 1730 "Dimensions.c"
}


#line 580 "Dimensions.vala"
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result) {
#line 1736 "Dimensions.c"
	GdkRectangle _tmp0_ = {0};
	GdkRectangle wrt_content;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _result_;
#line 581 "Dimensions.vala"
	wrt_content = (zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_), _tmp0_);
#line 583 "Dimensions.vala"
	_result_ = (_tmp1_.x = 0, _tmp1_);
#line 584 "Dimensions.vala"
	_result_.x = ((*self).viewport_dimensions.width / 2) - (wrt_content.width / 2);
#line 585 "Dimensions.vala"
	if (_result_.x < 0) {
#line 586 "Dimensions.vala"
		_result_.x = 0;
#line 1751 "Dimensions.c"
	}
#line 587 "Dimensions.vala"
	_result_.y = ((*self).viewport_dimensions.height / 2) - (wrt_content.height / 2);
#line 588 "Dimensions.vala"
	if (_result_.y < 0) {
#line 589 "Dimensions.vala"
		_result_.y = 0;
#line 1759 "Dimensions.c"
	}
#line 590 "Dimensions.vala"
	_result_.width = wrt_content.width;
#line 591 "Dimensions.vala"
	_result_.height = wrt_content.height;
#line 1765 "Dimensions.c"
	*result = _result_;
#line 593 "Dimensions.vala"
	return;
#line 1769 "Dimensions.c"
}


#line 597 "Dimensions.vala"
void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result) {
#line 1775 "Dimensions.c"
	double zoomed_width;
	double zoomed_height;
	double horiz_scale;
	double vert_scale;
	double scale;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle viewing_rectangle;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _result_;
	gint right;
	gint bottom;
#line 597 "Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (for_pixbuf));
#line 598 "Dimensions.vala"
	zoomed_width = (double) zoom_state_get_zoomed_width (&(*self));
#line 599 "Dimensions.vala"
	zoomed_height = (double) zoom_state_get_zoomed_height (&(*self));
#line 601 "Dimensions.vala"
	horiz_scale = gdk_pixbuf_get_width (for_pixbuf) / zoomed_width;
#line 602 "Dimensions.vala"
	vert_scale = gdk_pixbuf_get_height (for_pixbuf) / zoomed_height;
#line 603 "Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 605 "Dimensions.vala"
	viewing_rectangle = (zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_), _tmp0_);
#line 607 "Dimensions.vala"
	_result_ = (_tmp1_.x = 0, _tmp1_);
#line 608 "Dimensions.vala"
	_result_.x = (gint) (viewing_rectangle.x * scale);
#line 609 "Dimensions.vala"
	_result_.x = CLAMP (_result_.x, 0, gdk_pixbuf_get_width (for_pixbuf));
#line 610 "Dimensions.vala"
	_result_.y = (gint) (viewing_rectangle.y * scale);
#line 611 "Dimensions.vala"
	_result_.y = CLAMP (_result_.y, 0, gdk_pixbuf_get_height (for_pixbuf));
#line 612 "Dimensions.vala"
	right = (gint) ((viewing_rectangle.x + viewing_rectangle.width) * scale);
#line 613 "Dimensions.vala"
	right = CLAMP (right, 0, gdk_pixbuf_get_width (for_pixbuf));
#line 614 "Dimensions.vala"
	bottom = (gint) ((viewing_rectangle.y + viewing_rectangle.height) * scale);
#line 615 "Dimensions.vala"
	bottom = CLAMP (bottom, 0, gdk_pixbuf_get_height (for_pixbuf));
#line 616 "Dimensions.vala"
	_result_.width = right - _result_.x;
#line 617 "Dimensions.vala"
	_result_.height = bottom - _result_.y;
#line 1823 "Dimensions.c"
	*result = _result_;
#line 619 "Dimensions.vala"
	return;
#line 1827 "Dimensions.c"
}


#line 623 "Dimensions.vala"
double zoom_state_get_zoom_factor (ZoomState *self) {
#line 1833 "Dimensions.c"
	double result = 0.0;
	result = (*self).zoom_factor;
#line 624 "Dimensions.vala"
	return result;
#line 1838 "Dimensions.c"
}


#line 627 "Dimensions.vala"
gint zoom_state_get_zoomed_width (ZoomState *self) {
#line 1844 "Dimensions.c"
	gint result = 0;
	result = (gint) ((*self).content_dimensions.width * (*self).zoom_factor);
#line 628 "Dimensions.vala"
	return result;
#line 1849 "Dimensions.c"
}


#line 631 "Dimensions.vala"
gint zoom_state_get_zoomed_height (ZoomState *self) {
#line 1855 "Dimensions.c"
	gint result = 0;
	result = (gint) ((*self).content_dimensions.height * (*self).zoom_factor);
#line 632 "Dimensions.vala"
	return result;
#line 1860 "Dimensions.c"
}


#line 635 "Dimensions.vala"
void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result) {
#line 1866 "Dimensions.c"
	*result = (*self).viewport_center;
#line 636 "Dimensions.vala"
	return;
#line 1870 "Dimensions.c"
}


#line 639 "Dimensions.vala"
char* zoom_state_to_string (ZoomState *self) {
#line 1876 "Dimensions.c"
	char* result = NULL;
	char* named_modes;
	GdkRectangle _tmp9_ = {0};
	GdkRectangle viewing_rect;
#line 640 "Dimensions.vala"
	named_modes = g_strdup ("");
#line 641 "Dimensions.vala"
	if (zoom_state_is_min (&(*self))) {
#line 1885 "Dimensions.c"
		const char* _tmp0_;
		char* _tmp1_;
		_tmp0_ = NULL;
#line 642 "Dimensions.vala"
		if (_vala_strcmp0 (named_modes, "") == 0) {
#line 642 "Dimensions.vala"
			_tmp0_ = "MIN";
#line 1893 "Dimensions.c"
		} else {
#line 642 "Dimensions.vala"
			_tmp0_ = ", MIN";
#line 1897 "Dimensions.c"
		}
#line 642 "Dimensions.vala"
		named_modes = (_tmp1_ = g_strconcat (named_modes, _tmp0_, NULL), _g_free0 (named_modes), _tmp1_);
#line 1901 "Dimensions.c"
	}
#line 643 "Dimensions.vala"
	if (zoom_state_is_default (&(*self))) {
#line 1905 "Dimensions.c"
		const char* _tmp2_;
		char* _tmp3_;
		_tmp2_ = NULL;
#line 644 "Dimensions.vala"
		if (_vala_strcmp0 (named_modes, "") == 0) {
#line 644 "Dimensions.vala"
			_tmp2_ = "DEFAULT";
#line 1913 "Dimensions.c"
		} else {
#line 644 "Dimensions.vala"
			_tmp2_ = ", DEFAULT";
#line 1917 "Dimensions.c"
		}
#line 644 "Dimensions.vala"
		named_modes = (_tmp3_ = g_strconcat (named_modes, _tmp2_, NULL), _g_free0 (named_modes), _tmp3_);
#line 1921 "Dimensions.c"
	}
#line 645 "Dimensions.vala"
	if (zoom_state_is_isomorphic (&(*self))) {
#line 1925 "Dimensions.c"
		const char* _tmp4_;
		char* _tmp5_;
		_tmp4_ = NULL;
#line 646 "Dimensions.vala"
		if (_vala_strcmp0 (named_modes, "") == 0) {
#line 646 "Dimensions.vala"
			_tmp4_ = "ISOMORPHIC";
#line 1933 "Dimensions.c"
		} else {
#line 646 "Dimensions.vala"
			_tmp4_ = ", ISOMORPHIC";
#line 1937 "Dimensions.c"
		}
#line 646 "Dimensions.vala"
		named_modes = (_tmp5_ = g_strconcat (named_modes, _tmp4_, NULL), _g_free0 (named_modes), _tmp5_);
#line 1941 "Dimensions.c"
	}
#line 647 "Dimensions.vala"
	if (zoom_state_is_max (&(*self))) {
#line 1945 "Dimensions.c"
		const char* _tmp6_;
		char* _tmp7_;
		_tmp6_ = NULL;
#line 648 "Dimensions.vala"
		if (_vala_strcmp0 (named_modes, "") == 0) {
#line 648 "Dimensions.vala"
			_tmp6_ = "MAX";
#line 1953 "Dimensions.c"
		} else {
#line 648 "Dimensions.vala"
			_tmp6_ = ", MAX";
#line 1957 "Dimensions.c"
		}
#line 648 "Dimensions.vala"
		named_modes = (_tmp7_ = g_strconcat (named_modes, _tmp6_, NULL), _g_free0 (named_modes), _tmp7_);
#line 1961 "Dimensions.c"
	}
#line 649 "Dimensions.vala"
	if (_vala_strcmp0 (named_modes, "") == 0) {
#line 1965 "Dimensions.c"
		char* _tmp8_;
#line 650 "Dimensions.vala"
		named_modes = (_tmp8_ = g_strdup ("(none)"), _g_free0 (named_modes), _tmp8_);
#line 1969 "Dimensions.c"
	}
#line 652 "Dimensions.vala"
	viewing_rect = (zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp9_), _tmp9_);
#line 1973 "Dimensions.c"
	result = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", (*self).content_dimensions.width, (*self).content_dimensions.height, (*self).viewport_dimensions.width, (*self).viewport_dimensions.height, (*self).min_factor, (*self).max_factor, (*self).zoom_factor, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), named_modes, viewing_rect.x, viewing_rect.y, viewing_rect.width, viewing_rect.height, (*self).viewport_center.x, (*self).viewport_center.y);
	_g_free0 (named_modes);
#line 654 "Dimensions.vala"
	return result;
#line 1978 "Dimensions.c"
}


#line 665 "Dimensions.vala"
gboolean zoom_state_is_min (ZoomState *self) {
#line 1984 "Dimensions.c"
	gboolean result = FALSE;
	result = (*self).zoom_factor == (*self).min_factor;
#line 666 "Dimensions.vala"
	return result;
#line 1989 "Dimensions.c"
}


#line 669 "Dimensions.vala"
gboolean zoom_state_is_default (ZoomState *self) {
#line 1995 "Dimensions.c"
	gboolean result = FALSE;
	result = zoom_state_is_min (&(*self));
#line 670 "Dimensions.vala"
	return result;
#line 2000 "Dimensions.c"
}


#line 673 "Dimensions.vala"
gboolean zoom_state_is_max (ZoomState *self) {
#line 2006 "Dimensions.c"
	gboolean result = FALSE;
	result = (*self).zoom_factor == (*self).max_factor;
#line 674 "Dimensions.vala"
	return result;
#line 2011 "Dimensions.c"
}


#line 677 "Dimensions.vala"
gboolean zoom_state_is_isomorphic (ZoomState *self) {
#line 2017 "Dimensions.c"
	gboolean result = FALSE;
	result = (*self).zoom_factor == 1.0;
#line 678 "Dimensions.vala"
	return result;
#line 2022 "Dimensions.c"
}


#line 681 "Dimensions.vala"
gboolean zoom_state_equals (ZoomState *self, ZoomState* other) {
#line 2028 "Dimensions.c"
	gboolean result = FALSE;
#line 682 "Dimensions.vala"
	if (!dimensions_equals (&(*self).content_dimensions, &(*other).content_dimensions)) {
#line 2032 "Dimensions.c"
		result = FALSE;
#line 683 "Dimensions.vala"
		return result;
#line 2036 "Dimensions.c"
	}
#line 684 "Dimensions.vala"
	if (!dimensions_equals (&(*self).viewport_dimensions, &(*other).viewport_dimensions)) {
#line 2040 "Dimensions.c"
		result = FALSE;
#line 685 "Dimensions.vala"
		return result;
#line 2044 "Dimensions.c"
	}
#line 686 "Dimensions.vala"
	if ((*self).zoom_factor != (*other).zoom_factor) {
#line 2048 "Dimensions.c"
		result = FALSE;
#line 687 "Dimensions.vala"
		return result;
#line 2052 "Dimensions.c"
	}
#line 688 "Dimensions.vala"
	if ((*self).min_factor != (*other).min_factor) {
#line 2056 "Dimensions.c"
		result = FALSE;
#line 689 "Dimensions.vala"
		return result;
#line 2060 "Dimensions.c"
	}
#line 690 "Dimensions.vala"
	if ((*self).max_factor != (*other).max_factor) {
#line 2064 "Dimensions.c"
		result = FALSE;
#line 691 "Dimensions.vala"
		return result;
#line 2068 "Dimensions.c"
	}
#line 692 "Dimensions.vala"
	if ((*self).viewport_center.x != (*other).viewport_center.x) {
#line 2072 "Dimensions.c"
		result = FALSE;
#line 693 "Dimensions.vala"
		return result;
#line 2076 "Dimensions.c"
	}
#line 694 "Dimensions.vala"
	if ((*self).viewport_center.y != (*other).viewport_center.y) {
#line 2080 "Dimensions.c"
		result = FALSE;
#line 695 "Dimensions.vala"
		return result;
#line 2084 "Dimensions.c"
	}
	result = TRUE;
#line 697 "Dimensions.vala"
	return result;
#line 2089 "Dimensions.c"
}


ZoomState* zoom_state_dup (const ZoomState* self) {
	ZoomState* dup;
	dup = g_new0 (ZoomState, 1);
	memcpy (dup, self, sizeof (ZoomState));
	return dup;
}


void zoom_state_free (ZoomState* self) {
	g_free (self);
}


GType zoom_state_get_type (void) {
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




