/* MediaInterfaces.c generated by valac 0.10.3, the Vala compiler
 * generated from MediaInterfaces.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* Going forward, Shotwell will use MediaInterfaces, which allow for various operations and features*/
/* to be added only to the MediaSources that support them (or make sense for).  For example, adding*/
/* a library-mode photo or video to an Event makes perfect sense, but does not make sense for a*/
/* direct-mode photo.  All three are MediaSources, and to make DirectPhoto descend from another*/
/* base class is only inviting chaos and a tremendous amount of replicated code.*/
/**/
/* A key point to make of all MediaInterfaces is that they require MediaSource as a base class.*/
/* Thus, any code dealing with one of these interfaces knows they are also dealing with a*/
/* MediaSource.*/
/**/
/* TODO: Make Eventable and Taggable interfaces, which are the only types Event and Tag will deal*/
/* with (rather than MediaSources).*/
/**/
/* TODO: Make Trashable interface, which are much like Flaggable.*/
/**/
/* TODO: ContainerSources may also have specific needs in the future; an interface-based system*/
/* may make sense as well when that need arises.*/
/**/
/**/
/* TransactionController*/
/**/
/* Because many operations in Shotwell need to be performed on collections of objects all at once,*/
/* and that most of these objects are backed by a database, the TransactionController object gives */
/* a way to generically group a series of operations on one or more similar objects into a single*/
/* transaction. This class is listed here because it's used by the various media interfaces to offer*/
/* multiple operations.*/
/**/
/* begin() and commit() may be called multiple times in layering fashion.  The implementation*/
/* accounts for this.  If either throws an exception it should be assumed that the object is in*/
/* a "clean" state; that is, if begin() throws an exception, there is no need to call commit(),*/
/* and if commit() throws an exception, it does not need to be called again to revert the object*/
/* state.*/
/**/
/* This means that any user who calls begin() *must* match it with a corresponding commit(), even*/
/* if there is an error during the transaction.  It is up to the user to back out any undesired*/
/* changes.*/
/**/
/* Because of the nature of this object, it's assumed that every object type will share one*/
/* between all callers.*/
/**/
/* The object is thread-safe.  There is no guarantee that the underlying persistent store is,*/
/* however.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
typedef struct _TransactionControllerPrivate TransactionControllerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTransactionController ParamSpecTransactionController;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

struct _TransactionController {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TransactionControllerPrivate * priv;
};

struct _TransactionControllerClass {
	GTypeClass parent_class;
	void (*finalize) (TransactionController *self);
	void (*begin_impl) (TransactionController* self, GError** error);
	void (*commit_impl) (TransactionController* self, GError** error);
};

struct _TransactionControllerPrivate {
	gint count;
	GStaticRecMutex __lock_count;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _ParamSpecTransactionController {
	GParamSpec parent_instance;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};


static gpointer transaction_controller_parent_class = NULL;

gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
#define TRANSACTION_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TRANSACTION_CONTROLLER, TransactionControllerPrivate))
enum  {
	TRANSACTION_CONTROLLER_DUMMY_PROPERTY
};
TransactionController* transaction_controller_construct (GType object_type);
void transaction_controller_begin (TransactionController* self);
void transaction_controller_begin_impl (TransactionController* self, GError** error);
GQuark database_error_quark (void);
void app_window_database_error (GError* err);
void app_window_panic (const char* msg);
static void transaction_controller_real_begin_impl (TransactionController* self, GError** error);
void transaction_controller_commit (TransactionController* self);
void transaction_controller_commit_impl (TransactionController* self, GError** error);
static void transaction_controller_real_commit_impl (TransactionController* self, GError** error);
static void transaction_controller_finalize (TransactionController* obj);
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType flaggable_get_type (void) G_GNUC_CONST;
gboolean flaggable_is_flagged (Flaggable* self);
void flaggable_mark_flagged (Flaggable* self);
void flaggable_mark_unflagged (Flaggable* self);
void flaggable_mark_many_flagged_unflagged (GeeCollection* flag, GeeCollection* unflag, TransactionController* controller, GError** error);
GType monitorable_get_type (void) G_GNUC_CONST;
gboolean monitorable_is_offline (Monitorable* self);
void monitorable_mark_online (Monitorable* self);
void monitorable_mark_offline (Monitorable* self);
void monitorable_mark_many_online_offline (GeeCollection* online, GeeCollection* offline, TransactionController* controller, GError** error);
void monitorable_set_master_file (Monitorable* self, GFile* file);
void monitorable_set_many_master_file (GeeMap* map, TransactionController* controller, GError** error);
void monitorable_set_master_timestamp (Monitorable* self, GFileInfo* info);
void monitorable_set_many_master_timestamp (GeeMap* map, TransactionController* controller, GError** error);



#line 54 "MediaInterfaces.vala"
TransactionController* transaction_controller_construct (GType object_type) {
#line 229 "MediaInterfaces.c"
	TransactionController* self = (TransactionController*) g_type_create_instance (object_type);
	return self;
}


#line 63 "MediaInterfaces.vala"
void transaction_controller_begin (TransactionController* self) {
#line 237 "MediaInterfaces.c"
	GError * _inner_error_ = NULL;
#line 63 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 241 "MediaInterfaces.c"
	{
		g_static_rec_mutex_lock (&self->priv->__lock_count);
		{
#line 65 "MediaInterfaces.vala"
			if ((self->priv->count++) != 0) {
#line 247 "MediaInterfaces.c"
				{
					g_static_rec_mutex_unlock (&self->priv->__lock_count);
				}
#line 66 "MediaInterfaces.vala"
				return;
#line 253 "MediaInterfaces.c"
			}
			{
#line 69 "MediaInterfaces.vala"
				transaction_controller_begin_impl (self, &_inner_error_);
#line 258 "MediaInterfaces.c"
				if (_inner_error_ != NULL) {
					goto __catch439_g_error;
				}
			}
			goto __finally439;
			__catch439_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				{
#line 72 "MediaInterfaces.vala"
					self->priv->count--;
#line 74 "MediaInterfaces.vala"
					if (err->domain == DATABASE_ERROR) {
#line 75 "MediaInterfaces.vala"
						app_window_database_error ((GError*) err);
#line 276 "MediaInterfaces.c"
					} else {
						char* _tmp0_;
#line 77 "MediaInterfaces.vala"
						app_window_panic (_tmp0_ = g_strdup_printf ("%s", err->message));
#line 281 "MediaInterfaces.c"
						_g_free0 (_tmp0_);
					}
					_g_error_free0 (err);
				}
			}
			__finally439:
			if (_inner_error_ != NULL) {
				{
					g_static_rec_mutex_unlock (&self->priv->__lock_count);
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		__finally438:
		{
			g_static_rec_mutex_unlock (&self->priv->__lock_count);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


#line 83 "MediaInterfaces.vala"
static void transaction_controller_real_begin_impl (TransactionController* self, GError** error) {
#line 312 "MediaInterfaces.c"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_begin_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 54 "MediaInterfaces.vala"
void transaction_controller_begin_impl (TransactionController* self, GError** error) {
#line 54 "MediaInterfaces.vala"
	TRANSACTION_CONTROLLER_GET_CLASS (self)->begin_impl (self, error);
#line 323 "MediaInterfaces.c"
}


#line 85 "MediaInterfaces.vala"
void transaction_controller_commit (TransactionController* self) {
#line 329 "MediaInterfaces.c"
	GError * _inner_error_ = NULL;
#line 85 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
#line 333 "MediaInterfaces.c"
	{
		g_static_rec_mutex_lock (&self->priv->__lock_count);
		{
#line 87 "MediaInterfaces.vala"
			g_assert (self->priv->count > 0);
#line 88 "MediaInterfaces.vala"
			if ((self->priv->count = self->priv->count - 1) != 0) {
#line 341 "MediaInterfaces.c"
				{
					g_static_rec_mutex_unlock (&self->priv->__lock_count);
				}
#line 89 "MediaInterfaces.vala"
				return;
#line 347 "MediaInterfaces.c"
			}
			{
#line 93 "MediaInterfaces.vala"
				transaction_controller_commit_impl (self, &_inner_error_);
#line 352 "MediaInterfaces.c"
				if (_inner_error_ != NULL) {
					goto __catch441_g_error;
				}
			}
			goto __finally441;
			__catch441_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				{
#line 95 "MediaInterfaces.vala"
					if (err->domain == DATABASE_ERROR) {
#line 96 "MediaInterfaces.vala"
						app_window_database_error ((GError*) err);
#line 368 "MediaInterfaces.c"
					} else {
						char* _tmp0_;
#line 98 "MediaInterfaces.vala"
						app_window_panic (_tmp0_ = g_strdup_printf ("%s", err->message));
#line 373 "MediaInterfaces.c"
						_g_free0 (_tmp0_);
					}
					_g_error_free0 (err);
				}
			}
			__finally441:
			if (_inner_error_ != NULL) {
				{
					g_static_rec_mutex_unlock (&self->priv->__lock_count);
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		__finally440:
		{
			g_static_rec_mutex_unlock (&self->priv->__lock_count);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


#line 104 "MediaInterfaces.vala"
static void transaction_controller_real_commit_impl (TransactionController* self, GError** error) {
#line 404 "MediaInterfaces.c"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (self));
	g_critical ("Type `%s' does not implement abstract method `transaction_controller_commit_impl'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 54 "MediaInterfaces.vala"
void transaction_controller_commit_impl (TransactionController* self, GError** error) {
#line 54 "MediaInterfaces.vala"
	TRANSACTION_CONTROLLER_GET_CLASS (self)->commit_impl (self, error);
#line 415 "MediaInterfaces.c"
}


static void value_transaction_controller_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_transaction_controller_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		transaction_controller_unref (value->data[0].v_pointer);
	}
}


static void value_transaction_controller_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = transaction_controller_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_transaction_controller_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_transaction_controller_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		TransactionController* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = transaction_controller_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_transaction_controller_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TransactionController** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = transaction_controller_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTransactionController* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TRANSACTION_CONTROLLER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_transaction_controller (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER), NULL);
	return value->data[0].v_pointer;
}


void value_set_transaction_controller (GValue* value, gpointer v_object) {
	TransactionController* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		transaction_controller_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		transaction_controller_unref (old);
	}
}


void value_take_transaction_controller (GValue* value, gpointer v_object) {
	TransactionController* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TRANSACTION_CONTROLLER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TRANSACTION_CONTROLLER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		transaction_controller_unref (old);
	}
}


static void transaction_controller_class_init (TransactionControllerClass * klass) {
	transaction_controller_parent_class = g_type_class_peek_parent (klass);
	TRANSACTION_CONTROLLER_CLASS (klass)->finalize = transaction_controller_finalize;
	g_type_class_add_private (klass, sizeof (TransactionControllerPrivate));
	TRANSACTION_CONTROLLER_CLASS (klass)->begin_impl = transaction_controller_real_begin_impl;
	TRANSACTION_CONTROLLER_CLASS (klass)->commit_impl = transaction_controller_real_commit_impl;
}


static void transaction_controller_instance_init (TransactionController * self) {
	self->priv = TRANSACTION_CONTROLLER_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_count);
	self->priv->count = 0;
	self->ref_count = 1;
}


static void transaction_controller_finalize (TransactionController* obj) {
	TransactionController * self;
	GError * _inner_error_;
	self = TRANSACTION_CONTROLLER (obj);
	_inner_error_ = NULL;
	{
		{
			g_static_rec_mutex_lock (&self->priv->__lock_count);
			{
#line 59 "MediaInterfaces.vala"
				g_assert (self->priv->count == 0);
#line 557 "MediaInterfaces.c"
			}
			__finally442:
			{
				g_static_rec_mutex_unlock (&self->priv->__lock_count);
			}
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
			}
		}
	}
	g_static_rec_mutex_free (&self->priv->__lock_count);
}


GType transaction_controller_get_type (void) {
	static volatile gsize transaction_controller_type_id__volatile = 0;
	if (g_once_init_enter (&transaction_controller_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_transaction_controller_init, value_transaction_controller_free_value, value_transaction_controller_copy_value, value_transaction_controller_peek_pointer, "p", value_transaction_controller_collect_value, "p", value_transaction_controller_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TransactionControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) transaction_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TransactionController), 0, (GInstanceInitFunc) transaction_controller_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType transaction_controller_type_id;
		transaction_controller_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TransactionController", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&transaction_controller_type_id__volatile, transaction_controller_type_id);
	}
	return transaction_controller_type_id__volatile;
}


gpointer transaction_controller_ref (gpointer instance) {
	TransactionController* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void transaction_controller_unref (gpointer instance) {
	TransactionController* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TRANSACTION_CONTROLLER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 54 "MediaInterfaces.vala"
gboolean flaggable_is_flagged (Flaggable* self) {
#line 54 "MediaInterfaces.vala"
	return FLAGGABLE_GET_INTERFACE (self)->is_flagged (self);
#line 609 "MediaInterfaces.c"
}


#line 54 "MediaInterfaces.vala"
void flaggable_mark_flagged (Flaggable* self) {
#line 54 "MediaInterfaces.vala"
	FLAGGABLE_GET_INTERFACE (self)->mark_flagged (self);
#line 617 "MediaInterfaces.c"
}


#line 54 "MediaInterfaces.vala"
void flaggable_mark_unflagged (Flaggable* self) {
#line 54 "MediaInterfaces.vala"
	FLAGGABLE_GET_INTERFACE (self)->mark_unflagged (self);
#line 625 "MediaInterfaces.c"
}


#line 121 "MediaInterfaces.vala"
void flaggable_mark_many_flagged_unflagged (GeeCollection* flag, GeeCollection* unflag, TransactionController* controller, GError** error) {
#line 121 "MediaInterfaces.vala"
	g_return_if_fail ((flag == NULL) || GEE_IS_COLLECTION (flag));
#line 121 "MediaInterfaces.vala"
	g_return_if_fail ((unflag == NULL) || GEE_IS_COLLECTION (unflag));
#line 121 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 123 "MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 125 "MediaInterfaces.vala"
	if (flag != NULL) {
#line 641 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it;
#line 126 "MediaInterfaces.vala"
			_flaggable_it = gee_iterable_iterator (GEE_ITERABLE (flag));
#line 126 "MediaInterfaces.vala"
			while (TRUE) {
#line 648 "MediaInterfaces.c"
				Flaggable* flaggable;
#line 126 "MediaInterfaces.vala"
				if (!gee_iterator_next (_flaggable_it)) {
#line 126 "MediaInterfaces.vala"
					break;
#line 654 "MediaInterfaces.c"
				}
#line 126 "MediaInterfaces.vala"
				flaggable = (Flaggable*) gee_iterator_get (_flaggable_it);
#line 127 "MediaInterfaces.vala"
				flaggable_mark_flagged (flaggable);
#line 660 "MediaInterfaces.c"
				_g_object_unref0 (flaggable);
			}
			_g_object_unref0 (_flaggable_it);
		}
	}
#line 130 "MediaInterfaces.vala"
	if (unflag != NULL) {
#line 668 "MediaInterfaces.c"
		{
			GeeIterator* _flaggable_it;
#line 131 "MediaInterfaces.vala"
			_flaggable_it = gee_iterable_iterator (GEE_ITERABLE (unflag));
#line 131 "MediaInterfaces.vala"
			while (TRUE) {
#line 675 "MediaInterfaces.c"
				Flaggable* flaggable;
#line 131 "MediaInterfaces.vala"
				if (!gee_iterator_next (_flaggable_it)) {
#line 131 "MediaInterfaces.vala"
					break;
#line 681 "MediaInterfaces.c"
				}
#line 131 "MediaInterfaces.vala"
				flaggable = (Flaggable*) gee_iterator_get (_flaggable_it);
#line 132 "MediaInterfaces.vala"
				flaggable_mark_unflagged (flaggable);
#line 687 "MediaInterfaces.c"
				_g_object_unref0 (flaggable);
			}
			_g_object_unref0 (_flaggable_it);
		}
	}
#line 135 "MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 695 "MediaInterfaces.c"
}


static void flaggable_base_init (FlaggableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType flaggable_get_type (void) {
	static volatile gsize flaggable_type_id__volatile = 0;
	if (g_once_init_enter (&flaggable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FlaggableIface), (GBaseInitFunc) flaggable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType flaggable_type_id;
		flaggable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Flaggable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (flaggable_type_id, TYPE_MEDIA_SOURCE);
		g_once_init_leave (&flaggable_type_id__volatile, flaggable_type_id);
	}
	return flaggable_type_id__volatile;
}


#line 54 "MediaInterfaces.vala"
gboolean monitorable_is_offline (Monitorable* self) {
#line 54 "MediaInterfaces.vala"
	return MONITORABLE_GET_INTERFACE (self)->is_offline (self);
#line 724 "MediaInterfaces.c"
}


#line 54 "MediaInterfaces.vala"
void monitorable_mark_online (Monitorable* self) {
#line 54 "MediaInterfaces.vala"
	MONITORABLE_GET_INTERFACE (self)->mark_online (self);
#line 732 "MediaInterfaces.c"
}


#line 54 "MediaInterfaces.vala"
void monitorable_mark_offline (Monitorable* self) {
#line 54 "MediaInterfaces.vala"
	MONITORABLE_GET_INTERFACE (self)->mark_offline (self);
#line 740 "MediaInterfaces.c"
}


#line 159 "MediaInterfaces.vala"
void monitorable_mark_many_online_offline (GeeCollection* online, GeeCollection* offline, TransactionController* controller, GError** error) {
#line 159 "MediaInterfaces.vala"
	g_return_if_fail ((online == NULL) || GEE_IS_COLLECTION (online));
#line 159 "MediaInterfaces.vala"
	g_return_if_fail ((offline == NULL) || GEE_IS_COLLECTION (offline));
#line 159 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 161 "MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 163 "MediaInterfaces.vala"
	if (online != NULL) {
#line 756 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it;
#line 164 "MediaInterfaces.vala"
			_monitorable_it = gee_iterable_iterator (GEE_ITERABLE (online));
#line 164 "MediaInterfaces.vala"
			while (TRUE) {
#line 763 "MediaInterfaces.c"
				Monitorable* monitorable;
#line 164 "MediaInterfaces.vala"
				if (!gee_iterator_next (_monitorable_it)) {
#line 164 "MediaInterfaces.vala"
					break;
#line 769 "MediaInterfaces.c"
				}
#line 164 "MediaInterfaces.vala"
				monitorable = (Monitorable*) gee_iterator_get (_monitorable_it);
#line 165 "MediaInterfaces.vala"
				monitorable_mark_online (monitorable);
#line 775 "MediaInterfaces.c"
				_g_object_unref0 (monitorable);
			}
			_g_object_unref0 (_monitorable_it);
		}
	}
#line 168 "MediaInterfaces.vala"
	if (offline != NULL) {
#line 783 "MediaInterfaces.c"
		{
			GeeIterator* _monitorable_it;
#line 169 "MediaInterfaces.vala"
			_monitorable_it = gee_iterable_iterator (GEE_ITERABLE (offline));
#line 169 "MediaInterfaces.vala"
			while (TRUE) {
#line 790 "MediaInterfaces.c"
				Monitorable* monitorable;
#line 169 "MediaInterfaces.vala"
				if (!gee_iterator_next (_monitorable_it)) {
#line 169 "MediaInterfaces.vala"
					break;
#line 796 "MediaInterfaces.c"
				}
#line 169 "MediaInterfaces.vala"
				monitorable = (Monitorable*) gee_iterator_get (_monitorable_it);
#line 170 "MediaInterfaces.vala"
				monitorable_mark_offline (monitorable);
#line 802 "MediaInterfaces.c"
				_g_object_unref0 (monitorable);
			}
			_g_object_unref0 (_monitorable_it);
		}
	}
#line 173 "MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 810 "MediaInterfaces.c"
}


#line 54 "MediaInterfaces.vala"
void monitorable_set_master_file (Monitorable* self, GFile* file) {
#line 54 "MediaInterfaces.vala"
	MONITORABLE_GET_INTERFACE (self)->set_master_file (self, file);
#line 818 "MediaInterfaces.c"
}


#line 178 "MediaInterfaces.vala"
void monitorable_set_many_master_file (GeeMap* map, TransactionController* controller, GError** error) {
#line 824 "MediaInterfaces.c"
	GeeMapIterator* map_iter;
#line 178 "MediaInterfaces.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 178 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 180 "MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 182 "MediaInterfaces.vala"
	map_iter = gee_map_map_iterator (map);
#line 183 "MediaInterfaces.vala"
	while (TRUE) {
#line 836 "MediaInterfaces.c"
		Monitorable* _tmp0_;
		GFile* _tmp1_;
#line 183 "MediaInterfaces.vala"
		if (!gee_map_iterator_next (map_iter)) {
#line 183 "MediaInterfaces.vala"
			break;
#line 843 "MediaInterfaces.c"
		}
#line 184 "MediaInterfaces.vala"
		monitorable_set_master_file (_tmp0_ = (Monitorable*) gee_map_iterator_get_key (map_iter), _tmp1_ = (GFile*) gee_map_iterator_get_value (map_iter));
#line 847 "MediaInterfaces.c"
		_g_object_unref0 (_tmp1_);
		_g_object_unref0 (_tmp0_);
	}
#line 186 "MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 853 "MediaInterfaces.c"
	_g_object_unref0 (map_iter);
}


#line 54 "MediaInterfaces.vala"
void monitorable_set_master_timestamp (Monitorable* self, GFileInfo* info) {
#line 54 "MediaInterfaces.vala"
	MONITORABLE_GET_INTERFACE (self)->set_master_timestamp (self, info);
#line 862 "MediaInterfaces.c"
}


#line 191 "MediaInterfaces.vala"
void monitorable_set_many_master_timestamp (GeeMap* map, TransactionController* controller, GError** error) {
#line 868 "MediaInterfaces.c"
	GeeMapIterator* map_iter;
#line 191 "MediaInterfaces.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 191 "MediaInterfaces.vala"
	g_return_if_fail (IS_TRANSACTION_CONTROLLER (controller));
#line 193 "MediaInterfaces.vala"
	transaction_controller_begin (controller);
#line 195 "MediaInterfaces.vala"
	map_iter = gee_map_map_iterator (map);
#line 196 "MediaInterfaces.vala"
	while (TRUE) {
#line 880 "MediaInterfaces.c"
		Monitorable* _tmp0_;
		GFileInfo* _tmp1_;
#line 196 "MediaInterfaces.vala"
		if (!gee_map_iterator_next (map_iter)) {
#line 196 "MediaInterfaces.vala"
			break;
#line 887 "MediaInterfaces.c"
		}
#line 197 "MediaInterfaces.vala"
		monitorable_set_master_timestamp (_tmp0_ = (Monitorable*) gee_map_iterator_get_key (map_iter), _tmp1_ = (GFileInfo*) gee_map_iterator_get_value (map_iter));
#line 891 "MediaInterfaces.c"
		_g_object_unref0 (_tmp1_);
		_g_object_unref0 (_tmp0_);
	}
#line 199 "MediaInterfaces.vala"
	transaction_controller_commit (controller);
#line 897 "MediaInterfaces.c"
	_g_object_unref0 (map_iter);
}


static void monitorable_base_init (MonitorableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType monitorable_get_type (void) {
	static volatile gsize monitorable_type_id__volatile = 0;
	if (g_once_init_enter (&monitorable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MonitorableIface), (GBaseInitFunc) monitorable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType monitorable_type_id;
		monitorable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Monitorable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (monitorable_type_id, TYPE_MEDIA_SOURCE);
		g_once_init_leave (&monitorable_type_id__volatile, monitorable_type_id);
	}
	return monitorable_type_id__volatile;
}




