/* MediaMetadata.c generated by valac 0.10.3, the Vala compiler
 * generated from MediaMetadata.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
typedef struct _ParamSpecMediaMetadata ParamSpecMediaMetadata;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MetadataDateTimePrivate MetadataDateTimePrivate;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _ParamSpecMetadataDateTime ParamSpecMetadataDateTime;

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	char* (*get_title) (MediaMetadata* self);
};

struct _ParamSpecMediaMetadata {
	GParamSpec parent_instance;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _MetadataDateTime {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MetadataDateTimePrivate * priv;
};

struct _MetadataDateTimeClass {
	GTypeClass parent_class;
	void (*finalize) (MetadataDateTime *self);
};

struct _MetadataDateTimePrivate {
	time_t timestamp;
};

struct _ParamSpecMetadataDateTime {
	GParamSpec parent_instance;
};


static gpointer media_metadata_parent_class = NULL;
static gpointer metadata_date_time_parent_class = NULL;

gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
enum  {
	MEDIA_METADATA_DUMMY_PROPERTY
};
MediaMetadata* media_metadata_construct (GType object_type);
void media_metadata_read_from_file (MediaMetadata* self, GFile* file, GError** error);
static void media_metadata_real_read_from_file (MediaMetadata* self, GFile* file, GError** error);
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self);
static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self);
char* media_metadata_get_title (MediaMetadata* self);
static char* media_metadata_real_get_title (MediaMetadata* self);
static void media_metadata_finalize (MediaMetadata* obj);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator);
static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component);
gboolean metadata_rational_is_valid (MetadataRational *self);
char* metadata_rational_to_string (MetadataRational *self);
GQuark metadata_date_time_error_quark (void);
#define METADATA_DATE_TIME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_DATE_TIME, MetadataDateTimePrivate))
enum  {
	METADATA_DATE_TIME_DUMMY_PROPERTY
};
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
MetadataDateTime* metadata_date_time_new_from_exif (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const char* label, GError** error);
gboolean metadata_date_time_from_exif_date_time (const char* date_time, time_t* timestamp);
MetadataDateTime* metadata_date_time_new_from_iptc (const char* date, const char* time, GError** error);
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const char* date, const char* time, GError** error);
MetadataDateTime* metadata_date_time_new_from_xmp (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const char* label, GError** error);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
char* metadata_date_time_get_exif_label (MetadataDateTime* self);
char* metadata_date_time_to_exif_date_time (time_t timestamp);
char* metadata_date_time_get_xmp_label (MetadataDateTime* self);
char* metadata_date_time_to_string (MetadataDateTime* self);
static void metadata_date_time_finalize (MetadataDateTime* obj);



#line 8 "MediaMetadata.vala"
MediaMetadata* media_metadata_construct (GType object_type) {
#line 158 "MediaMetadata.c"
	MediaMetadata* self = (MediaMetadata*) g_type_create_instance (object_type);
	return self;
}


#line 11 "MediaMetadata.vala"
static void media_metadata_real_read_from_file (MediaMetadata* self, GFile* file, GError** error) {
#line 166 "MediaMetadata.c"
	g_return_if_fail (IS_MEDIA_METADATA (self));
	g_critical ("Type `%s' does not implement abstract method `media_metadata_read_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 8 "MediaMetadata.vala"
void media_metadata_read_from_file (MediaMetadata* self, GFile* file, GError** error) {
#line 8 "MediaMetadata.vala"
	MEDIA_METADATA_GET_CLASS (self)->read_from_file (self, file, error);
#line 177 "MediaMetadata.c"
}


#line 13 "MediaMetadata.vala"
static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self) {
#line 183 "MediaMetadata.c"
	g_return_val_if_fail (IS_MEDIA_METADATA (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_creation_date_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 8 "MediaMetadata.vala"
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self) {
#line 8 "MediaMetadata.vala"
	return MEDIA_METADATA_GET_CLASS (self)->get_creation_date_time (self);
#line 194 "MediaMetadata.c"
}


#line 15 "MediaMetadata.vala"
static char* media_metadata_real_get_title (MediaMetadata* self) {
#line 200 "MediaMetadata.c"
	g_return_val_if_fail (IS_MEDIA_METADATA (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 8 "MediaMetadata.vala"
char* media_metadata_get_title (MediaMetadata* self) {
#line 8 "MediaMetadata.vala"
	return MEDIA_METADATA_GET_CLASS (self)->get_title (self);
#line 211 "MediaMetadata.c"
}


static void value_media_metadata_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_media_metadata_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		media_metadata_unref (value->data[0].v_pointer);
	}
}


static void value_media_metadata_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = media_metadata_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_media_metadata_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_media_metadata_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		MediaMetadata* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = media_metadata_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_media_metadata_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	MediaMetadata** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = media_metadata_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMediaMetadata* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEDIA_METADATA), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_media_metadata (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA), NULL);
	return value->data[0].v_pointer;
}


void value_set_media_metadata (GValue* value, gpointer v_object) {
	MediaMetadata* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		media_metadata_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		media_metadata_unref (old);
	}
}


void value_take_media_metadata (GValue* value, gpointer v_object) {
	MediaMetadata* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		media_metadata_unref (old);
	}
}


static void media_metadata_class_init (MediaMetadataClass * klass) {
	media_metadata_parent_class = g_type_class_peek_parent (klass);
	MEDIA_METADATA_CLASS (klass)->finalize = media_metadata_finalize;
	MEDIA_METADATA_CLASS (klass)->read_from_file = media_metadata_real_read_from_file;
	MEDIA_METADATA_CLASS (klass)->get_creation_date_time = media_metadata_real_get_creation_date_time;
	MEDIA_METADATA_CLASS (klass)->get_title = media_metadata_real_get_title;
}


static void media_metadata_instance_init (MediaMetadata * self) {
	self->ref_count = 1;
}


static void media_metadata_finalize (MediaMetadata* obj) {
	MediaMetadata * self;
	self = MEDIA_METADATA (obj);
}


GType media_metadata_get_type (void) {
	static volatile gsize media_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&media_metadata_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_media_metadata_init, value_media_metadata_free_value, value_media_metadata_copy_value, value_media_metadata_peek_pointer, "p", value_media_metadata_collect_value, "p", value_media_metadata_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MediaMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaMetadata), 0, (GInstanceInitFunc) media_metadata_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType media_metadata_type_id;
		media_metadata_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MediaMetadata", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&media_metadata_type_id__volatile, media_metadata_type_id);
	}
	return media_metadata_type_id__volatile;
}


gpointer media_metadata_ref (gpointer instance) {
	MediaMetadata* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void media_metadata_unref (gpointer instance) {
	MediaMetadata* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		MEDIA_METADATA_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 22 "MediaMetadata.vala"
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator) {
#line 379 "MediaMetadata.c"
	memset (self, 0, sizeof (MetadataRational));
#line 23 "MediaMetadata.vala"
	(*self).numerator = numerator;
#line 24 "MediaMetadata.vala"
	(*self).denominator = denominator;
#line 385 "MediaMetadata.c"
}


#line 27 "MediaMetadata.vala"
static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component) {
#line 391 "MediaMetadata.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 28 "MediaMetadata.vala"
	if (component >= 0) {
#line 28 "MediaMetadata.vala"
		_tmp0_ = component <= 1000000;
#line 398 "MediaMetadata.c"
	} else {
#line 28 "MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 402 "MediaMetadata.c"
	}
	result = _tmp0_;
#line 28 "MediaMetadata.vala"
	return result;
#line 407 "MediaMetadata.c"
}


#line 31 "MediaMetadata.vala"
gboolean metadata_rational_is_valid (MetadataRational *self) {
#line 413 "MediaMetadata.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 32 "MediaMetadata.vala"
	if (metadata_rational_is_component_valid (&(*self), (*self).numerator)) {
#line 32 "MediaMetadata.vala"
		_tmp0_ = metadata_rational_is_component_valid (&(*self), (*self).denominator);
#line 420 "MediaMetadata.c"
	} else {
#line 32 "MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 424 "MediaMetadata.c"
	}
	result = _tmp0_;
#line 32 "MediaMetadata.vala"
	return result;
#line 429 "MediaMetadata.c"
}


#line 35 "MediaMetadata.vala"
char* metadata_rational_to_string (MetadataRational *self) {
#line 435 "MediaMetadata.c"
	char* result = NULL;
	char* _tmp0_;
	_tmp0_ = NULL;
#line 36 "MediaMetadata.vala"
	if (metadata_rational_is_valid (&(*self))) {
#line 441 "MediaMetadata.c"
		char* _tmp1_;
#line 36 "MediaMetadata.vala"
		_tmp0_ = (_tmp1_ = g_strdup_printf ("%d/%d", (*self).numerator, (*self).denominator), _g_free0 (_tmp0_), _tmp1_);
#line 445 "MediaMetadata.c"
	} else {
		char* _tmp2_;
#line 36 "MediaMetadata.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 450 "MediaMetadata.c"
	}
	result = _tmp0_;
#line 36 "MediaMetadata.vala"
	return result;
#line 455 "MediaMetadata.c"
}


MetadataRational* metadata_rational_dup (const MetadataRational* self) {
	MetadataRational* dup;
	dup = g_new0 (MetadataRational, 1);
	memcpy (dup, self, sizeof (MetadataRational));
	return dup;
}


void metadata_rational_free (MetadataRational* self) {
	g_free (self);
}


GType metadata_rational_get_type (void) {
	static volatile gsize metadata_rational_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_rational_type_id__volatile)) {
		GType metadata_rational_type_id;
		metadata_rational_type_id = g_boxed_type_register_static ("MetadataRational", (GBoxedCopyFunc) metadata_rational_dup, (GBoxedFreeFunc) metadata_rational_free);
		g_once_init_leave (&metadata_rational_type_id__volatile, metadata_rational_type_id);
	}
	return metadata_rational_type_id__volatile;
}


GQuark metadata_date_time_error_quark (void) {
	return g_quark_from_static_string ("metadata_date_time_error-quark");
}


#line 48 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp) {
#line 490 "MediaMetadata.c"
	MetadataDateTime* self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 49 "MediaMetadata.vala"
	self->priv->timestamp = timestamp;
#line 494 "MediaMetadata.c"
	return self;
}


#line 48 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_new (time_t timestamp) {
#line 48 "MediaMetadata.vala"
	return metadata_date_time_construct (TYPE_METADATA_DATE_TIME, timestamp);
#line 503 "MediaMetadata.c"
}


#line 52 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const char* label, GError** error) {
#line 509 "MediaMetadata.c"
	MetadataDateTime* self = (MetadataDateTime*) g_type_create_instance (object_type);
	GError * _inner_error_ = NULL;
#line 52 "MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 53 "MediaMetadata.vala"
	if (!metadata_date_time_from_exif_date_time (label, &self->priv->timestamp)) {
#line 516 "MediaMetadata.c"
		_inner_error_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not EXIF format date/time", label);
		{
			if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
				g_propagate_error (error, _inner_error_);
				_metadata_date_time_unref0 (self);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	return self;
}


#line 52 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_exif (const char* label, GError** error) {
#line 52 "MediaMetadata.vala"
	return metadata_date_time_construct_from_exif (TYPE_METADATA_DATE_TIME, label, error);
#line 538 "MediaMetadata.c"
}


#line 57 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const char* date, const char* time, GError** error) {
#line 544 "MediaMetadata.c"
	MetadataDateTime* self = (MetadataDateTime*) g_type_create_instance (object_type);
	GError * _inner_error_ = NULL;
#line 57 "MediaMetadata.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 57 "MediaMetadata.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 551 "MediaMetadata.c"
	_inner_error_ = g_error_new_literal (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT, "IPTC date/time format not currently supported");
	{
		if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error_);
			_metadata_date_time_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


#line 57 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_iptc (const char* date, const char* time, GError** error) {
#line 57 "MediaMetadata.vala"
	return metadata_date_time_construct_from_iptc (TYPE_METADATA_DATE_TIME, date, time, error);
#line 572 "MediaMetadata.c"
}


#line 62 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const char* label, GError** error) {
#line 578 "MediaMetadata.c"
	MetadataDateTime* self = (MetadataDateTime*) g_type_create_instance (object_type);
	GTimeVal time_val = {0};
	GError * _inner_error_ = NULL;
#line 62 "MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 584 "MediaMetadata.c"
	g_get_current_time (&time_val);
#line 64 "MediaMetadata.vala"
	if (!g_time_val_from_iso8601 (label, &time_val)) {
#line 588 "MediaMetadata.c"
		_inner_error_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not XMP format date/time", label);
		{
			if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
				g_propagate_error (error, _inner_error_);
				_metadata_date_time_unref0 (self);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 67 "MediaMetadata.vala"
	self->priv->timestamp = (time_t) time_val.tv_sec;
#line 604 "MediaMetadata.c"
	return self;
}


#line 62 "MediaMetadata.vala"
MetadataDateTime* metadata_date_time_new_from_xmp (const char* label, GError** error) {
#line 62 "MediaMetadata.vala"
	return metadata_date_time_construct_from_xmp (TYPE_METADATA_DATE_TIME, label, error);
#line 613 "MediaMetadata.c"
}


#line 70 "MediaMetadata.vala"
time_t metadata_date_time_get_timestamp (MetadataDateTime* self) {
#line 619 "MediaMetadata.c"
	time_t result = 0;
#line 70 "MediaMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), 0);
#line 623 "MediaMetadata.c"
	result = self->priv->timestamp;
#line 71 "MediaMetadata.vala"
	return result;
#line 627 "MediaMetadata.c"
}


#line 74 "MediaMetadata.vala"
char* metadata_date_time_get_exif_label (MetadataDateTime* self) {
#line 633 "MediaMetadata.c"
	char* result = NULL;
#line 74 "MediaMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
#line 637 "MediaMetadata.c"
	result = metadata_date_time_to_exif_date_time (self->priv->timestamp);
#line 75 "MediaMetadata.vala"
	return result;
#line 641 "MediaMetadata.c"
}


#line 80 "MediaMetadata.vala"
char* metadata_date_time_get_xmp_label (MetadataDateTime* self) {
#line 647 "MediaMetadata.c"
	char* result = NULL;
	GTimeVal time_val = {0};
#line 80 "MediaMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
#line 652 "MediaMetadata.c"
	g_get_current_time (&time_val);
#line 82 "MediaMetadata.vala"
	time_val.tv_sec = (glong) self->priv->timestamp;
#line 83 "MediaMetadata.vala"
	time_val.tv_usec = (glong) 0;
#line 658 "MediaMetadata.c"
	result = g_time_val_to_iso8601 (&time_val);
#line 85 "MediaMetadata.vala"
	return result;
#line 662 "MediaMetadata.c"
}


#line 88 "MediaMetadata.vala"
gboolean metadata_date_time_from_exif_date_time (const char* date_time, time_t* timestamp) {
#line 668 "MediaMetadata.c"
	gboolean result = FALSE;
	struct tm tm = {0};
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 88 "MediaMetadata.vala"
	g_return_val_if_fail (date_time != NULL, FALSE);
#line 678 "MediaMetadata.c"
	memset (&tm, 0, sizeof (struct tm));
#line 91 "MediaMetadata.vala"
	if (sscanf (date_time, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
#line 94 "MediaMetadata.vala"
		if (sscanf (date_time, "%d:%d:%d:%d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
#line 684 "MediaMetadata.c"
			result = FALSE;
#line 96 "MediaMetadata.vala"
			return result;
#line 688 "MediaMetadata.c"
		}
	}
#line 101 "MediaMetadata.vala"
	if (tm.tm_year <= 1900) {
#line 101 "MediaMetadata.vala"
		_tmp4_ = TRUE;
#line 695 "MediaMetadata.c"
	} else {
#line 101 "MediaMetadata.vala"
		_tmp4_ = tm.tm_mon <= 0;
#line 699 "MediaMetadata.c"
	}
#line 101 "MediaMetadata.vala"
	if (_tmp4_) {
#line 101 "MediaMetadata.vala"
		_tmp3_ = TRUE;
#line 705 "MediaMetadata.c"
	} else {
#line 101 "MediaMetadata.vala"
		_tmp3_ = tm.tm_mday < 0;
#line 709 "MediaMetadata.c"
	}
#line 101 "MediaMetadata.vala"
	if (_tmp3_) {
#line 101 "MediaMetadata.vala"
		_tmp2_ = TRUE;
#line 715 "MediaMetadata.c"
	} else {
#line 101 "MediaMetadata.vala"
		_tmp2_ = tm.tm_hour < 0;
#line 719 "MediaMetadata.c"
	}
#line 101 "MediaMetadata.vala"
	if (_tmp2_) {
#line 101 "MediaMetadata.vala"
		_tmp1_ = TRUE;
#line 725 "MediaMetadata.c"
	} else {
#line 101 "MediaMetadata.vala"
		_tmp1_ = tm.tm_min < 0;
#line 729 "MediaMetadata.c"
	}
#line 101 "MediaMetadata.vala"
	if (_tmp1_) {
#line 101 "MediaMetadata.vala"
		_tmp0_ = TRUE;
#line 735 "MediaMetadata.c"
	} else {
#line 101 "MediaMetadata.vala"
		_tmp0_ = tm.tm_sec < 0;
#line 739 "MediaMetadata.c"
	}
#line 101 "MediaMetadata.vala"
	if (_tmp0_) {
#line 743 "MediaMetadata.c"
		result = FALSE;
#line 102 "MediaMetadata.vala"
		return result;
#line 747 "MediaMetadata.c"
	}
#line 104 "MediaMetadata.vala"
	tm.tm_year = tm.tm_year - 1900;
#line 105 "MediaMetadata.vala"
	tm.tm_mon--;
#line 106 "MediaMetadata.vala"
	tm.tm_isdst = -1;
#line 108 "MediaMetadata.vala"
	*timestamp = mktime (&tm);
#line 757 "MediaMetadata.c"
	result = TRUE;
#line 110 "MediaMetadata.vala"
	return result;
#line 761 "MediaMetadata.c"
}


#line 2221 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 767 "MediaMetadata.c"
	struct tm _result_ = {0};
#line 2223 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 771 "MediaMetadata.c"
	*result = _result_;
#line 2224 "glib-2.0.vapi"
	return;
#line 775 "MediaMetadata.c"
}


#line 2231 "glib-2.0.vapi"
static char* g_time_format (struct tm *self, const char* format) {
#line 781 "MediaMetadata.c"
	char* result = NULL;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp0_;
	gchar* buffer;
#line 2231 "glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 789 "MediaMetadata.c"
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, _buffer_size_ = buffer_length1, _tmp0_);
#line 2233 "glib-2.0.vapi"
	strftime (buffer, buffer_length1, format, &(*self));
#line 793 "MediaMetadata.c"
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
#line 2234 "glib-2.0.vapi"
	return result;
#line 798 "MediaMetadata.c"
}


#line 113 "MediaMetadata.vala"
char* metadata_date_time_to_exif_date_time (time_t timestamp) {
#line 804 "MediaMetadata.c"
	char* result = NULL;
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	result = g_time_format ((_tmp1_ = (g_time_local (timestamp, &_tmp0_), _tmp0_), &_tmp1_), "%Y:%m:%d %H:%M:%S");
#line 114 "MediaMetadata.vala"
	return result;
#line 811 "MediaMetadata.c"
}


#line 117 "MediaMetadata.vala"
char* metadata_date_time_to_string (MetadataDateTime* self) {
#line 817 "MediaMetadata.c"
	char* result = NULL;
#line 117 "MediaMetadata.vala"
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
#line 821 "MediaMetadata.c"
	result = metadata_date_time_to_exif_date_time (self->priv->timestamp);
#line 118 "MediaMetadata.vala"
	return result;
#line 825 "MediaMetadata.c"
}


static void value_metadata_date_time_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_metadata_date_time_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		metadata_date_time_unref (value->data[0].v_pointer);
	}
}


static void value_metadata_date_time_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = metadata_date_time_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_metadata_date_time_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_metadata_date_time_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		MetadataDateTime* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = metadata_date_time_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_metadata_date_time_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	MetadataDateTime** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = metadata_date_time_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMetadataDateTime* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_METADATA_DATE_TIME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_metadata_date_time (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME), NULL);
	return value->data[0].v_pointer;
}


void value_set_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		metadata_date_time_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}


void value_take_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}


static void metadata_date_time_class_init (MetadataDateTimeClass * klass) {
	metadata_date_time_parent_class = g_type_class_peek_parent (klass);
	METADATA_DATE_TIME_CLASS (klass)->finalize = metadata_date_time_finalize;
	g_type_class_add_private (klass, sizeof (MetadataDateTimePrivate));
}


static void metadata_date_time_instance_init (MetadataDateTime * self) {
	self->priv = METADATA_DATE_TIME_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void metadata_date_time_finalize (MetadataDateTime* obj) {
	MetadataDateTime * self;
	self = METADATA_DATE_TIME (obj);
}


GType metadata_date_time_get_type (void) {
	static volatile gsize metadata_date_time_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_date_time_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_metadata_date_time_init, value_metadata_date_time_free_value, value_metadata_date_time_copy_value, value_metadata_date_time_peek_pointer, "p", value_metadata_date_time_collect_value, "p", value_metadata_date_time_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MetadataDateTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_date_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataDateTime), 0, (GInstanceInitFunc) metadata_date_time_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType metadata_date_time_type_id;
		metadata_date_time_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MetadataDateTime", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&metadata_date_time_type_id__volatile, metadata_date_time_type_id);
	}
	return metadata_date_time_type_id__volatile;
}


gpointer metadata_date_time_ref (gpointer instance) {
	MetadataDateTime* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void metadata_date_time_unref (gpointer instance) {
	MetadataDateTime* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		METADATA_DATE_TIME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




