/* MetadataWriter.c generated by valac 0.10.3, the Vala compiler
 * generated from MetadataWriter.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* MetadataWriter tracks LibraryPhotos for alterations to their metadata and commits those changes*/
/* in a timely manner to their backing files.  Because only the MetadataWriter knows when the*/
/* metadata has been properly committed, it is also responsible for updating the metadata-dirty*/
/* flag in Photo.  Thus, MetadataWriter should *always* be running, even if the user has turned off*/
/* the feature, so if they turn it on MetadataWriter can properly go out and update the backing*/
/* files.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <time.h>


#define TYPE_METADATA_WRITER (metadata_writer_get_type ())
#define METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_WRITER, MetadataWriter))
#define METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_WRITER, MetadataWriterClass))
#define IS_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_WRITER))
#define IS_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_WRITER))
#define METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_WRITER, MetadataWriterClass))

typedef struct _MetadataWriter MetadataWriter;
typedef struct _MetadataWriterClass MetadataWriterClass;
typedef struct _MetadataWriterPrivate MetadataWriterPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define METADATA_WRITER_TYPE_COMMIT_JOB (metadata_writer_commit_job_get_type ())
#define METADATA_WRITER_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob))
#define METADATA_WRITER_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))
#define METADATA_WRITER_IS_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_IS_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_COMMIT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))

typedef struct _MetadataWriterCommitJob MetadataWriterCommitJob;
typedef struct _MetadataWriterCommitJobClass MetadataWriterCommitJobClass;
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _timed_queue_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _MetadataWriterCommitJobPrivate MetadataWriterCommitJobPrivate;

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_RATING (rating_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())

struct _MetadataWriter {
	GObject parent_instance;
	MetadataWriterPrivate * priv;
};

struct _MetadataWriterClass {
	GObjectClass parent_class;
};

struct _MetadataWriterPrivate {
	Workers* workers;
	gboolean enabled;
	HashTimedQueue* dirty;
	GeeHashMap* pending;
	GeeHashSet* interested_photo_details;
	LibraryPhoto* ignore_photo_alteration;
	guint outstanding_total;
	guint outstanding_completed;
	gboolean closed;
	gint pause_count;
	GeeHashSet* importing_photos;
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _MetadataWriterCommitJob {
	BackgroundJob parent_instance;
	MetadataWriterCommitJobPrivate * priv;
	LibraryPhoto* photo;
	GeeSet* current_keywords;
	PhotoReimportMasterState* reimport_master_state;
	PhotoReimportEditableState* reimport_editable_state;
	GError* err;
};

struct _MetadataWriterCommitJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


static MetadataWriter* metadata_writer_instance;
static MetadataWriter* metadata_writer_instance = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
extern TagSourceCollection* tag_global;
static gpointer metadata_writer_commit_job_parent_class = NULL;
static gpointer metadata_writer_parent_class = NULL;

GType metadata_writer_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType photo_source_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType library_photo_get_type (void) G_GNUC_CONST;
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
static GType metadata_writer_commit_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define METADATA_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_WRITER, MetadataWriterPrivate))
enum  {
	METADATA_WRITER_DUMMY_PROPERTY
};
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
#define METADATA_WRITER_COMMIT_DELAY_MSEC ((guint) 3000)
#define METADATA_WRITER_COMMIT_SPACING_MSEC ((guint) 50)
static MetadataWriter* metadata_writer_new (void);
static MetadataWriter* metadata_writer_construct (GType object_type);
static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo);
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self, guint msec);
void metadata_writer_pause (MetadataWriter* self);
gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
Config* config_get_instance (void);
gboolean config_get_commit_metadata_to_masters (Config* self);
static void metadata_writer_on_config_bool_changed (MetadataWriter* self, const char* path, gboolean value);
static void _metadata_writer_on_config_bool_changed_config_bool_changed (Config* _sender, const char* path, gboolean value, gpointer self);
void metadata_writer_force_rescan (MetadataWriter* self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed);
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self);
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items);
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void metadata_writer_on_collection_frozen (MetadataWriter* self);
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self);
static void metadata_writer_on_collection_thawed (MetadataWriter* self);
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed);
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map);
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking);
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self);
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources);
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self);
gpointer application_ref (gpointer instance);
void application_unref (gpointer instance);
GParamSpec* param_spec_application (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_application (GValue* value, gpointer v_object);
void value_take_application (GValue* value, gpointer v_object);
gpointer value_get_application (const GValue* value);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
static void metadata_writer_on_application_exiting (MetadataWriter* self);
static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self);
gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_library_monitor_pool (GValue* value, gpointer v_object);
void value_take_library_monitor_pool (GValue* value, gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
LibraryMonitorPool* library_monitor_pool_get_instance (void);
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self);
static void metadata_writer_on_discovery_completed (MetadataWriter* self);
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self);
void metadata_writer_init (void);
void metadata_writer_terminate (void);
void metadata_writer_close (MetadataWriter* self);
MetadataWriter* metadata_writer_get_instance (void);
static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const char* reason);
GeeCollection* data_collection_get_all (DataCollection* self);
void timed_queue_pause (TimedQueue* self);
void metadata_writer_unpause (MetadataWriter* self);
void timed_queue_unpause (TimedQueue* self);
static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait);
#define CONFIG_PATH_SHOTWELL "/apps/shotwell/preferences"
#define CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS CONFIG_PATH_SHOTWELL "/files/commit_metadata"
static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo);
gboolean alteration_has_detail (Alteration* self, const char* subject, const char* detail);
GeeCollection* alteration_get_details (Alteration* self, const char* subject);
static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const char* reason, gboolean already_marked);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* tag_get_sources (Tag* self);
char* data_object_to_string (DataObject* self);
static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report);
gboolean photo_is_master_metadata_dirty (Photo* self);
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
void transaction_controller_begin (TransactionController* self);
GQuark database_error_quark (void);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void transaction_controller_commit (TransactionController* self);
void app_window_database_error (GError* err);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
void timed_queue_clear (TimedQueue* self);
void background_job_cancel (BackgroundJob* self);
void workers_wait_for_empty_queue (Workers* self);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_remove_first (TimedQueue* self, gconstpointer item);
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
char* data_object_get_name (DataObject* self);
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
void workers_enqueue (Workers* self, BackgroundJob* job);
static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j);
enum  {
	METADATA_WRITER_COMMIT_JOB_DUMMY_PROPERTY
};
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self);
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
static void metadata_writer_commit_job_real_execute (BackgroundJob* base);
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error);
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error);
GType photo_file_format_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_get_master_file_format (Photo* self);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata);
void library_monitor_blacklist_file (GFile* file, const char* reason);
GFile* media_source_get_master_file (MediaSource* self);
void library_monitor_unblacklist_file (GFile* file);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
gboolean photo_has_editable (Photo* self);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
GFile* photo_get_editable_file (Photo* self);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
char* media_source_get_title (MediaSource* self);
char* media_metadata_get_title (MediaMetadata* self);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const char* title, PhotoMetadataSetOption option);
GType rating_get_type (void) G_GNUC_CONST;
Rating media_source_get_rating (MediaSource* self);
Rating photo_metadata_get_rating (PhotoMetadata* self);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
time_t media_source_get_exposure_time (MediaSource* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
gboolean equal_sets (GeeSet* a, GeeSet* b);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_get_orientation (Photo* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const char* software, const char* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
static void metadata_writer_commit_job_finalize (BackgroundJob* obj);
static void metadata_writer_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const char* METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS[3] = {"name", "rating", "exposure-time"};

static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 555 "MetadataWriter.vala"
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self) {
#line 793 "MetadataWriter.c"
	metadata_writer_on_photo_dequeued (self, item);
}


#line 248 "MetadataWriter.vala"
static void _metadata_writer_on_config_bool_changed_config_bool_changed (Config* _sender, const char* path, gboolean value, gpointer self) {
#line 800 "MetadataWriter.c"
	metadata_writer_on_config_bool_changed (self, path, value);
}


#line 278 "MetadataWriter.vala"
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 807 "MetadataWriter.c"
	metadata_writer_on_importing_photos (self, media);
}


#line 282 "MetadataWriter.vala"
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 814 "MetadataWriter.c"
	metadata_writer_on_photos_imported (self, media);
}


#line 286 "MetadataWriter.vala"
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self) {
#line 821 "MetadataWriter.c"
	metadata_writer_on_photos_added_removed (self, added, removed);
}


#line 303 "MetadataWriter.vala"
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 828 "MetadataWriter.c"
	metadata_writer_on_photos_altered (self, items);
}


#line 270 "MetadataWriter.vala"
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self) {
#line 835 "MetadataWriter.c"
	metadata_writer_on_collection_frozen (self);
}


#line 274 "MetadataWriter.vala"
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 842 "MetadataWriter.c"
	metadata_writer_on_collection_thawed (self);
}


#line 347 "MetadataWriter.vala"
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self) {
#line 849 "MetadataWriter.c"
	metadata_writer_on_photos_destroyed (self, destroyed);
}


#line 355 "MetadataWriter.vala"
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 856 "MetadataWriter.c"
	metadata_writer_on_tags_altered (self, items);
}


#line 375 "MetadataWriter.vala"
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self) {
#line 863 "MetadataWriter.c"
	metadata_writer_on_tag_contents_altered (self, container, added, relinked, removed, unlinked);
}


#line 402 "MetadataWriter.vala"
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self) {
#line 870 "MetadataWriter.c"
	metadata_writer_on_tag_backlink_removed (self, container, sources);
}


#line 262 "MetadataWriter.vala"
static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self) {
#line 877 "MetadataWriter.c"
	metadata_writer_on_application_exiting (self);
}


#line 266 "MetadataWriter.vala"
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self) {
#line 884 "MetadataWriter.c"
	metadata_writer_on_discovery_completed (self);
}


#line 142 "MetadataWriter.vala"
static MetadataWriter* metadata_writer_construct (GType object_type) {
#line 891 "MetadataWriter.c"
	MetadataWriter * self = NULL;
	HashTimedQueue* _tmp0_;
	Config* _tmp1_;
	Config* _tmp2_;
	Application* _tmp3_;
	LibraryMonitorPool* _tmp4_;
	LibraryMonitor* _tmp5_;
#line 142 "MetadataWriter.vala"
	self = (MetadataWriter*) g_object_new (object_type, NULL);
#line 143 "MetadataWriter.vala"
	self->priv->dirty = (_tmp0_ = hash_timed_queue_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_COMMIT_DELAY_MSEC, _metadata_writer_on_photo_dequeued_dequeued_callback, self, NULL, NULL, G_PRIORITY_DEFAULT), _timed_queue_unref0 (self->priv->dirty), _tmp0_);
#line 144 "MetadataWriter.vala"
	timed_queue_set_dequeue_spacing_msec (TIMED_QUEUE (self->priv->dirty), METADATA_WRITER_COMMIT_SPACING_MSEC);
#line 149 "MetadataWriter.vala"
	metadata_writer_pause (self);
#line 907 "MetadataWriter.c"
	{
		const char** detail_collection;
		int detail_collection_length1;
		int detail_it;
#line 152 "MetadataWriter.vala"
		detail_collection = METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS;
#line 914 "MetadataWriter.c"
		detail_collection_length1 = G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS);
		for (detail_it = 0; detail_it < G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS); detail_it = detail_it + 1) {
			char* detail;
			detail = g_strdup (detail_collection[detail_it]);
			{
#line 153 "MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->interested_photo_details), detail);
#line 922 "MetadataWriter.c"
				_g_free0 (detail);
			}
		}
	}
#line 156 "MetadataWriter.vala"
	self->priv->enabled = config_get_commit_metadata_to_masters (_tmp1_ = config_get_instance ());
#line 929 "MetadataWriter.c"
	_config_unref0 (_tmp1_);
#line 157 "MetadataWriter.vala"
	g_signal_connect_object (_tmp2_ = config_get_instance (), "bool-changed", (GCallback) _metadata_writer_on_config_bool_changed_config_bool_changed, self, 0);
#line 933 "MetadataWriter.c"
	_config_unref0 (_tmp2_);
#line 160 "MetadataWriter.vala"
	metadata_writer_force_rescan (self);
#line 162 "MetadataWriter.vala"
	g_signal_connect_object (MEDIA_SOURCE_COLLECTION (library_photo_global), "media-import-starting", (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self, 0);
#line 163 "MetadataWriter.vala"
	g_signal_connect_object (MEDIA_SOURCE_COLLECTION (library_photo_global), "media-import-completed", (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self, 0);
#line 164 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (library_photo_global), "contents-altered", (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self, 0);
#line 165 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (library_photo_global), "items-altered", (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self, 0);
#line 166 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (library_photo_global), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 167 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (library_photo_global), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 168 "MetadataWriter.vala"
	g_signal_connect_object (SOURCE_COLLECTION (library_photo_global), "items-destroyed", (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self, 0);
#line 170 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (tag_global), "items-altered", (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self, 0);
#line 171 "MetadataWriter.vala"
	g_signal_connect_object (CONTAINER_SOURCE_COLLECTION (tag_global), "container-contents-altered", (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 172 "MetadataWriter.vala"
	g_signal_connect_object (CONTAINER_SOURCE_COLLECTION (tag_global), "backlink-to-container-removed", (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self, 0);
#line 173 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (tag_global), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 174 "MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (tag_global), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 176 "MetadataWriter.vala"
	g_signal_connect_object (_tmp3_ = application_get_instance (), "exiting", (GCallback) _metadata_writer_on_application_exiting_application_exiting, self, 0);
#line 963 "MetadataWriter.c"
	_application_unref0 (_tmp3_);
#line 178 "MetadataWriter.vala"
	g_signal_connect_object (DIRECTORY_MONITOR (_tmp5_ = library_monitor_pool_get_monitor (_tmp4_ = library_monitor_pool_get_instance ())), "discovery-completed", (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self, 0);
#line 967 "MetadataWriter.c"
	_g_object_unref0 (_tmp5_);
	_library_monitor_pool_unref0 (_tmp4_);
	return self;
}


#line 142 "MetadataWriter.vala"
static MetadataWriter* metadata_writer_new (void) {
#line 142 "MetadataWriter.vala"
	return metadata_writer_construct (TYPE_METADATA_WRITER);
#line 978 "MetadataWriter.c"
}


#line 203 "MetadataWriter.vala"
void metadata_writer_init (void) {
#line 984 "MetadataWriter.c"
	MetadataWriter* _tmp0_;
#line 204 "MetadataWriter.vala"
	metadata_writer_instance = (_tmp0_ = metadata_writer_new (), _g_object_unref0 (metadata_writer_instance), _tmp0_);
#line 988 "MetadataWriter.c"
}


#line 207 "MetadataWriter.vala"
void metadata_writer_terminate (void) {
#line 994 "MetadataWriter.c"
	MetadataWriter* _tmp0_;
#line 208 "MetadataWriter.vala"
	if (metadata_writer_instance != NULL) {
#line 209 "MetadataWriter.vala"
		metadata_writer_close (metadata_writer_instance);
#line 1000 "MetadataWriter.c"
	}
#line 211 "MetadataWriter.vala"
	metadata_writer_instance = (_tmp0_ = NULL, _g_object_unref0 (metadata_writer_instance), _tmp0_);
#line 1004 "MetadataWriter.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 214 "MetadataWriter.vala"
MetadataWriter* metadata_writer_get_instance (void) {
#line 1015 "MetadataWriter.c"
	MetadataWriter* result = NULL;
	result = _g_object_ref0 (metadata_writer_instance);
#line 215 "MetadataWriter.vala"
	return result;
#line 1020 "MetadataWriter.c"
}


#line 219 "MetadataWriter.vala"
void metadata_writer_force_rescan (MetadataWriter* self) {
#line 1026 "MetadataWriter.c"
	GeeCollection* _tmp0_;
#line 219 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 220 "MetadataWriter.vala"
	metadata_writer_schedule_if_dirty (self, GEE_ITERABLE (_tmp0_ = GEE_COLLECTION (data_collection_get_all (DATA_COLLECTION (library_photo_global)))), "force rescan");
#line 1032 "MetadataWriter.c"
	_g_object_unref0 (_tmp0_);
}


#line 223 "MetadataWriter.vala"
void metadata_writer_pause (MetadataWriter* self) {
#line 223 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 224 "MetadataWriter.vala"
	if ((self->priv->pause_count++) != 0) {
#line 225 "MetadataWriter.vala"
		return;
#line 1045 "MetadataWriter.c"
	}
#line 227 "MetadataWriter.vala"
	timed_queue_pause (TIMED_QUEUE (self->priv->dirty));
#line 229 "MetadataWriter.vala"
	g_signal_emit_by_name (self, "progress", (guint) 0, (guint) 0);
#line 1051 "MetadataWriter.c"
}


#line 232 "MetadataWriter.vala"
void metadata_writer_unpause (MetadataWriter* self) {
#line 1057 "MetadataWriter.c"
	gboolean _tmp0_ = FALSE;
#line 232 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 233 "MetadataWriter.vala"
	if (self->priv->pause_count == 0) {
#line 233 "MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 1065 "MetadataWriter.c"
	} else {
#line 233 "MetadataWriter.vala"
		_tmp0_ = (self->priv->pause_count = self->priv->pause_count - 1) != 0;
#line 1069 "MetadataWriter.c"
	}
#line 233 "MetadataWriter.vala"
	if (_tmp0_) {
#line 234 "MetadataWriter.vala"
		return;
#line 1075 "MetadataWriter.c"
	}
#line 236 "MetadataWriter.vala"
	timed_queue_unpause (TIMED_QUEUE (self->priv->dirty));
#line 1079 "MetadataWriter.c"
}


#line 239 "MetadataWriter.vala"
void metadata_writer_close (MetadataWriter* self) {
#line 239 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 240 "MetadataWriter.vala"
	if (self->priv->closed) {
#line 241 "MetadataWriter.vala"
		return;
#line 1091 "MetadataWriter.c"
	}
#line 243 "MetadataWriter.vala"
	metadata_writer_cancel_all (self, TRUE);
#line 245 "MetadataWriter.vala"
	self->priv->closed = TRUE;
#line 1097 "MetadataWriter.c"
}


#line 248 "MetadataWriter.vala"
static void metadata_writer_on_config_bool_changed (MetadataWriter* self, const char* path, gboolean value) {
#line 248 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 248 "MetadataWriter.vala"
	g_return_if_fail (path != NULL);
#line 249 "MetadataWriter.vala"
	if (_vala_strcmp0 (path, CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS) != 0) {
#line 250 "MetadataWriter.vala"
		return;
#line 1111 "MetadataWriter.c"
	}
#line 252 "MetadataWriter.vala"
	if (self->priv->enabled == value) {
#line 253 "MetadataWriter.vala"
		return;
#line 1117 "MetadataWriter.c"
	}
#line 255 "MetadataWriter.vala"
	self->priv->enabled = value;
#line 256 "MetadataWriter.vala"
	if (self->priv->enabled) {
#line 257 "MetadataWriter.vala"
		metadata_writer_force_rescan (self);
#line 1125 "MetadataWriter.c"
	} else {
#line 259 "MetadataWriter.vala"
		metadata_writer_cancel_all (self, FALSE);
#line 1129 "MetadataWriter.c"
	}
}


#line 262 "MetadataWriter.vala"
static void metadata_writer_on_application_exiting (MetadataWriter* self) {
#line 262 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 263 "MetadataWriter.vala"
	metadata_writer_close (self);
#line 1140 "MetadataWriter.c"
}


#line 266 "MetadataWriter.vala"
static void metadata_writer_on_discovery_completed (MetadataWriter* self) {
#line 266 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 267 "MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1150 "MetadataWriter.c"
}


#line 270 "MetadataWriter.vala"
static void metadata_writer_on_collection_frozen (MetadataWriter* self) {
#line 270 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 271 "MetadataWriter.vala"
	metadata_writer_pause (self);
#line 1160 "MetadataWriter.c"
}


#line 274 "MetadataWriter.vala"
static void metadata_writer_on_collection_thawed (MetadataWriter* self) {
#line 274 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 275 "MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1170 "MetadataWriter.c"
}


#line 278 "MetadataWriter.vala"
static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources) {
#line 278 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 278 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 279 "MetadataWriter.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->importing_photos), GEE_COLLECTION (media_sources));
#line 1182 "MetadataWriter.c"
}


#line 282 "MetadataWriter.vala"
static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources) {
#line 282 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 282 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 283 "MetadataWriter.vala"
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->importing_photos), GEE_COLLECTION (media_sources));
#line 1194 "MetadataWriter.c"
}


#line 286 "MetadataWriter.vala"
static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed) {
#line 1200 "MetadataWriter.c"
	gboolean _tmp0_ = FALSE;
#line 286 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 286 "MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 286 "MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 289 "MetadataWriter.vala"
	if (added != NULL) {
#line 289 "MetadataWriter.vala"
		_tmp0_ = self->priv->enabled;
#line 1212 "MetadataWriter.c"
	} else {
#line 289 "MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 1216 "MetadataWriter.c"
	}
#line 289 "MetadataWriter.vala"
	if (_tmp0_) {
#line 290 "MetadataWriter.vala"
		metadata_writer_schedule_if_dirty (self, GEE_ITERABLE (added), "added to LibraryPhoto.global");
#line 1222 "MetadataWriter.c"
	}
#line 293 "MetadataWriter.vala"
	if (removed != NULL) {
#line 1226 "MetadataWriter.c"
		gboolean cancelled;
#line 294 "MetadataWriter.vala"
		cancelled = FALSE;
#line 1230 "MetadataWriter.c"
		{
			GeeIterator* _object_it;
#line 295 "MetadataWriter.vala"
			_object_it = gee_iterable_iterator (removed);
#line 295 "MetadataWriter.vala"
			while (TRUE) {
#line 1237 "MetadataWriter.c"
				DataObject* object;
				gboolean _tmp1_ = FALSE;
#line 295 "MetadataWriter.vala"
				if (!gee_iterator_next (_object_it)) {
#line 295 "MetadataWriter.vala"
					break;
#line 1244 "MetadataWriter.c"
				}
#line 295 "MetadataWriter.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 296 "MetadataWriter.vala"
				if (metadata_writer_cancel_job (self, LIBRARY_PHOTO (object))) {
#line 296 "MetadataWriter.vala"
					_tmp1_ = TRUE;
#line 1252 "MetadataWriter.c"
				} else {
#line 296 "MetadataWriter.vala"
					_tmp1_ = cancelled;
#line 1256 "MetadataWriter.c"
				}
#line 296 "MetadataWriter.vala"
				cancelled = _tmp1_;
#line 1260 "MetadataWriter.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 298 "MetadataWriter.vala"
		if (cancelled) {
#line 299 "MetadataWriter.vala"
			g_signal_emit_by_name (self, "progress", self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1269 "MetadataWriter.c"
		}
	}
}


#line 303 "MetadataWriter.vala"
static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items) {
#line 1277 "MetadataWriter.c"
	GeeHashSet* photos;
#line 303 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 303 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 304 "MetadataWriter.vala"
	photos = NULL;
#line 1285 "MetadataWriter.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 305 "MetadataWriter.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (items))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 305 "MetadataWriter.vala"
		while (TRUE) {
#line 1294 "MetadataWriter.c"
			DataObject* object;
			LibraryPhoto* photo;
			Alteration* alteration;
			GeeCollection* details;
#line 305 "MetadataWriter.vala"
			if (!gee_iterator_next (_object_it)) {
#line 305 "MetadataWriter.vala"
				break;
#line 1303 "MetadataWriter.c"
			}
#line 305 "MetadataWriter.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 306 "MetadataWriter.vala"
			photo = _g_object_ref0 (LIBRARY_PHOTO (object));
#line 310 "MetadataWriter.vala"
			if (photo == self->priv->ignore_photo_alteration) {
#line 1311 "MetadataWriter.c"
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
#line 311 "MetadataWriter.vala"
				continue;
#line 1316 "MetadataWriter.c"
			}
#line 313 "MetadataWriter.vala"
			alteration = (Alteration*) gee_map_get (items, object);
#line 316 "MetadataWriter.vala"
			if (alteration_has_detail (alteration, "image", "orientation")) {
#line 317 "MetadataWriter.vala"
				if (photos == NULL) {
#line 1324 "MetadataWriter.c"
					GeeHashSet* _tmp2_;
#line 318 "MetadataWriter.vala"
					photos = (_tmp2_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (photos), _tmp2_);
#line 1328 "MetadataWriter.c"
				}
#line 320 "MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (photos), photo);
#line 1332 "MetadataWriter.c"
				_alteration_unref0 (alteration);
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
#line 322 "MetadataWriter.vala"
				continue;
#line 1338 "MetadataWriter.c"
			}
#line 326 "MetadataWriter.vala"
			details = alteration_get_details (alteration, "metadata");
#line 327 "MetadataWriter.vala"
			if (details == NULL) {
#line 1344 "MetadataWriter.c"
				_g_object_unref0 (details);
				_alteration_unref0 (alteration);
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
#line 328 "MetadataWriter.vala"
				continue;
#line 1351 "MetadataWriter.c"
			}
			{
				GeeIterator* _detail_it;
#line 331 "MetadataWriter.vala"
				_detail_it = gee_iterable_iterator (GEE_ITERABLE (details));
#line 331 "MetadataWriter.vala"
				while (TRUE) {
#line 1359 "MetadataWriter.c"
					char* detail;
#line 331 "MetadataWriter.vala"
					if (!gee_iterator_next (_detail_it)) {
#line 331 "MetadataWriter.vala"
						break;
#line 1365 "MetadataWriter.c"
					}
#line 331 "MetadataWriter.vala"
					detail = (char*) gee_iterator_get (_detail_it);
#line 332 "MetadataWriter.vala"
					if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->interested_photo_details), detail)) {
#line 333 "MetadataWriter.vala"
						if (photos == NULL) {
#line 1373 "MetadataWriter.c"
							GeeHashSet* _tmp3_;
#line 334 "MetadataWriter.vala"
							photos = (_tmp3_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (photos), _tmp3_);
#line 1377 "MetadataWriter.c"
						}
#line 336 "MetadataWriter.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (photos), photo);
#line 1381 "MetadataWriter.c"
						_g_free0 (detail);
#line 338 "MetadataWriter.vala"
						break;
#line 1385 "MetadataWriter.c"
					}
					_g_free0 (detail);
				}
				_g_object_unref0 (_detail_it);
			}
			_g_object_unref0 (details);
			_alteration_unref0 (alteration);
			_g_object_unref0 (photo);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 343 "MetadataWriter.vala"
	if (photos != NULL) {
#line 344 "MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (photos), "alteration", FALSE);
#line 1402 "MetadataWriter.c"
	}
	_g_object_unref0 (photos);
}


#line 347 "MetadataWriter.vala"
static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed) {
#line 347 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 347 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1414 "MetadataWriter.c"
	{
		GeeIterator* _source_it;
#line 348 "MetadataWriter.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (destroyed));
#line 348 "MetadataWriter.vala"
		while (TRUE) {
#line 1421 "MetadataWriter.c"
			DataSource* source;
			LibraryPhoto* photo;
#line 348 "MetadataWriter.vala"
			if (!gee_iterator_next (_source_it)) {
#line 348 "MetadataWriter.vala"
				break;
#line 1428 "MetadataWriter.c"
			}
#line 348 "MetadataWriter.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 349 "MetadataWriter.vala"
			photo = _g_object_ref0 (LIBRARY_PHOTO (source));
#line 350 "MetadataWriter.vala"
			metadata_writer_cancel_job (self, photo);
#line 351 "MetadataWriter.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->importing_photos), photo);
#line 1438 "MetadataWriter.c"
			_g_object_unref0 (photo);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 355 "MetadataWriter.vala"
static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map) {
#line 1449 "MetadataWriter.c"
	GeeHashSet* photos;
#line 355 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 355 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 356 "MetadataWriter.vala"
	photos = NULL;
#line 1457 "MetadataWriter.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 357 "MetadataWriter.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (map))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 357 "MetadataWriter.vala"
		while (TRUE) {
#line 1466 "MetadataWriter.c"
			DataObject* object;
			Alteration* _tmp2_;
			gboolean _tmp3_;
#line 357 "MetadataWriter.vala"
			if (!gee_iterator_next (_object_it)) {
#line 357 "MetadataWriter.vala"
				break;
#line 1474 "MetadataWriter.c"
			}
#line 357 "MetadataWriter.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 358 "MetadataWriter.vala"
			if ((_tmp3_ = !alteration_has_detail (_tmp2_ = (Alteration*) gee_map_get (map, object), "metadata", "name"), _alteration_unref0 (_tmp2_), _tmp3_)) {
#line 1480 "MetadataWriter.c"
				_g_object_unref0 (object);
#line 359 "MetadataWriter.vala"
				continue;
#line 1484 "MetadataWriter.c"
			}
#line 361 "MetadataWriter.vala"
			if (photos == NULL) {
#line 1488 "MetadataWriter.c"
				GeeHashSet* _tmp4_;
#line 362 "MetadataWriter.vala"
				photos = (_tmp4_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (photos), _tmp4_);
#line 1492 "MetadataWriter.c"
			}
			{
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _media_it;
#line 364 "MetadataWriter.vala"
				_media_it = (_tmp6_ = gee_iterable_iterator (GEE_ITERABLE (_tmp5_ = tag_get_sources (TAG (object)))), _g_object_unref0 (_tmp5_), _tmp6_);
#line 364 "MetadataWriter.vala"
				while (TRUE) {
#line 1502 "MetadataWriter.c"
					MediaSource* media;
					MediaSource* _tmp7_;
					LibraryPhoto* photo;
#line 364 "MetadataWriter.vala"
					if (!gee_iterator_next (_media_it)) {
#line 364 "MetadataWriter.vala"
						break;
#line 1510 "MetadataWriter.c"
					}
#line 364 "MetadataWriter.vala"
					media = (MediaSource*) gee_iterator_get (_media_it);
#line 365 "MetadataWriter.vala"
					photo = _g_object_ref0 ((_tmp7_ = media, IS_LIBRARY_PHOTO (_tmp7_) ? ((LibraryPhoto*) _tmp7_) : NULL));
#line 366 "MetadataWriter.vala"
					if (photo != NULL) {
#line 367 "MetadataWriter.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (photos), photo);
#line 1520 "MetadataWriter.c"
					}
					_g_object_unref0 (photo);
					_g_object_unref0 (media);
				}
				_g_object_unref0 (_media_it);
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 371 "MetadataWriter.vala"
	if (photos != NULL) {
#line 372 "MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (photos), "tag renamed", FALSE);
#line 1535 "MetadataWriter.c"
	}
	_g_object_unref0 (photos);
}


#line 375 "MetadataWriter.vala"
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking) {
#line 1543 "MetadataWriter.c"
	Tag* tag;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 375 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 375 "MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 375 "MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 375 "MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 377 "MetadataWriter.vala"
	tag = _g_object_ref0 (TAG (container));
#line 379 "MetadataWriter.vala"
	if (added != NULL) {
#line 379 "MetadataWriter.vala"
		_tmp0_ = !relinking;
#line 1561 "MetadataWriter.c"
	} else {
#line 379 "MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 1565 "MetadataWriter.c"
	}
#line 379 "MetadataWriter.vala"
	if (_tmp0_) {
#line 1569 "MetadataWriter.c"
		GeeArrayList* added_photos;
		char* _tmp3_;
		char* _tmp4_;
#line 380 "MetadataWriter.vala"
		added_photos = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1575 "MetadataWriter.c"
		{
			GeeIterator* _source_it;
#line 381 "MetadataWriter.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (added));
#line 381 "MetadataWriter.vala"
			while (TRUE) {
#line 1582 "MetadataWriter.c"
				DataSource* source;
				DataSource* _tmp1_;
				LibraryPhoto* photo;
				gboolean _tmp2_ = FALSE;
#line 381 "MetadataWriter.vala"
				if (!gee_iterator_next (_source_it)) {
#line 381 "MetadataWriter.vala"
					break;
#line 1591 "MetadataWriter.c"
				}
#line 381 "MetadataWriter.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 382 "MetadataWriter.vala"
				photo = _g_object_ref0 ((_tmp1_ = source, IS_LIBRARY_PHOTO (_tmp1_) ? ((LibraryPhoto*) _tmp1_) : NULL));
#line 383 "MetadataWriter.vala"
				if (photo != NULL) {
#line 383 "MetadataWriter.vala"
					_tmp2_ = !gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->importing_photos), photo);
#line 1601 "MetadataWriter.c"
				} else {
#line 383 "MetadataWriter.vala"
					_tmp2_ = FALSE;
#line 1605 "MetadataWriter.c"
				}
#line 383 "MetadataWriter.vala"
				if (_tmp2_) {
#line 384 "MetadataWriter.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_photos), photo);
#line 1611 "MetadataWriter.c"
				}
				_g_object_unref0 (photo);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 387 "MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (added_photos), _tmp4_ = g_strdup_printf ("added to %s", _tmp3_ = data_object_to_string (DATA_OBJECT (tag))), FALSE);
#line 1620 "MetadataWriter.c"
		_g_free0 (_tmp4_);
		_g_free0 (_tmp3_);
		_g_object_unref0 (added_photos);
	}
#line 390 "MetadataWriter.vala"
	if (removed != NULL) {
#line 390 "MetadataWriter.vala"
		_tmp5_ = !unlinking;
#line 1629 "MetadataWriter.c"
	} else {
#line 390 "MetadataWriter.vala"
		_tmp5_ = FALSE;
#line 1633 "MetadataWriter.c"
	}
#line 390 "MetadataWriter.vala"
	if (_tmp5_) {
#line 1637 "MetadataWriter.c"
		GeeArrayList* removed_photos;
		char* _tmp7_;
		char* _tmp8_;
#line 391 "MetadataWriter.vala"
		removed_photos = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1643 "MetadataWriter.c"
		{
			GeeIterator* _source_it;
#line 392 "MetadataWriter.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (removed));
#line 392 "MetadataWriter.vala"
			while (TRUE) {
#line 1650 "MetadataWriter.c"
				DataSource* source;
				DataSource* _tmp6_;
				LibraryPhoto* photo;
#line 392 "MetadataWriter.vala"
				if (!gee_iterator_next (_source_it)) {
#line 392 "MetadataWriter.vala"
					break;
#line 1658 "MetadataWriter.c"
				}
#line 392 "MetadataWriter.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 393 "MetadataWriter.vala"
				photo = _g_object_ref0 ((_tmp6_ = source, IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL));
#line 394 "MetadataWriter.vala"
				if (photo != NULL) {
#line 395 "MetadataWriter.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (removed_photos), photo);
#line 1668 "MetadataWriter.c"
				}
				_g_object_unref0 (photo);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 398 "MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (removed_photos), _tmp8_ = g_strdup_printf ("removed from %s", _tmp7_ = data_object_to_string (DATA_OBJECT (tag))), FALSE);
#line 1677 "MetadataWriter.c"
		_g_free0 (_tmp8_);
		_g_free0 (_tmp7_);
		_g_object_unref0 (removed_photos);
	}
	_g_object_unref0 (tag);
}


#line 402 "MetadataWriter.vala"
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources) {
#line 1688 "MetadataWriter.c"
	GeeArrayList* photos;
	char* _tmp1_;
	char* _tmp2_;
#line 402 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 402 "MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 402 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 403 "MetadataWriter.vala"
	photos = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1700 "MetadataWriter.c"
	{
		GeeIterator* _source_it;
#line 404 "MetadataWriter.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (sources));
#line 404 "MetadataWriter.vala"
		while (TRUE) {
#line 1707 "MetadataWriter.c"
			DataSource* source;
			DataSource* _tmp0_;
			LibraryPhoto* photo;
#line 404 "MetadataWriter.vala"
			if (!gee_iterator_next (_source_it)) {
#line 404 "MetadataWriter.vala"
				break;
#line 1715 "MetadataWriter.c"
			}
#line 404 "MetadataWriter.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 405 "MetadataWriter.vala"
			photo = _g_object_ref0 ((_tmp0_ = source, IS_LIBRARY_PHOTO (_tmp0_) ? ((LibraryPhoto*) _tmp0_) : NULL));
#line 406 "MetadataWriter.vala"
			if (photo != NULL) {
#line 407 "MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (photos), photo);
#line 1725 "MetadataWriter.c"
			}
			_g_object_unref0 (photo);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 410 "MetadataWriter.vala"
	metadata_writer_photos_are_dirty (self, GEE_COLLECTION (photos), _tmp2_ = g_strdup_printf ("backlink removed from %s", _tmp1_ = data_object_to_string (DATA_OBJECT (container))), FALSE);
#line 1734 "MetadataWriter.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_object_unref0 (photos);
}


#line 413 "MetadataWriter.vala"
static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report) {
#line 413 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 414 "MetadataWriter.vala"
	self->priv->outstanding_total = self->priv->outstanding_total + ((guint) count);
#line 420 "MetadataWriter.vala"
	if (report) {
#line 421 "MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1751 "MetadataWriter.c"
	}
}


#line 424 "MetadataWriter.vala"
static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report) {
#line 1758 "MetadataWriter.c"
	guint _tmp0_ = 0U;
#line 424 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 425 "MetadataWriter.vala"
	if (self->priv->outstanding_total >= count) {
#line 425 "MetadataWriter.vala"
		_tmp0_ = self->priv->outstanding_total - count;
#line 1766 "MetadataWriter.c"
	} else {
#line 425 "MetadataWriter.vala"
		_tmp0_ = (guint) 0;
#line 1770 "MetadataWriter.c"
	}
#line 425 "MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_;
#line 426 "MetadataWriter.vala"
	if (self->priv->outstanding_completed >= self->priv->outstanding_total) {
#line 427 "MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 428 "MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 1780 "MetadataWriter.c"
	}
#line 435 "MetadataWriter.vala"
	if (report) {
#line 436 "MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1786 "MetadataWriter.c"
	}
}


#line 439 "MetadataWriter.vala"
static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report) {
#line 439 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 440 "MetadataWriter.vala"
	self->priv->outstanding_completed = self->priv->outstanding_completed + ((guint) count);
#line 441 "MetadataWriter.vala"
	if (self->priv->outstanding_completed >= self->priv->outstanding_total) {
#line 442 "MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 443 "MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 1803 "MetadataWriter.c"
	}
#line 450 "MetadataWriter.vala"
	if (report) {
#line 451 "MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", self->priv->outstanding_completed, self->priv->outstanding_total);
#line 1809 "MetadataWriter.c"
	}
}


#line 454 "MetadataWriter.vala"
static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const char* reason) {
#line 1816 "MetadataWriter.c"
	GeeArrayList* photos;
#line 454 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 454 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_ITERABLE (media_sources));
#line 454 "MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 455 "MetadataWriter.vala"
	photos = NULL;
#line 1826 "MetadataWriter.c"
	{
		GeeIterator* _media_it;
#line 456 "MetadataWriter.vala"
		_media_it = gee_iterable_iterator (media_sources);
#line 456 "MetadataWriter.vala"
		while (TRUE) {
#line 1833 "MetadataWriter.c"
			MediaSource* media;
			MediaSource* _tmp0_;
			LibraryPhoto* photo;
#line 456 "MetadataWriter.vala"
			if (!gee_iterator_next (_media_it)) {
#line 456 "MetadataWriter.vala"
				break;
#line 1841 "MetadataWriter.c"
			}
#line 456 "MetadataWriter.vala"
			media = (MediaSource*) gee_iterator_get (_media_it);
#line 457 "MetadataWriter.vala"
			photo = _g_object_ref0 ((_tmp0_ = media, IS_LIBRARY_PHOTO (_tmp0_) ? ((LibraryPhoto*) _tmp0_) : NULL));
#line 458 "MetadataWriter.vala"
			if (photo == NULL) {
#line 1849 "MetadataWriter.c"
				_g_object_unref0 (photo);
				_g_object_unref0 (media);
#line 459 "MetadataWriter.vala"
				continue;
#line 1854 "MetadataWriter.c"
			}
#line 462 "MetadataWriter.vala"
			if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->importing_photos), photo)) {
#line 1858 "MetadataWriter.c"
				_g_object_unref0 (photo);
				_g_object_unref0 (media);
#line 463 "MetadataWriter.vala"
				continue;
#line 1863 "MetadataWriter.c"
			}
#line 465 "MetadataWriter.vala"
			if (photo_is_master_metadata_dirty (PHOTO (photo))) {
#line 466 "MetadataWriter.vala"
				if (photos == NULL) {
#line 1869 "MetadataWriter.c"
					GeeArrayList* _tmp1_;
#line 467 "MetadataWriter.vala"
					photos = (_tmp1_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (photos), _tmp1_);
#line 1873 "MetadataWriter.c"
				}
#line 469 "MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (photos), photo);
#line 1877 "MetadataWriter.c"
			}
			_g_object_unref0 (photo);
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
#line 473 "MetadataWriter.vala"
	if (photos != NULL) {
#line 474 "MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (photos), reason, TRUE);
#line 1888 "MetadataWriter.c"
	}
	_g_object_unref0 (photos);
}


#line 478 "MetadataWriter.vala"
static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const char* reason, gboolean already_marked) {
#line 1896 "MetadataWriter.c"
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 478 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 478 "MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (photos));
#line 478 "MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 479 "MetadataWriter.vala"
	if (gee_collection_get_size (photos) == 0) {
#line 480 "MetadataWriter.vala"
		return;
#line 1909 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it;
#line 483 "MetadataWriter.vala"
		_photo_it = gee_iterable_iterator (GEE_ITERABLE (photos));
#line 483 "MetadataWriter.vala"
		while (TRUE) {
#line 1917 "MetadataWriter.c"
			LibraryPhoto* photo;
#line 483 "MetadataWriter.vala"
			if (!gee_iterator_next (_photo_it)) {
#line 483 "MetadataWriter.vala"
				break;
#line 1923 "MetadataWriter.c"
			}
#line 483 "MetadataWriter.vala"
			photo = (LibraryPhoto*) gee_iterator_get (_photo_it);
#line 484 "MetadataWriter.vala"
			metadata_writer_cancel_job (self, photo);
#line 1929 "MetadataWriter.c"
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
#line 487 "MetadataWriter.vala"
	if (!already_marked) {
#line 1936 "MetadataWriter.c"
		{
#line 489 "MetadataWriter.vala"
			transaction_controller_begin (media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (library_photo_global)));
#line 1940 "MetadataWriter.c"
			{
				GeeIterator* _photo_it;
#line 491 "MetadataWriter.vala"
				_photo_it = gee_iterable_iterator (GEE_ITERABLE (photos));
#line 491 "MetadataWriter.vala"
				while (TRUE) {
#line 1947 "MetadataWriter.c"
					LibraryPhoto* photo;
#line 491 "MetadataWriter.vala"
					if (!gee_iterator_next (_photo_it)) {
#line 491 "MetadataWriter.vala"
						break;
#line 1953 "MetadataWriter.c"
					}
#line 491 "MetadataWriter.vala"
					photo = (LibraryPhoto*) gee_iterator_get (_photo_it);
#line 492 "MetadataWriter.vala"
					photo_set_master_metadata_dirty (PHOTO (photo), TRUE, &_inner_error_);
#line 1959 "MetadataWriter.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (photo);
						_g_object_unref0 (_photo_it);
						goto __catch418_g_error;
					}
					_g_object_unref0 (photo);
				}
				_g_object_unref0 (_photo_it);
			}
#line 494 "MetadataWriter.vala"
			transaction_controller_commit (media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (library_photo_global)));
#line 1971 "MetadataWriter.c"
		}
		goto __finally418;
		__catch418_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
#line 496 "MetadataWriter.vala"
				if (err->domain == DATABASE_ERROR) {
#line 497 "MetadataWriter.vala"
					app_window_database_error ((GError*) err);
#line 1984 "MetadataWriter.c"
				} else {
#line 499 "MetadataWriter.vala"
					g_error ("MetadataWriter.vala:499: Unable to mark metadata as dirty: %s", err->message);
#line 1988 "MetadataWriter.c"
				}
				_g_error_free0 (err);
			}
		}
		__finally418:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 505 "MetadataWriter.vala"
	if (self->priv->closed) {
#line 505 "MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 2004 "MetadataWriter.c"
	} else {
#line 505 "MetadataWriter.vala"
		_tmp0_ = !self->priv->enabled;
#line 2008 "MetadataWriter.c"
	}
#line 505 "MetadataWriter.vala"
	if (_tmp0_) {
#line 506 "MetadataWriter.vala"
		return;
#line 2014 "MetadataWriter.c"
	}
	{
		GeeIterator* _photo_it;
#line 512 "MetadataWriter.vala"
		_photo_it = gee_iterable_iterator (GEE_ITERABLE (photos));
#line 512 "MetadataWriter.vala"
		while (TRUE) {
#line 2022 "MetadataWriter.c"
			LibraryPhoto* photo;
			gboolean enqueued;
#line 512 "MetadataWriter.vala"
			if (!gee_iterator_next (_photo_it)) {
#line 512 "MetadataWriter.vala"
				break;
#line 2029 "MetadataWriter.c"
			}
#line 512 "MetadataWriter.vala"
			photo = (LibraryPhoto*) gee_iterator_get (_photo_it);
#line 513 "MetadataWriter.vala"
			enqueued = timed_queue_enqueue (TIMED_QUEUE (self->priv->dirty), photo);
#line 514 "MetadataWriter.vala"
			g_assert (enqueued);
#line 2037 "MetadataWriter.c"
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
#line 517 "MetadataWriter.vala"
	metadata_writer_count_enqueued_work (self, gee_collection_get_size (photos), TRUE);
#line 2044 "MetadataWriter.c"
}


#line 520 "MetadataWriter.vala"
static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait) {
#line 520 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 521 "MetadataWriter.vala"
	timed_queue_clear (TIMED_QUEUE (self->priv->dirty));
#line 2054 "MetadataWriter.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _job_it;
#line 523 "MetadataWriter.vala"
		_job_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_values (GEE_MAP (self->priv->pending)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 523 "MetadataWriter.vala"
		while (TRUE) {
#line 2063 "MetadataWriter.c"
			MetadataWriterCommitJob* job;
#line 523 "MetadataWriter.vala"
			if (!gee_iterator_next (_job_it)) {
#line 523 "MetadataWriter.vala"
				break;
#line 2069 "MetadataWriter.c"
			}
#line 523 "MetadataWriter.vala"
			job = (MetadataWriterCommitJob*) gee_iterator_get (_job_it);
#line 524 "MetadataWriter.vala"
			background_job_cancel (BACKGROUND_JOB (job));
#line 2075 "MetadataWriter.c"
			_background_job_unref0 (job);
		}
		_g_object_unref0 (_job_it);
	}
#line 526 "MetadataWriter.vala"
	if (wait) {
#line 527 "MetadataWriter.vala"
		workers_wait_for_empty_queue (self->priv->workers);
#line 2084 "MetadataWriter.c"
	}
#line 529 "MetadataWriter.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->pending));
#line 531 "MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, G_MAXINT, TRUE);
#line 2090 "MetadataWriter.c"
}


#line 534 "MetadataWriter.vala"
static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo) {
#line 2096 "MetadataWriter.c"
	gboolean result = FALSE;
	gboolean cancelled;
#line 534 "MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (self), FALSE);
#line 534 "MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), FALSE);
#line 535 "MetadataWriter.vala"
	cancelled = FALSE;
#line 537 "MetadataWriter.vala"
	if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->pending), photo)) {
#line 2107 "MetadataWriter.c"
		MetadataWriterCommitJob* _tmp0_;
#line 538 "MetadataWriter.vala"
		background_job_cancel (BACKGROUND_JOB (_tmp0_ = (MetadataWriterCommitJob*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->pending), photo)));
#line 2111 "MetadataWriter.c"
		_background_job_unref0 (_tmp0_);
#line 539 "MetadataWriter.vala"
		cancelled = TRUE;
#line 2115 "MetadataWriter.c"
	}
#line 542 "MetadataWriter.vala"
	if (timed_queue_contains (TIMED_QUEUE (self->priv->dirty), photo)) {
#line 2119 "MetadataWriter.c"
		gboolean removed;
#line 543 "MetadataWriter.vala"
		removed = timed_queue_remove_first (TIMED_QUEUE (self->priv->dirty), photo);
#line 544 "MetadataWriter.vala"
		g_assert (removed);
#line 546 "MetadataWriter.vala"
		g_assert (!timed_queue_contains (TIMED_QUEUE (self->priv->dirty), photo));
#line 548 "MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, FALSE);
#line 549 "MetadataWriter.vala"
		cancelled = TRUE;
#line 2131 "MetadataWriter.c"
	}
	result = cancelled;
#line 552 "MetadataWriter.vala"
	return result;
#line 2136 "MetadataWriter.c"
}


#line 555 "MetadataWriter.vala"
static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo) {
#line 2142 "MetadataWriter.c"
	GeeSet* keywords;
	GeeCollection* tags;
	MetadataWriterCommitJob* job;
#line 555 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 555 "MetadataWriter.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 556 "MetadataWriter.vala"
	g_assert (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->pending), photo));
#line 558 "MetadataWriter.vala"
	if (!self->priv->enabled) {
#line 559 "MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 561 "MetadataWriter.vala"
		return;
#line 2158 "MetadataWriter.c"
	}
#line 564 "MetadataWriter.vala"
	keywords = NULL;
#line 565 "MetadataWriter.vala"
	tags = GEE_COLLECTION (tag_source_collection_fetch_for_source (tag_global, MEDIA_SOURCE (photo)));
#line 566 "MetadataWriter.vala"
	if (tags != NULL) {
#line 2166 "MetadataWriter.c"
		GeeSet* _tmp0_;
#line 567 "MetadataWriter.vala"
		keywords = (_tmp0_ = GEE_SET (gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL)), _g_object_unref0 (keywords), _tmp0_);
#line 2170 "MetadataWriter.c"
		{
			GeeIterator* _tag_it;
#line 568 "MetadataWriter.vala"
			_tag_it = gee_iterable_iterator (GEE_ITERABLE (tags));
#line 568 "MetadataWriter.vala"
			while (TRUE) {
#line 2177 "MetadataWriter.c"
				Tag* tag;
				char* _tmp1_;
#line 568 "MetadataWriter.vala"
				if (!gee_iterator_next (_tag_it)) {
#line 568 "MetadataWriter.vala"
					break;
#line 2184 "MetadataWriter.c"
				}
#line 568 "MetadataWriter.vala"
				tag = (Tag*) gee_iterator_get (_tag_it);
#line 569 "MetadataWriter.vala"
				gee_collection_add (GEE_COLLECTION (keywords), _tmp1_ = data_object_get_name (DATA_OBJECT (tag)));
#line 2190 "MetadataWriter.c"
				_g_free0 (_tmp1_);
				_g_object_unref0 (tag);
			}
			_g_object_unref0 (_tag_it);
		}
	}
#line 572 "MetadataWriter.vala"
	job = metadata_writer_commit_job_new (self, photo, keywords);
#line 573 "MetadataWriter.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->pending), photo, job);
#line 579 "MetadataWriter.vala"
	workers_enqueue (self->priv->workers, BACKGROUND_JOB (job));
#line 2203 "MetadataWriter.c"
	_background_job_unref0 (job);
	_g_object_unref0 (tags);
	_g_object_unref0 (keywords);
}


static gpointer _background_job_ref0 (gpointer self) {
	return self ? background_job_ref (self) : NULL;
}


#line 582 "MetadataWriter.vala"
static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j) {
#line 2217 "MetadataWriter.c"
	MetadataWriterCommitJob* job;
	gboolean removed;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 582 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 582 "MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 583 "MetadataWriter.vala"
	job = _background_job_ref0 (METADATA_WRITER_COMMIT_JOB (j));
#line 585 "MetadataWriter.vala"
	if (job->err != NULL) {
#line 2230 "MetadataWriter.c"
		char* _tmp0_;
#line 586 "MetadataWriter.vala"
		g_warning ("MetadataWriter.vala:586: Unable to update metadata for %s: %s", _tmp0_ = data_object_to_string (DATA_OBJECT (job->photo)), job->err->message);
#line 2234 "MetadataWriter.c"
		_g_free0 (_tmp0_);
	} else {
		char* _tmp1_;
#line 588 "MetadataWriter.vala"
		g_message ("MetadataWriter.vala:588: Completed writing metadata for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (job->photo)));
#line 2240 "MetadataWriter.c"
		_g_free0 (_tmp1_);
	}
#line 590 "MetadataWriter.vala"
	removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->pending), job->photo, NULL);
#line 591 "MetadataWriter.vala"
	g_assert (removed);
#line 595 "MetadataWriter.vala"
	transaction_controller_begin (media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (library_photo_global)));
#line 597 "MetadataWriter.vala"
	if (job->reimport_master_state != NULL) {
#line 597 "MetadataWriter.vala"
		_tmp2_ = TRUE;
#line 2253 "MetadataWriter.c"
	} else {
#line 597 "MetadataWriter.vala"
		_tmp2_ = job->reimport_editable_state != NULL;
#line 2257 "MetadataWriter.c"
	}
#line 597 "MetadataWriter.vala"
	if (_tmp2_) {
#line 2261 "MetadataWriter.c"
		LibraryPhoto* _tmp3_;
#line 600 "MetadataWriter.vala"
		g_assert (self->priv->ignore_photo_alteration == NULL);
#line 601 "MetadataWriter.vala"
		self->priv->ignore_photo_alteration = (_tmp3_ = _g_object_ref0 (job->photo), _g_object_unref0 (self->priv->ignore_photo_alteration), _tmp3_);
#line 2267 "MetadataWriter.c"
		{
#line 603 "MetadataWriter.vala"
			if (job->reimport_master_state != NULL) {
#line 604 "MetadataWriter.vala"
				photo_finish_update_master_metadata (PHOTO (job->photo), job->reimport_master_state, &_inner_error_);
#line 2273 "MetadataWriter.c"
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == DATABASE_ERROR) {
						goto __catch419_database_error;
					}
					{
						LibraryPhoto* _tmp4_;
#line 612 "MetadataWriter.vala"
						g_assert (self->priv->ignore_photo_alteration == job->photo);
#line 613 "MetadataWriter.vala"
						self->priv->ignore_photo_alteration = (_tmp4_ = NULL, _g_object_unref0 (self->priv->ignore_photo_alteration), _tmp4_);
#line 2284 "MetadataWriter.c"
					}
					_background_job_unref0 (job);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
#line 606 "MetadataWriter.vala"
			if (job->reimport_editable_state != NULL) {
#line 607 "MetadataWriter.vala"
				photo_finish_update_editable_metadata (PHOTO (job->photo), job->reimport_editable_state, &_inner_error_);
#line 2296 "MetadataWriter.c"
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == DATABASE_ERROR) {
						goto __catch419_database_error;
					}
					{
						LibraryPhoto* _tmp4_;
#line 612 "MetadataWriter.vala"
						g_assert (self->priv->ignore_photo_alteration == job->photo);
#line 613 "MetadataWriter.vala"
						self->priv->ignore_photo_alteration = (_tmp4_ = NULL, _g_object_unref0 (self->priv->ignore_photo_alteration), _tmp4_);
#line 2307 "MetadataWriter.c"
					}
					_background_job_unref0 (job);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
		}
		goto __finally419;
		__catch419_database_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
#line 609 "MetadataWriter.vala"
				app_window_database_error (err);
#line 2325 "MetadataWriter.c"
				_g_error_free0 (err);
			}
		}
		__finally419:
		{
			LibraryPhoto* _tmp4_;
#line 612 "MetadataWriter.vala"
			g_assert (self->priv->ignore_photo_alteration == job->photo);
#line 613 "MetadataWriter.vala"
			self->priv->ignore_photo_alteration = (_tmp4_ = NULL, _g_object_unref0 (self->priv->ignore_photo_alteration), _tmp4_);
#line 2336 "MetadataWriter.c"
		}
		if (_inner_error_ != NULL) {
			_background_job_unref0 (job);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
	}
	{
#line 623 "MetadataWriter.vala"
		photo_set_master_metadata_dirty (PHOTO (job->photo), FALSE, &_inner_error_);
#line 2349 "MetadataWriter.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch420_database_error;
			}
			_background_job_unref0 (job);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally420;
	__catch420_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 625 "MetadataWriter.vala"
			app_window_database_error (err);
#line 2369 "MetadataWriter.c"
			_g_error_free0 (err);
		}
	}
	__finally420:
	if (_inner_error_ != NULL) {
		_background_job_unref0 (job);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
#line 628 "MetadataWriter.vala"
	transaction_controller_commit (media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (library_photo_global)));
#line 630 "MetadataWriter.vala"
	metadata_writer_count_completed_work (self, 1, TRUE);
#line 2384 "MetadataWriter.c"
	_background_job_unref0 (job);
}


#line 633 "MetadataWriter.vala"
static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j) {
#line 2391 "MetadataWriter.c"
	gboolean removed;
#line 633 "MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 633 "MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 634 "MetadataWriter.vala"
	removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->pending), METADATA_WRITER_COMMIT_JOB (j)->photo, NULL);
#line 635 "MetadataWriter.vala"
	g_assert (removed);
#line 637 "MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 2403 "MetadataWriter.c"
}


#line 582 "MetadataWriter.vala"
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 2409 "MetadataWriter.c"
	metadata_writer_on_update_completed (self, job);
}


#line 633 "MetadataWriter.vala"
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 2416 "MetadataWriter.c"
	metadata_writer_on_update_cancelled (self, job);
}


#line 27 "MetadataWriter.vala"
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
#line 2423 "MetadataWriter.c"
	MetadataWriterCommitJob* self = NULL;
	GCancellable* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeSet* _tmp2_;
#line 27 "MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (owner), NULL);
#line 27 "MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), NULL);
#line 27 "MetadataWriter.vala"
	g_return_val_if_fail ((keywords == NULL) || GEE_IS_SET (keywords), NULL);
#line 28 "MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) background_job_construct (object_type, G_OBJECT (owner), _metadata_writer_on_update_completed_completion_callback, owner, _tmp0_ = g_cancellable_new (), _metadata_writer_on_update_cancelled_cancellation_callback, owner);
#line 2436 "MetadataWriter.c"
	_g_object_unref0 (_tmp0_);
#line 30 "MetadataWriter.vala"
	self->photo = (_tmp1_ = _g_object_ref0 (photo), _g_object_unref0 (self->photo), _tmp1_);
#line 31 "MetadataWriter.vala"
	self->current_keywords = (_tmp2_ = _g_object_ref0 (keywords), _g_object_unref0 (self->current_keywords), _tmp2_);
#line 2442 "MetadataWriter.c"
	return self;
}


#line 27 "MetadataWriter.vala"
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
#line 27 "MetadataWriter.vala"
	return metadata_writer_commit_job_construct (METADATA_WRITER_TYPE_COMMIT_JOB, owner, photo, keywords);
#line 2451 "MetadataWriter.c"
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 34 "MetadataWriter.vala"
static void metadata_writer_commit_job_real_execute (BackgroundJob* base) {
#line 2462 "MetadataWriter.c"
	MetadataWriterCommitJob * self;
	GError * _inner_error_ = NULL;
	self = METADATA_WRITER_COMMIT_JOB (base);
	{
#line 36 "MetadataWriter.vala"
		metadata_writer_commit_job_commit_master (self, &_inner_error_);
#line 2469 "MetadataWriter.c"
		if (_inner_error_ != NULL) {
			goto __catch421_g_error;
		}
#line 37 "MetadataWriter.vala"
		metadata_writer_commit_job_commit_editable (self, &_inner_error_);
#line 2475 "MetadataWriter.c"
		if (_inner_error_ != NULL) {
			goto __catch421_g_error;
		}
	}
	goto __finally421;
	__catch421_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GError* _tmp0_;
#line 39 "MetadataWriter.vala"
			self->err = (_tmp0_ = _g_error_copy0 (err), _g_error_free0 (self->err), _tmp0_);
#line 2490 "MetadataWriter.c"
			_g_error_free0 (err);
		}
	}
	__finally421:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 43 "MetadataWriter.vala"
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error) {
#line 2505 "MetadataWriter.c"
	PhotoMetadata* metadata;
	GError * _inner_error_ = NULL;
#line 43 "MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 44 "MetadataWriter.vala"
	if (!photo_file_format_can_write_metadata (photo_get_master_file_format (PHOTO (self->photo)))) {
#line 45 "MetadataWriter.vala"
		return;
#line 2514 "MetadataWriter.c"
	}
#line 47 "MetadataWriter.vala"
	metadata = photo_get_master_metadata (PHOTO (self->photo), &_inner_error_);
#line 2518 "MetadataWriter.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 48 "MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, metadata)) {
#line 2525 "MetadataWriter.c"
		GFile* _tmp0_;
#line 49 "MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self->photo)), "MetadataWriter.commit_master");
#line 2529 "MetadataWriter.c"
		_g_object_unref0 (_tmp0_);
		{
			PhotoReimportMasterState* _tmp2_ = NULL;
			PhotoReimportMasterState* _tmp3_;
#line 51 "MetadataWriter.vala"
			photo_persist_master_metadata (PHOTO (self->photo), metadata, &_tmp2_, &_inner_error_);
#line 51 "MetadataWriter.vala"
			self->reimport_master_state = (_tmp3_ = _tmp2_, _photo_reimport_master_state_unref0 (self->reimport_master_state), _tmp3_);
#line 2538 "MetadataWriter.c"
			if (_inner_error_ != NULL) {
				goto __finally422;
			}
		}
		__finally422:
		{
			GFile* _tmp1_;
#line 53 "MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp1_ = media_source_get_master_file (MEDIA_SOURCE (self->photo)));
#line 2548 "MetadataWriter.c"
			_g_object_unref0 (_tmp1_);
		}
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_media_metadata_unref0 (metadata);
			return;
		}
	}
	_media_metadata_unref0 (metadata);
}


#line 58 "MetadataWriter.vala"
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error) {
#line 2563 "MetadataWriter.c"
	gboolean _tmp0_ = FALSE;
	PhotoMetadata* metadata;
	GError * _inner_error_ = NULL;
#line 58 "MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 59 "MetadataWriter.vala"
	if (!photo_has_editable (PHOTO (self->photo))) {
#line 59 "MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 2573 "MetadataWriter.c"
	} else {
		PhotoFileFormat* _tmp1_;
#line 59 "MetadataWriter.vala"
		_tmp0_ = !photo_file_format_can_write_metadata (*(_tmp1_ = photo_get_editable_file_format (PHOTO (self->photo))));
#line 2578 "MetadataWriter.c"
		_g_free0 (_tmp1_);
	}
#line 59 "MetadataWriter.vala"
	if (_tmp0_) {
#line 60 "MetadataWriter.vala"
		return;
#line 2585 "MetadataWriter.c"
	}
#line 62 "MetadataWriter.vala"
	metadata = photo_get_editable_metadata (PHOTO (self->photo), &_inner_error_);
#line 2589 "MetadataWriter.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 63 "MetadataWriter.vala"
	g_assert (metadata != NULL);
#line 65 "MetadataWriter.vala"
	if (metadata_writer_commit_job_update_metadata (self, metadata)) {
#line 2598 "MetadataWriter.c"
		GFile* _tmp2_;
#line 66 "MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp2_ = photo_get_editable_file (PHOTO (self->photo)), "MetadataWriter.commit_editable");
#line 2602 "MetadataWriter.c"
		_g_object_unref0 (_tmp2_);
		{
			PhotoReimportEditableState* _tmp4_ = NULL;
			PhotoReimportEditableState* _tmp5_;
#line 68 "MetadataWriter.vala"
			photo_persist_editable_metadata (PHOTO (self->photo), metadata, &_tmp4_, &_inner_error_);
#line 68 "MetadataWriter.vala"
			self->reimport_editable_state = (_tmp5_ = _tmp4_, _photo_reimport_editable_state_unref0 (self->reimport_editable_state), _tmp5_);
#line 2611 "MetadataWriter.c"
			if (_inner_error_ != NULL) {
				goto __finally423;
			}
		}
		__finally423:
		{
			GFile* _tmp3_;
#line 70 "MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp3_ = photo_get_editable_file (PHOTO (self->photo)));
#line 2621 "MetadataWriter.c"
			_g_object_unref0 (_tmp3_);
		}
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_media_metadata_unref0 (metadata);
			return;
		}
	}
	_media_metadata_unref0 (metadata);
}


#line 75 "MetadataWriter.vala"
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata) {
#line 2636 "MetadataWriter.c"
	gboolean result = FALSE;
	gboolean changed;
	char* current_title;
	char* _tmp0_;
	gboolean _tmp1_;
	Rating current_rating;
	time_t current_exposure_time;
	time_t metadata_exposure_time;
	MetadataDateTime* metadata_exposure_date_time;
	GeeSet* _tmp5_;
	gboolean _tmp6_;
	Orientation current_orientation;
#line 75 "MetadataWriter.vala"
	g_return_val_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self), FALSE);
#line 75 "MetadataWriter.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 76 "MetadataWriter.vala"
	changed = FALSE;
#line 79 "MetadataWriter.vala"
	current_title = media_source_get_title (MEDIA_SOURCE (self->photo));
#line 80 "MetadataWriter.vala"
	if ((_tmp1_ = _vala_strcmp0 (current_title, _tmp0_ = media_metadata_get_title (MEDIA_METADATA (metadata))) != 0, _g_free0 (_tmp0_), _tmp1_)) {
#line 81 "MetadataWriter.vala"
		photo_metadata_set_title (metadata, current_title, PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN);
#line 82 "MetadataWriter.vala"
		changed = TRUE;
#line 2663 "MetadataWriter.c"
	}
#line 86 "MetadataWriter.vala"
	current_rating = media_source_get_rating (MEDIA_SOURCE (self->photo));
#line 87 "MetadataWriter.vala"
	if (current_rating != photo_metadata_get_rating (metadata)) {
#line 88 "MetadataWriter.vala"
		photo_metadata_set_rating (metadata, current_rating);
#line 89 "MetadataWriter.vala"
		changed = TRUE;
#line 2673 "MetadataWriter.c"
	}
#line 93 "MetadataWriter.vala"
	current_exposure_time = media_source_get_exposure_time (MEDIA_SOURCE (self->photo));
#line 94 "MetadataWriter.vala"
	metadata_exposure_time = (time_t) 0;
#line 95 "MetadataWriter.vala"
	metadata_exposure_date_time = photo_metadata_get_exposure_date_time (metadata);
#line 96 "MetadataWriter.vala"
	if (metadata_exposure_date_time != NULL) {
#line 97 "MetadataWriter.vala"
		metadata_exposure_time = metadata_date_time_get_timestamp (metadata_exposure_date_time);
#line 2685 "MetadataWriter.c"
	}
#line 98 "MetadataWriter.vala"
	if (current_exposure_time != metadata_exposure_time) {
#line 2689 "MetadataWriter.c"
		MetadataDateTime* _tmp2_;
		_tmp2_ = NULL;
#line 99 "MetadataWriter.vala"
		if (current_exposure_time != 0) {
#line 2694 "MetadataWriter.c"
			MetadataDateTime* _tmp3_;
#line 100 "MetadataWriter.vala"
			_tmp2_ = (_tmp3_ = metadata_date_time_new (current_exposure_time), _metadata_date_time_unref0 (_tmp2_), _tmp3_);
#line 2698 "MetadataWriter.c"
		} else {
			MetadataDateTime* _tmp4_;
#line 101 "MetadataWriter.vala"
			_tmp2_ = (_tmp4_ = NULL, _metadata_date_time_unref0 (_tmp2_), _tmp4_);
#line 2703 "MetadataWriter.c"
		}
#line 99 "MetadataWriter.vala"
		photo_metadata_set_exposure_date_time (metadata, _tmp2_, PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN);
#line 102 "MetadataWriter.vala"
		changed = TRUE;
#line 2709 "MetadataWriter.c"
		_metadata_date_time_unref0 (_tmp2_);
	}
#line 106 "MetadataWriter.vala"
	if ((_tmp6_ = !equal_sets (self->current_keywords, _tmp5_ = photo_metadata_get_keywords (metadata, NULL)), _g_object_unref0 (_tmp5_), _tmp6_)) {
#line 107 "MetadataWriter.vala"
		photo_metadata_set_keywords (metadata, GEE_COLLECTION (self->current_keywords), PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN);
#line 108 "MetadataWriter.vala"
		changed = TRUE;
#line 2718 "MetadataWriter.c"
	}
#line 112 "MetadataWriter.vala"
	current_orientation = photo_get_orientation (PHOTO (self->photo));
#line 113 "MetadataWriter.vala"
	if (current_orientation != photo_metadata_get_orientation (metadata)) {
#line 114 "MetadataWriter.vala"
		photo_metadata_set_orientation (metadata, current_orientation);
#line 115 "MetadataWriter.vala"
		changed = TRUE;
#line 2728 "MetadataWriter.c"
	}
#line 119 "MetadataWriter.vala"
	if (changed) {
#line 120 "MetadataWriter.vala"
		photo_metadata_set_software (metadata, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 2734 "MetadataWriter.c"
	}
	result = changed;
	_metadata_date_time_unref0 (metadata_exposure_date_time);
	_g_free0 (current_title);
#line 122 "MetadataWriter.vala"
	return result;
#line 2741 "MetadataWriter.c"
}


static void metadata_writer_commit_job_class_init (MetadataWriterCommitJobClass * klass) {
	metadata_writer_commit_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = metadata_writer_commit_job_finalize;
	BACKGROUND_JOB_CLASS (klass)->execute = metadata_writer_commit_job_real_execute;
}


static void metadata_writer_commit_job_instance_init (MetadataWriterCommitJob * self) {
	self->reimport_master_state = NULL;
	self->reimport_editable_state = NULL;
	self->err = NULL;
}


static void metadata_writer_commit_job_finalize (BackgroundJob* obj) {
	MetadataWriterCommitJob * self;
	self = METADATA_WRITER_COMMIT_JOB (obj);
	_g_object_unref0 (self->photo);
	_g_object_unref0 (self->current_keywords);
	_photo_reimport_master_state_unref0 (self->reimport_master_state);
	_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
	_g_error_free0 (self->err);
	BACKGROUND_JOB_CLASS (metadata_writer_commit_job_parent_class)->finalize (obj);
}


static GType metadata_writer_commit_job_get_type (void) {
	static volatile gsize metadata_writer_commit_job_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_commit_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterCommitJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_commit_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriterCommitJob), 0, (GInstanceInitFunc) metadata_writer_commit_job_instance_init, NULL };
		GType metadata_writer_commit_job_type_id;
		metadata_writer_commit_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "MetadataWriterCommitJob", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_commit_job_type_id__volatile, metadata_writer_commit_job_type_id);
	}
	return metadata_writer_commit_job_type_id__volatile;
}


static void metadata_writer_class_init (MetadataWriterClass * klass) {
	metadata_writer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MetadataWriterPrivate));
	G_OBJECT_CLASS (klass)->finalize = metadata_writer_finalize;
	g_signal_new ("progress", TYPE_METADATA_WRITER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
}


static void metadata_writer_instance_init (MetadataWriter * self) {
	self->priv = METADATA_WRITER_GET_PRIVATE (self);
	self->priv->workers = workers_new (1, FALSE);
	self->priv->enabled = FALSE;
	self->priv->pending = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_TYPE_COMMIT_JOB, (GBoxedCopyFunc) background_job_ref, background_job_unref, NULL, NULL, NULL);
	self->priv->interested_photo_details = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
	self->priv->ignore_photo_alteration = NULL;
	self->priv->outstanding_total = (guint) 0;
	self->priv->outstanding_completed = (guint) 0;
	self->priv->closed = FALSE;
	self->priv->pause_count = 0;
	self->priv->importing_photos = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
}


static void metadata_writer_finalize (GObject* obj) {
	MetadataWriter * self;
	self = METADATA_WRITER (obj);
	{
		Config* _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
		Application* _tmp14_;
		guint _tmp15_;
		LibraryMonitorPool* _tmp16_;
		LibraryMonitor* _tmp17_;
		guint _tmp18_;
#line 182 "MetadataWriter.vala"
		g_signal_parse_name ("bool-changed", TYPE_CONFIG, &_tmp1_, NULL, FALSE);
#line 182 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (_tmp0_ = config_get_instance (), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _metadata_writer_on_config_bool_changed_config_bool_changed, self);
#line 2833 "MetadataWriter.c"
		_config_unref0 (_tmp0_);
#line 184 "MetadataWriter.vala"
		g_signal_parse_name ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp2_, NULL, FALSE);
#line 184 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (MEDIA_SOURCE_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self);
#line 185 "MetadataWriter.vala"
		g_signal_parse_name ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 185 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (MEDIA_SOURCE_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self);
#line 186 "MetadataWriter.vala"
		g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 186 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self);
#line 187 "MetadataWriter.vala"
		g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 187 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self);
#line 188 "MetadataWriter.vala"
		g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp6_, NULL, FALSE);
#line 188 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 189 "MetadataWriter.vala"
		g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp7_, NULL, FALSE);
#line 189 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 190 "MetadataWriter.vala"
		g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp8_, NULL, FALSE);
#line 190 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (SOURCE_COLLECTION (library_photo_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self);
#line 192 "MetadataWriter.vala"
		g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp9_, NULL, FALSE);
#line 192 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (tag_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self);
#line 193 "MetadataWriter.vala"
		g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp10_, NULL, FALSE);
#line 193 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (CONTAINER_SOURCE_COLLECTION (tag_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 194 "MetadataWriter.vala"
		g_signal_parse_name ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp11_, NULL, FALSE);
#line 194 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (CONTAINER_SOURCE_COLLECTION (tag_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self);
#line 195 "MetadataWriter.vala"
		g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp12_, NULL, FALSE);
#line 195 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (tag_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 196 "MetadataWriter.vala"
		g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp13_, NULL, FALSE);
#line 196 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (tag_global), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 198 "MetadataWriter.vala"
		g_signal_parse_name ("exiting", TYPE_APPLICATION, &_tmp15_, NULL, FALSE);
#line 198 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (_tmp14_ = application_get_instance (), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _metadata_writer_on_application_exiting_application_exiting, self);
#line 2887 "MetadataWriter.c"
		_application_unref0 (_tmp14_);
#line 200 "MetadataWriter.vala"
		g_signal_parse_name ("discovery-completed", TYPE_DIRECTORY_MONITOR, &_tmp18_, NULL, FALSE);
#line 200 "MetadataWriter.vala"
		g_signal_handlers_disconnect_matched (DIRECTORY_MONITOR (_tmp17_ = library_monitor_pool_get_monitor (_tmp16_ = library_monitor_pool_get_instance ())), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self);
#line 2893 "MetadataWriter.c"
		_g_object_unref0 (_tmp17_);
		_library_monitor_pool_unref0 (_tmp16_);
	}
	_workers_unref0 (self->priv->workers);
	_timed_queue_unref0 (self->priv->dirty);
	_g_object_unref0 (self->priv->pending);
	_g_object_unref0 (self->priv->interested_photo_details);
	_g_object_unref0 (self->priv->ignore_photo_alteration);
	_g_object_unref0 (self->priv->importing_photos);
	G_OBJECT_CLASS (metadata_writer_parent_class)->finalize (obj);
}


GType metadata_writer_get_type (void) {
	static volatile gsize metadata_writer_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriter), 0, (GInstanceInitFunc) metadata_writer_instance_init, NULL };
		GType metadata_writer_type_id;
		metadata_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "MetadataWriter", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_type_id__volatile, metadata_writer_type_id);
	}
	return metadata_writer_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
}



