/* Orientation.c generated by valac 0.10.3, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
char* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self, Rotation rotation);
Rotation* orientation_to_rotations (Orientation self, int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);



#line 19 "Orientation.vala"
char* orientation_to_string (Orientation self) {
#line 97 "Orientation.c"
	char* result = NULL;
#line 20 "Orientation.vala"
	switch (self) {
#line 101 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = g_strdup ("top-left");
#line 22 "Orientation.vala"
			return result;
#line 107 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = g_strdup ("top-right");
#line 25 "Orientation.vala"
			return result;
#line 114 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = g_strdup ("bottom-right");
#line 28 "Orientation.vala"
			return result;
#line 121 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = g_strdup ("bottom-left");
#line 31 "Orientation.vala"
			return result;
#line 128 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = g_strdup ("left-top");
#line 34 "Orientation.vala"
			return result;
#line 135 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = g_strdup ("right-top");
#line 37 "Orientation.vala"
			return result;
#line 142 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = g_strdup ("right-bottom");
#line 40 "Orientation.vala"
			return result;
#line 149 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = g_strdup ("left-bottom");
#line 43 "Orientation.vala"
			return result;
#line 156 "Orientation.c"
		}
		default:
		{
			result = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 46 "Orientation.vala"
			return result;
#line 163 "Orientation.c"
		}
	}
}


#line 50 "Orientation.vala"
Orientation orientation_rotate_clockwise (Orientation self) {
#line 171 "Orientation.c"
	Orientation result = 0;
#line 51 "Orientation.vala"
	switch (self) {
#line 175 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 53 "Orientation.vala"
			return result;
#line 181 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 56 "Orientation.vala"
			return result;
#line 188 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 59 "Orientation.vala"
			return result;
#line 195 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 62 "Orientation.vala"
			return result;
#line 202 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 65 "Orientation.vala"
			return result;
#line 209 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 68 "Orientation.vala"
			return result;
#line 216 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 71 "Orientation.vala"
			return result;
#line 223 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_TOP_LEFT;
#line 74 "Orientation.vala"
			return result;
#line 230 "Orientation.c"
		}
		default:
		{
#line 77 "Orientation.vala"
			g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
#line 236 "Orientation.c"
		}
	}
}


#line 81 "Orientation.vala"
Orientation orientation_rotate_counterclockwise (Orientation self) {
#line 244 "Orientation.c"
	Orientation result = 0;
#line 82 "Orientation.vala"
	switch (self) {
#line 248 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 84 "Orientation.vala"
			return result;
#line 254 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 87 "Orientation.vala"
			return result;
#line 261 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 90 "Orientation.vala"
			return result;
#line 268 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 93 "Orientation.vala"
			return result;
#line 275 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 96 "Orientation.vala"
			return result;
#line 282 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_TOP_LEFT;
#line 99 "Orientation.vala"
			return result;
#line 289 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 102 "Orientation.vala"
			return result;
#line 296 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 105 "Orientation.vala"
			return result;
#line 303 "Orientation.c"
		}
		default:
		{
#line 108 "Orientation.vala"
			g_error ("Orientation.vala:108: rotate_counterclockwise: %d", (gint) self);
#line 309 "Orientation.c"
		}
	}
}


#line 112 "Orientation.vala"
Orientation orientation_flip_top_to_bottom (Orientation self) {
#line 317 "Orientation.c"
	Orientation result = 0;
#line 113 "Orientation.vala"
	switch (self) {
#line 321 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 115 "Orientation.vala"
			return result;
#line 327 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "Orientation.vala"
			return result;
#line 334 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 121 "Orientation.vala"
			return result;
#line 341 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 124 "Orientation.vala"
			return result;
#line 348 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 127 "Orientation.vala"
			return result;
#line 355 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 130 "Orientation.vala"
			return result;
#line 362 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 133 "Orientation.vala"
			return result;
#line 369 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_LEFT_TOP;
#line 136 "Orientation.vala"
			return result;
#line 376 "Orientation.c"
		}
		default:
		{
#line 139 "Orientation.vala"
			g_error ("Orientation.vala:139: flip_top_to_bottom: %d", (gint) self);
#line 382 "Orientation.c"
		}
	}
}


#line 143 "Orientation.vala"
Orientation orientation_flip_left_to_right (Orientation self) {
#line 390 "Orientation.c"
	Orientation result = 0;
#line 144 "Orientation.vala"
	switch (self) {
#line 394 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 146 "Orientation.vala"
			return result;
#line 400 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 149 "Orientation.vala"
			return result;
#line 407 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 152 "Orientation.vala"
			return result;
#line 414 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 155 "Orientation.vala"
			return result;
#line 421 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 158 "Orientation.vala"
			return result;
#line 428 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_LEFT_TOP;
#line 161 "Orientation.vala"
			return result;
#line 435 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 164 "Orientation.vala"
			return result;
#line 442 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 167 "Orientation.vala"
			return result;
#line 449 "Orientation.c"
		}
		default:
		{
#line 170 "Orientation.vala"
			g_error ("Orientation.vala:170: flip_left_to_right: %d", (gint) self);
#line 455 "Orientation.c"
		}
	}
}


#line 174 "Orientation.vala"
Orientation orientation_perform (Orientation self, Rotation rotation) {
#line 463 "Orientation.c"
	Orientation result = 0;
#line 175 "Orientation.vala"
	switch (rotation) {
#line 467 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = orientation_rotate_clockwise (self);
#line 177 "Orientation.vala"
			return result;
#line 473 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = orientation_rotate_counterclockwise (self);
#line 180 "Orientation.vala"
			return result;
#line 480 "Orientation.c"
		}
		case ROTATION_MIRROR:
		{
			result = orientation_flip_left_to_right (self);
#line 183 "Orientation.vala"
			return result;
#line 487 "Orientation.c"
		}
		case ROTATION_UPSIDE_DOWN:
		{
			result = orientation_flip_top_to_bottom (self);
#line 186 "Orientation.vala"
			return result;
#line 494 "Orientation.c"
		}
		default:
		{
#line 189 "Orientation.vala"
			g_error ("Orientation.vala:189: perform: %d", (gint) rotation);
#line 500 "Orientation.c"
		}
	}
}


#line 193 "Orientation.vala"
Rotation* orientation_to_rotations (Orientation self, int* result_length1) {
#line 508 "Orientation.c"
	Rotation* result = NULL;
#line 194 "Orientation.vala"
	switch (self) {
#line 512 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			Rotation* _tmp0_ = NULL;
			Rotation* _tmp1_;
			result = (_tmp1_ = (_tmp0_ = g_new0 (Rotation, 0), _tmp0_), *result_length1 = 0, _tmp1_);
#line 197 "Orientation.vala"
			return result;
#line 520 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			Rotation* _tmp2_ = NULL;
			Rotation* _tmp3_;
			result = (_tmp3_ = (_tmp2_ = g_new0 (Rotation, 1), _tmp2_[0] = ROTATION_MIRROR, _tmp2_), *result_length1 = 1, _tmp3_);
#line 200 "Orientation.vala"
			return result;
#line 529 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			Rotation* _tmp4_ = NULL;
			Rotation* _tmp5_;
			result = (_tmp5_ = (_tmp4_ = g_new0 (Rotation, 1), _tmp4_[0] = ROTATION_UPSIDE_DOWN, _tmp4_), *result_length1 = 1, _tmp5_);
#line 203 "Orientation.vala"
			return result;
#line 538 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			Rotation* _tmp6_ = NULL;
			Rotation* _tmp7_;
			result = (_tmp7_ = (_tmp6_ = g_new0 (Rotation, 2), _tmp6_[0] = ROTATION_MIRROR, _tmp6_[1] = ROTATION_UPSIDE_DOWN, _tmp6_), *result_length1 = 2, _tmp7_);
#line 207 "Orientation.vala"
			return result;
#line 547 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			Rotation* _tmp8_ = NULL;
			Rotation* _tmp9_;
			result = (_tmp9_ = (_tmp8_ = g_new0 (Rotation, 2), _tmp8_[0] = ROTATION_COUNTERCLOCKWISE, _tmp8_[1] = ROTATION_UPSIDE_DOWN, _tmp8_), *result_length1 = 2, _tmp9_);
#line 210 "Orientation.vala"
			return result;
#line 556 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			Rotation* _tmp10_ = NULL;
			Rotation* _tmp11_;
			result = (_tmp11_ = (_tmp10_ = g_new0 (Rotation, 1), _tmp10_[0] = ROTATION_CLOCKWISE, _tmp10_), *result_length1 = 1, _tmp11_);
#line 213 "Orientation.vala"
			return result;
#line 565 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			Rotation* _tmp12_ = NULL;
			Rotation* _tmp13_;
			result = (_tmp13_ = (_tmp12_ = g_new0 (Rotation, 2), _tmp12_[0] = ROTATION_CLOCKWISE, _tmp12_[1] = ROTATION_UPSIDE_DOWN, _tmp12_), *result_length1 = 2, _tmp13_);
#line 216 "Orientation.vala"
			return result;
#line 574 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			Rotation* _tmp14_ = NULL;
			Rotation* _tmp15_;
			result = (_tmp15_ = (_tmp14_ = g_new0 (Rotation, 1), _tmp14_[0] = ROTATION_COUNTERCLOCKWISE, _tmp14_), *result_length1 = 1, _tmp15_);
#line 219 "Orientation.vala"
			return result;
#line 583 "Orientation.c"
		}
		default:
		{
#line 222 "Orientation.vala"
			g_error ("Orientation.vala:222: to_rotations: %d", (gint) self);
#line 589 "Orientation.c"
		}
	}
}


#line 226 "Orientation.vala"
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 227 "Orientation.vala"
	switch (self) {
#line 599 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		case ORIENTATION_TOP_RIGHT:
		case ORIENTATION_BOTTOM_RIGHT:
		case ORIENTATION_BOTTOM_LEFT:
		{
			*result = *dim;
#line 233 "Orientation.vala"
			return;
#line 608 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		case ORIENTATION_RIGHT_TOP:
		case ORIENTATION_RIGHT_BOTTOM:
		case ORIENTATION_LEFT_BOTTOM:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*dim).height, (*dim).width), _tmp0_);
#line 240 "Orientation.vala"
			return;
#line 619 "Orientation.c"
		}
		default:
		{
#line 243 "Orientation.vala"
			g_error ("Orientation.vala:243: rotate_dimensions: %d", (gint) self);
#line 625 "Orientation.c"
		}
	}
}


#line 247 "Orientation.vala"
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 633 "Orientation.c"
	Dimensions _tmp0_ = {0};
	*result = (orientation_rotate_dimensions (self, dim, &_tmp0_), _tmp0_);
#line 248 "Orientation.vala"
	return;
#line 638 "Orientation.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 251 "Orientation.vala"
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
#line 649 "Orientation.c"
	GdkPixbuf* result = NULL;
#line 251 "Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 252 "Orientation.vala"
	switch (self) {
#line 655 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 255 "Orientation.vala"
			break;
#line 660 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			GdkPixbuf* _tmp0_;
#line 259 "Orientation.vala"
			pixbuf = (_tmp0_ = gdk_pixbuf_flip (pixbuf, TRUE), _g_object_unref0 (pixbuf), _tmp0_);
#line 260 "Orientation.vala"
			break;
#line 669 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			GdkPixbuf* _tmp1_;
#line 263 "Orientation.vala"
			pixbuf = (_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN), _g_object_unref0 (pixbuf), _tmp1_);
#line 264 "Orientation.vala"
			break;
#line 678 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			GdkPixbuf* _tmp2_;
#line 268 "Orientation.vala"
			pixbuf = (_tmp2_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp2_);
#line 269 "Orientation.vala"
			break;
#line 687 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			GdkPixbuf* _tmp3_;
			GdkPixbuf* _tmp4_;
#line 272 "Orientation.vala"
			pixbuf = (_tmp3_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp3_);
#line 273 "Orientation.vala"
			pixbuf = (_tmp4_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp4_);
#line 274 "Orientation.vala"
			break;
#line 699 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			GdkPixbuf* _tmp5_;
#line 277 "Orientation.vala"
			pixbuf = (_tmp5_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp5_);
#line 278 "Orientation.vala"
			break;
#line 708 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 281 "Orientation.vala"
			pixbuf = (_tmp6_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp6_);
#line 282 "Orientation.vala"
			pixbuf = (_tmp7_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp7_);
#line 283 "Orientation.vala"
			break;
#line 720 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			GdkPixbuf* _tmp8_;
#line 286 "Orientation.vala"
			pixbuf = (_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp8_);
#line 287 "Orientation.vala"
			break;
#line 729 "Orientation.c"
		}
		default:
		{
#line 290 "Orientation.vala"
			g_error ("Orientation.vala:290: rotate_pixbuf: %d", (gint) self);
#line 735 "Orientation.c"
		}
	}
	result = _g_object_ref0 (pixbuf);
	_g_object_unref0 (pixbuf);
#line 293 "Orientation.vala"
	return result;
#line 742 "Orientation.c"
}


#line 297 "Orientation.vala"
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 748 "Orientation.c"
	GdkPoint rotated = {0};
#line 298 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 299 "Orientation.vala"
	g_assert ((*point).x >= 0);
#line 300 "Orientation.vala"
	g_assert ((*point).x < (*space).width);
#line 301 "Orientation.vala"
	g_assert ((*point).y >= 0);
#line 302 "Orientation.vala"
	g_assert ((*point).y < (*space).height);
#line 760 "Orientation.c"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 306 "Orientation.vala"
	switch (self) {
#line 764 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 309 "Orientation.vala"
			rotated = *point;
#line 310 "Orientation.vala"
			break;
#line 771 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 314 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 315 "Orientation.vala"
			rotated.y = (*point).y;
#line 316 "Orientation.vala"
			break;
#line 781 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 320 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 321 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 322 "Orientation.vala"
			break;
#line 791 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 326 "Orientation.vala"
			rotated.x = (*point).x;
#line 327 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 328 "Orientation.vala"
			break;
#line 801 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 332 "Orientation.vala"
			rotated.x = (*point).y;
#line 333 "Orientation.vala"
			rotated.y = (*point).x;
#line 334 "Orientation.vala"
			break;
#line 811 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 338 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 339 "Orientation.vala"
			rotated.y = (*point).x;
#line 340 "Orientation.vala"
			break;
#line 821 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 344 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 345 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 346 "Orientation.vala"
			break;
#line 831 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 350 "Orientation.vala"
			rotated.x = (*point).y;
#line 351 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 352 "Orientation.vala"
			break;
#line 841 "Orientation.c"
		}
		default:
		{
#line 355 "Orientation.vala"
			g_error ("Orientation.vala:355: rotate_point: %d", (gint) self);
#line 847 "Orientation.c"
		}
	}
	*result = rotated;
#line 358 "Orientation.vala"
	return;
#line 853 "Orientation.c"
}


#line 362 "Orientation.vala"
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 859 "Orientation.c"
	GdkPoint derotated = {0};
#line 363 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 863 "Orientation.c"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 367 "Orientation.vala"
	switch (self) {
#line 867 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 370 "Orientation.vala"
			derotated = *point;
#line 371 "Orientation.vala"
			break;
#line 874 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 375 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 376 "Orientation.vala"
			derotated.y = (*point).y;
#line 377 "Orientation.vala"
			break;
#line 884 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 381 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 382 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 383 "Orientation.vala"
			break;
#line 894 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 387 "Orientation.vala"
			derotated.x = (*point).x;
#line 388 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 389 "Orientation.vala"
			break;
#line 904 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 393 "Orientation.vala"
			derotated.x = (*point).y;
#line 394 "Orientation.vala"
			derotated.y = (*point).x;
#line 395 "Orientation.vala"
			break;
#line 914 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 399 "Orientation.vala"
			derotated.x = (*point).y;
#line 400 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 401 "Orientation.vala"
			break;
#line 924 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 405 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 406 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 407 "Orientation.vala"
			break;
#line 934 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 411 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 412 "Orientation.vala"
			derotated.y = (*point).x;
#line 413 "Orientation.vala"
			break;
#line 944 "Orientation.c"
		}
		default:
		{
#line 416 "Orientation.vala"
			g_error ("Orientation.vala:416: rotate_point: %d", (gint) self);
#line 950 "Orientation.c"
		}
	}
	*result = derotated;
#line 419 "Orientation.vala"
	return;
#line 956 "Orientation.c"
}


#line 423 "Orientation.vala"
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 962 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 425 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 427 "Orientation.vala"
	top_left = (orientation_rotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 428 "Orientation.vala"
	bottom_right = (orientation_rotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 974 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 430 "Orientation.vala"
	return;
#line 978 "Orientation.c"
}


#line 434 "Orientation.vala"
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 984 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 436 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 438 "Orientation.vala"
	top_left = (orientation_derotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 439 "Orientation.vala"
	bottom_right = (orientation_derotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 996 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 441 "Orientation.vala"
	return;
#line 1000 "Orientation.c"
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


#line 451 "Orientation.vala"
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf) {
#line 1018 "Orientation.c"
	GdkPixbuf* result = NULL;
#line 451 "Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 452 "Orientation.vala"
	switch (self) {
#line 1024 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 454 "Orientation.vala"
			return result;
#line 1030 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 457 "Orientation.vala"
			return result;
#line 1037 "Orientation.c"
		}
		case ROTATION_MIRROR:
		{
			result = gdk_pixbuf_flip (pixbuf, TRUE);
#line 460 "Orientation.vala"
			return result;
#line 1044 "Orientation.c"
		}
		case ROTATION_UPSIDE_DOWN:
		{
			result = gdk_pixbuf_flip (pixbuf, FALSE);
#line 463 "Orientation.vala"
			return result;
#line 1051 "Orientation.c"
		}
		default:
		{
#line 466 "Orientation.vala"
			g_error ("Orientation.vala:466: Unknown rotation: %d", (gint) self);
#line 1057 "Orientation.c"
		}
	}
}


#line 470 "Orientation.vala"
Rotation rotation_opposite (Rotation self) {
#line 1065 "Orientation.c"
	Rotation result = 0;
#line 471 "Orientation.vala"
	switch (self) {
#line 1069 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = ROTATION_COUNTERCLOCKWISE;
#line 473 "Orientation.vala"
			return result;
#line 1075 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = ROTATION_CLOCKWISE;
#line 476 "Orientation.vala"
			return result;
#line 1082 "Orientation.c"
		}
		case ROTATION_MIRROR:
		case ROTATION_UPSIDE_DOWN:
		{
			result = self;
#line 480 "Orientation.vala"
			return result;
#line 1090 "Orientation.c"
		}
		default:
		{
#line 483 "Orientation.vala"
			g_error ("Orientation.vala:483: Unknown rotation: %d", (gint) self);
#line 1096 "Orientation.c"
		}
	}
}


GType rotation_get_type (void) {
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}




