/* PhotoMetadata.c generated by valac 0.10.3, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _gexiv2_metadata_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_metadata_free (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _gexiv2_preview_image_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_preview_image_free (var), NULL)))

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	char* name;
	Dimensions dimensions;
	guint32 size;
	char* mime_type;
	char* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	char* (*get_title) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	char* source_name;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = (((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

typedef void (*PhotoMetadataSetGenericValue) (const char* tag, void* user_data);
struct _Block1Data {
	int _ref_count_;
	PhotoMetadata * self;
	char* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata * self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata * self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block5Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataDateTime* date_time;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};


static gpointer photo_preview_parent_class = NULL;
static char** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static char** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static char** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static char** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static char** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static char** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern char** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
char** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static char** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static char** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static char** photo_metadata_STANDARD_DESCRIPTION_TAGS;
static gint photo_metadata_STANDARD_DESCRIPTION_TAGS_length1;
static char** photo_metadata_STANDARD_DESCRIPTION_TAGS = NULL;
static gint photo_metadata_STANDARD_DESCRIPTION_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_DESCRIPTION_TAGS_size_ = 0;
static char** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static char** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static char** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static char** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static char** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static char** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const char* name, Dimensions* dimensions, guint32 size, const char* mime_type, const char* extension);
char* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
char* photo_preview_get_mime_type (PhotoPreview* self);
char* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS ((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
#define PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG "Iptc.Application2.Caption"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const char* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const char* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func);
char* photo_metadata_get_tag_label (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_tag_description (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_string (PhotoMetadata* self, const char* tag);
char* prepare_input_text (const char* text, PrepareInputTextOptions options);
char* photo_metadata_get_string_interpreted (PhotoMetadata* self, const char* tag);
char* photo_metadata_get_first_string (PhotoMetadata* self, char** tags, int tags_length1);
char* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, char** tags, int tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const char* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, char** tags, int tags_length1);
void photo_metadata_set_string (PhotoMetadata* self, const char* tag, const char* value);
static void photo_metadata_set_all_generic (PhotoMetadata* self, char** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self, char** tags, int tags_length1, const char* value, PhotoMetadataSetOption option);
static void _lambda1_ (const char* tag, Block1Data* _data1_);
static void __lambda1__photo_metadata_set_generic_value (const char* tag, gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const char* tag, GeeCollection* collection);
static void _vala_array_add252 (char*** array, int* length, int* size, char* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, char** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option);
static void _lambda2_ (const char* tag, Block2Data* _data2_);
static void __lambda2__photo_metadata_set_generic_value (const char* tag, gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (Block2Data* _data2_);
gboolean photo_metadata_get_long (PhotoMetadata* self, const char* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, char** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const char* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, char** tags, int tags_length1, glong value, PhotoMetadataSetOption option);
static void _lambda3_ (const char* tag, Block3Data* _data3_);
static void __lambda3__photo_metadata_set_generic_value (const char* tag, gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational);
char* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option);
static void _lambda4_ (const char* tag, Block4Data* _data4_);
static void __lambda4__photo_metadata_set_generic_value (const char* tag, gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (Block4Data* _data4_);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const char* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const char* label, GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const char* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const char* label, GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, char** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const char* tag, MetadataDateTime* date_time);
char* metadata_date_time_get_exif_label (MetadataDateTime* self);
char* metadata_date_time_get_xmp_label (MetadataDateTime* self);
void photo_metadata_set_all_date_time (PhotoMetadata* self, char** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static void _lambda5_ (const char* tag, Block5Data* _data5_);
static void __lambda5__photo_metadata_set_generic_value (const char* tag, gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (Block5Data* _data5_);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup24 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const char* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, char** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
static char* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const char* s);
void photo_metadata_set_title (PhotoMetadata* self, const char* title, PhotoMetadataSetOption option);
char* photo_metadata_get_description (PhotoMetadata* self);
void photo_metadata_set_description (PhotoMetadata* self, const char* description, PhotoMetadataSetOption option);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, double* longitude, char** long_ref, double* latitude, char** lat_ref, double* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
char* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
char* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
char* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
char* photo_metadata_get_camera_make (PhotoMetadata* self);
char* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
char* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
char* photo_metadata_get_focal_length_string (PhotoMetadata* self);
char* photo_metadata_get_artist (PhotoMetadata* self);
char* photo_metadata_get_copyright (PhotoMetadata* self);
char* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self, const char* software, const char* version);
void photo_metadata_remove_software (PhotoMetadata* self);
char* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
gint rating_serialize (Rating self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup25 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (MediaMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


#line 38 "PhotoMetadata.vala"
PhotoPreview* photo_preview_construct (GType object_type, const char* name, Dimensions* dimensions, guint32 size, const char* mime_type, const char* extension) {
#line 551 "PhotoMetadata.c"
	PhotoPreview* self = (PhotoPreview*) g_type_create_instance (object_type);
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 38 "PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 38 "PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 38 "PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 39 "PhotoMetadata.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 40 "PhotoMetadata.vala"
	self->priv->dimensions = *dimensions;
#line 41 "PhotoMetadata.vala"
	self->priv->size = size;
#line 42 "PhotoMetadata.vala"
	self->priv->mime_type = (_tmp1_ = g_strdup (mime_type), _g_free0 (self->priv->mime_type), _tmp1_);
#line 43 "PhotoMetadata.vala"
	self->priv->extension = (_tmp2_ = g_strdup (extension), _g_free0 (self->priv->extension), _tmp2_);
#line 572 "PhotoMetadata.c"
	return self;
}


#line 46 "PhotoMetadata.vala"
char* photo_preview_get_name (PhotoPreview* self) {
#line 579 "PhotoMetadata.c"
	char* result = NULL;
#line 46 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 583 "PhotoMetadata.c"
	result = g_strdup (self->priv->name);
#line 47 "PhotoMetadata.vala"
	return result;
#line 587 "PhotoMetadata.c"
}


#line 50 "PhotoMetadata.vala"
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
#line 50 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 595 "PhotoMetadata.c"
	*result = self->priv->dimensions;
#line 51 "PhotoMetadata.vala"
	return;
#line 599 "PhotoMetadata.c"
}


#line 54 "PhotoMetadata.vala"
guint32 photo_preview_get_size (PhotoPreview* self) {
#line 605 "PhotoMetadata.c"
	guint32 result = 0U;
#line 54 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 609 "PhotoMetadata.c"
	result = self->priv->size;
#line 55 "PhotoMetadata.vala"
	return result;
#line 613 "PhotoMetadata.c"
}


#line 58 "PhotoMetadata.vala"
char* photo_preview_get_mime_type (PhotoPreview* self) {
#line 619 "PhotoMetadata.c"
	char* result = NULL;
#line 58 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 623 "PhotoMetadata.c"
	result = g_strdup (self->priv->mime_type);
#line 59 "PhotoMetadata.vala"
	return result;
#line 627 "PhotoMetadata.c"
}


#line 62 "PhotoMetadata.vala"
char* photo_preview_get_extension (PhotoPreview* self) {
#line 633 "PhotoMetadata.c"
	char* result = NULL;
#line 62 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 637 "PhotoMetadata.c"
	result = g_strdup (self->priv->extension);
#line 63 "PhotoMetadata.vala"
	return result;
#line 641 "PhotoMetadata.c"
}


#line 66 "PhotoMetadata.vala"
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 647 "PhotoMetadata.c"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 38 "PhotoMetadata.vala"
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 38 "PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 658 "PhotoMetadata.c"
}


#line 68 "PhotoMetadata.vala"
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
#line 664 "PhotoMetadata.c"
	GdkPixbuf* result = NULL;
	gint flattened_length1;
	gint _flattened_size_;
	guint8* _tmp1_;
	gint _tmp0_;
	guint8* flattened;
	GError * _inner_error_ = NULL;
#line 68 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 674 "PhotoMetadata.c"
	flattened = (_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_), flattened_length1 = _tmp0_, _flattened_size_ = flattened_length1, _tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	{
		GMemoryInputStream* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 74 "PhotoMetadata.vala"
		_tmp4_ = (_tmp3_ = gdk_pixbuf_new_from_stream (G_INPUT_STREAM (_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (flattened, (gssize) flattened_length1, NULL)), NULL, &_inner_error_), _g_object_unref0 (_tmp2_), _tmp3_);
#line 686 "PhotoMetadata.c"
		if (_inner_error_ != NULL) {
			goto __catch324_g_error;
		}
		result = _tmp4_;
		flattened = (g_free (flattened), NULL);
#line 74 "PhotoMetadata.vala"
		return result;
#line 694 "PhotoMetadata.c"
	}
	goto __finally324;
	__catch324_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 77 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:77: Unable to decode thumbnail for %s: %s", self->priv->name, err->message);
#line 705 "PhotoMetadata.c"
			result = NULL;
			_g_error_free0 (err);
			flattened = (g_free (flattened), NULL);
#line 79 "PhotoMetadata.vala"
			return result;
#line 711 "PhotoMetadata.c"
		}
	}
	__finally324:
	{
		g_propagate_error (error, _inner_error_);
		flattened = (g_free (flattened), NULL);
		return NULL;
	}
	flattened = (g_free (flattened), NULL);
}


#line 38 "PhotoMetadata.vala"
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
#line 38 "PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 728 "PhotoMetadata.c"
}


static void value_photo_preview_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_preview_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_preview_unref (value->data[0].v_pointer);
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_preview_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_preview_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_preview (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_preview_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
	photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_preview_finalize;
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_preview_real_flatten;
	PHOTO_PREVIEW_CLASS (klass)->get_pixbuf = photo_preview_real_get_pixbuf;
}


static void photo_preview_instance_init (PhotoPreview * self) {
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
	self = PHOTO_PREVIEW (obj);
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->mime_type);
	_g_free0 (self->priv->extension);
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GType photo_metadata_set_option_get_type (void) {
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}


#line 123 "PhotoMetadata.vala"
PhotoMetadata* photo_metadata_construct (GType object_type) {
#line 912 "PhotoMetadata.c"
	PhotoMetadata* self = NULL;
#line 123 "PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 916 "PhotoMetadata.c"
	return self;
}


#line 123 "PhotoMetadata.vala"
PhotoMetadata* photo_metadata_new (void) {
#line 123 "PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 925 "PhotoMetadata.c"
}


#line 126 "PhotoMetadata.vala"
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error) {
#line 931 "PhotoMetadata.c"
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	ExifData* _tmp4_;
	char* _tmp5_;
	GError * _inner_error_ = NULL;
	self = PHOTO_METADATA (base);
#line 126 "PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 127 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 128 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 130 "PhotoMetadata.vala"
	gexiv2_metadata_open_path (self->priv->exiv2, _tmp2_ = g_file_get_path (file), &_inner_error_);
#line 949 "PhotoMetadata.c"
	_g_free0 (_tmp2_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 131 "PhotoMetadata.vala"
	self->priv->exif = (_tmp4_ = exif_data_new_from_file (_tmp3_ = g_file_get_path (file)), _exif_data_unref0 (self->priv->exif), _tmp4_);
#line 957 "PhotoMetadata.c"
	_g_free0 (_tmp3_);
#line 132 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp5_ = g_file_get_basename (file), _g_free0 (self->priv->source_name), _tmp5_);
#line 961 "PhotoMetadata.c"
}


#line 135 "PhotoMetadata.vala"
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
#line 967 "PhotoMetadata.c"
	char* _tmp0_;
	GError * _inner_error_ = NULL;
#line 135 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 135 "PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 136 "PhotoMetadata.vala"
	gexiv2_metadata_save_file (self->priv->exiv2, _tmp0_ = g_file_get_path (file), &_inner_error_);
#line 976 "PhotoMetadata.c"
	_g_free0 (_tmp0_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


#line 139 "PhotoMetadata.vala"
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
#line 987 "PhotoMetadata.c"
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	ExifData* _tmp2_;
	char* _tmp3_;
	GError * _inner_error_ = NULL;
#line 139 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 140 "PhotoMetadata.vala"
	if (length <= 0) {
#line 141 "PhotoMetadata.vala"
		length = buffer_length1;
#line 999 "PhotoMetadata.c"
	}
#line 143 "PhotoMetadata.vala"
	g_assert (buffer_length1 >= length);
#line 145 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 146 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 148 "PhotoMetadata.vala"
	gexiv2_metadata_open_buf (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
#line 1009 "PhotoMetadata.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 149 "PhotoMetadata.vala"
	self->priv->exif = (_tmp2_ = exif_data_new_from_data (buffer, (gsize) length), _exif_data_unref0 (self->priv->exif), _tmp2_);
#line 150 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length), _g_free0 (self->priv->source_name), _tmp3_);
#line 1018 "PhotoMetadata.c"
}


#line 153 "PhotoMetadata.vala"
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
#line 1024 "PhotoMetadata.c"
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
	ExifData* _tmp2_;
	char* _tmp3_;
	GError * _inner_error_ = NULL;
#line 153 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 154 "PhotoMetadata.vala"
	if (length <= 0) {
#line 155 "PhotoMetadata.vala"
		length = buffer_length1;
#line 1036 "PhotoMetadata.c"
	}
#line 157 "PhotoMetadata.vala"
	g_assert (buffer_length1 >= length);
#line 159 "PhotoMetadata.vala"
	self->priv->exiv2 = (_tmp0_ = gexiv2_metadata_new (), _gexiv2_metadata_free0 (self->priv->exiv2), _tmp0_);
#line 160 "PhotoMetadata.vala"
	self->priv->exif = (_tmp1_ = NULL, _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 162 "PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
#line 1046 "PhotoMetadata.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 163 "PhotoMetadata.vala"
	self->priv->exif = (_tmp2_ = exif_data_new_from_data (buffer, (gsize) length), _exif_data_unref0 (self->priv->exif), _tmp2_);
#line 164 "PhotoMetadata.vala"
	self->priv->source_name = (_tmp3_ = g_strdup_printf ("<app1 segment %d bytes>", length), _g_free0 (self->priv->source_name), _tmp3_);
#line 1055 "PhotoMetadata.c"
}


#line 167 "PhotoMetadata.vala"
MetadataDomain photo_metadata_get_tag_domain (const char* tag) {
#line 1061 "PhotoMetadata.c"
	MetadataDomain result = 0;
#line 167 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 168 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 1067 "PhotoMetadata.c"
		result = METADATA_DOMAIN_EXIF;
#line 169 "PhotoMetadata.vala"
		return result;
#line 1071 "PhotoMetadata.c"
	}
#line 171 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 1075 "PhotoMetadata.c"
		result = METADATA_DOMAIN_XMP;
#line 172 "PhotoMetadata.vala"
		return result;
#line 1079 "PhotoMetadata.c"
	}
#line 174 "PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 1083 "PhotoMetadata.c"
		result = METADATA_DOMAIN_IPTC;
#line 175 "PhotoMetadata.vala"
		return result;
#line 1087 "PhotoMetadata.c"
	}
	result = METADATA_DOMAIN_UNKNOWN;
#line 177 "PhotoMetadata.vala"
	return result;
#line 1092 "PhotoMetadata.c"
}


#line 180 "PhotoMetadata.vala"
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 1098 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 180 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 181 "PhotoMetadata.vala"
	switch (domain) {
#line 1104 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			result = gexiv2_metadata_has_exif (self->priv->exiv2);
#line 183 "PhotoMetadata.vala"
			return result;
#line 1110 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			result = gexiv2_metadata_has_xmp (self->priv->exiv2);
#line 186 "PhotoMetadata.vala"
			return result;
#line 1117 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			result = gexiv2_metadata_has_iptc (self->priv->exiv2);
#line 189 "PhotoMetadata.vala"
			return result;
#line 1124 "PhotoMetadata.c"
		}
		default:
		{
			result = FALSE;
#line 193 "PhotoMetadata.vala"
			return result;
#line 1131 "PhotoMetadata.c"
		}
	}
}


#line 197 "PhotoMetadata.vala"
gboolean photo_metadata_has_exif (PhotoMetadata* self) {
#line 1139 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 197 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1143 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 198 "PhotoMetadata.vala"
	return result;
#line 1147 "PhotoMetadata.c"
}


#line 201 "PhotoMetadata.vala"
gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
#line 1153 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 201 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1157 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 202 "PhotoMetadata.vala"
	return result;
#line 1161 "PhotoMetadata.c"
}


#line 205 "PhotoMetadata.vala"
gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
#line 1167 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 205 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1171 "PhotoMetadata.c"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 206 "PhotoMetadata.vala"
	return result;
#line 1175 "PhotoMetadata.c"
}


#line 209 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 1181 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 209 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 210 "PhotoMetadata.vala"
	switch (domain) {
#line 1187 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			result = gexiv2_metadata_get_supports_exif (self->priv->exiv2);
#line 212 "PhotoMetadata.vala"
			return result;
#line 1193 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			result = gexiv2_metadata_get_supports_xmp (self->priv->exiv2);
#line 215 "PhotoMetadata.vala"
			return result;
#line 1200 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			result = gexiv2_metadata_get_supports_iptc (self->priv->exiv2);
#line 218 "PhotoMetadata.vala"
			return result;
#line 1207 "PhotoMetadata.c"
		}
		default:
		{
			result = FALSE;
#line 222 "PhotoMetadata.vala"
			return result;
#line 1214 "PhotoMetadata.c"
		}
	}
}


#line 226 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
#line 1222 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 226 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1226 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 227 "PhotoMetadata.vala"
	return result;
#line 1230 "PhotoMetadata.c"
}


#line 230 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
#line 1236 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 230 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1240 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 231 "PhotoMetadata.vala"
	return result;
#line 1244 "PhotoMetadata.c"
}


#line 234 "PhotoMetadata.vala"
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
#line 1250 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 234 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1254 "PhotoMetadata.c"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 235 "PhotoMetadata.vala"
	return result;
#line 1258 "PhotoMetadata.c"
}


#line 238 "PhotoMetadata.vala"
gboolean photo_metadata_has_tag (PhotoMetadata* self, const char* tag) {
#line 1264 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 238 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 238 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 1270 "PhotoMetadata.c"
	result = gexiv2_metadata_has_tag (self->priv->exiv2, tag);
#line 239 "PhotoMetadata.vala"
	return result;
#line 1274 "PhotoMetadata.c"
}


#line 242 "PhotoMetadata.vala"
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func) {
#line 1280 "PhotoMetadata.c"
	GeeSet* result = NULL;
#line 242 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 244 "PhotoMetadata.vala"
	if (compare_func == NULL) {
#line 1286 "PhotoMetadata.c"
		result = GEE_SET (gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL));
#line 245 "PhotoMetadata.vala"
		return result;
#line 1290 "PhotoMetadata.c"
	} else {
		result = GEE_SET (gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func));
#line 247 "PhotoMetadata.vala"
		return result;
#line 1295 "PhotoMetadata.c"
	}
}


#line 250 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func) {
#line 1302 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	gint tags_length1;
	gint _tags_size_;
	char** _tmp0_;
	char** tags;
	gboolean _tmp7_ = FALSE;
	GeeCollection* collection;
#line 250 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1312 "PhotoMetadata.c"
	tags = (_tmp0_ = NULL, tags_length1 = 0, _tags_size_ = tags_length1, _tmp0_);
#line 252 "PhotoMetadata.vala"
	switch (domain) {
#line 1316 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			char** _tmp1_;
			char** _tmp2_;
#line 254 "PhotoMetadata.vala"
			tags = (_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp1_), _tags_size_ = tags_length1, _tmp2_);
#line 255 "PhotoMetadata.vala"
			break;
#line 1325 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			char** _tmp3_;
			char** _tmp4_;
#line 258 "PhotoMetadata.vala"
			tags = (_tmp4_ = _tmp3_ = gexiv2_metadata_get_xmp_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp3_), _tags_size_ = tags_length1, _tmp4_);
#line 259 "PhotoMetadata.vala"
			break;
#line 1335 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
			char** _tmp5_;
			char** _tmp6_;
#line 262 "PhotoMetadata.vala"
			tags = (_tmp6_ = _tmp5_ = gexiv2_metadata_get_iptc_tags (self->priv->exiv2), tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL), tags_length1 = _vala_array_length (_tmp5_), _tags_size_ = tags_length1, _tmp6_);
#line 263 "PhotoMetadata.vala"
			break;
#line 1345 "PhotoMetadata.c"
		}
	}
#line 266 "PhotoMetadata.vala"
	if (tags == NULL) {
#line 266 "PhotoMetadata.vala"
		_tmp7_ = TRUE;
#line 1352 "PhotoMetadata.c"
	} else {
#line 266 "PhotoMetadata.vala"
		_tmp7_ = tags_length1 == 0;
#line 1356 "PhotoMetadata.c"
	}
#line 266 "PhotoMetadata.vala"
	if (_tmp7_) {
#line 1360 "PhotoMetadata.c"
		result = NULL;
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 267 "PhotoMetadata.vala"
		return result;
#line 1365 "PhotoMetadata.c"
	}
#line 269 "PhotoMetadata.vala"
	collection = GEE_COLLECTION (photo_metadata_create_string_set (self, compare_func));
#line 1369 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 270 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1376 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 271 "PhotoMetadata.vala"
				gee_collection_add (collection, tag);
#line 1384 "PhotoMetadata.c"
				_g_free0 (tag);
			}
		}
	}
	result = collection;
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 273 "PhotoMetadata.vala"
	return result;
#line 1393 "PhotoMetadata.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 276 "PhotoMetadata.vala"
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func) {
#line 1404 "PhotoMetadata.c"
	GeeCollection* result = NULL;
	GeeCollection* all_tags;
	GeeCollection* exif_tags;
	gboolean _tmp0_ = FALSE;
	GeeCollection* xmp_tags;
	gboolean _tmp1_ = FALSE;
	GeeCollection* iptc_tags;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp3_;
#line 276 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 277 "PhotoMetadata.vala"
	all_tags = GEE_COLLECTION (photo_metadata_create_string_set (self, compare_func));
#line 279 "PhotoMetadata.vala"
	exif_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL);
#line 280 "PhotoMetadata.vala"
	if (exif_tags != NULL) {
#line 280 "PhotoMetadata.vala"
		_tmp0_ = gee_collection_get_size (exif_tags) > 0;
#line 1424 "PhotoMetadata.c"
	} else {
#line 280 "PhotoMetadata.vala"
		_tmp0_ = FALSE;
#line 1428 "PhotoMetadata.c"
	}
#line 280 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 281 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, exif_tags);
#line 1434 "PhotoMetadata.c"
	}
#line 283 "PhotoMetadata.vala"
	xmp_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL);
#line 284 "PhotoMetadata.vala"
	if (xmp_tags != NULL) {
#line 284 "PhotoMetadata.vala"
		_tmp1_ = gee_collection_get_size (xmp_tags) > 0;
#line 1442 "PhotoMetadata.c"
	} else {
#line 284 "PhotoMetadata.vala"
		_tmp1_ = FALSE;
#line 1446 "PhotoMetadata.c"
	}
#line 284 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 285 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, xmp_tags);
#line 1452 "PhotoMetadata.c"
	}
#line 287 "PhotoMetadata.vala"
	iptc_tags = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL);
#line 288 "PhotoMetadata.vala"
	if (iptc_tags != NULL) {
#line 288 "PhotoMetadata.vala"
		_tmp2_ = gee_collection_get_size (iptc_tags) > 0;
#line 1460 "PhotoMetadata.c"
	} else {
#line 288 "PhotoMetadata.vala"
		_tmp2_ = FALSE;
#line 1464 "PhotoMetadata.c"
	}
#line 288 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 289 "PhotoMetadata.vala"
		gee_collection_add_all (all_tags, iptc_tags);
#line 1470 "PhotoMetadata.c"
	}
	_tmp3_ = NULL;
#line 291 "PhotoMetadata.vala"
	if (gee_collection_get_size (all_tags) > 0) {
#line 291 "PhotoMetadata.vala"
		_tmp3_ = all_tags;
#line 1477 "PhotoMetadata.c"
	} else {
#line 291 "PhotoMetadata.vala"
		_tmp3_ = NULL;
#line 1481 "PhotoMetadata.c"
	}
	result = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (iptc_tags);
	_g_object_unref0 (xmp_tags);
	_g_object_unref0 (exif_tags);
	_g_object_unref0 (all_tags);
#line 291 "PhotoMetadata.vala"
	return result;
#line 1490 "PhotoMetadata.c"
}


#line 294 "PhotoMetadata.vala"
char* photo_metadata_get_tag_label (PhotoMetadata* self, const char* tag) {
#line 1496 "PhotoMetadata.c"
	char* result = NULL;
#line 294 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 294 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 1502 "PhotoMetadata.c"
	result = g_strdup (gexiv2_metadata_get_tag_label (tag));
#line 295 "PhotoMetadata.vala"
	return result;
#line 1506 "PhotoMetadata.c"
}


#line 298 "PhotoMetadata.vala"
char* photo_metadata_get_tag_description (PhotoMetadata* self, const char* tag) {
#line 1512 "PhotoMetadata.c"
	char* result = NULL;
#line 298 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 298 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 1518 "PhotoMetadata.c"
	result = g_strdup (gexiv2_metadata_get_tag_description (tag));
#line 299 "PhotoMetadata.vala"
	return result;
#line 1522 "PhotoMetadata.c"
}


#line 302 "PhotoMetadata.vala"
char* photo_metadata_get_string (PhotoMetadata* self, const char* tag) {
#line 1528 "PhotoMetadata.c"
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
#line 302 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 302 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 1536 "PhotoMetadata.c"
	result = (_tmp1_ = prepare_input_text (_tmp0_ = gexiv2_metadata_get_tag_string (self->priv->exiv2, tag), PHOTO_METADATA_PREPARE_STRING_OPTIONS), _g_free0 (_tmp0_), _tmp1_);
#line 303 "PhotoMetadata.vala"
	return result;
#line 1540 "PhotoMetadata.c"
}


#line 306 "PhotoMetadata.vala"
char* photo_metadata_get_string_interpreted (PhotoMetadata* self, const char* tag) {
#line 1546 "PhotoMetadata.c"
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
#line 306 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 306 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 1554 "PhotoMetadata.c"
	result = (_tmp1_ = prepare_input_text (_tmp0_ = gexiv2_metadata_get_tag_interpreted_string (self->priv->exiv2, tag), PHOTO_METADATA_PREPARE_STRING_OPTIONS), _g_free0 (_tmp0_), _tmp1_);
#line 307 "PhotoMetadata.vala"
	return result;
#line 1558 "PhotoMetadata.c"
}


#line 310 "PhotoMetadata.vala"
char* photo_metadata_get_first_string (PhotoMetadata* self, char** tags, int tags_length1) {
#line 1564 "PhotoMetadata.c"
	char* result = NULL;
#line 310 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1568 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 311 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1575 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				char* value;
#line 312 "PhotoMetadata.vala"
				value = photo_metadata_get_string (self, tag);
#line 313 "PhotoMetadata.vala"
				if (value != NULL) {
#line 1586 "PhotoMetadata.c"
					result = value;
					_g_free0 (tag);
#line 314 "PhotoMetadata.vala"
					return result;
#line 1591 "PhotoMetadata.c"
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 317 "PhotoMetadata.vala"
	return result;
#line 1601 "PhotoMetadata.c"
}


#line 320 "PhotoMetadata.vala"
char* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, char** tags, int tags_length1) {
#line 1607 "PhotoMetadata.c"
	char* result = NULL;
#line 320 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1611 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 321 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1618 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				char* value;
#line 322 "PhotoMetadata.vala"
				value = photo_metadata_get_string_interpreted (self, tag);
#line 323 "PhotoMetadata.vala"
				if (value != NULL) {
#line 1629 "PhotoMetadata.c"
					result = value;
					_g_free0 (tag);
#line 324 "PhotoMetadata.vala"
					return result;
#line 1634 "PhotoMetadata.c"
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 327 "PhotoMetadata.vala"
	return result;
#line 1644 "PhotoMetadata.c"
}


#line 336 "PhotoMetadata.vala"
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const char* tag) {
#line 1650 "PhotoMetadata.c"
	GeeList* result = NULL;
	gint values_length1;
	gint _values_size_;
	char** _tmp1_;
	char** _tmp0_;
	char** values;
	gboolean _tmp2_ = FALSE;
	GeeList* list;
	GeeHashSet* collection;
	GeeList* _tmp4_;
#line 336 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 336 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 1665 "PhotoMetadata.c"
	values = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_tag_multiple (self->priv->exiv2, tag), values_length1 = _vala_array_length (_tmp0_), _values_size_ = values_length1, _tmp1_);
#line 338 "PhotoMetadata.vala"
	if (values == NULL) {
#line 338 "PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 1671 "PhotoMetadata.c"
	} else {
#line 338 "PhotoMetadata.vala"
		_tmp2_ = values_length1 == 0;
#line 1675 "PhotoMetadata.c"
	}
#line 338 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 1679 "PhotoMetadata.c"
		result = NULL;
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 339 "PhotoMetadata.vala"
		return result;
#line 1684 "PhotoMetadata.c"
	}
#line 341 "PhotoMetadata.vala"
	list = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL));
#line 343 "PhotoMetadata.vala"
	collection = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 1690 "PhotoMetadata.c"
	{
		char** value_collection;
		int value_collection_length1;
		int value_it;
#line 344 "PhotoMetadata.vala"
		value_collection = values;
#line 1697 "PhotoMetadata.c"
		value_collection_length1 = values_length1;
		for (value_it = 0; value_it < values_length1; value_it = value_it + 1) {
			char* value;
			value = g_strdup (value_collection[value_it]);
			{
				char* prepped;
				gboolean _tmp3_ = FALSE;
#line 345 "PhotoMetadata.vala"
				prepped = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 346 "PhotoMetadata.vala"
				if (prepped != NULL) {
#line 346 "PhotoMetadata.vala"
					_tmp3_ = !gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (collection), prepped);
#line 1711 "PhotoMetadata.c"
				} else {
#line 346 "PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 1715 "PhotoMetadata.c"
				}
#line 346 "PhotoMetadata.vala"
				if (_tmp3_) {
#line 347 "PhotoMetadata.vala"
					gee_collection_add (GEE_COLLECTION (list), prepped);
#line 348 "PhotoMetadata.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (collection), prepped);
#line 1723 "PhotoMetadata.c"
				}
				_g_free0 (prepped);
				_g_free0 (value);
			}
		}
	}
	_tmp4_ = NULL;
#line 352 "PhotoMetadata.vala"
	if (gee_collection_get_size (GEE_COLLECTION (list)) > 0) {
#line 352 "PhotoMetadata.vala"
		_tmp4_ = list;
#line 1735 "PhotoMetadata.c"
	} else {
#line 352 "PhotoMetadata.vala"
		_tmp4_ = NULL;
#line 1739 "PhotoMetadata.c"
	}
	result = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (collection);
	_g_object_unref0 (list);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 352 "PhotoMetadata.vala"
	return result;
#line 1747 "PhotoMetadata.c"
}


#line 361 "PhotoMetadata.vala"
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, char** tags, int tags_length1) {
#line 1753 "PhotoMetadata.c"
	GeeList* result = NULL;
#line 361 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1757 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 362 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1764 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				GeeList* values;
				gboolean _tmp0_ = FALSE;
#line 363 "PhotoMetadata.vala"
				values = photo_metadata_get_string_multiple (self, tag);
#line 364 "PhotoMetadata.vala"
				if (values != NULL) {
#line 364 "PhotoMetadata.vala"
					_tmp0_ = gee_collection_get_size (GEE_COLLECTION (values)) > 0;
#line 1778 "PhotoMetadata.c"
				} else {
#line 364 "PhotoMetadata.vala"
					_tmp0_ = FALSE;
#line 1782 "PhotoMetadata.c"
				}
#line 364 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 1786 "PhotoMetadata.c"
					result = values;
					_g_free0 (tag);
#line 365 "PhotoMetadata.vala"
					return result;
#line 1791 "PhotoMetadata.c"
				}
				_g_object_unref0 (values);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 368 "PhotoMetadata.vala"
	return result;
#line 1801 "PhotoMetadata.c"
}


#line 371 "PhotoMetadata.vala"
void photo_metadata_set_string (PhotoMetadata* self, const char* tag, const char* value) {
#line 1807 "PhotoMetadata.c"
	char* prepped;
#line 371 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 371 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 371 "PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 372 "PhotoMetadata.vala"
	prepped = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 373 "PhotoMetadata.vala"
	if (prepped == NULL) {
#line 374 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:374: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 1821 "PhotoMetadata.c"
		_g_free0 (prepped);
#line 376 "PhotoMetadata.vala"
		return;
#line 1825 "PhotoMetadata.c"
	}
#line 379 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_string (self->priv->exiv2, tag, prepped)) {
#line 380 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:380: Unable to set tag %s to string %s from source " \
"%s", tag, value, self->priv->source_name);
#line 1831 "PhotoMetadata.c"
	}
	_g_free0 (prepped);
}


#line 385 "PhotoMetadata.vala"
static void photo_metadata_set_all_generic (PhotoMetadata* self, char** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target) {
#line 1839 "PhotoMetadata.c"
	gboolean written;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 385 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 386 "PhotoMetadata.vala"
	written = FALSE;
#line 1847 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 387 "PhotoMetadata.vala"
		tag_collection = tags;
#line 1854 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				gboolean _tmp0_ = FALSE;
#line 388 "PhotoMetadata.vala"
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 388 "PhotoMetadata.vala"
					_tmp0_ = TRUE;
#line 1865 "PhotoMetadata.c"
				} else {
#line 388 "PhotoMetadata.vala"
					_tmp0_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (tag));
#line 1869 "PhotoMetadata.c"
				}
#line 388 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 389 "PhotoMetadata.vala"
					setter (tag, setter_target);
#line 390 "PhotoMetadata.vala"
					written = TRUE;
#line 1877 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
#line 394 "PhotoMetadata.vala"
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 394 "PhotoMetadata.vala"
		_tmp2_ = !written;
#line 1887 "PhotoMetadata.c"
	} else {
#line 394 "PhotoMetadata.vala"
		_tmp2_ = FALSE;
#line 1891 "PhotoMetadata.c"
	}
#line 394 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 394 "PhotoMetadata.vala"
		_tmp1_ = tags_length1 > 0;
#line 1897 "PhotoMetadata.c"
	} else {
#line 394 "PhotoMetadata.vala"
		_tmp1_ = FALSE;
#line 1901 "PhotoMetadata.c"
	}
#line 394 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 1905 "PhotoMetadata.c"
		MetadataDomain default_domain;
#line 395 "PhotoMetadata.vala"
		default_domain = photo_metadata_get_tag_domain (tags[0]);
#line 398 "PhotoMetadata.vala"
		setter (tags[0], setter_target);
#line 1911 "PhotoMetadata.c"
		{
			gint ctr;
#line 401 "PhotoMetadata.vala"
			ctr = 1;
#line 1916 "PhotoMetadata.c"
			{
				gboolean _tmp3_;
#line 401 "PhotoMetadata.vala"
				_tmp3_ = TRUE;
#line 401 "PhotoMetadata.vala"
				while (TRUE) {
#line 401 "PhotoMetadata.vala"
					if (!_tmp3_) {
#line 401 "PhotoMetadata.vala"
						ctr++;
#line 1927 "PhotoMetadata.c"
					}
#line 401 "PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 401 "PhotoMetadata.vala"
					if (!(ctr < tags_length1)) {
#line 401 "PhotoMetadata.vala"
						break;
#line 1935 "PhotoMetadata.c"
					}
#line 402 "PhotoMetadata.vala"
					if (photo_metadata_get_tag_domain (tags[ctr]) == default_domain) {
#line 403 "PhotoMetadata.vala"
						setter (tags[ctr], setter_target);
#line 1941 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}


#line 409 "PhotoMetadata.vala"
static void _lambda1_ (const char* tag, Block1Data* _data1_) {
#line 1952 "PhotoMetadata.c"
	PhotoMetadata * self;
	self = _data1_->self;
#line 409 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 409 "PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data1_->value);
#line 1959 "PhotoMetadata.c"
}


#line 409 "PhotoMetadata.vala"
static void __lambda1__photo_metadata_set_generic_value (const char* tag, gpointer self) {
#line 1965 "PhotoMetadata.c"
	_lambda1_ (tag, self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_media_metadata_unref0 (_data1_->self);
		_g_free0 (_data1_->value);
		g_slice_free (Block1Data, _data1_);
	}
}


#line 408 "PhotoMetadata.vala"
void photo_metadata_set_all_string (PhotoMetadata* self, char** tags, int tags_length1, const char* value, PhotoMetadataSetOption option) {
#line 1987 "PhotoMetadata.c"
	Block1Data* _data1_;
#line 408 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 408 "PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 1993 "PhotoMetadata.c"
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = media_metadata_ref (self);
	_data1_->value = g_strdup (value);
#line 409 "PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda1__photo_metadata_set_generic_value, _data1_);
#line 2000 "PhotoMetadata.c"
	block1_data_unref (_data1_);
}


static void _vala_array_add252 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 412 "PhotoMetadata.vala"
void photo_metadata_set_string_multiple (PhotoMetadata* self, const char* tag, GeeCollection* collection) {
#line 2017 "PhotoMetadata.c"
	gint values_length1;
	gint _values_size_;
	char** _tmp0_;
	char** values;
#line 412 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 412 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 412 "PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (collection));
#line 2028 "PhotoMetadata.c"
	values = (_tmp0_ = g_new0 (char*, 0 + 1), values_length1 = 0, _values_size_ = values_length1, _tmp0_);
	{
		GeeIterator* _value_it;
#line 414 "PhotoMetadata.vala"
		_value_it = gee_iterable_iterator (GEE_ITERABLE (collection));
#line 414 "PhotoMetadata.vala"
		while (TRUE) {
#line 2036 "PhotoMetadata.c"
			char* value;
			char* prepped;
#line 414 "PhotoMetadata.vala"
			if (!gee_iterator_next (_value_it)) {
#line 414 "PhotoMetadata.vala"
				break;
#line 2043 "PhotoMetadata.c"
			}
#line 414 "PhotoMetadata.vala"
			value = (char*) gee_iterator_get (_value_it);
#line 415 "PhotoMetadata.vala"
			prepped = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 416 "PhotoMetadata.vala"
			if (prepped != NULL) {
#line 417 "PhotoMetadata.vala"
				_vala_array_add252 (&values, &values_length1, &_values_size_, g_strdup (prepped));
#line 2053 "PhotoMetadata.c"
			} else {
#line 419 "PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:419: Unable to set string %s to %s: invalid UTF-8", value, tag);
#line 2057 "PhotoMetadata.c"
			}
			_g_free0 (prepped);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
#line 422 "PhotoMetadata.vala"
	if (values_length1 == 0) {
#line 2066 "PhotoMetadata.c"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 423 "PhotoMetadata.vala"
		return;
#line 2070 "PhotoMetadata.c"
	}
#line 425 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_multiple (self->priv->exiv2, tag, values)) {
#line 426 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:426: Unable to set %d strings to tag %s from source" \
" %s", values_length1, tag, self->priv->source_name);
#line 2076 "PhotoMetadata.c"
	}
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
}


#line 430 "PhotoMetadata.vala"
static void _lambda2_ (const char* tag, Block2Data* _data2_) {
#line 2084 "PhotoMetadata.c"
	PhotoMetadata * self;
	self = _data2_->self;
#line 430 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 430 "PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, tag, _data2_->values);
#line 2091 "PhotoMetadata.c"
}


#line 430 "PhotoMetadata.vala"
static void __lambda2__photo_metadata_set_generic_value (const char* tag, gpointer self) {
#line 2097 "PhotoMetadata.c"
	_lambda2_ (tag, self);
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (Block2Data* _data2_) {
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_media_metadata_unref0 (_data2_->self);
		_g_object_unref0 (_data2_->values);
		g_slice_free (Block2Data, _data2_);
	}
}


#line 429 "PhotoMetadata.vala"
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, char** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option) {
#line 2119 "PhotoMetadata.c"
	Block2Data* _data2_;
#line 429 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 429 "PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (values));
#line 2125 "PhotoMetadata.c"
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = media_metadata_ref (self);
	_data2_->values = _g_object_ref0 (values);
#line 430 "PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda2__photo_metadata_set_generic_value, _data2_);
#line 2132 "PhotoMetadata.c"
	block2_data_unref (_data2_);
}


#line 433 "PhotoMetadata.vala"
gboolean photo_metadata_get_long (PhotoMetadata* self, const char* tag, glong* value) {
#line 2139 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 433 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 433 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 434 "PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 2147 "PhotoMetadata.c"
		result = FALSE;
#line 435 "PhotoMetadata.vala"
		return result;
#line 2151 "PhotoMetadata.c"
	}
#line 437 "PhotoMetadata.vala"
	*value = gexiv2_metadata_get_tag_long (self->priv->exiv2, tag);
#line 2155 "PhotoMetadata.c"
	result = TRUE;
#line 439 "PhotoMetadata.vala"
	return result;
#line 2159 "PhotoMetadata.c"
}


#line 442 "PhotoMetadata.vala"
gboolean photo_metadata_get_first_long (PhotoMetadata* self, char** tags, int tags_length1, glong* value) {
#line 2165 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 442 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 2169 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 443 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2176 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 444 "PhotoMetadata.vala"
				if (photo_metadata_get_long (self, tag, value)) {
#line 2184 "PhotoMetadata.c"
					result = TRUE;
					_g_free0 (tag);
#line 445 "PhotoMetadata.vala"
					return result;
#line 2189 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
#line 448 "PhotoMetadata.vala"
	return result;
#line 2198 "PhotoMetadata.c"
}


#line 451 "PhotoMetadata.vala"
void photo_metadata_set_long (PhotoMetadata* self, const char* tag, glong value) {
#line 451 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 451 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 452 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_long (self->priv->exiv2, tag, value)) {
#line 453 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:453: Unable to set tag %s to long %ld from source %" \
"s", tag, value, self->priv->source_name);
#line 2212 "PhotoMetadata.c"
	}
}


#line 457 "PhotoMetadata.vala"
static void _lambda3_ (const char* tag, Block3Data* _data3_) {
#line 2219 "PhotoMetadata.c"
	PhotoMetadata * self;
	self = _data3_->self;
#line 457 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 457 "PhotoMetadata.vala"
	photo_metadata_set_long (self, tag, _data3_->value);
#line 2226 "PhotoMetadata.c"
}


#line 457 "PhotoMetadata.vala"
static void __lambda3__photo_metadata_set_generic_value (const char* tag, gpointer self) {
#line 2232 "PhotoMetadata.c"
	_lambda3_ (tag, self);
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_media_metadata_unref0 (_data3_->self);
		g_slice_free (Block3Data, _data3_);
	}
}


#line 456 "PhotoMetadata.vala"
void photo_metadata_set_all_long (PhotoMetadata* self, char** tags, int tags_length1, glong value, PhotoMetadataSetOption option) {
#line 2253 "PhotoMetadata.c"
	Block3Data* _data3_;
#line 456 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 2257 "PhotoMetadata.c"
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = media_metadata_ref (self);
	_data3_->value = value;
#line 457 "PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda3__photo_metadata_set_generic_value, _data3_);
#line 2264 "PhotoMetadata.c"
	block3_data_unref (_data3_);
}


#line 460 "PhotoMetadata.vala"
gboolean photo_metadata_get_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational) {
#line 2271 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 460 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 460 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 2277 "PhotoMetadata.c"
	result = gexiv2_metadata_get_exif_tag_rational (self->priv->exiv2, tag, &(*rational).numerator, &(*rational).denominator);
#line 461 "PhotoMetadata.vala"
	return result;
#line 2281 "PhotoMetadata.c"
}


#line 464 "PhotoMetadata.vala"
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational) {
#line 2287 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 464 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 2291 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 465 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2298 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 466 "PhotoMetadata.vala"
				if (photo_metadata_get_rational (self, tag, rational)) {
#line 2306 "PhotoMetadata.c"
					result = TRUE;
					_g_free0 (tag);
#line 467 "PhotoMetadata.vala"
					return result;
#line 2311 "PhotoMetadata.c"
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
#line 470 "PhotoMetadata.vala"
	return result;
#line 2320 "PhotoMetadata.c"
}


#line 473 "PhotoMetadata.vala"
void photo_metadata_set_rational (PhotoMetadata* self, const char* tag, MetadataRational* rational) {
#line 473 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 473 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 474 "PhotoMetadata.vala"
	if (!gexiv2_metadata_set_exif_tag_rational (self->priv->exiv2, tag, (*rational).numerator, (*rational).denominator)) {
#line 2332 "PhotoMetadata.c"
		char* _tmp0_;
#line 475 "PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:475: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp0_ = metadata_rational_to_string (rational), self->priv->source_name);
#line 2336 "PhotoMetadata.c"
		_g_free0 (_tmp0_);
	}
}


#line 481 "PhotoMetadata.vala"
static void _lambda4_ (const char* tag, Block4Data* _data4_) {
#line 2344 "PhotoMetadata.c"
	PhotoMetadata * self;
	self = _data4_->self;
#line 481 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 481 "PhotoMetadata.vala"
	photo_metadata_set_rational (self, tag, &_data4_->rational);
#line 2351 "PhotoMetadata.c"
}


#line 481 "PhotoMetadata.vala"
static void __lambda4__photo_metadata_set_generic_value (const char* tag, gpointer self) {
#line 2357 "PhotoMetadata.c"
	_lambda4_ (tag, self);
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (Block4Data* _data4_) {
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		_media_metadata_unref0 (_data4_->self);
		g_slice_free (Block4Data, _data4_);
	}
}


#line 480 "PhotoMetadata.vala"
void photo_metadata_set_all_rational (PhotoMetadata* self, char** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option) {
#line 2378 "PhotoMetadata.c"
	Block4Data* _data4_;
#line 480 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 2382 "PhotoMetadata.c"
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = media_metadata_ref (self);
	_data4_->rational = *rational;
#line 481 "PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda4__photo_metadata_set_generic_value, _data4_);
#line 2389 "PhotoMetadata.c"
	block4_data_unref (_data4_);
}


#line 484 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const char* tag) {
#line 2396 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
	char* value;
	GError * _inner_error_ = NULL;
#line 484 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 484 "PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 485 "PhotoMetadata.vala"
	value = photo_metadata_get_string (self, tag);
#line 486 "PhotoMetadata.vala"
	if (value == NULL) {
#line 2408 "PhotoMetadata.c"
		result = NULL;
		_g_free0 (value);
#line 487 "PhotoMetadata.vala"
		return result;
#line 2413 "PhotoMetadata.c"
	}
	{
#line 490 "PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 2418 "PhotoMetadata.c"
			case METADATA_DOMAIN_XMP:
			{
				MetadataDateTime* _tmp0_;
#line 492 "PhotoMetadata.vala"
				_tmp0_ = metadata_date_time_new_from_xmp (value, &_inner_error_);
#line 2424 "PhotoMetadata.c"
				if (_inner_error_ != NULL) {
					goto __catch325_g_error;
				}
				result = _tmp0_;
				_g_free0 (value);
#line 492 "PhotoMetadata.vala"
				return result;
#line 2432 "PhotoMetadata.c"
			}
			case METADATA_DOMAIN_IPTC:
			{
				result = NULL;
				_g_free0 (value);
#line 497 "PhotoMetadata.vala"
				return result;
#line 2440 "PhotoMetadata.c"
			}
			default:
			{
				MetadataDateTime* _tmp1_;
#line 501 "PhotoMetadata.vala"
				_tmp1_ = metadata_date_time_new_from_exif (value, &_inner_error_);
#line 2447 "PhotoMetadata.c"
				if (_inner_error_ != NULL) {
					goto __catch325_g_error;
				}
				result = _tmp1_;
				_g_free0 (value);
#line 501 "PhotoMetadata.vala"
				return result;
#line 2455 "PhotoMetadata.c"
			}
		}
	}
	goto __finally325;
	__catch325_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 504 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:504: Unable to read date/time %s from source %s: %s", tag, self->priv->source_name, err->message);
#line 2468 "PhotoMetadata.c"
			result = NULL;
			_g_error_free0 (err);
			_g_free0 (value);
#line 506 "PhotoMetadata.vala"
			return result;
#line 2474 "PhotoMetadata.c"
		}
	}
	__finally325:
	{
		_g_free0 (value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_free0 (value);
}


#line 510 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, char** tags, int tags_length1) {
#line 2490 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 510 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2494 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 511 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2501 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				MetadataDateTime* date_time;
#line 512 "PhotoMetadata.vala"
				date_time = photo_metadata_get_date_time (self, tag);
#line 513 "PhotoMetadata.vala"
				if (date_time != NULL) {
#line 2512 "PhotoMetadata.c"
					result = date_time;
					_g_free0 (tag);
#line 514 "PhotoMetadata.vala"
					return result;
#line 2517 "PhotoMetadata.c"
				}
				_metadata_date_time_unref0 (date_time);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
#line 517 "PhotoMetadata.vala"
	return result;
#line 2527 "PhotoMetadata.c"
}


#line 520 "PhotoMetadata.vala"
void photo_metadata_set_date_time (PhotoMetadata* self, const char* tag, MetadataDateTime* date_time) {
#line 520 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 520 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 520 "PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 521 "PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 2541 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
			char* _tmp0_;
#line 523 "PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp0_ = metadata_date_time_get_exif_label (date_time));
#line 2547 "PhotoMetadata.c"
			_g_free0 (_tmp0_);
#line 524 "PhotoMetadata.vala"
			break;
#line 2551 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
			char* _tmp1_;
#line 527 "PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_ = metadata_date_time_get_xmp_label (date_time));
#line 2558 "PhotoMetadata.c"
			_g_free0 (_tmp1_);
#line 528 "PhotoMetadata.vala"
			break;
#line 2562 "PhotoMetadata.c"
		}
		default:
		{
			GEnumValue* _tmp2_;
#line 533 "PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:533: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, self->priv->source_name, (_tmp2_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), (int) photo_metadata_get_tag_domain (tag)), (_tmp2_ != NULL) ? _tmp2_->value_name : NULL));
#line 535 "PhotoMetadata.vala"
			break;
#line 2571 "PhotoMetadata.c"
		}
	}
}


#line 540 "PhotoMetadata.vala"
static void _lambda5_ (const char* tag, Block5Data* _data5_) {
#line 2579 "PhotoMetadata.c"
	PhotoMetadata * self;
	self = _data5_->self;
#line 540 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 540 "PhotoMetadata.vala"
	photo_metadata_set_date_time (self, tag, _data5_->date_time);
#line 2586 "PhotoMetadata.c"
}


#line 540 "PhotoMetadata.vala"
static void __lambda5__photo_metadata_set_generic_value (const char* tag, gpointer self) {
#line 2592 "PhotoMetadata.c"
	_lambda5_ (tag, self);
}


static gpointer _metadata_date_time_ref0 (gpointer self) {
	return self ? metadata_date_time_ref (self) : NULL;
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (Block5Data* _data5_) {
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		_media_metadata_unref0 (_data5_->self);
		_metadata_date_time_unref0 (_data5_->date_time);
		g_slice_free (Block5Data, _data5_);
	}
}


#line 539 "PhotoMetadata.vala"
void photo_metadata_set_all_date_time (PhotoMetadata* self, char** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
#line 2619 "PhotoMetadata.c"
	Block5Data* _data5_;
#line 539 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 539 "PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 2625 "PhotoMetadata.c"
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = media_metadata_ref (self);
	_data5_->date_time = _metadata_date_time_ref0 (date_time);
#line 540 "PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda5__photo_metadata_set_generic_value, _data5_);
#line 2632 "PhotoMetadata.c"
	block5_data_unref (_data5_);
}


#line 544 "PhotoMetadata.vala"
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
#line 2639 "PhotoMetadata.c"
	guint8* result = NULL;
	guchar* thumbnail;
	guint thumbnail_size;
	gint flattened_length1;
	gint _flattened_size_;
	guint8* _tmp1_;
	guint8* flattened;
	guchar* saved_data;
	guint saved_size;
	gboolean _tmp2_ = FALSE;
	guint8* _tmp5_;
#line 544 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 545 "PhotoMetadata.vala"
	if (self->priv->exif == NULL) {
#line 2655 "PhotoMetadata.c"
		gpointer _tmp0_;
		result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
#line 546 "PhotoMetadata.vala"
		return result;
#line 2660 "PhotoMetadata.c"
	}
#line 550 "PhotoMetadata.vala"
	thumbnail = self->priv->exif->data;
#line 551 "PhotoMetadata.vala"
	thumbnail_size = self->priv->exif->size;
#line 552 "PhotoMetadata.vala"
	if (!include_preview) {
#line 553 "PhotoMetadata.vala"
		self->priv->exif->data = NULL;
#line 554 "PhotoMetadata.vala"
		self->priv->exif->size = (guint) 0;
#line 2672 "PhotoMetadata.c"
	}
	flattened = (_tmp1_ = NULL, flattened_length1 = 0, _flattened_size_ = flattened_length1, _tmp1_);
#line 560 "PhotoMetadata.vala"
	saved_data = NULL;
#line 561 "PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 562 "PhotoMetadata.vala"
	exif_data_save_data (self->priv->exif, &saved_data, &saved_size);
#line 563 "PhotoMetadata.vala"
	if (saved_size > 0) {
#line 563 "PhotoMetadata.vala"
		_tmp2_ = saved_data != NULL;
#line 2685 "PhotoMetadata.c"
	} else {
#line 563 "PhotoMetadata.vala"
		_tmp2_ = FALSE;
#line 2689 "PhotoMetadata.c"
	}
#line 563 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 2693 "PhotoMetadata.c"
		guint8* _tmp3_;
		ExifMem* _tmp4_;
#line 564 "PhotoMetadata.vala"
		flattened = (_tmp3_ = g_new0 (guint8, saved_size), flattened = (g_free (flattened), NULL), flattened_length1 = saved_size, _flattened_size_ = flattened_length1, _tmp3_);
#line 565 "PhotoMetadata.vala"
		memcpy (flattened, saved_data, (gsize) saved_size);
#line 567 "PhotoMetadata.vala"
		exif_mem_free (_tmp4_ = exif_mem_new_default (), saved_data);
#line 2702 "PhotoMetadata.c"
		_exif_mem_unref0 (_tmp4_);
	}
#line 571 "PhotoMetadata.vala"
	self->priv->exif->data = thumbnail;
#line 572 "PhotoMetadata.vala"
	self->priv->exif->size = thumbnail_size;
#line 2709 "PhotoMetadata.c"
	result = (_tmp5_ = flattened, *result_length1 = flattened_length1, _tmp5_);
#line 574 "PhotoMetadata.vala"
	return result;
#line 2713 "PhotoMetadata.c"
	flattened = (g_free (flattened), NULL);
}


static guint8* _vala_array_dup24 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


#line 578 "PhotoMetadata.vala"
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
#line 2725 "PhotoMetadata.c"
	guint8* result = NULL;
	gint buffer_length1;
	gint _buffer_size_;
	guchar* buffer;
	gint _tmp0__length1;
	gint __tmp0__size_;
	guchar* _tmp0_;
	guint8* _tmp3_;
	guchar* _tmp4_;
#line 578 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2737 "PhotoMetadata.c"
	buffer = (buffer_length1 = 0, NULL);
	_tmp0_ = (_tmp0__length1 = 0, NULL);
#line 580 "PhotoMetadata.vala"
	if (gexiv2_metadata_get_exif_thumbnail (self->priv->exiv2, &buffer, &buffer_length1)) {
#line 2742 "PhotoMetadata.c"
		guchar* _tmp1_;
#line 580 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = buffer, _tmp0__length1 = buffer_length1, __tmp0__size_ = _tmp0__length1, _tmp1_);
#line 2746 "PhotoMetadata.c"
	} else {
		guchar* _tmp2_;
#line 580 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = NULL, _tmp0__length1 = 0, __tmp0__size_ = _tmp0__length1, _tmp2_);
#line 2751 "PhotoMetadata.c"
	}
	result = (_tmp4_ = (_tmp3_ = _tmp0_, (_tmp3_ == NULL) ? ((gpointer) _tmp3_) : _vala_array_dup24 (_tmp3_, _tmp0__length1)), *result_length1 = _tmp0__length1, _tmp4_);
	buffer = (g_free (buffer), NULL);
#line 580 "PhotoMetadata.vala"
	return result;
#line 2757 "PhotoMetadata.c"
	buffer = (g_free (buffer), NULL);
}


#line 583 "PhotoMetadata.vala"
guint photo_metadata_get_preview_count (PhotoMetadata* self) {
#line 2764 "PhotoMetadata.c"
	guint result = 0U;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	gint _tmp2_ = 0;
#line 583 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 2774 "PhotoMetadata.c"
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 586 "PhotoMetadata.vala"
	if (props != NULL) {
#line 586 "PhotoMetadata.vala"
		_tmp2_ = props_length1;
#line 2780 "PhotoMetadata.c"
	} else {
#line 586 "PhotoMetadata.vala"
		_tmp2_ = 0;
#line 2784 "PhotoMetadata.c"
	}
	result = (guint) _tmp2_;
#line 586 "PhotoMetadata.vala"
	return result;
#line 2789 "PhotoMetadata.c"
}


#line 590 "PhotoMetadata.vala"
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
#line 2795 "PhotoMetadata.c"
	PhotoPreview* result = NULL;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	gboolean _tmp2_ = FALSE;
#line 590 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2805 "PhotoMetadata.c"
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 592 "PhotoMetadata.vala"
	if (props == NULL) {
#line 592 "PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 2811 "PhotoMetadata.c"
	} else {
#line 592 "PhotoMetadata.vala"
		_tmp2_ = props_length1 <= number;
#line 2815 "PhotoMetadata.c"
	}
#line 592 "PhotoMetadata.vala"
	if (_tmp2_) {
#line 2819 "PhotoMetadata.c"
		result = NULL;
#line 593 "PhotoMetadata.vala"
		return result;
#line 2823 "PhotoMetadata.c"
	}
	result = PHOTO_PREVIEW (photo_metadata_internal_photo_preview_new (self, self->priv->source_name, number, props[number]));
#line 595 "PhotoMetadata.vala"
	return result;
#line 2828 "PhotoMetadata.c"
}


#line 598 "PhotoMetadata.vala"
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
#line 598 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 599 "PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (self->priv->exiv2);
#line 600 "PhotoMetadata.vala"
	if (self->priv->exif != NULL) {
#line 2840 "PhotoMetadata.c"
		ExifMem* _tmp0_;
#line 601 "PhotoMetadata.vala"
		exif_mem_free (_tmp0_ = exif_mem_new_default (), self->priv->exif->data);
#line 2844 "PhotoMetadata.c"
		_exif_mem_unref0 (_tmp0_);
#line 602 "PhotoMetadata.vala"
		self->priv->exif->data = NULL;
#line 603 "PhotoMetadata.vala"
		self->priv->exif->size = (guint) 0;
#line 2850 "PhotoMetadata.c"
	}
}


#line 607 "PhotoMetadata.vala"
void photo_metadata_remove_tag (PhotoMetadata* self, const char* tag) {
#line 607 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 607 "PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 608 "PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (self->priv->exiv2, tag);
#line 2863 "PhotoMetadata.c"
}


#line 611 "PhotoMetadata.vala"
void photo_metadata_remove_tags (PhotoMetadata* self, char** tags, int tags_length1) {
#line 611 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 2871 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 612 "PhotoMetadata.vala"
		tag_collection = tags;
#line 2878 "PhotoMetadata.c"
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
#line 613 "PhotoMetadata.vala"
				photo_metadata_remove_tag (self, tag);
#line 2886 "PhotoMetadata.c"
				_g_free0 (tag);
			}
		}
	}
}


#line 616 "PhotoMetadata.vala"
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
#line 616 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 617 "PhotoMetadata.vala"
	switch (domain) {
#line 2900 "PhotoMetadata.c"
		case METADATA_DOMAIN_EXIF:
		{
#line 619 "PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (self->priv->exiv2);
#line 620 "PhotoMetadata.vala"
			break;
#line 2907 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_XMP:
		{
#line 623 "PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (self->priv->exiv2);
#line 624 "PhotoMetadata.vala"
			break;
#line 2915 "PhotoMetadata.c"
		}
		case METADATA_DOMAIN_IPTC:
		{
#line 627 "PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (self->priv->exiv2);
#line 628 "PhotoMetadata.vala"
			break;
#line 2923 "PhotoMetadata.c"
		}
	}
}


#line 632 "PhotoMetadata.vala"
void photo_metadata_clear (PhotoMetadata* self) {
#line 632 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 633 "PhotoMetadata.vala"
	gexiv2_metadata_clear (self->priv->exiv2);
#line 2935 "PhotoMetadata.c"
}


#line 642 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
#line 2941 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 642 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2945 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
#line 643 "PhotoMetadata.vala"
	return result;
#line 2949 "PhotoMetadata.c"
}


#line 646 "PhotoMetadata.vala"
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
#line 646 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 646 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 648 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 649 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1, date_time, option);
#line 2963 "PhotoMetadata.c"
	} else {
#line 651 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
#line 2967 "PhotoMetadata.c"
	}
}


#line 663 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
#line 2974 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 663 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 2978 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
#line 664 "PhotoMetadata.vala"
	return result;
#line 2982 "PhotoMetadata.c"
}


#line 667 "PhotoMetadata.vala"
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
#line 667 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 667 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 669 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 670 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1, date_time, option);
#line 2996 "PhotoMetadata.c"
	} else {
#line 672 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
#line 3000 "PhotoMetadata.c"
	}
}


#line 680 "PhotoMetadata.vala"
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
#line 3007 "PhotoMetadata.c"
	MetadataDateTime* result = NULL;
#line 680 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3011 "PhotoMetadata.c"
	result = photo_metadata_get_first_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
#line 681 "PhotoMetadata.vala"
	return result;
#line 3015 "PhotoMetadata.c"
}


#line 684 "PhotoMetadata.vala"
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
#line 684 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 684 "PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 686 "PhotoMetadata.vala"
	if (date_time != NULL) {
#line 687 "PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1, date_time, option);
#line 3029 "PhotoMetadata.c"
	} else {
#line 689 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
#line 3033 "PhotoMetadata.c"
	}
}


#line 692 "PhotoMetadata.vala"
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base) {
#line 3040 "PhotoMetadata.c"
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* creation;
	self = PHOTO_METADATA (base);
#line 693 "PhotoMetadata.vala"
	creation = photo_metadata_get_exposure_date_time (self);
#line 694 "PhotoMetadata.vala"
	if (creation == NULL) {
#line 3049 "PhotoMetadata.c"
		MetadataDateTime* _tmp0_;
#line 695 "PhotoMetadata.vala"
		creation = (_tmp0_ = photo_metadata_get_digitized_date_time (self), _metadata_date_time_unref0 (creation), _tmp0_);
#line 3053 "PhotoMetadata.c"
	}
	result = creation;
#line 697 "PhotoMetadata.vala"
	return result;
#line 3058 "PhotoMetadata.c"
}


static gpointer _dimensions_dup0 (gpointer self) {
	return self ? dimensions_dup (self) : NULL;
}


#line 714 "PhotoMetadata.vala"
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
#line 3069 "PhotoMetadata.c"
	Dimensions* result = NULL;
#line 714 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 716 "PhotoMetadata.vala"
	g_assert (photo_metadata_WIDTH_TAGS_length1 == photo_metadata_HEIGHT_TAGS_length1);
#line 3075 "PhotoMetadata.c"
	{
		gint ctr;
#line 717 "PhotoMetadata.vala"
		ctr = 0;
#line 3080 "PhotoMetadata.c"
		{
			gboolean _tmp0_;
#line 717 "PhotoMetadata.vala"
			_tmp0_ = TRUE;
#line 717 "PhotoMetadata.vala"
			while (TRUE) {
#line 3087 "PhotoMetadata.c"
				glong width = 0L;
				glong height = 0L;
				Dimensions _tmp1_ = {0};
				Dimensions _tmp2_;
#line 717 "PhotoMetadata.vala"
				if (!_tmp0_) {
#line 717 "PhotoMetadata.vala"
					ctr++;
#line 3096 "PhotoMetadata.c"
				}
#line 717 "PhotoMetadata.vala"
				_tmp0_ = FALSE;
#line 717 "PhotoMetadata.vala"
				if (!(ctr < photo_metadata_WIDTH_TAGS_length1)) {
#line 717 "PhotoMetadata.vala"
					break;
#line 3104 "PhotoMetadata.c"
				}
#line 721 "PhotoMetadata.vala"
				if (!photo_metadata_get_long (self, photo_metadata_WIDTH_TAGS[ctr], &width)) {
#line 722 "PhotoMetadata.vala"
					continue;
#line 3110 "PhotoMetadata.c"
				}
#line 725 "PhotoMetadata.vala"
				if (!photo_metadata_get_long (self, photo_metadata_HEIGHT_TAGS[ctr], &height)) {
#line 726 "PhotoMetadata.vala"
					continue;
#line 3116 "PhotoMetadata.c"
				}
				result = _dimensions_dup0 ((_tmp2_ = (dimensions_init (&_tmp1_, (gint) width, (gint) height), _tmp1_), &_tmp2_));
#line 728 "PhotoMetadata.vala"
				return result;
#line 3121 "PhotoMetadata.c"
			}
		}
	}
	result = NULL;
#line 731 "PhotoMetadata.vala"
	return result;
#line 3128 "PhotoMetadata.c"
}


#line 734 "PhotoMetadata.vala"
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option) {
#line 734 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 736 "PhotoMetadata.vala"
	if (dim != NULL) {
#line 737 "PhotoMetadata.vala"
		photo_metadata_set_all_long (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1, (glong) (*dim).width, option);
#line 738 "PhotoMetadata.vala"
		photo_metadata_set_all_long (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1, (glong) (*dim).height, option);
#line 3142 "PhotoMetadata.c"
	} else {
#line 740 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1);
#line 741 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1);
#line 3148 "PhotoMetadata.c"
	}
}


#line 1051 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 3155 "PhotoMetadata.c"
	char* result = NULL;
	char* _result_;
#line 1051 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1053 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 3164 "PhotoMetadata.c"
	result = _result_;
#line 1054 "glib-2.0.vapi"
	return result;
#line 3168 "PhotoMetadata.c"
}


#line 1177 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 3174 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 3180 "PhotoMetadata.c"
	result = strstr (self, needle) != NULL;
#line 1178 "glib-2.0.vapi"
	return result;
#line 3184 "PhotoMetadata.c"
}


#line 774 "PhotoMetadata.vala"
static char* photo_metadata_real_get_title (MediaMetadata* base) {
#line 3190 "PhotoMetadata.c"
	PhotoMetadata * self;
	char* result = NULL;
	GeeList* _tmp0_;
	GeeList* titles;
	char* _tmp3_;
	gboolean _tmp4_ = FALSE;
	char* title;
	const char* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	self = PHOTO_METADATA (base);
	_tmp0_ = NULL;
#line 782 "PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3205 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 783 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG), _g_object_unref0 (_tmp0_), _tmp1_);
#line 3209 "PhotoMetadata.c"
	} else {
		GeeList* _tmp2_;
#line 784 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = photo_metadata_get_first_string_multiple (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1), _g_object_unref0 (_tmp0_), _tmp2_);
#line 3214 "PhotoMetadata.c"
	}
#line 782 "PhotoMetadata.vala"
	titles = _g_object_ref0 (_tmp0_);
#line 3218 "PhotoMetadata.c"
	_tmp3_ = NULL;
#line 789 "PhotoMetadata.vala"
	if (titles != NULL) {
#line 789 "PhotoMetadata.vala"
		_tmp4_ = gee_collection_get_size (GEE_COLLECTION (titles)) > 0;
#line 3224 "PhotoMetadata.c"
	} else {
#line 789 "PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 3228 "PhotoMetadata.c"
	}
#line 789 "PhotoMetadata.vala"
	if (_tmp4_) {
#line 3232 "PhotoMetadata.c"
		char* _tmp5_;
#line 789 "PhotoMetadata.vala"
		_tmp3_ = (_tmp5_ = (char*) gee_list_get (titles, 0), _g_free0 (_tmp3_), _tmp5_);
#line 3236 "PhotoMetadata.c"
	} else {
		char* _tmp6_;
#line 789 "PhotoMetadata.vala"
		_tmp3_ = (_tmp6_ = NULL, _g_free0 (_tmp3_), _tmp6_);
#line 3241 "PhotoMetadata.c"
	}
#line 789 "PhotoMetadata.vala"
	title = g_strdup (_tmp3_);
#line 792 "PhotoMetadata.vala"
	if (title != NULL) {
#line 3247 "PhotoMetadata.c"
		char* _tmp7_;
#line 793 "PhotoMetadata.vala"
		title = (_tmp7_ = string_strip (title), _g_free0 (title), _tmp7_);
#line 3251 "PhotoMetadata.c"
	}
	_tmp8_ = NULL;
#line 796 "PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 796 "PhotoMetadata.vala"
		_tmp10_ = !string_contains (title, "\n");
#line 3258 "PhotoMetadata.c"
	} else {
#line 796 "PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 3262 "PhotoMetadata.c"
	}
#line 796 "PhotoMetadata.vala"
	if (_tmp10_) {
#line 796 "PhotoMetadata.vala"
		_tmp9_ = !string_contains (title, "\r");
#line 3268 "PhotoMetadata.c"
	} else {
#line 796 "PhotoMetadata.vala"
		_tmp9_ = FALSE;
#line 3272 "PhotoMetadata.c"
	}
#line 796 "PhotoMetadata.vala"
	if (_tmp9_) {
#line 797 "PhotoMetadata.vala"
		_tmp8_ = title;
#line 3278 "PhotoMetadata.c"
	} else {
#line 797 "PhotoMetadata.vala"
		_tmp8_ = NULL;
#line 3282 "PhotoMetadata.c"
	}
	result = g_strdup (_tmp8_);
	_g_free0 (title);
	_g_free0 (_tmp3_);
	_g_object_unref0 (titles);
	_g_object_unref0 (_tmp0_);
#line 796 "PhotoMetadata.vala"
	return result;
#line 3291 "PhotoMetadata.c"
}


#line 800 "PhotoMetadata.vala"
void photo_metadata_set_title (PhotoMetadata* self, const char* title, PhotoMetadataSetOption option) {
#line 800 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 801 "PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 802 "PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 803 "PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title);
#line 3305 "PhotoMetadata.c"
		} else {
#line 805 "PhotoMetadata.vala"
			photo_metadata_set_all_string (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1, title, option);
#line 3309 "PhotoMetadata.c"
		}
	} else {
#line 807 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1);
#line 3314 "PhotoMetadata.c"
	}
}


#line 817 "PhotoMetadata.vala"
char* photo_metadata_get_description (PhotoMetadata* self) {
#line 3321 "PhotoMetadata.c"
	char* result = NULL;
	GeeList* _tmp0_;
	GeeList* descriptions;
	char* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 817 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3329 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 819 "PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3333 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 820 "PhotoMetadata.vala"
		_tmp0_ = (_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG), _g_object_unref0 (_tmp0_), _tmp1_);
#line 3337 "PhotoMetadata.c"
	} else {
		GeeList* _tmp2_;
#line 821 "PhotoMetadata.vala"
		_tmp0_ = (_tmp2_ = photo_metadata_get_first_string_multiple (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1), _g_object_unref0 (_tmp0_), _tmp2_);
#line 3342 "PhotoMetadata.c"
	}
#line 819 "PhotoMetadata.vala"
	descriptions = _g_object_ref0 (_tmp0_);
#line 3346 "PhotoMetadata.c"
	_tmp3_ = NULL;
#line 823 "PhotoMetadata.vala"
	if (descriptions != NULL) {
#line 823 "PhotoMetadata.vala"
		_tmp4_ = gee_collection_get_size (GEE_COLLECTION (descriptions)) > 0;
#line 3352 "PhotoMetadata.c"
	} else {
#line 823 "PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 3356 "PhotoMetadata.c"
	}
#line 823 "PhotoMetadata.vala"
	if (_tmp4_) {
#line 3360 "PhotoMetadata.c"
		char* _tmp5_;
#line 823 "PhotoMetadata.vala"
		_tmp3_ = (_tmp5_ = (char*) gee_list_get (descriptions, 0), _g_free0 (_tmp3_), _tmp5_);
#line 3364 "PhotoMetadata.c"
	} else {
		char* _tmp6_;
#line 823 "PhotoMetadata.vala"
		_tmp3_ = (_tmp6_ = NULL, _g_free0 (_tmp3_), _tmp6_);
#line 3369 "PhotoMetadata.c"
	}
	result = _tmp3_;
	_g_object_unref0 (descriptions);
	_g_object_unref0 (_tmp0_);
#line 823 "PhotoMetadata.vala"
	return result;
#line 3376 "PhotoMetadata.c"
}


#line 826 "PhotoMetadata.vala"
void photo_metadata_set_description (PhotoMetadata* self, const char* description, PhotoMetadataSetOption option) {
#line 826 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 828 "PhotoMetadata.vala"
	if (!is_string_empty (description)) {
#line 3386 "PhotoMetadata.c"
		gboolean _tmp0_ = FALSE;
#line 829 "PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 3390 "PhotoMetadata.c"
			gboolean _tmp1_ = FALSE;
#line 830 "PhotoMetadata.vala"
			if (option != PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT) {
#line 830 "PhotoMetadata.vala"
				_tmp1_ = TRUE;
#line 3396 "PhotoMetadata.c"
			} else {
#line 830 "PhotoMetadata.vala"
				_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG));
#line 3400 "PhotoMetadata.c"
			}
#line 830 "PhotoMetadata.vala"
			_tmp0_ = _tmp1_;
#line 3404 "PhotoMetadata.c"
		} else {
#line 829 "PhotoMetadata.vala"
			_tmp0_ = FALSE;
#line 3408 "PhotoMetadata.c"
		}
#line 829 "PhotoMetadata.vala"
		if (_tmp0_) {
#line 831 "PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_DESCRIPTION_TAG, description);
#line 3414 "PhotoMetadata.c"
		} else {
#line 833 "PhotoMetadata.vala"
			photo_metadata_set_all_string (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1, description, option);
#line 3418 "PhotoMetadata.c"
		}
	} else {
#line 835 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_STANDARD_DESCRIPTION_TAGS, photo_metadata_STANDARD_DESCRIPTION_TAGS_length1);
#line 3423 "PhotoMetadata.c"
	}
}


#line 844 "PhotoMetadata.vala"
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func) {
#line 3430 "PhotoMetadata.c"
	GeeSet* result = NULL;
	GeeSet* keywords;
	GeeSet* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 844 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 845 "PhotoMetadata.vala"
	keywords = NULL;
#line 3439 "PhotoMetadata.c"
	{
		char** tag_collection;
		int tag_collection_length1;
		int tag_it;
#line 846 "PhotoMetadata.vala"
		tag_collection = photo_metadata_KEYWORD_TAGS;
#line 3446 "PhotoMetadata.c"
		tag_collection_length1 = photo_metadata_KEYWORD_TAGS_length1;
		for (tag_it = 0; tag_it < photo_metadata_KEYWORD_TAGS_length1; tag_it = tag_it + 1) {
			char* tag;
			tag = g_strdup (tag_collection[tag_it]);
			{
				GeeCollection* values;
				gboolean _tmp0_ = FALSE;
#line 847 "PhotoMetadata.vala"
				values = GEE_COLLECTION (photo_metadata_get_string_multiple (self, tag));
#line 848 "PhotoMetadata.vala"
				if (values != NULL) {
#line 848 "PhotoMetadata.vala"
					_tmp0_ = gee_collection_get_size (values) > 0;
#line 3460 "PhotoMetadata.c"
				} else {
#line 848 "PhotoMetadata.vala"
					_tmp0_ = FALSE;
#line 3464 "PhotoMetadata.c"
				}
#line 848 "PhotoMetadata.vala"
				if (_tmp0_) {
#line 849 "PhotoMetadata.vala"
					if (keywords == NULL) {
#line 3470 "PhotoMetadata.c"
						GeeSet* _tmp1_;
#line 850 "PhotoMetadata.vala"
						keywords = (_tmp1_ = photo_metadata_create_string_set (self, compare_func), _g_object_unref0 (keywords), _tmp1_);
#line 3474 "PhotoMetadata.c"
					}
#line 852 "PhotoMetadata.vala"
					gee_collection_add_all (GEE_COLLECTION (keywords), values);
#line 3478 "PhotoMetadata.c"
				}
				_g_object_unref0 (values);
				_g_free0 (tag);
			}
		}
	}
	_tmp2_ = NULL;
#line 856 "PhotoMetadata.vala"
	if (keywords != NULL) {
#line 856 "PhotoMetadata.vala"
		_tmp3_ = gee_collection_get_size (GEE_COLLECTION (keywords)) > 0;
#line 3490 "PhotoMetadata.c"
	} else {
#line 856 "PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 3494 "PhotoMetadata.c"
	}
#line 856 "PhotoMetadata.vala"
	if (_tmp3_) {
#line 856 "PhotoMetadata.vala"
		_tmp2_ = keywords;
#line 3500 "PhotoMetadata.c"
	} else {
#line 856 "PhotoMetadata.vala"
		_tmp2_ = NULL;
#line 3504 "PhotoMetadata.c"
	}
	result = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (keywords);
#line 856 "PhotoMetadata.vala"
	return result;
#line 3510 "PhotoMetadata.c"
}


#line 859 "PhotoMetadata.vala"
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option) {
#line 859 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 859 "PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || GEE_IS_COLLECTION (keywords));
#line 861 "PhotoMetadata.vala"
	if (keywords != NULL) {
#line 862 "PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1, keywords, option);
#line 3524 "PhotoMetadata.c"
	} else {
#line 864 "PhotoMetadata.vala"
		photo_metadata_remove_tags (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1);
#line 3528 "PhotoMetadata.c"
	}
}


#line 867 "PhotoMetadata.vala"
gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
#line 3535 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 867 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3539 "PhotoMetadata.c"
	result = gexiv2_metadata_get_orientation (self->priv->exiv2) == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 868 "PhotoMetadata.vala"
	return result;
#line 3543 "PhotoMetadata.c"
}


#line 872 "PhotoMetadata.vala"
Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
#line 3549 "PhotoMetadata.c"
	Orientation result = 0;
	GExiv2Orientation orientation;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 872 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 875 "PhotoMetadata.vala"
	orientation = gexiv2_metadata_get_orientation (self->priv->exiv2);
#line 876 "PhotoMetadata.vala"
	if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 876 "PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 3562 "PhotoMetadata.c"
	} else {
#line 876 "PhotoMetadata.vala"
		_tmp1_ = orientation < ORIENTATION_MIN;
#line 3566 "PhotoMetadata.c"
	}
#line 876 "PhotoMetadata.vala"
	if (_tmp1_) {
#line 876 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 3572 "PhotoMetadata.c"
	} else {
#line 877 "PhotoMetadata.vala"
		_tmp0_ = orientation > ORIENTATION_MAX;
#line 3576 "PhotoMetadata.c"
	}
#line 876 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 3580 "PhotoMetadata.c"
		result = ORIENTATION_TOP_LEFT;
#line 878 "PhotoMetadata.vala"
		return result;
#line 3584 "PhotoMetadata.c"
	} else {
		result = (Orientation) orientation;
#line 880 "PhotoMetadata.vala"
		return result;
#line 3589 "PhotoMetadata.c"
	}
}


#line 883 "PhotoMetadata.vala"
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
#line 883 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 885 "PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (self->priv->exiv2, (GExiv2Orientation) orientation);
#line 3600 "PhotoMetadata.c"
}


#line 888 "PhotoMetadata.vala"
gboolean photo_metadata_get_gps (PhotoMetadata* self, double* longitude, char** long_ref, double* latitude, char** lat_ref, double* altitude) {
#line 3606 "PhotoMetadata.c"
	gboolean result = FALSE;
	char* _tmp0_;
	char* _tmp1_;
#line 888 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3612 "PhotoMetadata.c"
	if (long_ref != NULL) {
		*long_ref = NULL;
	}
	if (lat_ref != NULL) {
		*lat_ref = NULL;
	}
#line 890 "PhotoMetadata.vala"
	if (!gexiv2_metadata_get_gps_info (self->priv->exiv2, longitude, latitude, altitude)) {
#line 3621 "PhotoMetadata.c"
		result = FALSE;
#line 891 "PhotoMetadata.vala"
		return result;
#line 3625 "PhotoMetadata.c"
	}
#line 893 "PhotoMetadata.vala"
	*long_ref = (_tmp0_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef"), _g_free0 (*long_ref), _tmp0_);
#line 894 "PhotoMetadata.vala"
	*lat_ref = (_tmp1_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef"), _g_free0 (*lat_ref), _tmp1_);
#line 3631 "PhotoMetadata.c"
	result = TRUE;
#line 896 "PhotoMetadata.vala"
	return result;
#line 3635 "PhotoMetadata.c"
}


#line 899 "PhotoMetadata.vala"
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
#line 3641 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 899 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3645 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", exposure);
#line 900 "PhotoMetadata.vala"
	return result;
#line 3649 "PhotoMetadata.c"
}


#line 903 "PhotoMetadata.vala"
char* photo_metadata_get_exposure_string (PhotoMetadata* self) {
#line 3655 "PhotoMetadata.c"
	char* result = NULL;
	MetadataRational exposure_time = {0};
#line 903 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 905 "PhotoMetadata.vala"
	if (!photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &exposure_time)) {
#line 3662 "PhotoMetadata.c"
		result = NULL;
#line 906 "PhotoMetadata.vala"
		return result;
#line 3666 "PhotoMetadata.c"
	}
#line 908 "PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 3670 "PhotoMetadata.c"
		result = NULL;
#line 909 "PhotoMetadata.vala"
		return result;
#line 3674 "PhotoMetadata.c"
	}
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime");
#line 911 "PhotoMetadata.vala"
	return result;
#line 3679 "PhotoMetadata.c"
}


#line 914 "PhotoMetadata.vala"
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
#line 3685 "PhotoMetadata.c"
	gboolean result = FALSE;
	gboolean fetched_ok;
	gboolean _tmp0_ = FALSE;
#line 914 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 915 "PhotoMetadata.vala"
	fetched_ok = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", iso);
#line 917 "PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 3695 "PhotoMetadata.c"
		result = FALSE;
#line 918 "PhotoMetadata.vala"
		return result;
#line 3699 "PhotoMetadata.c"
	}
#line 922 "PhotoMetadata.vala"
	if ((*iso) < 6) {
#line 922 "PhotoMetadata.vala"
		_tmp0_ = TRUE;
#line 3705 "PhotoMetadata.c"
	} else {
#line 922 "PhotoMetadata.vala"
		_tmp0_ = (*iso) > 409600;
#line 3709 "PhotoMetadata.c"
	}
#line 922 "PhotoMetadata.vala"
	if (_tmp0_) {
#line 3713 "PhotoMetadata.c"
		result = FALSE;
#line 923 "PhotoMetadata.vala"
		return result;
#line 3717 "PhotoMetadata.c"
	}
	result = TRUE;
#line 925 "PhotoMetadata.vala"
	return result;
#line 3722 "PhotoMetadata.c"
}


#line 928 "PhotoMetadata.vala"
char* photo_metadata_get_iso_string (PhotoMetadata* self) {
#line 3728 "PhotoMetadata.c"
	char* result = NULL;
	glong iso = 0L;
#line 928 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 930 "PhotoMetadata.vala"
	if (!photo_metadata_get_iso (self, &iso)) {
#line 3735 "PhotoMetadata.c"
		result = NULL;
#line 931 "PhotoMetadata.vala"
		return result;
#line 3739 "PhotoMetadata.c"
	}
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings");
#line 933 "PhotoMetadata.vala"
	return result;
#line 3744 "PhotoMetadata.c"
}


#line 936 "PhotoMetadata.vala"
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
#line 3750 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 936 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3754 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.FNumber", aperture);
#line 937 "PhotoMetadata.vala"
	return result;
#line 3758 "PhotoMetadata.c"
}


#line 940 "PhotoMetadata.vala"
char* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
#line 3764 "PhotoMetadata.c"
	char* result = NULL;
	MetadataRational aperture = {0};
	double aperture_value;
	const char* _tmp0_;
	const char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 940 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 942 "PhotoMetadata.vala"
	if (!photo_metadata_get_aperture (self, &aperture)) {
#line 3776 "PhotoMetadata.c"
		result = NULL;
#line 943 "PhotoMetadata.vala"
		return result;
#line 3780 "PhotoMetadata.c"
	}
#line 945 "PhotoMetadata.vala"
	aperture_value = ((double) aperture.numerator) / ((double) aperture.denominator);
#line 946 "PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 3786 "PhotoMetadata.c"
	_tmp0_ = NULL;
#line 948 "PhotoMetadata.vala"
	if (pango_formatted) {
#line 948 "PhotoMetadata.vala"
		_tmp0_ = "<i>f</i>/";
#line 3792 "PhotoMetadata.c"
	} else {
#line 948 "PhotoMetadata.vala"
		_tmp0_ = "f/";
#line 3796 "PhotoMetadata.c"
	}
	_tmp1_ = NULL;
#line 949 "PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == 0) {
#line 949 "PhotoMetadata.vala"
		_tmp1_ = "%.0f";
#line 3803 "PhotoMetadata.c"
	} else {
#line 949 "PhotoMetadata.vala"
		_tmp1_ = "%.1f";
#line 3807 "PhotoMetadata.c"
	}
	result = (_tmp3_ = g_strconcat (_tmp0_, _tmp2_ = g_strdup_printf (_tmp1_, aperture_value), NULL), _g_free0 (_tmp2_), _tmp3_);
#line 948 "PhotoMetadata.vala"
	return result;
#line 3812 "PhotoMetadata.c"
}


#line 952 "PhotoMetadata.vala"
char* photo_metadata_get_camera_make (PhotoMetadata* self) {
#line 3818 "PhotoMetadata.c"
	char* result = NULL;
#line 952 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3822 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Make");
#line 953 "PhotoMetadata.vala"
	return result;
#line 3826 "PhotoMetadata.c"
}


#line 956 "PhotoMetadata.vala"
char* photo_metadata_get_camera_model (PhotoMetadata* self) {
#line 3832 "PhotoMetadata.c"
	char* result = NULL;
#line 956 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3836 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Model");
#line 957 "PhotoMetadata.vala"
	return result;
#line 3840 "PhotoMetadata.c"
}


#line 960 "PhotoMetadata.vala"
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
#line 3846 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 960 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3850 "PhotoMetadata.c"
	result = photo_metadata_get_long (self, "Exif.Photo.Flash", flash);
#line 962 "PhotoMetadata.vala"
	return result;
#line 3854 "PhotoMetadata.c"
}


#line 965 "PhotoMetadata.vala"
char* photo_metadata_get_flash_string (PhotoMetadata* self) {
#line 3860 "PhotoMetadata.c"
	char* result = NULL;
#line 965 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3864 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash");
#line 967 "PhotoMetadata.vala"
	return result;
#line 3868 "PhotoMetadata.c"
}


#line 970 "PhotoMetadata.vala"
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
#line 3874 "PhotoMetadata.c"
	gboolean result = FALSE;
#line 970 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 3878 "PhotoMetadata.c"
	result = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", focal_length);
#line 971 "PhotoMetadata.vala"
	return result;
#line 3882 "PhotoMetadata.c"
}


#line 974 "PhotoMetadata.vala"
char* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
#line 3888 "PhotoMetadata.c"
	char* result = NULL;
#line 974 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3892 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength");
#line 975 "PhotoMetadata.vala"
	return result;
#line 3896 "PhotoMetadata.c"
}


#line 983 "PhotoMetadata.vala"
char* photo_metadata_get_artist (PhotoMetadata* self) {
#line 3902 "PhotoMetadata.c"
	char* result = NULL;
#line 983 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3906 "PhotoMetadata.c"
	result = photo_metadata_get_first_string_interpreted (self, photo_metadata_ARTIST_TAGS, photo_metadata_ARTIST_TAGS_length1);
#line 984 "PhotoMetadata.vala"
	return result;
#line 3910 "PhotoMetadata.c"
}


#line 987 "PhotoMetadata.vala"
char* photo_metadata_get_copyright (PhotoMetadata* self) {
#line 3916 "PhotoMetadata.c"
	char* result = NULL;
#line 987 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3920 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright");
#line 988 "PhotoMetadata.vala"
	return result;
#line 3924 "PhotoMetadata.c"
}


#line 991 "PhotoMetadata.vala"
char* photo_metadata_get_software (PhotoMetadata* self) {
#line 3930 "PhotoMetadata.c"
	char* result = NULL;
#line 991 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3934 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Image.Software");
#line 992 "PhotoMetadata.vala"
	return result;
#line 3938 "PhotoMetadata.c"
}


#line 995 "PhotoMetadata.vala"
void photo_metadata_set_software (PhotoMetadata* self, const char* software, const char* version) {
#line 3944 "PhotoMetadata.c"
	char* _tmp0_;
#line 995 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 995 "PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 995 "PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 997 "PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp0_ = g_strdup_printf ("%s %s", software, version));
#line 3954 "PhotoMetadata.c"
	_g_free0 (_tmp0_);
#line 999 "PhotoMetadata.vala"
	if (photo_metadata_has_iptc (self)) {
#line 1000 "PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", software);
#line 1001 "PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version);
#line 3962 "PhotoMetadata.c"
	}
}


#line 1005 "PhotoMetadata.vala"
void photo_metadata_remove_software (PhotoMetadata* self) {
#line 1005 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1006 "PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1007 "PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1008 "PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 3977 "PhotoMetadata.c"
}


#line 1011 "PhotoMetadata.vala"
char* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
#line 3983 "PhotoMetadata.c"
	char* result = NULL;
#line 1011 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 3987 "PhotoMetadata.c"
	result = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue");
#line 1012 "PhotoMetadata.vala"
	return result;
#line 3991 "PhotoMetadata.c"
}


#line 1021 "PhotoMetadata.vala"
Rating photo_metadata_get_rating (PhotoMetadata* self) {
#line 3997 "PhotoMetadata.c"
	Rating result = 0;
	char* rating_string;
	Rating _tmp0_ = 0;
#line 1021 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1022 "PhotoMetadata.vala"
	rating_string = photo_metadata_get_first_string (self, photo_metadata_RATING_TAGS, photo_metadata_RATING_TAGS_length1);
#line 1023 "PhotoMetadata.vala"
	if (rating_string == NULL) {
#line 1023 "PhotoMetadata.vala"
		_tmp0_ = RATING_UNRATED;
#line 4009 "PhotoMetadata.c"
	} else {
#line 1023 "PhotoMetadata.vala"
		_tmp0_ = rating_unserialize (atoi (rating_string));
#line 4013 "PhotoMetadata.c"
	}
	result = _tmp0_;
	_g_free0 (rating_string);
#line 1023 "PhotoMetadata.vala"
	return result;
#line 4019 "PhotoMetadata.c"
}


#line 1031 "PhotoMetadata.vala"
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating) {
#line 4025 "PhotoMetadata.c"
	char* _tmp0_;
#line 1031 "PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1032 "PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp0_ = g_strdup_printf ("%i", rating_serialize (rating)));
#line 4031 "PhotoMetadata.c"
	_g_free0 (_tmp0_);
}


static gpointer _media_metadata_ref0 (gpointer self) {
	return self ? media_metadata_ref (self) : NULL;
}


#line 102 "PhotoMetadata.vala"
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props) {
#line 4043 "PhotoMetadata.c"
	PhotoMetadataInternalPhotoPreview* self = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	PhotoMetadata* _tmp2_;
#line 102 "PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 102 "PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 102 "PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 104 "PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, (_tmp1_ = (dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props)), _tmp0_), &_tmp1_), gexiv2_preview_properties_get_size (props), gexiv2_preview_properties_get_mime_type (props), gexiv2_preview_properties_get_extension (props));
#line 107 "PhotoMetadata.vala"
	self->owner = (_tmp2_ = _media_metadata_ref0 (owner), _media_metadata_unref0 (self->owner), _tmp2_);
#line 108 "PhotoMetadata.vala"
	self->number = number;
#line 4060 "PhotoMetadata.c"
	return self;
}


#line 102 "PhotoMetadata.vala"
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const char* name, guint number, GExiv2PreviewProperties* props) {
#line 102 "PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 4069 "PhotoMetadata.c"
}


static guint8* _vala_array_dup25 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


#line 111 "PhotoMetadata.vala"
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
#line 4080 "PhotoMetadata.c"
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	gint props_length1;
	gint _props_size_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** props;
	GExiv2PreviewImage* _tmp2_;
	gint _tmp3_;
	guint8* _tmp4_;
	guint8* _tmp5_;
	guchar** _tmp6_;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (base);
	props = (_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->owner->priv->exiv2), props_length1 = _vala_array_length (_tmp0_), _props_size_ = props_length1, _tmp1_);
#line 113 "PhotoMetadata.vala"
	g_assert ((props != NULL) && (props_length1 > self->number));
#line 4097 "PhotoMetadata.c"
	result = (_tmp6_ = (_tmp5_ = (_tmp4_ = gexiv2_preview_image_get_data (_tmp2_ = gexiv2_metadata_get_preview_image (self->owner->priv->exiv2, props[self->number]), &_tmp3_), (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup25 (_tmp4_, _tmp3_)), _gexiv2_preview_image_free0 (_tmp2_), _tmp5_), *result_length1 = _tmp3_, _tmp6_);
#line 115 "PhotoMetadata.vala"
	return result;
#line 4101 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_metadata_internal_photo_preview_finalize;
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (obj);
	_media_metadata_unref0 (self->owner);
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	char** _tmp0_ = NULL;
	char** _tmp1_ = NULL;
	char** _tmp2_ = NULL;
	char** _tmp3_ = NULL;
	char** _tmp4_ = NULL;
	char** _tmp5_ = NULL;
	char** _tmp6_ = NULL;
	char** _tmp7_ = NULL;
	char** _tmp8_ = NULL;
	char** _tmp9_ = NULL;
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
	MEDIA_METADATA_CLASS (klass)->finalize = photo_metadata_finalize;
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
	MEDIA_METADATA_CLASS (klass)->read_from_file = photo_metadata_real_read_from_file;
	MEDIA_METADATA_CLASS (klass)->get_creation_date_time = photo_metadata_real_get_creation_date_time;
	MEDIA_METADATA_CLASS (klass)->get_title = photo_metadata_real_get_title;
	photo_metadata_DATE_TIME_TAGS = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("Exif.Image.DateTime"), _tmp0_[1] = g_strdup ("Xmp.tiff.DateTime"), _tmp0_[2] = g_strdup ("Xmp.xmp.ModifyDate"), _tmp0_);
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = (_tmp1_ = g_new0 (char*, 6 + 1), _tmp1_[0] = g_strdup ("Exif.Photo.DateTimeOriginal"), _tmp1_[1] = g_strdup ("Xmp.exif.DateTimeOriginal"), _tmp1_[2] = g_strdup ("Xmp.xmp.CreateDate"), _tmp1_[3] = g_strdup ("Exif.Photo.DateTimeDigitized"), _tmp1_[4] = g_strdup ("Xmp.exif.DateTimeDigitized"), _tmp1_[5] = g_strdup ("Exif.Image.DateTime"), _tmp1_);
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = (_tmp2_ = g_new0 (char*, 2 + 1), _tmp2_[0] = g_strdup ("Exif.Photo.DateTimeDigitized"), _tmp2_[1] = g_strdup ("Xmp.exif.DateTimeDigitized"), _tmp2_);
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
	photo_metadata_WIDTH_TAGS = (_tmp3_ = g_new0 (char*, 4 + 1), _tmp3_[0] = g_strdup ("Exif.Photo.PixelXDimension"), _tmp3_[1] = g_strdup ("Xmp.exif.PixelXDimension"), _tmp3_[2] = g_strdup ("Xmp.tiff.ImageWidth"), _tmp3_[3] = g_strdup ("Xmp.exif.PixelXDimension"), _tmp3_);
	photo_metadata_WIDTH_TAGS_length1 = 4;
	photo_metadata_HEIGHT_TAGS = (_tmp4_ = g_new0 (char*, 4 + 1), _tmp4_[0] = g_strdup ("Exif.Photo.PixelYDimension"), _tmp4_[1] = g_strdup ("Xmp.exif.PixelYDimension"), _tmp4_[2] = g_strdup ("Xmp.tiff.ImageHeight"), _tmp4_[3] = g_strdup ("Xmp.exif.PixelYDimension"), _tmp4_);
	photo_metadata_HEIGHT_TAGS_length1 = 4;
	photo_metadata_STANDARD_TITLE_TAGS = (_tmp5_ = g_new0 (char*, 4 + 1), _tmp5_[0] = g_strdup ("Iptc.Application2.Caption"), _tmp5_[1] = g_strdup ("Xmp.dc.title"), _tmp5_[2] = g_strdup ("Iptc.Application2.Headline"), _tmp5_[3] = g_strdup ("Xmp.photoshop.Headline"), _tmp5_);
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
	photo_metadata_STANDARD_DESCRIPTION_TAGS = (_tmp6_ = g_new0 (char*, 1 + 1), _tmp6_[0] = g_strdup ("Xmp.dc.description"), _tmp6_);
	photo_metadata_STANDARD_DESCRIPTION_TAGS_length1 = 1;
	photo_metadata_KEYWORD_TAGS = (_tmp7_ = g_new0 (char*, 2 + 1), _tmp7_[0] = g_strdup ("Xmp.dc.subject"), _tmp7_[1] = g_strdup ("Iptc.Application2.Keywords"), _tmp7_);
	photo_metadata_KEYWORD_TAGS_length1 = 2;
	photo_metadata_ARTIST_TAGS = (_tmp8_ = g_new0 (char*, 2 + 1), _tmp8_[0] = g_strdup ("Exif.Image.Artist"), _tmp8_[1] = g_strdup ("Exif.Canon.OwnerName"), _tmp8_);
	photo_metadata_ARTIST_TAGS_length1 = 2;
	photo_metadata_RATING_TAGS = (_tmp9_ = g_new0 (char*, 3 + 1), _tmp9_[0] = g_strdup ("Xmp.xmp.Rating"), _tmp9_[1] = g_strdup ("Iptc.Application2.Urgency"), _tmp9_[2] = g_strdup ("Xmp.photoshop.Urgency"), _tmp9_);
	photo_metadata_RATING_TAGS_length1 = 3;
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
	self->priv->exiv2 = gexiv2_metadata_new ();
	self->priv->exif = NULL;
	self->priv->source_name = g_strdup ("<uninitialized>");
}


static void photo_metadata_finalize (MediaMetadata* obj) {
	PhotoMetadata * self;
	self = PHOTO_METADATA (obj);
	_gexiv2_metadata_free0 (self->priv->exiv2);
	_exif_data_unref0 (self->priv->exif);
	_g_free0 (self->priv->source_name);
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




