/* file_util.c generated by valac 0.10.3, the Vala compiler
 * generated from file_util.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existance.*/
/**/
/* This function is thread-safe.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean claim_file (GFile* file, GError** error);
GFile* generate_unique_file (GFile* dir, const char* basename, gboolean* collision, GError** error);
void disassemble_filename (const char* basename, char** name, char** ext);
glong find_last_offset (const char* str, gchar c);
guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error);
void delete_all_files (GFile* dir, GeeSet* exceptions, GCancellable* cancellable, GError** error);
time_t query_file_modified (GFile* file, GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir, GError** error);
char* get_display_pathname (GFile* file);
char* strip_pretty_path (const char* path);
char* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 12 "file_util.vala"
gboolean claim_file (GFile* file, GError** error) {
#line 54 "file_util.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 12 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 59 "file_util.c"
	{
		GFileOutputStream* _tmp0_;
#line 14 "file_util.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 64 "file_util.c"
		_g_object_unref0 (_tmp0_);
		if (_inner_error_ != NULL) {
			goto __catch430_g_error;
		}
		result = TRUE;
#line 17 "file_util.vala"
		return result;
#line 72 "file_util.c"
	}
	goto __finally430;
	__catch430_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 20 "file_util.vala"
			if (!g_error_matches (err, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 83 "file_util.c"
				char* _tmp1_;
#line 21 "file_util.vala"
				g_warning ("file_util.vala:21: claim_file %s: %s", _tmp1_ = g_file_get_path (file), err->message);
#line 87 "file_util.c"
				_g_free0 (_tmp1_);
				_inner_error_ = _g_error_copy0 (err);
				{
					_g_error_free0 (err);
					goto __finally430;
				}
			}
			result = FALSE;
			_g_error_free0 (err);
#line 26 "file_util.vala"
			return result;
#line 99 "file_util.c"
		}
	}
	__finally430:
	{
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
}


#line 36 "file_util.vala"
GFile* generate_unique_file (GFile* dir, const char* basename, gboolean* collision, GError** error) {
#line 112 "file_util.c"
	GFile* result = NULL;
	GFile* file;
	gboolean _tmp0_;
	char* name;
	char* ext;
	char* _tmp1_ = NULL;
	char* _tmp2_;
	char* _tmp3_ = NULL;
	char* _tmp4_;
	char* _tmp11_;
	GError * _inner_error_ = NULL;
#line 36 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (dir), NULL);
#line 36 "file_util.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 38 "file_util.vala"
	file = g_file_get_child (dir, basename);
#line 39 "file_util.vala"
	_tmp0_ = claim_file (file, &_inner_error_);
#line 132 "file_util.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		return NULL;
	}
#line 39 "file_util.vala"
	if (_tmp0_) {
#line 40 "file_util.vala"
		*collision = FALSE;
#line 142 "file_util.c"
		result = file;
#line 42 "file_util.vala"
		return result;
#line 146 "file_util.c"
	}
#line 46 "file_util.vala"
	*collision = TRUE;
#line 150 "file_util.c"
	name = NULL;
	ext = NULL;
#line 49 "file_util.vala"
	(disassemble_filename (basename, &_tmp1_, &_tmp3_), name = (_tmp2_ = _tmp1_, _g_free0 (name), _tmp2_));
#line 49 "file_util.vala"
	ext = (_tmp4_ = _tmp3_, _g_free0 (ext), _tmp4_);
#line 157 "file_util.c"
	{
		gint ctr;
#line 52 "file_util.vala"
		ctr = 1;
#line 162 "file_util.c"
		{
			gboolean _tmp5_;
#line 52 "file_util.vala"
			_tmp5_ = TRUE;
#line 52 "file_util.vala"
			while (TRUE) {
#line 169 "file_util.c"
				char* _tmp6_;
				char* new_name;
				GFile* _tmp9_;
				gboolean _tmp10_;
#line 52 "file_util.vala"
				if (!_tmp5_) {
#line 52 "file_util.vala"
					ctr++;
#line 178 "file_util.c"
				}
#line 52 "file_util.vala"
				_tmp5_ = FALSE;
#line 52 "file_util.vala"
				if (!(ctr < G_MAXINT)) {
#line 52 "file_util.vala"
					break;
#line 186 "file_util.c"
				}
				_tmp6_ = NULL;
#line 53 "file_util.vala"
				if (ext != NULL) {
#line 191 "file_util.c"
					char* _tmp7_;
#line 53 "file_util.vala"
					_tmp6_ = (_tmp7_ = g_strdup_printf ("%s_%d.%s", name, ctr, ext), _g_free0 (_tmp6_), _tmp7_);
#line 195 "file_util.c"
				} else {
					char* _tmp8_;
#line 53 "file_util.vala"
					_tmp6_ = (_tmp8_ = g_strdup_printf ("%s_%d", name, ctr), _g_free0 (_tmp6_), _tmp8_);
#line 200 "file_util.c"
				}
#line 53 "file_util.vala"
				new_name = g_strdup (_tmp6_);
#line 55 "file_util.vala"
				file = (_tmp9_ = g_file_get_child (dir, new_name), _g_object_unref0 (file), _tmp9_);
#line 56 "file_util.vala"
				_tmp10_ = claim_file (file, &_inner_error_);
#line 208 "file_util.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (new_name);
					_g_free0 (_tmp6_);
					_g_free0 (ext);
					_g_free0 (name);
					_g_object_unref0 (file);
					return NULL;
				}
#line 56 "file_util.vala"
				if (_tmp10_) {
#line 220 "file_util.c"
					result = file;
					_g_free0 (new_name);
					_g_free0 (_tmp6_);
					_g_free0 (ext);
					_g_free0 (name);
#line 57 "file_util.vala"
					return result;
#line 228 "file_util.c"
				}
				_g_free0 (new_name);
				_g_free0 (_tmp6_);
			}
		}
	}
#line 60 "file_util.vala"
	g_warning ("file_util.vala:60: generate_unique_filename %s for %s: unable to claim" \
" file", _tmp11_ = g_file_get_path (dir), basename);
#line 237 "file_util.c"
	_g_free0 (_tmp11_);
	result = NULL;
	_g_free0 (ext);
	_g_free0 (name);
	_g_object_unref0 (file);
#line 62 "file_util.vala"
	return result;
#line 245 "file_util.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 255 "file_util.c"
}


#line 1110 "glib-2.0.vapi"
static char* string_substring (const char* self, glong offset, glong len) {
#line 261 "file_util.c"
	char* result = NULL;
	glong string_length;
	const char* start;
#line 1110 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1111 "glib-2.0.vapi"
	string_length = string_get_length (self);
#line 1112 "glib-2.0.vapi"
	if (offset < 0) {
#line 1113 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1114 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= 0, NULL);
#line 275 "file_util.c"
	} else {
#line 1116 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 279 "file_util.c"
	}
#line 1118 "glib-2.0.vapi"
	if (len < 0) {
#line 1119 "glib-2.0.vapi"
		len = string_length - offset;
#line 285 "file_util.c"
	}
#line 1121 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1122 "glib-2.0.vapi"
	start = g_utf8_offset_to_pointer (self, offset);
#line 291 "file_util.c"
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
#line 1123 "glib-2.0.vapi"
	return result;
#line 295 "file_util.c"
}


#line 65 "file_util.vala"
void disassemble_filename (const char* basename, char** name, char** ext) {
#line 301 "file_util.c"
	glong offset;
#line 65 "file_util.vala"
	g_return_if_fail (basename != NULL);
#line 305 "file_util.c"
	if (name != NULL) {
		*name = NULL;
	}
	if (ext != NULL) {
		*ext = NULL;
	}
#line 66 "file_util.vala"
	offset = find_last_offset (basename, '.');
#line 67 "file_util.vala"
	if (offset <= 0) {
#line 316 "file_util.c"
		char* _tmp0_;
		char* _tmp1_;
#line 68 "file_util.vala"
		*name = (_tmp0_ = g_strdup (basename), _g_free0 (*name), _tmp0_);
#line 69 "file_util.vala"
		*ext = (_tmp1_ = NULL, _g_free0 (*ext), _tmp1_);
#line 323 "file_util.c"
	} else {
		char* _tmp2_;
		char* _tmp3_;
#line 71 "file_util.vala"
		*name = (_tmp2_ = string_substring (basename, (glong) 0, offset), _g_free0 (*name), _tmp2_);
#line 72 "file_util.vala"
		*ext = (_tmp3_ = string_substring (basename, offset + 1, (glong) (-1)), _g_free0 (*ext), _tmp3_);
#line 331 "file_util.c"
	}
}


#line 77 "file_util.vala"
guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error) {
#line 338 "file_util.c"
	guint64 result = 0ULL;
	GFileType type;
	GFileEnumerator* enumerator;
	guint64 total_bytes;
	GFileInfo* info;
	GError * _inner_error_ = NULL;
#line 77 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (file_or_dir), 0ULL);
#line 77 "file_util.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0ULL);
#line 78 "file_util.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 79 "file_util.vala"
	if (type == G_FILE_TYPE_REGULAR) {
#line 353 "file_util.c"
		GFileInfo* info;
#line 80 "file_util.vala"
		info = NULL;
#line 357 "file_util.c"
		{
			GFileInfo* _tmp0_;
			GFileInfo* _tmp1_;
#line 82 "file_util.vala"
			_tmp0_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 363 "file_util.c"
			if (_inner_error_ != NULL) {
				goto __catch431_g_error;
			}
#line 82 "file_util.vala"
			info = (_tmp1_ = _tmp0_, _g_object_unref0 (info), _tmp1_);
#line 369 "file_util.c"
		}
		goto __finally431;
		__catch431_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp2_;
#line 85 "file_util.vala"
				if (g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 381 "file_util.c"
					_inner_error_ = _g_error_copy0 (err);
					{
						_g_error_free0 (err);
						_g_object_unref0 (info);
						goto __finally431;
					}
				}
#line 88 "file_util.vala"
				g_debug ("file_util.vala:88: Unable to query filesize for %s: %s", _tmp2_ = g_file_get_path (file_or_dir), err->message);
#line 391 "file_util.c"
				_g_free0 (_tmp2_);
				result = (guint64) 0;
				_g_error_free0 (err);
				_g_object_unref0 (info);
#line 90 "file_util.vala"
				return result;
#line 398 "file_util.c"
			}
		}
		__finally431:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			return 0ULL;
		}
		result = (guint64) g_file_info_get_size (info);
		_g_object_unref0 (info);
#line 93 "file_util.vala"
		return result;
#line 411 "file_util.c"
	} else {
#line 94 "file_util.vala"
		if (type != G_FILE_TYPE_DIRECTORY) {
#line 415 "file_util.c"
			result = (guint64) 0;
#line 95 "file_util.vala"
			return result;
#line 419 "file_util.c"
		}
	}
	enumerator = NULL;
	{
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 100 "file_util.vala"
		_tmp3_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 428 "file_util.c"
		if (_inner_error_ != NULL) {
			goto __catch432_g_error;
		}
#line 100 "file_util.vala"
		enumerator = (_tmp4_ = _tmp3_, _g_object_unref0 (enumerator), _tmp4_);
#line 102 "file_util.vala"
		if (enumerator == NULL) {
#line 436 "file_util.c"
			result = (guint64) 0;
			_g_object_unref0 (enumerator);
#line 103 "file_util.vala"
			return result;
#line 441 "file_util.c"
		}
	}
	goto __finally432;
	__catch432_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			gboolean _tmp5_ = FALSE;
#line 106 "file_util.vala"
			if (g_error_matches (err, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 106 "file_util.vala"
				_tmp5_ = TRUE;
#line 456 "file_util.c"
			} else {
#line 106 "file_util.vala"
				_tmp5_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 460 "file_util.c"
			}
#line 106 "file_util.vala"
			if (_tmp5_) {
#line 464 "file_util.c"
				result = (guint64) 0;
				_g_error_free0 (err);
				_g_object_unref0 (enumerator);
#line 107 "file_util.vala"
				return result;
#line 470 "file_util.c"
			}
			_inner_error_ = _g_error_copy0 (err);
			{
				_g_error_free0 (err);
				_g_object_unref0 (enumerator);
				goto __finally432;
			}
			_g_error_free0 (err);
		}
	}
	__finally432:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (enumerator);
		return 0ULL;
	}
#line 112 "file_util.vala"
	total_bytes = (guint64) 0;
#line 114 "file_util.vala"
	info = NULL;
#line 115 "file_util.vala"
	while (TRUE) {
#line 493 "file_util.c"
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFile* _tmp8_;
		guint64 _tmp9_;
		guint64 _tmp10_;
#line 115 "file_util.vala"
		_tmp6_ = g_file_enumerator_next_file (enumerator, cancellable, &_inner_error_);
#line 501 "file_util.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return 0ULL;
		}
#line 115 "file_util.vala"
		if (!((info = (_tmp7_ = _tmp6_, _g_object_unref0 (info), _tmp7_)) != NULL)) {
#line 115 "file_util.vala"
			break;
#line 512 "file_util.c"
		}
#line 116 "file_util.vala"
		_tmp10_ = (_tmp9_ = query_total_file_size (_tmp8_ = g_file_get_child (file_or_dir, g_file_info_get_name (info)), cancellable, &_inner_error_), _g_object_unref0 (_tmp8_), _tmp9_);
#line 516 "file_util.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return 0ULL;
		}
#line 116 "file_util.vala"
		total_bytes = total_bytes + _tmp10_;
#line 525 "file_util.c"
	}
	result = total_bytes;
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
#line 118 "file_util.vala"
	return result;
#line 532 "file_util.c"
}


#line 123 "file_util.vala"
void delete_all_files (GFile* dir, GeeSet* exceptions, GCancellable* cancellable, GError** error) {
#line 538 "file_util.c"
	GFileType type;
	GFileEnumerator* enumerator;
	GFileInfo* info;
	GError * _inner_error_ = NULL;
#line 123 "file_util.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 123 "file_util.vala"
	g_return_if_fail ((exceptions == NULL) || GEE_IS_SET (exceptions));
#line 123 "file_util.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 125 "file_util.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 126 "file_util.vala"
	if (type != G_FILE_TYPE_DIRECTORY) {
#line 553 "file_util.c"
		char* _tmp0_;
		char* _tmp1_;
		GError* _tmp2_;
		_inner_error_ = (_tmp2_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp1_ = g_strdup_printf ("%s is not a directory", _tmp0_ = g_file_get_path (dir))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
		{
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
#line 129 "file_util.vala"
	enumerator = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
#line 565 "file_util.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 131 "file_util.vala"
	info = NULL;
#line 132 "file_util.vala"
	while (TRUE) {
#line 574 "file_util.c"
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GFile* file;
#line 132 "file_util.vala"
		_tmp3_ = g_file_enumerator_next_file (enumerator, cancellable, &_inner_error_);
#line 581 "file_util.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return;
		}
#line 132 "file_util.vala"
		if (!((info = (_tmp4_ = _tmp3_, _g_object_unref0 (info), _tmp4_)) != NULL)) {
#line 132 "file_util.vala"
			break;
#line 592 "file_util.c"
		}
#line 133 "file_util.vala"
		if (g_file_info_get_file_type (info) != G_FILE_TYPE_REGULAR) {
#line 134 "file_util.vala"
			continue;
#line 598 "file_util.c"
		}
#line 136 "file_util.vala"
		if (exceptions != NULL) {
#line 136 "file_util.vala"
			_tmp5_ = gee_collection_contains (GEE_COLLECTION (exceptions), g_file_info_get_name (info));
#line 604 "file_util.c"
		} else {
#line 136 "file_util.vala"
			_tmp5_ = FALSE;
#line 608 "file_util.c"
		}
#line 136 "file_util.vala"
		if (_tmp5_) {
#line 137 "file_util.vala"
			continue;
#line 614 "file_util.c"
		}
#line 139 "file_util.vala"
		file = g_file_get_child (dir, g_file_info_get_name (info));
#line 618 "file_util.c"
		{
#line 141 "file_util.vala"
			g_file_delete (file, cancellable, &_inner_error_);
#line 622 "file_util.c"
			if (_inner_error_ != NULL) {
				goto __catch433_g_error;
			}
		}
		goto __finally433;
		__catch433_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp6_;
#line 143 "file_util.vala"
				g_warning ("file_util.vala:143: Unable to delete file %s: %s", _tmp6_ = g_file_get_path (file), err->message);
#line 637 "file_util.c"
				_g_free0 (_tmp6_);
				_g_error_free0 (err);
			}
		}
		__finally433:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return;
		}
		_g_object_unref0 (file);
	}
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
}


#line 148 "file_util.vala"
time_t query_file_modified (GFile* file, GError** error) {
#line 659 "file_util.c"
	time_t result = 0;
	GFileInfo* info;
	GTimeVal timestamp = {0};
	GError * _inner_error_ = NULL;
#line 148 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (file), 0);
#line 149 "file_util.vala"
	info = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 668 "file_util.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return 0;
	}
	g_get_current_time (&timestamp);
#line 153 "file_util.vala"
	g_file_info_get_modification_time (info, &timestamp);
#line 676 "file_util.c"
	result = (time_t) timestamp.tv_sec;
	_g_object_unref0 (info);
#line 155 "file_util.vala"
	return result;
#line 681 "file_util.c"
}


#line 158 "file_util.vala"
gboolean query_is_directory (GFile* file) {
#line 687 "file_util.c"
	gboolean result = FALSE;
#line 158 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 691 "file_util.c"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 159 "file_util.vala"
	return result;
#line 695 "file_util.c"
}


#line 162 "file_util.vala"
gboolean query_is_directory_empty (GFile* dir, GError** error) {
#line 701 "file_util.c"
	gboolean result = FALSE;
	GFileEnumerator* enumerator;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
#line 162 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 163 "file_util.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 712 "file_util.c"
		result = FALSE;
#line 164 "file_util.vala"
		return result;
#line 716 "file_util.c"
	}
#line 166 "file_util.vala"
	enumerator = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 720 "file_util.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
#line 168 "file_util.vala"
	if (enumerator == NULL) {
#line 727 "file_util.c"
		result = FALSE;
		_g_object_unref0 (enumerator);
#line 169 "file_util.vala"
		return result;
#line 732 "file_util.c"
	}
#line 171 "file_util.vala"
	_tmp0_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error_);
#line 736 "file_util.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (enumerator);
		return FALSE;
	}
	result = (_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _g_object_unref0 (_tmp1_), _tmp2_);
	_g_object_unref0 (enumerator);
#line 171 "file_util.vala"
	return result;
#line 746 "file_util.c"
	_g_object_unref0 (enumerator);
}


#line 174 "file_util.vala"
char* get_display_pathname (GFile* file) {
#line 753 "file_util.c"
	char* result = NULL;
	char* path;
	char* home;
#line 174 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 176 "file_util.vala"
	path = g_file_get_parse_name (file);
#line 177 "file_util.vala"
	home = g_strdup (g_get_home_dir ());
#line 179 "file_util.vala"
	if (_vala_strcmp0 (path, home) == 0) {
#line 765 "file_util.c"
		result = g_strdup ("~");
		_g_free0 (home);
		_g_free0 (path);
#line 180 "file_util.vala"
		return result;
#line 771 "file_util.c"
	}
#line 182 "file_util.vala"
	if (g_str_has_prefix (path, home)) {
#line 775 "file_util.c"
		char* _tmp0_;
		char* _tmp1_;
		result = (_tmp1_ = g_strdup_printf ("~%s", _tmp0_ = string_substring (path, string_get_length (home), -1)), _g_free0 (_tmp0_), _tmp1_);
		_g_free0 (home);
		_g_free0 (path);
#line 183 "file_util.vala"
		return result;
#line 783 "file_util.c"
	}
	result = path;
	_g_free0 (home);
#line 185 "file_util.vala"
	return result;
#line 789 "file_util.c"
}


#line 188 "file_util.vala"
char* strip_pretty_path (const char* path) {
#line 795 "file_util.c"
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
#line 188 "file_util.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 189 "file_util.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 803 "file_util.c"
		result = g_strdup (path);
#line 190 "file_util.vala"
		return result;
#line 807 "file_util.c"
	}
	result = (_tmp1_ = g_strconcat (g_get_home_dir (), _tmp0_ = string_substring (path, (glong) 1, -1), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 192 "file_util.vala"
	return result;
#line 812 "file_util.c"
}


#line 195 "file_util.vala"
char* get_file_info_id (GFileInfo* info) {
#line 818 "file_util.c"
	char* result = NULL;
#line 195 "file_util.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), NULL);
#line 822 "file_util.c"
	result = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE));
#line 196 "file_util.vala"
	return result;
#line 826 "file_util.c"
}


#line 200 "file_util.vala"
void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error) {
#line 832 "file_util.c"
	GError * _inner_error_ = NULL;
#line 200 "file_util.vala"
	g_return_if_fail (G_IS_INPUT_STREAM (input));
#line 201 "file_util.vala"
	while (TRUE) {
#line 201 "file_util.vala"
		if (!(skip_amount > 0)) {
#line 201 "file_util.vala"
			break;
#line 842 "file_util.c"
		}
#line 203 "file_util.vala"
		if (skip_amount >= G_MAXSSIZE) {
#line 204 "file_util.vala"
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error_);
#line 848 "file_util.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				return;
			}
#line 205 "file_util.vala"
			skip_amount = skip_amount - ((guint64) G_MAXSSIZE);
#line 855 "file_util.c"
		} else {
#line 207 "file_util.vala"
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error_);
#line 859 "file_util.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				return;
			}
#line 208 "file_util.vala"
			skip_amount = (guint64) 0;
#line 866 "file_util.c"
		}
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




