/* image_util.c generated by valac 0.10.3, the Vala compiler
 * generated from image_util.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* This is only needed until the following ticket is closed (see EventDirectoryItem's paint_border)*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=617000*/

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <float.h>
#include <math.h>
#include <cairo.h>


#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _Dimensions {
	gint width;
	gint height;
};



void gdk_gc_get_values (GdkGC* gc, GdkGCValues* values);
gboolean is_color_parsable (const char* spec);
void parse_color (const char* spec, GdkColor* result);
void fetch_color (const char* spec, GdkDrawable* drawable, GdkColor* result);
GType page_window_get_type (void) G_GNUC_CONST;
GType app_window_get_type (void) G_GNUC_CONST;
AppWindow* app_window_get_instance (void);
guint32 convert_color (guint16 component);
guint32 convert_rgba (GdkColor* c, guint8 alpha);
#define MIN_SCALED_WIDTH 10
#define MIN_SCALED_HEIGHT 10
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
#define DEGREE (G_PI / 180.0)
void draw_rounded_corners_filled (GdkGC* gc, GdkDrawable* drawable, Dimensions* dim, GdkPoint* origin, double radius_proportion);
cairo_t* get_rounded_corners_context (GdkDrawable* drawable, Dimensions* dim, GdkPoint* origin, double radius_proportion);
gint dimensions_minor_axis (Dimensions *self);
guchar shift_color_byte (gint b, gint shift);
void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha);
gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect);
void coord_scaled_in_space (gint x, gint y, Dimensions* original, Dimensions* scaled, GdkPoint* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b);
char* rectangle_to_string (GdkRectangle* rect);
void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result);
gint radius_scaled_in_space (gint radius, Dimensions* original, Dimensions* scaled);
void scale_point (GdkPoint* p, double factor, GdkPoint* result);
void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);
void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);



#line 11 "image_util.vala"
gboolean is_color_parsable (const char* spec) {
#line 97 "image_util.c"
	gboolean result = FALSE;
	GdkColor color = {0};
#line 11 "image_util.vala"
	g_return_val_if_fail (spec != NULL, FALSE);
#line 102 "image_util.c"
	result = gdk_color_parse (spec, &color);
#line 13 "image_util.vala"
	return result;
#line 106 "image_util.c"
}


#line 16 "image_util.vala"
void parse_color (const char* spec, GdkColor* result) {
#line 112 "image_util.c"
	GdkColor _tmp0_ = {0};
#line 16 "image_util.vala"
	g_return_if_fail (spec != NULL);
#line 116 "image_util.c"
	*result = (fetch_color (spec, NULL, &_tmp0_), _tmp0_);
#line 17 "image_util.vala"
	return;
#line 120 "image_util.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 20 "image_util.vala"
void fetch_color (const char* spec, GdkDrawable* drawable, GdkColor* result) {
#line 131 "image_util.c"
	GdkColor color = {0};
#line 20 "image_util.vala"
	g_return_if_fail (spec != NULL);
#line 20 "image_util.vala"
	g_return_if_fail ((drawable == NULL) || GDK_IS_DRAWABLE (drawable));
#line 22 "image_util.vala"
	if (!gdk_color_parse (spec, &color)) {
#line 23 "image_util.vala"
		g_error ("image_util.vala:23: Can't parse color %s", spec);
#line 141 "image_util.c"
	}
#line 25 "image_util.vala"
	if (drawable == NULL) {
#line 145 "image_util.c"
		GtkWindow* app;
#line 26 "image_util.vala"
		app = GTK_WINDOW (app_window_get_instance ());
#line 27 "image_util.vala"
		if (app != NULL) {
#line 28 "image_util.vala"
			drawable = GDK_DRAWABLE (GTK_WIDGET (app)->window);
#line 153 "image_util.c"
		}
		_g_object_unref0 (app);
	}
#line 31 "image_util.vala"
	if (drawable != NULL) {
#line 159 "image_util.c"
		GdkColormap* colormap;
#line 32 "image_util.vala"
		colormap = _g_object_ref0 (gdk_drawable_get_colormap (drawable));
#line 33 "image_util.vala"
		if (colormap == NULL) {
#line 34 "image_util.vala"
			g_error ("image_util.vala:34: Can't get colormap for drawable");
#line 167 "image_util.c"
		}
#line 36 "image_util.vala"
		if (!gdk_colormap_alloc_color (colormap, &color, FALSE, TRUE)) {
#line 37 "image_util.vala"
			g_error ("image_util.vala:37: Can't allocate color %s", spec);
#line 173 "image_util.c"
		}
		_g_object_unref0 (colormap);
	}
	*result = color;
#line 40 "image_util.vala"
	return;
#line 180 "image_util.c"
}


#line 43 "image_util.vala"
inline guint32 convert_color (guint16 component) {
#line 186 "image_util.c"
	guint32 result = 0U;
	result = (guint32) (component / 256);
#line 44 "image_util.vala"
	return result;
#line 191 "image_util.c"
}


#line 47 "image_util.vala"
guint32 convert_rgba (GdkColor* c, guint8 alpha) {
#line 197 "image_util.c"
	guint32 result = 0U;
	result = (((convert_color ((*c).red) << 24) | (convert_color ((*c).green) << 16)) | (convert_color ((*c).blue) << 8)) | alpha;
#line 48 "image_util.vala"
	return result;
#line 202 "image_util.c"
}


#line 55 "image_util.vala"
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up) {
#line 208 "image_util.c"
	GdkPixbuf* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions original;
	Dimensions _tmp1_ = {0};
	Dimensions scaled;
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_ = {0};
#line 55 "image_util.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 56 "image_util.vala"
	original = (dimensions_for_pixbuf (pixbuf, &_tmp0_), _tmp0_);
#line 57 "image_util.vala"
	scaled = (dimensions_get_scaled (&original, scale, scale_up, &_tmp1_), _tmp1_);
#line 58 "image_util.vala"
	if (original.width == scaled.width) {
#line 58 "image_util.vala"
		_tmp2_ = original.height == scaled.height;
#line 226 "image_util.c"
	} else {
#line 58 "image_util.vala"
		_tmp2_ = FALSE;
#line 230 "image_util.c"
	}
#line 58 "image_util.vala"
	if (_tmp2_) {
#line 234 "image_util.c"
		result = _g_object_ref0 (pixbuf);
#line 59 "image_util.vala"
		return result;
#line 238 "image_util.c"
	}
#line 62 "image_util.vala"
	scaled = (dimensions_with_min (&scaled, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp3_), _tmp3_);
#line 242 "image_util.c"
	result = gdk_pixbuf_scale_simple (pixbuf, scaled.width, scaled.height, interp);
#line 64 "image_util.vala"
	return result;
#line 246 "image_util.c"
}


#line 67 "image_util.vala"
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp) {
#line 252 "image_util.c"
	GdkPixbuf* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions original;
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_ = {0};
#line 67 "image_util.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 68 "image_util.vala"
	original = (dimensions_for_pixbuf (pixbuf, &_tmp0_), _tmp0_);
#line 69 "image_util.vala"
	if (original.width == (*resized).width) {
#line 69 "image_util.vala"
		_tmp1_ = original.height == (*resized).height;
#line 266 "image_util.c"
	} else {
#line 69 "image_util.vala"
		_tmp1_ = FALSE;
#line 270 "image_util.c"
	}
#line 69 "image_util.vala"
	if (_tmp1_) {
#line 274 "image_util.c"
		result = _g_object_ref0 (pixbuf);
#line 70 "image_util.vala"
		return result;
#line 278 "image_util.c"
	}
#line 73 "image_util.vala"
	*resized = (dimensions_with_min (resized, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp2_), _tmp2_);
#line 282 "image_util.c"
	result = gdk_pixbuf_scale_simple (pixbuf, (*resized).width, (*resized).height, interp);
#line 75 "image_util.vala"
	return result;
#line 286 "image_util.c"
}


#line 80 "image_util.vala"
void draw_rounded_corners_filled (GdkGC* gc, GdkDrawable* drawable, Dimensions* dim, GdkPoint* origin, double radius_proportion) {
#line 292 "image_util.c"
	cairo_t* cx;
	GdkGCValues values = {0};
	GdkColor color = {0};
#line 80 "image_util.vala"
	g_return_if_fail (GDK_IS_GC (gc));
#line 80 "image_util.vala"
	g_return_if_fail (GDK_IS_DRAWABLE (drawable));
#line 82 "image_util.vala"
	cx = get_rounded_corners_context (drawable, dim, origin, radius_proportion);
#line 302 "image_util.c"
	memset (&values, 0, sizeof (GdkGCValues));
#line 88 "image_util.vala"
	gdk_gc_get_values (gc, &values);
#line 91 "image_util.vala"
	gdk_colormap_query_color (gc->colormap, (gulong) values.foreground.pixel, &color);
#line 93 "image_util.vala"
	gdk_cairo_set_source_color (cx, &color);
#line 94 "image_util.vala"
	cairo_paint (cx);
#line 312 "image_util.c"
	_cairo_destroy0 (cx);
}


#line 97 "image_util.vala"
cairo_t* get_rounded_corners_context (GdkDrawable* drawable, Dimensions* dim, GdkPoint* origin, double radius_proportion) {
#line 319 "image_util.c"
	cairo_t* result = NULL;
	double left;
	double top;
	double right;
	double bottom;
	double radius;
	cairo_t* cx;
#line 97 "image_util.vala"
	g_return_val_if_fail (GDK_IS_DRAWABLE (drawable), NULL);
#line 100 "image_util.vala"
	radius_proportion = CLAMP (radius_proportion, 2.0, 100.0);
#line 102 "image_util.vala"
	left = (double) (*origin).x;
#line 103 "image_util.vala"
	top = (double) (*origin).y;
#line 104 "image_util.vala"
	right = (double) ((*origin).x + (*dim).width);
#line 105 "image_util.vala"
	bottom = (double) ((*origin).y + (*dim).height);
#line 108 "image_util.vala"
	radius = ((double) dimensions_minor_axis (dim)) / radius_proportion;
#line 112 "image_util.vala"
	cx = gdk_cairo_create (drawable);
#line 113 "image_util.vala"
	cairo_arc (cx, right - radius, top + radius, radius, (-90) * DEGREE, 0 * DEGREE);
#line 114 "image_util.vala"
	cairo_arc (cx, right - radius, bottom - radius, radius, 0 * DEGREE, 90 * DEGREE);
#line 115 "image_util.vala"
	cairo_arc (cx, left + radius, bottom - radius, radius, 90 * DEGREE, 180 * DEGREE);
#line 116 "image_util.vala"
	cairo_arc (cx, left + radius, top + radius, radius, 180 * DEGREE, 270 * DEGREE);
#line 117 "image_util.vala"
	cairo_clip (cx);
#line 353 "image_util.c"
	result = cx;
#line 119 "image_util.vala"
	return result;
#line 357 "image_util.c"
}


#line 122 "image_util.vala"
inline guchar shift_color_byte (gint b, gint shift) {
#line 363 "image_util.c"
	guchar result = '\0';
	result = (guchar) CLAMP (b + shift, 0, 255);
#line 123 "image_util.vala"
	return result;
#line 368 "image_util.c"
}


#line 126 "image_util.vala"
void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha) {
#line 374 "image_util.c"
	gint width;
	gint height;
	gint rowstride;
	gint channels;
	guchar* pixels;
#line 126 "image_util.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 127 "image_util.vala"
	g_assert ((red >= (-255)) && (red <= 255));
#line 128 "image_util.vala"
	g_assert ((green >= (-255)) && (green <= 255));
#line 129 "image_util.vala"
	g_assert ((blue >= (-255)) && (blue <= 255));
#line 130 "image_util.vala"
	g_assert ((alpha >= (-255)) && (alpha <= 255));
#line 132 "image_util.vala"
	width = gdk_pixbuf_get_width (pixbuf);
#line 133 "image_util.vala"
	height = gdk_pixbuf_get_height (pixbuf);
#line 134 "image_util.vala"
	rowstride = gdk_pixbuf_get_rowstride (pixbuf);
#line 135 "image_util.vala"
	channels = gdk_pixbuf_get_n_channels (pixbuf);
#line 136 "image_util.vala"
	pixels = gdk_pixbuf_get_pixels (pixbuf);
#line 138 "image_util.vala"
	g_assert (channels >= 3);
#line 139 "image_util.vala"
	g_assert (gdk_pixbuf_get_colorspace (pixbuf) == GDK_COLORSPACE_RGB);
#line 140 "image_util.vala"
	g_assert (gdk_pixbuf_get_bits_per_sample (pixbuf) == 8);
#line 406 "image_util.c"
	{
		gint y;
#line 142 "image_util.vala"
		y = 0;
#line 411 "image_util.c"
		{
			gboolean _tmp0_;
#line 142 "image_util.vala"
			_tmp0_ = TRUE;
#line 142 "image_util.vala"
			while (TRUE) {
#line 418 "image_util.c"
				gint y_offset;
#line 142 "image_util.vala"
				if (!_tmp0_) {
#line 142 "image_util.vala"
					y++;
#line 424 "image_util.c"
				}
#line 142 "image_util.vala"
				_tmp0_ = FALSE;
#line 142 "image_util.vala"
				if (!(y < height)) {
#line 142 "image_util.vala"
					break;
#line 432 "image_util.c"
				}
#line 143 "image_util.vala"
				y_offset = y * rowstride;
#line 436 "image_util.c"
				{
					gint x;
#line 145 "image_util.vala"
					x = 0;
#line 441 "image_util.c"
					{
						gboolean _tmp1_;
#line 145 "image_util.vala"
						_tmp1_ = TRUE;
#line 145 "image_util.vala"
						while (TRUE) {
#line 448 "image_util.c"
							gint offset;
							gboolean _tmp2_ = FALSE;
#line 145 "image_util.vala"
							if (!_tmp1_) {
#line 145 "image_util.vala"
								x++;
#line 455 "image_util.c"
							}
#line 145 "image_util.vala"
							_tmp1_ = FALSE;
#line 145 "image_util.vala"
							if (!(x < width)) {
#line 145 "image_util.vala"
								break;
#line 463 "image_util.c"
							}
#line 146 "image_util.vala"
							offset = y_offset + (x * channels);
#line 148 "image_util.vala"
							if (red != 0) {
#line 149 "image_util.vala"
								pixels[offset] = shift_color_byte ((gint) pixels[offset], red);
#line 471 "image_util.c"
							}
#line 151 "image_util.vala"
							if (green != 0) {
#line 152 "image_util.vala"
								pixels[offset + 1] = shift_color_byte ((gint) pixels[offset + 1], green);
#line 477 "image_util.c"
							}
#line 154 "image_util.vala"
							if (blue != 0) {
#line 155 "image_util.vala"
								pixels[offset + 2] = shift_color_byte ((gint) pixels[offset + 2], blue);
#line 483 "image_util.c"
							}
#line 157 "image_util.vala"
							if (alpha != 0) {
#line 157 "image_util.vala"
								_tmp2_ = channels >= 4;
#line 489 "image_util.c"
							} else {
#line 157 "image_util.vala"
								_tmp2_ = FALSE;
#line 493 "image_util.c"
							}
#line 157 "image_util.vala"
							if (_tmp2_) {
#line 158 "image_util.vala"
								pixels[offset + 3] = shift_color_byte ((gint) pixels[offset + 3], alpha);
#line 499 "image_util.c"
							}
						}
					}
				}
			}
		}
	}
}


#line 163 "image_util.vala"
gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect) {
#line 512 "image_util.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 164 "image_util.vala"
	if (x >= (*rect).x) {
#line 164 "image_util.vala"
		_tmp2_ = x < ((*rect).x + (*rect).width);
#line 521 "image_util.c"
	} else {
#line 164 "image_util.vala"
		_tmp2_ = FALSE;
#line 525 "image_util.c"
	}
#line 164 "image_util.vala"
	if (_tmp2_) {
#line 164 "image_util.vala"
		_tmp1_ = y >= (*rect).y;
#line 531 "image_util.c"
	} else {
#line 164 "image_util.vala"
		_tmp1_ = FALSE;
#line 535 "image_util.c"
	}
#line 164 "image_util.vala"
	if (_tmp1_) {
#line 164 "image_util.vala"
		_tmp0_ = y <= ((*rect).y + (*rect).height);
#line 541 "image_util.c"
	} else {
#line 164 "image_util.vala"
		_tmp0_ = FALSE;
#line 545 "image_util.c"
	}
	result = _tmp0_;
#line 164 "image_util.vala"
	return result;
#line 550 "image_util.c"
}


#line 167 "image_util.vala"
void coord_scaled_in_space (gint x, gint y, Dimensions* original, Dimensions* scaled, GdkPoint* result) {
#line 556 "image_util.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	GdkPoint point = {0};
#line 169 "image_util.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 562 "image_util.c"
	memset (&point, 0, sizeof (GdkPoint));
#line 172 "image_util.vala"
	point.x = (gint) round (x * x_scale);
#line 173 "image_util.vala"
	point.y = (gint) round (y * y_scale);
#line 176 "image_util.vala"
	if (point.x >= (*scaled).width) {
#line 177 "image_util.vala"
		point.x = (*scaled).width - 1;
#line 572 "image_util.c"
	}
#line 179 "image_util.vala"
	if (point.y >= (*scaled).height) {
#line 180 "image_util.vala"
		point.y = (*scaled).height - 1;
#line 578 "image_util.c"
	}
	*result = point;
#line 182 "image_util.vala"
	return;
#line 583 "image_util.c"
}


#line 185 "image_util.vala"
gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b) {
#line 589 "image_util.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 186 "image_util.vala"
	if ((*a).x == (*b).x) {
#line 186 "image_util.vala"
		_tmp2_ = (*a).y == (*b).y;
#line 598 "image_util.c"
	} else {
#line 186 "image_util.vala"
		_tmp2_ = FALSE;
#line 602 "image_util.c"
	}
#line 186 "image_util.vala"
	if (_tmp2_) {
#line 186 "image_util.vala"
		_tmp1_ = (*a).width == (*b).width;
#line 608 "image_util.c"
	} else {
#line 186 "image_util.vala"
		_tmp1_ = FALSE;
#line 612 "image_util.c"
	}
#line 186 "image_util.vala"
	if (_tmp1_) {
#line 186 "image_util.vala"
		_tmp0_ = (*a).height == (*b).height;
#line 618 "image_util.c"
	} else {
#line 186 "image_util.vala"
		_tmp0_ = FALSE;
#line 622 "image_util.c"
	}
	result = _tmp0_;
#line 186 "image_util.vala"
	return result;
#line 627 "image_util.c"
}


#line 189 "image_util.vala"
char* rectangle_to_string (GdkRectangle* rect) {
#line 633 "image_util.c"
	char* result = NULL;
	result = g_strdup_printf ("%d,%d %dx%d", (*rect).x, (*rect).y, (*rect).width, (*rect).height);
#line 190 "image_util.vala"
	return result;
#line 638 "image_util.c"
}


#line 193 "image_util.vala"
void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result) {
#line 644 "image_util.c"
	GdkRectangle rect = {0};
	memset (&rect, 0, sizeof (GdkRectangle));
#line 195 "image_util.vala"
	rect.x = CLAMP ((*original).x, 0, (*max).width);
#line 196 "image_util.vala"
	rect.y = CLAMP ((*original).y, 0, (*max).height);
#line 197 "image_util.vala"
	rect.width = CLAMP ((*original).width, 0, (*max).width);
#line 198 "image_util.vala"
	rect.height = CLAMP ((*original).height, 0, (*max).height);
#line 655 "image_util.c"
	*result = rect;
#line 200 "image_util.vala"
	return;
#line 659 "image_util.c"
}


#line 205 "image_util.vala"
gint radius_scaled_in_space (gint radius, Dimensions* original, Dimensions* scaled) {
#line 665 "image_util.c"
	gint result = 0;
	double x_scale = 0.0;
	double y_scale = 0.0;
#line 207 "image_util.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 211 "image_util.vala"
	if (fabs (x_scale - y_scale) > 1.0) {
#line 673 "image_util.c"
		result = -1;
#line 212 "image_util.vala"
		return result;
#line 677 "image_util.c"
	}
	result = (gint) round (radius * x_scale);
#line 214 "image_util.vala"
	return result;
#line 682 "image_util.c"
}


#line 217 "image_util.vala"
void scale_point (GdkPoint* p, double factor, GdkPoint* result) {
#line 688 "image_util.c"
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
#line 218 "image_util.vala"
	_result_ = (_tmp0_.x = 0, _tmp0_);
#line 219 "image_util.vala"
	_result_.x = (gint) ((factor * (*p).x) + 0.5);
#line 220 "image_util.vala"
	_result_.y = (gint) ((factor * (*p).y) + 0.5);
#line 697 "image_util.c"
	*result = _result_;
#line 222 "image_util.vala"
	return;
#line 701 "image_util.c"
}


#line 225 "image_util.vala"
void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
#line 707 "image_util.c"
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
#line 226 "image_util.vala"
	_result_ = (_tmp0_.x = 0, _tmp0_);
#line 227 "image_util.vala"
	_result_.x = (*p1).x + (*p2).x;
#line 228 "image_util.vala"
	_result_.y = (*p1).y + (*p2).y;
#line 716 "image_util.c"
	*result = _result_;
#line 230 "image_util.vala"
	return;
#line 720 "image_util.c"
}


#line 233 "image_util.vala"
void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
#line 726 "image_util.c"
	GdkPoint _tmp0_ = {0};
	GdkPoint _result_;
#line 234 "image_util.vala"
	_result_ = (_tmp0_.x = 0, _tmp0_);
#line 235 "image_util.vala"
	_result_.x = (*p1).x - (*p2).x;
#line 236 "image_util.vala"
	_result_.y = (*p1).y - (*p2).y;
#line 735 "image_util.c"
	*result = _result_;
#line 238 "image_util.vala"
	return;
#line 739 "image_util.c"
}




