/* string_util.c generated by valac 0.10.3, the Vala compiler
 * generated from string_util.vala, do not modify */

/* Copyright 2010 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = (((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;



gboolean is_string_empty (const char* s);
char* uchar_array_to_string (guchar* data, int data_length1, gint length);
guchar* string_to_uchar_array (const char* str, int* result_length1);
static void _vala_array_add317 (guchar** array, int* length, int* size, guchar value);
char* guarded_markup_escape_text (const char* plain);
glong find_last_offset (const char* str, gchar c);
gboolean is_in_ci_array (const char* str, char** strings, int strings_length1);
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
char* prepare_input_text (const char* text, PrepareInputTextOptions options);
char* asciify_string (const char* s);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 7 "string_util.vala"
inline gboolean is_string_empty (const char* s) {
#line 48 "string_util.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 8 "string_util.vala"
	if (s == NULL) {
#line 8 "string_util.vala"
		_tmp0_ = TRUE;
#line 55 "string_util.c"
	} else {
#line 8 "string_util.vala"
		_tmp0_ = g_utf8_get_char (g_utf8_offset_to_pointer (s, 0)) == '\0';
#line 59 "string_util.c"
	}
	result = _tmp0_;
#line 8 "string_util.vala"
	return result;
#line 64 "string_util.c"
}


#line 11 "string_util.vala"
char* uchar_array_to_string (guchar* data, int data_length1, gint length) {
#line 70 "string_util.c"
	char* result = NULL;
	GString* builder;
#line 12 "string_util.vala"
	if (length < 0) {
#line 13 "string_util.vala"
		length = data_length1;
#line 77 "string_util.c"
	}
#line 15 "string_util.vala"
	builder = g_string_new ("");
#line 81 "string_util.c"
	{
		gint ctr;
#line 16 "string_util.vala"
		ctr = 0;
#line 86 "string_util.c"
		{
			gboolean _tmp0_;
#line 16 "string_util.vala"
			_tmp0_ = TRUE;
#line 16 "string_util.vala"
			while (TRUE) {
#line 16 "string_util.vala"
				if (!_tmp0_) {
#line 16 "string_util.vala"
					ctr++;
#line 97 "string_util.c"
				}
#line 16 "string_util.vala"
				_tmp0_ = FALSE;
#line 16 "string_util.vala"
				if (!(ctr < length)) {
#line 16 "string_util.vala"
					break;
#line 105 "string_util.c"
				}
#line 17 "string_util.vala"
				if (data[ctr] != '\0') {
#line 18 "string_util.vala"
					g_string_append_c (builder, (gchar) data[ctr]);
#line 111 "string_util.c"
				} else {
#line 20 "string_util.vala"
					break;
#line 115 "string_util.c"
				}
			}
		}
	}
	result = g_strdup (builder->str);
	_g_string_free0 (builder);
#line 23 "string_util.vala"
	return result;
#line 124 "string_util.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 134 "string_util.c"
}


static void _vala_array_add317 (guchar** array, int* length, int* size, guchar value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guchar, *array, *size);
	}
	(*array)[(*length)++] = value;
}


#line 26 "string_util.vala"
guchar* string_to_uchar_array (const char* str, int* result_length1) {
#line 149 "string_util.c"
	guchar* result = NULL;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp0_;
	guchar* data;
	guchar* _tmp2_;
#line 26 "string_util.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 158 "string_util.c"
	data = (_tmp0_ = g_new0 (guchar, 0), data_length1 = 0, _data_size_ = data_length1, _tmp0_);
	{
		gint ctr;
#line 28 "string_util.vala"
		ctr = 0;
#line 164 "string_util.c"
		{
			gboolean _tmp1_;
#line 28 "string_util.vala"
			_tmp1_ = TRUE;
#line 28 "string_util.vala"
			while (TRUE) {
#line 28 "string_util.vala"
				if (!_tmp1_) {
#line 28 "string_util.vala"
					ctr++;
#line 175 "string_util.c"
				}
#line 28 "string_util.vala"
				_tmp1_ = FALSE;
#line 28 "string_util.vala"
				if (!(ctr < string_get_length (str))) {
#line 28 "string_util.vala"
					break;
#line 183 "string_util.c"
				}
#line 29 "string_util.vala"
				_vala_array_add317 (&data, &data_length1, &_data_size_, (guchar) g_utf8_get_char (g_utf8_offset_to_pointer (str, ctr)));
#line 187 "string_util.c"
			}
		}
	}
	result = (_tmp2_ = data, *result_length1 = data_length1, _tmp2_);
#line 31 "string_util.vala"
	return result;
#line 194 "string_util.c"
	data = (g_free (data), NULL);
}


#line 39 "string_util.vala"
inline char* guarded_markup_escape_text (const char* plain) {
#line 201 "string_util.c"
	char* result = NULL;
	char* _tmp0_;
#line 39 "string_util.vala"
	g_return_val_if_fail (plain != NULL, NULL);
#line 206 "string_util.c"
	_tmp0_ = NULL;
#line 40 "string_util.vala"
	if (g_utf8_validate (plain, -1, NULL)) {
#line 210 "string_util.c"
		char* _tmp1_;
#line 40 "string_util.vala"
		_tmp0_ = (_tmp1_ = g_markup_escape_text (plain, -1), _g_free0 (_tmp0_), _tmp1_);
#line 214 "string_util.c"
	} else {
		char* _tmp2_;
#line 40 "string_util.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 219 "string_util.c"
	}
	result = _tmp0_;
#line 40 "string_util.vala"
	return result;
#line 224 "string_util.c"
}


#line 43 "string_util.vala"
glong find_last_offset (const char* str, gchar c) {
#line 230 "string_util.c"
	glong result = 0L;
	glong offset;
#line 43 "string_util.vala"
	g_return_val_if_fail (str != NULL, 0L);
#line 44 "string_util.vala"
	offset = string_get_length (str);
#line 45 "string_util.vala"
	while (TRUE) {
#line 45 "string_util.vala"
		if (!((offset = offset - 1) >= 0)) {
#line 45 "string_util.vala"
			break;
#line 243 "string_util.c"
		}
#line 46 "string_util.vala"
		if (g_utf8_get_char (g_utf8_offset_to_pointer (str, offset)) == c) {
#line 247 "string_util.c"
			result = offset;
#line 47 "string_util.vala"
			return result;
#line 251 "string_util.c"
		}
	}
	result = (glong) (-1);
#line 50 "string_util.vala"
	return result;
#line 257 "string_util.c"
}


#line 55 "string_util.vala"
gboolean is_in_ci_array (const char* str, char** strings, int strings_length1) {
#line 263 "string_util.c"
	gboolean result = FALSE;
	char* strdown;
#line 55 "string_util.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 56 "string_util.vala"
	strdown = g_utf8_strdown (str, -1);
#line 270 "string_util.c"
	{
		char** str_element_collection;
		int str_element_collection_length1;
		int str_element_it;
#line 57 "string_util.vala"
		str_element_collection = strings;
#line 277 "string_util.c"
		str_element_collection_length1 = strings_length1;
		for (str_element_it = 0; str_element_it < strings_length1; str_element_it = str_element_it + 1) {
			char* str_element;
			str_element = g_strdup (str_element_collection[str_element_it]);
			{
#line 58 "string_util.vala"
				if (_vala_strcmp0 (strdown, str_element) == 0) {
#line 285 "string_util.c"
					result = TRUE;
					_g_free0 (str_element);
					_g_free0 (strdown);
#line 59 "string_util.vala"
					return result;
#line 291 "string_util.c"
				}
				_g_free0 (str_element);
			}
		}
	}
	result = FALSE;
	_g_free0 (strdown);
#line 62 "string_util.vala"
	return result;
#line 301 "string_util.c"
}


GType prepare_input_text_options_get_type (void) {
	static volatile gsize prepare_input_text_options_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__volatile)) {
		static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
		g_once_init_leave (&prepare_input_text_options_type_id__volatile, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__volatile;
}


#line 1051 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 319 "string_util.c"
	char* result = NULL;
	char* _result_;
#line 1051 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1053 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 328 "string_util.c"
	result = _result_;
#line 1054 "glib-2.0.vapi"
	return result;
#line 332 "string_util.c"
}


#line 75 "string_util.vala"
char* prepare_input_text (const char* text, PrepareInputTextOptions options) {
#line 338 "string_util.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
	char* prepped;
	gboolean _tmp4_ = FALSE;
#line 76 "string_util.vala"
	if (text == NULL) {
#line 345 "string_util.c"
		result = NULL;
#line 77 "string_util.vala"
		return result;
#line 349 "string_util.c"
	}
#line 79 "string_util.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) != 0) {
#line 79 "string_util.vala"
		_tmp0_ = !g_utf8_validate (text, -1, NULL);
#line 355 "string_util.c"
	} else {
#line 79 "string_util.vala"
		_tmp0_ = FALSE;
#line 359 "string_util.c"
	}
#line 79 "string_util.vala"
	if (_tmp0_) {
#line 363 "string_util.c"
		const char* _tmp1_;
		_tmp1_ = NULL;
#line 80 "string_util.vala"
		if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
#line 80 "string_util.vala"
			_tmp1_ = NULL;
#line 370 "string_util.c"
		} else {
#line 80 "string_util.vala"
			_tmp1_ = "";
#line 374 "string_util.c"
		}
		result = g_strdup (_tmp1_);
#line 80 "string_util.vala"
		return result;
#line 379 "string_util.c"
	}
#line 82 "string_util.vala"
	prepped = g_strdup (text);
#line 88 "string_util.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
#line 385 "string_util.c"
		char* _tmp2_;
#line 89 "string_util.vala"
		prepped = (_tmp2_ = g_utf8_normalize (prepped, (gssize) (-1), G_NORMALIZE_NFC), _g_free0 (prepped), _tmp2_);
#line 389 "string_util.c"
	}
#line 91 "string_util.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
#line 393 "string_util.c"
		char* _tmp3_;
#line 92 "string_util.vala"
		prepped = (_tmp3_ = string_strip (prepped), _g_free0 (prepped), _tmp3_);
#line 397 "string_util.c"
	}
#line 94 "string_util.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
#line 94 "string_util.vala"
		_tmp4_ = is_string_empty (prepped);
#line 403 "string_util.c"
	} else {
#line 94 "string_util.vala"
		_tmp4_ = FALSE;
#line 407 "string_util.c"
	}
#line 94 "string_util.vala"
	if (_tmp4_) {
#line 411 "string_util.c"
		result = NULL;
		_g_free0 (prepped);
#line 95 "string_util.vala"
		return result;
#line 416 "string_util.c"
	}
	result = prepped;
#line 97 "string_util.vala"
	return result;
#line 421 "string_util.c"
}


#line 103 "string_util.vala"
char* asciify_string (const char* s) {
#line 427 "string_util.c"
	char* result = NULL;
	char* t;
	GString* b;
#line 103 "string_util.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 104 "string_util.vala"
	t = g_utf8_normalize (s, -1, G_NORMALIZE_DEFAULT);
#line 106 "string_util.vala"
	b = g_string_new ("");
#line 437 "string_util.c"
	{
		const char* u;
#line 107 "string_util.vala"
		u = t;
#line 442 "string_util.c"
		{
			gboolean _tmp0_;
#line 107 "string_util.vala"
			_tmp0_ = TRUE;
#line 107 "string_util.vala"
			while (TRUE) {
#line 449 "string_util.c"
				gunichar c;
#line 107 "string_util.vala"
				if (!_tmp0_) {
#line 107 "string_util.vala"
					u = g_utf8_next_char (u);
#line 455 "string_util.c"
				}
#line 107 "string_util.vala"
				_tmp0_ = FALSE;
#line 107 "string_util.vala"
				if (!(g_utf8_get_char (u) != 0)) {
#line 107 "string_util.vala"
					break;
#line 463 "string_util.c"
				}
#line 108 "string_util.vala"
				c = g_utf8_get_char (u);
#line 109 "string_util.vala"
				if (((gint) c) < 128) {
#line 110 "string_util.vala"
					g_string_append_unichar (b, c);
#line 471 "string_util.c"
				}
			}
		}
	}
	result = g_strdup (b->str);
	_g_string_free0 (b);
	_g_free0 (t);
#line 113 "string_util.vala"
	return result;
#line 481 "string_util.c"
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




