/* DataCollection.c generated by valac 0.10.3, the Vala compiler
 * generated from DataCollection.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataSet*/
/**/
/* A DataSet is a collection class used for internal implementations of DataCollection*/
/* and its children.  It may be of use to other classes, however.*/
/**/
/* The general purpose of DataSet is to provide low-cost implementations of various collection*/
/* operations at a cost of internally maintaining its objects in more than one simple collection.*/
/* contains(), for example, can return a result with hash-table performance while notions of*/
/* ordering are maintained by a SortedList.  The cost is in adding and removing objects (in general,*/
/* there are others).*/
/**/
/* Because this class has no signalling mechanisms and does not manipulate DataObjects in ways*/
/* they expect to be manipulated (these features are performed by DataCollection), it's probably*/
/* best not to use this class.  Even in cases of building a list of DataObjects for some quick*/
/* operation is probably best done by a Gee.ArrayList.*/
/**/
/* ComparatorPredicate is used to determine if a re-sort operation is necessary; it has no*/
/* effect on adding a DataObject to a DataSet in sorted order.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
typedef struct _DataSetPrivate DataSetPrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
typedef struct _ParamSpecDataSet ParamSpecDataSet;

#define TYPE_SINGLETON_COLLECTION (singleton_collection_get_type ())
#define SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollection))
#define SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))
#define IS_SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLETON_COLLECTION))
#define IS_SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLETON_COLLECTION))
#define SINGLETON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))

typedef struct _SingletonCollection SingletonCollection;
typedef struct _SingletonCollectionClass SingletonCollectionClass;
typedef struct _SingletonCollectionPrivate SingletonCollectionPrivate;
#define _g_destroy_func0(var) (((var == NULL) || (g_destroy_func == NULL)) ? NULL : (var = (g_destroy_func (var), NULL)))

#define SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR (singleton_collection_singleton_iterator_get_type ())
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIterator))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))

typedef struct _SingletonCollectionSingletonIterator SingletonCollectionSingletonIterator;
typedef struct _SingletonCollectionSingletonIteratorClass SingletonCollectionSingletonIteratorClass;
typedef struct _SingletonCollectionSingletonIteratorPrivate SingletonCollectionSingletonIteratorPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_UNKNOWN_TOTAL_MONITOR (unknown_total_monitor_get_type ())
#define UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitor))
#define UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))
#define IS_UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNKNOWN_TOTAL_MONITOR))
#define IS_UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNKNOWN_TOTAL_MONITOR))
#define UNKNOWN_TOTAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))

typedef struct _UnknownTotalMonitor UnknownTotalMonitor;
typedef struct _UnknownTotalMonitorClass UnknownTotalMonitorClass;
typedef struct _UnknownTotalMonitorPrivate UnknownTotalMonitorPrivate;
typedef struct _ParamSpecUnknownTotalMonitor ParamSpecUnknownTotalMonitor;

#define TYPE_AGGREGATE_PROGRESS_MONITOR (aggregate_progress_monitor_get_type ())
#define AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitor))
#define AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))
#define IS_AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define IS_AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define AGGREGATE_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))

typedef struct _AggregateProgressMonitor AggregateProgressMonitor;
typedef struct _AggregateProgressMonitorClass AggregateProgressMonitorClass;
typedef struct _AggregateProgressMonitorPrivate AggregateProgressMonitorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecAggregateProgressMonitor ParamSpecAggregateProgressMonitor;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define DATA_COLLECTION_TYPE_MARKER_IMPL (data_collection_marker_impl_get_type ())
#define DATA_COLLECTION_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImpl))
#define DATA_COLLECTION_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))
#define DATA_COLLECTION_IS_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_IS_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_MARKER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))

typedef struct _DataCollectionMarkerImpl DataCollectionMarkerImpl;
typedef struct _DataCollectionMarkerImplClass DataCollectionMarkerImplClass;
typedef struct _DataCollectionMarkerImplPrivate DataCollectionMarkerImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
typedef struct _ParamSpecDataCollection ParamSpecDataCollection;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define SOURCE_COLLECTION_TYPE_DESTROY_COUNTER (source_collection_destroy_counter_get_type ())
#define SOURCE_COLLECTION_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounter))
#define SOURCE_COLLECTION_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_DESTROY_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))

typedef struct _SourceCollectionDestroyCounter SourceCollectionDestroyCounter;
typedef struct _SourceCollectionDestroyCounterClass SourceCollectionDestroyCounterClass;
typedef struct _SourceCollectionDestroyCounterPrivate SourceCollectionDestroyCounterPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;
typedef struct _ContainerSourceCollectionPrivate ContainerSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _ParamSpecSourceHoldingTank ParamSpecSourceHoldingTank;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewManagerPrivate ViewManagerPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
typedef struct _ParamSpecViewManager ParamSpecViewManager;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))

typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
struct _DataSet {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataSetPrivate * priv;
};

struct _DataSetClass {
	GTypeClass parent_class;
	void (*finalize) (DataSet *self);
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _DataSetPrivate {
	SortedList* list;
	GeeHashSet* hash_set;
	Comparator user_comparator;
	gpointer user_comparator_target;
	GDestroyNotify user_comparator_target_destroy_notify;
	ComparatorPredicate comparator_predicate;
	gpointer comparator_predicate_target;
	GDestroyNotify comparator_predicate_target_destroy_notify;
};

struct _ParamSpecDataSet {
	GParamSpec parent_instance;
};

struct _SingletonCollection {
	GeeAbstractCollection parent_instance;
	SingletonCollectionPrivate * priv;
};

struct _SingletonCollectionClass {
	GeeAbstractCollectionClass parent_class;
};

struct _SingletonCollectionPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gpointer object;
};

struct _SingletonCollectionSingletonIterator {
	GObject parent_instance;
	SingletonCollectionSingletonIteratorPrivate * priv;
};

struct _SingletonCollectionSingletonIteratorClass {
	GObjectClass parent_class;
};

struct _SingletonCollectionSingletonIteratorPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	SingletonCollection* c;
	gboolean done;
	gpointer current;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UnknownTotalMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UnknownTotalMonitorPrivate * priv;
};

struct _UnknownTotalMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UnknownTotalMonitor *self);
};

struct _UnknownTotalMonitorPrivate {
	guint64 total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
};

struct _ParamSpecUnknownTotalMonitor {
	GParamSpec parent_instance;
};

struct _AggregateProgressMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AggregateProgressMonitorPrivate * priv;
};

struct _AggregateProgressMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (AggregateProgressMonitor *self);
};

struct _AggregateProgressMonitorPrivate {
	guint64 grand_total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
	guint64 aggregate_count;
	guint64 last_count;
};

struct _ParamSpecAggregateProgressMonitor {
	GParamSpec parent_instance;
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	char* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const char* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const char* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _DataCollectionPrivate {
	char* name;
	DataSet* dataset;
	GeeHashMap* properties;
	gint64 object_ordinal_generator;
	gint notifies_frozen;
	GeeHashMap* frozen_items_altered;
	gboolean fire_ordering_changed;
};

struct _DataCollectionMarkerImpl {
	GObject parent_instance;
	DataCollectionMarkerImplPrivate * priv;
	DataCollection* owner;
	GeeHashSet* marked;
	gint freeze_count;
};

struct _DataCollectionMarkerImplClass {
	GObjectClass parent_class;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _ParamSpecDataCollection {
	GParamSpec parent_instance;
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _SourceCollectionPrivate {
	GeeMultiMap* backlinks;
};

struct _SourceCollectionDestroyCounter {
	GObject parent_instance;
	SourceCollectionDestroyCounterPrivate * priv;
	Marker* remove_marker;
	GeeArrayList* notify_list;
	GeeArrayList* not_removed;
};

struct _SourceCollectionDestroyCounterClass {
	GObjectClass parent_class;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _DatabaseSourceCollectionPrivate {
	GetSourceDatabaseKey source_key_func;
	gpointer source_key_func_target;
	GDestroyNotify source_key_func_target_destroy_notify;
	GeeHashMap* map;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _ContainerSourceCollection {
	DatabaseSourceCollection parent_instance;
	ContainerSourceCollectionPrivate * priv;
};

struct _ContainerSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	void (*notify_container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*notify_container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*notify_container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*notify_backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
	GeeCollection* (*get_containers_holding_source) (ContainerSourceCollection* self, DataSource* source);
	ContainerSource* (*convert_backlink_to_container) (ContainerSourceCollection* self, SourceBacklink* backlink);
	void (*container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
};

struct _ContainerSourceCollectionPrivate {
	GeeHashSet* attached_collections;
	char* backlink_name;
	GeeHashSet* holding_tank;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _SourceHoldingTankPrivate {
	SourceCollection* sources;
	SourceHoldingTankCheckToKeep check_to_keep;
	gpointer check_to_keep_target;
	GDestroyNotify check_to_keep_target_destroy_notify;
	DataSet* tank;
	GeeHashSet* relinks;
	GeeHashSet* unlinking;
	gint64 ordinal;
};

struct _ParamSpecSourceHoldingTank {
	GParamSpec parent_instance;
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _DatabaseSourceHoldingTankPrivate {
	GetSourceDatabaseKey get_key;
	gpointer get_key_target;
	GDestroyNotify get_key_target_destroy_notify;
	GeeHashMap* map;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*ViewFilter) (DataView* view, void* user_data);
struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected) (ViewCollection* self, GeeIterable* views);
	void (*notify_items_unselected) (ViewCollection* self, GeeIterable* views);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
};

struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	GDestroyNotify mirroring_ctor_target_destroy_notify;
	ViewFilter filter;
	gpointer filter_target;
	GDestroyNotify filter_target_destroy_notify;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	gint view_lock_count;
	GeeHashMap* locked_filter_items;
	GeeHashSet* locked_unlinked_items;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};


static gpointer data_set_parent_class = NULL;
static gpointer singleton_collection_singleton_iterator_parent_class = NULL;
static GeeIteratorIface* singleton_collection_singleton_iterator_gee_iterator_parent_iface = NULL;
static gpointer singleton_collection_parent_class = NULL;
static gpointer unknown_total_monitor_parent_class = NULL;
static gpointer aggregate_progress_monitor_parent_class = NULL;
static gpointer data_collection_marker_impl_parent_class = NULL;
static MarkerIface* data_collection_marker_impl_marker_parent_iface = NULL;
static gpointer data_collection_parent_class = NULL;
static gpointer source_collection_destroy_counter_parent_class = NULL;
static gpointer source_collection_parent_class = NULL;
static gpointer database_source_collection_parent_class = NULL;
static gpointer container_source_collection_parent_class = NULL;
static gpointer source_holding_tank_parent_class = NULL;
static gpointer database_source_holding_tank_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_collection_parent_class = NULL;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
GType sorted_list_get_type (void) G_GNUC_CONST;
#define DATA_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SET, DataSetPrivate))
enum  {
	DATA_SET_DUMMY_PROPERTY
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
void data_set_reset_comparator (DataSet* self);
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b);
gint64 data_object_internal_get_ordinal (DataObject* self);
static gboolean data_set_order_added_predicate (DataSet* self, DataObject* object, Alteration* alteration);
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b);
gboolean data_set_contains (DataSet* self, DataObject* object);
gint data_set_get_count (DataSet* self);
gint sorted_list_get_count (SortedList* self);
static gboolean _data_set_order_added_predicate_comparator_predicate (DataObject* object, Alteration* alteration, gpointer self);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target);
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self);
GeeCollection* data_set_get_all (DataSet* self);
DataSet* data_set_copy (DataSet* self);
SortedList* sorted_list_copy (SortedList* self);
DataObject* data_set_get_at (DataSet* self, gint index);
gpointer sorted_list_get_at (SortedList* self, gint index);
gint data_set_index_of (DataSet* self, DataObject* object);
gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func);
gboolean data_set_add (DataSet* self, DataObject* object);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
gboolean data_set_remove (DataSet* self, DataObject* object);
gboolean data_set_remove_many (DataSet* self, GeeList* objects);
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
static void data_set_finalize (DataSet* obj);
GType singleton_collection_get_type (void) G_GNUC_CONST;
#define SINGLETON_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SINGLETON_COLLECTION, SingletonCollectionPrivate))
enum  {
	SINGLETON_COLLECTION_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SIZE,
	SINGLETON_COLLECTION_G_TYPE,
	SINGLETON_COLLECTION_G_DUP_FUNC,
	SINGLETON_COLLECTION_G_DESTROY_FUNC
};
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object);
static void singleton_collection_real_clear (GeeAbstractCollection* base);
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object);
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static GType singleton_collection_singleton_iterator_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item);
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorPrivate))
enum  {
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC
};
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base);
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base);
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base);
static void singleton_collection_singleton_iterator_finalize (GObject* obj);
static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void singleton_collection_finalize (GObject* obj);
static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
void marker_mark (Marker* self, DataObject* object);
void marker_unmark (Marker* self, DataObject* object);
gboolean marker_toggle (Marker* self, DataObject* object);
void marker_mark_many (Marker* self, GeeCollection* list);
void marker_unmark_many (Marker* self, GeeCollection* list);
void marker_mark_all (Marker* self);
gint marker_get_count (Marker* self);
GeeCollection* marker_get_all (Marker* self);
gpointer unknown_total_monitor_ref (gpointer instance);
void unknown_total_monitor_unref (gpointer instance);
GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_unknown_total_monitor (GValue* value, gpointer v_object);
void value_take_unknown_total_monitor (GValue* value, gpointer v_object);
gpointer value_get_unknown_total_monitor (const GValue* value);
GType unknown_total_monitor_get_type (void) G_GNUC_CONST;
#define UNKNOWN_TOTAL_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorPrivate))
enum  {
	UNKNOWN_TOTAL_MONITOR_DUMMY_PROPERTY
};
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total);
static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj);
gpointer aggregate_progress_monitor_ref (gpointer instance);
void aggregate_progress_monitor_unref (gpointer instance);
GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object);
void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object);
gpointer value_get_aggregate_progress_monitor (const GValue* value);
GType aggregate_progress_monitor_get_type (void) G_GNUC_CONST;
#define AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorPrivate))
enum  {
	AGGREGATE_PROGRESS_MONITOR_DUMMY_PROPERTY
};
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name);
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total);
static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj);
gboolean null_progress_monitor (guint64 count, guint64 total);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_COLLECTION, DataCollectionPrivate))
enum  {
	DATA_COLLECTION_DUMMY_PROPERTY
};
static GValue* _g_value_dup (GValue* self);
static void _vala_GValue_free (GValue* self);
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataCollection* data_collection_new (const char* name);
DataCollection* data_collection_construct (GType object_type, const char* name);
char* data_collection_to_string (DataCollection* self);
static char* data_collection_real_to_string (DataCollection* self);
gint data_collection_get_count (DataCollection* self);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_notify_items_altered (DataCollection* self, GeeMap* items);
static void data_collection_real_notify_items_altered (DataCollection* self, GeeMap* items);
void data_collection_notify_ordering_changed (DataCollection* self);
static void data_collection_real_notify_ordering_changed (DataCollection* self);
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_notify_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name);
GeeCollection* data_collection_get_singleton (DataObject* object);
GeeMap* data_collection_get_alteration_singleton (DataObject* object, Alteration* alteration);
gboolean data_collection_valid_type (DataCollection* self, DataObject* object);
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
void data_collection_reset_comparator (DataCollection* self);
static void data_collection_real_reset_comparator (DataCollection* self);
GeeCollection* data_collection_get_all (DataCollection* self);
static GeeCollection* data_collection_real_get_all (DataCollection* self);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
static gint data_collection_real_get_count (DataCollection* self);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static DataObject* data_collection_real_get_at (DataCollection* self, gint index);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gint data_collection_real_index_of (DataCollection* self, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object);
DataCollection* data_object_get_membership (DataObject* self);
static void data_collection_internal_add (DataCollection* self, DataObject* object);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target);
static void data_collection_internal_remove (DataCollection* self, DataObject* object);
void data_object_internal_clear_membership (DataObject* self);
gboolean data_collection_add (DataCollection* self, DataObject* object);
static gboolean data_collection_real_add (DataCollection* self, DataObject* object);
char* data_object_to_string (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static GeeCollection* data_collection_real_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_start_marking (DataCollection* self);
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner);
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner);
static GType data_collection_marker_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
Marker* data_collection_mark (DataCollection* self, DataObject* object);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection);
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self);
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self);
void data_collection_remove_marked (DataCollection* self, Marker* m);
static void data_collection_real_remove_marked (DataCollection* self, Marker* m);
void data_collection_clear (DataCollection* self);
static void data_collection_real_clear (DataCollection* self);
void data_collection_close (DataCollection* self);
static void data_collection_real_close (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
Alteration* alteration_compress (Alteration* self, Alteration* other);
GValue* data_collection_get_property (DataCollection* self, const char* name);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
gboolean bool_value_equals (GValue* a, GValue* b);
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
gboolean int_value_equals (GValue* a, GValue* b);
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
void data_collection_freeze_notifications (DataCollection* self);
void data_collection_notify_frozen (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void data_collection_notify_thawed (DataCollection* self);
static void data_collection_real_notify_frozen (DataCollection* self);
static void data_collection_real_notify_thawed (DataCollection* self);
void data_collection_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added);
void data_collection_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_items_altered (DataCollection* self, GeeMap* items);
static void data_collection_real_items_altered (DataCollection* self, GeeMap* items);
void data_collection_ordering_changed (DataCollection* self);
static void data_collection_real_ordering_changed (DataCollection* self);
void data_collection_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_property_cleared (DataCollection* self, const char* name);
void data_collection_frozen (DataCollection* self);
static void data_collection_real_frozen (DataCollection* self);
void data_collection_thawed (DataCollection* self);
static void data_collection_real_thawed (DataCollection* self);
enum  {
	DATA_COLLECTION_MARKER_IMPL_DUMMY_PROPERTY
};
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed);
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object);
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_mark_all (Marker* base);
static gint data_collection_marker_impl_real_get_count (Marker* base);
static GeeCollection* data_collection_marker_impl_real_get_all (Marker* base);
static void data_collection_marker_impl_finalize (GObject* obj);
static void data_collection_finalize (DataCollection* obj);
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
#define SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_COLLECTION, SourceCollectionPrivate))
enum  {
	SOURCE_COLLECTION_DUMMY_PROPERTY
};
SourceCollection* source_collection_construct (GType object_type, const char* name);
gboolean source_collection_holds_type_of_source (SourceCollection* self, DataSource* source);
static gboolean source_collection_real_holds_type_of_source (SourceCollection* self, DataSource* source);
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
static void source_collection_real_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
void source_collection_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
static void source_collection_real_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker);
static GType source_collection_destroy_counter_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self);
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
void data_source_internal_mark_for_destroy (DataSource* self);
void data_source_destroy (DataSource* self);
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
guint source_backlink_hash_func (void* key);
static guint _source_backlink_hash_func_ghash_func (void* key);
gboolean source_backlink_equal_func (void* a, void* b);
static gboolean _source_backlink_equal_func_gequal_func (void* a, void* b);
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink);
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
void source_collection_relink (SourceCollection* self, DataSource* source);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
void source_collection_unlinked_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_unlinked_destroyed (SourceCollection* self, DataSource* source);
void source_collection_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
static void source_collection_real_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
enum  {
	SOURCE_COLLECTION_DESTROY_COUNTER_DUMMY_PROPERTY
};
static void source_collection_destroy_counter_finalize (GObject* obj);
static void source_collection_finalize (DataCollection* obj);
GType database_source_collection_get_type (void) G_GNUC_CONST;
#define DATABASE_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionPrivate))
enum  {
	DATABASE_SOURCE_COLLECTION_DUMMY_PROPERTY
};
guint int64_hash (void* p);
static guint _int64_hash_ghash_func (void* key);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (void* a, void* b);
static gint64* _int64_dup (gint64* self);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
static void database_source_collection_finalize (DataCollection* obj);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
#define CONTAINER_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionPrivate))
enum  {
	CONTAINER_SOURCE_COLLECTION_DUMMY_PROPERTY
};
ContainerSourceCollection* container_source_collection_construct (GType object_type, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources);
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self);
void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self);
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self);
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked);
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked);
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source);
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
char* source_backlink_to_string (SourceBacklink* self);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source);
gboolean container_source_has_links (ContainerSource* self);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source);
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container);
void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
void container_source_collection_detach_all_collections (ContainerSourceCollection* self);
void container_source_collection_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
void container_source_collection_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
void container_source_collection_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
void container_source_collection_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
static void container_source_collection_finalize (DataCollection* obj);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
#define SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankPrivate))
enum  {
	SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source);
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self);
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
gint source_holding_tank_get_count (SourceHoldingTank* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source);
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration);
void source_holding_tank_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_finalize (SourceHoldingTank* obj);
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
#define DATABASE_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankPrivate))
enum  {
	DATABASE_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
DatabaseSourceHoldingTank* database_source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
DatabaseSourceHoldingTank* database_source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
DataSource* database_source_holding_tank_get_by_id (DatabaseSourceHoldingTank* self, gint64 id);
static void database_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void database_source_holding_tank_finalize (SourceHoldingTank* obj);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
GType view_collection_get_type (void) G_GNUC_CONST;
gpointer view_collection_monitor_ref (gpointer instance);
void view_collection_monitor_unref (gpointer instance);
GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void view_collection_value_set_monitor (GValue* value, gpointer v_object);
void view_collection_value_take_monitor (GValue* value, gpointer v_object);
gpointer view_collection_value_get_monitor (const GValue* value);
GType view_collection_monitor_get_type (void) G_GNUC_CONST;
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
ViewCollection* view_collection_new (const char* name);
ViewCollection* view_collection_construct (GType object_type, const char* name);
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views);
void view_collection_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_clear (DataCollection* base);
gboolean view_collection_is_view_locked (ViewCollection* self);
void view_collection_unlock_view (ViewCollection* self);
void view_collection_lock_view (ViewCollection* self);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_all_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target);
void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target);
void view_collection_reapply_view_filter (ViewCollection* self);
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views);
void view_collection_reset_view_filter (ViewCollection* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added);
static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self);
static gboolean view_collection_real_add (DataCollection* base, DataObject* object);
void data_view_internal_set_visible (DataView* self, gboolean visible);
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
DataSource* data_view_get_source (DataView* self);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
static void view_collection_remove_selected (ViewCollection* self, DataView* view);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map);
static void view_collection_real_remove_marked (DataCollection* base, Marker* marker);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const char* type_selector);
char* data_source_get_typename (DataSource* self);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const char* typename);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
static void view_collection_add_selected (ViewCollection* self, DataView* view);
void view_collection_select_all (ViewCollection* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_all (ViewCollection* self);
GeeCollection* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
GeeCollection* view_collection_get_sources (ViewCollection* self);
GeeCollection* view_collection_get_selected_sources (ViewCollection* self);
DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources);
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources);
static void view_collection_real_notify_thawed (DataCollection* base);
void view_collection_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
void view_collection_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
void view_collection_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_selection_group_altered (ViewCollection* self);
static void view_collection_real_selection_group_altered (ViewCollection* self);
void view_collection_items_shown (ViewCollection* self, GeeCollection* visible);
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible);
void view_collection_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
enum  {
	VIEW_COLLECTION_MONITOR_DUMMY_PROPERTY
};
ViewCollectionMonitor* view_collection_monitor_new (void);
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_MONITOR_IMPL_DUMMY_PROPERTY
};
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__SOURCE_BACKLINK_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 35 "DataCollection.vala"
DataSet* data_set_construct (GType object_type) {
#line 1459 "DataCollection.c"
	DataSet* self = (DataSet*) g_type_create_instance (object_type);
#line 36 "DataCollection.vala"
	data_set_reset_comparator (self);
#line 1463 "DataCollection.c"
	return self;
}


#line 35 "DataCollection.vala"
DataSet* data_set_new (void) {
#line 35 "DataCollection.vala"
	return data_set_construct (TYPE_DATA_SET);
#line 1472 "DataCollection.c"
}


#line 39 "DataCollection.vala"
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b) {
#line 1478 "DataCollection.c"
	gint64 result = 0LL;
#line 39 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 1482 "DataCollection.c"
	result = data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) a)) - data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) b));
#line 40 "DataCollection.vala"
	return result;
#line 1486 "DataCollection.c"
}


#line 43 "DataCollection.vala"
static gboolean data_set_order_added_predicate (DataSet* self, DataObject* object, Alteration* alteration) {
#line 1492 "DataCollection.c"
	gboolean result = FALSE;
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 43 "DataCollection.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 1500 "DataCollection.c"
	result = FALSE;
#line 45 "DataCollection.vala"
	return result;
#line 1504 "DataCollection.c"
}


#line 48 "DataCollection.vala"
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b) {
#line 1510 "DataCollection.c"
	gint64 result = 0LL;
	gint64 _result_;
#line 48 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 49 "DataCollection.vala"
	if (a == b) {
#line 1517 "DataCollection.c"
		result = (gint64) 0;
#line 50 "DataCollection.vala"
		return result;
#line 1521 "DataCollection.c"
	}
#line 54 "DataCollection.vala"
	_result_ = self->priv->user_comparator (a, b, self->priv->user_comparator_target);
#line 55 "DataCollection.vala"
	if (_result_ == 0) {
#line 56 "DataCollection.vala"
		_result_ = data_set_order_added_comparator (self, a, b);
#line 1529 "DataCollection.c"
	}
#line 58 "DataCollection.vala"
	g_assert (_result_ != 0);
#line 1533 "DataCollection.c"
	result = _result_;
#line 60 "DataCollection.vala"
	return result;
#line 1537 "DataCollection.c"
}


#line 63 "DataCollection.vala"
gboolean data_set_contains (DataSet* self, DataObject* object) {
#line 1543 "DataCollection.c"
	gboolean result = FALSE;
#line 63 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 63 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1549 "DataCollection.c"
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object);
#line 64 "DataCollection.vala"
	return result;
#line 1553 "DataCollection.c"
}


#line 67 "DataCollection.vala"
inline gint data_set_get_count (DataSet* self) {
#line 1559 "DataCollection.c"
	gint result = 0;
#line 67 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 1563 "DataCollection.c"
	result = sorted_list_get_count (self->priv->list);
#line 68 "DataCollection.vala"
	return result;
#line 1567 "DataCollection.c"
}


#line 43 "DataCollection.vala"
static gboolean _data_set_order_added_predicate_comparator_predicate (DataObject* object, Alteration* alteration, gpointer self) {
#line 1573 "DataCollection.c"
	gboolean result;
	result = data_set_order_added_predicate (self, object, alteration);
	return result;
}


#line 39 "DataCollection.vala"
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self) {
#line 1582 "DataCollection.c"
	gint64 result;
	result = data_set_order_added_comparator (self, a, b);
	return result;
}


#line 71 "DataCollection.vala"
void data_set_reset_comparator (DataSet* self) {
#line 1591 "DataCollection.c"
	Comparator _tmp0_;
	ComparatorPredicate _tmp1_;
#line 71 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 72 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = NULL, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 73 "DataCollection.vala"
	self->priv->comparator_predicate = (_tmp1_ = _data_set_order_added_predicate_comparator_predicate, ((self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL), self->priv->comparator_predicate = NULL, self->priv->comparator_predicate_target = NULL, self->priv->comparator_predicate_target_destroy_notify = NULL), self->priv->comparator_predicate_target = data_set_ref (self), self->priv->comparator_predicate_target_destroy_notify = data_set_unref, _tmp1_);
#line 74 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_order_added_comparator_comparator, self);
#line 1602 "DataCollection.c"
}


#line 48 "DataCollection.vala"
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self) {
#line 1608 "DataCollection.c"
	gint64 result;
	result = data_set_comparator_wrapper (self, a, b);
	return result;
}


#line 77 "DataCollection.vala"
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target) {
#line 1617 "DataCollection.c"
	Comparator _tmp0_;
	ComparatorPredicate _tmp1_;
#line 77 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 78 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = user_comparator, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = user_comparator_target, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 79 "DataCollection.vala"
	self->priv->comparator_predicate = (_tmp1_ = comparator_predicate, ((self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL), self->priv->comparator_predicate = NULL, self->priv->comparator_predicate_target = NULL, self->priv->comparator_predicate_target_destroy_notify = NULL), self->priv->comparator_predicate_target = comparator_predicate_target, self->priv->comparator_predicate_target_destroy_notify = NULL, _tmp1_);
#line 80 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_comparator_wrapper_comparator, self);
#line 1628 "DataCollection.c"
}


#line 83 "DataCollection.vala"
GeeCollection* data_set_get_all (DataSet* self) {
#line 1634 "DataCollection.c"
	GeeCollection* result = NULL;
#line 83 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1638 "DataCollection.c"
	result = gee_collection_get_read_only_view (GEE_COLLECTION (self->priv->list));
#line 84 "DataCollection.vala"
	return result;
#line 1642 "DataCollection.c"
}


#line 87 "DataCollection.vala"
DataSet* data_set_copy (DataSet* self) {
#line 1648 "DataCollection.c"
	DataSet* result = NULL;
	DataSet* clone;
	SortedList* _tmp0_;
#line 87 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 88 "DataCollection.vala"
	clone = data_set_new ();
#line 89 "DataCollection.vala"
	clone->priv->list = (_tmp0_ = sorted_list_copy (self->priv->list), _g_object_unref0 (clone->priv->list), _tmp0_);
#line 90 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (clone->priv->hash_set), GEE_COLLECTION (self->priv->hash_set));
#line 1660 "DataCollection.c"
	result = clone;
#line 92 "DataCollection.vala"
	return result;
#line 1664 "DataCollection.c"
}


#line 95 "DataCollection.vala"
DataObject* data_set_get_at (DataSet* self, gint index) {
#line 1670 "DataCollection.c"
	DataObject* result = NULL;
#line 95 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1674 "DataCollection.c"
	result = (DataObject*) sorted_list_get_at (self->priv->list, index);
#line 96 "DataCollection.vala"
	return result;
#line 1678 "DataCollection.c"
}


#line 99 "DataCollection.vala"
gint data_set_index_of (DataSet* self, DataObject* object) {
#line 1684 "DataCollection.c"
	gint result = 0;
#line 99 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 99 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1690 "DataCollection.c"
	result = sorted_list_locate (self->priv->list, object, FALSE, g_direct_equal);
#line 100 "DataCollection.vala"
	return result;
#line 1694 "DataCollection.c"
}


#line 104 "DataCollection.vala"
gboolean data_set_add (DataSet* self, DataObject* object) {
#line 1700 "DataCollection.c"
	gboolean result = FALSE;
#line 104 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 104 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 105 "DataCollection.vala"
	if (!gee_collection_add (GEE_COLLECTION (self->priv->list), object)) {
#line 1708 "DataCollection.c"
		result = FALSE;
#line 106 "DataCollection.vala"
		return result;
#line 1712 "DataCollection.c"
	}
#line 108 "DataCollection.vala"
	if (!gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 110 "DataCollection.vala"
		gee_collection_remove (GEE_COLLECTION (self->priv->list), object);
#line 1718 "DataCollection.c"
		result = FALSE;
#line 112 "DataCollection.vala"
		return result;
#line 1722 "DataCollection.c"
	}
	result = TRUE;
#line 115 "DataCollection.vala"
	return result;
#line 1727 "DataCollection.c"
}


#line 119 "DataCollection.vala"
gboolean data_set_add_many (DataSet* self, GeeCollection* objects) {
#line 1733 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 119 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 119 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), FALSE);
#line 120 "DataCollection.vala"
	count = gee_collection_get_size (objects);
#line 121 "DataCollection.vala"
	if (count == 0) {
#line 1744 "DataCollection.c"
		result = TRUE;
#line 122 "DataCollection.vala"
		return result;
#line 1748 "DataCollection.c"
	}
#line 124 "DataCollection.vala"
	if (!gee_collection_add_all (GEE_COLLECTION (self->priv->list), objects)) {
#line 1752 "DataCollection.c"
		result = FALSE;
#line 125 "DataCollection.vala"
		return result;
#line 1756 "DataCollection.c"
	}
#line 127 "DataCollection.vala"
	if (!gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), objects)) {
#line 129 "DataCollection.vala"
		gee_collection_remove_all (GEE_COLLECTION (self->priv->list), objects);
#line 1762 "DataCollection.c"
		result = FALSE;
#line 131 "DataCollection.vala"
		return result;
#line 1766 "DataCollection.c"
	}
	result = TRUE;
#line 134 "DataCollection.vala"
	return result;
#line 1771 "DataCollection.c"
}


#line 137 "DataCollection.vala"
gboolean data_set_remove (DataSet* self, DataObject* object) {
#line 1777 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 138 "DataCollection.vala"
	success = TRUE;
#line 140 "DataCollection.vala"
	if (!gee_collection_remove (GEE_COLLECTION (self->priv->list), object)) {
#line 141 "DataCollection.vala"
		success = FALSE;
#line 1790 "DataCollection.c"
	}
#line 143 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 144 "DataCollection.vala"
		success = FALSE;
#line 1796 "DataCollection.c"
	}
	result = success;
#line 146 "DataCollection.vala"
	return result;
#line 1801 "DataCollection.c"
}


#line 149 "DataCollection.vala"
gboolean data_set_remove_many (DataSet* self, GeeList* objects) {
#line 1807 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 149 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 149 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 150 "DataCollection.vala"
	success = TRUE;
#line 152 "DataCollection.vala"
	if (!gee_collection_remove_all (GEE_COLLECTION (self->priv->list), GEE_COLLECTION (objects))) {
#line 153 "DataCollection.vala"
		success = FALSE;
#line 1820 "DataCollection.c"
	}
#line 155 "DataCollection.vala"
	if (!gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 156 "DataCollection.vala"
		success = FALSE;
#line 1826 "DataCollection.c"
	}
	result = success;
#line 158 "DataCollection.vala"
	return result;
#line 1831 "DataCollection.c"
}


#line 162 "DataCollection.vala"
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration) {
#line 1837 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 162 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 162 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 162 "DataCollection.vala"
	g_return_val_if_fail ((alteration == NULL) || IS_ALTERATION (alteration), FALSE);
#line 163 "DataCollection.vala"
	if (self->priv->comparator_predicate != NULL) {
#line 163 "DataCollection.vala"
		_tmp1_ = alteration != NULL;
#line 1851 "DataCollection.c"
	} else {
#line 163 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 1855 "DataCollection.c"
	}
#line 163 "DataCollection.vala"
	if (_tmp1_) {
#line 164 "DataCollection.vala"
		_tmp0_ = !self->priv->comparator_predicate (object, alteration, self->priv->comparator_predicate_target);
#line 1861 "DataCollection.c"
	} else {
#line 163 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 1865 "DataCollection.c"
	}
#line 163 "DataCollection.vala"
	if (_tmp0_) {
#line 1869 "DataCollection.c"
		result = FALSE;
#line 165 "DataCollection.vala"
		return result;
#line 1873 "DataCollection.c"
	}
	result = sorted_list_resort_item (self->priv->list, object);
#line 168 "DataCollection.vala"
	return result;
#line 1878 "DataCollection.c"
}


static void value_data_set_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_set_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_set_unref (value->data[0].v_pointer);
	}
}


static void value_data_set_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_set_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_set_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_set_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataSet* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_set_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_set_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataSet** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_set_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataSet* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_SET), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_set (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_set_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


void value_take_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


static void data_set_class_init (DataSetClass * klass) {
	data_set_parent_class = g_type_class_peek_parent (klass);
	DATA_SET_CLASS (klass)->finalize = data_set_finalize;
	g_type_class_add_private (klass, sizeof (DataSetPrivate));
}


static void data_set_instance_init (DataSet * self) {
	self->priv = DATA_SET_GET_PRIVATE (self);
	self->priv->list = sorted_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->hash_set = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->user_comparator = NULL;
	self->priv->comparator_predicate = NULL;
	self->ref_count = 1;
}


static void data_set_finalize (DataSet* obj) {
	DataSet * self;
	self = DATA_SET (obj);
	_g_object_unref0 (self->priv->list);
	_g_object_unref0 (self->priv->hash_set);
	(self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL);
	self->priv->user_comparator = NULL;
	self->priv->user_comparator_target = NULL;
	self->priv->user_comparator_target_destroy_notify = NULL;
	(self->priv->comparator_predicate_target_destroy_notify == NULL) ? NULL : (self->priv->comparator_predicate_target_destroy_notify (self->priv->comparator_predicate_target), NULL);
	self->priv->comparator_predicate = NULL;
	self->priv->comparator_predicate_target = NULL;
	self->priv->comparator_predicate_target_destroy_notify = NULL;
}


GType data_set_get_type (void) {
	static volatile gsize data_set_type_id__volatile = 0;
	if (g_once_init_enter (&data_set_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_set_init, value_data_set_free_value, value_data_set_copy_value, value_data_set_peek_pointer, "p", value_data_set_collect_value, "p", value_data_set_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSet), 0, (GInstanceInitFunc) data_set_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_set_type_id;
		data_set_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataSet", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_set_type_id__volatile, data_set_type_id);
	}
	return data_set_type_id__volatile;
}


gpointer data_set_ref (gpointer instance) {
	DataSet* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_set_unref (gpointer instance) {
	DataSet* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_SET_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 225 "DataCollection.vala"
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 2059 "DataCollection.c"
	SingletonCollection * self = NULL;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
#line 225 "DataCollection.vala"
	self = (SingletonCollection*) gee_abstract_collection_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func);
#line 225 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 225 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 225 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 226 "DataCollection.vala"
	self->priv->object = (_tmp1_ = (_tmp0_ = object, ((_tmp0_ == NULL) || (g_dup_func == NULL)) ? ((gpointer) _tmp0_) : g_dup_func ((gpointer) _tmp0_)), _g_destroy_func0 (self->priv->object), _tmp1_);
#line 2073 "DataCollection.c"
	return self;
}


#line 225 "DataCollection.vala"
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 225 "DataCollection.vala"
	return singleton_collection_construct (TYPE_SINGLETON_COLLECTION, g_type, g_dup_func, g_destroy_func, object);
#line 2082 "DataCollection.c"
}


#line 229 "DataCollection.vala"
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object) {
#line 2088 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 230 "DataCollection.vala"
	g_warning ("DataCollection.vala:230: Cannot add to SingletonCollection");
#line 2094 "DataCollection.c"
	result = FALSE;
#line 232 "DataCollection.vala"
	return result;
#line 2098 "DataCollection.c"
}


#line 235 "DataCollection.vala"
static void singleton_collection_real_clear (GeeAbstractCollection* base) {
#line 2104 "DataCollection.c"
	SingletonCollection * self;
	gpointer _tmp0_;
	self = SINGLETON_COLLECTION (base);
#line 236 "DataCollection.vala"
	self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 2110 "DataCollection.c"
}


#line 239 "DataCollection.vala"
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object) {
#line 2116 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
	result = self->priv->object == object;
#line 240 "DataCollection.vala"
	return result;
#line 2123 "DataCollection.c"
}


#line 243 "DataCollection.vala"
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base) {
#line 2129 "DataCollection.c"
	SingletonCollection * self;
	GeeIterator* result = NULL;
	self = SINGLETON_COLLECTION (base);
	result = GEE_ITERATOR (singleton_collection_singleton_iterator_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self));
#line 244 "DataCollection.vala"
	return result;
#line 2136 "DataCollection.c"
}


#line 247 "DataCollection.vala"
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item) {
#line 2142 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 248 "DataCollection.vala"
	if (item == self->priv->object) {
#line 2148 "DataCollection.c"
		gpointer _tmp0_;
#line 249 "DataCollection.vala"
		self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 2152 "DataCollection.c"
		result = TRUE;
#line 251 "DataCollection.vala"
		return result;
#line 2156 "DataCollection.c"
	}
	result = FALSE;
#line 254 "DataCollection.vala"
	return result;
#line 2161 "DataCollection.c"
}


static gint singleton_collection_real_get_size (GeeAbstractCollection* base) {
	gint result;
	SingletonCollection* self;
	gint _tmp0_ = 0;
	self = SINGLETON_COLLECTION (base);
#line 259 "DataCollection.vala"
	if (self->priv->object != NULL) {
#line 259 "DataCollection.vala"
		_tmp0_ = 1;
#line 2174 "DataCollection.c"
	} else {
#line 259 "DataCollection.vala"
		_tmp0_ = 0;
#line 2178 "DataCollection.c"
	}
	result = _tmp0_;
#line 259 "DataCollection.vala"
	return result;
#line 2183 "DataCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 184 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 2194 "DataCollection.c"
	SingletonCollectionSingletonIterator * self = NULL;
	SingletonCollection* _tmp0_;
#line 184 "DataCollection.vala"
	g_return_val_if_fail (IS_SINGLETON_COLLECTION (c), NULL);
#line 184 "DataCollection.vala"
	self = (SingletonCollectionSingletonIterator*) g_object_new (object_type, NULL);
#line 184 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 184 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 184 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 185 "DataCollection.vala"
	self->priv->c = (_tmp0_ = _g_object_ref0 (c), _g_object_unref0 (self->priv->c), _tmp0_);
#line 2209 "DataCollection.c"
	return self;
}


#line 184 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 184 "DataCollection.vala"
	return singleton_collection_singleton_iterator_construct (SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, g_type, g_dup_func, g_destroy_func, c);
#line 2218 "DataCollection.c"
}


#line 188 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base) {
#line 2224 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 189 "DataCollection.vala"
	self->priv->done = FALSE;
#line 190 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2234 "DataCollection.c"
	result = self->priv->current != NULL;
#line 192 "DataCollection.vala"
	return result;
#line 2238 "DataCollection.c"
}


#line 195 "DataCollection.vala"
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base) {
#line 2244 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gpointer result = NULL;
	gconstpointer _tmp0_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = (_tmp0_ = self->priv->current, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_));
#line 196 "DataCollection.vala"
	return result;
#line 2252 "DataCollection.c"
}


#line 199 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base) {
#line 2258 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = FALSE;
#line 200 "DataCollection.vala"
	return result;
#line 2265 "DataCollection.c"
}


#line 203 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base) {
#line 2271 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 204 "DataCollection.vala"
	if (self->priv->done) {
#line 2279 "DataCollection.c"
		result = FALSE;
#line 205 "DataCollection.vala"
		return result;
#line 2283 "DataCollection.c"
	}
#line 207 "DataCollection.vala"
	self->priv->done = TRUE;
#line 208 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2289 "DataCollection.c"
	result = TRUE;
#line 210 "DataCollection.vala"
	return result;
#line 2293 "DataCollection.c"
}


#line 213 "DataCollection.vala"
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base) {
#line 2299 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 214 "DataCollection.vala"
	if (!self->priv->done) {
#line 2304 "DataCollection.c"
		gpointer _tmp0_;
		gpointer _tmp1_;
#line 215 "DataCollection.vala"
		self->priv->c->priv->object = (_tmp0_ = NULL, ((self->priv->c->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->c->priv->object = (self->priv->g_destroy_func (self->priv->c->priv->object), NULL)), _tmp0_);
#line 216 "DataCollection.vala"
		self->priv->current = (_tmp1_ = NULL, ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 2311 "DataCollection.c"
	}
#line 219 "DataCollection.vala"
	self->priv->done = TRUE;
#line 2315 "DataCollection.c"
}


static void singleton_collection_singleton_iterator_class_init (SingletonCollectionSingletonIteratorClass * klass) {
	singleton_collection_singleton_iterator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionSingletonIteratorPrivate));
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_singleton_iterator_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_singleton_iterator_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_singleton_iterator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void singleton_collection_singleton_iterator_gee_iterator_interface_init (GeeIteratorIface * iface) {
	singleton_collection_singleton_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
	iface->first = singleton_collection_singleton_iterator_real_first;
	iface->get = singleton_collection_singleton_iterator_real_get;
	iface->has_next = singleton_collection_singleton_iterator_real_has_next;
	iface->next = singleton_collection_singleton_iterator_real_next;
	iface->remove = singleton_collection_singleton_iterator_real_remove;
}


static void singleton_collection_singleton_iterator_instance_init (SingletonCollectionSingletonIterator * self) {
	self->priv = SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE (self);
	self->priv->done = FALSE;
	self->priv->current = NULL;
}


static void singleton_collection_singleton_iterator_finalize (GObject* obj) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (obj);
	_g_object_unref0 (self->priv->c);
	((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL));
	G_OBJECT_CLASS (singleton_collection_singleton_iterator_parent_class)->finalize (obj);
}


static GType singleton_collection_singleton_iterator_get_type (void) {
	static volatile gsize singleton_collection_singleton_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_singleton_iterator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionSingletonIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_singleton_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollectionSingletonIterator), 0, (GInstanceInitFunc) singleton_collection_singleton_iterator_instance_init, NULL };
		static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) singleton_collection_singleton_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType singleton_collection_singleton_iterator_type_id;
		singleton_collection_singleton_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "SingletonCollectionSingletonIterator", &g_define_type_info, 0);
		g_type_add_interface_static (singleton_collection_singleton_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
		g_once_init_leave (&singleton_collection_singleton_iterator_type_id__volatile, singleton_collection_singleton_iterator_type_id);
	}
	return singleton_collection_singleton_iterator_type_id__volatile;
}


static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void singleton_collection_class_init (SingletonCollectionClass * klass) {
	singleton_collection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionPrivate));
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->add = singleton_collection_real_add;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->clear = singleton_collection_real_clear;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->contains = singleton_collection_real_contains;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->iterator = singleton_collection_real_iterator;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->remove = singleton_collection_real_remove;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->get_size = singleton_collection_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SIZE, "size");
}


static void singleton_collection_instance_init (SingletonCollection * self) {
	self->priv = SINGLETON_COLLECTION_GET_PRIVATE (self);
}


static void singleton_collection_finalize (GObject* obj) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (obj);
	((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL));
	G_OBJECT_CLASS (singleton_collection_parent_class)->finalize (obj);
}


GType singleton_collection_get_type (void) {
	static volatile gsize singleton_collection_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollection), 0, (GInstanceInitFunc) singleton_collection_instance_init, NULL };
		GType singleton_collection_type_id;
		singleton_collection_type_id = g_type_register_static (GEE_TYPE_ABSTRACT_COLLECTION, "SingletonCollection", &g_define_type_info, 0);
		g_once_init_leave (&singleton_collection_type_id__volatile, singleton_collection_type_id);
	}
	return singleton_collection_type_id__volatile;
}


static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		case SINGLETON_COLLECTION_SIZE:
		g_value_set_int (value, gee_abstract_collection_get_size (GEE_ABSTRACT_COLLECTION (self)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


#line 184 "DataCollection.vala"
void marker_mark (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark (self, object);
#line 2484 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_unmark (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark (self, object);
#line 2492 "DataCollection.c"
}


#line 184 "DataCollection.vala"
gboolean marker_toggle (Marker* self, DataObject* object) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->toggle (self, object);
#line 2500 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_mark_many (Marker* self, GeeCollection* list) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_many (self, list);
#line 2508 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_unmark_many (Marker* self, GeeCollection* list) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark_many (self, list);
#line 2516 "DataCollection.c"
}


#line 184 "DataCollection.vala"
void marker_mark_all (Marker* self) {
#line 184 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_all (self);
#line 2524 "DataCollection.c"
}


#line 184 "DataCollection.vala"
gint marker_get_count (Marker* self) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_count (self);
#line 2532 "DataCollection.c"
}


#line 184 "DataCollection.vala"
GeeCollection* marker_get_all (Marker* self) {
#line 184 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_all (self);
#line 2540 "DataCollection.c"
}


static void marker_base_init (MarkerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType marker_get_type (void) {
	static volatile gsize marker_type_id__volatile = 0;
	if (g_once_init_enter (&marker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarkerIface), (GBaseInitFunc) marker_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType marker_type_id;
		marker_type_id = g_type_register_static (G_TYPE_INTERFACE, "Marker", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (marker_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&marker_type_id__volatile, marker_type_id);
	}
	return marker_type_id__volatile;
}


#line 307 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2567 "DataCollection.c"
	UnknownTotalMonitor* self = (UnknownTotalMonitor*) g_type_create_instance (object_type);
	ProgressMonitor _tmp0_;
#line 308 "DataCollection.vala"
	self->priv->total = total;
#line 309 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2574 "DataCollection.c"
	return self;
}


#line 307 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 307 "DataCollection.vala"
	return unknown_total_monitor_construct (TYPE_UNKNOWN_TOTAL_MONITOR, total, wrapped_monitor, wrapped_monitor_target);
#line 2583 "DataCollection.c"
}


#line 312 "DataCollection.vala"
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total) {
#line 2589 "DataCollection.c"
	gboolean result = FALSE;
#line 312 "DataCollection.vala"
	g_return_val_if_fail (IS_UNKNOWN_TOTAL_MONITOR (self), FALSE);
#line 2593 "DataCollection.c"
	result = self->priv->wrapped_monitor (count, self->priv->total, self->priv->wrapped_monitor_target);
#line 313 "DataCollection.vala"
	return result;
#line 2597 "DataCollection.c"
}


static void value_unknown_total_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_unknown_total_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		unknown_total_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_unknown_total_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = unknown_total_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_unknown_total_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_unknown_total_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		UnknownTotalMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = unknown_total_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_unknown_total_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	UnknownTotalMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = unknown_total_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUnknownTotalMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_unknown_total_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		unknown_total_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


void value_take_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


static void unknown_total_monitor_class_init (UnknownTotalMonitorClass * klass) {
	unknown_total_monitor_parent_class = g_type_class_peek_parent (klass);
	UNKNOWN_TOTAL_MONITOR_CLASS (klass)->finalize = unknown_total_monitor_finalize;
	g_type_class_add_private (klass, sizeof (UnknownTotalMonitorPrivate));
}


static void unknown_total_monitor_instance_init (UnknownTotalMonitor * self) {
	self->priv = UNKNOWN_TOTAL_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj) {
	UnknownTotalMonitor * self;
	self = UNKNOWN_TOTAL_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType unknown_total_monitor_get_type (void) {
	static volatile gsize unknown_total_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&unknown_total_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_unknown_total_monitor_init, value_unknown_total_monitor_free_value, value_unknown_total_monitor_copy_value, value_unknown_total_monitor_peek_pointer, "p", value_unknown_total_monitor_collect_value, "p", value_unknown_total_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UnknownTotalMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unknown_total_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnknownTotalMonitor), 0, (GInstanceInitFunc) unknown_total_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType unknown_total_monitor_type_id;
		unknown_total_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UnknownTotalMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&unknown_total_monitor_type_id__volatile, unknown_total_monitor_type_id);
	}
	return unknown_total_monitor_type_id__volatile;
}


gpointer unknown_total_monitor_ref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void unknown_total_monitor_unref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UNKNOWN_TOTAL_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 325 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2768 "DataCollection.c"
	AggregateProgressMonitor* self = (AggregateProgressMonitor*) g_type_create_instance (object_type);
	ProgressMonitor _tmp0_;
#line 326 "DataCollection.vala"
	self->priv->grand_total = grand_total;
#line 327 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2775 "DataCollection.c"
	return self;
}


#line 325 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 325 "DataCollection.vala"
	return aggregate_progress_monitor_construct (TYPE_AGGREGATE_PROGRESS_MONITOR, grand_total, wrapped_monitor, wrapped_monitor_target);
#line 2784 "DataCollection.c"
}


#line 330 "DataCollection.vala"
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name) {
#line 2790 "DataCollection.c"
	char* _tmp0_;
	char* _tmp1_;
#line 330 "DataCollection.vala"
	g_return_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self));
#line 330 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 331 "DataCollection.vala"
	g_debug ("DataCollection.vala:331: next step: %s (%s/%s)", name, _tmp0_ = g_strdup_printf ("%" G_GUINT64_FORMAT, self->priv->aggregate_count), _tmp1_ = g_strdup_printf ("%" G_GUINT64_FORMAT, self->priv->grand_total));
#line 2799 "DataCollection.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 332 "DataCollection.vala"
	self->priv->last_count = G_MAXUINT64;
#line 2804 "DataCollection.c"
}


#line 335 "DataCollection.vala"
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total) {
#line 2810 "DataCollection.c"
	gboolean result = FALSE;
	guint64 _tmp0_ = 0ULL;
#line 335 "DataCollection.vala"
	g_return_val_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self), FALSE);
#line 337 "DataCollection.vala"
	if (self->priv->last_count != G_MAXUINT64) {
#line 337 "DataCollection.vala"
		_tmp0_ = count - self->priv->last_count;
#line 2819 "DataCollection.c"
	} else {
#line 337 "DataCollection.vala"
		_tmp0_ = count;
#line 2823 "DataCollection.c"
	}
#line 337 "DataCollection.vala"
	self->priv->aggregate_count = self->priv->aggregate_count + _tmp0_;
#line 338 "DataCollection.vala"
	if (self->priv->aggregate_count > self->priv->grand_total) {
#line 339 "DataCollection.vala"
		self->priv->aggregate_count = self->priv->grand_total;
#line 2831 "DataCollection.c"
	}
#line 342 "DataCollection.vala"
	self->priv->last_count = count;
#line 2835 "DataCollection.c"
	result = self->priv->wrapped_monitor (self->priv->aggregate_count, self->priv->grand_total, self->priv->wrapped_monitor_target);
#line 344 "DataCollection.vala"
	return result;
#line 2839 "DataCollection.c"
}


static void value_aggregate_progress_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_aggregate_progress_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		aggregate_progress_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_aggregate_progress_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = aggregate_progress_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_aggregate_progress_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_aggregate_progress_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		AggregateProgressMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = aggregate_progress_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_aggregate_progress_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	AggregateProgressMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = aggregate_progress_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAggregateProgressMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_aggregate_progress_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		aggregate_progress_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


static void aggregate_progress_monitor_class_init (AggregateProgressMonitorClass * klass) {
	aggregate_progress_monitor_parent_class = g_type_class_peek_parent (klass);
	AGGREGATE_PROGRESS_MONITOR_CLASS (klass)->finalize = aggregate_progress_monitor_finalize;
	g_type_class_add_private (klass, sizeof (AggregateProgressMonitorPrivate));
}


static void aggregate_progress_monitor_instance_init (AggregateProgressMonitor * self) {
	self->priv = AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE (self);
	self->priv->aggregate_count = (guint64) 0;
	self->priv->last_count = G_MAXUINT64;
	self->ref_count = 1;
}


static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj) {
	AggregateProgressMonitor * self;
	self = AGGREGATE_PROGRESS_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType aggregate_progress_monitor_get_type (void) {
	static volatile gsize aggregate_progress_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&aggregate_progress_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_aggregate_progress_monitor_init, value_aggregate_progress_monitor_free_value, value_aggregate_progress_monitor_copy_value, value_aggregate_progress_monitor_peek_pointer, "p", value_aggregate_progress_monitor_collect_value, "p", value_aggregate_progress_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AggregateProgressMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aggregate_progress_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AggregateProgressMonitor), 0, (GInstanceInitFunc) aggregate_progress_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType aggregate_progress_monitor_type_id;
		aggregate_progress_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AggregateProgressMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&aggregate_progress_monitor_type_id__volatile, aggregate_progress_monitor_type_id);
	}
	return aggregate_progress_monitor_type_id__volatile;
}


gpointer aggregate_progress_monitor_ref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void aggregate_progress_monitor_unref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		AGGREGATE_PROGRESS_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 349 "DataCollection.vala"
gboolean null_progress_monitor (guint64 count, guint64 total) {
#line 3012 "DataCollection.c"
	gboolean result = FALSE;
	result = TRUE;
#line 350 "DataCollection.vala"
	return result;
#line 3017 "DataCollection.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


#line 503 "DataCollection.vala"
DataCollection* data_collection_construct (GType object_type, const char* name) {
#line 3034 "DataCollection.c"
	DataCollection* self = (DataCollection*) g_type_create_instance (object_type);
	char* _tmp0_;
#line 503 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 504 "DataCollection.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 3041 "DataCollection.c"
	return self;
}


#line 503 "DataCollection.vala"
DataCollection* data_collection_new (const char* name) {
#line 503 "DataCollection.vala"
	return data_collection_construct (TYPE_DATA_COLLECTION, name);
#line 3050 "DataCollection.c"
}


#line 513 "DataCollection.vala"
static char* data_collection_real_to_string (DataCollection* self) {
#line 3056 "DataCollection.c"
	char* result = NULL;
#line 513 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3060 "DataCollection.c"
	result = g_strdup_printf ("%s (%d)", self->priv->name, data_collection_get_count (self));
#line 514 "DataCollection.vala"
	return result;
#line 3064 "DataCollection.c"
}


#line 503 "DataCollection.vala"
char* data_collection_to_string (DataCollection* self) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->to_string (self);
#line 3072 "DataCollection.c"
}


#line 518 "DataCollection.vala"
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 518 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 518 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 519 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-added", added);
#line 3084 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_added (self, added);
#line 3092 "DataCollection.c"
}


#line 522 "DataCollection.vala"
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 522 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 522 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 523 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-removed", removed);
#line 3104 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_removed (self, removed);
#line 3112 "DataCollection.c"
}


#line 526 "DataCollection.vala"
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 526 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 526 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 526 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 528 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 3126 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 3134 "DataCollection.c"
}


#line 531 "DataCollection.vala"
static void data_collection_real_notify_items_altered (DataCollection* self, GeeMap* items) {
#line 531 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 531 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 532 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-altered", items);
#line 3146 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_items_altered (DataCollection* self, GeeMap* items) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_altered (self, items);
#line 3154 "DataCollection.c"
}


#line 535 "DataCollection.vala"
static void data_collection_real_notify_ordering_changed (DataCollection* self) {
#line 535 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 536 "DataCollection.vala"
	g_signal_emit_by_name (self, "ordering-changed");
#line 3164 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_ordering_changed (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_ordering_changed (self);
#line 3172 "DataCollection.c"
}


#line 539 "DataCollection.vala"
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 539 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 539 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 540 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-set", name, old, val);
#line 3184 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_set (self, name, old, val);
#line 3192 "DataCollection.c"
}


#line 543 "DataCollection.vala"
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name) {
#line 543 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 543 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 544 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-cleared", name);
#line 3204 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_property_cleared (DataCollection* self, const char* name) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_cleared (self, name);
#line 3212 "DataCollection.c"
}


#line 552 "DataCollection.vala"
GeeCollection* data_collection_get_singleton (DataObject* object) {
#line 3218 "DataCollection.c"
	GeeCollection* result = NULL;
#line 552 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 3222 "DataCollection.c"
	result = GEE_COLLECTION (singleton_collection_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, object));
#line 553 "DataCollection.vala"
	return result;
#line 3226 "DataCollection.c"
}


#line 556 "DataCollection.vala"
GeeMap* data_collection_get_alteration_singleton (DataObject* object, Alteration* alteration) {
#line 3232 "DataCollection.c"
	GeeMap* result = NULL;
	GeeMap* map;
#line 556 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 556 "DataCollection.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), NULL);
#line 558 "DataCollection.vala"
	map = GEE_MAP (gee_hash_map_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_ALTERATION, (GBoxedCopyFunc) alteration_ref, alteration_unref, NULL, NULL, NULL));
#line 559 "DataCollection.vala"
	gee_map_set (map, object, alteration);
#line 3243 "DataCollection.c"
	result = map;
#line 561 "DataCollection.vala"
	return result;
#line 3247 "DataCollection.c"
}


#line 564 "DataCollection.vala"
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object) {
#line 3253 "DataCollection.c"
	gboolean result = FALSE;
#line 564 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 564 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 3259 "DataCollection.c"
	result = TRUE;
#line 565 "DataCollection.vala"
	return result;
#line 3263 "DataCollection.c"
}


#line 503 "DataCollection.vala"
gboolean data_collection_valid_type (DataCollection* self, DataObject* object) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->valid_type (self, object);
#line 3271 "DataCollection.c"
}


#line 568 "DataCollection.vala"
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 568 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 569 "DataCollection.vala"
	data_set_set_comparator (self->priv->dataset, comparator, comparator_target, predicate, predicate_target);
#line 570 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 3283 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->set_comparator (self, comparator, comparator_target, predicate, predicate_target);
#line 3291 "DataCollection.c"
}


#line 574 "DataCollection.vala"
static void data_collection_real_reset_comparator (DataCollection* self) {
#line 574 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 575 "DataCollection.vala"
	data_set_reset_comparator (self->priv->dataset);
#line 576 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 3303 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_reset_comparator (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->reset_comparator (self);
#line 3311 "DataCollection.c"
}


#line 579 "DataCollection.vala"
static GeeCollection* data_collection_real_get_all (DataCollection* self) {
#line 3317 "DataCollection.c"
	GeeCollection* result = NULL;
#line 579 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3321 "DataCollection.c"
	result = data_set_get_all (self->priv->dataset);
#line 580 "DataCollection.vala"
	return result;
#line 3325 "DataCollection.c"
}


#line 503 "DataCollection.vala"
GeeCollection* data_collection_get_all (DataCollection* self) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_all (self);
#line 3333 "DataCollection.c"
}


#line 583 "DataCollection.vala"
DataSet* data_collection_get_dataset_copy (DataCollection* self) {
#line 3339 "DataCollection.c"
	DataSet* result = NULL;
#line 583 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3343 "DataCollection.c"
	result = data_set_copy (self->priv->dataset);
#line 584 "DataCollection.vala"
	return result;
#line 3347 "DataCollection.c"
}


#line 587 "DataCollection.vala"
static gint data_collection_real_get_count (DataCollection* self) {
#line 3353 "DataCollection.c"
	gint result = 0;
#line 587 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 3357 "DataCollection.c"
	result = data_set_get_count (self->priv->dataset);
#line 588 "DataCollection.vala"
	return result;
#line 3361 "DataCollection.c"
}


#line 503 "DataCollection.vala"
gint data_collection_get_count (DataCollection* self) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_count (self);
#line 3369 "DataCollection.c"
}


#line 591 "DataCollection.vala"
static DataObject* data_collection_real_get_at (DataCollection* self, gint index) {
#line 3375 "DataCollection.c"
	DataObject* result = NULL;
#line 591 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3379 "DataCollection.c"
	result = data_set_get_at (self->priv->dataset, index);
#line 592 "DataCollection.vala"
	return result;
#line 3383 "DataCollection.c"
}


#line 503 "DataCollection.vala"
DataObject* data_collection_get_at (DataCollection* self, gint index) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_at (self, index);
#line 3391 "DataCollection.c"
}


#line 595 "DataCollection.vala"
static gint data_collection_real_index_of (DataCollection* self, DataObject* object) {
#line 3397 "DataCollection.c"
	gint result = 0;
#line 595 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 595 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 3403 "DataCollection.c"
	result = data_set_index_of (self->priv->dataset, object);
#line 596 "DataCollection.vala"
	return result;
#line 3407 "DataCollection.c"
}


#line 503 "DataCollection.vala"
gint data_collection_index_of (DataCollection* self, DataObject* object) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->index_of (self, object);
#line 3415 "DataCollection.c"
}


#line 599 "DataCollection.vala"
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object) {
#line 3421 "DataCollection.c"
	gboolean result = FALSE;
#line 599 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 599 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 3427 "DataCollection.c"
	result = data_collection_internal_contains (self, object);
#line 600 "DataCollection.vala"
	return result;
#line 3431 "DataCollection.c"
}


#line 503 "DataCollection.vala"
gboolean data_collection_contains (DataCollection* self, DataObject* object) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->contains (self, object);
#line 3439 "DataCollection.c"
}


#line 605 "DataCollection.vala"
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object) {
#line 3445 "DataCollection.c"
	gboolean result = FALSE;
	DataCollection* _tmp0_;
#line 605 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 605 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 606 "DataCollection.vala"
	if (!data_set_contains (self->priv->dataset, object)) {
#line 3454 "DataCollection.c"
		result = FALSE;
#line 607 "DataCollection.vala"
		return result;
#line 3458 "DataCollection.c"
	}
#line 609 "DataCollection.vala"
	g_assert ((_tmp0_ = data_object_get_membership (object)) == self);
#line 3462 "DataCollection.c"
	_data_collection_unref0 (_tmp0_);
	result = TRUE;
#line 611 "DataCollection.vala"
	return result;
#line 3467 "DataCollection.c"
}


#line 614 "DataCollection.vala"
static void data_collection_internal_add (DataCollection* self, DataObject* object) {
#line 3473 "DataCollection.c"
	gboolean added;
#line 614 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 614 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 615 "DataCollection.vala"
	g_assert (data_collection_valid_type (self, object));
#line 617 "DataCollection.vala"
	data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 619 "DataCollection.vala"
	added = data_set_add (self->priv->dataset, object);
#line 620 "DataCollection.vala"
	g_assert (added);
#line 3487 "DataCollection.c"
}


#line 623 "DataCollection.vala"
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3493 "DataCollection.c"
	gint count;
	gboolean added;
#line 623 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 623 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (objects));
#line 624 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 3502 "DataCollection.c"
	{
		gint ctr;
#line 625 "DataCollection.vala"
		ctr = 0;
#line 3507 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 625 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 625 "DataCollection.vala"
			while (TRUE) {
#line 3514 "DataCollection.c"
				DataObject* object;
#line 625 "DataCollection.vala"
				if (!_tmp0_) {
#line 625 "DataCollection.vala"
					ctr++;
#line 3520 "DataCollection.c"
				}
#line 625 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 625 "DataCollection.vala"
				if (!(ctr < count)) {
#line 625 "DataCollection.vala"
					break;
#line 3528 "DataCollection.c"
				}
#line 626 "DataCollection.vala"
				object = (DataObject*) gee_list_get (objects, ctr);
#line 627 "DataCollection.vala"
				g_assert (data_collection_valid_type (self, object));
#line 629 "DataCollection.vala"
				data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 631 "DataCollection.vala"
				if (monitor != NULL) {
#line 632 "DataCollection.vala"
					monitor ((guint64) ctr, (guint64) count, monitor_target);
#line 3540 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
		}
	}
#line 635 "DataCollection.vala"
	added = data_set_add_many (self->priv->dataset, GEE_COLLECTION (objects));
#line 636 "DataCollection.vala"
	g_assert (added);
#line 3550 "DataCollection.c"
}


#line 639 "DataCollection.vala"
static void data_collection_internal_remove (DataCollection* self, DataObject* object) {
#line 3556 "DataCollection.c"
	gboolean removed;
#line 639 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 639 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 640 "DataCollection.vala"
	removed = data_set_remove (self->priv->dataset, object);
#line 641 "DataCollection.vala"
	g_assert (removed);
#line 643 "DataCollection.vala"
	data_object_internal_clear_membership (object);
#line 3568 "DataCollection.c"
}


#line 647 "DataCollection.vala"
static gboolean data_collection_real_add (DataCollection* self, DataObject* object) {
#line 3574 "DataCollection.c"
	gboolean result = FALSE;
	GeeCollection* added;
#line 647 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 647 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 648 "DataCollection.vala"
	if (data_collection_internal_contains (self, object)) {
#line 3583 "DataCollection.c"
		char* _tmp0_;
		char* _tmp1_;
#line 649 "DataCollection.vala"
		g_debug ("DataCollection.vala:649: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3588 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
		result = FALSE;
#line 651 "DataCollection.vala"
		return result;
#line 3594 "DataCollection.c"
	}
#line 654 "DataCollection.vala"
	data_collection_internal_add (self, object);
#line 657 "DataCollection.vala"
	added = data_collection_get_singleton (object);
#line 658 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 659 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 662 "DataCollection.vala"
	data_object_notify_membership_changed (object, self);
#line 3606 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (added);
#line 664 "DataCollection.vala"
	return result;
#line 3611 "DataCollection.c"
}


#line 503 "DataCollection.vala"
gboolean data_collection_add (DataCollection* self, DataObject* object) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->add (self, object);
#line 3619 "DataCollection.c"
}


#line 668 "DataCollection.vala"
static GeeCollection* data_collection_real_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3625 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeArrayList* added;
	gint count;
#line 668 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 668 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 670 "DataCollection.vala"
	added = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3635 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 671 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (objects));
#line 671 "DataCollection.vala"
		while (TRUE) {
#line 3642 "DataCollection.c"
			DataObject* object;
#line 671 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 671 "DataCollection.vala"
				break;
#line 3648 "DataCollection.c"
			}
#line 671 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 672 "DataCollection.vala"
			if (data_collection_internal_contains (self, object)) {
#line 3654 "DataCollection.c"
				char* _tmp0_;
				char* _tmp1_;
#line 673 "DataCollection.vala"
				g_debug ("DataCollection.vala:673: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3659 "DataCollection.c"
				_g_free0 (_tmp1_);
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 675 "DataCollection.vala"
				continue;
#line 3665 "DataCollection.c"
			}
#line 678 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added), object);
#line 3669 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 681 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (added));
#line 682 "DataCollection.vala"
	if (count == 0) {
#line 3678 "DataCollection.c"
		result = GEE_COLLECTION (added);
#line 683 "DataCollection.vala"
		return result;
#line 3682 "DataCollection.c"
	}
#line 685 "DataCollection.vala"
	data_collection_internal_add_many (self, GEE_LIST (added), monitor, monitor_target);
#line 688 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 689 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 3690 "DataCollection.c"
	{
		gint ctr;
#line 692 "DataCollection.vala"
		ctr = 0;
#line 3695 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 692 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 692 "DataCollection.vala"
			while (TRUE) {
#line 3702 "DataCollection.c"
				DataObject* _tmp3_;
#line 692 "DataCollection.vala"
				if (!_tmp2_) {
#line 692 "DataCollection.vala"
					ctr++;
#line 3708 "DataCollection.c"
				}
#line 692 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 692 "DataCollection.vala"
				if (!(ctr < count)) {
#line 692 "DataCollection.vala"
					break;
#line 3716 "DataCollection.c"
				}
#line 693 "DataCollection.vala"
				data_object_notify_membership_changed (_tmp3_ = (DataObject*) gee_abstract_list_get (GEE_ABSTRACT_LIST (added), ctr), self);
#line 3720 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	result = GEE_COLLECTION (added);
#line 695 "DataCollection.vala"
	return result;
#line 3728 "DataCollection.c"
}


#line 503 "DataCollection.vala"
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 503 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->add_many (self, objects, monitor, monitor_target);
#line 3736 "DataCollection.c"
}


#line 699 "DataCollection.vala"
Marker* data_collection_start_marking (DataCollection* self) {
#line 3742 "DataCollection.c"
	Marker* result = NULL;
#line 699 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3746 "DataCollection.c"
	result = MARKER (data_collection_marker_impl_new (self));
#line 700 "DataCollection.vala"
	return result;
#line 3750 "DataCollection.c"
}


#line 704 "DataCollection.vala"
Marker* data_collection_mark (DataCollection* self, DataObject* object) {
#line 3756 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 704 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 704 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 705 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 706 "DataCollection.vala"
	marker_mark (marker, object);
#line 3767 "DataCollection.c"
	result = marker;
#line 708 "DataCollection.vala"
	return result;
#line 3771 "DataCollection.c"
}


#line 712 "DataCollection.vala"
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects) {
#line 3777 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 712 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 712 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 713 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 714 "DataCollection.vala"
	marker_mark_many (marker, objects);
#line 3788 "DataCollection.c"
	result = marker;
#line 716 "DataCollection.vala"
	return result;
#line 3792 "DataCollection.c"
}


#line 721 "DataCollection.vala"
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user) {
#line 3798 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	guint64 count;
	guint64 total;
#line 721 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 721 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 721 "DataCollection.vala"
	g_return_if_fail ((user == NULL) || G_IS_OBJECT (user));
#line 723 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 725 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 728 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 730 "DataCollection.vala"
	count = (guint64) 0;
#line 731 "DataCollection.vala"
	total = (guint64) gee_collection_get_size (GEE_COLLECTION (marker->marked));
#line 3818 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 734 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 734 "DataCollection.vala"
		while (TRUE) {
#line 3825 "DataCollection.c"
			DataObject* object;
#line 734 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 734 "DataCollection.vala"
				break;
#line 3831 "DataCollection.c"
			}
#line 734 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 736 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3837 "DataCollection.c"
				char* _tmp0_;
#line 737 "DataCollection.vala"
				g_warning ("DataCollection.vala:737: act_on_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3841 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 739 "DataCollection.vala"
				continue;
#line 3846 "DataCollection.c"
			}
#line 742 "DataCollection.vala"
			if (!action (object, user, action_target)) {
#line 3850 "DataCollection.c"
				_g_object_unref0 (object);
#line 743 "DataCollection.vala"
				break;
#line 3854 "DataCollection.c"
			}
#line 745 "DataCollection.vala"
			if (monitor != NULL) {
#line 746 "DataCollection.vala"
				if (!monitor (count = count + 1, total, monitor_target)) {
#line 3860 "DataCollection.c"
					_g_object_unref0 (object);
#line 747 "DataCollection.vala"
					break;
#line 3864 "DataCollection.c"
				}
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 752 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3873 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 757 "DataCollection.vala"
static void data_collection_real_remove_marked (DataCollection* self, Marker* m) {
#line 3880 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	GeeArrayList* skipped;
#line 757 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 757 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 758 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 760 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 763 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 766 "DataCollection.vala"
	skipped = NULL;
#line 3895 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 767 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 767 "DataCollection.vala"
		while (TRUE) {
#line 3902 "DataCollection.c"
			DataObject* object;
#line 767 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 767 "DataCollection.vala"
				break;
#line 3908 "DataCollection.c"
			}
#line 767 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 769 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3914 "DataCollection.c"
				char* _tmp0_;
#line 770 "DataCollection.vala"
				g_warning ("DataCollection.vala:770: remove_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3918 "DataCollection.c"
				_g_free0 (_tmp0_);
#line 772 "DataCollection.vala"
				if (skipped == NULL) {
#line 3922 "DataCollection.c"
					GeeArrayList* _tmp1_;
#line 773 "DataCollection.vala"
					skipped = (_tmp1_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (skipped), _tmp1_);
#line 3926 "DataCollection.c"
				}
#line 775 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (skipped), object);
#line 3930 "DataCollection.c"
				_g_object_unref0 (object);
#line 777 "DataCollection.vala"
				continue;
#line 3934 "DataCollection.c"
			}
#line 780 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 3938 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 783 "DataCollection.vala"
	if (skipped != NULL) {
#line 784 "DataCollection.vala"
		gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (marker->marked), GEE_COLLECTION (skipped));
#line 3947 "DataCollection.c"
	}
#line 787 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (marker->marked)) > 0) {
#line 788 "DataCollection.vala"
		data_collection_notify_items_removed (self, GEE_ITERABLE (marker->marked));
#line 789 "DataCollection.vala"
		data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (marker->marked));
#line 3955 "DataCollection.c"
		{
			GeeIterator* _object_it;
#line 792 "DataCollection.vala"
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 792 "DataCollection.vala"
			while (TRUE) {
#line 3962 "DataCollection.c"
				DataObject* object;
#line 792 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 792 "DataCollection.vala"
					break;
#line 3968 "DataCollection.c"
				}
#line 792 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 793 "DataCollection.vala"
				data_object_notify_membership_changed (object, NULL);
#line 3974 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 797 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3982 "DataCollection.c"
	_g_object_unref0 (skipped);
	_g_object_unref0 (marker);
}


#line 503 "DataCollection.vala"
void data_collection_remove_marked (DataCollection* self, Marker* m) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->remove_marked (self, m);
#line 3992 "DataCollection.c"
}


#line 800 "DataCollection.vala"
static void data_collection_real_clear (DataCollection* self) {
#line 3998 "DataCollection.c"
	GeeArrayList* removed;
#line 800 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 801 "DataCollection.vala"
	if (data_set_get_count (self->priv->dataset) == 0) {
#line 802 "DataCollection.vala"
		return;
#line 4006 "DataCollection.c"
	}
#line 806 "DataCollection.vala"
	removed = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4010 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 807 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 807 "DataCollection.vala"
		while (TRUE) {
#line 4017 "DataCollection.c"
			DataObject* object;
#line 807 "DataCollection.vala"
			if (!_tmp0_) {
#line 813 "DataCollection.vala"
				if (!(data_set_get_count (self->priv->dataset) > 0)) {
#line 813 "DataCollection.vala"
					break;
#line 4025 "DataCollection.c"
				}
			}
#line 807 "DataCollection.vala"
			_tmp0_ = FALSE;
#line 808 "DataCollection.vala"
			object = data_set_get_at (self->priv->dataset, 0);
#line 809 "DataCollection.vala"
			g_assert (object != NULL);
#line 811 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (removed), object);
#line 812 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 4038 "DataCollection.c"
			_g_object_unref0 (object);
		}
	}
#line 816 "DataCollection.vala"
	data_collection_notify_items_removed (self, GEE_ITERABLE (removed));
#line 817 "DataCollection.vala"
	data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (removed));
#line 4046 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 820 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (removed));
#line 820 "DataCollection.vala"
		while (TRUE) {
#line 4053 "DataCollection.c"
			DataObject* object;
#line 820 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 820 "DataCollection.vala"
				break;
#line 4059 "DataCollection.c"
			}
#line 820 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 821 "DataCollection.vala"
			data_object_notify_membership_changed (object, NULL);
#line 4065 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_g_object_unref0 (removed);
}


#line 503 "DataCollection.vala"
void data_collection_clear (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->clear (self);
#line 4078 "DataCollection.c"
}


#line 830 "DataCollection.vala"
static void data_collection_real_close (DataCollection* self) {
#line 830 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 831 "DataCollection.vala"
	data_collection_clear (self);
#line 4088 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_close (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->close (self);
#line 4096 "DataCollection.c"
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


#line 836 "DataCollection.vala"
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration) {
#line 4107 "DataCollection.c"
	gboolean resort_occurred;
	GeeMap* _tmp4_;
#line 836 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 836 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 836 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 837 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 839 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object, alteration);
#line 841 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 4122 "DataCollection.c"
		Alteration* current;
		gboolean _tmp3_ = FALSE;
#line 842 "DataCollection.vala"
		if (self->priv->frozen_items_altered == NULL) {
#line 4127 "DataCollection.c"
			GeeHashMap* _tmp0_;
#line 843 "DataCollection.vala"
			self->priv->frozen_items_altered = (_tmp0_ = gee_hash_map_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_ALTERATION, (GBoxedCopyFunc) alteration_ref, alteration_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 4131 "DataCollection.c"
		}
#line 847 "DataCollection.vala"
		current = (Alteration*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->frozen_items_altered), object);
#line 848 "DataCollection.vala"
		if (current != NULL) {
#line 4137 "DataCollection.c"
			Alteration* _tmp1_;
#line 849 "DataCollection.vala"
			current = (_tmp1_ = alteration_compress (current, alteration), _alteration_unref0 (current), _tmp1_);
#line 4141 "DataCollection.c"
		} else {
			Alteration* _tmp2_;
#line 851 "DataCollection.vala"
			current = (_tmp2_ = _alteration_ref0 (alteration), _alteration_unref0 (current), _tmp2_);
#line 4146 "DataCollection.c"
		}
#line 853 "DataCollection.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->frozen_items_altered), object, current);
#line 855 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 855 "DataCollection.vala"
			_tmp3_ = TRUE;
#line 4154 "DataCollection.c"
		} else {
#line 855 "DataCollection.vala"
			_tmp3_ = resort_occurred;
#line 4158 "DataCollection.c"
		}
#line 855 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp3_;
#line 4162 "DataCollection.c"
		_alteration_unref0 (current);
#line 857 "DataCollection.vala"
		return;
#line 4166 "DataCollection.c"
	}
#line 860 "DataCollection.vala"
	if (resort_occurred) {
#line 861 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 4172 "DataCollection.c"
	}
#line 863 "DataCollection.vala"
	data_collection_notify_items_altered (self, _tmp4_ = data_collection_get_alteration_singleton (object, alteration));
#line 4176 "DataCollection.c"
	_g_object_unref0 (_tmp4_);
}


#line 866 "DataCollection.vala"
GValue* data_collection_get_property (DataCollection* self, const char* name) {
#line 4183 "DataCollection.c"
	GValue* result = NULL;
#line 866 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 866 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 4189 "DataCollection.c"
	result = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 867 "DataCollection.vala"
	return result;
#line 4193 "DataCollection.c"
}


#line 49 "util.vala"
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 4199 "DataCollection.c"
	gboolean result;
	result = bool_value_equals (a, b);
	return result;
}


#line 53 "util.vala"
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 4208 "DataCollection.c"
	gboolean result;
	result = int_value_equals (a, b);
	return result;
}


#line 870 "DataCollection.vala"
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 4217 "DataCollection.c"
	GValue* old;
	gint count;
#line 870 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 870 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 871 "DataCollection.vala"
	if (value_equals == NULL) {
#line 872 "DataCollection.vala"
		if (G_VALUE_HOLDS (val, G_TYPE_BOOLEAN)) {
#line 4228 "DataCollection.c"
			ValueEqualFunc _tmp0_;
#line 873 "DataCollection.vala"
			value_equals = (_tmp0_ = _bool_value_equals_value_equal_func, value_equals_target = NULL, _tmp0_);
#line 4232 "DataCollection.c"
		} else {
#line 874 "DataCollection.vala"
			if (G_VALUE_HOLDS (val, G_TYPE_INT)) {
#line 4236 "DataCollection.c"
				ValueEqualFunc _tmp1_;
#line 875 "DataCollection.vala"
				value_equals = (_tmp1_ = _int_value_equals_value_equal_func, value_equals_target = NULL, _tmp1_);
#line 4240 "DataCollection.c"
			} else {
#line 877 "DataCollection.vala"
				g_error ("DataCollection.vala:877: value_equals must be specified for this type");
#line 4244 "DataCollection.c"
			}
		}
	}
#line 880 "DataCollection.vala"
	old = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 881 "DataCollection.vala"
	if (old != NULL) {
#line 882 "DataCollection.vala"
		if (value_equals (old, val, value_equals_target)) {
#line 4254 "DataCollection.c"
			__vala_GValue_free0 (old);
#line 883 "DataCollection.vala"
			return;
#line 4258 "DataCollection.c"
		}
	}
#line 886 "DataCollection.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->properties), name, val);
#line 888 "DataCollection.vala"
	data_collection_notify_property_set (self, name, old, val);
#line 891 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 4267 "DataCollection.c"
	{
		gint ctr;
#line 892 "DataCollection.vala"
		ctr = 0;
#line 4272 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 892 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 892 "DataCollection.vala"
			while (TRUE) {
#line 4279 "DataCollection.c"
				DataObject* _tmp3_;
#line 892 "DataCollection.vala"
				if (!_tmp2_) {
#line 892 "DataCollection.vala"
					ctr++;
#line 4285 "DataCollection.c"
				}
#line 892 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 892 "DataCollection.vala"
				if (!(ctr < count)) {
#line 892 "DataCollection.vala"
					break;
#line 4293 "DataCollection.c"
				}
#line 893 "DataCollection.vala"
				data_object_notify_collection_property_set (_tmp3_ = data_set_get_at (self->priv->dataset, ctr), name, old, val);
#line 4297 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	__vala_GValue_free0 (old);
}


#line 896 "DataCollection.vala"
void data_collection_clear_property (DataCollection* self, const char* name) {
#line 4308 "DataCollection.c"
	gint count;
#line 896 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 896 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 897 "DataCollection.vala"
	if (!gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->properties), name, NULL)) {
#line 898 "DataCollection.vala"
		return;
#line 4318 "DataCollection.c"
	}
#line 901 "DataCollection.vala"
	data_collection_notify_property_cleared (self, name);
#line 904 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 4324 "DataCollection.c"
	{
		gint ctr;
#line 905 "DataCollection.vala"
		ctr = 0;
#line 4329 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 905 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 905 "DataCollection.vala"
			while (TRUE) {
#line 4336 "DataCollection.c"
				DataObject* _tmp1_;
#line 905 "DataCollection.vala"
				if (!_tmp0_) {
#line 905 "DataCollection.vala"
					ctr++;
#line 4342 "DataCollection.c"
				}
#line 905 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 905 "DataCollection.vala"
				if (!(ctr < count)) {
#line 905 "DataCollection.vala"
					break;
#line 4350 "DataCollection.c"
				}
#line 906 "DataCollection.vala"
				data_object_notify_collection_property_cleared (_tmp1_ = data_set_get_at (self->priv->dataset, ctr), name);
#line 4354 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 919 "DataCollection.vala"
void data_collection_freeze_notifications (DataCollection* self) {
#line 919 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 920 "DataCollection.vala"
	if ((self->priv->notifies_frozen++) == 0) {
#line 921 "DataCollection.vala"
		data_collection_notify_frozen (self);
#line 4370 "DataCollection.c"
	}
}


#line 924 "DataCollection.vala"
void data_collection_thaw_notifications (DataCollection* self) {
#line 924 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 925 "DataCollection.vala"
	if (self->priv->notifies_frozen == 0) {
#line 926 "DataCollection.vala"
		return;
#line 4383 "DataCollection.c"
	}
#line 928 "DataCollection.vala"
	if ((self->priv->notifies_frozen = self->priv->notifies_frozen - 1) == 0) {
#line 929 "DataCollection.vala"
		data_collection_notify_thawed (self);
#line 4389 "DataCollection.c"
	}
}


#line 932 "DataCollection.vala"
gboolean data_collection_are_notifications_frozen (DataCollection* self) {
#line 4396 "DataCollection.c"
	gboolean result = FALSE;
#line 932 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 4400 "DataCollection.c"
	result = self->priv->notifies_frozen > 0;
#line 933 "DataCollection.vala"
	return result;
#line 4404 "DataCollection.c"
}


#line 938 "DataCollection.vala"
static void data_collection_real_notify_frozen (DataCollection* self) {
#line 938 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 939 "DataCollection.vala"
	g_signal_emit_by_name (self, "frozen");
#line 4414 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_frozen (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_frozen (self);
#line 4422 "DataCollection.c"
}


#line 944 "DataCollection.vala"
static void data_collection_real_notify_thawed (DataCollection* self) {
#line 944 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 945 "DataCollection.vala"
	if (self->priv->frozen_items_altered != NULL) {
#line 4432 "DataCollection.c"
		GeeMap* copy;
		GeeHashMap* _tmp0_;
#line 947 "DataCollection.vala"
		copy = _g_object_ref0 (GEE_MAP (self->priv->frozen_items_altered));
#line 948 "DataCollection.vala"
		self->priv->frozen_items_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 950 "DataCollection.vala"
		data_collection_notify_items_altered (self, copy);
#line 4441 "DataCollection.c"
		_g_object_unref0 (copy);
	}
#line 953 "DataCollection.vala"
	if (self->priv->fire_ordering_changed) {
#line 954 "DataCollection.vala"
		self->priv->fire_ordering_changed = FALSE;
#line 955 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 4450 "DataCollection.c"
	}
#line 958 "DataCollection.vala"
	g_signal_emit_by_name (self, "thawed");
#line 4454 "DataCollection.c"
}


#line 503 "DataCollection.vala"
void data_collection_notify_thawed (DataCollection* self) {
#line 503 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_thawed (self);
#line 4462 "DataCollection.c"
}


#line 462 "DataCollection.vala"
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added) {
#line 462 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 462 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 4472 "DataCollection.c"
}


#line 466 "DataCollection.vala"
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed) {
#line 466 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 466 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4482 "DataCollection.c"
}


#line 470 "DataCollection.vala"
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 470 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 470 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 470 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4494 "DataCollection.c"
}


#line 476 "DataCollection.vala"
static void data_collection_real_items_altered (DataCollection* self, GeeMap* items) {
#line 476 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 476 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 4504 "DataCollection.c"
}


#line 481 "DataCollection.vala"
static void data_collection_real_ordering_changed (DataCollection* self) {
#line 481 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4512 "DataCollection.c"
}


#line 486 "DataCollection.vala"
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 486 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 486 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4522 "DataCollection.c"
}


#line 490 "DataCollection.vala"
static void data_collection_real_property_cleared (DataCollection* self, const char* name) {
#line 490 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 490 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4532 "DataCollection.c"
}


#line 495 "DataCollection.vala"
static void data_collection_real_frozen (DataCollection* self) {
#line 495 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4540 "DataCollection.c"
}


#line 500 "DataCollection.vala"
static void data_collection_real_thawed (DataCollection* self) {
#line 500 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4548 "DataCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 429 "DataCollection.vala"
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 4559 "DataCollection.c"
	data_collection_marker_impl_on_items_removed (self, removed);
}


#line 361 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner) {
#line 4566 "DataCollection.c"
	DataCollectionMarkerImpl * self = NULL;
	DataCollection* _tmp0_;
#line 361 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (owner), NULL);
#line 361 "DataCollection.vala"
	self = (DataCollectionMarkerImpl*) g_object_new (object_type, NULL);
#line 362 "DataCollection.vala"
	self->owner = (_tmp0_ = _data_collection_ref0 (owner), _data_collection_unref0 (self->owner), _tmp0_);
#line 366 "DataCollection.vala"
	g_signal_connect_object (owner, "items-removed", (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self, 0);
#line 4577 "DataCollection.c"
	return self;
}


#line 361 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner) {
#line 361 "DataCollection.vala"
	return data_collection_marker_impl_construct (DATA_COLLECTION_TYPE_MARKER_IMPL, owner);
#line 4586 "DataCollection.c"
}


#line 373 "DataCollection.vala"
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object) {
#line 4592 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 373 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 374 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 376 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4601 "DataCollection.c"
}


#line 379 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object) {
#line 4607 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 379 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 380 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 382 "DataCollection.vala"
	gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4616 "DataCollection.c"
}


#line 385 "DataCollection.vala"
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object) {
#line 4622 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gboolean result = FALSE;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 385 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 386 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 388 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object)) {
#line 389 "DataCollection.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4634 "DataCollection.c"
	} else {
#line 391 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4638 "DataCollection.c"
	}
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 394 "DataCollection.vala"
	return result;
#line 4643 "DataCollection.c"
}


#line 397 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list) {
#line 4649 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 397 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4654 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 398 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 398 "DataCollection.vala"
		while (TRUE) {
#line 4661 "DataCollection.c"
			DataObject* object;
#line 398 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 398 "DataCollection.vala"
				break;
#line 4667 "DataCollection.c"
			}
#line 398 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 399 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 401 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4675 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 405 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list) {
#line 4685 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 405 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4690 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 406 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 406 "DataCollection.vala"
		while (TRUE) {
#line 4697 "DataCollection.c"
			DataObject* object;
#line 406 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 406 "DataCollection.vala"
				break;
#line 4703 "DataCollection.c"
			}
#line 406 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 407 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 409 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4711 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 413 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_all (Marker* base) {
#line 4721 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 414 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (self->owner))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 414 "DataCollection.vala"
		while (TRUE) {
#line 4732 "DataCollection.c"
			DataObject* object;
#line 414 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 414 "DataCollection.vala"
				break;
#line 4738 "DataCollection.c"
			}
#line 414 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 415 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4744 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 418 "DataCollection.vala"
static gint data_collection_marker_impl_real_get_count (Marker* base) {
#line 4754 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 419 "DataCollection.vala"
	if (self->marked != NULL) {
#line 419 "DataCollection.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4763 "DataCollection.c"
	} else {
#line 419 "DataCollection.vala"
		_tmp0_ = self->freeze_count;
#line 4767 "DataCollection.c"
	}
	result = _tmp0_;
#line 419 "DataCollection.vala"
	return result;
#line 4772 "DataCollection.c"
}


#line 422 "DataCollection.vala"
static GeeCollection* data_collection_marker_impl_real_get_all (Marker* base) {
#line 4778 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	GeeCollection* result = NULL;
	GeeArrayList* copy;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 423 "DataCollection.vala"
	copy = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 424 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (copy), GEE_COLLECTION (self->marked));
#line 4787 "DataCollection.c"
	result = GEE_COLLECTION (copy);
#line 426 "DataCollection.vala"
	return result;
#line 4791 "DataCollection.c"
}


#line 429 "DataCollection.vala"
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed) {
#line 429 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 429 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4801 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 430 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 430 "DataCollection.vala"
		while (TRUE) {
#line 4808 "DataCollection.c"
			DataObject* object;
#line 430 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 430 "DataCollection.vala"
				break;
#line 4814 "DataCollection.c"
			}
#line 430 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 431 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4820 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 437 "DataCollection.vala"
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self) {
#line 4830 "DataCollection.c"
	guint _tmp0_;
#line 437 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 438 "DataCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 438 "DataCollection.vala"
	g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4838 "DataCollection.c"
}


#line 441 "DataCollection.vala"
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self) {
#line 4844 "DataCollection.c"
	GeeHashSet* _tmp0_;
#line 441 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 442 "DataCollection.vala"
	if (self->marked != NULL) {
#line 443 "DataCollection.vala"
		self->freeze_count = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4852 "DataCollection.c"
	}
#line 445 "DataCollection.vala"
	self->marked = (_tmp0_ = NULL, _g_object_unref0 (self->marked), _tmp0_);
#line 4856 "DataCollection.c"
}


#line 448 "DataCollection.vala"
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection) {
#line 4862 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 448 "DataCollection.vala"
	g_return_val_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self), FALSE);
#line 448 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (collection), FALSE);
#line 449 "DataCollection.vala"
	if (collection == self->owner) {
#line 449 "DataCollection.vala"
		_tmp0_ = self->marked != NULL;
#line 4873 "DataCollection.c"
	} else {
#line 449 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 4877 "DataCollection.c"
	}
	result = _tmp0_;
#line 449 "DataCollection.vala"
	return result;
#line 4882 "DataCollection.c"
}


static void data_collection_marker_impl_class_init (DataCollectionMarkerImplClass * klass) {
	data_collection_marker_impl_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = data_collection_marker_impl_finalize;
}


static void data_collection_marker_impl_marker_interface_init (MarkerIface * iface) {
	data_collection_marker_impl_marker_parent_iface = g_type_interface_peek_parent (iface);
	iface->mark = data_collection_marker_impl_real_mark;
	iface->unmark = data_collection_marker_impl_real_unmark;
	iface->toggle = data_collection_marker_impl_real_toggle;
	iface->mark_many = data_collection_marker_impl_real_mark_many;
	iface->unmark_many = data_collection_marker_impl_real_unmark_many;
	iface->mark_all = data_collection_marker_impl_real_mark_all;
	iface->get_count = data_collection_marker_impl_real_get_count;
	iface->get_all = data_collection_marker_impl_real_get_all;
}


static void data_collection_marker_impl_instance_init (DataCollectionMarkerImpl * self) {
	self->marked = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->freeze_count = 0;
}


static void data_collection_marker_impl_finalize (GObject* obj) {
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (obj);
	{
		guint _tmp0_;
#line 370 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 370 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4920 "DataCollection.c"
	}
	_data_collection_unref0 (self->owner);
	_g_object_unref0 (self->marked);
	G_OBJECT_CLASS (data_collection_marker_impl_parent_class)->finalize (obj);
}


static GType data_collection_marker_impl_get_type (void) {
	static volatile gsize data_collection_marker_impl_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_marker_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionMarkerImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_marker_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollectionMarkerImpl), 0, (GInstanceInitFunc) data_collection_marker_impl_instance_init, NULL };
		static const GInterfaceInfo marker_info = { (GInterfaceInitFunc) data_collection_marker_impl_marker_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType data_collection_marker_impl_type_id;
		data_collection_marker_impl_type_id = g_type_register_static (G_TYPE_OBJECT, "DataCollectionMarkerImpl", &g_define_type_info, 0);
		g_type_add_interface_static (data_collection_marker_impl_type_id, TYPE_MARKER, &marker_info);
		g_once_init_leave (&data_collection_marker_impl_type_id__volatile, data_collection_marker_impl_type_id);
	}
	return data_collection_marker_impl_type_id__volatile;
}


static void value_data_collection_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_collection_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_collection_unref (value->data[0].v_pointer);
	}
}


static void value_data_collection_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_collection_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_collection_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_collection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataCollection* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_collection_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_collection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataCollection** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_collection_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataCollection* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_COLLECTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_collection (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_collection_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


void value_take_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


static void data_collection_class_init (DataCollectionClass * klass) {
	data_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = data_collection_finalize;
	g_type_class_add_private (klass, sizeof (DataCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->to_string = data_collection_real_to_string;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = data_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = data_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = data_collection_real_notify_contents_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_altered = data_collection_real_notify_items_altered;
	DATA_COLLECTION_CLASS (klass)->notify_ordering_changed = data_collection_real_notify_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->notify_property_set = data_collection_real_notify_property_set;
	DATA_COLLECTION_CLASS (klass)->notify_property_cleared = data_collection_real_notify_property_cleared;
	DATA_COLLECTION_CLASS (klass)->valid_type = data_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->set_comparator = data_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = data_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = data_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = data_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = data_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = data_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = data_collection_real_contains;
	DATA_COLLECTION_CLASS (klass)->add = data_collection_real_add;
	DATA_COLLECTION_CLASS (klass)->add_many = data_collection_real_add_many;
	DATA_COLLECTION_CLASS (klass)->remove_marked = data_collection_real_remove_marked;
	DATA_COLLECTION_CLASS (klass)->clear = data_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = data_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->notify_frozen = data_collection_real_notify_frozen;
	DATA_COLLECTION_CLASS (klass)->notify_thawed = data_collection_real_notify_thawed;
	DATA_COLLECTION_CLASS (klass)->items_added = data_collection_real_items_added;
	DATA_COLLECTION_CLASS (klass)->items_removed = data_collection_real_items_removed;
	DATA_COLLECTION_CLASS (klass)->contents_altered = data_collection_real_contents_altered;
	DATA_COLLECTION_CLASS (klass)->items_altered = data_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->ordering_changed = data_collection_real_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->property_set = data_collection_real_property_set;
	DATA_COLLECTION_CLASS (klass)->property_cleared = data_collection_real_property_cleared;
	DATA_COLLECTION_CLASS (klass)->frozen = data_collection_real_frozen;
	DATA_COLLECTION_CLASS (klass)->thawed = data_collection_real_thawed;
	g_signal_new ("items_added", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_added), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_removed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_removed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("contents_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_ITERABLE, GEE_TYPE_ITERABLE);
	g_signal_new ("items_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_MAP);
	g_signal_new ("ordering_changed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, ordering_changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("property_set", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_set), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VALUE, G_TYPE_VALUE);
	g_signal_new ("property_cleared", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_cleared), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("frozen", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, frozen), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("thawed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, thawed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_collection_instance_init (DataCollection * self) {
	self->priv = DATA_COLLECTION_GET_PRIVATE (self);
	self->priv->dataset = data_set_new ();
	self->priv->properties = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_VALUE, (GBoxedCopyFunc) _g_value_dup, _vala_GValue_free, NULL, NULL, NULL);
	self->priv->object_ordinal_generator = (gint64) 0;
	self->priv->notifies_frozen = 0;
	self->priv->frozen_items_altered = NULL;
	self->priv->fire_ordering_changed = FALSE;
	self->ref_count = 1;
}


static void data_collection_finalize (DataCollection* obj) {
	DataCollection * self;
	self = DATA_COLLECTION (obj);
	{
	}
	_g_free0 (self->priv->name);
	_data_set_unref0 (self->priv->dataset);
	_g_object_unref0 (self->priv->properties);
	_g_object_unref0 (self->priv->frozen_items_altered);
}


GType data_collection_get_type (void) {
	static volatile gsize data_collection_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_collection_init, value_data_collection_free_value, value_data_collection_copy_value, value_data_collection_peek_pointer, "p", value_data_collection_collect_value, "p", value_data_collection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollection), 0, (GInstanceInitFunc) data_collection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_collection_type_id;
		data_collection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataCollection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_collection_type_id__volatile, data_collection_type_id);
	}
	return data_collection_type_id__volatile;
}


gpointer data_collection_ref (gpointer instance) {
	DataCollection* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_collection_unref (gpointer instance) {
	DataCollection* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_COLLECTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1009 "DataCollection.vala"
SourceCollection* source_collection_construct (GType object_type, const char* name) {
#line 5158 "DataCollection.c"
	SourceCollection* self = NULL;
#line 1009 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1010 "DataCollection.vala"
	self = (SourceCollection*) data_collection_construct (object_type, name);
#line 5164 "DataCollection.c"
	return self;
}


#line 1013 "DataCollection.vala"
static gboolean source_collection_real_holds_type_of_source (SourceCollection* self, DataSource* source) {
#line 5171 "DataCollection.c"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
	g_critical ("Type `%s' does not implement abstract method `source_collection_holds_type_of_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


#line 1009 "DataCollection.vala"
gboolean source_collection_holds_type_of_source (SourceCollection* self, DataSource* source) {
#line 1009 "DataCollection.vala"
	return SOURCE_COLLECTION_GET_CLASS (self)->holds_type_of_source (self, source);
#line 5182 "DataCollection.c"
}


#line 1015 "DataCollection.vala"
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1015 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1015 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 1016 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unlinking", unlinking);
#line 5194 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_unlinking (self, unlinking);
#line 5202 "DataCollection.c"
}


#line 1019 "DataCollection.vala"
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1019 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1019 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 1020 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-relinked", relinked);
#line 5214 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_relinked (self, relinked);
#line 5222 "DataCollection.c"
}


#line 1023 "DataCollection.vala"
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1023 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1023 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1024 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-destroyed", source);
#line 5234 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_item_destroyed (self, source);
#line 5242 "DataCollection.c"
}


#line 1027 "DataCollection.vala"
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1027 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1027 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1028 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-destroyed", destroyed);
#line 5254 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_destroyed (self, destroyed);
#line 5262 "DataCollection.c"
}


#line 1032 "DataCollection.vala"
static void source_collection_real_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked) {
#line 1032 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1032 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (unlinked));
#line 1033 "DataCollection.vala"
	g_signal_emit_by_name (self, "unlinked-destroyed", unlinked);
#line 5274 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_unlinked_destroyed (self, unlinked);
#line 5282 "DataCollection.c"
}


#line 1036 "DataCollection.vala"
static void source_collection_real_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources) {
#line 1036 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1036 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1036 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 1038 "DataCollection.vala"
	g_signal_emit_by_name (self, "backlink-removed", backlink, sources);
#line 5296 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_backlink_removed (self, backlink, sources);
#line 5304 "DataCollection.c"
}


#line 1041 "DataCollection.vala"
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 5310 "DataCollection.c"
	SourceCollection * self;
	gboolean result = FALSE;
	self = SOURCE_COLLECTION (base);
#line 1041 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 5316 "DataCollection.c"
	result = IS_DATA_SOURCE (object);
#line 1042 "DataCollection.vala"
	return result;
#line 5320 "DataCollection.c"
}


#line 1071 "DataCollection.vala"
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5326 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_and_delete_source (self, object, user);
	return result;
}


#line 1086 "DataCollection.vala"
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5335 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_source (self, object, user);
	return result;
}


#line 1047 "DataCollection.vala"
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed) {
#line 5344 "DataCollection.c"
	gint result = 0;
	Marker* _tmp0_;
	SourceCollectionDestroyCounter* _tmp1_;
	SourceCollectionDestroyCounter* counter;
#line 1047 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), 0);
#line 1047 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), 0);
#line 1047 "DataCollection.vala"
	g_return_val_if_fail ((not_removed == NULL) || GEE_IS_LIST (not_removed), 0);
#line 1049 "DataCollection.vala"
	counter = (_tmp1_ = source_collection_destroy_counter_new (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1051 "DataCollection.vala"
	if (delete_backing) {
#line 1052 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_and_delete_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5361 "DataCollection.c"
	} else {
#line 1054 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5365 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1057 "DataCollection.vala"
		_source_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (counter->notify_list));
#line 1057 "DataCollection.vala"
		while (TRUE) {
#line 5373 "DataCollection.c"
			DataSource* source;
#line 1057 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1057 "DataCollection.vala"
				break;
#line 5379 "DataCollection.c"
			}
#line 1057 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1058 "DataCollection.vala"
			source_collection_notify_item_destroyed (self, source);
#line 5385 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1059 "DataCollection.vala"
	source_collection_notify_items_destroyed (self, GEE_COLLECTION (counter->notify_list));
#line 1062 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), counter->remove_marker);
#line 1064 "DataCollection.vala"
	if (NULL != not_removed) {
#line 1065 "DataCollection.vala"
		gee_collection_add_all (GEE_COLLECTION (not_removed), GEE_COLLECTION (counter->not_removed));
#line 5398 "DataCollection.c"
	}
	result = gee_collection_get_size (GEE_COLLECTION (counter->not_removed));
	_g_object_unref0 (counter);
#line 1068 "DataCollection.vala"
	return result;
#line 5404 "DataCollection.c"
}


#line 1071 "DataCollection.vala"
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5410 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1071 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1071 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1071 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1072 "DataCollection.vala"
	success = FALSE;
#line 5424 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 1074 "DataCollection.vala"
		_tmp0_ = data_source_internal_delete_backing (DATA_SOURCE (object), &_inner_error_);
#line 5429 "DataCollection.c"
		if (_inner_error_ != NULL) {
			goto __catch192_g_error;
		}
#line 1074 "DataCollection.vala"
		success = _tmp0_;
#line 5435 "DataCollection.c"
	}
	goto __finally192;
	__catch192_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1076 "DataCollection.vala"
			success = FALSE;
#line 5446 "DataCollection.c"
			_g_error_free0 (err);
		}
	}
	__finally192:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 1079 "DataCollection.vala"
	if (!success) {
#line 1079 "DataCollection.vala"
		_tmp1_ = IS_MEDIA_SOURCE (object);
#line 5460 "DataCollection.c"
	} else {
#line 1079 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 5464 "DataCollection.c"
	}
#line 1079 "DataCollection.vala"
	if (_tmp1_) {
#line 1080 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (SOURCE_COLLECTION_DESTROY_COUNTER (user)->not_removed), MEDIA_SOURCE (object));
#line 5470 "DataCollection.c"
	}
#line 1083 "DataCollection.vala"
	if (source_collection_destroy_source (self, object, user)) {
#line 1083 "DataCollection.vala"
		_tmp2_ = success;
#line 5476 "DataCollection.c"
	} else {
#line 1083 "DataCollection.vala"
		_tmp2_ = FALSE;
#line 5480 "DataCollection.c"
	}
	result = _tmp2_;
#line 1083 "DataCollection.vala"
	return result;
#line 5485 "DataCollection.c"
}


#line 1086 "DataCollection.vala"
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5491 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1086 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1086 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1086 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1087 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1089 "DataCollection.vala"
	data_source_internal_mark_for_destroy (source);
#line 1090 "DataCollection.vala"
	data_source_destroy (source);
#line 1092 "DataCollection.vala"
	marker_mark (SOURCE_COLLECTION_DESTROY_COUNTER (user)->remove_marker, DATA_OBJECT (source));
#line 1093 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (SOURCE_COLLECTION_DESTROY_COUNTER (user)->notify_list), source);
#line 5510 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1095 "DataCollection.vala"
	return result;
#line 5515 "DataCollection.c"
}


#line 553 "DataObject.vala"
static guint _source_backlink_hash_func_ghash_func (void* key) {
#line 5521 "DataCollection.c"
	guint result;
	result = source_backlink_hash_func (key);
	return result;
}


#line 559 "DataObject.vala"
static gboolean _source_backlink_equal_func_gequal_func (void* a, void* b) {
#line 5530 "DataCollection.c"
	gboolean result;
	result = source_backlink_equal_func (a, b);
	return result;
}


#line 1099 "DataCollection.vala"
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink) {
#line 1099 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1099 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1099 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1100 "DataCollection.vala"
	if (self->priv->backlinks == NULL) {
#line 5547 "DataCollection.c"
		GeeMultiMap* _tmp0_;
#line 1101 "DataCollection.vala"
		self->priv->backlinks = (_tmp0_ = GEE_MULTI_MAP (gee_hash_multi_map_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _source_backlink_hash_func_ghash_func, _source_backlink_equal_func_gequal_func, NULL, NULL)), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 5551 "DataCollection.c"
	}
#line 1105 "DataCollection.vala"
	gee_multi_map_set (self->priv->backlinks, backlink, source);
#line 5555 "DataCollection.c"
}


#line 1109 "DataCollection.vala"
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink) {
#line 5561 "DataCollection.c"
	gboolean removed;
#line 1109 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1109 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1109 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1110 "DataCollection.vala"
	g_assert (self->priv->backlinks != NULL);
#line 1112 "DataCollection.vala"
	removed = gee_multi_map_remove (self->priv->backlinks, backlink, source);
#line 1113 "DataCollection.vala"
	g_assert (removed);
#line 5575 "DataCollection.c"
}


#line 1116 "DataCollection.vala"
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 5581 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1116 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1116 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 1117 "DataCollection.vala"
	if (self->priv->backlinks != NULL) {
#line 1117 "DataCollection.vala"
		_tmp0_ = gee_multi_map_contains (self->priv->backlinks, backlink);
#line 5592 "DataCollection.c"
	} else {
#line 1117 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 5596 "DataCollection.c"
	}
	result = _tmp0_;
#line 1117 "DataCollection.vala"
	return result;
#line 5601 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1009 "DataCollection.vala"
	return SOURCE_COLLECTION_GET_CLASS (self)->has_backlink (self, backlink);
#line 5609 "DataCollection.c"
}


#line 1134 "DataCollection.vala"
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5615 "DataCollection.c"
	gboolean result;
	result = source_collection_prepare_for_unlink (self, object, user);
	return result;
}


#line 1120 "DataCollection.vala"
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target) {
#line 5624 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeArrayList* list;
	Marker* _tmp0_;
#line 1120 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), NULL);
#line 1120 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), NULL);
#line 1121 "DataCollection.vala"
	list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1122 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_prepare_for_unlink_marked_action, self, monitor, monitor_target, G_OBJECT (list));
#line 1124 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (list)) == 0) {
#line 5638 "DataCollection.c"
		result = NULL;
		_g_object_unref0 (list);
#line 1125 "DataCollection.vala"
		return result;
#line 5643 "DataCollection.c"
	}
#line 1127 "DataCollection.vala"
	source_collection_notify_items_unlinking (self, GEE_COLLECTION (list));
#line 1129 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), _tmp0_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (list)));
#line 5649 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	result = GEE_COLLECTION (list);
#line 1131 "DataCollection.vala"
	return result;
#line 5654 "DataCollection.c"
}


#line 1134 "DataCollection.vala"
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user) {
#line 5660 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1134 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1134 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1134 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1135 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1137 "DataCollection.vala"
	data_source_notify_unlinking (source, self);
#line 1138 "DataCollection.vala"
	gee_collection_add (GEE_COLLECTION (GEE_LIST (user)), source);
#line 5675 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1140 "DataCollection.vala"
	return result;
#line 5680 "DataCollection.c"
}


#line 1143 "DataCollection.vala"
void source_collection_relink (SourceCollection* self, DataSource* source) {
#line 5686 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1143 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1143 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1144 "DataCollection.vala"
	data_source_notify_relinking (source, self);
#line 1146 "DataCollection.vala"
	data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (source));
#line 1147 "DataCollection.vala"
	source_collection_notify_items_relinked (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (source))));
#line 5698 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1149 "DataCollection.vala"
	data_source_notify_relinked (source);
#line 5702 "DataCollection.c"
}


#line 1152 "DataCollection.vala"
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink) {
#line 5708 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1152 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1152 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relink));
#line 1153 "DataCollection.vala"
	if (gee_collection_get_size (relink) == 0) {
#line 1154 "DataCollection.vala"
		return;
#line 5718 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1156 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1156 "DataCollection.vala"
		while (TRUE) {
#line 5726 "DataCollection.c"
			DataSource* source;
#line 1156 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1156 "DataCollection.vala"
				break;
#line 5732 "DataCollection.c"
			}
#line 1156 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1157 "DataCollection.vala"
			data_source_notify_relinking (source, self);
#line 5738 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1159 "DataCollection.vala"
	_tmp0_ = data_collection_add_many (DATA_COLLECTION (self), relink, NULL, NULL);
#line 5745 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1160 "DataCollection.vala"
	source_collection_notify_items_relinked (self, relink);
#line 5749 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1162 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1162 "DataCollection.vala"
		while (TRUE) {
#line 5756 "DataCollection.c"
			DataSource* source;
#line 1162 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1162 "DataCollection.vala"
				break;
#line 5762 "DataCollection.c"
			}
#line 1162 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1163 "DataCollection.vala"
			data_source_notify_relinked (source);
#line 5768 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 1166 "DataCollection.vala"
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 5778 "DataCollection.c"
	GeeArrayList* sources;
	GeeCollection* _tmp0_;
#line 1166 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1166 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1167 "DataCollection.vala"
	if (self->priv->backlinks == NULL) {
#line 1168 "DataCollection.vala"
		return;
#line 5789 "DataCollection.c"
	}
#line 1171 "DataCollection.vala"
	sources = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1172 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (sources), _tmp0_ = gee_multi_map_get (self->priv->backlinks, backlink));
#line 5795 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	{
		GeeIterator* _source_it;
#line 1174 "DataCollection.vala"
		_source_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (sources));
#line 1174 "DataCollection.vala"
		while (TRUE) {
#line 5803 "DataCollection.c"
			DataSource* source;
#line 1174 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1174 "DataCollection.vala"
				break;
#line 5809 "DataCollection.c"
			}
#line 1174 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1175 "DataCollection.vala"
			data_source_remove_backlink (source, backlink);
#line 5815 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1177 "DataCollection.vala"
	source_collection_notify_backlink_removed (self, backlink, GEE_COLLECTION (sources));
#line 5822 "DataCollection.c"
	_g_object_unref0 (sources);
}


#line 1009 "DataCollection.vala"
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->remove_backlink (self, backlink);
#line 5831 "DataCollection.c"
}


#line 979 "DataCollection.vala"
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 979 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 979 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 5841 "DataCollection.c"
}


#line 984 "DataCollection.vala"
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 984 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 984 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 5851 "DataCollection.c"
}


#line 989 "DataCollection.vala"
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source) {
#line 989 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 989 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5861 "DataCollection.c"
}


#line 994 "DataCollection.vala"
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 994 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 994 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 5871 "DataCollection.c"
}


#line 999 "DataCollection.vala"
static void source_collection_real_unlinked_destroyed (SourceCollection* self, DataSource* source) {
#line 999 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 999 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5881 "DataCollection.c"
}


#line 1003 "DataCollection.vala"
static void source_collection_real_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources) {
#line 1003 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1003 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1003 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 5893 "DataCollection.c"
}


#line 972 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker) {
#line 5899 "DataCollection.c"
	SourceCollectionDestroyCounter * self = NULL;
	Marker* _tmp0_;
#line 972 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (remove_marker), NULL);
#line 972 "DataCollection.vala"
	self = (SourceCollectionDestroyCounter*) g_object_new (object_type, NULL);
#line 973 "DataCollection.vala"
	self->remove_marker = (_tmp0_ = _g_object_ref0 (remove_marker), _g_object_unref0 (self->remove_marker), _tmp0_);
#line 5908 "DataCollection.c"
	return self;
}


#line 972 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker) {
#line 972 "DataCollection.vala"
	return source_collection_destroy_counter_construct (SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, remove_marker);
#line 5917 "DataCollection.c"
}


static void source_collection_destroy_counter_class_init (SourceCollectionDestroyCounterClass * klass) {
	source_collection_destroy_counter_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = source_collection_destroy_counter_finalize;
}


static void source_collection_destroy_counter_instance_init (SourceCollectionDestroyCounter * self) {
	self->notify_list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->not_removed = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
}


static void source_collection_destroy_counter_finalize (GObject* obj) {
	SourceCollectionDestroyCounter * self;
	self = SOURCE_COLLECTION_DESTROY_COUNTER (obj);
	_g_object_unref0 (self->remove_marker);
	_g_object_unref0 (self->notify_list);
	_g_object_unref0 (self->not_removed);
	G_OBJECT_CLASS (source_collection_destroy_counter_parent_class)->finalize (obj);
}


static GType source_collection_destroy_counter_get_type (void) {
	static volatile gsize source_collection_destroy_counter_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_destroy_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionDestroyCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_destroy_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollectionDestroyCounter), 0, (GInstanceInitFunc) source_collection_destroy_counter_instance_init, NULL };
		GType source_collection_destroy_counter_type_id;
		source_collection_destroy_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "SourceCollectionDestroyCounter", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_destroy_counter_type_id__volatile, source_collection_destroy_counter_type_id);
	}
	return source_collection_destroy_counter_type_id__volatile;
}


static void source_collection_class_init (SourceCollectionClass * klass) {
	source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = source_collection_finalize;
	g_type_class_add_private (klass, sizeof (SourceCollectionPrivate));
	SOURCE_COLLECTION_CLASS (klass)->holds_type_of_source = source_collection_real_holds_type_of_source;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_unlinking = source_collection_real_notify_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_relinked = source_collection_real_notify_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = source_collection_real_notify_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_destroyed = source_collection_real_notify_items_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_unlinked_destroyed = source_collection_real_notify_unlinked_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_backlink_removed = source_collection_real_notify_backlink_removed;
	DATA_COLLECTION_CLASS (klass)->valid_type = source_collection_real_valid_type;
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = source_collection_real_has_backlink;
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = source_collection_real_remove_backlink;
	SOURCE_COLLECTION_CLASS (klass)->items_unlinking = source_collection_real_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->items_relinked = source_collection_real_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->item_destroyed = source_collection_real_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->items_destroyed = source_collection_real_items_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->unlinked_destroyed = source_collection_real_unlinked_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->backlink_removed = source_collection_real_backlink_removed;
	g_signal_new ("items_unlinking", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_unlinking), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_relinked", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_relinked), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, item_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("items_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("unlinked_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, unlinked_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("backlink_removed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, backlink_removed), NULL, NULL, g_cclosure_user_marshal_VOID__SOURCE_BACKLINK_OBJECT, G_TYPE_NONE, 2, TYPE_SOURCE_BACKLINK, GEE_TYPE_COLLECTION);
}


static void source_collection_instance_init (SourceCollection * self) {
	self->priv = SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->backlinks = NULL;
}


static void source_collection_finalize (DataCollection* obj) {
	SourceCollection * self;
	self = SOURCE_COLLECTION (obj);
	_g_object_unref0 (self->priv->backlinks);
	DATA_COLLECTION_CLASS (source_collection_parent_class)->finalize (obj);
}


GType source_collection_get_type (void) {
	static volatile gsize source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollection), 0, (GInstanceInitFunc) source_collection_instance_init, NULL };
		GType source_collection_type_id;
		source_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "SourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_collection_type_id__volatile, source_collection_type_id);
	}
	return source_collection_type_id__volatile;
}


#line 7 "util.vala"
static guint _int64_hash_ghash_func (void* key) {
#line 6012 "DataCollection.c"
	guint result;
	result = int64_hash (key);
	return result;
}


#line 18 "util.vala"
static gboolean _int64_equal_gequal_func (void* a, void* b) {
#line 6021 "DataCollection.c"
	gboolean result;
	result = int64_equal (a, b);
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


#line 1198 "DataCollection.vala"
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 6038 "DataCollection.c"
	DatabaseSourceCollection* self = NULL;
	GetSourceDatabaseKey _tmp0_;
#line 1198 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1199 "DataCollection.vala"
	self = (DatabaseSourceCollection*) source_collection_construct (object_type, name);
#line 1201 "DataCollection.vala"
	self->priv->source_key_func = (_tmp0_ = source_key_func, ((self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL), self->priv->source_key_func = NULL, self->priv->source_key_func_target = NULL, self->priv->source_key_func_target_destroy_notify = NULL), self->priv->source_key_func_target = source_key_func_target, self->priv->source_key_func_target_destroy_notify = NULL, _tmp0_);
#line 6047 "DataCollection.c"
	return self;
}


#line 1204 "DataCollection.vala"
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 6054 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1204 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 6059 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1205 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 1205 "DataCollection.vala"
		while (TRUE) {
#line 6066 "DataCollection.c"
			DataObject* object;
			DataSource* source;
			gint64 key;
#line 1205 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1205 "DataCollection.vala"
				break;
#line 6074 "DataCollection.c"
			}
#line 1205 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1206 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 1207 "DataCollection.vala"
			key = self->priv->source_key_func (source, self->priv->source_key_func_target);
#line 1209 "DataCollection.vala"
			g_assert (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), &key));
#line 1211 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), &key, source);
#line 6086 "DataCollection.c"
			_g_object_unref0 (source);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1214 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_added (DATA_COLLECTION (SOURCE_COLLECTION (self)), added);
#line 6094 "DataCollection.c"
}


#line 1217 "DataCollection.vala"
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 6100 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1217 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 6105 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1218 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 1218 "DataCollection.vala"
		while (TRUE) {
#line 6112 "DataCollection.c"
			DataObject* object;
			gint64 key;
			gboolean is_removed;
#line 1218 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1218 "DataCollection.vala"
				break;
#line 6120 "DataCollection.c"
			}
#line 1218 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1219 "DataCollection.vala"
			key = self->priv->source_key_func (DATA_SOURCE (object), self->priv->source_key_func_target);
#line 1221 "DataCollection.vala"
			is_removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), &key, NULL);
#line 1222 "DataCollection.vala"
			g_assert (is_removed);
#line 6130 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1225 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_removed (DATA_COLLECTION (SOURCE_COLLECTION (self)), removed);
#line 6137 "DataCollection.c"
}


#line 1228 "DataCollection.vala"
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key) {
#line 6143 "DataCollection.c"
	DataSource* result = NULL;
#line 1228 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_COLLECTION (self), NULL);
#line 6147 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &key);
#line 1229 "DataCollection.vala"
	return result;
#line 6151 "DataCollection.c"
}


static void database_source_collection_class_init (DatabaseSourceCollectionClass * klass) {
	database_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = database_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->notify_items_added = database_source_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = database_source_collection_real_notify_items_removed;
}


static void database_source_collection_instance_init (DatabaseSourceCollection * self) {
	self->priv = DATABASE_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, g_direct_equal);
}


static void database_source_collection_finalize (DataCollection* obj) {
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (obj);
	(self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL);
	self->priv->source_key_func = NULL;
	self->priv->source_key_func_target = NULL;
	self->priv->source_key_func_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->finalize (obj);
}


GType database_source_collection_get_type (void) {
	static volatile gsize database_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceCollection), 0, (GInstanceInitFunc) database_source_collection_instance_init, NULL };
		GType database_source_collection_type_id;
		database_source_collection_type_id = g_type_register_static (TYPE_SOURCE_COLLECTION, "DatabaseSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_source_collection_type_id__volatile, database_source_collection_type_id);
	}
	return database_source_collection_type_id__volatile;
}


#line 1267 "DataCollection.vala"
ContainerSourceCollection* container_source_collection_construct (GType object_type, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 6196 "DataCollection.c"
	ContainerSourceCollection* self = NULL;
	char* _tmp0_;
#line 1267 "DataCollection.vala"
	g_return_val_if_fail (backlink_name != NULL, NULL);
#line 1267 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1269 "DataCollection.vala"
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
#line 1271 "DataCollection.vala"
	self->priv->backlink_name = (_tmp0_ = g_strdup (backlink_name), _g_free0 (self->priv->backlink_name), _tmp0_);
#line 6207 "DataCollection.c"
	return self;
}


#line 1278 "DataCollection.vala"
static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources) {
#line 6214 "DataCollection.c"
	ContainerSourceCollection * self;
	ContainerSource* container;
	self = CONTAINER_SOURCE_COLLECTION (base);
#line 1278 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1278 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 1280 "DataCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_backlink_removed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), backlink, sources);
#line 1282 "DataCollection.vala"
	container = container_source_collection_convert_backlink_to_container (self, backlink);
#line 1283 "DataCollection.vala"
	if (container != NULL) {
#line 1284 "DataCollection.vala"
		container_source_collection_notify_backlink_to_container_removed (self, container, sources);
#line 6230 "DataCollection.c"
	}
	_g_object_unref0 (container);
}


#line 1287 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
#line 1287 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1287 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1287 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 1290 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container)) {
#line 6246 "DataCollection.c"
		gboolean removed;
#line 1291 "DataCollection.vala"
		removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1292 "DataCollection.vala"
		g_assert (removed);
#line 1294 "DataCollection.vala"
		source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (container));
#line 6254 "DataCollection.c"
	}
#line 1297 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-added", container, added, relinked);
#line 6258 "DataCollection.c"
}


#line 1267 "DataCollection.vala"
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
#line 1267 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_added (self, container, added, relinked);
#line 6266 "DataCollection.c"
}


#line 1300 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
#line 1300 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1300 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1300 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 1302 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-removed", container, removed, unlinked);
#line 6280 "DataCollection.c"
}


#line 1267 "DataCollection.vala"
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
#line 1267 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_removed (self, container, removed, unlinked);
#line 6288 "DataCollection.c"
}


#line 1305 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
#line 1305 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1305 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1305 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1305 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1308 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-altered", container, added, relinked, removed, unlinked);
#line 6304 "DataCollection.c"
}


#line 1267 "DataCollection.vala"
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
#line 1267 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_altered (self, container, added, relinked, removed, unlinked);
#line 6312 "DataCollection.c"
}


#line 1311 "DataCollection.vala"
static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
#line 1311 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1311 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1311 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 1313 "DataCollection.vala"
	g_signal_emit_by_name (self, "backlink-to-container-removed", container, sources);
#line 6326 "DataCollection.c"
}


#line 1267 "DataCollection.vala"
void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
#line 1267 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_backlink_to_container_removed (self, container, sources);
#line 6334 "DataCollection.c"
}


#line 1316 "DataCollection.vala"
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 6340 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1267 "DataCollection.vala"
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 1267 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->get_containers_holding_source (self, source);
#line 6351 "DataCollection.c"
}


#line 1319 "DataCollection.vala"
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 6357 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1267 "DataCollection.vala"
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 1267 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->convert_backlink_to_container (self, backlink);
#line 6368 "DataCollection.c"
}


#line 1321 "DataCollection.vala"
void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self) {
#line 1321 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 6376 "DataCollection.c"
	{
		GeeIterator* _collection_it;
#line 1322 "DataCollection.vala"
		_collection_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 1322 "DataCollection.vala"
		while (TRUE) {
#line 6383 "DataCollection.c"
			SourceCollection* collection;
#line 1322 "DataCollection.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 1322 "DataCollection.vala"
				break;
#line 6389 "DataCollection.c"
			}
#line 1322 "DataCollection.vala"
			collection = (SourceCollection*) gee_iterator_get (_collection_it);
#line 1323 "DataCollection.vala"
			data_collection_freeze_notifications (DATA_COLLECTION (collection));
#line 6395 "DataCollection.c"
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
}


#line 1326 "DataCollection.vala"
void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self) {
#line 1326 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 6407 "DataCollection.c"
	{
		GeeIterator* _collection_it;
#line 1327 "DataCollection.vala"
		_collection_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 1327 "DataCollection.vala"
		while (TRUE) {
#line 6414 "DataCollection.c"
			SourceCollection* collection;
#line 1327 "DataCollection.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 1327 "DataCollection.vala"
				break;
#line 6420 "DataCollection.c"
			}
#line 1327 "DataCollection.vala"
			collection = (SourceCollection*) gee_iterator_get (_collection_it);
#line 1328 "DataCollection.vala"
			data_collection_thaw_notifications (DATA_COLLECTION (collection));
#line 6426 "DataCollection.c"
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
}


#line 1331 "DataCollection.vala"
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self) {
#line 6436 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1331 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 6440 "DataCollection.c"
	result = GEE_COLLECTION (gee_abstract_set_get_read_only_view (GEE_ABSTRACT_SET (self->priv->holding_tank)));
#line 1332 "DataCollection.vala"
	return result;
#line 6444 "DataCollection.c"
}


#line 1335 "DataCollection.vala"
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked) {
#line 1335 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1335 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (unlinked));
#line 1336 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 6456 "DataCollection.c"
}


#line 1339 "DataCollection.vala"
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked) {
#line 1339 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1339 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinked));
#line 1340 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 6468 "DataCollection.c"
}


#line 1343 "DataCollection.vala"
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source) {
#line 6474 "DataCollection.c"
	gboolean result = FALSE;
#line 1343 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), FALSE);
#line 1343 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE (source), FALSE);
#line 1344 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), source)) {
#line 6482 "DataCollection.c"
		result = FALSE;
#line 1345 "DataCollection.vala"
		return result;
#line 6486 "DataCollection.c"
	}
#line 1347 "DataCollection.vala"
	source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (source));
#line 6490 "DataCollection.c"
	result = TRUE;
#line 1349 "DataCollection.vala"
	return result;
#line 6494 "DataCollection.c"
}


#line 1352 "DataCollection.vala"
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking) {
#line 6500 "DataCollection.c"
	GeeHashMultiMap* map;
#line 1352 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1352 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 1353 "DataCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 1356 "DataCollection.vala"
	map = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 6510 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1358 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (unlinking));
#line 1358 "DataCollection.vala"
		while (TRUE) {
#line 6517 "DataCollection.c"
			DataSource* source;
			GeeCollection* containers;
			gboolean _tmp0_ = FALSE;
#line 1358 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1358 "DataCollection.vala"
				break;
#line 6525 "DataCollection.c"
			}
#line 1358 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1359 "DataCollection.vala"
			containers = container_source_collection_get_containers_holding_source (self, source);
#line 1360 "DataCollection.vala"
			if (containers == NULL) {
#line 1360 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 6535 "DataCollection.c"
			} else {
#line 1360 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (containers) == 0;
#line 6539 "DataCollection.c"
			}
#line 1360 "DataCollection.vala"
			if (_tmp0_) {
#line 6543 "DataCollection.c"
				_g_object_unref0 (containers);
				_g_object_unref0 (source);
#line 1361 "DataCollection.vala"
				continue;
#line 6548 "DataCollection.c"
			}
			{
				GeeIterator* _container_it;
#line 1363 "DataCollection.vala"
				_container_it = gee_iterable_iterator (GEE_ITERABLE (containers));
#line 1363 "DataCollection.vala"
				while (TRUE) {
#line 6556 "DataCollection.c"
					ContainerSource* container;
					SourceBacklink* _tmp1_;
#line 1363 "DataCollection.vala"
					if (!gee_iterator_next (_container_it)) {
#line 1363 "DataCollection.vala"
						break;
#line 6563 "DataCollection.c"
					}
#line 1363 "DataCollection.vala"
					container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1364 "DataCollection.vala"
					gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
#line 1365 "DataCollection.vala"
					data_source_set_backlink (source, _tmp1_ = container_source_get_backlink (container));
#line 6571 "DataCollection.c"
					_source_backlink_unref0 (_tmp1_);
					_g_object_unref0 (container);
				}
				_g_object_unref0 (_container_it);
			}
			_g_object_unref0 (containers);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _container_it;
#line 1369 "DataCollection.vala"
		_container_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map)))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1369 "DataCollection.vala"
		while (TRUE) {
#line 6590 "DataCollection.c"
			ContainerSource* container;
			GeeCollection* _tmp4_;
#line 1369 "DataCollection.vala"
			if (!gee_iterator_next (_container_it)) {
#line 1369 "DataCollection.vala"
				break;
#line 6597 "DataCollection.c"
			}
#line 1369 "DataCollection.vala"
			container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1370 "DataCollection.vala"
			container_source_break_link_many (container, _tmp4_ = gee_multi_map_get (GEE_MULTI_MAP (map), container));
#line 6603 "DataCollection.c"
			_g_object_unref0 (_tmp4_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
#line 1372 "DataCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 6611 "DataCollection.c"
	_g_object_unref0 (map);
}


#line 1375 "DataCollection.vala"
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked) {
#line 6618 "DataCollection.c"
	GeeHashMultiMap* map;
#line 1375 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1375 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 1376 "DataCollection.vala"
	container_source_collection_freeze_attached_notifications (self);
#line 1379 "DataCollection.vala"
	map = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 6628 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1381 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relinked));
#line 1381 "DataCollection.vala"
		while (TRUE) {
#line 6635 "DataCollection.c"
			DataSource* source;
			GeeList* backlinks;
			gboolean _tmp0_ = FALSE;
#line 1381 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1381 "DataCollection.vala"
				break;
#line 6643 "DataCollection.c"
			}
#line 1381 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1382 "DataCollection.vala"
			backlinks = data_source_get_backlinks (source, self->priv->backlink_name);
#line 1383 "DataCollection.vala"
			if (backlinks == NULL) {
#line 1383 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 6653 "DataCollection.c"
			} else {
#line 1383 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (GEE_COLLECTION (backlinks)) == 0;
#line 6657 "DataCollection.c"
			}
#line 1383 "DataCollection.vala"
			if (_tmp0_) {
#line 6661 "DataCollection.c"
				_g_object_unref0 (backlinks);
				_g_object_unref0 (source);
#line 1384 "DataCollection.vala"
				continue;
#line 6666 "DataCollection.c"
			}
			{
				GeeIterator* _backlink_it;
#line 1386 "DataCollection.vala"
				_backlink_it = gee_iterable_iterator (GEE_ITERABLE (backlinks));
#line 1386 "DataCollection.vala"
				while (TRUE) {
#line 6674 "DataCollection.c"
					SourceBacklink* backlink;
					ContainerSource* container;
#line 1386 "DataCollection.vala"
					if (!gee_iterator_next (_backlink_it)) {
#line 1386 "DataCollection.vala"
						break;
#line 6681 "DataCollection.c"
					}
#line 1386 "DataCollection.vala"
					backlink = (SourceBacklink*) gee_iterator_get (_backlink_it);
#line 1387 "DataCollection.vala"
					container = container_source_collection_convert_backlink_to_container (self, backlink);
#line 1388 "DataCollection.vala"
					if (container != NULL) {
#line 1389 "DataCollection.vala"
						gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
#line 6691 "DataCollection.c"
					} else {
						char* _tmp1_;
						char* _tmp2_;
#line 1391 "DataCollection.vala"
						g_warning ("DataCollection.vala:1391: Unable to relink %s to container backlink %s", _tmp1_ = data_object_to_string (DATA_OBJECT (source)), _tmp2_ = source_backlink_to_string (backlink));
#line 6697 "DataCollection.c"
						_g_free0 (_tmp2_);
						_g_free0 (_tmp1_);
					}
					_g_object_unref0 (container);
					_source_backlink_unref0 (backlink);
				}
				_g_object_unref0 (_backlink_it);
			}
			_g_object_unref0 (backlinks);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _container_it;
#line 1397 "DataCollection.vala"
		_container_it = (_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map)))), _g_object_unref0 (_tmp3_), _tmp4_);
#line 1397 "DataCollection.vala"
		while (TRUE) {
#line 6719 "DataCollection.c"
			ContainerSource* container;
			GeeCollection* _tmp5_;
#line 1397 "DataCollection.vala"
			if (!gee_iterator_next (_container_it)) {
#line 1397 "DataCollection.vala"
				break;
#line 6726 "DataCollection.c"
			}
#line 1397 "DataCollection.vala"
			container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1398 "DataCollection.vala"
			container_source_establish_link_many (container, _tmp5_ = gee_multi_map_get (GEE_MULTI_MAP (map), container));
#line 6732 "DataCollection.c"
			_g_object_unref0 (_tmp5_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
#line 1400 "DataCollection.vala"
	container_source_collection_thaw_attached_notifications (self);
#line 6740 "DataCollection.c"
	_g_object_unref0 (map);
}


#line 1403 "DataCollection.vala"
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source) {
#line 6747 "DataCollection.c"
	GeeIterator* iter;
#line 1403 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1403 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1404 "DataCollection.vala"
	iter = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank));
#line 1405 "DataCollection.vala"
	while (TRUE) {
#line 6757 "DataCollection.c"
		ContainerSource* container;
#line 1405 "DataCollection.vala"
		if (!gee_iterator_next (iter)) {
#line 1405 "DataCollection.vala"
			break;
#line 6763 "DataCollection.c"
		}
#line 1406 "DataCollection.vala"
		container = (ContainerSource*) gee_iterator_get (iter);
#line 1407 "DataCollection.vala"
		if (!container_source_has_links (container)) {
#line 1408 "DataCollection.vala"
			gee_iterator_remove (iter);
#line 1409 "DataCollection.vala"
			data_source_destroy_orphan (DATA_SOURCE (container), TRUE);
#line 6773 "DataCollection.c"
		}
		_g_object_unref0 (container);
	}
	_g_object_unref0 (iter);
}


#line 1414 "DataCollection.vala"
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source) {
#line 6783 "DataCollection.c"
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (base);
#line 1414 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 6788 "DataCollection.c"
	{
		GeeIterator* _collection_it;
#line 1415 "DataCollection.vala"
		_collection_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 1415 "DataCollection.vala"
		while (TRUE) {
#line 6795 "DataCollection.c"
			SourceCollection* collection;
			SourceBacklink* _tmp0_;
#line 1415 "DataCollection.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 1415 "DataCollection.vala"
				break;
#line 6802 "DataCollection.c"
			}
#line 1415 "DataCollection.vala"
			collection = (SourceCollection*) gee_iterator_get (_collection_it);
#line 1416 "DataCollection.vala"
			source_collection_remove_backlink (collection, _tmp0_ = container_source_get_backlink (CONTAINER_SOURCE (source)));
#line 6808 "DataCollection.c"
			_source_backlink_unref0 (_tmp0_);
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
#line 1419 "DataCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), source);
#line 6816 "DataCollection.c"
}


#line 1426 "DataCollection.vala"
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container) {
#line 6822 "DataCollection.c"
	Marker* _tmp4_;
#line 1426 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1426 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 6828 "DataCollection.c"
	{
		GeeIterator* _collection_it;
#line 1427 "DataCollection.vala"
		_collection_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 1427 "DataCollection.vala"
		while (TRUE) {
#line 6835 "DataCollection.c"
			SourceCollection* collection;
			SourceBacklink* _tmp0_;
			gboolean _tmp1_;
#line 1427 "DataCollection.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 1427 "DataCollection.vala"
				break;
#line 6843 "DataCollection.c"
			}
#line 1427 "DataCollection.vala"
			collection = (SourceCollection*) gee_iterator_get (_collection_it);
#line 1428 "DataCollection.vala"
			if ((_tmp1_ = source_collection_has_backlink (collection, _tmp0_ = container_source_get_backlink (container)), _source_backlink_unref0 (_tmp0_), _tmp1_)) {
#line 6849 "DataCollection.c"
				Marker* _tmp2_;
				GeeCollection* _tmp3_;
				gboolean added;
#line 1429 "DataCollection.vala"
				_tmp3_ = source_collection_unlink_marked (SOURCE_COLLECTION (self), _tmp2_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), NULL, NULL);
#line 6855 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (_tmp2_);
#line 1430 "DataCollection.vala"
				added = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1431 "DataCollection.vala"
				g_assert (added);
#line 6862 "DataCollection.c"
				_data_collection_unref0 (collection);
				_g_object_unref0 (_collection_it);
#line 1432 "DataCollection.vala"
				return;
#line 6867 "DataCollection.c"
			}
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
#line 1436 "DataCollection.vala"
	source_collection_destroy_marked (SOURCE_COLLECTION (self), _tmp4_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), TRUE, NULL, NULL, NULL);
#line 6875 "DataCollection.c"
	_g_object_unref0 (_tmp4_);
}


#line 1352 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self) {
#line 6882 "DataCollection.c"
	container_source_collection_on_contained_sources_unlinking (self, unlinking);
}


#line 1375 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self) {
#line 6889 "DataCollection.c"
	container_source_collection_on_contained_sources_relinked (self, relinked);
}


#line 1403 "DataCollection.vala"
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 6896 "DataCollection.c"
	container_source_collection_on_contained_source_destroyed (self, source);
}


#line 1403 "DataCollection.vala"
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 6903 "DataCollection.c"
	container_source_collection_on_contained_source_destroyed (self, source);
}


#line 1439 "DataCollection.vala"
void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection) {
#line 1439 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1439 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 1440 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections), collection)) {
#line 6916 "DataCollection.c"
		char* _tmp0_;
		char* _tmp1_;
#line 1441 "DataCollection.vala"
		g_warning ("DataCollection.vala:1441: attempted to multiple-attach '%s' to '%s'", _tmp0_ = data_collection_to_string (DATA_COLLECTION (collection)), _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 6921 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
#line 1442 "DataCollection.vala"
		return;
#line 6926 "DataCollection.c"
	}
#line 1445 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections), collection);
#line 1447 "DataCollection.vala"
	g_signal_connect (collection, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1448 "DataCollection.vala"
	g_signal_connect (collection, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1449 "DataCollection.vala"
	g_signal_connect (collection, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 1450 "DataCollection.vala"
	g_signal_connect (collection, "unlinked-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 6938 "DataCollection.c"
}


#line 1453 "DataCollection.vala"
void container_source_collection_detach_all_collections (ContainerSourceCollection* self) {
#line 1453 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 6946 "DataCollection.c"
	{
		GeeIterator* _collection_it;
#line 1454 "DataCollection.vala"
		_collection_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 1454 "DataCollection.vala"
		while (TRUE) {
#line 6953 "DataCollection.c"
			SourceCollection* collection;
			guint _tmp0_;
			guint _tmp1_;
			guint _tmp2_;
			guint _tmp3_;
#line 1454 "DataCollection.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 1454 "DataCollection.vala"
				break;
#line 6963 "DataCollection.c"
			}
#line 1454 "DataCollection.vala"
			collection = (SourceCollection*) gee_iterator_get (_collection_it);
#line 1455 "DataCollection.vala"
			g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1455 "DataCollection.vala"
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1456 "DataCollection.vala"
			g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1456 "DataCollection.vala"
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1457 "DataCollection.vala"
			g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1457 "DataCollection.vala"
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 1458 "DataCollection.vala"
			g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1458 "DataCollection.vala"
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
#line 6983 "DataCollection.c"
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
#line 1461 "DataCollection.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
#line 6990 "DataCollection.c"
}


#line 1250 "DataCollection.vala"
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
#line 1250 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1250 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1250 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 7002 "DataCollection.c"
}


#line 1254 "DataCollection.vala"
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
#line 1254 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1254 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1254 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 7014 "DataCollection.c"
}


#line 1258 "DataCollection.vala"
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
#line 1258 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1258 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1258 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1258 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 7028 "DataCollection.c"
}


#line 1263 "DataCollection.vala"
static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
#line 1263 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1263 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1263 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 7040 "DataCollection.c"
}


static void container_source_collection_class_init (ContainerSourceCollectionClass * klass) {
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = container_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (ContainerSourceCollectionPrivate));
	SOURCE_COLLECTION_CLASS (klass)->notify_backlink_removed = container_source_collection_real_notify_backlink_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_added = container_source_collection_real_notify_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_removed = container_source_collection_real_notify_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_altered = container_source_collection_real_notify_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_backlink_to_container_removed = container_source_collection_real_notify_backlink_to_container_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->get_containers_holding_source = container_source_collection_real_get_containers_holding_source;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->convert_backlink_to_container = container_source_collection_real_convert_backlink_to_container;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = container_source_collection_real_notify_item_destroyed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_added = container_source_collection_real_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->backlink_to_container_removed = container_source_collection_real_backlink_to_container_removed;
	g_signal_new ("container_contents_added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("container_contents_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("container_contents_altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN, G_TYPE_NONE, 5, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("backlink_to_container_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, backlink_to_container_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
}


static void container_source_collection_instance_init (ContainerSourceCollection * self) {
	self->priv = CONTAINER_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->attached_collections = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, NULL, NULL);
	self->priv->holding_tank = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
}


static void container_source_collection_finalize (DataCollection* obj) {
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (obj);
	{
#line 1275 "DataCollection.vala"
		container_source_collection_detach_all_collections (self);
#line 7080 "DataCollection.c"
	}
	_g_object_unref0 (self->priv->attached_collections);
	_g_free0 (self->priv->backlink_name);
	_g_object_unref0 (self->priv->holding_tank);
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
}


GType container_source_collection_get_type (void) {
	static volatile gsize container_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
		GType container_source_collection_type_id;
		container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&container_source_collection_type_id__volatile, container_source_collection_type_id);
	}
	return container_source_collection_type_id__volatile;
}


#line 1613 "DataCollection.vala"
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 7103 "DataCollection.c"
	source_holding_tank_on_source_destroyed (self, source);
}


#line 1645 "DataCollection.vala"
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 7110 "DataCollection.c"
	source_holding_tank_on_source_collection_thawed (self);
}


#line 1497 "DataCollection.vala"
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
#line 7117 "DataCollection.c"
	SourceHoldingTank* self = (SourceHoldingTank*) g_type_create_instance (object_type);
	SourceCollection* _tmp0_;
	SourceHoldingTankCheckToKeep _tmp1_;
#line 1497 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 1498 "DataCollection.vala"
	self->priv->sources = (_tmp0_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->priv->sources), _tmp0_);
#line 1499 "DataCollection.vala"
	self->priv->check_to_keep = (_tmp1_ = check_to_keep, ((self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL), self->priv->check_to_keep = NULL, self->priv->check_to_keep_target = NULL, self->priv->check_to_keep_target_destroy_notify = NULL), self->priv->check_to_keep_target = check_to_keep_target, self->priv->check_to_keep_target_destroy_notify = NULL, _tmp1_);
#line 1501 "DataCollection.vala"
	g_signal_connect (self->priv->sources, "item-destroyed", (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 1502 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->sources), "thawed", (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 7131 "DataCollection.c"
	return self;
}


#line 1497 "DataCollection.vala"
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
#line 1497 "DataCollection.vala"
	return source_holding_tank_construct (TYPE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target);
#line 7140 "DataCollection.c"
}


#line 1510 "DataCollection.vala"
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1510 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1510 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1510 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1512 "DataCollection.vala"
	if (added != NULL) {
#line 7154 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1513 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (added));
#line 1513 "DataCollection.vala"
			while (TRUE) {
#line 7161 "DataCollection.c"
				DataSource* source;
#line 1513 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1513 "DataCollection.vala"
					break;
#line 7167 "DataCollection.c"
				}
#line 1513 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1514 "DataCollection.vala"
				data_source_notify_held_in_tank (source, self);
#line 7173 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1517 "DataCollection.vala"
	if (removed != NULL) {
#line 7181 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1518 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (removed));
#line 1518 "DataCollection.vala"
			while (TRUE) {
#line 7188 "DataCollection.c"
				DataSource* source;
#line 1518 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1518 "DataCollection.vala"
					break;
#line 7194 "DataCollection.c"
				}
#line 1518 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1519 "DataCollection.vala"
				data_source_notify_held_in_tank (source, NULL);
#line 7200 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1522 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 7208 "DataCollection.c"
}


#line 1497 "DataCollection.vala"
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1497 "DataCollection.vala"
	SOURCE_HOLDING_TANK_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 7216 "DataCollection.c"
}


#line 1525 "DataCollection.vala"
gint source_holding_tank_get_count (SourceHoldingTank* self) {
#line 7222 "DataCollection.c"
	gint result = 0;
#line 1525 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), 0);
#line 7226 "DataCollection.c"
	result = data_set_get_count (self->priv->tank);
#line 1526 "DataCollection.vala"
	return result;
#line 7230 "DataCollection.c"
}


#line 1529 "DataCollection.vala"
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self) {
#line 7236 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1529 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), NULL);
#line 7240 "DataCollection.c"
	result = GEE_COLLECTION (data_set_get_all (self->priv->tank));
#line 1530 "DataCollection.vala"
	return result;
#line 7244 "DataCollection.c"
}


#line 1533 "DataCollection.vala"
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source) {
#line 7250 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1533 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
#line 1533 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1534 "DataCollection.vala"
	if (data_set_contains (self->priv->tank, DATA_OBJECT (source))) {
#line 1534 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 7261 "DataCollection.c"
	} else {
#line 1534 "DataCollection.vala"
		_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), source);
#line 7265 "DataCollection.c"
	}
	result = _tmp0_;
#line 1534 "DataCollection.vala"
	return result;
#line 7270 "DataCollection.c"
}


#line 1538 "DataCollection.vala"
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many) {
#line 7276 "DataCollection.c"
	gboolean added;
#line 1538 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1538 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (many));
#line 1539 "DataCollection.vala"
	if (gee_collection_get_size (many) == 0) {
#line 1540 "DataCollection.vala"
		return;
#line 7286 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1542 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (many));
#line 1542 "DataCollection.vala"
		while (TRUE) {
#line 7294 "DataCollection.c"
			DataSource* source;
#line 1542 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1542 "DataCollection.vala"
				break;
#line 7300 "DataCollection.c"
			}
#line 1542 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1543 "DataCollection.vala"
			data_object_internal_set_ordinal (DATA_OBJECT (source), self->priv->ordinal++);
#line 7306 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1545 "DataCollection.vala"
	added = data_set_add_many (self->priv->tank, many);
#line 1546 "DataCollection.vala"
	g_assert (added);
#line 1548 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, many, NULL);
#line 7317 "DataCollection.c"
}


#line 1553 "DataCollection.vala"
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink) {
#line 7323 "DataCollection.c"
	Marker* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean added;
#line 1553 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1553 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlink));
#line 1554 "DataCollection.vala"
	if (gee_collection_get_size (unlink) == 0) {
#line 1555 "DataCollection.vala"
		return;
#line 7335 "DataCollection.c"
	}
#line 1558 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
#line 1560 "DataCollection.vala"
	_tmp1_ = source_collection_unlink_marked (self->priv->sources, _tmp0_ = data_collection_mark_many (DATA_COLLECTION (self->priv->sources), unlink), NULL, NULL);
#line 7341 "DataCollection.c"
	_g_object_unref0 (_tmp1_);
	_g_object_unref0 (_tmp0_);
	{
		GeeIterator* _source_it;
#line 1562 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (unlink));
#line 1562 "DataCollection.vala"
		while (TRUE) {
#line 7350 "DataCollection.c"
			DataSource* source;
#line 1562 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1562 "DataCollection.vala"
				break;
#line 7356 "DataCollection.c"
			}
#line 1562 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1563 "DataCollection.vala"
			data_object_internal_set_ordinal (DATA_OBJECT (source), self->priv->ordinal++);
#line 7362 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1565 "DataCollection.vala"
	added = data_set_add_many (self->priv->tank, unlink);
#line 1566 "DataCollection.vala"
	g_assert (added);
#line 1569 "DataCollection.vala"
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
#line 1571 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, unlink, NULL);
#line 7375 "DataCollection.c"
}


#line 1574 "DataCollection.vala"
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
#line 7381 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 1574 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
#line 1574 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 1575 "DataCollection.vala"
	count = data_set_get_count (self->priv->tank);
#line 7390 "DataCollection.c"
	{
		gint ctr;
#line 1576 "DataCollection.vala"
		ctr = 0;
#line 7395 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1576 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1576 "DataCollection.vala"
			while (TRUE) {
#line 7402 "DataCollection.c"
				DataSource* _tmp1_;
				gboolean _tmp2_;
#line 1576 "DataCollection.vala"
				if (!_tmp0_) {
#line 1576 "DataCollection.vala"
					ctr++;
#line 7409 "DataCollection.c"
				}
#line 1576 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1576 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1576 "DataCollection.vala"
					break;
#line 7417 "DataCollection.c"
				}
#line 1577 "DataCollection.vala"
				if ((_tmp2_ = data_source_has_backlink (_tmp1_ = DATA_SOURCE (data_set_get_at (self->priv->tank, ctr)), backlink), _g_object_unref0 (_tmp1_), _tmp2_)) {
#line 7421 "DataCollection.c"
					result = TRUE;
#line 1578 "DataCollection.vala"
					return result;
#line 7425 "DataCollection.c"
				}
			}
		}
	}
	result = FALSE;
#line 1581 "DataCollection.vala"
	return result;
#line 7433 "DataCollection.c"
}


#line 1584 "DataCollection.vala"
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
#line 7439 "DataCollection.c"
	gint count;
#line 1584 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1584 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 1585 "DataCollection.vala"
	count = data_set_get_count (self->priv->tank);
#line 7447 "DataCollection.c"
	{
		gint ctr;
#line 1586 "DataCollection.vala"
		ctr = 0;
#line 7452 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1586 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1586 "DataCollection.vala"
			while (TRUE) {
#line 7459 "DataCollection.c"
				DataSource* _tmp1_;
#line 1586 "DataCollection.vala"
				if (!_tmp0_) {
#line 1586 "DataCollection.vala"
					ctr++;
#line 7465 "DataCollection.c"
				}
#line 1586 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1586 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1586 "DataCollection.vala"
					break;
#line 7473 "DataCollection.c"
				}
#line 1587 "DataCollection.vala"
				data_source_remove_backlink (_tmp1_ = DATA_SOURCE (data_set_get_at (self->priv->tank, ctr)), backlink);
#line 7477 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 1590 "DataCollection.vala"
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed) {
#line 7487 "DataCollection.c"
	gboolean removed;
	gint count;
#line 1590 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1590 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (destroy));
#line 1590 "DataCollection.vala"
	g_return_if_fail ((not_removed == NULL) || GEE_IS_LIST (not_removed));
#line 1592 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (destroy)) == 0) {
#line 1593 "DataCollection.vala"
		return;
#line 7500 "DataCollection.c"
	}
#line 1595 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->tank, destroy);
#line 1596 "DataCollection.vala"
	g_assert (removed);
#line 1598 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (destroy));
#line 1600 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (destroy));
#line 7510 "DataCollection.c"
	{
		gint ctr;
#line 1601 "DataCollection.vala"
		ctr = 0;
#line 7515 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1601 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1601 "DataCollection.vala"
			while (TRUE) {
#line 7522 "DataCollection.c"
				DataSource* source;
#line 1601 "DataCollection.vala"
				if (!_tmp0_) {
#line 1601 "DataCollection.vala"
					ctr++;
#line 7528 "DataCollection.c"
				}
#line 1601 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1601 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1601 "DataCollection.vala"
					break;
#line 7536 "DataCollection.c"
				}
#line 1602 "DataCollection.vala"
				source = (DataSource*) gee_list_get (destroy, ctr);
#line 1603 "DataCollection.vala"
				if (!data_source_destroy_orphan (source, delete_backing)) {
#line 1604 "DataCollection.vala"
					if (NULL != not_removed) {
#line 1605 "DataCollection.vala"
						gee_collection_add (GEE_COLLECTION (not_removed), source);
#line 7546 "DataCollection.c"
					}
				}
#line 1608 "DataCollection.vala"
				if (monitor != NULL) {
#line 1609 "DataCollection.vala"
					monitor ((guint64) (ctr + 1), (guint64) count, monitor_target);
#line 7553 "DataCollection.c"
				}
				_g_object_unref0 (source);
			}
		}
	}
}


#line 1613 "DataCollection.vala"
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source) {
#line 7564 "DataCollection.c"
	gboolean removed;
	SingletonCollection* _tmp0_;
#line 1613 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1613 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1614 "DataCollection.vala"
	if (!data_set_contains (self->priv->tank, DATA_OBJECT (source))) {
#line 1615 "DataCollection.vala"
		return;
#line 7575 "DataCollection.c"
	}
#line 1617 "DataCollection.vala"
	removed = data_set_remove (self->priv->tank, DATA_OBJECT (source));
#line 1618 "DataCollection.vala"
	g_assert (removed);
#line 1620 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp0_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source)));
#line 7583 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
}


#line 1624 "DataCollection.vala"
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration) {
#line 7590 "DataCollection.c"
	gboolean removed;
	SingletonCollection* _tmp0_;
#line 1624 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1624 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1624 "DataCollection.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 1625 "DataCollection.vala"
	g_assert (data_set_contains (self->priv->tank, DATA_OBJECT (source)));
#line 1628 "DataCollection.vala"
	if (self->priv->check_to_keep (source, alteration, self->priv->check_to_keep_target)) {
#line 1629 "DataCollection.vala"
		return;
#line 7605 "DataCollection.c"
	}
#line 1631 "DataCollection.vala"
	removed = data_set_remove (self->priv->tank, DATA_OBJECT (source));
#line 1632 "DataCollection.vala"
	g_assert (removed);
#line 1634 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (DATA_COLLECTION (self->priv->sources))) {
#line 1635 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->relinks), source);
#line 1637 "DataCollection.vala"
		return;
#line 7617 "DataCollection.c"
	}
#line 1640 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp0_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source)));
#line 7621 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1642 "DataCollection.vala"
	source_collection_relink (self->priv->sources, source);
#line 7625 "DataCollection.c"
}


#line 1645 "DataCollection.vala"
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self) {
#line 7631 "DataCollection.c"
	GeeHashSet* copy;
	GeeHashSet* _tmp0_;
#line 1645 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1646 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->relinks)) == 0) {
#line 1647 "DataCollection.vala"
		return;
#line 7640 "DataCollection.c"
	}
#line 1650 "DataCollection.vala"
	copy = _g_object_ref0 (self->priv->relinks);
#line 1651 "DataCollection.vala"
	self->priv->relinks = (_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->relinks), _tmp0_);
#line 1653 "DataCollection.vala"
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (copy));
#line 1655 "DataCollection.vala"
	source_collection_relink_many (self->priv->sources, GEE_COLLECTION (copy));
#line 7650 "DataCollection.c"
	_g_object_unref0 (copy);
}


#line 1493 "DataCollection.vala"
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 1493 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
#line 1493 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1493 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 7663 "DataCollection.c"
}


static void value_source_holding_tank_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_holding_tank_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_holding_tank_unref (value->data[0].v_pointer);
	}
}


static void value_source_holding_tank_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_holding_tank_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_holding_tank_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_holding_tank_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceHoldingTank* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_holding_tank_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_holding_tank_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceHoldingTank** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_holding_tank_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceHoldingTank* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_HOLDING_TANK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_holding_tank (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_holding_tank_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


void value_take_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


static void source_holding_tank_class_init (SourceHoldingTankClass * klass) {
	source_holding_tank_parent_class = g_type_class_peek_parent (klass);
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = source_holding_tank_finalize;
	g_type_class_add_private (klass, sizeof (SourceHoldingTankPrivate));
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = source_holding_tank_real_notify_contents_altered;
	SOURCE_HOLDING_TANK_CLASS (klass)->contents_altered = source_holding_tank_real_contents_altered;
	g_signal_new ("contents_altered", TYPE_SOURCE_HOLDING_TANK, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceHoldingTankClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
}


static void source_holding_tank_instance_init (SourceHoldingTank * self) {
	self->priv = SOURCE_HOLDING_TANK_GET_PRIVATE (self);
	self->priv->tank = data_set_new ();
	self->priv->relinks = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->unlinking = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->ordinal = (gint64) 0;
	self->ref_count = 1;
}


static void source_holding_tank_finalize (SourceHoldingTank* obj) {
	SourceHoldingTank * self;
	self = SOURCE_HOLDING_TANK (obj);
	{
		guint _tmp0_;
		guint _tmp1_;
#line 1506 "DataCollection.vala"
		g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1506 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 1507 "DataCollection.vala"
		g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1507 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 7811 "DataCollection.c"
	}
	_data_collection_unref0 (self->priv->sources);
	(self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL);
	self->priv->check_to_keep = NULL;
	self->priv->check_to_keep_target = NULL;
	self->priv->check_to_keep_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->tank);
	_g_object_unref0 (self->priv->relinks);
	_g_object_unref0 (self->priv->unlinking);
}


GType source_holding_tank_get_type (void) {
	static volatile gsize source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&source_holding_tank_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_holding_tank_init, value_source_holding_tank_free_value, value_source_holding_tank_copy_value, value_source_holding_tank_peek_pointer, "p", value_source_holding_tank_collect_value, "p", value_source_holding_tank_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceHoldingTank), 0, (GInstanceInitFunc) source_holding_tank_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_holding_tank_type_id;
		source_holding_tank_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceHoldingTank", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_holding_tank_type_id__volatile, source_holding_tank_type_id);
	}
	return source_holding_tank_type_id__volatile;
}


gpointer source_holding_tank_ref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_holding_tank_unref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_HOLDING_TANK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1664 "DataCollection.vala"
DatabaseSourceHoldingTank* database_source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 7858 "DataCollection.c"
	DatabaseSourceHoldingTank* self = NULL;
	GetSourceDatabaseKey _tmp0_;
#line 1664 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 1666 "DataCollection.vala"
	self = (DatabaseSourceHoldingTank*) source_holding_tank_construct (object_type, sources, check_to_keep, check_to_keep_target);
#line 1668 "DataCollection.vala"
	self->priv->get_key = (_tmp0_ = get_key, ((self->priv->get_key_target_destroy_notify == NULL) ? NULL : (self->priv->get_key_target_destroy_notify (self->priv->get_key_target), NULL), self->priv->get_key = NULL, self->priv->get_key_target = NULL, self->priv->get_key_target_destroy_notify = NULL), self->priv->get_key_target = get_key_target, self->priv->get_key_target_destroy_notify = NULL, _tmp0_);
#line 7867 "DataCollection.c"
	return self;
}


#line 1664 "DataCollection.vala"
DatabaseSourceHoldingTank* database_source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 1664 "DataCollection.vala"
	return database_source_holding_tank_construct (TYPE_DATABASE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 7876 "DataCollection.c"
}


#line 1671 "DataCollection.vala"
DataSource* database_source_holding_tank_get_by_id (DatabaseSourceHoldingTank* self, gint64 id) {
#line 7882 "DataCollection.c"
	DataSource* result = NULL;
#line 1671 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_HOLDING_TANK (self), NULL);
#line 7886 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &id);
#line 1672 "DataCollection.vala"
	return result;
#line 7890 "DataCollection.c"
}


#line 1675 "DataCollection.vala"
static void database_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
#line 7896 "DataCollection.c"
	DatabaseSourceHoldingTank * self;
	self = DATABASE_SOURCE_HOLDING_TANK (base);
#line 1675 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1675 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1677 "DataCollection.vala"
	if (added != NULL) {
#line 7905 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1678 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (added));
#line 1678 "DataCollection.vala"
			while (TRUE) {
#line 7912 "DataCollection.c"
				DataSource* source;
				gint64 _tmp0_;
#line 1678 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1678 "DataCollection.vala"
					break;
#line 7919 "DataCollection.c"
				}
#line 1678 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1679 "DataCollection.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), (_tmp0_ = self->priv->get_key (source, self->priv->get_key_target), &_tmp0_), source);
#line 7925 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1682 "DataCollection.vala"
	if (removed != NULL) {
#line 7933 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1683 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (removed));
#line 1683 "DataCollection.vala"
			while (TRUE) {
#line 7940 "DataCollection.c"
				DataSource* source;
				gint64 _tmp1_;
#line 1683 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1683 "DataCollection.vala"
					break;
#line 7947 "DataCollection.c"
				}
#line 1683 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1684 "DataCollection.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), (_tmp1_ = self->priv->get_key (source, self->priv->get_key_target), &_tmp1_), NULL);
#line 7953 "DataCollection.c"
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
#line 1687 "DataCollection.vala"
	SOURCE_HOLDING_TANK_CLASS (database_source_holding_tank_parent_class)->notify_contents_altered (SOURCE_HOLDING_TANK (self), added, removed);
#line 7961 "DataCollection.c"
}


static void database_source_holding_tank_class_init (DatabaseSourceHoldingTankClass * klass) {
	database_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = database_source_holding_tank_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceHoldingTankPrivate));
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = database_source_holding_tank_real_notify_contents_altered;
}


static void database_source_holding_tank_instance_init (DatabaseSourceHoldingTank * self) {
	self->priv = DATABASE_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, NULL);
}


static void database_source_holding_tank_finalize (SourceHoldingTank* obj) {
	DatabaseSourceHoldingTank * self;
	self = DATABASE_SOURCE_HOLDING_TANK (obj);
	(self->priv->get_key_target_destroy_notify == NULL) ? NULL : (self->priv->get_key_target_destroy_notify (self->priv->get_key_target), NULL);
	self->priv->get_key = NULL;
	self->priv->get_key_target = NULL;
	self->priv->get_key_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	SOURCE_HOLDING_TANK_CLASS (database_source_holding_tank_parent_class)->finalize (obj);
}


GType database_source_holding_tank_get_type (void) {
	static volatile gsize database_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceHoldingTank), 0, (GInstanceInitFunc) database_source_holding_tank_instance_init, NULL };
		GType database_source_holding_tank_type_id;
		database_source_holding_tank_type_id = g_type_register_static (TYPE_SOURCE_HOLDING_TANK, "DatabaseSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&database_source_holding_tank_type_id__volatile, database_source_holding_tank_type_id);
	}
	return database_source_holding_tank_type_id__volatile;
}


#line 1701 "DataCollection.vala"
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
#line 8005 "DataCollection.c"
	gboolean result = FALSE;
#line 1701 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1701 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 8011 "DataCollection.c"
	result = TRUE;
#line 1702 "DataCollection.vala"
	return result;
#line 8015 "DataCollection.c"
}


#line 1664 "DataCollection.vala"
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 1664 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 8023 "DataCollection.c"
}


#line 1707 "DataCollection.vala"
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 8029 "DataCollection.c"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1664 "DataCollection.vala"
DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 1664 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 8040 "DataCollection.c"
}


#line 1697 "DataCollection.vala"
ViewManager* view_manager_construct (GType object_type) {
#line 8046 "DataCollection.c"
	ViewManager* self = (ViewManager*) g_type_create_instance (object_type);
	return self;
}


static void value_view_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_manager_unref (value->data[0].v_pointer);
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
	view_manager_parent_class = g_type_class_peek_parent (klass);
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
}


static void view_manager_instance_init (ViewManager * self) {
	self->ref_count = 1;
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
	self = VIEW_MANAGER (obj);
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1834 "DataCollection.vala"
ViewCollection* view_collection_construct (GType object_type, const char* name) {
#line 8215 "DataCollection.c"
	ViewCollection* self = NULL;
#line 1834 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1835 "DataCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 8221 "DataCollection.c"
	return self;
}


#line 1834 "DataCollection.vala"
ViewCollection* view_collection_new (const char* name) {
#line 1834 "DataCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 8230 "DataCollection.c"
}


#line 1838 "DataCollection.vala"
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1838 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1838 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1839 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-selected", views);
#line 1840 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1842 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 8246 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected (self, views);
#line 8254 "DataCollection.c"
}


#line 1845 "DataCollection.vala"
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1845 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1845 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1846 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unselected", views);
#line 1847 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1849 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 8270 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_unselected (self, views);
#line 8278 "DataCollection.c"
}


#line 1852 "DataCollection.vala"
static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
#line 1852 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1853 "DataCollection.vala"
	g_signal_emit_by_name (self, "selection-group-altered");
#line 8288 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_selection_group_altered (ViewCollection* self) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 8296 "DataCollection.c"
}


#line 1856 "DataCollection.vala"
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1856 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1856 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1857 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", view);
#line 8308 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 8316 "DataCollection.c"
}


#line 1860 "DataCollection.vala"
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1860 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1860 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1861 "DataCollection.vala"
	g_signal_emit_by_name (self, "views-altered", views);
#line 8328 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 8336 "DataCollection.c"
}


#line 1864 "DataCollection.vala"
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1864 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1864 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1865 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", view);
#line 8348 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 8356 "DataCollection.c"
}


#line 1868 "DataCollection.vala"
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1868 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1868 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1869 "DataCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", views);
#line 8368 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 8376 "DataCollection.c"
}


#line 1872 "DataCollection.vala"
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 1872 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1872 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (shown));
#line 1873 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-shown", shown);
#line 8388 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
#line 8396 "DataCollection.c"
}


#line 1876 "DataCollection.vala"
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1876 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1876 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 1877 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-hidden", hidden);
#line 8408 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
#line 8416 "DataCollection.c"
}


#line 1880 "DataCollection.vala"
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1880 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1880 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 1881 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-visibility-changed", changed);
#line 8428 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1834 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
#line 8436 "DataCollection.c"
}


#line 1884 "DataCollection.vala"
static void view_collection_real_clear (DataCollection* base) {
#line 8442 "DataCollection.c"
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	gint original_lock_count;
	self = VIEW_COLLECTION (base);
#line 1887 "DataCollection.vala"
	if (gee_multi_map_get_size (GEE_MULTI_MAP (self->priv->monitors)) > 0) {
#line 1887 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 8451 "DataCollection.c"
	} else {
#line 1887 "DataCollection.vala"
		_tmp0_ = self->priv->mirroring != NULL;
#line 8455 "DataCollection.c"
	}
#line 1887 "DataCollection.vala"
	if (_tmp0_) {
#line 8459 "DataCollection.c"
		char* _tmp1_;
#line 1888 "DataCollection.vala"
		g_warning ("DataCollection.vala:1888: Cannot clear %s: monitoring or mirroring in " \
"effect", _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 8463 "DataCollection.c"
		_g_free0 (_tmp1_);
#line 1890 "DataCollection.vala"
		return;
#line 8467 "DataCollection.c"
	}
#line 1894 "DataCollection.vala"
	original_lock_count = self->priv->view_lock_count;
#line 1895 "DataCollection.vala"
	while (TRUE) {
#line 1895 "DataCollection.vala"
		if (!view_collection_is_view_locked (self)) {
#line 1895 "DataCollection.vala"
			break;
#line 8477 "DataCollection.c"
		}
#line 1896 "DataCollection.vala"
		view_collection_unlock_view (self);
#line 8481 "DataCollection.c"
	}
#line 1899 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (DATA_COLLECTION (self));
#line 8485 "DataCollection.c"
	{
		gint i;
#line 1901 "DataCollection.vala"
		i = 0;
#line 8490 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 1901 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 1901 "DataCollection.vala"
			while (TRUE) {
#line 1901 "DataCollection.vala"
				if (!_tmp2_) {
#line 1901 "DataCollection.vala"
					i++;
#line 8501 "DataCollection.c"
				}
#line 1901 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 1901 "DataCollection.vala"
				if (!(i < original_lock_count)) {
#line 1901 "DataCollection.vala"
					break;
#line 8509 "DataCollection.c"
				}
#line 1902 "DataCollection.vala"
				view_collection_lock_view (self);
#line 8513 "DataCollection.c"
			}
		}
	}
}


#line 1906 "DataCollection.vala"
static void view_collection_real_close (DataCollection* base) {
#line 8522 "DataCollection.c"
	ViewCollection * self;
	ViewFilter _tmp0_;
	self = VIEW_COLLECTION (base);
#line 1907 "DataCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 1908 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1909 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1911 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
#line 8534 "DataCollection.c"
}


#line 1914 "DataCollection.vala"
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target) {
#line 8540 "DataCollection.c"
	ViewCollectionMonitor* result = NULL;
	ViewCollectionMonitorImpl* monitor;
	gboolean _tmp0_ = FALSE;
#line 1914 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1914 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 1914 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 1914 "DataCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 1914 "DataCollection.vala"
	g_return_val_if_fail ((initial == NULL) || GEE_IS_COLLECTION (initial), NULL);
#line 1918 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1921 "DataCollection.vala"
	monitor = view_collection_monitor_impl_new (self, sources, manager, prereq);
#line 1922 "DataCollection.vala"
	gee_multi_map_set (GEE_MULTI_MAP (self->priv->monitors), sources, monitor);
#line 1924 "DataCollection.vala"
	if (initial != NULL) {
#line 1924 "DataCollection.vala"
		_tmp0_ = gee_collection_get_size (initial) > 0;
#line 8564 "DataCollection.c"
	} else {
#line 1924 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 8568 "DataCollection.c"
	}
#line 1924 "DataCollection.vala"
	if (_tmp0_) {
#line 8572 "DataCollection.c"
		GeeArrayList* created_views;
		GeeCollection* _tmp2_;
#line 1926 "DataCollection.vala"
		created_views = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 8577 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1927 "DataCollection.vala"
			_source_it = gee_iterable_iterator (GEE_ITERABLE (initial));
#line 1927 "DataCollection.vala"
			while (TRUE) {
#line 8584 "DataCollection.c"
				DataSource* source;
				DataView* _tmp1_;
#line 1927 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1927 "DataCollection.vala"
					break;
#line 8591 "DataCollection.c"
				}
#line 1927 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1928 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp1_ = view_manager_create_view (manager, source));
#line 8597 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 1930 "DataCollection.vala"
		_tmp2_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), progress_monitor, progress_monitor_target);
#line 8605 "DataCollection.c"
		_g_object_unref0 (_tmp2_);
		_g_object_unref0 (created_views);
	} else {
		GeeIterable* _tmp3_;
#line 1933 "DataCollection.vala"
		view_collection_add_sources (self, sources, _tmp3_ = GEE_ITERABLE (data_collection_get_all (DATA_COLLECTION (sources))), progress_monitor, progress_monitor_target);
#line 8612 "DataCollection.c"
		_g_object_unref0 (_tmp3_);
	}
	result = VIEW_COLLECTION_MONITOR (monitor);
#line 1936 "DataCollection.vala"
	return result;
#line 8618 "DataCollection.c"
}


static gpointer _view_collection_monitor_ref0 (gpointer self) {
	return self ? view_collection_monitor_ref (self) : NULL;
}


#line 1939 "DataCollection.vala"
void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m) {
#line 8629 "DataCollection.c"
	ViewCollectionMonitorImpl* monitor;
	gboolean removed;
#line 1939 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1939 "DataCollection.vala"
	g_return_if_fail (VIEW_COLLECTION_IS_MONITOR (m));
#line 1940 "DataCollection.vala"
	monitor = _view_collection_monitor_ref0 (VIEW_COLLECTION_MONITOR_IMPL (m));
#line 1942 "DataCollection.vala"
	removed = gee_multi_map_remove (GEE_MULTI_MAP (self->priv->monitors), monitor->sources, monitor);
#line 1943 "DataCollection.vala"
	g_assert (removed);
#line 8642 "DataCollection.c"
	_view_collection_monitor_unref0 (monitor);
}


#line 1946 "DataCollection.vala"
void view_collection_halt_all_monitoring (ViewCollection* self) {
#line 1946 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1947 "DataCollection.vala"
	gee_multi_map_clear (GEE_MULTI_MAP (self->priv->monitors));
#line 8653 "DataCollection.c"
}


#line 2165 "DataCollection.vala"
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 8659 "DataCollection.c"
	view_collection_on_mirror_contents_added (self, added);
}


#line 2177 "DataCollection.vala"
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 8666 "DataCollection.c"
	view_collection_on_mirror_contents_removed (self, removed);
}


#line 1950 "DataCollection.vala"
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target) {
#line 8673 "DataCollection.c"
	ViewCollection* _tmp0_;
	CreateView _tmp1_;
	GeeCollection* _tmp2_;
#line 1950 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1950 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 1951 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1952 "DataCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 1953 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1955 "DataCollection.vala"
	self->priv->mirroring = (_tmp0_ = _data_collection_ref0 (to_mirror), _data_collection_unref0 (self->priv->mirroring), _tmp0_);
#line 1956 "DataCollection.vala"
	self->priv->mirroring_ctor = (_tmp1_ = mirroring_ctor, ((self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL), self->priv->mirroring_ctor = NULL, self->priv->mirroring_ctor_target = NULL, self->priv->mirroring_ctor_target_destroy_notify = NULL), self->priv->mirroring_ctor_target = mirroring_ctor_target, self->priv->mirroring_ctor_target_destroy_notify = NULL, _tmp1_);
#line 1959 "DataCollection.vala"
	view_collection_on_mirror_contents_added (self, GEE_ITERABLE (_tmp2_ = data_collection_get_all (DATA_COLLECTION (self->priv->mirroring))));
#line 8693 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
#line 1961 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1962 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 8699 "DataCollection.c"
}


#line 1965 "DataCollection.vala"
void view_collection_halt_mirroring (ViewCollection* self) {
#line 8705 "DataCollection.c"
	ViewCollection* _tmp2_;
#line 1965 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1966 "DataCollection.vala"
	if (self->priv->mirroring != NULL) {
#line 8711 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
#line 1967 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1967 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1968 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1968 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 8722 "DataCollection.c"
	}
#line 1971 "DataCollection.vala"
	self->priv->mirroring = (_tmp2_ = NULL, _data_collection_unref0 (self->priv->mirroring), _tmp2_);
#line 8726 "DataCollection.c"
}


#line 1974 "DataCollection.vala"
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target) {
#line 8732 "DataCollection.c"
	ViewFilter _tmp0_;
#line 1974 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1975 "DataCollection.vala"
	if (self->priv->filter == filter) {
#line 1976 "DataCollection.vala"
		return;
#line 8740 "DataCollection.c"
	}
#line 1979 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = filter, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = filter_target, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1982 "DataCollection.vala"
	view_collection_reapply_view_filter (self);
#line 8746 "DataCollection.c"
}


#line 1987 "DataCollection.vala"
void view_collection_reapply_view_filter (ViewCollection* self) {
#line 8752 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1987 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1988 "DataCollection.vala"
	view_collection_filter_altered_items (self, _tmp0_ = GEE_COLLECTION (DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self))));
#line 8758 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
}


#line 1991 "DataCollection.vala"
void view_collection_reset_view_filter (ViewCollection* self) {
#line 8765 "DataCollection.c"
	ViewFilter _tmp0_;
	GeeArrayList* to_show;
#line 1991 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1992 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1996 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 8774 "DataCollection.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _object_it;
#line 1997 "DataCollection.vala"
		_object_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 1997 "DataCollection.vala"
		while (TRUE) {
#line 8783 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1997 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1997 "DataCollection.vala"
				break;
#line 8790 "DataCollection.c"
			}
#line 1997 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1998 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1999 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 2000 "DataCollection.vala"
				g_assert (view_collection_is_visible (self, view));
#line 8800 "DataCollection.c"
				_g_object_unref0 (view);
				_g_object_unref0 (object);
#line 2002 "DataCollection.vala"
				continue;
#line 8805 "DataCollection.c"
			}
#line 2005 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 8809 "DataCollection.c"
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2008 "DataCollection.vala"
	view_collection_show_items (self, GEE_LIST (to_show));
#line 8817 "DataCollection.c"
	_g_object_unref0 (to_show);
}


#line 2011 "DataCollection.vala"
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 8824 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 2011 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 8830 "DataCollection.c"
	result = IS_DATA_VIEW (object);
#line 2012 "DataCollection.vala"
	return result;
#line 8834 "DataCollection.c"
}


#line 2015 "DataCollection.vala"
static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added) {
#line 2015 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2015 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (sources));
#line 2015 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2016 "DataCollection.vala"
	view_collection_add_sources (self, SOURCE_COLLECTION (sources), added, NULL, NULL);
#line 8848 "DataCollection.c"
}


#line 1707 "DataCollection.vala"
static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self) {
#line 8854 "DataCollection.c"
	DataView* result;
	result = view_manager_create_view (self, source);
	return result;
}


#line 2019 "DataCollection.vala"
static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target) {
#line 8863 "DataCollection.c"
	DataView* created_view;
	GeeArrayList* created_views;
#line 2019 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2019 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2019 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2023 "DataCollection.vala"
	created_view = NULL;
#line 2024 "DataCollection.vala"
	created_views = NULL;
#line 8876 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 2025 "DataCollection.vala"
		_source_it = gee_iterable_iterator (added);
#line 2025 "DataCollection.vala"
		while (TRUE) {
#line 8883 "DataCollection.c"
			DataSource* source;
			void* factory_target = NULL;
			GDestroyNotify factory_target_destroy_notify = NULL;
			CreateView _tmp0_;
			CreateView factory;
#line 2025 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 2025 "DataCollection.vala"
				break;
#line 8893 "DataCollection.c"
			}
#line 2025 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 8897 "DataCollection.c"
			factory = (_tmp0_ = NULL, factory_target = NULL, factory_target_destroy_notify = NULL, _tmp0_);
			{
				GeeCollection* _tmp1_;
				GeeIterator* _tmp2_;
				GeeIterator* _monitor_it;
#line 2027 "DataCollection.vala"
				_monitor_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = gee_multi_map_get (GEE_MULTI_MAP (self->priv->monitors), sources))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 2027 "DataCollection.vala"
				while (TRUE) {
#line 8907 "DataCollection.c"
					ViewCollectionMonitorImpl* monitor;
#line 2027 "DataCollection.vala"
					if (!gee_iterator_next (_monitor_it)) {
#line 2027 "DataCollection.vala"
						break;
#line 8913 "DataCollection.c"
					}
#line 2027 "DataCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) gee_iterator_get (_monitor_it);
#line 2028 "DataCollection.vala"
					if (view_manager_include_in_view (monitor->manager, source)) {
#line 8919 "DataCollection.c"
						CreateView _tmp3_;
#line 2029 "DataCollection.vala"
						factory = (_tmp3_ = _view_manager_create_view_create_view, ((factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL), factory = NULL, factory_target = NULL, factory_target_destroy_notify = NULL), factory_target = view_manager_ref (monitor->manager), factory_target_destroy_notify = view_manager_unref, _tmp3_);
#line 8923 "DataCollection.c"
						_view_collection_monitor_unref0 (monitor);
#line 2031 "DataCollection.vala"
						break;
#line 8927 "DataCollection.c"
					}
					_view_collection_monitor_unref0 (monitor);
				}
				_g_object_unref0 (_monitor_it);
			}
#line 2035 "DataCollection.vala"
			if (factory != NULL) {
#line 8935 "DataCollection.c"
				DataView* new_view;
#line 2036 "DataCollection.vala"
				new_view = factory (source, factory_target);
#line 2040 "DataCollection.vala"
				if (created_views != NULL) {
#line 2041 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 8943 "DataCollection.c"
				} else {
#line 2042 "DataCollection.vala"
					if (created_view == NULL) {
#line 8947 "DataCollection.c"
						DataView* _tmp4_;
#line 2043 "DataCollection.vala"
						created_view = (_tmp4_ = _g_object_ref0 (new_view), _g_object_unref0 (created_view), _tmp4_);
#line 8951 "DataCollection.c"
					} else {
						GeeArrayList* _tmp5_;
						DataView* _tmp6_;
#line 2045 "DataCollection.vala"
						created_views = (_tmp5_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (created_views), _tmp5_);
#line 2046 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), created_view);
#line 2047 "DataCollection.vala"
						created_view = (_tmp6_ = NULL, _g_object_unref0 (created_view), _tmp6_);
#line 2048 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 8963 "DataCollection.c"
					}
				}
				_g_object_unref0 (new_view);
			}
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
			factory = NULL;
			factory_target = NULL;
			factory_target_destroy_notify = NULL;
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 2053 "DataCollection.vala"
	if (created_view != NULL) {
#line 2054 "DataCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (created_view));
#line 8980 "DataCollection.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 2055 "DataCollection.vala"
		if (created_views != NULL) {
#line 2055 "DataCollection.vala"
			_tmp7_ = gee_collection_get_size (GEE_COLLECTION (created_views)) > 0;
#line 8987 "DataCollection.c"
		} else {
#line 2055 "DataCollection.vala"
			_tmp7_ = FALSE;
#line 8991 "DataCollection.c"
		}
#line 2055 "DataCollection.vala"
		if (_tmp7_) {
#line 8995 "DataCollection.c"
			GeeCollection* _tmp8_;
#line 2056 "DataCollection.vala"
			_tmp8_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), progress_monitor, progress_monitor_target);
#line 8999 "DataCollection.c"
			_g_object_unref0 (_tmp8_);
		}
	}
	_g_object_unref0 (created_views);
	_g_object_unref0 (created_view);
}


#line 2059 "DataCollection.vala"
static gboolean view_collection_real_add (DataCollection* base, DataObject* object) {
#line 9010 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	self = VIEW_COLLECTION (base);
#line 2059 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2060 "DataCollection.vala"
	data_view_internal_set_visible (DATA_VIEW (object), TRUE);
#line 2062 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->add (DATA_COLLECTION (self), object)) {
#line 9021 "DataCollection.c"
		result = FALSE;
#line 2063 "DataCollection.vala"
		return result;
#line 9025 "DataCollection.c"
	}
#line 2065 "DataCollection.vala"
	view_collection_filter_altered_items (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (object)));
#line 9029 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	result = TRUE;
#line 2067 "DataCollection.vala"
	return result;
#line 9034 "DataCollection.c"
}


#line 2070 "DataCollection.vala"
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 9040 "DataCollection.c"
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* return_list;
	self = VIEW_COLLECTION (base);
#line 2070 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 9047 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2072 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (objects));
#line 2072 "DataCollection.vala"
		while (TRUE) {
#line 9054 "DataCollection.c"
			DataObject* object;
#line 2072 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2072 "DataCollection.vala"
				break;
#line 9060 "DataCollection.c"
			}
#line 2072 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2073 "DataCollection.vala"
			data_view_internal_set_visible (DATA_VIEW (object), TRUE);
#line 9066 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2075 "DataCollection.vala"
	return_list = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (DATA_COLLECTION (self), objects, monitor, monitor_target);
#line 2077 "DataCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (return_list));
#line 9075 "DataCollection.c"
	result = return_list;
#line 2079 "DataCollection.vala"
	return result;
#line 9079 "DataCollection.c"
}


#line 2082 "DataCollection.vala"
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
#line 9085 "DataCollection.c"
	Marker* marker;
	gboolean _tmp1_ = FALSE;
#line 2082 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2082 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 2084 "DataCollection.vala"
	marker = NULL;
#line 9094 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 2085 "DataCollection.vala"
		_source_it = gee_iterable_iterator (removed);
#line 2085 "DataCollection.vala"
		while (TRUE) {
#line 9101 "DataCollection.c"
			DataSource* source;
			DataView* view;
#line 2085 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 2085 "DataCollection.vala"
				break;
#line 9108 "DataCollection.c"
			}
#line 2085 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 2086 "DataCollection.vala"
			view = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2089 "DataCollection.vala"
			if (view != NULL) {
#line 2090 "DataCollection.vala"
				if (marker == NULL) {
#line 9118 "DataCollection.c"
					Marker* _tmp0_;
#line 2091 "DataCollection.vala"
					marker = (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self)), _g_object_unref0 (marker), _tmp0_);
#line 9122 "DataCollection.c"
				}
#line 2093 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 9126 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 2097 "DataCollection.vala"
	if (marker != NULL) {
#line 2097 "DataCollection.vala"
		_tmp1_ = marker_get_count (marker) != 0;
#line 9137 "DataCollection.c"
	} else {
#line 2097 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 9141 "DataCollection.c"
	}
#line 2097 "DataCollection.vala"
	if (_tmp1_) {
#line 2098 "DataCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 9147 "DataCollection.c"
	}
	_g_object_unref0 (marker);
}


#line 2101 "DataCollection.vala"
static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items) {
#line 9155 "DataCollection.c"
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	gboolean ordering_changed;
#line 2101 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2101 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 2101 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 2104 "DataCollection.vala"
	to_add = NULL;
#line 2105 "DataCollection.vala"
	to_remove = NULL;
#line 2106 "DataCollection.vala"
	ordering_changed = FALSE;
#line 9171 "DataCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 2107 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (items))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2107 "DataCollection.vala"
		while (TRUE) {
#line 9180 "DataCollection.c"
			DataObject* object;
			Alteration* alteration;
			DataSource* source;
			ViewCollectionMonitorImpl* monitor;
			gboolean ignored;
			gboolean _tmp6_ = FALSE;
#line 2107 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2107 "DataCollection.vala"
				break;
#line 9191 "DataCollection.c"
			}
#line 2107 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2108 "DataCollection.vala"
			alteration = (Alteration*) gee_map_get (items, object);
#line 2109 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 2111 "DataCollection.vala"
			monitor = NULL;
#line 2112 "DataCollection.vala"
			ignored = TRUE;
#line 9203 "DataCollection.c"
			{
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _monitor_impl_it;
#line 2113 "DataCollection.vala"
				_monitor_impl_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = gee_multi_map_get (GEE_MULTI_MAP (self->priv->monitors), SOURCE_COLLECTION (collection)))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 2113 "DataCollection.vala"
				while (TRUE) {
#line 9212 "DataCollection.c"
					ViewCollectionMonitorImpl* monitor_impl;
					gboolean _tmp4_ = FALSE;
#line 2113 "DataCollection.vala"
					if (!gee_iterator_next (_monitor_impl_it)) {
#line 2113 "DataCollection.vala"
						break;
#line 9219 "DataCollection.c"
					}
#line 2113 "DataCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) gee_iterator_get (_monitor_impl_it);
#line 2114 "DataCollection.vala"
					if (monitor_impl->prereq != NULL) {
#line 2114 "DataCollection.vala"
						_tmp4_ = !alteration_contains_any (alteration, monitor_impl->prereq);
#line 9227 "DataCollection.c"
					} else {
#line 2114 "DataCollection.vala"
						_tmp4_ = FALSE;
#line 9231 "DataCollection.c"
					}
#line 2114 "DataCollection.vala"
					if (_tmp4_) {
#line 9235 "DataCollection.c"
						_view_collection_monitor_unref0 (monitor_impl);
#line 2115 "DataCollection.vala"
						continue;
#line 9239 "DataCollection.c"
					}
#line 2117 "DataCollection.vala"
					ignored = FALSE;
#line 2119 "DataCollection.vala"
					if (view_manager_include_in_view (monitor_impl->manager, source)) {
#line 9245 "DataCollection.c"
						ViewCollectionMonitorImpl* _tmp5_;
#line 2120 "DataCollection.vala"
						monitor = (_tmp5_ = _view_collection_monitor_ref0 (monitor_impl), _view_collection_monitor_unref0 (monitor), _tmp5_);
#line 9249 "DataCollection.c"
						_view_collection_monitor_unref0 (monitor_impl);
#line 2122 "DataCollection.vala"
						break;
#line 9253 "DataCollection.c"
					}
					_view_collection_monitor_unref0 (monitor_impl);
				}
				_g_object_unref0 (_monitor_impl_it);
			}
#line 2126 "DataCollection.vala"
			if (ignored) {
#line 2127 "DataCollection.vala"
				g_assert (monitor == NULL);
#line 9263 "DataCollection.c"
				_view_collection_monitor_unref0 (monitor);
				_g_object_unref0 (source);
				_alteration_unref0 (alteration);
				_g_object_unref0 (object);
#line 2129 "DataCollection.vala"
				continue;
#line 9270 "DataCollection.c"
			}
#line 2132 "DataCollection.vala"
			if (monitor != NULL) {
#line 2132 "DataCollection.vala"
				_tmp6_ = !view_collection_has_view_for_source (self, source);
#line 9276 "DataCollection.c"
			} else {
#line 2132 "DataCollection.vala"
				_tmp6_ = FALSE;
#line 9280 "DataCollection.c"
			}
#line 2132 "DataCollection.vala"
			if (_tmp6_) {
#line 9284 "DataCollection.c"
				DataView* _tmp8_;
#line 2133 "DataCollection.vala"
				if (to_add == NULL) {
#line 9288 "DataCollection.c"
					GeeArrayList* _tmp7_;
#line 2134 "DataCollection.vala"
					to_add = (_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_add), _tmp7_);
#line 9292 "DataCollection.c"
				}
#line 2136 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp8_ = view_manager_create_view (monitor->manager, source));
#line 9296 "DataCollection.c"
				_g_object_unref0 (_tmp8_);
			} else {
				gboolean _tmp9_ = FALSE;
#line 2137 "DataCollection.vala"
				if (monitor == NULL) {
#line 2137 "DataCollection.vala"
					_tmp9_ = view_collection_has_view_for_source (self, source);
#line 9304 "DataCollection.c"
				} else {
#line 2137 "DataCollection.vala"
					_tmp9_ = FALSE;
#line 9308 "DataCollection.c"
				}
#line 2137 "DataCollection.vala"
				if (_tmp9_) {
#line 9312 "DataCollection.c"
					DataView* _tmp11_;
#line 2138 "DataCollection.vala"
					if (to_remove == NULL) {
#line 9316 "DataCollection.c"
						GeeArrayList* _tmp10_;
#line 2139 "DataCollection.vala"
						to_remove = (_tmp10_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_remove), _tmp10_);
#line 9320 "DataCollection.c"
					}
#line 2141 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_remove), _tmp11_ = view_collection_get_view_for_source (self, source));
#line 9324 "DataCollection.c"
					_g_object_unref0 (_tmp11_);
				} else {
					gboolean _tmp12_ = FALSE;
#line 2142 "DataCollection.vala"
					if (monitor != NULL) {
#line 2142 "DataCollection.vala"
						_tmp12_ = view_collection_has_view_for_source (self, source);
#line 9332 "DataCollection.c"
					} else {
#line 2142 "DataCollection.vala"
						_tmp12_ = FALSE;
#line 9336 "DataCollection.c"
					}
#line 2142 "DataCollection.vala"
					if (_tmp12_) {
#line 9340 "DataCollection.c"
						DataView* view;
						gboolean _tmp13_ = FALSE;
#line 2143 "DataCollection.vala"
						view = view_collection_get_view_for_source (self, source);
#line 2145 "DataCollection.vala"
						if (data_set_contains (self->priv->selected, DATA_OBJECT (view))) {
#line 2146 "DataCollection.vala"
							data_set_resort_object (self->priv->selected, DATA_OBJECT (view), alteration);
#line 9349 "DataCollection.c"
						}
#line 2148 "DataCollection.vala"
						if (self->priv->visible != NULL) {
#line 2148 "DataCollection.vala"
							_tmp13_ = view_collection_is_visible (self, view);
#line 9355 "DataCollection.c"
						} else {
#line 2148 "DataCollection.vala"
							_tmp13_ = FALSE;
#line 9359 "DataCollection.c"
						}
#line 2148 "DataCollection.vala"
						if (_tmp13_) {
#line 2149 "DataCollection.vala"
							if (data_set_resort_object (self->priv->visible, DATA_OBJECT (view), alteration)) {
#line 2150 "DataCollection.vala"
								ordering_changed = TRUE;
#line 9367 "DataCollection.c"
							}
						}
						_g_object_unref0 (view);
					}
				}
			}
			_view_collection_monitor_unref0 (monitor);
			_g_object_unref0 (source);
			_alteration_unref0 (alteration);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2155 "DataCollection.vala"
	if (to_add != NULL) {
#line 9383 "DataCollection.c"
		GeeCollection* _tmp14_;
#line 2156 "DataCollection.vala"
		_tmp14_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
#line 9387 "DataCollection.c"
		_g_object_unref0 (_tmp14_);
	}
#line 2158 "DataCollection.vala"
	if (to_remove != NULL) {
#line 9392 "DataCollection.c"
		Marker* _tmp15_;
#line 2159 "DataCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), _tmp15_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (to_remove)));
#line 9396 "DataCollection.c"
		_g_object_unref0 (_tmp15_);
	}
#line 2161 "DataCollection.vala"
	if (ordering_changed) {
#line 2162 "DataCollection.vala"
		data_collection_notify_ordering_changed (DATA_COLLECTION (self));
#line 9403 "DataCollection.c"
	}
	_g_object_unref0 (to_remove);
	_g_object_unref0 (to_add);
}


#line 2165 "DataCollection.vala"
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
#line 9412 "DataCollection.c"
	GeeArrayList* to_add;
#line 2165 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2165 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2166 "DataCollection.vala"
	to_add = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 9420 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2167 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 2167 "DataCollection.vala"
		while (TRUE) {
#line 9427 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
#line 2167 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2167 "DataCollection.vala"
				break;
#line 9436 "DataCollection.c"
			}
#line 2167 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2168 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2170 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp1_ = self->priv->mirroring_ctor (_tmp0_ = data_view_get_source (view), self->priv->mirroring_ctor_target));
#line 9444 "DataCollection.c"
			_g_object_unref0 (_tmp1_);
			_g_object_unref0 (_tmp0_);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2173 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_add)) > 0) {
#line 9454 "DataCollection.c"
		GeeCollection* _tmp2_;
#line 2174 "DataCollection.vala"
		_tmp2_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
#line 9458 "DataCollection.c"
		_g_object_unref0 (_tmp2_);
	}
	_g_object_unref0 (to_add);
}


#line 2177 "DataCollection.vala"
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
#line 9467 "DataCollection.c"
	Marker* marker;
#line 2177 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2177 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 2178 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 9475 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2179 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 2179 "DataCollection.vala"
		while (TRUE) {
#line 9482 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
			DataView* our_view;
#line 2179 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2179 "DataCollection.vala"
				break;
#line 9492 "DataCollection.c"
			}
#line 2179 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2180 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2182 "DataCollection.vala"
			our_view = (_tmp1_ = view_collection_get_view_for_source (self, _tmp0_ = data_view_get_source (view)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2183 "DataCollection.vala"
			marker_mark (marker, DATA_OBJECT (our_view));
#line 9502 "DataCollection.c"
			_g_object_unref0 (our_view);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2186 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 9511 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2190 "DataCollection.vala"
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 9518 "DataCollection.c"
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	self = VIEW_COLLECTION (base);
#line 2190 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 2191 "DataCollection.vala"
	added_visible = NULL;
#line 2192 "DataCollection.vala"
	added_selected = NULL;
#line 9529 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2194 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 2194 "DataCollection.vala"
		while (TRUE) {
#line 9536 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			gboolean _tmp2_ = FALSE;
#line 2194 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2194 "DataCollection.vala"
				break;
#line 9545 "DataCollection.c"
			}
#line 2194 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2195 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2196 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), view);
#line 9553 "DataCollection.c"
			_g_object_unref0 (_tmp0_);
#line 2198 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 2199 "DataCollection.vala"
				if (added_selected == NULL) {
#line 9559 "DataCollection.c"
					GeeArrayList* _tmp1_;
#line 2200 "DataCollection.vala"
					added_selected = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (added_selected), _tmp1_);
#line 9563 "DataCollection.c"
				}
#line 2202 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 9567 "DataCollection.c"
			}
#line 2206 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 2206 "DataCollection.vala"
				_tmp2_ = self->priv->visible != NULL;
#line 9573 "DataCollection.c"
			} else {
#line 2206 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 9577 "DataCollection.c"
			}
#line 2206 "DataCollection.vala"
			if (_tmp2_) {
#line 2207 "DataCollection.vala"
				if (added_visible == NULL) {
#line 9583 "DataCollection.c"
					GeeArrayList* _tmp3_;
#line 2208 "DataCollection.vala"
					added_visible = (_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (added_visible), _tmp3_);
#line 9587 "DataCollection.c"
				}
#line 2210 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_visible), view);
#line 9591 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2214 "DataCollection.vala"
	if (added_visible != NULL) {
#line 9600 "DataCollection.c"
		gboolean is_added;
#line 2215 "DataCollection.vala"
		is_added = view_collection_add_many_visible (self, GEE_COLLECTION (added_visible));
#line 2216 "DataCollection.vala"
		g_assert (is_added);
#line 9606 "DataCollection.c"
	}
#line 2219 "DataCollection.vala"
	if (added_selected != NULL) {
#line 9610 "DataCollection.c"
		gboolean is_added;
#line 2220 "DataCollection.vala"
		is_added = data_set_add_many (self->priv->selected, GEE_COLLECTION (added_selected));
#line 2221 "DataCollection.vala"
		g_assert (is_added);
#line 2223 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (added_selected));
#line 9618 "DataCollection.c"
	}
#line 2226 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), added);
#line 9622 "DataCollection.c"
	_g_object_unref0 (added_selected);
	_g_object_unref0 (added_visible);
}


#line 2230 "DataCollection.vala"
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 9630 "DataCollection.c"
	ViewCollection * self;
	gboolean selected_removed;
	self = VIEW_COLLECTION (base);
#line 2230 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 2231 "DataCollection.vala"
	selected_removed = FALSE;
#line 9638 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 2232 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 2232 "DataCollection.vala"
		while (TRUE) {
#line 9645 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			gboolean _tmp1_;
			gboolean is_removed;
			gboolean _tmp2_ = FALSE;
#line 2232 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2232 "DataCollection.vala"
				break;
#line 9656 "DataCollection.c"
			}
#line 2232 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2233 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2235 "DataCollection.vala"
			is_removed = (_tmp1_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), NULL), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2236 "DataCollection.vala"
			g_assert (is_removed);
#line 2238 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 2239 "DataCollection.vala"
				view_collection_remove_selected (self, view);
#line 2240 "DataCollection.vala"
				selected_removed = TRUE;
#line 9672 "DataCollection.c"
			}
#line 2243 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 2243 "DataCollection.vala"
				_tmp2_ = self->priv->visible != NULL;
#line 9678 "DataCollection.c"
			} else {
#line 2243 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 9682 "DataCollection.c"
			}
#line 2243 "DataCollection.vala"
			if (_tmp2_) {
#line 2244 "DataCollection.vala"
				is_removed = data_set_remove (self->priv->visible, DATA_OBJECT (view));
#line 2245 "DataCollection.vala"
				g_assert (is_removed);
#line 9690 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2252 "DataCollection.vala"
	if (selected_removed) {
#line 2253 "DataCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 9701 "DataCollection.c"
	}
#line 2255 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), removed);
#line 9705 "DataCollection.c"
}


#line 2258 "DataCollection.vala"
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views) {
#line 9711 "DataCollection.c"
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 2258 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2258 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 2259 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 2260 "DataCollection.vala"
		return;
#line 9722 "DataCollection.c"
	}
#line 2264 "DataCollection.vala"
	to_show = NULL;
#line 2265 "DataCollection.vala"
	to_hide = NULL;
#line 9728 "DataCollection.c"
	{
		GeeIterator* _view_it;
#line 2267 "DataCollection.vala"
		_view_it = gee_iterable_iterator (GEE_ITERABLE (views));
#line 2267 "DataCollection.vala"
		while (TRUE) {
#line 9735 "DataCollection.c"
			DataView* view;
#line 2267 "DataCollection.vala"
			if (!gee_iterator_next (_view_it)) {
#line 2267 "DataCollection.vala"
				break;
#line 9741 "DataCollection.c"
			}
#line 2267 "DataCollection.vala"
			view = (DataView*) gee_iterator_get (_view_it);
#line 2268 "DataCollection.vala"
			if (self->priv->filter (view, self->priv->filter_target)) {
#line 9747 "DataCollection.c"
				gboolean _tmp0_ = FALSE;
#line 2269 "DataCollection.vala"
				if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view)) {
#line 2269 "DataCollection.vala"
					_tmp0_ = TRUE;
#line 9753 "DataCollection.c"
				} else {
#line 2269 "DataCollection.vala"
					_tmp0_ = !data_view_is_visible (view);
#line 9757 "DataCollection.c"
				}
#line 2269 "DataCollection.vala"
				if (_tmp0_) {
#line 2270 "DataCollection.vala"
					if (to_show == NULL) {
#line 9763 "DataCollection.c"
						GeeArrayList* _tmp1_;
#line 2271 "DataCollection.vala"
						to_show = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_show), _tmp1_);
#line 9767 "DataCollection.c"
					}
#line 2273 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 9771 "DataCollection.c"
				}
			} else {
				gboolean _tmp2_ = FALSE;
#line 2276 "DataCollection.vala"
				if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view)) {
#line 2276 "DataCollection.vala"
					_tmp2_ = TRUE;
#line 9779 "DataCollection.c"
				} else {
#line 2276 "DataCollection.vala"
					_tmp2_ = data_view_is_visible (view);
#line 9783 "DataCollection.c"
				}
#line 2276 "DataCollection.vala"
				if (_tmp2_) {
#line 2277 "DataCollection.vala"
					if (to_hide == NULL) {
#line 9789 "DataCollection.c"
						GeeArrayList* _tmp3_;
#line 2278 "DataCollection.vala"
						to_hide = (_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (to_hide), _tmp3_);
#line 9793 "DataCollection.c"
					}
#line 2280 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), view);
#line 9797 "DataCollection.c"
				}
			}
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
#line 2285 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 2286 "DataCollection.vala"
		if (to_show != NULL) {
#line 9808 "DataCollection.c"
			{
				GeeIterator* _view_it;
#line 2287 "DataCollection.vala"
				_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (to_show));
#line 2287 "DataCollection.vala"
				while (TRUE) {
#line 9815 "DataCollection.c"
					DataView* view;
#line 2287 "DataCollection.vala"
					if (!gee_iterator_next (_view_it)) {
#line 2287 "DataCollection.vala"
						break;
#line 9821 "DataCollection.c"
					}
#line 2287 "DataCollection.vala"
					view = (DataView*) gee_iterator_get (_view_it);
#line 2288 "DataCollection.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, GINT_TO_POINTER (TRUE));
#line 9827 "DataCollection.c"
					_g_object_unref0 (view);
				}
				_g_object_unref0 (_view_it);
			}
		}
#line 2292 "DataCollection.vala"
		if (to_hide != NULL) {
#line 9835 "DataCollection.c"
			{
				GeeIterator* _view_it;
#line 2293 "DataCollection.vala"
				_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (to_hide));
#line 2293 "DataCollection.vala"
				while (TRUE) {
#line 9842 "DataCollection.c"
					DataView* view;
#line 2293 "DataCollection.vala"
					if (!gee_iterator_next (_view_it)) {
#line 2293 "DataCollection.vala"
						break;
#line 9848 "DataCollection.c"
					}
#line 2293 "DataCollection.vala"
					view = (DataView*) gee_iterator_get (_view_it);
#line 2294 "DataCollection.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, GINT_TO_POINTER (FALSE));
#line 9854 "DataCollection.c"
					_g_object_unref0 (view);
				}
				_g_object_unref0 (_view_it);
			}
		}
		_g_object_unref0 (to_hide);
		_g_object_unref0 (to_show);
#line 2297 "DataCollection.vala"
		return;
#line 9864 "DataCollection.c"
	}
#line 2300 "DataCollection.vala"
	if (to_show != NULL) {
#line 2301 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 9870 "DataCollection.c"
	}
#line 2303 "DataCollection.vala"
	if (to_hide != NULL) {
#line 2304 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 9876 "DataCollection.c"
	}
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
}


#line 2307 "DataCollection.vala"
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map) {
#line 9885 "DataCollection.c"
	ViewCollection * self;
	GeeSet* _tmp0_;
	self = VIEW_COLLECTION (base);
#line 2307 "DataCollection.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 2308 "DataCollection.vala"
	view_collection_filter_altered_items (self, GEE_COLLECTION (_tmp0_ = gee_map_get_keys (map)));
#line 9893 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 2310 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (DATA_COLLECTION (self), map);
#line 9897 "DataCollection.c"
}


#line 2313 "DataCollection.vala"
gboolean view_collection_is_view_locked (ViewCollection* self) {
#line 9903 "DataCollection.c"
	gboolean result = FALSE;
#line 2313 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 9907 "DataCollection.c"
	result = self->priv->view_lock_count > 0;
#line 2314 "DataCollection.vala"
	return result;
#line 9911 "DataCollection.c"
}


#line 2317 "DataCollection.vala"
void view_collection_lock_view (ViewCollection* self) {
#line 2317 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2318 "DataCollection.vala"
	self->priv->view_lock_count++;
#line 9921 "DataCollection.c"
}


#line 2321 "DataCollection.vala"
void view_collection_unlock_view (ViewCollection* self) {
#line 9927 "DataCollection.c"
	Marker* marker;
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 2321 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2322 "DataCollection.vala"
	g_assert (self->priv->view_lock_count > 0);
#line 2323 "DataCollection.vala"
	if ((self->priv->view_lock_count = self->priv->view_lock_count - 1) != 0) {
#line 2324 "DataCollection.vala"
		return;
#line 9939 "DataCollection.c"
	}
	{
		GeeIterator* _view_it;
#line 2328 "DataCollection.vala"
		_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items));
#line 2328 "DataCollection.vala"
		while (TRUE) {
#line 9947 "DataCollection.c"
			DataView* view;
#line 2328 "DataCollection.vala"
			if (!gee_iterator_next (_view_it)) {
#line 2328 "DataCollection.vala"
				break;
#line 9953 "DataCollection.c"
			}
#line 2328 "DataCollection.vala"
			view = (DataView*) gee_iterator_get (_view_it);
#line 2329 "DataCollection.vala"
			gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), view, NULL);
#line 9959 "DataCollection.c"
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
#line 2333 "DataCollection.vala"
	marker = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (self->priv->locked_unlinked_items));
#line 2334 "DataCollection.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items));
#line 2335 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 2338 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2339 "DataCollection.vala"
	to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 9974 "DataCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
#line 2341 "DataCollection.vala"
		_key_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->locked_filter_items)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2341 "DataCollection.vala"
		while (TRUE) {
#line 9983 "DataCollection.c"
			DataView* key;
			gboolean _tmp2_ = FALSE;
#line 2341 "DataCollection.vala"
			if (!gee_iterator_next (_key_it)) {
#line 2341 "DataCollection.vala"
				break;
#line 9990 "DataCollection.c"
			}
#line 2341 "DataCollection.vala"
			key = (DataView*) gee_iterator_get (_key_it);
#line 2342 "DataCollection.vala"
			if (GPOINTER_TO_INT (gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), key))) {
#line 2342 "DataCollection.vala"
				_tmp2_ = !data_view_is_visible (key);
#line 9998 "DataCollection.c"
			} else {
#line 2342 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 10002 "DataCollection.c"
			}
#line 2342 "DataCollection.vala"
			if (_tmp2_) {
#line 2343 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), key);
#line 10008 "DataCollection.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 2344 "DataCollection.vala"
				if (!GPOINTER_TO_INT (gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->locked_filter_items), key))) {
#line 2344 "DataCollection.vala"
					_tmp3_ = data_view_is_visible (key);
#line 10015 "DataCollection.c"
				} else {
#line 2344 "DataCollection.vala"
					_tmp3_ = FALSE;
#line 10019 "DataCollection.c"
				}
#line 2344 "DataCollection.vala"
				if (_tmp3_) {
#line 2345 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), key);
#line 10025 "DataCollection.c"
				}
			}
			_g_object_unref0 (key);
		}
		_g_object_unref0 (_key_it);
	}
#line 2348 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 2349 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 10036 "DataCollection.c"
	}
#line 2351 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 2352 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 10042 "DataCollection.c"
	}
#line 2354 "DataCollection.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->locked_filter_items));
#line 10046 "DataCollection.c"
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
	_g_object_unref0 (marker);
}


#line 2357 "DataCollection.vala"
static void view_collection_real_remove_marked (DataCollection* base, Marker* marker) {
#line 10055 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2357 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2359 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->locked_unlinked_items)) > 0) {
#line 10062 "DataCollection.c"
		{
			GeeCollection* _tmp0_;
			GeeIterator* _tmp1_;
			GeeIterator* _object_it;
#line 2360 "DataCollection.vala"
			_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = marker_get_all (marker))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2360 "DataCollection.vala"
			while (TRUE) {
#line 10071 "DataCollection.c"
				DataObject* object;
#line 2360 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 2360 "DataCollection.vala"
					break;
#line 10077 "DataCollection.c"
				}
#line 2360 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 2361 "DataCollection.vala"
				if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), DATA_VIEW (object))) {
#line 2362 "DataCollection.vala"
					marker_unmark (marker, object);
#line 10085 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 2366 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->remove_marked (DATA_COLLECTION (self), marker);
#line 10094 "DataCollection.c"
}


#line 2369 "DataCollection.vala"
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
#line 10100 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2370 "DataCollection.vala"
	data_set_set_comparator (self->priv->selected, comparator, comparator_target, predicate, predicate_target);
#line 2371 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2372 "DataCollection.vala"
		data_set_set_comparator (self->priv->visible, comparator, comparator_target, predicate, predicate_target);
#line 10109 "DataCollection.c"
	}
#line 2374 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), comparator, comparator_target, predicate, predicate_target);
#line 10113 "DataCollection.c"
}


#line 2377 "DataCollection.vala"
static void view_collection_real_reset_comparator (DataCollection* base) {
#line 10119 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2378 "DataCollection.vala"
	data_set_reset_comparator (self->priv->selected);
#line 2379 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2380 "DataCollection.vala"
		data_set_reset_comparator (self->priv->visible);
#line 10128 "DataCollection.c"
	}
#line 2382 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
#line 10132 "DataCollection.c"
}


#line 2385 "DataCollection.vala"
static GeeCollection* view_collection_real_get_all (DataCollection* base) {
#line 10138 "DataCollection.c"
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 2386 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 10146 "DataCollection.c"
		GeeCollection* _tmp1_;
#line 2386 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_all (self->priv->visible), _g_object_unref0 (_tmp0_), _tmp1_);
#line 10150 "DataCollection.c"
	} else {
		GeeCollection* _tmp2_;
#line 2386 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)), _g_object_unref0 (_tmp0_), _tmp2_);
#line 10155 "DataCollection.c"
	}
	result = _tmp0_;
#line 2386 "DataCollection.vala"
	return result;
#line 10160 "DataCollection.c"
}


#line 2389 "DataCollection.vala"
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
#line 10166 "DataCollection.c"
	GeeCollection* result = NULL;
#line 2389 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10170 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 2390 "DataCollection.vala"
	return result;
#line 10174 "DataCollection.c"
}


#line 2393 "DataCollection.vala"
static gint view_collection_real_get_count (DataCollection* base) {
#line 10180 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 2394 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2394 "DataCollection.vala"
		_tmp0_ = data_set_get_count (self->priv->visible);
#line 10189 "DataCollection.c"
	} else {
#line 2394 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 10193 "DataCollection.c"
	}
	result = _tmp0_;
#line 2394 "DataCollection.vala"
	return result;
#line 10198 "DataCollection.c"
}


#line 2397 "DataCollection.vala"
gint view_collection_get_unfiltered_count (ViewCollection* self) {
#line 10204 "DataCollection.c"
	gint result = 0;
#line 2397 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 10208 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 2398 "DataCollection.vala"
	return result;
#line 10212 "DataCollection.c"
}


#line 2401 "DataCollection.vala"
static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
#line 10218 "DataCollection.c"
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 2402 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 10226 "DataCollection.c"
		DataObject* _tmp1_;
#line 2402 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_at (self->priv->visible, index), _g_object_unref0 (_tmp0_), _tmp1_);
#line 10230 "DataCollection.c"
	} else {
		DataObject* _tmp2_;
#line 2402 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), index), _g_object_unref0 (_tmp0_), _tmp2_);
#line 10235 "DataCollection.c"
	}
	result = _tmp0_;
#line 2402 "DataCollection.vala"
	return result;
#line 10240 "DataCollection.c"
}


#line 2405 "DataCollection.vala"
static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
#line 10246 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 2405 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 2406 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2406 "DataCollection.vala"
		_tmp0_ = data_set_index_of (self->priv->visible, object);
#line 10257 "DataCollection.c"
	} else {
#line 2406 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), object);
#line 10261 "DataCollection.c"
	}
	result = _tmp0_;
#line 2406 "DataCollection.vala"
	return result;
#line 10266 "DataCollection.c"
}


#line 2409 "DataCollection.vala"
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
#line 10272 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 2409 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2412 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), object)) {
#line 10280 "DataCollection.c"
		result = FALSE;
#line 2413 "DataCollection.vala"
		return result;
#line 10284 "DataCollection.c"
	}
	result = view_collection_is_visible (self, DATA_VIEW (object));
#line 2416 "DataCollection.vala"
	return result;
#line 10289 "DataCollection.c"
}


#line 2419 "DataCollection.vala"
static DataView* view_collection_real_get_first (ViewCollection* self) {
#line 10295 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 2419 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10300 "DataCollection.c"
	_tmp0_ = NULL;
#line 2420 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 10304 "DataCollection.c"
		DataView* _tmp1_;
#line 2420 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), 0)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 10308 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 2420 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 10313 "DataCollection.c"
	}
	result = _tmp0_;
#line 2420 "DataCollection.vala"
	return result;
#line 10318 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
DataView* view_collection_get_first (ViewCollection* self) {
#line 1834 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 10326 "DataCollection.c"
}


#line 2423 "DataCollection.vala"
static DataView* view_collection_real_get_last (ViewCollection* self) {
#line 10332 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 2423 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 10337 "DataCollection.c"
	_tmp0_ = NULL;
#line 2424 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 10341 "DataCollection.c"
		DataView* _tmp1_;
#line 2424 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), data_collection_get_count (DATA_COLLECTION (self)) - 1)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 10345 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 2424 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 10350 "DataCollection.c"
	}
	result = _tmp0_;
#line 2424 "DataCollection.vala"
	return result;
#line 10355 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
DataView* view_collection_get_last (ViewCollection* self) {
#line 1834 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 10363 "DataCollection.c"
}


#line 2427 "DataCollection.vala"
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
#line 10369 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 2427 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2427 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 2428 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 10378 "DataCollection.c"
		result = NULL;
#line 2429 "DataCollection.vala"
		return result;
#line 10382 "DataCollection.c"
	}
#line 2431 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 2432 "DataCollection.vala"
	if (index < 0) {
#line 10388 "DataCollection.c"
		result = NULL;
#line 2433 "DataCollection.vala"
		return result;
#line 10392 "DataCollection.c"
	}
#line 2435 "DataCollection.vala"
	index++;
#line 2436 "DataCollection.vala"
	if (index >= data_collection_get_count (DATA_COLLECTION (self))) {
#line 2437 "DataCollection.vala"
		index = 0;
#line 10400 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 2439 "DataCollection.vala"
	return result;
#line 10405 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 1834 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 10413 "DataCollection.c"
}


#line 2442 "DataCollection.vala"
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
#line 10419 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 2442 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2442 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 2443 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 10428 "DataCollection.c"
		result = NULL;
#line 2444 "DataCollection.vala"
		return result;
#line 10432 "DataCollection.c"
	}
#line 2446 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 2447 "DataCollection.vala"
	if (index < 0) {
#line 10438 "DataCollection.c"
		result = NULL;
#line 2448 "DataCollection.vala"
		return result;
#line 10442 "DataCollection.c"
	}
#line 2450 "DataCollection.vala"
	index--;
#line 2451 "DataCollection.vala"
	if (index < 0) {
#line 2452 "DataCollection.vala"
		index = data_collection_get_count (DATA_COLLECTION (self)) - 1;
#line 10450 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 2454 "DataCollection.vala"
	return result;
#line 10455 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 1834 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 10463 "DataCollection.c"
}


#line 2457 "DataCollection.vala"
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const char* type_selector) {
#line 10469 "DataCollection.c"
	gboolean result = FALSE;
	DataView* home_view;
	DataSource* _tmp0_;
	DataView* next_view;
	DataSource* _tmp6_;
	DataView* prev_view;
#line 2457 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2457 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 10480 "DataCollection.c"
	if (next != NULL) {
		*next = NULL;
	}
	if (prev != NULL) {
		*prev = NULL;
	}
#line 2459 "DataCollection.vala"
	home_view = view_collection_get_view_for_source (self, home);
#line 2460 "DataCollection.vala"
	if (home_view == NULL) {
#line 10491 "DataCollection.c"
		result = FALSE;
		_g_object_unref0 (home_view);
#line 2461 "DataCollection.vala"
		return result;
#line 10496 "DataCollection.c"
	}
#line 2463 "DataCollection.vala"
	*next = (_tmp0_ = NULL, _g_object_unref0 (*next), _tmp0_);
#line 2464 "DataCollection.vala"
	next_view = view_collection_get_next (self, home_view);
#line 2465 "DataCollection.vala"
	while (TRUE) {
#line 10504 "DataCollection.c"
		gboolean _tmp1_ = FALSE;
		DataView* _tmp5_;
#line 2465 "DataCollection.vala"
		if (!(next_view != home_view)) {
#line 2465 "DataCollection.vala"
			break;
#line 10511 "DataCollection.c"
		}
#line 2466 "DataCollection.vala"
		if (type_selector == NULL) {
#line 2466 "DataCollection.vala"
			_tmp1_ = TRUE;
#line 10517 "DataCollection.c"
		} else {
			DataSource* _tmp2_;
			char* _tmp3_;
#line 2466 "DataCollection.vala"
			_tmp1_ = _vala_strcmp0 (_tmp3_ = data_source_get_typename (_tmp2_ = data_view_get_source (next_view)), type_selector) == 0;
#line 10523 "DataCollection.c"
			_g_free0 (_tmp3_);
			_g_object_unref0 (_tmp2_);
		}
#line 2466 "DataCollection.vala"
		if (_tmp1_) {
#line 10529 "DataCollection.c"
			DataSource* _tmp4_;
#line 2467 "DataCollection.vala"
			*next = (_tmp4_ = data_view_get_source (next_view), _g_object_unref0 (*next), _tmp4_);
#line 2468 "DataCollection.vala"
			break;
#line 10535 "DataCollection.c"
		}
#line 2470 "DataCollection.vala"
		next_view = (_tmp5_ = view_collection_get_next (self, next_view), _g_object_unref0 (next_view), _tmp5_);
#line 10539 "DataCollection.c"
	}
#line 2473 "DataCollection.vala"
	*prev = (_tmp6_ = NULL, _g_object_unref0 (*prev), _tmp6_);
#line 2474 "DataCollection.vala"
	prev_view = view_collection_get_previous (self, home_view);
#line 2475 "DataCollection.vala"
	while (TRUE) {
#line 10547 "DataCollection.c"
		gboolean _tmp7_ = FALSE;
		DataView* _tmp11_;
#line 2475 "DataCollection.vala"
		if (!(prev_view != home_view)) {
#line 2475 "DataCollection.vala"
			break;
#line 10554 "DataCollection.c"
		}
#line 2476 "DataCollection.vala"
		if (type_selector == NULL) {
#line 2476 "DataCollection.vala"
			_tmp7_ = TRUE;
#line 10560 "DataCollection.c"
		} else {
			DataSource* _tmp8_;
			char* _tmp9_;
#line 2476 "DataCollection.vala"
			_tmp7_ = _vala_strcmp0 (_tmp9_ = data_source_get_typename (_tmp8_ = data_view_get_source (prev_view)), type_selector) == 0;
#line 10566 "DataCollection.c"
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp8_);
		}
#line 2476 "DataCollection.vala"
		if (_tmp7_) {
#line 10572 "DataCollection.c"
			DataSource* _tmp10_;
#line 2477 "DataCollection.vala"
			*prev = (_tmp10_ = data_view_get_source (prev_view), _g_object_unref0 (*prev), _tmp10_);
#line 2478 "DataCollection.vala"
			break;
#line 10578 "DataCollection.c"
		}
#line 2480 "DataCollection.vala"
		prev_view = (_tmp11_ = view_collection_get_previous (self, prev_view), _g_object_unref0 (prev_view), _tmp11_);
#line 10582 "DataCollection.c"
	}
	result = TRUE;
	_g_object_unref0 (prev_view);
	_g_object_unref0 (next_view);
	_g_object_unref0 (home_view);
#line 2483 "DataCollection.vala"
	return result;
#line 10590 "DataCollection.c"
}


#line 2487 "DataCollection.vala"
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const char* typename) {
#line 10596 "DataCollection.c"
	GeeSet* result = NULL;
	GeeSet* neighbors;
	DataSource* next;
	DataSource* prev;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_;
	DataSource* _tmp2_;
	DataSource* _tmp3_ = NULL;
	gboolean _tmp4_;
	DataSource* _tmp5_;
#line 2487 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2487 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 2489 "DataCollection.vala"
	neighbors = GEE_SET (gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL));
#line 10613 "DataCollection.c"
	next = NULL;
	prev = NULL;
#line 2493 "DataCollection.vala"
	if (!(_tmp4_ = (_tmp1_ = view_collection_get_immediate_neighbors (self, home, &_tmp0_, &_tmp3_, typename), next = (_tmp2_ = _tmp0_, _g_object_unref0 (next), _tmp2_), _tmp1_), prev = (_tmp5_ = _tmp3_, _g_object_unref0 (prev), _tmp5_), _tmp4_)) {
#line 10618 "DataCollection.c"
		result = neighbors;
		_g_object_unref0 (prev);
		_g_object_unref0 (next);
#line 2494 "DataCollection.vala"
		return result;
#line 10624 "DataCollection.c"
	}
#line 2497 "DataCollection.vala"
	if (next != NULL) {
#line 10628 "DataCollection.c"
		DataSource* next_next;
		DataSource* next_prev;
		DataSource* _tmp6_ = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp9_;
#line 2498 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), next);
#line 10637 "DataCollection.c"
		next_next = NULL;
		next_prev = NULL;
#line 2501 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, next, &_tmp6_, &_tmp8_, typename), next_next = (_tmp7_ = _tmp6_, _g_object_unref0 (next_next), _tmp7_));
#line 2501 "DataCollection.vala"
		next_prev = (_tmp9_ = _tmp8_, _g_object_unref0 (next_prev), _tmp9_);
#line 2504 "DataCollection.vala"
		if (next_next != NULL) {
#line 2505 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), next_next);
#line 10648 "DataCollection.c"
		}
		_g_object_unref0 (next_prev);
		_g_object_unref0 (next_next);
	}
#line 2509 "DataCollection.vala"
	if (prev != NULL) {
#line 10655 "DataCollection.c"
		DataSource* next_prev;
		DataSource* prev_prev;
		DataSource* _tmp10_ = NULL;
		DataSource* _tmp11_;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp13_;
#line 2510 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), prev);
#line 10664 "DataCollection.c"
		next_prev = NULL;
		prev_prev = NULL;
#line 2513 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, prev, &_tmp10_, &_tmp12_, typename), next_prev = (_tmp11_ = _tmp10_, _g_object_unref0 (next_prev), _tmp11_));
#line 2513 "DataCollection.vala"
		prev_prev = (_tmp13_ = _tmp12_, _g_object_unref0 (prev_prev), _tmp13_);
#line 2516 "DataCollection.vala"
		if (prev_prev != NULL) {
#line 2517 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), prev_prev);
#line 10675 "DataCollection.c"
		}
		_g_object_unref0 (prev_prev);
		_g_object_unref0 (next_prev);
	}
#line 2521 "DataCollection.vala"
	gee_collection_remove (GEE_COLLECTION (neighbors), home);
#line 10682 "DataCollection.c"
	result = neighbors;
	_g_object_unref0 (prev);
	_g_object_unref0 (next);
#line 2523 "DataCollection.vala"
	return result;
#line 10688 "DataCollection.c"
}


#line 2552 "DataCollection.vala"
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10694 "DataCollection.c"
	gboolean result;
	result = view_collection_select_item (self, object, user);
	return result;
}


#line 2527 "DataCollection.vala"
void view_collection_select_marked (ViewCollection* self, Marker* marker) {
#line 10703 "DataCollection.c"
	GeeArrayList* selected;
#line 2527 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2527 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2528 "DataCollection.vala"
	selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2529 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
#line 2531 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (selected)) > 0) {
#line 2532 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (selected));
#line 10717 "DataCollection.c"
	}
	_g_object_unref0 (selected);
}


#line 2535 "DataCollection.vala"
static void view_collection_add_selected (ViewCollection* self, DataView* view) {
#line 10725 "DataCollection.c"
	gboolean added;
#line 2535 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2535 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2536 "DataCollection.vala"
	added = data_set_add (self->priv->selected, DATA_OBJECT (view));
#line 2537 "DataCollection.vala"
	g_assert (added);
#line 10735 "DataCollection.c"
}


#line 2540 "DataCollection.vala"
static void view_collection_remove_selected (ViewCollection* self, DataView* view) {
#line 10741 "DataCollection.c"
	gboolean removed;
#line 2540 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2540 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2541 "DataCollection.vala"
	removed = data_set_remove (self->priv->selected, DATA_OBJECT (view));
#line 2542 "DataCollection.vala"
	g_assert (removed);
#line 10751 "DataCollection.c"
}


#line 2546 "DataCollection.vala"
void view_collection_select_all (ViewCollection* self) {
#line 10757 "DataCollection.c"
	Marker* marker;
#line 2546 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2547 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2548 "DataCollection.vala"
	marker_mark_all (marker);
#line 2549 "DataCollection.vala"
	view_collection_select_marked (self, marker);
#line 10767 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2552 "DataCollection.vala"
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10774 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2552 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2552 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2552 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2553 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2554 "DataCollection.vala"
	if (data_view_is_selected (view)) {
#line 2555 "DataCollection.vala"
		g_assert (data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 10789 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2557 "DataCollection.vala"
		return result;
#line 10794 "DataCollection.c"
	}
#line 2560 "DataCollection.vala"
	data_view_internal_set_selected (view, TRUE);
#line 2561 "DataCollection.vala"
	view_collection_add_selected (self, view);
#line 2563 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 10802 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2565 "DataCollection.vala"
	return result;
#line 10807 "DataCollection.c"
}


#line 2600 "DataCollection.vala"
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10813 "DataCollection.c"
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
	return result;
}


#line 2569 "DataCollection.vala"
void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
#line 10822 "DataCollection.c"
	GeeArrayList* unselected;
#line 2569 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2569 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2570 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2571 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
#line 2573 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2574 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 10836 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2578 "DataCollection.vala"
void view_collection_unselect_all (ViewCollection* self) {
#line 10844 "DataCollection.c"
	Marker* marker;
	GeeCollection* _tmp0_;
#line 2578 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2579 "DataCollection.vala"
	if (data_set_get_count (self->priv->selected) == 0) {
#line 2580 "DataCollection.vala"
		return;
#line 10853 "DataCollection.c"
	}
#line 2582 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2583 "DataCollection.vala"
	marker_mark_many (marker, _tmp0_ = view_collection_get_selected (self));
#line 10859 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 2585 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 10863 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2589 "DataCollection.vala"
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
#line 10870 "DataCollection.c"
	Marker* marker;
#line 2589 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2589 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 2590 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 10878 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 2591 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2591 "DataCollection.vala"
		while (TRUE) {
#line 10887 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 2591 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2591 "DataCollection.vala"
				break;
#line 10894 "DataCollection.c"
			}
#line 2591 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2592 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2593 "DataCollection.vala"
			if (view != exception) {
#line 2594 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 10904 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2597 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 10913 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2600 "DataCollection.vala"
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10920 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2600 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2600 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2600 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2601 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2602 "DataCollection.vala"
	if (!data_view_is_selected (view)) {
#line 2603 "DataCollection.vala"
		g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 10935 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2605 "DataCollection.vala"
		return result;
#line 10940 "DataCollection.c"
	}
#line 2608 "DataCollection.vala"
	data_view_internal_set_selected (view, FALSE);
#line 2609 "DataCollection.vala"
	view_collection_remove_selected (self, view);
#line 2611 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 10948 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2613 "DataCollection.vala"
	return result;
#line 10953 "DataCollection.c"
}


#line 2629 "DataCollection.vala"
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 10959 "DataCollection.c"
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
	return result;
}


#line 2618 "DataCollection.vala"
void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
#line 10968 "DataCollection.c"
	ViewCollectionToggleLists* lists;
#line 2618 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2618 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2619 "DataCollection.vala"
	lists = view_collection_toggle_lists_new ();
#line 2620 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
#line 2622 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->selected)) > 0) {
#line 2623 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (lists->selected));
#line 10982 "DataCollection.c"
	}
#line 2625 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->unselected)) > 0) {
#line 2626 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (lists->unselected));
#line 10988 "DataCollection.c"
	}
	_g_object_unref0 (lists);
}


#line 2629 "DataCollection.vala"
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 10996 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
	ViewCollectionToggleLists* lists;
#line 2629 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2629 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2629 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2630 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2631 "DataCollection.vala"
	lists = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (user));
#line 2635 "DataCollection.vala"
	if (data_view_internal_toggle (view)) {
#line 2636 "DataCollection.vala"
		view_collection_add_selected (self, view);
#line 2638 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->selected), view);
#line 11016 "DataCollection.c"
	} else {
#line 2640 "DataCollection.vala"
		view_collection_remove_selected (self, view);
#line 2642 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->unselected), view);
#line 11022 "DataCollection.c"
	}
	result = TRUE;
	_g_object_unref0 (lists);
	_g_object_unref0 (view);
#line 2645 "DataCollection.vala"
	return result;
#line 11029 "DataCollection.c"
}


#line 2648 "DataCollection.vala"
gint view_collection_get_selected_count (ViewCollection* self) {
#line 11035 "DataCollection.c"
	gint result = 0;
#line 2648 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 11039 "DataCollection.c"
	result = data_set_get_count (self->priv->selected);
#line 2649 "DataCollection.vala"
	return result;
#line 11043 "DataCollection.c"
}


#line 2652 "DataCollection.vala"
GeeCollection* view_collection_get_selected (ViewCollection* self) {
#line 11049 "DataCollection.c"
	GeeCollection* result = NULL;
#line 2652 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 11053 "DataCollection.c"
	result = GEE_COLLECTION (data_set_get_all (self->priv->selected));
#line 2653 "DataCollection.vala"
	return result;
#line 11057 "DataCollection.c"
}


#line 2656 "DataCollection.vala"
DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
#line 11063 "DataCollection.c"
	DataView* result = NULL;
#line 2656 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 11067 "DataCollection.c"
	result = DATA_VIEW (data_set_get_at (self->priv->selected, index));
#line 2657 "DataCollection.vala"
	return result;
#line 11071 "DataCollection.c"
}


#line 2660 "DataCollection.vala"
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
#line 11077 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2660 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2660 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 2661 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2661 "DataCollection.vala"
		_tmp0_ = data_set_contains (self->priv->visible, DATA_OBJECT (view));
#line 11088 "DataCollection.c"
	} else {
#line 2661 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 11092 "DataCollection.c"
	}
	result = _tmp0_;
#line 2661 "DataCollection.vala"
	return result;
#line 11097 "DataCollection.c"
}


#line 2664 "DataCollection.vala"
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many) {
#line 11103 "DataCollection.c"
	gboolean result = FALSE;
#line 2664 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2664 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (many), FALSE);
#line 2665 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 11111 "DataCollection.c"
		result = TRUE;
#line 2666 "DataCollection.vala"
		return result;
#line 11115 "DataCollection.c"
	}
#line 2668 "DataCollection.vala"
	if (!data_set_add_many (self->priv->visible, many)) {
#line 11119 "DataCollection.c"
		result = FALSE;
#line 2669 "DataCollection.vala"
		return result;
#line 11123 "DataCollection.c"
	}
#line 2672 "DataCollection.vala"
	if (data_set_get_count (self->priv->visible) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self))) {
#line 11127 "DataCollection.c"
		DataSet* _tmp0_;
#line 2673 "DataCollection.vala"
		self->priv->visible = (_tmp0_ = NULL, _data_set_unref0 (self->priv->visible), _tmp0_);
#line 11131 "DataCollection.c"
	}
	result = TRUE;
#line 2675 "DataCollection.vala"
	return result;
#line 11136 "DataCollection.c"
}


#line 2679 "DataCollection.vala"
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
#line 11142 "DataCollection.c"
	GeeArrayList* unselected;
	gint count;
	gboolean removed;
#line 2679 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2679 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 2680 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2682 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_hide));
#line 11154 "DataCollection.c"
	{
		gint ctr;
#line 2683 "DataCollection.vala"
		ctr = 0;
#line 11159 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2683 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2683 "DataCollection.vala"
			while (TRUE) {
#line 11166 "DataCollection.c"
				DataView* view;
#line 2683 "DataCollection.vala"
				if (!_tmp0_) {
#line 2683 "DataCollection.vala"
					ctr++;
#line 11172 "DataCollection.c"
				}
#line 2683 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2683 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2683 "DataCollection.vala"
					break;
#line 11180 "DataCollection.c"
				}
#line 2684 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_hide, ctr);
#line 2685 "DataCollection.vala"
				g_assert (data_view_is_visible (view));
#line 2687 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2688 "DataCollection.vala"
					data_view_internal_set_selected (view, FALSE);
#line 2689 "DataCollection.vala"
					view_collection_remove_selected (self, view);
#line 2690 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (unselected), view);
#line 11194 "DataCollection.c"
				}
#line 2693 "DataCollection.vala"
				data_view_internal_set_visible (view, FALSE);
#line 11198 "DataCollection.c"
				_g_object_unref0 (view);
			}
		}
	}
#line 2696 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 11205 "DataCollection.c"
		DataSet* _tmp1_;
#line 2698 "DataCollection.vala"
		self->priv->visible = (_tmp1_ = data_collection_get_dataset_copy (DATA_COLLECTION (self)), _data_set_unref0 (self->priv->visible), _tmp1_);
#line 11209 "DataCollection.c"
	}
#line 2701 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->visible, to_hide);
#line 2702 "DataCollection.vala"
	g_assert (removed);
#line 2704 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2705 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 11219 "DataCollection.c"
	}
#line 2707 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 2708 "DataCollection.vala"
		view_collection_notify_items_hidden (self, GEE_COLLECTION (to_hide));
#line 2709 "DataCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_hide));
#line 11227 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2714 "DataCollection.vala"
static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
#line 11235 "DataCollection.c"
	GeeArrayList* added_selected;
	gint count;
	gboolean added;
#line 2714 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2714 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 2715 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2717 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_show));
#line 11247 "DataCollection.c"
	{
		gint ctr;
#line 2718 "DataCollection.vala"
		ctr = 0;
#line 11252 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2718 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2718 "DataCollection.vala"
			while (TRUE) {
#line 11259 "DataCollection.c"
				DataView* view;
#line 2718 "DataCollection.vala"
				if (!_tmp0_) {
#line 2718 "DataCollection.vala"
					ctr++;
#line 11265 "DataCollection.c"
				}
#line 2718 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2718 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2718 "DataCollection.vala"
					break;
#line 11273 "DataCollection.c"
				}
#line 2719 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_show, ctr);
#line 2720 "DataCollection.vala"
				g_assert (!data_view_is_visible (view));
#line 2722 "DataCollection.vala"
				data_view_internal_set_visible (view, TRUE);
#line 2725 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2726 "DataCollection.vala"
					g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 2727 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 11287 "DataCollection.c"
				}
				_g_object_unref0 (view);
			}
		}
	}
#line 2731 "DataCollection.vala"
	added = view_collection_add_many_visible (self, GEE_COLLECTION (to_show));
#line 2732 "DataCollection.vala"
	g_assert (added);
#line 2733 "DataCollection.vala"
	added = data_set_add_many (self->priv->selected, GEE_COLLECTION (added_selected));
#line 2734 "DataCollection.vala"
	g_assert (added);
#line 2736 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 2737 "DataCollection.vala"
		view_collection_notify_items_shown (self, GEE_COLLECTION (to_show));
#line 2738 "DataCollection.vala"
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_show));
#line 11307 "DataCollection.c"
	}
	_g_object_unref0 (added_selected);
}


#line 2742 "DataCollection.vala"
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
#line 11315 "DataCollection.c"
	gboolean result = FALSE;
#line 2742 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2742 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 11321 "DataCollection.c"
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2743 "DataCollection.vala"
	return result;
#line 11325 "DataCollection.c"
}


#line 2746 "DataCollection.vala"
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
#line 11331 "DataCollection.c"
	DataView* result = NULL;
#line 2746 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2746 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 11337 "DataCollection.c"
	result = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2747 "DataCollection.vala"
	return result;
#line 11341 "DataCollection.c"
}


#line 2750 "DataCollection.vala"
GeeCollection* view_collection_get_sources (ViewCollection* self) {
#line 11347 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 2750 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 11353 "DataCollection.c"
	result = (_tmp1_ = GEE_COLLECTION (gee_set_get_read_only_view (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->source_map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2751 "DataCollection.vala"
	return result;
#line 11357 "DataCollection.c"
}


#line 2754 "DataCollection.vala"
GeeCollection* view_collection_get_selected_sources (ViewCollection* self) {
#line 11363 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeCollection* sources;
	gint count;
#line 2754 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2755 "DataCollection.vala"
	sources = GEE_COLLECTION (gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
#line 2757 "DataCollection.vala"
	count = data_set_get_count (self->priv->selected);
#line 11373 "DataCollection.c"
	{
		gint ctr;
#line 2758 "DataCollection.vala"
		ctr = 0;
#line 11378 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2758 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2758 "DataCollection.vala"
			while (TRUE) {
#line 11385 "DataCollection.c"
				DataView* _tmp1_;
				DataSource* _tmp2_;
#line 2758 "DataCollection.vala"
				if (!_tmp0_) {
#line 2758 "DataCollection.vala"
					ctr++;
#line 11392 "DataCollection.c"
				}
#line 2758 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2758 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2758 "DataCollection.vala"
					break;
#line 11400 "DataCollection.c"
				}
#line 2759 "DataCollection.vala"
				gee_collection_add (sources, _tmp2_ = data_view_get_source (_tmp1_ = DATA_VIEW (data_set_get_at (self->priv->selected, ctr))));
#line 11404 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (_tmp1_);
			}
		}
	}
	result = sources;
#line 2761 "DataCollection.vala"
	return result;
#line 11413 "DataCollection.c"
}


#line 2764 "DataCollection.vala"
DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index) {
#line 11419 "DataCollection.c"
	DataSource* result = NULL;
	DataObject* object;
	DataSource* _tmp0_;
#line 2764 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2765 "DataCollection.vala"
	object = data_set_get_at (self->priv->selected, index);
#line 11427 "DataCollection.c"
	_tmp0_ = NULL;
#line 2767 "DataCollection.vala"
	if (object != NULL) {
#line 11431 "DataCollection.c"
		DataSource* _tmp1_;
#line 2767 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_view_get_source (DATA_VIEW (object)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 11435 "DataCollection.c"
	} else {
		DataSource* _tmp2_;
#line 2767 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 11440 "DataCollection.c"
	}
	result = _tmp0_;
	_g_object_unref0 (object);
#line 2767 "DataCollection.vala"
	return result;
#line 11446 "DataCollection.c"
}


#line 2771 "DataCollection.vala"
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
#line 2771 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2771 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2772 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 11458 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2773 "DataCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 2774 "DataCollection.vala"
		view_collection_notify_views_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 11464 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2776 "DataCollection.vala"
		if (self->priv->frozen_views_altered == NULL) {
#line 11469 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2777 "DataCollection.vala"
			self->priv->frozen_views_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_views_altered), _tmp1_);
#line 11473 "DataCollection.c"
		}
#line 2778 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered), view);
#line 11477 "DataCollection.c"
	}
}


#line 2783 "DataCollection.vala"
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
#line 2783 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2783 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2784 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 11490 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2785 "DataCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 2786 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 11496 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2788 "DataCollection.vala"
		if (self->priv->frozen_geometries_altered == NULL) {
#line 11501 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2789 "DataCollection.vala"
			self->priv->frozen_geometries_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 11505 "DataCollection.c"
		}
#line 2790 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered), view);
#line 11509 "DataCollection.c"
	}
}


#line 2795 "DataCollection.vala"
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources) {
#line 2795 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2795 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2795 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2796 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 11524 "DataCollection.c"
		gboolean added;
#line 2797 "DataCollection.vala"
		added = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), view);
#line 2798 "DataCollection.vala"
		g_assert (added);
#line 11530 "DataCollection.c"
	}
}


#line 2803 "DataCollection.vala"
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources) {
#line 2803 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2803 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2803 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2806 "DataCollection.vala"
	if (self->priv->view_lock_count > 0) {
#line 2807 "DataCollection.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->locked_unlinked_items), view);
#line 11547 "DataCollection.c"
	}
}


#line 2810 "DataCollection.vala"
static void view_collection_real_notify_thawed (DataCollection* base) {
#line 11554 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2811 "DataCollection.vala"
	if (self->priv->frozen_views_altered != NULL) {
#line 11559 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _view_it;
#line 2812 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered));
#line 2812 "DataCollection.vala"
			while (TRUE) {
#line 11567 "DataCollection.c"
				DataView* view;
#line 2812 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2812 "DataCollection.vala"
					break;
#line 11573 "DataCollection.c"
				}
#line 2812 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2813 "DataCollection.vala"
				view_collection_notify_item_view_altered (self, view);
#line 11579 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2814 "DataCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (self->priv->frozen_views_altered));
#line 2815 "DataCollection.vala"
		self->priv->frozen_views_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_views_altered), _tmp0_);
#line 11588 "DataCollection.c"
	}
#line 2818 "DataCollection.vala"
	if (self->priv->frozen_geometries_altered != NULL) {
#line 11592 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _view_it;
#line 2819 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered));
#line 2819 "DataCollection.vala"
			while (TRUE) {
#line 11600 "DataCollection.c"
				DataView* view;
#line 2819 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2819 "DataCollection.vala"
					break;
#line 11606 "DataCollection.c"
				}
#line 2819 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2820 "DataCollection.vala"
				view_collection_notify_item_geometry_altered (self, view);
#line 11612 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2821 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (self->priv->frozen_geometries_altered));
#line 2822 "DataCollection.vala"
		self->priv->frozen_geometries_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 11621 "DataCollection.c"
	}
#line 2825 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (DATA_COLLECTION (self));
#line 11625 "DataCollection.c"
}


#line 1790 "DataCollection.vala"
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 1790 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1790 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 11635 "DataCollection.c"
}


#line 1794 "DataCollection.vala"
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 1794 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1794 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 11645 "DataCollection.c"
}


#line 1798 "DataCollection.vala"
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 1798 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1798 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 11655 "DataCollection.c"
}


#line 1805 "DataCollection.vala"
static void view_collection_real_selection_group_altered (ViewCollection* self) {
#line 1805 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 11663 "DataCollection.c"
}


#line 1809 "DataCollection.vala"
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible) {
#line 1809 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1809 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (visible));
#line 11673 "DataCollection.c"
}


#line 1813 "DataCollection.vala"
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 1813 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1813 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 11683 "DataCollection.c"
}


#line 1817 "DataCollection.vala"
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 1817 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1817 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 11693 "DataCollection.c"
}


#line 1821 "DataCollection.vala"
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 1821 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1821 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 11703 "DataCollection.c"
}


#line 1825 "DataCollection.vala"
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1825 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1825 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 11713 "DataCollection.c"
}


#line 1828 "DataCollection.vala"
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1828 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1828 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 11723 "DataCollection.c"
}


#line 1831 "DataCollection.vala"
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1831 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1831 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 11733 "DataCollection.c"
}


#line 1737 "DataCollection.vala"
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type) {
#line 11739 "DataCollection.c"
	ViewCollectionMonitor* self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
	return self;
}


#line 1737 "DataCollection.vala"
ViewCollectionMonitor* view_collection_monitor_new (void) {
#line 1737 "DataCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 11749 "DataCollection.c"
}


static void view_collection_value_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void view_collection_value_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_collection_monitor_unref (value->data[0].v_pointer);
	}
}


static void view_collection_value_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer view_collection_value_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* view_collection_value_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewCollectionMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_collection_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* view_collection_value_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewCollectionMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ViewCollectionParamSpecMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer view_collection_value_get_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void view_collection_value_set_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_collection_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_collection_monitor_unref (old);
	}
}


void view_collection_value_take_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_collection_monitor_unref (old);
	}
}


static void view_collection_monitor_class_init (ViewCollectionMonitorClass * klass) {
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_finalize;
}


static void view_collection_monitor_instance_init (ViewCollectionMonitor * self) {
	self->ref_count = 1;
}


static void view_collection_monitor_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitor * self;
	self = VIEW_COLLECTION_MONITOR (obj);
}


GType view_collection_monitor_get_type (void) {
	static volatile gsize view_collection_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&view_collection_monitor_type_id__volatile, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__volatile;
}


gpointer view_collection_monitor_ref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_collection_monitor_unref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gpointer _view_manager_ref0 (gpointer self) {
	return self ? view_manager_ref (self) : NULL;
}


#line 2015 "DataCollection.vala"
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 11919 "DataCollection.c"
	view_collection_on_sources_added (self, _sender, added);
}


#line 2082 "DataCollection.vala"
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 11926 "DataCollection.c"
	view_collection_on_sources_removed (self, removed);
}


#line 2101 "DataCollection.vala"
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 11933 "DataCollection.c"
	view_collection_on_sources_altered (self, _sender, items);
}


#line 1746 "DataCollection.vala"
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
#line 11940 "DataCollection.c"
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	SourceCollection* _tmp1_;
	ViewManager* _tmp2_;
	Alteration* _tmp3_;
#line 1746 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (owner), NULL);
#line 1746 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 1746 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 1746 "DataCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 1746 "DataCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 1748 "DataCollection.vala"
	self->owner = (_tmp0_ = _data_collection_ref0 (owner), _data_collection_unref0 (self->owner), _tmp0_);
#line 1749 "DataCollection.vala"
	self->sources = (_tmp1_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->sources), _tmp1_);
#line 1750 "DataCollection.vala"
	self->manager = (_tmp2_ = _view_manager_ref0 (manager), _view_manager_unref0 (self->manager), _tmp2_);
#line 1751 "DataCollection.vala"
	self->prereq = (_tmp3_ = _alteration_ref0 (prereq), _alteration_unref0 (self->prereq), _tmp3_);
#line 1753 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, owner);
#line 1754 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, owner);
#line 1755 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, owner);
#line 11970 "DataCollection.c"
	return self;
}


#line 1746 "DataCollection.vala"
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
#line 1746 "DataCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 11979 "DataCollection.c"
}


static void view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass) {
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_impl_finalize;
}


static void view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self) {
}


static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitorImpl * self;
	self = VIEW_COLLECTION_MONITOR_IMPL (obj);
	{
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
#line 1759 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1759 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, self->owner);
#line 1760 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1760 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self->owner);
#line 1761 "DataCollection.vala"
		g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1761 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, self->owner);
#line 12012 "DataCollection.c"
	}
	_data_collection_unref0 (self->owner);
	_data_collection_unref0 (self->sources);
	_view_manager_unref0 (self->manager);
	_alteration_unref0 (self->prereq);
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
}


static GType view_collection_monitor_impl_get_type (void) {
	static volatile gsize view_collection_monitor_impl_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_monitor_impl_type_id__volatile, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__volatile;
}


#line 1765 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
#line 12036 "DataCollection.c"
	ViewCollectionToggleLists * self = NULL;
#line 1765 "DataCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 12040 "DataCollection.c"
	return self;
}


#line 1765 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 1765 "DataCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 12049 "DataCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	self->selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
	_g_object_unref0 (self->selected);
	_g_object_unref0 (self->unselected);
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
	view_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected = view_collection_real_notify_items_selected;
	VIEW_COLLECTION_CLASS (klass)->notify_items_unselected = view_collection_real_notify_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_items_shown = view_collection_real_notify_items_shown;
	VIEW_COLLECTION_CLASS (klass)->notify_items_hidden = view_collection_real_notify_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->notify_items_visibility_changed = view_collection_real_notify_items_visibility_changed;
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->add = view_collection_real_add;
	DATA_COLLECTION_CLASS (klass)->add_many = view_collection_real_add_many;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->items_altered = view_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->remove_marked = view_collection_real_remove_marked;
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
	DATA_COLLECTION_CLASS (klass)->notify_thawed = view_collection_real_notify_thawed;
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}


static void view_collection_instance_init (ViewCollection * self) {
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
	self->priv->monitors = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, view_collection_monitor_unref, NULL, NULL, NULL, NULL);
	self->priv->mirroring = NULL;
	self->priv->mirroring_ctor = NULL;
	self->priv->filter = NULL;
	self->priv->selected = data_set_new ();
	self->priv->visible = NULL;
	self->priv->frozen_views_altered = NULL;
	self->priv->frozen_geometries_altered = NULL;
	self->priv->view_lock_count = 0;
	self->priv->locked_filter_items = gee_hash_map_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL);
	self->priv->locked_unlinked_items = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->source_map = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal, g_direct_equal);
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
	self = VIEW_COLLECTION (obj);
	_g_object_unref0 (self->priv->monitors);
	_data_collection_unref0 (self->priv->mirroring);
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	(self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL);
	self->priv->filter = NULL;
	self->priv->filter_target = NULL;
	self->priv->filter_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->selected);
	_data_set_unref0 (self->priv->visible);
	_g_object_unref0 (self->priv->frozen_views_altered);
	_g_object_unref0 (self->priv->frozen_geometries_altered);
	_g_object_unref0 (self->priv->locked_filter_items);
	_g_object_unref0 (self->priv->locked_unlinked_items);
	_g_object_unref0 (self->priv->source_map);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_BOXED) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_boxed (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__SOURCE_BACKLINK_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__SOURCE_BACKLINK_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__SOURCE_BACKLINK_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__SOURCE_BACKLINK_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_source_backlink (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 6);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_object (param_values + 4), g_value_get_boolean (param_values + 5), data2);
}



