/* DataObject.c generated by valac 0.10.3, the Vala compiler
 * generated from DataObject.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gio/gio.h>
#include <time.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _AlterationPrivate AlterationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
typedef struct _SourceBacklinkPrivate SourceBacklinkPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;
typedef struct _VideoSourcePrivate VideoSourcePrivate;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;
typedef struct _EventSourcePrivate EventSourcePrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;
typedef struct _DataViewPrivate DataViewPrivate;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ThumbnailViewPrivate ThumbnailViewPrivate;

#define TYPE_PHOTO_VIEW (photo_view_get_type ())
#define PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_VIEW, PhotoView))
#define PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_VIEW, PhotoViewClass))
#define IS_PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_VIEW))
#define IS_PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_VIEW))
#define PHOTO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_VIEW, PhotoViewClass))

typedef struct _PhotoView PhotoView;
typedef struct _PhotoViewClass PhotoViewClass;
typedef struct _PhotoViewPrivate PhotoViewPrivate;

#define TYPE_VIDEO_VIEW (video_view_get_type ())
#define VIDEO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_VIEW, VideoView))
#define VIDEO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_VIEW, VideoViewClass))
#define IS_VIDEO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_VIEW))
#define IS_VIDEO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_VIEW))
#define VIDEO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_VIEW, VideoViewClass))

typedef struct _VideoView VideoView;
typedef struct _VideoViewClass VideoViewClass;
typedef struct _VideoViewPrivate VideoViewPrivate;

#define TYPE_EVENT_VIEW (event_view_get_type ())
#define EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_VIEW, EventView))
#define EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_VIEW, EventViewClass))
#define IS_EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_VIEW))
#define IS_EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_VIEW))
#define EVENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_VIEW, EventViewClass))

typedef struct _EventView EventView;
typedef struct _EventViewClass EventViewClass;
typedef struct _EventViewPrivate EventViewPrivate;

struct _Alteration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AlterationPrivate * priv;
};

struct _AlterationClass {
	GTypeClass parent_class;
	void (*finalize) (Alteration *self);
};

struct _AlterationPrivate {
	char* subject;
	char* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const char* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const char* name);
	char* (*get_name) (DataObject* self);
	char* (*to_string) (DataObject* self);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceBacklinkPrivate * priv;
};

struct _SourceBacklinkClass {
	GTypeClass parent_class;
	void (*finalize) (SourceBacklink *self);
};

struct _SourceBacklinkPrivate {
	char* _name;
	char* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	char* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	char* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const char* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceHoldingTank* holding_tank;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
typedef void (*DataSourceContactSubscriberAlteration) (DataView* view, Alteration* alteration, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	char* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ImportID {
	gint64 id;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*internal_set_event_id) (MediaSource* self, EventID* id);
	char* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	char* (*get_title) (MediaSource* self);
	void (*set_title) (MediaSource* self, const char* title);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	char* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _VideoSource {
	MediaSource parent_instance;
	VideoSourcePrivate * priv;
};

struct _VideoSourceClass {
	MediaSourceClass parent_class;
};

struct _EventSource {
	ThumbnailSource parent_instance;
	EventSourcePrivate * priv;
};

struct _EventSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_start_time) (EventSource* self);
	time_t (*get_end_time) (EventSource* self);
	guint64 (*get_total_filesize) (EventSource* self);
	gint (*get_media_count) (EventSource* self);
	GeeCollection* (*get_media) (EventSource* self);
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	char* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};

struct _DataView {
	DataObject parent_instance;
	DataViewPrivate * priv;
};

struct _DataViewClass {
	DataObjectClass parent_class;
	void (*notify_view_altered) (DataView* self);
	void (*notify_geometry_altered) (DataView* self);
	void (*notify_unsubscribed) (DataView* self, DataSource* source);
	void (*notify_source_unlinking) (DataView* self, SourceCollection* sources);
	void (*notify_source_relinked) (DataView* self, SourceCollection* sources);
	void (*state_changed) (DataView* self, gboolean selected);
	void (*visibility_changed) (DataView* self, gboolean visible);
	void (*view_altered) (DataView* self);
	void (*geometry_altered) (DataView* self);
	void (*unsubscribed) (DataView* self, DataSource* source);
};

struct _DataViewPrivate {
	DataSource* source;
	gboolean selected;
	gboolean visible;
};

struct _ThumbnailView {
	DataView parent_instance;
	ThumbnailViewPrivate * priv;
};

struct _ThumbnailViewClass {
	DataViewClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailView* self);
	void (*thumbnail_altered) (ThumbnailView* self);
};

struct _PhotoView {
	ThumbnailView parent_instance;
	PhotoViewPrivate * priv;
};

struct _PhotoViewClass {
	ThumbnailViewClass parent_class;
};

struct _VideoView {
	ThumbnailView parent_instance;
	VideoViewPrivate * priv;
};

struct _VideoViewClass {
	ThumbnailViewClass parent_class;
};

struct _EventView {
	ThumbnailView parent_instance;
	EventViewPrivate * priv;
};

struct _EventViewClass {
	ThumbnailViewClass parent_class;
};


static gpointer alteration_parent_class = NULL;
static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;
static gpointer data_object_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer source_backlink_parent_class = NULL;
static gpointer data_source_parent_class = NULL;
static gpointer thumbnail_source_parent_class = NULL;
static gpointer photo_source_parent_class = NULL;
static gpointer video_source_parent_class = NULL;
static gpointer event_source_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;
static gpointer data_view_parent_class = NULL;
static gpointer thumbnail_view_parent_class = NULL;
static gpointer photo_view_parent_class = NULL;
static gpointer video_view_parent_class = NULL;
static gpointer event_view_parent_class = NULL;

gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
#define ALTERATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ALTERATION, AlterationPrivate))
enum  {
	ALTERATION_DUMMY_PROPERTY
};
Alteration* alteration_new (const char* subject, const char* detail);
Alteration* alteration_construct (GType object_type, const char* subject, const char* detail);
static void alteration_add_detail (Alteration* self, const char* sub, const char* det);
Alteration* alteration_new_from_list (const char* list);
Alteration* alteration_construct_from_list (GType object_type, const char* list);
Alteration* alteration_new_from_array (char** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, char** array, int array_length1);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (void* a);
static guint _alteration_case_hash_ghash_func (void* key);
static gboolean alteration_case_equal (void* a, void* b);
static gboolean _alteration_case_equal_gequal_func (void* a, void* b);
static inline gboolean alteration_equal_values (const char* str1, const char* str2);
static inline guint alteration_hash_value (const char* str);
gboolean alteration_has_subject (Alteration* self, const char* subject);
gboolean alteration_has_detail (Alteration* self, const char* subject, const char* detail);
GeeCollection* alteration_get_details (Alteration* self, const char* subject);
char* alteration_to_string (Alteration* self);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean alteration_equals (Alteration* self, Alteration* other);
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src);
Alteration* alteration_compress (Alteration* self, Alteration* other);
static void alteration_finalize (Alteration* obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataObject* data_object_construct (GType object_type, gint64 object_id);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name);
char* data_object_get_name (DataObject* self);
static char* data_object_real_get_name (DataObject* self);
char* data_object_to_string (DataObject* self);
static char* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const char* name);
static void _vala_GValue_free (GValue* self);
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_clear_collection_property (DataObject* self, const char* name);
void data_collection_clear_property (DataCollection* self, const char* name);
static void data_object_finalize (GObject* obj);
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
enum  {
	SOURCE_SNAPSHOT_DUMMY_PROPERTY
};
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
void source_snapshot_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot* obj);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
#define SOURCE_BACKLINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_BACKLINK, SourceBacklinkPrivate))
enum  {
	SOURCE_BACKLINK_DUMMY_PROPERTY
};
SourceBacklink* source_backlink_new (const char* name, const char* value);
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value);
static gboolean source_backlink_validate_name_value (const char* name, const char* value);
GType data_source_get_type (void) G_GNUC_CONST;
SourceBacklink* source_backlink_new_from_source (DataSource* source);
SourceBacklink* source_backlink_construct_from_source (GType object_type, DataSource* source);
char* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
char* source_backlink_to_string (SourceBacklink* self);
const char* source_backlink_get_name (SourceBacklink* self);
const char* source_backlink_get_value (SourceBacklink* self);
guint source_backlink_hash_func (void* key);
gboolean source_backlink_equal_func (void* a, void* b);
const char* source_backlink_get_typename (SourceBacklink* self);
gint64 source_backlink_get_instance_id (SourceBacklink* self);
static void source_backlink_finalize (SourceBacklink* obj);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
enum  {
	DATA_SOURCE_DUMMY_PROPERTY
};
DataSource* data_source_construct (GType object_type, gint64 object_id);
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection);
void data_source_notify_unlinked (DataSource* self);
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
static void data_source_real_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
static void data_source_real_notify_altered (DataObject* base, Alteration* alteration);
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration);
void data_source_contact_subscribers_alteration (DataSource* self, Alteration* alteration);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection);
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target);
static void data_source_subscriber_unlinking (DataSource* self, DataView* view);
static void _data_source_subscriber_unlinking_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_unlinked (DataSource* self);
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
static char* data_source_dehydrate_backlinks (DataSource* self);
void data_view_notify_source_unlinking (DataView* self, SourceCollection* sources);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
static void data_source_real_notify_relinked (DataSource* self);
static void data_source_subscriber_relinked (DataSource* self, DataView* view);
static void _data_source_subscriber_relinked_data_source_contact_subscriber (DataView* view, gpointer self);
void data_view_notify_source_relinked (DataView* self, SourceCollection* sources);
static char* data_source_real_get_typename (DataSource* self);
static gint64 data_source_real_get_instance_id (DataSource* self);
char* data_source_get_source_id (DataSource* self);
static char* data_source_real_get_source_id (DataSource* self);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
gboolean is_string_empty (const char* s);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error);
gboolean data_source_equals (DataSource* self, DataSource* source);
static gboolean data_source_real_equals (DataSource* self, DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
void data_view_notify_unsubscribed (DataView* self, DataSource* source);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
void data_source_internal_subscribe (DataSource* self, DataView* view);
static void _vala_array_add183 (DataView*** array, int* length, int* size, DataView* value);
void data_source_internal_unsubscribe (DataSource* self, DataView* view);
void data_source_unlinked (DataSource* self, SourceCollection* sources);
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources);
void data_source_relinked (DataSource* self, SourceCollection* sources);
static void data_source_real_relinked (DataSource* self, SourceCollection* sources);
void data_source_destroyed (DataSource* self);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject* obj);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
enum  {
	THUMBNAIL_SOURCE_DUMMY_PROPERTY
};
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view);
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self);
GType thumbnail_view_get_type (void) G_GNUC_CONST;
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_create_thumbnail (ThumbnailSource* self, gint scale, GError** error);
char* thumbnail_source_get_representative_id (ThumbnailSource* self);
static char* thumbnail_source_real_get_representative_id (ThumbnailSource* self);
PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self);
static PhotoFileFormat thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self);
void thumbnail_source_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self);
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType rating_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_SOURCE_DUMMY_PROPERTY
};
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
MediaSource* media_source_construct (GType object_type, gint64 object_id);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
GType video_source_get_type (void) G_GNUC_CONST;
enum  {
	VIDEO_SOURCE_DUMMY_PROPERTY
};
VideoSource* video_source_construct (GType object_type);
GType event_source_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_SOURCE_DUMMY_PROPERTY
};
EventSource* event_source_construct (GType object_type, gint64 object_id);
time_t event_source_get_start_time (EventSource* self);
static time_t event_source_real_get_start_time (EventSource* self);
time_t event_source_get_end_time (EventSource* self);
static time_t event_source_real_get_end_time (EventSource* self);
guint64 event_source_get_total_filesize (EventSource* self);
static guint64 event_source_real_get_total_filesize (EventSource* self);
gint event_source_get_media_count (EventSource* self);
static gint event_source_real_get_media_count (EventSource* self);
GeeCollection* event_source_get_media (EventSource* self);
static GeeCollection* event_source_real_get_media (EventSource* self);
GType container_source_get_type (void) G_GNUC_CONST;
gboolean container_source_has_links (ContainerSource* self);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link (ContainerSource* self, DataSource* source);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
void container_source_establish_link (ContainerSource* self, DataSource* source);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_proxy (GValue* value, gpointer v_object);
void value_take_source_proxy (GValue* value, gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void) G_GNUC_CONST;
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
enum  {
	SOURCE_PROXY_DUMMY_PROPERTY
};
SourceProxy* source_proxy_construct (GType object_type, DataSource* source);
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self);
static void source_proxy_set_source (SourceProxy* self, DataSource* source);
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self);
DataSource* source_proxy_get_source (SourceProxy* self);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
void source_proxy_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_dehydrated (SourceProxy* self);
static void source_proxy_real_dehydrated (SourceProxy* self);
void source_proxy_broken (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy* obj);
GType proxyable_get_type (void) G_GNUC_CONST;
SourceProxy* proxyable_get_proxy (Proxyable* self);
#define DATA_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_VIEW, DataViewPrivate))
enum  {
	DATA_VIEW_DUMMY_PROPERTY
};
DataView* data_view_new (DataSource* source);
DataView* data_view_construct (GType object_type, DataSource* source);
static char* data_view_real_get_name (DataObject* base);
static char* data_view_real_to_string (DataObject* base);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
gboolean data_view_internal_toggle (DataView* self);
gboolean data_view_is_visible (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
void data_view_notify_view_altered (DataView* self);
static void data_view_real_notify_view_altered (DataView* self);
GType view_collection_get_type (void) G_GNUC_CONST;
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void data_view_notify_geometry_altered (DataView* self);
static void data_view_real_notify_geometry_altered (DataView* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source);
static void data_view_real_notify_source_unlinking (DataView* self, SourceCollection* sources);
void view_collection_internal_notify_unlinking (ViewCollection* self, DataView* view, SourceCollection* sources);
static void data_view_real_notify_source_relinked (DataView* self, SourceCollection* sources);
void view_collection_internal_notify_relinked (ViewCollection* self, DataView* view, SourceCollection* sources);
void data_view_state_changed (DataView* self, gboolean selected);
static void data_view_real_state_changed (DataView* self, gboolean selected);
void data_view_visibility_changed (DataView* self, gboolean visible);
static void data_view_real_visibility_changed (DataView* self, gboolean visible);
void data_view_view_altered (DataView* self);
static void data_view_real_view_altered (DataView* self);
void data_view_geometry_altered (DataView* self);
static void data_view_real_geometry_altered (DataView* self);
void data_view_unsubscribed (DataView* self, DataSource* source);
static void data_view_real_unsubscribed (DataView* self, DataSource* source);
static void data_view_finalize (GObject* obj);
enum  {
	THUMBNAIL_VIEW_DUMMY_PROPERTY
};
ThumbnailView* thumbnail_view_new (ThumbnailSource* source);
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source);
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self);
void thumbnail_view_thumbnail_altered (ThumbnailView* self);
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self);
GType photo_view_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_VIEW_DUMMY_PROPERTY
};
PhotoView* photo_view_new (PhotoSource* source);
PhotoView* photo_view_construct (GType object_type, PhotoSource* source);
PhotoSource* photo_view_get_photo_source (PhotoView* self);
GType video_view_get_type (void) G_GNUC_CONST;
enum  {
	VIDEO_VIEW_DUMMY_PROPERTY
};
VideoView* video_view_new (VideoSource* source);
VideoView* video_view_construct (GType object_type, VideoSource* source);
VideoSource* video_view_get_video_source (VideoView* self);
GType event_view_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_VIEW_DUMMY_PROPERTY
};
EventView* event_view_new (EventSource* source);
EventView* event_view_construct (GType object_type, EventSource* source);
EventSource* event_view_get_event_source (EventView* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 44 "DataObject.vala"
Alteration* alteration_construct (GType object_type, const char* subject, const char* detail) {
#line 1128 "DataObject.c"
	Alteration* self = (Alteration*) g_type_create_instance (object_type);
#line 44 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 44 "DataObject.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 45 "DataObject.vala"
	alteration_add_detail (self, subject, detail);
#line 1136 "DataObject.c"
	return self;
}


#line 44 "DataObject.vala"
Alteration* alteration_new (const char* subject, const char* detail) {
#line 44 "DataObject.vala"
	return alteration_construct (TYPE_ALTERATION, subject, detail);
#line 1145 "DataObject.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 1155 "DataObject.c"
}


#line 50 "DataObject.vala"
Alteration* alteration_construct_from_list (GType object_type, const char* list) {
#line 1161 "DataObject.c"
	Alteration* self = (Alteration*) g_type_create_instance (object_type);
	gint pairs_length1;
	gint _pairs_size_;
	char** _tmp1_;
	char** _tmp0_;
	char** pairs;
#line 50 "DataObject.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1170 "DataObject.c"
	g_return_val_if_fail (string_get_length (list) > 0, NULL);
	pairs = (_tmp1_ = _tmp0_ = g_strsplit (list, ",", 0), pairs_length1 = _vala_array_length (_tmp0_), _pairs_size_ = pairs_length1, _tmp1_);
#line 52 "DataObject.vala"
	g_assert (pairs_length1 >= 1);
#line 1175 "DataObject.c"
	{
		char** pair_collection;
		int pair_collection_length1;
		int pair_it;
#line 54 "DataObject.vala"
		pair_collection = pairs;
#line 1182 "DataObject.c"
		pair_collection_length1 = pairs_length1;
		for (pair_it = 0; pair_it < pairs_length1; pair_it = pair_it + 1) {
			char* pair;
			pair = g_strdup (pair_collection[pair_it]);
			{
				gint subject_detail_length1;
				gint _subject_detail_size_;
				char** _tmp3_;
				char** _tmp2_;
				char** subject_detail;
				subject_detail = (_tmp3_ = _tmp2_ = g_strsplit (pair, ":", 2), subject_detail_length1 = _vala_array_length (_tmp2_), _subject_detail_size_ = subject_detail_length1, _tmp3_);
#line 56 "DataObject.vala"
				g_assert (subject_detail_length1 == 2);
#line 58 "DataObject.vala"
				alteration_add_detail (self, subject_detail[0], subject_detail[1]);
#line 1198 "DataObject.c"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (pair);
			}
		}
	}
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


#line 50 "DataObject.vala"
Alteration* alteration_new_from_list (const char* list) {
#line 50 "DataObject.vala"
	return alteration_construct_from_list (TYPE_ALTERATION, list);
#line 1213 "DataObject.c"
}


#line 64 "DataObject.vala"
Alteration* alteration_construct_from_array (GType object_type, char** array, int array_length1) {
#line 1219 "DataObject.c"
	Alteration* self = (Alteration*) g_type_create_instance (object_type);
	g_return_val_if_fail (array_length1 > 0, NULL);
	{
		char** pair_collection;
		int pair_collection_length1;
		int pair_it;
#line 65 "DataObject.vala"
		pair_collection = array;
#line 1228 "DataObject.c"
		pair_collection_length1 = array_length1;
		for (pair_it = 0; pair_it < array_length1; pair_it = pair_it + 1) {
			char* pair;
			pair = g_strdup (pair_collection[pair_it]);
			{
				gint subject_detail_length1;
				gint _subject_detail_size_;
				char** _tmp1_;
				char** _tmp0_;
				char** subject_detail;
				subject_detail = (_tmp1_ = _tmp0_ = g_strsplit (pair, ":", 2), subject_detail_length1 = _vala_array_length (_tmp0_), _subject_detail_size_ = subject_detail_length1, _tmp1_);
#line 67 "DataObject.vala"
				g_assert (subject_detail_length1 == 2);
#line 69 "DataObject.vala"
				alteration_add_detail (self, subject_detail[0], subject_detail[1]);
#line 1244 "DataObject.c"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (pair);
			}
		}
	}
	return self;
}


#line 64 "DataObject.vala"
Alteration* alteration_new_from_array (char** array, int array_length1) {
#line 64 "DataObject.vala"
	return alteration_construct_from_array (TYPE_ALTERATION, array, array_length1);
#line 1258 "DataObject.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 74 "DataObject.vala"
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map) {
#line 1269 "DataObject.c"
	Alteration* self = (Alteration*) g_type_create_instance (object_type);
	GeeMultiMap* _tmp0_;
#line 74 "DataObject.vala"
	g_return_val_if_fail (GEE_IS_MULTI_MAP (map), NULL);
#line 75 "DataObject.vala"
	self->priv->map = (_tmp0_ = _g_object_ref0 (map), _g_object_unref0 (self->priv->map), _tmp0_);
#line 1276 "DataObject.c"
	return self;
}


#line 74 "DataObject.vala"
static Alteration* alteration_new_from_map (GeeMultiMap* map) {
#line 74 "DataObject.vala"
	return alteration_construct_from_map (TYPE_ALTERATION, map);
#line 1285 "DataObject.c"
}


#line 1051 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 1291 "DataObject.c"
	char* result = NULL;
	char* _result_;
#line 1051 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1053 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1300 "DataObject.c"
	result = _result_;
#line 1054 "glib-2.0.vapi"
	return result;
#line 1304 "DataObject.c"
}


#line 78 "DataObject.vala"
static void alteration_add_detail (Alteration* self, const char* sub, const char* det) {
#line 1310 "DataObject.c"
	char* subject;
	char* detail;
	gboolean _tmp0_ = FALSE;
#line 78 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (self));
#line 78 "DataObject.vala"
	g_return_if_fail (sub != NULL);
#line 78 "DataObject.vala"
	g_return_if_fail (det != NULL);
#line 80 "DataObject.vala"
	subject = string_strip (sub);
#line 81 "DataObject.vala"
	g_assert (string_get_length (subject) > 0);
#line 83 "DataObject.vala"
	detail = string_strip (det);
#line 84 "DataObject.vala"
	g_assert (string_get_length (detail) > 0);
#line 87 "DataObject.vala"
	if (self->priv->subject == NULL) {
#line 87 "DataObject.vala"
		_tmp0_ = self->priv->map == NULL;
#line 1332 "DataObject.c"
	} else {
#line 87 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1336 "DataObject.c"
	}
#line 87 "DataObject.vala"
	if (_tmp0_) {
#line 1340 "DataObject.c"
		char* _tmp1_;
		char* _tmp2_;
#line 88 "DataObject.vala"
		g_assert (self->priv->detail == NULL);
#line 90 "DataObject.vala"
		self->priv->subject = (_tmp1_ = g_strdup (subject), _g_free0 (self->priv->subject), _tmp1_);
#line 91 "DataObject.vala"
		self->priv->detail = (_tmp2_ = g_strdup (detail), _g_free0 (self->priv->detail), _tmp2_);
#line 1349 "DataObject.c"
		_g_free0 (detail);
		_g_free0 (subject);
#line 93 "DataObject.vala"
		return;
#line 1354 "DataObject.c"
	}
#line 97 "DataObject.vala"
	if (self->priv->map == NULL) {
#line 1358 "DataObject.c"
		GeeMultiMap* _tmp3_;
#line 98 "DataObject.vala"
		self->priv->map = (_tmp3_ = alteration_create_map (self), _g_object_unref0 (self->priv->map), _tmp3_);
#line 1362 "DataObject.c"
	}
#line 101 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 1366 "DataObject.c"
		char* _tmp4_;
		char* _tmp5_;
#line 102 "DataObject.vala"
		g_assert (self->priv->detail != NULL);
#line 104 "DataObject.vala"
		gee_multi_map_set (self->priv->map, self->priv->subject, self->priv->detail);
#line 105 "DataObject.vala"
		self->priv->subject = (_tmp4_ = NULL, _g_free0 (self->priv->subject), _tmp4_);
#line 106 "DataObject.vala"
		self->priv->detail = (_tmp5_ = NULL, _g_free0 (self->priv->detail), _tmp5_);
#line 1377 "DataObject.c"
	}
#line 110 "DataObject.vala"
	gee_multi_map_set (self->priv->map, subject, detail);
#line 1381 "DataObject.c"
	_g_free0 (detail);
	_g_free0 (subject);
}


#line 121 "DataObject.vala"
static guint _alteration_case_hash_ghash_func (void* key) {
#line 1389 "DataObject.c"
	guint result;
	result = alteration_case_hash (key);
	return result;
}


#line 117 "DataObject.vala"
static gboolean _alteration_case_equal_gequal_func (void* a, void* b) {
#line 1398 "DataObject.c"
	gboolean result;
	result = alteration_case_equal (a, b);
	return result;
}


#line 113 "DataObject.vala"
static GeeMultiMap* alteration_create_map (Alteration* self) {
#line 1407 "DataObject.c"
	GeeMultiMap* result = NULL;
#line 113 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 1411 "DataObject.c"
	result = GEE_MULTI_MAP (gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func));
#line 114 "DataObject.vala"
	return result;
#line 1415 "DataObject.c"
}


#line 117 "DataObject.vala"
static gboolean alteration_case_equal (void* a, void* b) {
#line 1421 "DataObject.c"
	gboolean result = FALSE;
	result = alteration_equal_values ((const char*) a, (const char*) b);
#line 118 "DataObject.vala"
	return result;
#line 1426 "DataObject.c"
}


#line 121 "DataObject.vala"
static guint alteration_case_hash (void* a) {
#line 1432 "DataObject.c"
	guint result = 0U;
	result = alteration_hash_value ((const char*) a);
#line 122 "DataObject.vala"
	return result;
#line 1437 "DataObject.c"
}


#line 125 "DataObject.vala"
static inline gboolean alteration_equal_values (const char* str1, const char* str2) {
#line 1443 "DataObject.c"
	gboolean result = FALSE;
#line 125 "DataObject.vala"
	g_return_val_if_fail (str1 != NULL, FALSE);
#line 125 "DataObject.vala"
	g_return_val_if_fail (str2 != NULL, FALSE);
#line 1449 "DataObject.c"
	result = g_ascii_strcasecmp (str1, str2) == 0;
#line 126 "DataObject.vala"
	return result;
#line 1453 "DataObject.c"
}


#line 129 "DataObject.vala"
static inline guint alteration_hash_value (const char* str) {
#line 1459 "DataObject.c"
	guint result = 0U;
#line 129 "DataObject.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 1463 "DataObject.c"
	result = g_str_hash (str);
#line 130 "DataObject.vala"
	return result;
#line 1467 "DataObject.c"
}


#line 133 "DataObject.vala"
gboolean alteration_has_subject (Alteration* self, const char* subject) {
#line 1473 "DataObject.c"
	gboolean result = FALSE;
	GeeSet* keys;
#line 133 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 133 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 134 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 1482 "DataObject.c"
		result = alteration_equal_values (self->priv->subject, subject);
#line 135 "DataObject.vala"
		return result;
#line 1486 "DataObject.c"
	}
#line 137 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 138 "DataObject.vala"
	keys = gee_multi_map_get_keys (self->priv->map);
#line 139 "DataObject.vala"
	if (keys != NULL) {
#line 1494 "DataObject.c"
		{
			GeeIterator* _key_it;
#line 140 "DataObject.vala"
			_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 140 "DataObject.vala"
			while (TRUE) {
#line 1501 "DataObject.c"
				char* key;
#line 140 "DataObject.vala"
				if (!gee_iterator_next (_key_it)) {
#line 140 "DataObject.vala"
					break;
#line 1507 "DataObject.c"
				}
#line 140 "DataObject.vala"
				key = (char*) gee_iterator_get (_key_it);
#line 141 "DataObject.vala"
				if (alteration_equal_values (key, subject)) {
#line 1513 "DataObject.c"
					result = TRUE;
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (keys);
#line 142 "DataObject.vala"
					return result;
#line 1520 "DataObject.c"
				}
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (keys);
#line 146 "DataObject.vala"
	return result;
#line 1531 "DataObject.c"
}


#line 149 "DataObject.vala"
gboolean alteration_has_detail (Alteration* self, const char* subject, const char* detail) {
#line 1537 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GeeCollection* values;
#line 149 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 149 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 149 "DataObject.vala"
	g_return_val_if_fail (detail != NULL, FALSE);
#line 150 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 150 "DataObject.vala"
		_tmp0_ = self->priv->detail != NULL;
#line 1551 "DataObject.c"
	} else {
#line 150 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1555 "DataObject.c"
	}
#line 150 "DataObject.vala"
	if (_tmp0_) {
#line 1559 "DataObject.c"
		gboolean _tmp1_ = FALSE;
#line 151 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, subject)) {
#line 151 "DataObject.vala"
			_tmp1_ = alteration_equal_values (self->priv->detail, detail);
#line 1565 "DataObject.c"
		} else {
#line 151 "DataObject.vala"
			_tmp1_ = FALSE;
#line 1569 "DataObject.c"
		}
		result = _tmp1_;
#line 151 "DataObject.vala"
		return result;
#line 1574 "DataObject.c"
	}
#line 153 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 154 "DataObject.vala"
	values = gee_multi_map_get (self->priv->map, subject);
#line 155 "DataObject.vala"
	if (values != NULL) {
#line 1582 "DataObject.c"
		{
			GeeIterator* _value_it;
#line 156 "DataObject.vala"
			_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 156 "DataObject.vala"
			while (TRUE) {
#line 1589 "DataObject.c"
				char* value;
#line 156 "DataObject.vala"
				if (!gee_iterator_next (_value_it)) {
#line 156 "DataObject.vala"
					break;
#line 1595 "DataObject.c"
				}
#line 156 "DataObject.vala"
				value = (char*) gee_iterator_get (_value_it);
#line 157 "DataObject.vala"
				if (alteration_equal_values (value, detail)) {
#line 1601 "DataObject.c"
					result = TRUE;
					_g_free0 (value);
					_g_object_unref0 (_value_it);
					_g_object_unref0 (values);
#line 158 "DataObject.vala"
					return result;
#line 1608 "DataObject.c"
				}
				_g_free0 (value);
			}
			_g_object_unref0 (_value_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (values);
#line 162 "DataObject.vala"
	return result;
#line 1619 "DataObject.c"
}


#line 165 "DataObject.vala"
GeeCollection* alteration_get_details (Alteration* self, const char* subject) {
#line 1625 "DataObject.c"
	GeeCollection* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeCollection* _tmp2_;
#line 165 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 165 "DataObject.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 166 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 166 "DataObject.vala"
		_tmp1_ = self->priv->detail != NULL;
#line 1638 "DataObject.c"
	} else {
#line 166 "DataObject.vala"
		_tmp1_ = FALSE;
#line 1642 "DataObject.c"
	}
#line 166 "DataObject.vala"
	if (_tmp1_) {
#line 166 "DataObject.vala"
		_tmp0_ = alteration_equal_values (self->priv->subject, subject);
#line 1648 "DataObject.c"
	} else {
#line 166 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1652 "DataObject.c"
	}
#line 166 "DataObject.vala"
	if (_tmp0_) {
#line 1656 "DataObject.c"
		GeeArrayList* details;
#line 167 "DataObject.vala"
		details = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 168 "DataObject.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (details), self->priv->detail);
#line 1662 "DataObject.c"
		result = GEE_COLLECTION (details);
#line 170 "DataObject.vala"
		return result;
#line 1666 "DataObject.c"
	}
	_tmp2_ = NULL;
#line 173 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 1671 "DataObject.c"
		GeeCollection* _tmp3_;
#line 173 "DataObject.vala"
		_tmp2_ = (_tmp3_ = gee_multi_map_get (self->priv->map, subject), _g_object_unref0 (_tmp2_), _tmp3_);
#line 1675 "DataObject.c"
	} else {
		GeeCollection* _tmp4_;
#line 173 "DataObject.vala"
		_tmp2_ = (_tmp4_ = NULL, _g_object_unref0 (_tmp2_), _tmp4_);
#line 1680 "DataObject.c"
	}
	result = _tmp2_;
#line 173 "DataObject.vala"
	return result;
#line 1685 "DataObject.c"
}


#line 176 "DataObject.vala"
char* alteration_to_string (Alteration* self) {
#line 1691 "DataObject.c"
	char* result = NULL;
	char* str;
#line 176 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 177 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 178 "DataObject.vala"
		g_assert (self->priv->detail != NULL);
#line 1700 "DataObject.c"
		result = g_strdup_printf ("%s:%s", self->priv->subject, self->priv->detail);
#line 180 "DataObject.vala"
		return result;
#line 1704 "DataObject.c"
	}
#line 183 "DataObject.vala"
	g_assert (self->priv->map != NULL);
#line 185 "DataObject.vala"
	str = g_strdup ("");
#line 1710 "DataObject.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
#line 186 "DataObject.vala"
		_key_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_multi_map_get_keys (self->priv->map))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 186 "DataObject.vala"
		while (TRUE) {
#line 1719 "DataObject.c"
			char* key;
#line 186 "DataObject.vala"
			if (!gee_iterator_next (_key_it)) {
#line 186 "DataObject.vala"
				break;
#line 1725 "DataObject.c"
			}
#line 186 "DataObject.vala"
			key = (char*) gee_iterator_get (_key_it);
#line 1729 "DataObject.c"
			{
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _value_it;
#line 187 "DataObject.vala"
				_value_it = (_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_ = gee_multi_map_get (self->priv->map, key))), _g_object_unref0 (_tmp2_), _tmp3_);
#line 187 "DataObject.vala"
				while (TRUE) {
#line 1738 "DataObject.c"
					char* value;
					char* _tmp5_;
					char* _tmp6_;
#line 187 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 187 "DataObject.vala"
						break;
#line 1746 "DataObject.c"
					}
#line 187 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 188 "DataObject.vala"
					if (string_get_length (str) != 0) {
#line 1752 "DataObject.c"
						char* _tmp4_;
#line 189 "DataObject.vala"
						str = (_tmp4_ = g_strconcat (str, ", ", NULL), _g_free0 (str), _tmp4_);
#line 1756 "DataObject.c"
					}
#line 191 "DataObject.vala"
					str = (_tmp6_ = g_strconcat (str, _tmp5_ = g_strdup_printf ("%s:%s", key, value), NULL), _g_free0 (str), _tmp6_);
#line 1760 "DataObject.c"
					_g_free0 (_tmp5_);
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	result = str;
#line 195 "DataObject.vala"
	return result;
#line 1773 "DataObject.c"
}


#line 199 "DataObject.vala"
gboolean alteration_contains_any (Alteration* self, Alteration* other) {
#line 1779 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp12_ = FALSE;
#line 199 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 199 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 201 "DataObject.vala"
	if (self == other) {
#line 1793 "DataObject.c"
		result = TRUE;
#line 202 "DataObject.vala"
		return result;
#line 1797 "DataObject.c"
	}
#line 205 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 205 "DataObject.vala"
		_tmp2_ = other->priv->subject != NULL;
#line 1803 "DataObject.c"
	} else {
#line 205 "DataObject.vala"
		_tmp2_ = FALSE;
#line 1807 "DataObject.c"
	}
#line 205 "DataObject.vala"
	if (_tmp2_) {
#line 205 "DataObject.vala"
		_tmp1_ = self->priv->detail != NULL;
#line 1813 "DataObject.c"
	} else {
#line 205 "DataObject.vala"
		_tmp1_ = FALSE;
#line 1817 "DataObject.c"
	}
#line 205 "DataObject.vala"
	if (_tmp1_) {
#line 205 "DataObject.vala"
		_tmp0_ = other->priv->detail != NULL;
#line 1823 "DataObject.c"
	} else {
#line 205 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1827 "DataObject.c"
	}
#line 205 "DataObject.vala"
	if (_tmp0_) {
#line 1831 "DataObject.c"
		gboolean _tmp3_ = FALSE;
#line 206 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, other->priv->subject)) {
#line 206 "DataObject.vala"
			_tmp3_ = alteration_equal_values (self->priv->detail, other->priv->detail);
#line 1837 "DataObject.c"
		} else {
#line 206 "DataObject.vala"
			_tmp3_ = FALSE;
#line 1841 "DataObject.c"
		}
		result = _tmp3_;
#line 206 "DataObject.vala"
		return result;
#line 1846 "DataObject.c"
	}
#line 209 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 209 "DataObject.vala"
		_tmp5_ = other->priv->map == NULL;
#line 1852 "DataObject.c"
	} else {
#line 209 "DataObject.vala"
		_tmp5_ = FALSE;
#line 1856 "DataObject.c"
	}
#line 209 "DataObject.vala"
	if (_tmp5_) {
#line 209 "DataObject.vala"
		_tmp4_ = TRUE;
#line 1862 "DataObject.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 209 "DataObject.vala"
		if (self->priv->map == NULL) {
#line 209 "DataObject.vala"
			_tmp6_ = other->priv->map != NULL;
#line 1869 "DataObject.c"
		} else {
#line 209 "DataObject.vala"
			_tmp6_ = FALSE;
#line 1873 "DataObject.c"
		}
#line 209 "DataObject.vala"
		_tmp4_ = _tmp6_;
#line 1877 "DataObject.c"
	}
#line 209 "DataObject.vala"
	if (_tmp4_) {
#line 1881 "DataObject.c"
		const char* _tmp7_;
		char* single_subject;
		const char* _tmp8_;
		char* single_detail;
		GeeMultiMap* _tmp9_;
		GeeMultiMap* multimap;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = NULL;
#line 210 "DataObject.vala"
		if (self->priv->subject != NULL) {
#line 210 "DataObject.vala"
			_tmp7_ = self->priv->subject;
#line 1894 "DataObject.c"
		} else {
#line 210 "DataObject.vala"
			_tmp7_ = other->priv->subject;
#line 1898 "DataObject.c"
		}
#line 210 "DataObject.vala"
		single_subject = g_strdup (_tmp7_);
#line 1902 "DataObject.c"
		_tmp8_ = NULL;
#line 211 "DataObject.vala"
		if (self->priv->detail != NULL) {
#line 211 "DataObject.vala"
			_tmp8_ = self->priv->detail;
#line 1908 "DataObject.c"
		} else {
#line 211 "DataObject.vala"
			_tmp8_ = other->priv->detail;
#line 1912 "DataObject.c"
		}
#line 211 "DataObject.vala"
		single_detail = g_strdup (_tmp8_);
#line 1916 "DataObject.c"
		_tmp9_ = NULL;
#line 212 "DataObject.vala"
		if (self->priv->map != NULL) {
#line 212 "DataObject.vala"
			_tmp9_ = self->priv->map;
#line 1922 "DataObject.c"
		} else {
#line 212 "DataObject.vala"
			_tmp9_ = other->priv->map;
#line 1926 "DataObject.c"
		}
#line 212 "DataObject.vala"
		multimap = _g_object_ref0 (_tmp9_);
#line 214 "DataObject.vala"
		if (gee_multi_map_contains (multimap, single_subject)) {
#line 1932 "DataObject.c"
			GeeCollection* _tmp11_;
#line 214 "DataObject.vala"
			_tmp10_ = gee_collection_contains (_tmp11_ = gee_multi_map_get (self->priv->map, single_subject), single_detail);
#line 1936 "DataObject.c"
			_g_object_unref0 (_tmp11_);
		} else {
#line 214 "DataObject.vala"
			_tmp10_ = FALSE;
#line 1941 "DataObject.c"
		}
		result = _tmp10_;
		_g_object_unref0 (multimap);
		_g_free0 (single_detail);
		_g_free0 (single_subject);
#line 214 "DataObject.vala"
		return result;
#line 1949 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 218 "DataObject.vala"
		_tmp12_ = other->priv->map != NULL;
#line 1955 "DataObject.c"
	} else {
#line 218 "DataObject.vala"
		_tmp12_ = FALSE;
#line 1959 "DataObject.c"
	}
#line 218 "DataObject.vala"
	if (_tmp12_) {
#line 1963 "DataObject.c"
		GeeSet* keys;
		GeeSet* other_keys;
#line 219 "DataObject.vala"
		keys = gee_multi_map_get_keys (self->priv->map);
#line 220 "DataObject.vala"
		g_assert (keys != NULL);
#line 221 "DataObject.vala"
		other_keys = gee_multi_map_get_keys (other->priv->map);
#line 222 "DataObject.vala"
		g_assert (other_keys != NULL);
#line 1974 "DataObject.c"
		{
			GeeIterator* _subject_it;
#line 224 "DataObject.vala"
			_subject_it = gee_iterable_iterator (GEE_ITERABLE (other_keys));
#line 224 "DataObject.vala"
			while (TRUE) {
#line 1981 "DataObject.c"
				char* subject;
				GeeCollection* details;
				GeeCollection* other_details;
				gboolean _tmp13_ = FALSE;
#line 224 "DataObject.vala"
				if (!gee_iterator_next (_subject_it)) {
#line 224 "DataObject.vala"
					break;
#line 1990 "DataObject.c"
				}
#line 224 "DataObject.vala"
				subject = (char*) gee_iterator_get (_subject_it);
#line 225 "DataObject.vala"
				if (!gee_collection_contains (GEE_COLLECTION (keys), subject)) {
#line 1996 "DataObject.c"
					_g_free0 (subject);
#line 226 "DataObject.vala"
					continue;
#line 2000 "DataObject.c"
				}
#line 228 "DataObject.vala"
				details = gee_multi_map_get (self->priv->map, subject);
#line 229 "DataObject.vala"
				other_details = gee_multi_map_get (other->priv->map, subject);
#line 231 "DataObject.vala"
				if (details != NULL) {
#line 231 "DataObject.vala"
					_tmp13_ = other_details != NULL;
#line 2010 "DataObject.c"
				} else {
#line 231 "DataObject.vala"
					_tmp13_ = FALSE;
#line 2014 "DataObject.c"
				}
#line 231 "DataObject.vala"
				if (_tmp13_) {
#line 2018 "DataObject.c"
					{
						GeeIterator* _detail_it;
#line 232 "DataObject.vala"
						_detail_it = gee_iterable_iterator (GEE_ITERABLE (other_details));
#line 232 "DataObject.vala"
						while (TRUE) {
#line 2025 "DataObject.c"
							char* detail;
#line 232 "DataObject.vala"
							if (!gee_iterator_next (_detail_it)) {
#line 232 "DataObject.vala"
								break;
#line 2031 "DataObject.c"
							}
#line 232 "DataObject.vala"
							detail = (char*) gee_iterator_get (_detail_it);
#line 233 "DataObject.vala"
							if (gee_collection_contains (details, detail)) {
#line 2037 "DataObject.c"
								result = TRUE;
								_g_free0 (detail);
								_g_object_unref0 (_detail_it);
								_g_object_unref0 (other_details);
								_g_object_unref0 (details);
								_g_free0 (subject);
								_g_object_unref0 (_subject_it);
								_g_object_unref0 (other_keys);
								_g_object_unref0 (keys);
#line 234 "DataObject.vala"
								return result;
#line 2049 "DataObject.c"
							}
							_g_free0 (detail);
						}
						_g_object_unref0 (_detail_it);
					}
				}
				_g_object_unref0 (other_details);
				_g_object_unref0 (details);
				_g_free0 (subject);
			}
			_g_object_unref0 (_subject_it);
		}
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
	}
	result = FALSE;
#line 240 "DataObject.vala"
	return result;
#line 2068 "DataObject.c"
}


#line 243 "DataObject.vala"
gboolean alteration_equals (Alteration* self, Alteration* other) {
#line 2074 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 243 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
#line 243 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
#line 245 "DataObject.vala"
	if (self == other) {
#line 2086 "DataObject.c"
		result = TRUE;
#line 246 "DataObject.vala"
		return result;
#line 2090 "DataObject.c"
	}
#line 249 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 249 "DataObject.vala"
		_tmp2_ = other->priv->subject != NULL;
#line 2096 "DataObject.c"
	} else {
#line 249 "DataObject.vala"
		_tmp2_ = FALSE;
#line 2100 "DataObject.c"
	}
#line 249 "DataObject.vala"
	if (_tmp2_) {
#line 249 "DataObject.vala"
		_tmp1_ = self->priv->detail != NULL;
#line 2106 "DataObject.c"
	} else {
#line 249 "DataObject.vala"
		_tmp1_ = FALSE;
#line 2110 "DataObject.c"
	}
#line 249 "DataObject.vala"
	if (_tmp1_) {
#line 249 "DataObject.vala"
		_tmp0_ = other->priv->detail != NULL;
#line 2116 "DataObject.c"
	} else {
#line 249 "DataObject.vala"
		_tmp0_ = FALSE;
#line 2120 "DataObject.c"
	}
#line 249 "DataObject.vala"
	if (_tmp0_) {
#line 2124 "DataObject.c"
		gboolean _tmp3_ = FALSE;
#line 250 "DataObject.vala"
		if (alteration_equal_values (self->priv->subject, other->priv->subject)) {
#line 250 "DataObject.vala"
			_tmp3_ = alteration_equal_values (self->priv->detail, other->priv->detail);
#line 2130 "DataObject.c"
		} else {
#line 250 "DataObject.vala"
			_tmp3_ = FALSE;
#line 2134 "DataObject.c"
		}
		result = _tmp3_;
#line 250 "DataObject.vala"
		return result;
#line 2139 "DataObject.c"
	}
#line 253 "DataObject.vala"
	if (self->priv->map != NULL) {
#line 253 "DataObject.vala"
		_tmp4_ = other->priv->map != NULL;
#line 2145 "DataObject.c"
	} else {
#line 253 "DataObject.vala"
		_tmp4_ = FALSE;
#line 2149 "DataObject.c"
	}
#line 253 "DataObject.vala"
	if (_tmp4_) {
#line 2153 "DataObject.c"
		GeeSet* keys;
		GeeSet* other_keys;
#line 255 "DataObject.vala"
		keys = gee_multi_map_get_keys (self->priv->map);
#line 256 "DataObject.vala"
		g_assert (keys != NULL);
#line 257 "DataObject.vala"
		other_keys = gee_multi_map_get_keys (other->priv->map);
#line 258 "DataObject.vala"
		g_assert (other_keys != NULL);
#line 260 "DataObject.vala"
		if (gee_collection_get_size (GEE_COLLECTION (keys)) != gee_collection_get_size (GEE_COLLECTION (other_keys))) {
#line 2166 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 261 "DataObject.vala"
			return result;
#line 2172 "DataObject.c"
		}
#line 263 "DataObject.vala"
		if (!gee_collection_contains_all (GEE_COLLECTION (keys), GEE_COLLECTION (other_keys))) {
#line 2176 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 264 "DataObject.vala"
			return result;
#line 2182 "DataObject.c"
		}
#line 266 "DataObject.vala"
		if (!gee_collection_contains_all (GEE_COLLECTION (other_keys), GEE_COLLECTION (keys))) {
#line 2186 "DataObject.c"
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
#line 267 "DataObject.vala"
			return result;
#line 2192 "DataObject.c"
		}
		{
			GeeIterator* _key_it;
#line 269 "DataObject.vala"
			_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 269 "DataObject.vala"
			while (TRUE) {
#line 2200 "DataObject.c"
				char* key;
				GeeCollection* values;
				GeeCollection* other_values;
#line 269 "DataObject.vala"
				if (!gee_iterator_next (_key_it)) {
#line 269 "DataObject.vala"
					break;
#line 2208 "DataObject.c"
				}
#line 269 "DataObject.vala"
				key = (char*) gee_iterator_get (_key_it);
#line 270 "DataObject.vala"
				values = gee_multi_map_get (self->priv->map, key);
#line 271 "DataObject.vala"
				other_values = gee_multi_map_get (other->priv->map, key);
#line 273 "DataObject.vala"
				if (gee_collection_get_size (values) != gee_collection_get_size (other_values)) {
#line 2218 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 274 "DataObject.vala"
					return result;
#line 2228 "DataObject.c"
				}
#line 276 "DataObject.vala"
				if (!gee_collection_contains_all (values, other_values)) {
#line 2232 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 277 "DataObject.vala"
					return result;
#line 2242 "DataObject.c"
				}
#line 279 "DataObject.vala"
				if (!gee_collection_contains_all (other_values, values)) {
#line 2246 "DataObject.c"
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
#line 280 "DataObject.vala"
					return result;
#line 2256 "DataObject.c"
				}
				_g_object_unref0 (other_values);
				_g_object_unref0 (values);
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
		result = TRUE;
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
#line 284 "DataObject.vala"
		return result;
#line 2269 "DataObject.c"
	}
	result = FALSE;
#line 288 "DataObject.vala"
	return result;
#line 2274 "DataObject.c"
}


#line 291 "DataObject.vala"
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src) {
#line 2280 "DataObject.c"
	GeeSet* keys;
#line 291 "DataObject.vala"
	g_return_if_fail (GEE_IS_MULTI_MAP (dest));
#line 291 "DataObject.vala"
	g_return_if_fail (GEE_IS_MULTI_MAP (src));
#line 293 "DataObject.vala"
	keys = gee_multi_map_get_keys (src);
#line 2288 "DataObject.c"
	{
		GeeIterator* _key_it;
#line 294 "DataObject.vala"
		_key_it = gee_iterable_iterator (GEE_ITERABLE (keys));
#line 294 "DataObject.vala"
		while (TRUE) {
#line 2295 "DataObject.c"
			char* key;
			GeeCollection* values;
#line 294 "DataObject.vala"
			if (!gee_iterator_next (_key_it)) {
#line 294 "DataObject.vala"
				break;
#line 2302 "DataObject.c"
			}
#line 294 "DataObject.vala"
			key = (char*) gee_iterator_get (_key_it);
#line 295 "DataObject.vala"
			values = gee_multi_map_get (src, key);
#line 2308 "DataObject.c"
			{
				GeeIterator* _value_it;
#line 296 "DataObject.vala"
				_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 296 "DataObject.vala"
				while (TRUE) {
#line 2315 "DataObject.c"
					char* value;
#line 296 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 296 "DataObject.vala"
						break;
#line 2321 "DataObject.c"
					}
#line 296 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 297 "DataObject.vala"
					gee_multi_map_set (dest, key, value);
#line 2327 "DataObject.c"
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_object_unref0 (values);
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	_g_object_unref0 (keys);
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


#line 303 "DataObject.vala"
Alteration* alteration_compress (Alteration* self, Alteration* other) {
#line 2348 "DataObject.c"
	Alteration* result = NULL;
	GeeMultiMap* compressed;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 303 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
#line 303 "DataObject.vala"
	g_return_val_if_fail (IS_ALTERATION (other), NULL);
#line 304 "DataObject.vala"
	if (alteration_equals (self, other)) {
#line 2359 "DataObject.c"
		result = _alteration_ref0 (self);
#line 305 "DataObject.vala"
		return result;
#line 2363 "DataObject.c"
	}
#line 309 "DataObject.vala"
	compressed = alteration_create_map (self);
#line 311 "DataObject.vala"
	if (self->priv->subject != NULL) {
#line 311 "DataObject.vala"
		_tmp0_ = self->priv->detail != NULL;
#line 2371 "DataObject.c"
	} else {
#line 311 "DataObject.vala"
		_tmp0_ = FALSE;
#line 2375 "DataObject.c"
	}
#line 311 "DataObject.vala"
	if (_tmp0_) {
#line 312 "DataObject.vala"
		gee_multi_map_set (compressed, self->priv->subject, self->priv->detail);
#line 2381 "DataObject.c"
	} else {
#line 314 "DataObject.vala"
		g_assert (self->priv->map != NULL);
#line 315 "DataObject.vala"
		alteration_multimap_add_all (compressed, self->priv->map);
#line 2387 "DataObject.c"
	}
#line 318 "DataObject.vala"
	if (other->priv->subject != NULL) {
#line 318 "DataObject.vala"
		_tmp1_ = other->priv->detail != NULL;
#line 2393 "DataObject.c"
	} else {
#line 318 "DataObject.vala"
		_tmp1_ = FALSE;
#line 2397 "DataObject.c"
	}
#line 318 "DataObject.vala"
	if (_tmp1_) {
#line 319 "DataObject.vala"
		gee_multi_map_set (compressed, other->priv->subject, other->priv->detail);
#line 2403 "DataObject.c"
	} else {
#line 321 "DataObject.vala"
		g_assert (other->priv->map != NULL);
#line 322 "DataObject.vala"
		alteration_multimap_add_all (compressed, other->priv->map);
#line 2409 "DataObject.c"
	}
	result = alteration_new_from_map (compressed);
	_g_object_unref0 (compressed);
#line 325 "DataObject.vala"
	return result;
#line 2415 "DataObject.c"
}


static void value_alteration_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_alteration_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		alteration_unref (value->data[0].v_pointer);
	}
}


static void value_alteration_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_alteration_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_alteration_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Alteration* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = alteration_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_alteration_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Alteration** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = alteration_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAlteration* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_alteration (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
	return value->data[0].v_pointer;
}


void value_set_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		alteration_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


void value_take_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


static void alteration_class_init (AlterationClass * klass) {
	alteration_parent_class = g_type_class_peek_parent (klass);
	ALTERATION_CLASS (klass)->finalize = alteration_finalize;
	g_type_class_add_private (klass, sizeof (AlterationPrivate));
}


static void alteration_instance_init (Alteration * self) {
	self->priv = ALTERATION_GET_PRIVATE (self);
	self->priv->subject = NULL;
	self->priv->detail = NULL;
	self->priv->map = NULL;
	self->ref_count = 1;
}


static void alteration_finalize (Alteration* obj) {
	Alteration * self;
	self = ALTERATION (obj);
	_g_free0 (self->priv->subject);
	_g_free0 (self->priv->detail);
	_g_object_unref0 (self->priv->map);
}


GType alteration_get_type (void) {
	static volatile gsize alteration_type_id__volatile = 0;
	if (g_once_init_enter (&alteration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType alteration_type_id;
		alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&alteration_type_id__volatile, alteration_type_id);
	}
	return alteration_type_id__volatile;
}


gpointer alteration_ref (gpointer instance) {
	Alteration* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void alteration_unref (gpointer instance) {
	Alteration* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ALTERATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 348 "DataObject.vala"
DataObject* data_object_construct (GType object_type, gint64 object_id) {
#line 2588 "DataObject.c"
	DataObject * self = NULL;
	gint64 _tmp0_ = 0LL;
#line 348 "DataObject.vala"
	self = (DataObject*) g_object_new (object_type, NULL);
#line 349 "DataObject.vala"
	if (object_id == DATA_OBJECT_INVALID_OBJECT_ID) {
#line 349 "DataObject.vala"
		_tmp0_ = data_object_object_id_generator++;
#line 2597 "DataObject.c"
	} else {
#line 349 "DataObject.vala"
		_tmp0_ = object_id;
#line 2601 "DataObject.c"
	}
#line 349 "DataObject.vala"
	self->priv->object_id = _tmp0_;
#line 2605 "DataObject.c"
	return self;
}


#line 352 "DataObject.vala"
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration) {
#line 352 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 352 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 353 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 354 "DataObject.vala"
		data_collection_internal_notify_altered (self->priv->member_of, self, alteration);
#line 2620 "DataObject.c"
	}
}


#line 348 "DataObject.vala"
void data_object_notify_altered (DataObject* self, Alteration* alteration) {
#line 348 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self, alteration);
#line 2629 "DataObject.c"
}


#line 366 "DataObject.vala"
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 366 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 366 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 2639 "DataObject.c"
}


#line 348 "DataObject.vala"
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 348 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
#line 2647 "DataObject.c"
}


#line 371 "DataObject.vala"
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 371 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 371 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 2657 "DataObject.c"
}


#line 348 "DataObject.vala"
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 348 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
#line 2665 "DataObject.c"
}


#line 376 "DataObject.vala"
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 376 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 376 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 2675 "DataObject.c"
}


#line 348 "DataObject.vala"
void data_object_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 348 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
#line 2683 "DataObject.c"
}


#line 379 "DataObject.vala"
static char* data_object_real_get_name (DataObject* self) {
#line 2689 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 348 "DataObject.vala"
char* data_object_get_name (DataObject* self) {
#line 348 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
#line 2700 "DataObject.c"
}


#line 381 "DataObject.vala"
static char* data_object_real_to_string (DataObject* self) {
#line 2706 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 348 "DataObject.vala"
char* data_object_to_string (DataObject* self) {
#line 348 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
#line 2717 "DataObject.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 383 "DataObject.vala"
DataCollection* data_object_get_membership (DataObject* self) {
#line 2728 "DataObject.c"
	DataCollection* result = NULL;
#line 383 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 2732 "DataObject.c"
	result = _data_collection_ref0 (self->priv->member_of);
#line 384 "DataObject.vala"
	return result;
#line 2736 "DataObject.c"
}


#line 387 "DataObject.vala"
gboolean data_object_has_membership (DataObject* self) {
#line 2742 "DataObject.c"
	gboolean result = FALSE;
#line 387 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), FALSE);
#line 2746 "DataObject.c"
	result = self->priv->member_of != NULL;
#line 388 "DataObject.vala"
	return result;
#line 2750 "DataObject.c"
}


#line 393 "DataObject.vala"
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
#line 2756 "DataObject.c"
	DataCollection* _tmp0_;
#line 393 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 393 "DataObject.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 394 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 396 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = _data_collection_ref0 (collection), _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 397 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 2768 "DataObject.c"
}


#line 406 "DataObject.vala"
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal) {
#line 406 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 407 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 409 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 2780 "DataObject.c"
}


#line 414 "DataObject.vala"
void data_object_internal_clear_membership (DataObject* self) {
#line 2786 "DataObject.c"
	DataCollection* _tmp0_;
#line 414 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 415 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = NULL, _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 416 "DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 2794 "DataObject.c"
}


#line 420 "DataObject.vala"
inline gint64 data_object_internal_get_ordinal (DataObject* self) {
#line 2800 "DataObject.c"
	gint64 result = 0LL;
#line 420 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 2804 "DataObject.c"
	result = self->priv->ordinal;
#line 421 "DataObject.vala"
	return result;
#line 2808 "DataObject.c"
}


#line 424 "DataObject.vala"
inline gint64 data_object_get_object_id (DataObject* self) {
#line 2814 "DataObject.c"
	gint64 result = 0LL;
#line 424 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 2818 "DataObject.c"
	result = self->priv->object_id;
#line 425 "DataObject.vala"
	return result;
#line 2822 "DataObject.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


#line 428 "DataObject.vala"
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def) {
#line 2844 "DataObject.c"
	GValue* result = NULL;
	GValue* _result_;
	GValue* _tmp0_ = NULL;
#line 428 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 428 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 429 "DataObject.vala"
	if (self->priv->member_of == NULL) {
#line 2854 "DataObject.c"
		result = __g_value_dup0 (def);
#line 430 "DataObject.vala"
		return result;
#line 2858 "DataObject.c"
	}
#line 432 "DataObject.vala"
	_result_ = data_collection_get_property (self->priv->member_of, name);
#line 434 "DataObject.vala"
	if (_result_ != NULL) {
#line 434 "DataObject.vala"
		_tmp0_ = _result_;
#line 2866 "DataObject.c"
	} else {
#line 434 "DataObject.vala"
		_tmp0_ = def;
#line 2870 "DataObject.c"
	}
	result = __g_value_dup0 (_tmp0_);
	__vala_GValue_free0 (_result_);
#line 434 "DataObject.vala"
	return result;
#line 2876 "DataObject.c"
}


#line 437 "DataObject.vala"
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 437 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 437 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 438 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 439 "DataObject.vala"
		data_collection_set_property (self->priv->member_of, name, val, value_equals, value_equals_target);
#line 2890 "DataObject.c"
	}
}


#line 442 "DataObject.vala"
void data_object_clear_collection_property (DataObject* self, const char* name) {
#line 442 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 442 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 443 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 444 "DataObject.vala"
		data_collection_clear_property (self->priv->member_of, name);
#line 2905 "DataObject.c"
	}
}


static void data_object_class_init (DataObjectClass * klass) {
	data_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_object_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_object_real_notify_membership_changed;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_set = data_object_real_notify_collection_property_set;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_cleared = data_object_real_notify_collection_property_cleared;
	DATA_OBJECT_CLASS (klass)->get_name = data_object_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_object_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
}


static void data_object_instance_init (DataObject * self) {
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
}


static void data_object_finalize (GObject* obj) {
	DataObject * self;
	self = DATA_OBJECT (obj);
	_data_collection_unref0 (self->priv->member_of);
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}


#line 487 "DataObject.vala"
static void source_snapshot_real_notify_broken (SourceSnapshot* self) {
#line 487 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 488 "DataObject.vala"
	self->priv->snapshot_broken = TRUE;
#line 490 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 2959 "DataObject.c"
}


#line 348 "DataObject.vala"
void source_snapshot_notify_broken (SourceSnapshot* self) {
#line 348 "DataObject.vala"
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
#line 2967 "DataObject.c"
}


#line 493 "DataObject.vala"
gboolean source_snapshot_is_broken (SourceSnapshot* self) {
#line 2973 "DataObject.c"
	gboolean result = FALSE;
#line 493 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_SNAPSHOT (self), FALSE);
#line 2977 "DataObject.c"
	result = self->priv->snapshot_broken;
#line 494 "DataObject.vala"
	return result;
#line 2981 "DataObject.c"
}


#line 479 "DataObject.vala"
SourceSnapshot* source_snapshot_construct (GType object_type) {
#line 2987 "DataObject.c"
	SourceSnapshot* self = (SourceSnapshot*) g_type_create_instance (object_type);
	return self;
}


#line 484 "DataObject.vala"
static void source_snapshot_real_broken (SourceSnapshot* self) {
#line 484 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 2997 "DataObject.c"
}


static void value_source_snapshot_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_snapshot_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_snapshot_unref (value->data[0].v_pointer);
	}
}


static void value_source_snapshot_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_snapshot_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_snapshot_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceSnapshot* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_snapshot_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_snapshot_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceSnapshot** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceSnapshot* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_snapshot (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_snapshot_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


void value_take_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


static void source_snapshot_class_init (SourceSnapshotClass * klass) {
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
	SOURCE_SNAPSHOT_CLASS (klass)->finalize = source_snapshot_finalize;
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
	SOURCE_SNAPSHOT_CLASS (klass)->notify_broken = source_snapshot_real_notify_broken;
	SOURCE_SNAPSHOT_CLASS (klass)->broken = source_snapshot_real_broken;
	g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_snapshot_instance_init (SourceSnapshot * self) {
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
	self->priv->snapshot_broken = FALSE;
	self->ref_count = 1;
}


static void source_snapshot_finalize (SourceSnapshot* obj) {
	SourceSnapshot * self;
	self = SOURCE_SNAPSHOT (obj);
}


GType source_snapshot_get_type (void) {
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer source_snapshot_ref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_snapshot_unref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 531 "DataObject.vala"
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value) {
#line 3168 "DataObject.c"
	SourceBacklink* self = (SourceBacklink*) g_type_create_instance (object_type);
	char* _tmp0_;
	char* _tmp1_;
#line 531 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 531 "DataObject.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 532 "DataObject.vala"
	g_assert (source_backlink_validate_name_value (name, value));
#line 534 "DataObject.vala"
	self->priv->_name = (_tmp0_ = string_strip (name), _g_free0 (self->priv->_name), _tmp0_);
#line 535 "DataObject.vala"
	self->priv->_value = (_tmp1_ = string_strip (value), _g_free0 (self->priv->_value), _tmp1_);
#line 3182 "DataObject.c"
	return self;
}


#line 531 "DataObject.vala"
SourceBacklink* source_backlink_new (const char* name, const char* value) {
#line 531 "DataObject.vala"
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
#line 3191 "DataObject.c"
}


#line 538 "DataObject.vala"
SourceBacklink* source_backlink_construct_from_source (GType object_type, DataSource* source) {
#line 3197 "DataObject.c"
	SourceBacklink* self = (SourceBacklink*) g_type_create_instance (object_type);
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 538 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 539 "DataObject.vala"
	self->priv->_name = (_tmp1_ = string_strip (_tmp0_ = data_source_get_typename (source)), _g_free0 (self->priv->_name), _tmp1_);
#line 3207 "DataObject.c"
	_g_free0 (_tmp0_);
#line 540 "DataObject.vala"
	self->priv->_value = (_tmp3_ = string_strip (_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, data_source_get_instance_id (source))), _g_free0 (self->priv->_value), _tmp3_);
#line 3211 "DataObject.c"
	_g_free0 (_tmp2_);
#line 542 "DataObject.vala"
	g_assert (source_backlink_validate_name_value (self->priv->_name, self->priv->_value));
#line 3215 "DataObject.c"
	return self;
}


#line 538 "DataObject.vala"
SourceBacklink* source_backlink_new_from_source (DataSource* source) {
#line 538 "DataObject.vala"
	return source_backlink_construct_from_source (TYPE_SOURCE_BACKLINK, source);
#line 3224 "DataObject.c"
}


#line 1177 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 3230 "DataObject.c"
	gboolean result = FALSE;
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 3236 "DataObject.c"
	result = strstr (self, needle) != NULL;
#line 1178 "glib-2.0.vapi"
	return result;
#line 3240 "DataObject.c"
}


#line 545 "DataObject.vala"
static gboolean source_backlink_validate_name_value (const char* name, const char* value) {
#line 3246 "DataObject.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 545 "DataObject.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 545 "DataObject.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 546 "DataObject.vala"
	if (!string_contains (name, "=")) {
#line 546 "DataObject.vala"
		_tmp1_ = !string_contains (name, "|");
#line 3258 "DataObject.c"
	} else {
#line 546 "DataObject.vala"
		_tmp1_ = FALSE;
#line 3262 "DataObject.c"
	}
#line 546 "DataObject.vala"
	if (_tmp1_) {
#line 546 "DataObject.vala"
		_tmp0_ = !string_contains (value, "|");
#line 3268 "DataObject.c"
	} else {
#line 546 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3272 "DataObject.c"
	}
	result = _tmp0_;
#line 546 "DataObject.vala"
	return result;
#line 3277 "DataObject.c"
}


#line 549 "DataObject.vala"
char* source_backlink_to_string (SourceBacklink* self) {
#line 3283 "DataObject.c"
	char* result = NULL;
#line 549 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
#line 3287 "DataObject.c"
	result = g_strdup_printf ("Backlink %s=%s", source_backlink_get_name (self), source_backlink_get_value (self));
#line 550 "DataObject.vala"
	return result;
#line 3291 "DataObject.c"
}


#line 553 "DataObject.vala"
guint source_backlink_hash_func (void* key) {
#line 3297 "DataObject.c"
	guint result = 0U;
	SourceBacklink* backlink;
#line 554 "DataObject.vala"
	backlink = (SourceBacklink*) key;
#line 3302 "DataObject.c"
	result = g_str_hash (SOURCE_BACKLINK (backlink)->priv->_name) ^ g_str_hash (SOURCE_BACKLINK (backlink)->priv->_value);
#line 556 "DataObject.vala"
	return result;
#line 3306 "DataObject.c"
}


#line 559 "DataObject.vala"
gboolean source_backlink_equal_func (void* a, void* b) {
#line 3312 "DataObject.c"
	gboolean result = FALSE;
	SourceBacklink* alink;
	SourceBacklink* blink;
	gboolean _tmp0_ = FALSE;
#line 560 "DataObject.vala"
	alink = (SourceBacklink*) a;
#line 561 "DataObject.vala"
	blink = (SourceBacklink*) b;
#line 563 "DataObject.vala"
	if (g_str_equal (SOURCE_BACKLINK (alink)->priv->_name, SOURCE_BACKLINK (blink)->priv->_name)) {
#line 563 "DataObject.vala"
		_tmp0_ = g_str_equal (SOURCE_BACKLINK (alink)->priv->_value, SOURCE_BACKLINK (blink)->priv->_value);
#line 3325 "DataObject.c"
	} else {
#line 563 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3329 "DataObject.c"
	}
	result = _tmp0_;
#line 563 "DataObject.vala"
	return result;
#line 3334 "DataObject.c"
}


const char* source_backlink_get_name (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
#line 507 "DataObject.vala"
	return result;
#line 3344 "DataObject.c"
}


const char* source_backlink_get_value (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_value;
#line 513 "DataObject.vala"
	return result;
#line 3354 "DataObject.c"
}


const char* source_backlink_get_typename (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
#line 520 "DataObject.vala"
	return result;
#line 3364 "DataObject.c"
}


gint64 source_backlink_get_instance_id (SourceBacklink* self) {
	gint64 result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), 0LL);
	result = g_ascii_strtoll (self->priv->_value, NULL, 0);
#line 527 "DataObject.vala"
	return result;
#line 3374 "DataObject.c"
}


static void value_source_backlink_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_backlink_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_backlink_unref (value->data[0].v_pointer);
	}
}


static void value_source_backlink_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_backlink_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_backlink_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceBacklink* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_backlink_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_backlink_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceBacklink** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_backlink_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceBacklink* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_backlink (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_backlink_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


void value_take_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


static void source_backlink_class_init (SourceBacklinkClass * klass) {
	source_backlink_parent_class = g_type_class_peek_parent (klass);
	SOURCE_BACKLINK_CLASS (klass)->finalize = source_backlink_finalize;
	g_type_class_add_private (klass, sizeof (SourceBacklinkPrivate));
}


static void source_backlink_instance_init (SourceBacklink * self) {
	self->priv = SOURCE_BACKLINK_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_backlink_finalize (SourceBacklink* obj) {
	SourceBacklink * self;
	self = SOURCE_BACKLINK (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_value);
}


GType source_backlink_get_type (void) {
	static volatile gsize source_backlink_type_id__volatile = 0;
	if (g_once_init_enter (&source_backlink_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_backlink_type_id;
		source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_backlink_type_id__volatile, source_backlink_type_id);
	}
	return source_backlink_type_id__volatile;
}


gpointer source_backlink_ref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_backlink_unref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 592 "DataObject.vala"
DataSource* data_source_construct (GType object_type, gint64 object_id) {
#line 3543 "DataObject.c"
	DataSource * self = NULL;
#line 593 "DataObject.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 3547 "DataObject.c"
	return self;
}


#line 602 "DataObject.vala"
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection) {
#line 3554 "DataObject.c"
	DataSource * self;
	gboolean _tmp0_ = FALSE;
	self = DATA_SOURCE (base);
#line 602 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 604 "DataObject.vala"
	if (collection == NULL) {
#line 605 "DataObject.vala"
		g_assert (self->priv->is_destroyed || (self->priv->backlinks != NULL));
#line 3564 "DataObject.c"
	} else {
#line 607 "DataObject.vala"
		g_assert (!self->priv->is_destroyed);
#line 3568 "DataObject.c"
	}
#line 611 "DataObject.vala"
	if (collection == NULL) {
#line 611 "DataObject.vala"
		_tmp0_ = self->priv->backlinks != NULL;
#line 3574 "DataObject.c"
	} else {
#line 611 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3578 "DataObject.c"
	}
#line 611 "DataObject.vala"
	if (_tmp0_) {
#line 612 "DataObject.vala"
		data_source_notify_unlinked (self);
#line 3584 "DataObject.c"
	}
#line 614 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (DATA_OBJECT (self), collection);
#line 3588 "DataObject.c"
}


static gpointer _source_holding_tank_ref0 (gpointer self) {
	return self ? source_holding_tank_ref (self) : NULL;
}


#line 617 "DataObject.vala"
static void data_source_real_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank) {
#line 3599 "DataObject.c"
	DataCollection* _tmp0_;
	SourceHoldingTank* _tmp1_;
#line 617 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 617 "DataObject.vala"
	g_return_if_fail ((holding_tank == NULL) || IS_SOURCE_HOLDING_TANK (holding_tank));
#line 619 "DataObject.vala"
	g_assert ((_tmp0_ = data_object_get_membership (DATA_OBJECT (self))) == NULL);
#line 3608 "DataObject.c"
	_data_collection_unref0 (_tmp0_);
#line 623 "DataObject.vala"
	if (holding_tank != NULL) {
#line 624 "DataObject.vala"
		g_assert (self->priv->holding_tank == NULL);
#line 3614 "DataObject.c"
	} else {
#line 626 "DataObject.vala"
		g_assert (self->priv->holding_tank != NULL);
#line 3618 "DataObject.c"
	}
#line 629 "DataObject.vala"
	self->priv->holding_tank = (_tmp1_ = _source_holding_tank_ref0 (holding_tank), _source_holding_tank_unref0 (self->priv->holding_tank), _tmp1_);
#line 3622 "DataObject.c"
}


#line 592 "DataObject.vala"
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_held_in_tank (self, holding_tank);
#line 3630 "DataObject.c"
}


#line 632 "DataObject.vala"
static void data_source_real_notify_altered (DataObject* base, Alteration* alteration) {
#line 3636 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 632 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 634 "DataObject.vala"
	if (self->priv->holding_tank != NULL) {
#line 635 "DataObject.vala"
		source_holding_tank_internal_notify_altered (self->priv->holding_tank, self, alteration);
#line 3645 "DataObject.c"
	} else {
#line 637 "DataObject.vala"
		data_source_contact_subscribers_alteration (self, alteration);
#line 639 "DataObject.vala"
		DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (DATA_OBJECT (self), alteration);
#line 3651 "DataObject.c"
	}
}


#line 664 "DataObject.vala"
static void _data_source_subscriber_unlinking_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 3658 "DataObject.c"
	data_source_subscriber_unlinking (self, view);
}


#line 644 "DataObject.vala"
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 3665 "DataObject.c"
	GeeHashMap* _tmp0_;
#line 644 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 644 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 645 "DataObject.vala"
	g_assert ((self->priv->backlinks == NULL) && (self->priv->unlinked_from_collection == NULL));
#line 647 "DataObject.vala"
	self->priv->unlinked_from_collection = collection;
#line 648 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 650 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_unlinking_data_source_contact_subscriber, self);
#line 3679 "DataObject.c"
}


#line 592 "DataObject.vala"
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinking (self, collection);
#line 3687 "DataObject.c"
}


#line 654 "DataObject.vala"
static void data_source_real_notify_unlinked (DataSource* self) {
#line 654 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 655 "DataObject.vala"
	g_assert ((self->priv->unlinked_from_collection != NULL) && (self->priv->backlinks != NULL));
#line 657 "DataObject.vala"
	g_signal_emit_by_name (self, "unlinked", self->priv->unlinked_from_collection);
#line 660 "DataObject.vala"
	if (gee_map_get_size (GEE_MAP (self->priv->backlinks)) > 0) {
#line 3701 "DataObject.c"
		char* _tmp0_;
#line 661 "DataObject.vala"
		data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp0_ = data_source_dehydrate_backlinks (self));
#line 3705 "DataObject.c"
		_g_free0 (_tmp0_);
	}
}


#line 592 "DataObject.vala"
void data_source_notify_unlinked (DataSource* self) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinked (self);
#line 3715 "DataObject.c"
}


#line 664 "DataObject.vala"
static void data_source_subscriber_unlinking (DataSource* self, DataView* view) {
#line 664 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 664 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 665 "DataObject.vala"
	data_view_notify_source_unlinking (view, self->priv->unlinked_from_collection);
#line 3727 "DataObject.c"
}


#line 669 "DataObject.vala"
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 669 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 669 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 670 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection == collection));
#line 3739 "DataObject.c"
}


#line 592 "DataObject.vala"
void data_source_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinking (self, collection);
#line 3747 "DataObject.c"
}


#line 687 "DataObject.vala"
static void _data_source_subscriber_relinked_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 3753 "DataObject.c"
	data_source_subscriber_relinked (self, view);
}


#line 674 "DataObject.vala"
static void data_source_real_notify_relinked (DataSource* self) {
#line 3760 "DataObject.c"
	SourceCollection* relinked_to;
	GeeHashMap* _tmp0_;
#line 674 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 675 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection != NULL));
#line 677 "DataObject.vala"
	relinked_to = _data_collection_ref0 (self->priv->unlinked_from_collection);
#line 678 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = NULL, _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 679 "DataObject.vala"
	self->priv->unlinked_from_collection = NULL;
#line 680 "DataObject.vala"
	g_signal_emit_by_name (self, "relinked", relinked_to);
#line 681 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_relinked_data_source_contact_subscriber, self);
#line 684 "DataObject.vala"
	data_source_commit_backlinks (self, NULL, NULL);
#line 3779 "DataObject.c"
	_data_collection_unref0 (relinked_to);
}


#line 592 "DataObject.vala"
void data_source_notify_relinked (DataSource* self) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinked (self);
#line 3788 "DataObject.c"
}


#line 687 "DataObject.vala"
static void data_source_subscriber_relinked (DataSource* self, DataView* view) {
#line 3794 "DataObject.c"
	SourceCollection* _tmp0_;
#line 687 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 687 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 688 "DataObject.vala"
	data_view_notify_source_relinked (view, _tmp0_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self))));
#line 3802 "DataObject.c"
	_data_collection_unref0 (_tmp0_);
}


#line 696 "DataObject.vala"
static char* data_source_real_get_typename (DataSource* self) {
#line 3809 "DataObject.c"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_source_get_typename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 592 "DataObject.vala"
char* data_source_get_typename (DataSource* self) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_typename (self);
#line 3820 "DataObject.c"
}


#line 702 "DataObject.vala"
static gint64 data_source_real_get_instance_id (DataSource* self) {
#line 3826 "DataObject.c"
	g_return_val_if_fail (IS_DATA_SOURCE (self), 0LL);
	g_critical ("Type `%s' does not implement abstract method `data_source_get_instance_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0LL;
}


#line 592 "DataObject.vala"
gint64 data_source_get_instance_id (DataSource* self) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_instance_id (self);
#line 3837 "DataObject.c"
}


#line 706 "DataObject.vala"
static char* data_source_real_get_source_id (DataSource* self) {
#line 3843 "DataObject.c"
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
#line 706 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 3849 "DataObject.c"
	result = (_tmp1_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", _tmp0_ = data_source_get_typename (self), data_source_get_instance_id (self)), _g_free0 (_tmp0_), _tmp1_);
#line 707 "DataObject.vala"
	return result;
#line 3853 "DataObject.c"
}


#line 592 "DataObject.vala"
char* data_source_get_source_id (DataSource* self) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->get_source_id (self);
#line 3861 "DataObject.c"
}


#line 710 "DataObject.vala"
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink) {
#line 3867 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
#line 710 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 710 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 711 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 3877 "DataObject.c"
		result = FALSE;
#line 712 "DataObject.vala"
		return result;
#line 3881 "DataObject.c"
	}
#line 714 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 716 "DataObject.vala"
	if (values != NULL) {
#line 716 "DataObject.vala"
		_tmp0_ = gee_collection_contains (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 3889 "DataObject.c"
	} else {
#line 716 "DataObject.vala"
		_tmp0_ = FALSE;
#line 3893 "DataObject.c"
	}
	result = _tmp0_;
	_g_object_unref0 (values);
#line 716 "DataObject.vala"
	return result;
#line 3899 "DataObject.c"
}


#line 719 "DataObject.vala"
GeeList* data_source_get_backlinks (DataSource* self, const char* name) {
#line 3905 "DataObject.c"
	GeeList* result = NULL;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
	GeeList* backlinks;
#line 719 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 719 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 720 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 3916 "DataObject.c"
		result = NULL;
#line 721 "DataObject.vala"
		return result;
#line 3920 "DataObject.c"
	}
#line 723 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 724 "DataObject.vala"
	if (values == NULL) {
#line 724 "DataObject.vala"
		_tmp0_ = TRUE;
#line 3928 "DataObject.c"
	} else {
#line 724 "DataObject.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 3932 "DataObject.c"
	}
#line 724 "DataObject.vala"
	if (_tmp0_) {
#line 3936 "DataObject.c"
		result = NULL;
		_g_object_unref0 (values);
#line 725 "DataObject.vala"
		return result;
#line 3941 "DataObject.c"
	}
#line 727 "DataObject.vala"
	backlinks = GEE_LIST (gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, NULL));
#line 3945 "DataObject.c"
	{
		GeeIterator* _value_it;
#line 728 "DataObject.vala"
		_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 728 "DataObject.vala"
		while (TRUE) {
#line 3952 "DataObject.c"
			char* value;
			SourceBacklink* _tmp1_;
#line 728 "DataObject.vala"
			if (!gee_iterator_next (_value_it)) {
#line 728 "DataObject.vala"
				break;
#line 3959 "DataObject.c"
			}
#line 728 "DataObject.vala"
			value = (char*) gee_iterator_get (_value_it);
#line 729 "DataObject.vala"
			gee_collection_add (GEE_COLLECTION (backlinks), _tmp1_ = source_backlink_new (name, value));
#line 3965 "DataObject.c"
			_source_backlink_unref0 (_tmp1_);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
	result = backlinks;
	_g_object_unref0 (values);
#line 731 "DataObject.vala"
	return result;
#line 3975 "DataObject.c"
}


#line 734 "DataObject.vala"
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink) {
#line 3981 "DataObject.c"
	GeeList* values;
	SourceCollection* sources;
#line 734 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 734 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 736 "DataObject.vala"
	g_assert (self->priv->backlinks != NULL);
#line 738 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 739 "DataObject.vala"
	if (values == NULL) {
#line 3994 "DataObject.c"
		GeeList* _tmp0_;
#line 740 "DataObject.vala"
		values = (_tmp0_ = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL)), _g_object_unref0 (values), _tmp0_);
#line 741 "DataObject.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), values);
#line 4000 "DataObject.c"
	}
#line 744 "DataObject.vala"
	gee_collection_add (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 746 "DataObject.vala"
	sources = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 747 "DataObject.vala"
	if (sources != NULL) {
#line 748 "DataObject.vala"
		source_collection_internal_backlink_set (sources, self, backlink);
#line 4010 "DataObject.c"
	}
	_data_collection_unref0 (sources);
	_g_object_unref0 (values);
}


#line 751 "DataObject.vala"
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink) {
#line 4019 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gint original_size;
	GeeIterator* iter;
	char* _tmp2_;
	SourceCollection* sources;
#line 751 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 751 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 752 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 4032 "DataObject.c"
		result = FALSE;
#line 753 "DataObject.vala"
		return result;
#line 4036 "DataObject.c"
	}
#line 755 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 756 "DataObject.vala"
	if (values == NULL) {
#line 4042 "DataObject.c"
		result = FALSE;
		_g_object_unref0 (values);
#line 757 "DataObject.vala"
		return result;
#line 4047 "DataObject.c"
	}
#line 759 "DataObject.vala"
	original_size = gee_collection_get_size (GEE_COLLECTION (values));
#line 760 "DataObject.vala"
	g_assert (original_size > 0);
#line 762 "DataObject.vala"
	iter = gee_iterable_iterator (GEE_ITERABLE (values));
#line 763 "DataObject.vala"
	while (TRUE) {
#line 4057 "DataObject.c"
		char* _tmp0_;
		gboolean _tmp1_;
#line 763 "DataObject.vala"
		if (!gee_iterator_next (iter)) {
#line 763 "DataObject.vala"
			break;
#line 4064 "DataObject.c"
		}
#line 764 "DataObject.vala"
		if ((_tmp1_ = _vala_strcmp0 (_tmp0_ = (char*) gee_iterator_get (iter), source_backlink_get_value (backlink)) == 0, _g_free0 (_tmp0_), _tmp1_)) {
#line 765 "DataObject.vala"
			gee_iterator_remove (iter);
#line 4070 "DataObject.c"
		}
	}
#line 768 "DataObject.vala"
	if (gee_collection_get_size (GEE_COLLECTION (values)) == 0) {
#line 769 "DataObject.vala"
		gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), NULL);
#line 4077 "DataObject.c"
	}
#line 773 "DataObject.vala"
	data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp2_ = data_source_dehydrate_backlinks (self));
#line 4081 "DataObject.c"
	_g_free0 (_tmp2_);
#line 775 "DataObject.vala"
	sources = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 776 "DataObject.vala"
	if (sources != NULL) {
#line 777 "DataObject.vala"
		source_collection_internal_backlink_removed (sources, self, backlink);
#line 4089 "DataObject.c"
	}
	result = gee_collection_get_size (GEE_COLLECTION (values)) != original_size;
	_data_collection_unref0 (sources);
	_g_object_unref0 (iter);
	_g_object_unref0 (values);
#line 779 "DataObject.vala"
	return result;
#line 4097 "DataObject.c"
}


#line 788 "DataObject.vala"
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 4103 "DataObject.c"
	gboolean _tmp0_ = FALSE;
#line 788 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 788 "DataObject.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 789 "DataObject.vala"
	if (sources != NULL) {
#line 789 "DataObject.vala"
		_tmp0_ = TRUE;
#line 4113 "DataObject.c"
	} else {
#line 789 "DataObject.vala"
		_tmp0_ = dehydrated != NULL;
#line 4117 "DataObject.c"
	}
#line 789 "DataObject.vala"
	if (_tmp0_) {
#line 4121 "DataObject.c"
		char* _tmp1_;
#line 790 "DataObject.vala"
		g_warning ("DataObject.vala:790: No implementation to commit link state for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 4125 "DataObject.c"
		_g_free0 (_tmp1_);
	}
}


#line 592 "DataObject.vala"
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->commit_backlinks (self, sources, dehydrated);
#line 4135 "DataObject.c"
}


#line 793 "DataObject.vala"
static char* data_source_dehydrate_backlinks (DataSource* self) {
#line 4141 "DataObject.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
	GString* builder;
	const char* _tmp7_;
#line 793 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 794 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 794 "DataObject.vala"
		_tmp0_ = TRUE;
#line 4152 "DataObject.c"
	} else {
#line 794 "DataObject.vala"
		_tmp0_ = gee_map_get_size (GEE_MAP (self->priv->backlinks)) == 0;
#line 4156 "DataObject.c"
	}
#line 794 "DataObject.vala"
	if (_tmp0_) {
#line 4160 "DataObject.c"
		result = NULL;
#line 795 "DataObject.vala"
		return result;
#line 4164 "DataObject.c"
	}
#line 797 "DataObject.vala"
	builder = g_string_new ("");
#line 4168 "DataObject.c"
	{
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _name_it;
#line 798 "DataObject.vala"
		_name_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = gee_map_get_keys (GEE_MAP (self->priv->backlinks)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 798 "DataObject.vala"
		while (TRUE) {
#line 4177 "DataObject.c"
			char* name;
			GeeList* values;
			gboolean _tmp3_ = FALSE;
			char* value_field;
#line 798 "DataObject.vala"
			if (!gee_iterator_next (_name_it)) {
#line 798 "DataObject.vala"
				break;
#line 4186 "DataObject.c"
			}
#line 798 "DataObject.vala"
			name = (char*) gee_iterator_get (_name_it);
#line 799 "DataObject.vala"
			values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 800 "DataObject.vala"
			if (values == NULL) {
#line 800 "DataObject.vala"
				_tmp3_ = TRUE;
#line 4196 "DataObject.c"
			} else {
#line 800 "DataObject.vala"
				_tmp3_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 4200 "DataObject.c"
			}
#line 800 "DataObject.vala"
			if (_tmp3_) {
#line 4204 "DataObject.c"
				_g_object_unref0 (values);
				_g_free0 (name);
#line 801 "DataObject.vala"
				continue;
#line 4209 "DataObject.c"
			}
#line 803 "DataObject.vala"
			value_field = g_strdup ("");
#line 4213 "DataObject.c"
			{
				GeeIterator* _value_it;
#line 804 "DataObject.vala"
				_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 804 "DataObject.vala"
				while (TRUE) {
#line 4220 "DataObject.c"
					char* value;
#line 804 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 804 "DataObject.vala"
						break;
#line 4226 "DataObject.c"
					}
#line 804 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 805 "DataObject.vala"
					if (!is_string_empty (value)) {
#line 4232 "DataObject.c"
						char* _tmp4_;
						char* _tmp5_;
#line 806 "DataObject.vala"
						value_field = (_tmp5_ = g_strconcat (value_field, _tmp4_ = g_strconcat (value, "|", NULL), NULL), _g_free0 (value_field), _tmp5_);
#line 4237 "DataObject.c"
						_g_free0 (_tmp4_);
					}
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
#line 809 "DataObject.vala"
			if (string_get_length (value_field) > 0) {
#line 4246 "DataObject.c"
				char* _tmp6_;
#line 810 "DataObject.vala"
				g_string_append (builder, _tmp6_ = g_strdup_printf ("%s=%s\n", name, value_field));
#line 4250 "DataObject.c"
				_g_free0 (_tmp6_);
			}
			_g_free0 (value_field);
			_g_object_unref0 (values);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_it);
	}
	_tmp7_ = NULL;
#line 813 "DataObject.vala"
	if (string_get_length (builder->str) > 0) {
#line 813 "DataObject.vala"
		_tmp7_ = builder->str;
#line 4264 "DataObject.c"
	} else {
#line 813 "DataObject.vala"
		_tmp7_ = NULL;
#line 4268 "DataObject.c"
	}
	result = g_strdup (_tmp7_);
	_g_string_free0 (builder);
#line 813 "DataObject.vala"
	return result;
#line 4274 "DataObject.c"
}


#line 818 "DataObject.vala"
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated) {
#line 4280 "DataObject.c"
	GeeHashMap* _tmp0_;
	gint lines_length1;
	gint _lines_size_;
	char** _tmp2_;
	char** _tmp1_;
	char** lines;
#line 818 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 818 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (unlinked_from));
#line 819 "DataObject.vala"
	self->priv->unlinked_from_collection = unlinked_from;
#line 820 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 822 "DataObject.vala"
	if (dehydrated == NULL) {
#line 823 "DataObject.vala"
		return;
#line 4299 "DataObject.c"
	}
	lines = (_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0), lines_length1 = _vala_array_length (_tmp1_), _lines_size_ = lines_length1, _tmp2_);
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
#line 826 "DataObject.vala"
		line_collection = lines;
#line 4308 "DataObject.c"
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			char* line;
			line = g_strdup (line_collection[line_it]);
			{
				gint tokens_length1;
				gint _tokens_size_;
				char** _tmp4_;
				char** _tmp3_;
				char** tokens;
				gint decoded_values_length1;
				gint _decoded_values_size_;
				char** _tmp7_;
				char** _tmp6_;
				char** decoded_values;
				GeeList* values;
#line 827 "DataObject.vala"
				if (string_get_length (line) == 0) {
#line 4327 "DataObject.c"
					_g_free0 (line);
#line 828 "DataObject.vala"
					continue;
#line 4331 "DataObject.c"
				}
				tokens = (_tmp4_ = _tmp3_ = g_strsplit (line, "=", 2), tokens_length1 = _vala_array_length (_tmp3_), _tokens_size_ = tokens_length1, _tmp4_);
#line 831 "DataObject.vala"
				if (tokens_length1 < 2) {
#line 4336 "DataObject.c"
					char* _tmp5_;
#line 832 "DataObject.vala"
					g_warning ("DataObject.vala:832: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", line, _tmp5_ = data_object_to_string (DATA_OBJECT (self)));
#line 4340 "DataObject.c"
					_g_free0 (_tmp5_);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (line);
#line 835 "DataObject.vala"
					continue;
#line 4346 "DataObject.c"
				}
				decoded_values = (_tmp7_ = _tmp6_ = g_strsplit (tokens[1], "|", 0), decoded_values_length1 = _vala_array_length (_tmp6_), _decoded_values_size_ = decoded_values_length1, _tmp7_);
#line 839 "DataObject.vala"
				values = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL));
#line 4351 "DataObject.c"
				{
					char** value_collection;
					int value_collection_length1;
					int value_it;
#line 840 "DataObject.vala"
					value_collection = decoded_values;
#line 4358 "DataObject.c"
					value_collection_length1 = decoded_values_length1;
					for (value_it = 0; value_it < decoded_values_length1; value_it = value_it + 1) {
						char* value;
						value = g_strdup (value_collection[value_it]);
						{
							gboolean _tmp8_ = FALSE;
#line 841 "DataObject.vala"
							if (value != NULL) {
#line 841 "DataObject.vala"
								_tmp8_ = string_get_length (value) > 0;
#line 4369 "DataObject.c"
							} else {
#line 841 "DataObject.vala"
								_tmp8_ = FALSE;
#line 4373 "DataObject.c"
							}
#line 841 "DataObject.vala"
							if (_tmp8_) {
#line 842 "DataObject.vala"
								gee_collection_add (GEE_COLLECTION (values), value);
#line 4379 "DataObject.c"
							}
							_g_free0 (value);
						}
					}
				}
#line 845 "DataObject.vala"
				if (gee_collection_get_size (GEE_COLLECTION (values)) > 0) {
#line 846 "DataObject.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), tokens[0], values);
#line 4389 "DataObject.c"
				}
				_g_object_unref0 (values);
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (line);
			}
		}
	}
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


#line 851 "DataObject.vala"
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self) {
#line 4404 "DataObject.c"
	SourceSnapshot* result = NULL;
#line 851 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 4408 "DataObject.c"
	result = NULL;
#line 852 "DataObject.vala"
	return result;
#line 4412 "DataObject.c"
}


#line 592 "DataObject.vala"
SourceSnapshot* data_source_save_snapshot (DataSource* self) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
#line 4420 "DataObject.c"
}


#line 856 "DataObject.vala"
void data_source_internal_mark_for_destroy (DataSource* self) {
#line 856 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 857 "DataObject.vala"
	self->priv->marked_for_destroy = TRUE;
#line 4430 "DataObject.c"
}


#line 864 "DataObject.vala"
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error) {
#line 4436 "DataObject.c"
	gboolean result = FALSE;
#line 864 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 4440 "DataObject.c"
	result = TRUE;
#line 865 "DataObject.vala"
	return result;
#line 4444 "DataObject.c"
}


#line 592 "DataObject.vala"
gboolean data_source_internal_delete_backing (DataSource* self, GError** error) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
#line 4452 "DataObject.c"
}


#line 870 "DataObject.vala"
static gboolean data_source_real_equals (DataSource* self, DataSource* source) {
#line 4458 "DataObject.c"
	gboolean result = FALSE;
#line 870 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 870 "DataObject.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 4464 "DataObject.c"
	result = self == source;
#line 871 "DataObject.vala"
	return result;
#line 4468 "DataObject.c"
}


#line 592 "DataObject.vala"
gboolean data_source_equals (DataSource* self, DataSource* source) {
#line 592 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
#line 4476 "DataObject.c"
}


#line 880 "DataObject.vala"
static void data_source_real_destroy (DataSource* self) {
#line 880 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 881 "DataObject.vala"
	g_assert (self->priv->marked_for_destroy);
#line 884 "DataObject.vala"
	self->priv->is_destroyed = TRUE;
#line 4488 "DataObject.c"
	{
		gint ctr;
#line 887 "DataObject.vala"
		ctr = 0;
#line 4493 "DataObject.c"
		{
			gboolean _tmp0_;
#line 887 "DataObject.vala"
			_tmp0_ = TRUE;
#line 887 "DataObject.vala"
			while (TRUE) {
#line 887 "DataObject.vala"
				if (!_tmp0_) {
#line 887 "DataObject.vala"
					ctr++;
#line 4504 "DataObject.c"
				}
#line 887 "DataObject.vala"
				_tmp0_ = FALSE;
#line 887 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 887 "DataObject.vala"
					break;
#line 4512 "DataObject.c"
				}
#line 888 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 4516 "DataObject.c"
					DataView* view;
					DataView* _tmp1_;
#line 889 "DataObject.vala"
					view = _g_object_ref0 (self->priv->subscribers[ctr]);
#line 890 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 892 "DataObject.vala"
					data_view_notify_unsubscribed (view, self);
#line 4525 "DataObject.c"
					_g_object_unref0 (view);
				}
			}
		}
	}
#line 897 "DataObject.vala"
	g_signal_emit_by_name (self, "destroyed");
#line 4533 "DataObject.c"
}


#line 592 "DataObject.vala"
void data_source_destroy (DataSource* self) {
#line 592 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
#line 4541 "DataObject.c"
}


#line 906 "DataObject.vala"
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing) {
#line 4547 "DataObject.c"
	gboolean result = FALSE;
	gboolean ret;
	GError * _inner_error_ = NULL;
#line 906 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 907 "DataObject.vala"
	ret = TRUE;
#line 908 "DataObject.vala"
	if (delete_backing) {
#line 4557 "DataObject.c"
		{
			gboolean _tmp0_;
#line 910 "DataObject.vala"
			_tmp0_ = data_source_internal_delete_backing (self, &_inner_error_);
#line 4562 "DataObject.c"
			if (_inner_error_ != NULL) {
				goto __catch191_g_error;
			}
#line 910 "DataObject.vala"
			ret = _tmp0_;
#line 911 "DataObject.vala"
			if (!ret) {
#line 4570 "DataObject.c"
				char* _tmp1_;
#line 912 "DataObject.vala"
				g_warning ("DataObject.vala:912: Unable to delete backing for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 4574 "DataObject.c"
				_g_free0 (_tmp1_);
			}
		}
		goto __finally191;
		__catch191_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp2_;
#line 915 "DataObject.vala"
				g_warning ("DataObject.vala:915: Unable to delete backing for %s: %s", _tmp2_ = data_object_to_string (DATA_OBJECT (self)), err->message);
#line 4588 "DataObject.c"
				_g_free0 (_tmp2_);
#line 916 "DataObject.vala"
				ret = FALSE;
#line 4592 "DataObject.c"
				_g_error_free0 (err);
			}
		}
		__finally191:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
#line 920 "DataObject.vala"
	data_source_internal_mark_for_destroy (self);
#line 921 "DataObject.vala"
	data_source_destroy (self);
#line 923 "DataObject.vala"
	if (self->priv->unlinked_from_collection != NULL) {
#line 924 "DataObject.vala"
		source_collection_notify_unlinked_destroyed (self->priv->unlinked_from_collection, self);
#line 4611 "DataObject.c"
	}
	result = ret;
#line 926 "DataObject.vala"
	return result;
#line 4616 "DataObject.c"
}


static void _vala_array_add183 (DataView*** array, int* length, int* size, DataView* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DataView*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 935 "DataObject.vala"
void data_source_internal_subscribe (DataSource* self, DataView* view) {
#line 935 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 935 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 936 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 4638 "DataObject.c"
	{
		gint ctr;
#line 938 "DataObject.vala"
		ctr = 0;
#line 4643 "DataObject.c"
		{
			gboolean _tmp0_;
#line 938 "DataObject.vala"
			_tmp0_ = TRUE;
#line 938 "DataObject.vala"
			while (TRUE) {
#line 938 "DataObject.vala"
				if (!_tmp0_) {
#line 938 "DataObject.vala"
					ctr++;
#line 4654 "DataObject.c"
				}
#line 938 "DataObject.vala"
				_tmp0_ = FALSE;
#line 938 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 938 "DataObject.vala"
					break;
#line 4662 "DataObject.c"
				}
#line 939 "DataObject.vala"
				if (self->priv->subscribers[ctr] == NULL) {
#line 4666 "DataObject.c"
					DataView* _tmp1_;
#line 940 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = _g_object_ref0 (view), _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 942 "DataObject.vala"
					return;
#line 4672 "DataObject.c"
				}
			}
		}
	}
#line 946 "DataObject.vala"
	_vala_array_add183 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _g_object_ref0 (view));
#line 4679 "DataObject.c"
}


#line 951 "DataObject.vala"
void data_source_internal_unsubscribe (DataSource* self, DataView* view) {
#line 951 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 951 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 952 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 4691 "DataObject.c"
	{
		gint ctr;
#line 954 "DataObject.vala"
		ctr = 0;
#line 4696 "DataObject.c"
		{
			gboolean _tmp0_;
#line 954 "DataObject.vala"
			_tmp0_ = TRUE;
#line 954 "DataObject.vala"
			while (TRUE) {
#line 954 "DataObject.vala"
				if (!_tmp0_) {
#line 954 "DataObject.vala"
					ctr++;
#line 4707 "DataObject.c"
				}
#line 954 "DataObject.vala"
				_tmp0_ = FALSE;
#line 954 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 954 "DataObject.vala"
					break;
#line 4715 "DataObject.c"
				}
#line 955 "DataObject.vala"
				if (self->priv->subscribers[ctr] == view) {
#line 4719 "DataObject.c"
					DataView* _tmp1_;
#line 956 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 958 "DataObject.vala"
					return;
#line 4725 "DataObject.c"
				}
			}
		}
	}
}


#line 963 "DataObject.vala"
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target) {
#line 963 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 964 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 966 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 4741 "DataObject.c"
	{
		gint ctr;
#line 967 "DataObject.vala"
		ctr = 0;
#line 4746 "DataObject.c"
		{
			gboolean _tmp0_;
#line 967 "DataObject.vala"
			_tmp0_ = TRUE;
#line 967 "DataObject.vala"
			while (TRUE) {
#line 967 "DataObject.vala"
				if (!_tmp0_) {
#line 967 "DataObject.vala"
					ctr++;
#line 4757 "DataObject.c"
				}
#line 967 "DataObject.vala"
				_tmp0_ = FALSE;
#line 967 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 967 "DataObject.vala"
					break;
#line 4765 "DataObject.c"
				}
#line 968 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 969 "DataObject.vala"
					contact_subscriber (self->priv->subscribers[ctr], contact_subscriber_target);
#line 4771 "DataObject.c"
				}
			}
		}
	}
#line 971 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 4778 "DataObject.c"
}


#line 974 "DataObject.vala"
void data_source_contact_subscribers_alteration (DataSource* self, Alteration* alteration) {
#line 974 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 974 "DataObject.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 975 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 977 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 4792 "DataObject.c"
	{
		gint ctr;
#line 978 "DataObject.vala"
		ctr = 0;
#line 4797 "DataObject.c"
		{
			gboolean _tmp0_;
#line 978 "DataObject.vala"
			_tmp0_ = TRUE;
#line 978 "DataObject.vala"
			while (TRUE) {
#line 978 "DataObject.vala"
				if (!_tmp0_) {
#line 978 "DataObject.vala"
					ctr++;
#line 4808 "DataObject.c"
				}
#line 978 "DataObject.vala"
				_tmp0_ = FALSE;
#line 978 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 978 "DataObject.vala"
					break;
#line 4816 "DataObject.c"
				}
#line 979 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 980 "DataObject.vala"
					data_object_notify_altered (DATA_OBJECT (self->priv->subscribers[ctr]), alteration);
#line 4822 "DataObject.c"
				}
			}
		}
	}
#line 982 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 4829 "DataObject.c"
}


#line 580 "DataObject.vala"
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources) {
#line 580 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 580 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 4839 "DataObject.c"
}


#line 584 "DataObject.vala"
static void data_source_real_relinked (DataSource* self, SourceCollection* sources) {
#line 584 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 584 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 4849 "DataObject.c"
}


#line 589 "DataObject.vala"
static void data_source_real_destroyed (DataSource* self) {
#line 589 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 4857 "DataObject.c"
}


static void data_source_class_init (DataSourceClass * klass) {
	data_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_source_real_notify_membership_changed;
	DATA_SOURCE_CLASS (klass)->notify_held_in_tank = data_source_real_notify_held_in_tank;
	DATA_OBJECT_CLASS (klass)->notify_altered = data_source_real_notify_altered;
	DATA_SOURCE_CLASS (klass)->notify_unlinking = data_source_real_notify_unlinking;
	DATA_SOURCE_CLASS (klass)->notify_unlinked = data_source_real_notify_unlinked;
	DATA_SOURCE_CLASS (klass)->notify_relinking = data_source_real_notify_relinking;
	DATA_SOURCE_CLASS (klass)->notify_relinked = data_source_real_notify_relinked;
	DATA_SOURCE_CLASS (klass)->get_typename = data_source_real_get_typename;
	DATA_SOURCE_CLASS (klass)->get_instance_id = data_source_real_get_instance_id;
	DATA_SOURCE_CLASS (klass)->get_source_id = data_source_real_get_source_id;
	DATA_SOURCE_CLASS (klass)->commit_backlinks = data_source_real_commit_backlinks;
	DATA_SOURCE_CLASS (klass)->save_snapshot = data_source_real_save_snapshot;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = data_source_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->equals = data_source_real_equals;
	DATA_SOURCE_CLASS (klass)->destroy = data_source_real_destroy;
	DATA_SOURCE_CLASS (klass)->unlinked = data_source_real_unlinked;
	DATA_SOURCE_CLASS (klass)->relinked = data_source_real_relinked;
	DATA_SOURCE_CLASS (klass)->destroyed = data_source_real_destroyed;
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
	g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_source_instance_init (DataSource * self) {
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
	self->priv->subscribers = g_new0 (DataView*, 4 + 1);
	self->priv->subscribers_length1 = 4;
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
	self->priv->holding_tank = NULL;
	self->priv->unlinked_from_collection = NULL;
	self->priv->backlinks = NULL;
	self->priv->in_contact = FALSE;
	self->priv->marked_for_destroy = FALSE;
	self->priv->is_destroyed = FALSE;
}


static void data_source_finalize (GObject* obj) {
	DataSource * self;
	self = DATA_SOURCE (obj);
	{
	}
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
	_source_holding_tank_unref0 (self->priv->holding_tank);
	_g_object_unref0 (self->priv->backlinks);
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
}


GType data_source_get_type (void) {
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


#line 990 "DataObject.vala"
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id) {
#line 4929 "DataObject.c"
	ThumbnailSource * self = NULL;
#line 991 "DataObject.vala"
	self = (ThumbnailSource*) data_source_construct (object_type, object_id);
#line 4933 "DataObject.c"
	return self;
}


#line 1002 "DataObject.vala"
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 4940 "DataObject.c"
	thumbnail_source_subscriber_thumbnail_altered (self, view);
}


#line 994 "DataObject.vala"
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self) {
#line 994 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 996 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 999 "DataObject.vala"
	data_source_contact_subscribers (DATA_SOURCE (self), _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber, self);
#line 4953 "DataObject.c"
}


#line 990 "DataObject.vala"
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self) {
#line 990 "DataObject.vala"
	THUMBNAIL_SOURCE_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 4961 "DataObject.c"
}


#line 1002 "DataObject.vala"
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view) {
#line 1002 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 1002 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1003 "DataObject.vala"
	thumbnail_view_notify_thumbnail_altered (THUMBNAIL_VIEW (view));
#line 4973 "DataObject.c"
}


#line 1006 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 4979 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 990 "DataObject.vala"
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 990 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_thumbnail (self, scale, error);
#line 4990 "DataObject.c"
}


#line 1010 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_create_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 4996 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_create_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 990 "DataObject.vala"
GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 990 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->create_thumbnail (self, scale, error);
#line 5007 "DataObject.c"
}


#line 1021 "DataObject.vala"
static char* thumbnail_source_real_get_representative_id (ThumbnailSource* self) {
#line 5013 "DataObject.c"
	char* result = NULL;
#line 1021 "DataObject.vala"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
#line 5017 "DataObject.c"
	result = data_source_get_source_id (DATA_SOURCE (self));
#line 1022 "DataObject.vala"
	return result;
#line 5021 "DataObject.c"
}


#line 990 "DataObject.vala"
char* thumbnail_source_get_representative_id (ThumbnailSource* self) {
#line 990 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_representative_id (self);
#line 5029 "DataObject.c"
}


#line 1025 "DataObject.vala"
static PhotoFileFormat thumbnail_source_real_get_preferred_thumbnail_format (ThumbnailSource* self) {
#line 5035 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_preferred_thumbnail_format'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 990 "DataObject.vala"
PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self) {
#line 990 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_preferred_thumbnail_format (self);
#line 5046 "DataObject.c"
}


#line 987 "DataObject.vala"
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self) {
#line 987 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 5054 "DataObject.c"
}


static void thumbnail_source_class_init (ThumbnailSourceClass * klass) {
	thumbnail_source_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_SOURCE_CLASS (klass)->notify_thumbnail_altered = thumbnail_source_real_notify_thumbnail_altered;
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = thumbnail_source_real_get_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = thumbnail_source_real_create_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->get_representative_id = thumbnail_source_real_get_representative_id;
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = thumbnail_source_real_get_preferred_thumbnail_format;
	THUMBNAIL_SOURCE_CLASS (klass)->thumbnail_altered = thumbnail_source_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailSourceClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_source_instance_init (ThumbnailSource * self) {
}


GType thumbnail_source_get_type (void) {
	static volatile gsize thumbnail_source_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailSource), 0, (GInstanceInitFunc) thumbnail_source_instance_init, NULL };
		GType thumbnail_source_type_id;
		thumbnail_source_type_id = g_type_register_static (TYPE_DATA_SOURCE, "ThumbnailSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&thumbnail_source_type_id__volatile, thumbnail_source_type_id);
	}
	return thumbnail_source_type_id__volatile;
}


#line 1029 "DataObject.vala"
PhotoSource* photo_source_construct (GType object_type, gint64 object_id) {
#line 5088 "DataObject.c"
	PhotoSource * self = NULL;
#line 1030 "DataObject.vala"
	self = (PhotoSource*) media_source_construct (object_type, object_id);
#line 5092 "DataObject.c"
	return self;
}


#line 1033 "DataObject.vala"
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self) {
#line 5099 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1029 "DataObject.vala"
PhotoMetadata* photo_source_get_metadata (PhotoSource* self) {
#line 1029 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_metadata (self);
#line 5110 "DataObject.c"
}


#line 1035 "DataObject.vala"
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 5116 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1029 "DataObject.vala"
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 1029 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_pixbuf (self, scaling, error);
#line 5127 "DataObject.c"
}


static void photo_source_class_init (PhotoSourceClass * klass) {
	photo_source_parent_class = g_type_class_peek_parent (klass);
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_source_real_get_metadata;
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_source_real_get_pixbuf;
}


static void photo_source_instance_init (PhotoSource * self) {
}


GType photo_source_get_type (void) {
	static volatile gsize photo_source_type_id__volatile = 0;
	if (g_once_init_enter (&photo_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoSource), 0, (GInstanceInitFunc) photo_source_instance_init, NULL };
		GType photo_source_type_id;
		photo_source_type_id = g_type_register_static (TYPE_MEDIA_SOURCE, "PhotoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_source_type_id__volatile, photo_source_type_id);
	}
	return photo_source_type_id__volatile;
}


#line 1038 "DataObject.vala"
VideoSource* video_source_construct (GType object_type) {
#line 5156 "DataObject.c"
	VideoSource * self = NULL;
#line 1038 "DataObject.vala"
	self = (VideoSource*) media_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 5160 "DataObject.c"
	return self;
}


static void video_source_class_init (VideoSourceClass * klass) {
	video_source_parent_class = g_type_class_peek_parent (klass);
}


static void video_source_instance_init (VideoSource * self) {
}


GType video_source_get_type (void) {
	static volatile gsize video_source_type_id__volatile = 0;
	if (g_once_init_enter (&video_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoSource), 0, (GInstanceInitFunc) video_source_instance_init, NULL };
		GType video_source_type_id;
		video_source_type_id = g_type_register_static (TYPE_MEDIA_SOURCE, "VideoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&video_source_type_id__volatile, video_source_type_id);
	}
	return video_source_type_id__volatile;
}


#line 1042 "DataObject.vala"
EventSource* event_source_construct (GType object_type, gint64 object_id) {
#line 5188 "DataObject.c"
	EventSource * self = NULL;
#line 1043 "DataObject.vala"
	self = (EventSource*) thumbnail_source_construct (object_type, object_id);
#line 5192 "DataObject.c"
	return self;
}


#line 1046 "DataObject.vala"
static time_t event_source_real_get_start_time (EventSource* self) {
#line 5199 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_start_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 1042 "DataObject.vala"
time_t event_source_get_start_time (EventSource* self) {
#line 1042 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_start_time (self);
#line 5210 "DataObject.c"
}


#line 1048 "DataObject.vala"
static time_t event_source_real_get_end_time (EventSource* self) {
#line 5216 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_end_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 1042 "DataObject.vala"
time_t event_source_get_end_time (EventSource* self) {
#line 1042 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_end_time (self);
#line 5227 "DataObject.c"
}


#line 1050 "DataObject.vala"
static guint64 event_source_real_get_total_filesize (EventSource* self) {
#line 5233 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_total_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 1042 "DataObject.vala"
guint64 event_source_get_total_filesize (EventSource* self) {
#line 1042 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_total_filesize (self);
#line 5244 "DataObject.c"
}


#line 1052 "DataObject.vala"
static gint event_source_real_get_media_count (EventSource* self) {
#line 5250 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_media_count'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 1042 "DataObject.vala"
gint event_source_get_media_count (EventSource* self) {
#line 1042 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_media_count (self);
#line 5261 "DataObject.c"
}


#line 1054 "DataObject.vala"
static GeeCollection* event_source_real_get_media (EventSource* self) {
#line 5267 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1042 "DataObject.vala"
GeeCollection* event_source_get_media (EventSource* self) {
#line 1042 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_media (self);
#line 5278 "DataObject.c"
}


static void event_source_class_init (EventSourceClass * klass) {
	event_source_parent_class = g_type_class_peek_parent (klass);
	EVENT_SOURCE_CLASS (klass)->get_start_time = event_source_real_get_start_time;
	EVENT_SOURCE_CLASS (klass)->get_end_time = event_source_real_get_end_time;
	EVENT_SOURCE_CLASS (klass)->get_total_filesize = event_source_real_get_total_filesize;
	EVENT_SOURCE_CLASS (klass)->get_media_count = event_source_real_get_media_count;
	EVENT_SOURCE_CLASS (klass)->get_media = event_source_real_get_media;
}


static void event_source_instance_init (EventSource * self) {
}


GType event_source_get_type (void) {
	static volatile gsize event_source_type_id__volatile = 0;
	if (g_once_init_enter (&event_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSource), 0, (GInstanceInitFunc) event_source_instance_init, NULL };
		GType event_source_type_id;
		event_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "EventSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&event_source_type_id__volatile, event_source_type_id);
	}
	return event_source_type_id__volatile;
}


#line 1042 "DataObject.vala"
gboolean container_source_has_links (ContainerSource* self) {
#line 1042 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->has_links (self);
#line 5312 "DataObject.c"
}


#line 1042 "DataObject.vala"
SourceBacklink* container_source_get_backlink (ContainerSource* self) {
#line 1042 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->get_backlink (self);
#line 5320 "DataObject.c"
}


#line 1042 "DataObject.vala"
void container_source_break_link (ContainerSource* self, DataSource* source) {
#line 1042 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->break_link (self, source);
#line 5328 "DataObject.c"
}


#line 1042 "DataObject.vala"
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources) {
#line 1042 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->break_link_many (self, sources);
#line 5336 "DataObject.c"
}


#line 1042 "DataObject.vala"
void container_source_establish_link (ContainerSource* self, DataSource* source) {
#line 1042 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->establish_link (self, source);
#line 5344 "DataObject.c"
}


#line 1042 "DataObject.vala"
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources) {
#line 1042 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->establish_link_many (self, sources);
#line 5352 "DataObject.c"
}


static void container_source_base_init (ContainerSourceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType container_source_get_type (void) {
	static volatile gsize container_source_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceIface), (GBaseInitFunc) container_source_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType container_source_type_id;
		container_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "ContainerSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (container_source_type_id, TYPE_DATA_SOURCE);
		g_once_init_leave (&container_source_type_id__volatile, container_source_type_id);
	}
	return container_source_type_id__volatile;
}


#line 1151 "DataObject.vala"
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self) {
#line 5379 "DataObject.c"
	source_proxy_on_snapshot_broken (self);
}


#line 1199 "DataObject.vala"
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 5386 "DataObject.c"
	source_proxy_on_source_added (self, added);
}


#line 1117 "DataObject.vala"
SourceProxy* source_proxy_construct (GType object_type, DataSource* source) {
#line 5393 "DataObject.c"
	SourceProxy* self = (SourceProxy*) g_type_create_instance (object_type);
	char* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceCollection* _tmp2_;
#line 1117 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1118 "DataObject.vala"
	self->priv->object_id = data_object_get_object_id (DATA_OBJECT (source));
#line 1119 "DataObject.vala"
	self->priv->source_string = (_tmp0_ = data_object_to_string (DATA_OBJECT (source)), _g_free0 (self->priv->source_string), _tmp0_);
#line 1121 "DataObject.vala"
	self->priv->snapshot = (_tmp1_ = data_source_save_snapshot (source), _source_snapshot_unref0 (self->priv->snapshot), _tmp1_);
#line 1122 "DataObject.vala"
	g_assert (self->priv->snapshot != NULL);
#line 1123 "DataObject.vala"
	g_signal_connect (self->priv->snapshot, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 1125 "DataObject.vala"
	source_proxy_set_source (self, source);
#line 1127 "DataObject.vala"
	self->priv->membership = (_tmp2_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (source))), _data_collection_unref0 (self->priv->membership), _tmp2_);
#line 1128 "DataObject.vala"
	g_assert (self->priv->membership != NULL);
#line 1129 "DataObject.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->membership), "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 5418 "DataObject.c"
	return self;
}


#line 1137 "DataObject.vala"
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 5425 "DataObject.c"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1117 "DataObject.vala"
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 1117 "DataObject.vala"
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
#line 5436 "DataObject.c"
}


#line 1139 "DataObject.vala"
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 1139 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1139 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1140 "DataObject.vala"
	g_signal_emit_by_name (self, "reconstituted", source);
#line 5448 "DataObject.c"
}


#line 1117 "DataObject.vala"
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 1117 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
#line 5456 "DataObject.c"
}


#line 1143 "DataObject.vala"
static void source_proxy_real_notify_dehydrated (SourceProxy* self) {
#line 1143 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1144 "DataObject.vala"
	g_signal_emit_by_name (self, "dehydrated");
#line 5466 "DataObject.c"
}


#line 1117 "DataObject.vala"
void source_proxy_notify_dehydrated (SourceProxy* self) {
#line 1117 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
#line 5474 "DataObject.c"
}


#line 1147 "DataObject.vala"
static void source_proxy_real_notify_broken (SourceProxy* self) {
#line 1147 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1148 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 5484 "DataObject.c"
}


#line 1117 "DataObject.vala"
void source_proxy_notify_broken (SourceProxy* self) {
#line 1117 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
#line 5492 "DataObject.c"
}


#line 1151 "DataObject.vala"
static void source_proxy_on_snapshot_broken (SourceProxy* self) {
#line 1151 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1152 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1154 "DataObject.vala"
	source_proxy_notify_broken (self);
#line 5504 "DataObject.c"
}


#line 1190 "DataObject.vala"
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self) {
#line 5510 "DataObject.c"
	source_proxy_on_destroyed (self);
}


#line 1157 "DataObject.vala"
static void source_proxy_set_source (SourceProxy* self, DataSource* source) {
#line 5517 "DataObject.c"
	DataSource* _tmp0_;
#line 1157 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1157 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1158 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1160 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 1161 "DataObject.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 5529 "DataObject.c"
}


#line 1164 "DataObject.vala"
static void source_proxy_drop_source (SourceProxy* self) {
#line 5535 "DataObject.c"
	guint _tmp0_;
	DataSource* _tmp1_;
#line 1164 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1165 "DataObject.vala"
	if (self->priv->source == NULL) {
#line 1166 "DataObject.vala"
		return;
#line 5544 "DataObject.c"
	}
#line 1168 "DataObject.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp0_, NULL, FALSE);
#line 1168 "DataObject.vala"
	g_signal_handlers_disconnect_matched (self->priv->source, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 1169 "DataObject.vala"
	self->priv->source = (_tmp1_ = NULL, _g_object_unref0 (self->priv->source), _tmp1_);
#line 5552 "DataObject.c"
}


#line 1172 "DataObject.vala"
DataSource* source_proxy_get_source (SourceProxy* self) {
#line 5558 "DataObject.c"
	DataSource* result = NULL;
	DataSource* new_source;
#line 1172 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
#line 1173 "DataObject.vala"
	if (source_snapshot_is_broken (self->priv->snapshot)) {
#line 5565 "DataObject.c"
		result = NULL;
#line 1174 "DataObject.vala"
		return result;
#line 5569 "DataObject.c"
	}
#line 1176 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 5573 "DataObject.c"
		result = _g_object_ref0 (self->priv->source);
#line 1177 "DataObject.vala"
		return result;
#line 5577 "DataObject.c"
	}
#line 1182 "DataObject.vala"
	new_source = source_proxy_reconstitute (self, self->priv->object_id, self->priv->snapshot);
#line 1183 "DataObject.vala"
	g_assert (self->priv->source == new_source);
#line 1184 "DataObject.vala"
	g_assert (data_object_get_object_id (DATA_OBJECT (self->priv->source)) == self->priv->object_id);
#line 1185 "DataObject.vala"
	g_assert (data_collection_contains (DATA_COLLECTION (self->priv->membership), DATA_OBJECT (self->priv->source)));
#line 5587 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
	_g_object_unref0 (new_source);
#line 1187 "DataObject.vala"
	return result;
#line 5592 "DataObject.c"
}


#line 1190 "DataObject.vala"
static void source_proxy_on_destroyed (SourceProxy* self) {
#line 1190 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1191 "DataObject.vala"
	g_assert (self->priv->source != NULL);
#line 1194 "DataObject.vala"
	source_proxy_drop_source (self);
#line 1196 "DataObject.vala"
	source_proxy_notify_dehydrated (self);
#line 5606 "DataObject.c"
}


#line 1199 "DataObject.vala"
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added) {
#line 1199 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1199 "DataObject.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1201 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 1202 "DataObject.vala"
		return;
#line 5620 "DataObject.c"
	}
	{
		GeeIterator* _object_it;
#line 1204 "DataObject.vala"
		_object_it = gee_iterable_iterator (added);
#line 1204 "DataObject.vala"
		while (TRUE) {
#line 5628 "DataObject.c"
			DataObject* object;
#line 1204 "DataObject.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1204 "DataObject.vala"
				break;
#line 5634 "DataObject.c"
			}
#line 1204 "DataObject.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1206 "DataObject.vala"
			if (data_object_get_object_id (object) != self->priv->object_id) {
#line 5640 "DataObject.c"
				_g_object_unref0 (object);
#line 1207 "DataObject.vala"
				continue;
#line 5644 "DataObject.c"
			}
#line 1210 "DataObject.vala"
			source_proxy_set_source (self, DATA_SOURCE (object));
#line 1212 "DataObject.vala"
			source_proxy_notify_reconstituted (self, DATA_SOURCE (object));
#line 5650 "DataObject.c"
			_g_object_unref0 (object);
#line 1214 "DataObject.vala"
			break;
#line 5654 "DataObject.c"
		}
		_g_object_unref0 (_object_it);
	}
}


#line 1104 "DataObject.vala"
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source) {
#line 1104 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 1104 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5667 "DataObject.c"
}


#line 1109 "DataObject.vala"
static void source_proxy_real_dehydrated (SourceProxy* self) {
#line 1109 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 5675 "DataObject.c"
}


#line 1114 "DataObject.vala"
static void source_proxy_real_broken (SourceProxy* self) {
#line 1114 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 5683 "DataObject.c"
}


static void value_source_proxy_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_proxy_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_proxy_unref (value->data[0].v_pointer);
	}
}


static void value_source_proxy_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_proxy_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_proxy_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceProxy* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_proxy_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_proxy_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceProxy** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_proxy_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceProxy* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_proxy (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_proxy_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


void value_take_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


static void source_proxy_class_init (SourceProxyClass * klass) {
	source_proxy_parent_class = g_type_class_peek_parent (klass);
	SOURCE_PROXY_CLASS (klass)->finalize = source_proxy_finalize;
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
	SOURCE_PROXY_CLASS (klass)->reconstitute = source_proxy_real_reconstitute;
	SOURCE_PROXY_CLASS (klass)->notify_reconstituted = source_proxy_real_notify_reconstituted;
	SOURCE_PROXY_CLASS (klass)->notify_dehydrated = source_proxy_real_notify_dehydrated;
	SOURCE_PROXY_CLASS (klass)->notify_broken = source_proxy_real_notify_broken;
	SOURCE_PROXY_CLASS (klass)->reconstituted = source_proxy_real_reconstituted;
	SOURCE_PROXY_CLASS (klass)->dehydrated = source_proxy_real_dehydrated;
	SOURCE_PROXY_CLASS (klass)->broken = source_proxy_real_broken;
	g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_proxy_instance_init (SourceProxy * self) {
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_proxy_finalize (SourceProxy* obj) {
	SourceProxy * self;
	self = SOURCE_PROXY (obj);
	{
		guint _tmp0_;
#line 1133 "DataObject.vala"
		source_proxy_drop_source (self);
#line 1134 "DataObject.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1134 "DataObject.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->membership), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 5831 "DataObject.c"
	}
	_g_free0 (self->priv->source_string);
	_g_object_unref0 (self->priv->source);
	_source_snapshot_unref0 (self->priv->snapshot);
	_data_collection_unref0 (self->priv->membership);
}


GType source_proxy_get_type (void) {
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer source_proxy_ref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_proxy_unref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1117 "DataObject.vala"
SourceProxy* proxyable_get_proxy (Proxyable* self) {
#line 1117 "DataObject.vala"
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
#line 5876 "DataObject.c"
}


static void proxyable_base_init (ProxyableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType proxyable_get_type (void) {
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


#line 1252 "DataObject.vala"
DataView* data_view_construct (GType object_type, DataSource* source) {
#line 5902 "DataObject.c"
	DataView * self = NULL;
	DataSource* _tmp0_;
#line 1252 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1252 "DataObject.vala"
	self = (DataView*) data_object_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 1253 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 1257 "DataObject.vala"
	data_source_internal_subscribe (source, self);
#line 5913 "DataObject.c"
	return self;
}


#line 1252 "DataObject.vala"
DataView* data_view_new (DataSource* source) {
#line 1252 "DataObject.vala"
	return data_view_construct (TYPE_DATA_VIEW, source);
#line 5922 "DataObject.c"
}


#line 1267 "DataObject.vala"
static char* data_view_real_get_name (DataObject* base) {
#line 5928 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	self = DATA_VIEW (base);
	result = (_tmp1_ = g_strdup_printf ("View of %s", _tmp0_ = data_object_get_name (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp0_), _tmp1_);
#line 1268 "DataObject.vala"
	return result;
#line 5937 "DataObject.c"
}


#line 1271 "DataObject.vala"
static char* data_view_real_to_string (DataObject* base) {
#line 5943 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	self = DATA_VIEW (base);
	result = (_tmp2_ = g_strdup_printf ("DataView %s [DataSource %s]", _tmp0_ = data_object_get_name (DATA_OBJECT (self)), _tmp1_ = data_object_to_string (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
#line 1272 "DataObject.vala"
	return result;
#line 5953 "DataObject.c"
}


#line 1275 "DataObject.vala"
DataSource* data_view_get_source (DataView* self) {
#line 5959 "DataObject.c"
	DataSource* result = NULL;
#line 1275 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), NULL);
#line 5963 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
#line 1276 "DataObject.vala"
	return result;
#line 5967 "DataObject.c"
}


#line 1279 "DataObject.vala"
gboolean data_view_is_selected (DataView* self) {
#line 5973 "DataObject.c"
	gboolean result = FALSE;
#line 1279 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 5977 "DataObject.c"
	result = self->priv->selected;
#line 1280 "DataObject.vala"
	return result;
#line 5981 "DataObject.c"
}


#line 1284 "DataObject.vala"
void data_view_internal_set_selected (DataView* self, gboolean selected) {
#line 1284 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1285 "DataObject.vala"
	if (self->priv->selected == selected) {
#line 1286 "DataObject.vala"
		return;
#line 5993 "DataObject.c"
	}
#line 1288 "DataObject.vala"
	self->priv->selected = selected;
#line 1289 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", selected);
#line 5999 "DataObject.c"
}


#line 1293 "DataObject.vala"
gboolean data_view_internal_toggle (DataView* self) {
#line 6005 "DataObject.c"
	gboolean result = FALSE;
#line 1293 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 1294 "DataObject.vala"
	self->priv->selected = !self->priv->selected;
#line 1295 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", self->priv->selected);
#line 6013 "DataObject.c"
	result = self->priv->selected;
#line 1297 "DataObject.vala"
	return result;
#line 6017 "DataObject.c"
}


#line 1300 "DataObject.vala"
gboolean data_view_is_visible (DataView* self) {
#line 6023 "DataObject.c"
	gboolean result = FALSE;
#line 1300 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 6027 "DataObject.c"
	result = self->priv->visible;
#line 1301 "DataObject.vala"
	return result;
#line 6031 "DataObject.c"
}


#line 1305 "DataObject.vala"
void data_view_internal_set_visible (DataView* self, gboolean visible) {
#line 1305 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1306 "DataObject.vala"
	if (self->priv->visible == visible) {
#line 1307 "DataObject.vala"
		return;
#line 6043 "DataObject.c"
	}
#line 1309 "DataObject.vala"
	self->priv->visible = visible;
#line 1310 "DataObject.vala"
	g_signal_emit_by_name (self, "visibility-changed", visible);
#line 6049 "DataObject.c"
}


#line 1313 "DataObject.vala"
static void data_view_real_notify_view_altered (DataView* self) {
#line 6055 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 1313 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1315 "DataObject.vala"
	if (!self->priv->visible) {
#line 1316 "DataObject.vala"
		return;
#line 6064 "DataObject.c"
	}
#line 1318 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 1319 "DataObject.vala"
	if (vc != NULL) {
#line 1320 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 1321 "DataObject.vala"
			g_signal_emit_by_name (self, "view-altered");
#line 6074 "DataObject.c"
		}
#line 1324 "DataObject.vala"
		view_collection_internal_notify_view_altered (vc, self);
#line 6078 "DataObject.c"
	} else {
#line 1326 "DataObject.vala"
		g_signal_emit_by_name (self, "view-altered");
#line 6082 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 1252 "DataObject.vala"
void data_view_notify_view_altered (DataView* self) {
#line 1252 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_view_altered (self);
#line 6092 "DataObject.c"
}


#line 1330 "DataObject.vala"
static void data_view_real_notify_geometry_altered (DataView* self) {
#line 6098 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 1330 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1332 "DataObject.vala"
	if (!self->priv->visible) {
#line 1333 "DataObject.vala"
		return;
#line 6107 "DataObject.c"
	}
#line 1335 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 1336 "DataObject.vala"
	if (vc != NULL) {
#line 1337 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 1338 "DataObject.vala"
			g_signal_emit_by_name (self, "geometry-altered");
#line 6117 "DataObject.c"
		}
#line 1341 "DataObject.vala"
		view_collection_internal_notify_geometry_altered (vc, self);
#line 6121 "DataObject.c"
	} else {
#line 1343 "DataObject.vala"
		g_signal_emit_by_name (self, "geometry-altered");
#line 6125 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 1252 "DataObject.vala"
void data_view_notify_geometry_altered (DataView* self) {
#line 1252 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_geometry_altered (self);
#line 6135 "DataObject.c"
}


#line 1348 "DataObject.vala"
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source) {
#line 1348 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1348 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1349 "DataObject.vala"
	g_signal_emit_by_name (self, "unsubscribed", source);
#line 6147 "DataObject.c"
}


#line 1252 "DataObject.vala"
void data_view_notify_unsubscribed (DataView* self, DataSource* source) {
#line 1252 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_unsubscribed (self, source);
#line 6155 "DataObject.c"
}


#line 1353 "DataObject.vala"
static void data_view_real_notify_source_unlinking (DataView* self, SourceCollection* sources) {
#line 6161 "DataObject.c"
	ViewCollection* membership;
#line 1353 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1353 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1354 "DataObject.vala"
	membership = VIEW_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 1355 "DataObject.vala"
	if (membership != NULL) {
#line 1356 "DataObject.vala"
		view_collection_internal_notify_unlinking (membership, self, sources);
#line 6173 "DataObject.c"
	}
	_data_collection_unref0 (membership);
}


#line 1252 "DataObject.vala"
void data_view_notify_source_unlinking (DataView* self, SourceCollection* sources) {
#line 1252 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_source_unlinking (self, sources);
#line 6183 "DataObject.c"
}


#line 1360 "DataObject.vala"
static void data_view_real_notify_source_relinked (DataView* self, SourceCollection* sources) {
#line 6189 "DataObject.c"
	ViewCollection* membership;
#line 1360 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1360 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1361 "DataObject.vala"
	membership = VIEW_COLLECTION (data_object_get_membership (DATA_OBJECT (self)));
#line 1362 "DataObject.vala"
	if (membership != NULL) {
#line 1363 "DataObject.vala"
		view_collection_internal_notify_relinked (membership, self, sources);
#line 6201 "DataObject.c"
	}
	_data_collection_unref0 (membership);
}


#line 1252 "DataObject.vala"
void data_view_notify_source_relinked (DataView* self, SourceCollection* sources) {
#line 1252 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_source_relinked (self, sources);
#line 6211 "DataObject.c"
}


#line 1233 "DataObject.vala"
static void data_view_real_state_changed (DataView* self, gboolean selected) {
#line 1233 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 6219 "DataObject.c"
}


#line 1237 "DataObject.vala"
static void data_view_real_visibility_changed (DataView* self, gboolean visible) {
#line 1237 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 6227 "DataObject.c"
}


#line 1241 "DataObject.vala"
static void data_view_real_view_altered (DataView* self) {
#line 1241 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 6235 "DataObject.c"
}


#line 1246 "DataObject.vala"
static void data_view_real_geometry_altered (DataView* self) {
#line 1246 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 6243 "DataObject.c"
}


#line 1249 "DataObject.vala"
static void data_view_real_unsubscribed (DataView* self, DataSource* source) {
#line 1249 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 1249 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 6253 "DataObject.c"
}


static void data_view_class_init (DataViewClass * klass) {
	data_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataViewPrivate));
	DATA_OBJECT_CLASS (klass)->get_name = data_view_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_view_real_to_string;
	DATA_VIEW_CLASS (klass)->notify_view_altered = data_view_real_notify_view_altered;
	DATA_VIEW_CLASS (klass)->notify_geometry_altered = data_view_real_notify_geometry_altered;
	DATA_VIEW_CLASS (klass)->notify_unsubscribed = data_view_real_notify_unsubscribed;
	DATA_VIEW_CLASS (klass)->notify_source_unlinking = data_view_real_notify_source_unlinking;
	DATA_VIEW_CLASS (klass)->notify_source_relinked = data_view_real_notify_source_relinked;
	DATA_VIEW_CLASS (klass)->state_changed = data_view_real_state_changed;
	DATA_VIEW_CLASS (klass)->visibility_changed = data_view_real_visibility_changed;
	DATA_VIEW_CLASS (klass)->view_altered = data_view_real_view_altered;
	DATA_VIEW_CLASS (klass)->geometry_altered = data_view_real_geometry_altered;
	DATA_VIEW_CLASS (klass)->unsubscribed = data_view_real_unsubscribed;
	G_OBJECT_CLASS (klass)->finalize = data_view_finalize;
	g_signal_new ("state_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, state_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("visibility_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("view_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, view_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("geometry_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("unsubscribed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, unsubscribed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
}


static void data_view_instance_init (DataView * self) {
	self->priv = DATA_VIEW_GET_PRIVATE (self);
	self->priv->selected = FALSE;
	self->priv->visible = TRUE;
}


static void data_view_finalize (GObject* obj) {
	DataView * self;
	self = DATA_VIEW (obj);
	{
#line 1264 "DataObject.vala"
		data_source_internal_unsubscribe (self->priv->source, self);
#line 6294 "DataObject.c"
	}
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (data_view_parent_class)->finalize (obj);
}


GType data_view_get_type (void) {
	static volatile gsize data_view_type_id__volatile = 0;
	if (g_once_init_enter (&data_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataView), 0, (GInstanceInitFunc) data_view_instance_init, NULL };
		GType data_view_type_id;
		data_view_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataView", &g_define_type_info, 0);
		g_once_init_leave (&data_view_type_id__volatile, data_view_type_id);
	}
	return data_view_type_id__volatile;
}


#line 1371 "DataObject.vala"
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source) {
#line 6315 "DataObject.c"
	ThumbnailView * self = NULL;
#line 1371 "DataObject.vala"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (source), NULL);
#line 1372 "DataObject.vala"
	self = (ThumbnailView*) data_view_construct (object_type, DATA_SOURCE (source));
#line 6321 "DataObject.c"
	return self;
}


#line 1371 "DataObject.vala"
ThumbnailView* thumbnail_view_new (ThumbnailSource* source) {
#line 1371 "DataObject.vala"
	return thumbnail_view_construct (TYPE_THUMBNAIL_VIEW, source);
#line 6330 "DataObject.c"
}


#line 1375 "DataObject.vala"
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self) {
#line 1375 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 1377 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 6340 "DataObject.c"
}


#line 1371 "DataObject.vala"
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self) {
#line 1371 "DataObject.vala"
	THUMBNAIL_VIEW_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 6348 "DataObject.c"
}


#line 1368 "DataObject.vala"
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self) {
#line 1368 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 6356 "DataObject.c"
}


static void thumbnail_view_class_init (ThumbnailViewClass * klass) {
	thumbnail_view_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_VIEW_CLASS (klass)->notify_thumbnail_altered = thumbnail_view_real_notify_thumbnail_altered;
	THUMBNAIL_VIEW_CLASS (klass)->thumbnail_altered = thumbnail_view_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailViewClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_view_instance_init (ThumbnailView * self) {
}


GType thumbnail_view_get_type (void) {
	static volatile gsize thumbnail_view_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailView), 0, (GInstanceInitFunc) thumbnail_view_instance_init, NULL };
		GType thumbnail_view_type_id;
		thumbnail_view_type_id = g_type_register_static (TYPE_DATA_VIEW, "ThumbnailView", &g_define_type_info, 0);
		g_once_init_leave (&thumbnail_view_type_id__volatile, thumbnail_view_type_id);
	}
	return thumbnail_view_type_id__volatile;
}


#line 1382 "DataObject.vala"
PhotoView* photo_view_construct (GType object_type, PhotoSource* source) {
#line 6386 "DataObject.c"
	PhotoView * self = NULL;
#line 1382 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_SOURCE (source), NULL);
#line 1383 "DataObject.vala"
	self = (PhotoView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 6392 "DataObject.c"
	return self;
}


#line 1382 "DataObject.vala"
PhotoView* photo_view_new (PhotoSource* source) {
#line 1382 "DataObject.vala"
	return photo_view_construct (TYPE_PHOTO_VIEW, source);
#line 6401 "DataObject.c"
}


#line 1386 "DataObject.vala"
PhotoSource* photo_view_get_photo_source (PhotoView* self) {
#line 6407 "DataObject.c"
	PhotoSource* result = NULL;
#line 1386 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_VIEW (self), NULL);
#line 6411 "DataObject.c"
	result = PHOTO_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 1387 "DataObject.vala"
	return result;
#line 6415 "DataObject.c"
}


static void photo_view_class_init (PhotoViewClass * klass) {
	photo_view_parent_class = g_type_class_peek_parent (klass);
}


static void photo_view_instance_init (PhotoView * self) {
}


GType photo_view_get_type (void) {
	static volatile gsize photo_view_type_id__volatile = 0;
	if (g_once_init_enter (&photo_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoView), 0, (GInstanceInitFunc) photo_view_instance_init, NULL };
		GType photo_view_type_id;
		photo_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "PhotoView", &g_define_type_info, 0);
		g_once_init_leave (&photo_view_type_id__volatile, photo_view_type_id);
	}
	return photo_view_type_id__volatile;
}


#line 1392 "DataObject.vala"
VideoView* video_view_construct (GType object_type, VideoSource* source) {
#line 6442 "DataObject.c"
	VideoView * self = NULL;
#line 1392 "DataObject.vala"
	g_return_val_if_fail (IS_VIDEO_SOURCE (source), NULL);
#line 1393 "DataObject.vala"
	self = (VideoView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 6448 "DataObject.c"
	return self;
}


#line 1392 "DataObject.vala"
VideoView* video_view_new (VideoSource* source) {
#line 1392 "DataObject.vala"
	return video_view_construct (TYPE_VIDEO_VIEW, source);
#line 6457 "DataObject.c"
}


#line 1396 "DataObject.vala"
VideoSource* video_view_get_video_source (VideoView* self) {
#line 6463 "DataObject.c"
	VideoSource* result = NULL;
#line 1396 "DataObject.vala"
	g_return_val_if_fail (IS_VIDEO_VIEW (self), NULL);
#line 6467 "DataObject.c"
	result = VIDEO_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 1397 "DataObject.vala"
	return result;
#line 6471 "DataObject.c"
}


static void video_view_class_init (VideoViewClass * klass) {
	video_view_parent_class = g_type_class_peek_parent (klass);
}


static void video_view_instance_init (VideoView * self) {
}


GType video_view_get_type (void) {
	static volatile gsize video_view_type_id__volatile = 0;
	if (g_once_init_enter (&video_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoView), 0, (GInstanceInitFunc) video_view_instance_init, NULL };
		GType video_view_type_id;
		video_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "VideoView", &g_define_type_info, 0);
		g_once_init_leave (&video_view_type_id__volatile, video_view_type_id);
	}
	return video_view_type_id__volatile;
}


#line 1402 "DataObject.vala"
EventView* event_view_construct (GType object_type, EventSource* source) {
#line 6498 "DataObject.c"
	EventView * self = NULL;
#line 1402 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_SOURCE (source), NULL);
#line 1403 "DataObject.vala"
	self = (EventView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 6504 "DataObject.c"
	return self;
}


#line 1402 "DataObject.vala"
EventView* event_view_new (EventSource* source) {
#line 1402 "DataObject.vala"
	return event_view_construct (TYPE_EVENT_VIEW, source);
#line 6513 "DataObject.c"
}


#line 1406 "DataObject.vala"
EventSource* event_view_get_event_source (EventView* self) {
#line 6519 "DataObject.c"
	EventSource* result = NULL;
#line 1406 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_VIEW (self), NULL);
#line 6523 "DataObject.c"
	result = EVENT_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 1407 "DataObject.vala"
	return result;
#line 6527 "DataObject.c"
}


static void event_view_class_init (EventViewClass * klass) {
	event_view_parent_class = g_type_class_peek_parent (klass);
}


static void event_view_instance_init (EventView * self) {
}


GType event_view_get_type (void) {
	static volatile gsize event_view_type_id__volatile = 0;
	if (g_once_init_enter (&event_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventView), 0, (GInstanceInitFunc) event_view_instance_init, NULL };
		GType event_view_type_id;
		event_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "EventView", &g_define_type_info, 0);
		g_once_init_leave (&event_view_type_id__volatile, event_view_type_id);
	}
	return event_view_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_data_collection (param_values + 1), data2);
}



