/* DirectoryMonitor.c generated by valac 0.10.3, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* file_children;
	GeeArrayList* dir_children;
	gint count;
	GeeIterator* _dir_child_it;
	GFile* dir_child;
	GFileInfo* dir_info;
	char* _tmp0_;
	char* _tmp1_;
	GFile* _tmp2_;
	GeeIterator* _file_child_it;
	GFile* file_child;
	GFileInfo* file_info;
	char* _tmp3_;
	char* _tmp4_;
	GFile* _tmp5_;
	gboolean updated;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* file_children;
	GeeArrayList* dir_children;
	gint count;
	GeeIterator* _dir_child_it;
	GFile* dir_child;
	GeeIterator* _file_child_it;
	GFile* file_child;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	char* _tmp0_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp2_;
	char* _tmp3_;
	GError * err;
	char* _tmp4_;
	char* _tmp7_;
	char* _tmp5_;
	gboolean _tmp6_;
	char* _tmp8_;
	GEnumValue* _tmp9_;
	char* _tmp10_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* enumerator;
	gboolean _tmp11_;
	GList* infos;
	GFile* _tmp12_;
	char* _tmp13_;
	GeeHashMap* _tmp14_;
	GFile* _tmp15_;
	GeeHashMap* _tmp16_;
	GFile* _tmp17_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* info;
	char* _tmp18_;
	GError * err2;
	gboolean _tmp19_;
	GeeIterator* _subdir_it;
	GeeSet* _tmp20_;
	GeeIterator* _tmp21_;
	GFile* subdir;
	GFileInfo* _tmp22_;
	GFileInfo* _tmp23_;
	GError * _inner_error_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMapIterator* iter;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};


static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static gpointer directory_monitor_file_info_map_parent_class = NULL;
static gpointer directory_monitor_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define DIRECTORY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIRECTORY_MONITOR, DirectoryMonitorPrivate))
enum  {
	DIRECTORY_MONITOR_DUMMY_PROPERTY
};
static GType directory_monitor_ftype_get_type (void) G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
void directory_monitor_mdbg (const char* msg);
gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const char* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const char* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* data);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
gboolean directory_monitor_has_started (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self, GError** error);
static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
static void directory_monitor_explore_async_data_free (gpointer _data);
static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery);
char* get_file_info_id (GFileInfo* info);
static void _g_list_free_g_object_unref (GList* self);
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static void directory_monitor_notify_directory_files_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* data);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static char* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
gulong now_ms (void);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable);
void directory_monitor_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root);
void directory_monitor_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
void directory_monitor_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_discovery_failed (DirectoryMonitor* self, const char* reason);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const char* reason);
void directory_monitor_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
void directory_monitor_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file);
void directory_monitor_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file);
void directory_monitor_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir);
void directory_monitor_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
void directory_monitor_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_closed (DirectoryMonitor* self);
static void directory_monitor_real_closed (DirectoryMonitor* self);
enum  {
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj);
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, char** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
static void directory_monitor_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static GType directory_monitor_ftype_get_type (void) {
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 451 "DirectoryMonitor.vala"
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
#line 577 "DirectoryMonitor.c"
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
#line 451 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 451 "DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 452 "DirectoryMonitor.vala"
	self->priv->root = (_tmp0_ = _g_object_ref0 (root), _g_object_unref0 (self->priv->root), _tmp0_);
#line 453 "DirectoryMonitor.vala"
	self->priv->recurse = recurse;
#line 454 "DirectoryMonitor.vala"
	self->priv->monitoring = monitoring;
#line 590 "DirectoryMonitor.c"
	return self;
}


#line 451 "DirectoryMonitor.vala"
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 451 "DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 599 "DirectoryMonitor.c"
}


#line 457 "DirectoryMonitor.vala"
void directory_monitor_mdbg (const char* msg) {
#line 457 "DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 607 "DirectoryMonitor.c"
}


#line 463 "DirectoryMonitor.vala"
gboolean directory_monitor_is_recursive (DirectoryMonitor* self) {
#line 613 "DirectoryMonitor.c"
	gboolean result = FALSE;
#line 463 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 617 "DirectoryMonitor.c"
	result = self->priv->recurse;
#line 464 "DirectoryMonitor.vala"
	return result;
#line 621 "DirectoryMonitor.c"
}


#line 467 "DirectoryMonitor.vala"
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self) {
#line 627 "DirectoryMonitor.c"
	gboolean result = FALSE;
#line 467 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 631 "DirectoryMonitor.c"
	result = self->priv->monitoring;
#line 468 "DirectoryMonitor.vala"
	return result;
#line 635 "DirectoryMonitor.c"
}


#line 471 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 471 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 472 "DirectoryMonitor.vala"
	g_assert (g_file_equal (self->priv->root, root));
#line 474 "DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 475 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-deleted", root);
#line 651 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
#line 659 "DirectoryMonitor.c"
}


#line 478 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 665 "DirectoryMonitor.c"
	gboolean removed;
	gboolean updated;
	GFile* _tmp0_;
#line 478 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 478 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 478 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 478 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 479 "DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (self->priv->files, old_root, NULL);
#line 480 "DirectoryMonitor.vala"
	g_assert (removed);
#line 482 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, new_root, new_root_info);
#line 483 "DirectoryMonitor.vala"
	g_assert (updated);
#line 485 "DirectoryMonitor.vala"
	self->priv->root = (_tmp0_ = _g_object_ref0 (new_root), _g_object_unref0 (self->priv->root), _tmp0_);
#line 487 "DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
#line 689 "DirectoryMonitor.c"
}


#line 490 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 695 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 490 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 490 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 490 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 490 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 491 "DirectoryMonitor.vala"
	g_assert (g_file_equal (self->priv->root, old_root));
#line 493 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp2_ = g_strdup_printf ("root moved: %s -> %s", _tmp0_ = g_file_get_path (old_root), _tmp1_ = g_file_get_path (new_root)));
#line 711 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 494 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-moved", old_root, new_root, new_root_info);
#line 717 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
#line 725 "DirectoryMonitor.c"
}


#line 497 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self) {
#line 497 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 498 "DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 499 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-started");
#line 737 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_started (DirectoryMonitor* self) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
#line 745 "DirectoryMonitor.c"
}


#line 502 "DirectoryMonitor.vala"
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 751 "DirectoryMonitor.c"
	gboolean updated;
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 502 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 503 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 504 "DirectoryMonitor.vala"
	g_assert (updated);
#line 506 "DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, file, info);
#line 765 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
#line 773 "DirectoryMonitor.c"
}


#line 509 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 779 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 509 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 509 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 509 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 510 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file discovered: %s", _tmp0_ = g_file_get_path (file)));
#line 790 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 511 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-discovered", file, info);
#line 795 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
#line 803 "DirectoryMonitor.c"
}


#line 514 "DirectoryMonitor.vala"
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 809 "DirectoryMonitor.c"
	gboolean updated;
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 514 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 515 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 516 "DirectoryMonitor.vala"
	g_assert (updated);
#line 518 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, dir, info);
#line 823 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
#line 831 "DirectoryMonitor.c"
}


#line 521 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 837 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 521 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 521 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 521 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 522 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory discovered: %s", _tmp0_ = g_file_get_path (dir)));
#line 848 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 523 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-discovered", dir, info);
#line 853 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
#line 861 "DirectoryMonitor.c"
}


#line 526 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 526 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 526 "DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 527 "DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:527: discovery failed: %s", reason);
#line 528 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-failed", reason);
#line 875 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
#line 883 "DirectoryMonitor.c"
}


#line 531 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self) {
#line 531 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 532 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-completed");
#line 893 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
#line 901 "DirectoryMonitor.c"
}


#line 535 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 907 "DirectoryMonitor.c"
	GFile* old_file;
	GFileInfo* old_file_info;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_;
	GFileInfo* _tmp5_;
#line 535 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 535 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 535 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 922 "DirectoryMonitor.c"
	old_file = NULL;
	old_file_info = NULL;
#line 538 "DirectoryMonitor.vala"
	if ((_tmp4_ = (_tmp1_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp3_), old_file = (_tmp2_ = _tmp0_, _g_object_unref0 (old_file), _tmp2_), _tmp1_), old_file_info = (_tmp5_ = _tmp3_, _g_object_unref0 (old_file_info), _tmp5_), _tmp4_)) {
#line 539 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, old_file, file, info);
#line 929 "DirectoryMonitor.c"
	} else {
		gboolean updated;
#line 541 "DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 542 "DirectoryMonitor.vala"
		g_assert (updated);
#line 544 "DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, file, info);
#line 938 "DirectoryMonitor.c"
	}
	_g_object_unref0 (old_file_info);
	_g_object_unref0 (old_file);
}


#line 548 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 947 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 548 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 548 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 548 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 549 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file created: %s", _tmp0_ = g_file_get_path (file)));
#line 958 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 550 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-created", file, info);
#line 963 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
#line 971 "DirectoryMonitor.c"
}


#line 553 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 977 "DirectoryMonitor.c"
	gboolean updated;
#line 553 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 553 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 553 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 553 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 556 "DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (self->priv->files, old_file, NULL);
#line 558 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, new_file, new_file_info);
#line 559 "DirectoryMonitor.vala"
	g_assert (updated);
#line 561 "DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
#line 995 "DirectoryMonitor.c"
}


#line 564 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 1001 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 564 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 564 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 564 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 564 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 565 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp2_ = g_strdup_printf ("file moved: %s -> %s", _tmp0_ = g_file_get_path (old_file), _tmp1_ = g_file_get_path (new_file)));
#line 1015 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 566 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-moved", old_file, new_file, new_file_info);
#line 1021 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1029 "DirectoryMonitor.c"
}


#line 569 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 1035 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 569 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 569 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 570 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file altered: %s", _tmp0_ = g_file_get_path (file)));
#line 1044 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 571 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-altered", file);
#line 1049 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
#line 1057 "DirectoryMonitor.c"
}


#line 574 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 1063 "DirectoryMonitor.c"
	gboolean updated;
#line 574 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 574 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 574 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 575 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, file, info);
#line 576 "DirectoryMonitor.vala"
	g_assert (updated);
#line 578 "DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, file, info);
#line 1077 "DirectoryMonitor.c"
}


#line 581 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 1083 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 581 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 581 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 581 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 582 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file alteration completed: %s", _tmp0_ = g_file_get_path (file)));
#line 1094 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 583 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-alteration-completed", file, info);
#line 1099 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
#line 1107 "DirectoryMonitor.c"
}


#line 586 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 1113 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 586 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 586 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 587 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file attributes altered: %s", _tmp0_ = g_file_get_path (file)));
#line 1122 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 588 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-attributes-altered", file);
#line 1127 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file);
#line 1135 "DirectoryMonitor.c"
}


#line 591 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 1141 "DirectoryMonitor.c"
	gboolean removed;
#line 591 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 591 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 592 "DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (self->priv->files, file, NULL);
#line 593 "DirectoryMonitor.vala"
	g_assert (removed);
#line 595 "DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, file);
#line 1153 "DirectoryMonitor.c"
}


#line 598 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 1159 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 598 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 598 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 599 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("file deleted: %s", _tmp0_ = g_file_get_path (file)));
#line 1168 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 600 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-deleted", file);
#line 1173 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
#line 1181 "DirectoryMonitor.c"
}


#line 603 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1187 "DirectoryMonitor.c"
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_;
	GFileInfo* _tmp5_;
#line 603 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 603 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 603 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1202 "DirectoryMonitor.c"
	old_dir = NULL;
	old_dir_info = NULL;
#line 606 "DirectoryMonitor.vala"
	if ((_tmp4_ = (_tmp1_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp3_), old_dir = (_tmp2_ = _tmp0_, _g_object_unref0 (old_dir), _tmp2_), _tmp1_), old_dir_info = (_tmp5_ = _tmp3_, _g_object_unref0 (old_dir_info), _tmp5_), _tmp4_)) {
#line 612 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (self->priv->files, old_dir, self->priv->parent_moved);
#line 614 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, old_dir, old_dir_info, dir, info);
#line 1211 "DirectoryMonitor.c"
	} else {
		gboolean updated;
#line 616 "DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 617 "DirectoryMonitor.vala"
		g_assert (updated);
#line 619 "DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, dir, info);
#line 1220 "DirectoryMonitor.c"
	}
	_g_object_unref0 (old_dir_info);
	_g_object_unref0 (old_dir);
}


#line 623 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1229 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 623 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 623 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 623 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 624 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory created: %s", _tmp0_ = g_file_get_path (dir)));
#line 1240 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 625 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-created", dir, info);
#line 1245 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
#line 1253 "DirectoryMonitor.c"
}


#line 628 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info) {
#line 628 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 628 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 628 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (old_dir_info));
#line 628 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 628 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 630 "DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, old_dir, old_dir_info, new_dir, new_dir_info, NULL, NULL);
#line 1271 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data;
	data = _data;
	_g_object_unref0 (data->old_dir);
	_g_object_unref0 (data->old_dir_info);
	_g_object_unref0 (data->new_dir);
	_g_object_unref0 (data->new_dir_info);
	g_object_unref (data->self);
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, data);
}


static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_internal_notify_directory_moved);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
	_data_->self = g_object_ref (self);
	_data_->old_dir = _g_object_ref0 (old_dir);
	_data_->old_dir_info = _g_object_ref0 (old_dir_info);
	_data_->new_dir = _g_object_ref0 (new_dir);
	_data_->new_dir_info = _g_object_ref0 (new_dir_info);
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
}


static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data;
	data = _user_data_;
	data->_res_ = _res_;
	directory_monitor_async_internal_notify_directory_moved_co (data);
}


#line 633 "DirectoryMonitor.vala"
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self) {
#line 1317 "DirectoryMonitor.c"
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
	return result;
}


static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
	}
	_state_0:
	data->file_children = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->dir_children = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->count = directory_monitor_file_info_map_get_children (data->self->priv->files, data->old_dir, GEE_COLLECTION (data->file_children), GEE_COLLECTION (data->dir_children));
#line 638 "DirectoryMonitor.vala"
	if (data->count > 0) {
#line 1341 "DirectoryMonitor.c"
		{
			data->_dir_child_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->dir_children));
#line 642 "DirectoryMonitor.vala"
			while (TRUE) {
#line 642 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_dir_child_it)) {
#line 642 "DirectoryMonitor.vala"
					break;
#line 1350 "DirectoryMonitor.c"
				}
				data->dir_child = (GFile*) gee_iterator_get (data->_dir_child_it);
				data->dir_info = directory_monitor_file_info_map_get_info (data->self->priv->files, data->dir_child);
#line 644 "DirectoryMonitor.vala"
				if (data->dir_info == NULL) {
#line 645 "DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:645: Unable to retrieve directory-moved info for" \
" %s", data->_tmp0_ = g_file_get_path (data->dir_child));
#line 1358 "DirectoryMonitor.c"
					_g_free0 (data->_tmp0_);
					_g_object_unref0 (data->dir_info);
					_g_object_unref0 (data->dir_child);
#line 647 "DirectoryMonitor.vala"
					continue;
#line 1364 "DirectoryMonitor.c"
				}
				data->_state_ = 2;
				directory_monitor_async_internal_notify_directory_moved (data->self, data->dir_child, data->dir_info, data->_tmp2_ = g_file_get_child (data->new_dir, data->_tmp1_ = g_file_get_basename (data->dir_child)), data->dir_info, directory_monitor_async_internal_notify_directory_moved_ready, data);
				return FALSE;
				_state_2:
#line 650 "DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (data->self, data->_res_);
#line 1372 "DirectoryMonitor.c"
				_g_object_unref0 (data->_tmp2_);
				_g_free0 (data->_tmp1_);
				_g_object_unref0 (data->dir_info);
				_g_object_unref0 (data->dir_child);
			}
			_g_object_unref0 (data->_dir_child_it);
		}
		{
			data->_file_child_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->file_children));
#line 655 "DirectoryMonitor.vala"
			while (TRUE) {
#line 655 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_file_child_it)) {
#line 655 "DirectoryMonitor.vala"
					break;
#line 1388 "DirectoryMonitor.c"
				}
				data->file_child = (GFile*) gee_iterator_get (data->_file_child_it);
				data->file_info = directory_monitor_file_info_map_get_info (data->self->priv->files, data->file_child);
#line 657 "DirectoryMonitor.vala"
				if (data->file_info == NULL) {
#line 658 "DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:658: Unable to retrieve directory-moved info for" \
" %s", data->_tmp3_ = g_file_get_path (data->file_child));
#line 1396 "DirectoryMonitor.c"
					_g_free0 (data->_tmp3_);
					_g_object_unref0 (data->file_info);
					_g_object_unref0 (data->file_child);
#line 660 "DirectoryMonitor.vala"
					continue;
#line 1402 "DirectoryMonitor.c"
				}
#line 663 "DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (data->self, data->file_child, data->_tmp5_ = g_file_get_child (data->new_dir, data->_tmp4_ = g_file_get_basename (data->file_child)), data->file_info);
#line 1406 "DirectoryMonitor.c"
				_g_object_unref0 (data->_tmp5_);
				_g_free0 (data->_tmp4_);
#line 666 "DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, data, NULL);
#line 1411 "DirectoryMonitor.c"
				data->_state_ = 3;
				return FALSE;
				_state_3:
				;
				_g_object_unref0 (data->file_info);
				_g_object_unref0 (data->file_child);
			}
			_g_object_unref0 (data->_file_child_it);
		}
	}
#line 673 "DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (data->self->priv->files, data->old_dir, NULL);
#line 1424 "DirectoryMonitor.c"
	data->updated = directory_monitor_file_info_map_update (data->self->priv->files, data->new_dir, data->new_dir_info);
#line 676 "DirectoryMonitor.vala"
	g_assert (data->updated);
#line 679 "DirectoryMonitor.vala"
	directory_monitor_remove_monitor (data->self, data->old_dir, data->old_dir_info);
#line 680 "DirectoryMonitor.vala"
	directory_monitor_add_monitor (data->self, data->new_dir, data->new_dir_info);
#line 682 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (data->self, data->old_dir, data->new_dir, data->new_dir_info);
#line 1434 "DirectoryMonitor.c"
	_g_object_unref0 (data->dir_children);
	_g_object_unref0 (data->file_children);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 685 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 1451 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 685 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 685 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 685 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 685 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 686 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp2_ = g_strdup_printf ("directory moved: %s -> %s", _tmp0_ = g_file_get_path (old_dir), _tmp1_ = g_file_get_path (new_dir)));
#line 1465 "DirectoryMonitor.c"
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 687 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-moved", old_dir, new_dir, new_dir_info);
#line 689 "DirectoryMonitor.vala"
	if (g_file_equal (old_dir, self->priv->root)) {
#line 690 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
#line 1475 "DirectoryMonitor.c"
	}
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 1484 "DirectoryMonitor.c"
}


#line 693 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 1490 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 693 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 693 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 694 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory altered: %s", _tmp0_ = g_file_get_path (dir)));
#line 1499 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 695 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-altered", dir);
#line 1504 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
#line 1512 "DirectoryMonitor.c"
}


#line 698 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1518 "DirectoryMonitor.c"
	gboolean updated;
#line 698 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 698 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 698 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 699 "DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (self->priv->files, dir, info);
#line 700 "DirectoryMonitor.vala"
	g_assert (updated);
#line 702 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
#line 1532 "DirectoryMonitor.c"
}


#line 705 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 1538 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 705 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 705 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 705 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 706 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory alteration completed: %s", _tmp0_ = g_file_get_path (dir)));
#line 1549 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 707 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-alteration-completed", dir, info);
#line 1554 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
#line 1562 "DirectoryMonitor.c"
}


#line 710 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 1568 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 710 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 710 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 711 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory attributes altered: %s", _tmp0_ = g_file_get_path (dir)));
#line 1577 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 712 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-attributes-altered", dir);
#line 1582 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir);
#line 1590 "DirectoryMonitor.c"
}


#line 715 "DirectoryMonitor.vala"
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 1596 "DirectoryMonitor.c"
	GFileInfo* info;
#line 715 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 715 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 716 "DirectoryMonitor.vala"
	info = directory_monitor_file_info_map_get_info (self->priv->files, dir);
#line 717 "DirectoryMonitor.vala"
	g_assert (info != NULL);
#line 720 "DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, dir, info);
#line 722 "DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, dir, FALSE, NULL, NULL);
#line 1610 "DirectoryMonitor.c"
	_g_object_unref0 (info);
}


static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	g_object_unref (data->self);
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, data);
}


static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_notify_directory_deleted);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
	_data_->self = g_object_ref (self);
	_data_->dir = _g_object_ref0 (dir);
	_data_->already_removed = already_removed;
	directory_monitor_async_notify_directory_deleted_co (_data_);
}


static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* data;
	data = _user_data_;
	data->_res_ = _res_;
	directory_monitor_async_notify_directory_deleted_co (data);
}


#line 725 "DirectoryMonitor.vala"
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self) {
#line 1652 "DirectoryMonitor.c"
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
	return result;
}


static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
	}
	_state_0:
	data->file_children = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->dir_children = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->count = directory_monitor_file_info_map_get_children (data->self->priv->files, data->dir, GEE_COLLECTION (data->file_children), GEE_COLLECTION (data->dir_children));
#line 736 "DirectoryMonitor.vala"
	if (data->count > 0) {
#line 1676 "DirectoryMonitor.c"
		{
			data->_dir_child_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->dir_children));
#line 744 "DirectoryMonitor.vala"
			while (TRUE) {
#line 744 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_dir_child_it)) {
#line 744 "DirectoryMonitor.vala"
					break;
#line 1685 "DirectoryMonitor.c"
				}
				data->dir_child = (GFile*) gee_iterator_get (data->_dir_child_it);
				data->_state_ = 4;
				directory_monitor_async_notify_directory_deleted (data->self, data->dir_child, FALSE, directory_monitor_async_notify_directory_deleted_ready, data);
				return FALSE;
				_state_4:
#line 745 "DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (data->self, data->_res_);
#line 1694 "DirectoryMonitor.c"
				_g_object_unref0 (data->dir_child);
			}
			_g_object_unref0 (data->_dir_child_it);
		}
		{
			data->_file_child_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->file_children));
#line 749 "DirectoryMonitor.vala"
			while (TRUE) {
#line 749 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_file_child_it)) {
#line 749 "DirectoryMonitor.vala"
					break;
#line 1707 "DirectoryMonitor.c"
				}
				data->file_child = (GFile*) gee_iterator_get (data->_file_child_it);
#line 750 "DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (data->self->priv->files, data->file_child, NULL);
#line 752 "DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (data->self, data->file_child);
#line 754 "DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, data, NULL);
#line 1716 "DirectoryMonitor.c"
				data->_state_ = 5;
				return FALSE;
				_state_5:
				;
				_g_object_unref0 (data->file_child);
			}
			_g_object_unref0 (data->_file_child_it);
		}
	}
#line 759 "DirectoryMonitor.vala"
	if (!data->already_removed) {
#line 760 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (data->self->priv->files, data->dir, NULL);
#line 1730 "DirectoryMonitor.c"
	}
#line 762 "DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (data->self, data->dir);
#line 1734 "DirectoryMonitor.c"
	_g_object_unref0 (data->dir_children);
	_g_object_unref0 (data->file_children);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 765 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 1751 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 765 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 765 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 766 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("directory deleted: %s", _tmp0_ = g_file_get_path (dir)));
#line 1760 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 767 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-deleted", dir);
#line 769 "DirectoryMonitor.vala"
	if (g_file_equal (dir, self->priv->root)) {
#line 770 "DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, dir);
#line 1769 "DirectoryMonitor.c"
	}
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
#line 1778 "DirectoryMonitor.c"
}


#line 773 "DirectoryMonitor.vala"
static void directory_monitor_real_notify_closed (DirectoryMonitor* self) {
#line 1784 "DirectoryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
#line 773 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 774 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("monitoring of %s closed", _tmp0_ = g_file_get_path (self->priv->root)));
#line 1791 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 775 "DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "closed");
#line 1796 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_notify_closed (DirectoryMonitor* self) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
#line 1804 "DirectoryMonitor.c"
}


#line 778 "DirectoryMonitor.vala"
GFile* directory_monitor_get_root (DirectoryMonitor* self) {
#line 1810 "DirectoryMonitor.c"
	GFile* result = NULL;
#line 778 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1814 "DirectoryMonitor.c"
	result = _g_object_ref0 (self->priv->root);
#line 779 "DirectoryMonitor.vala"
	return result;
#line 1818 "DirectoryMonitor.c"
}


#line 782 "DirectoryMonitor.vala"
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file) {
#line 1824 "DirectoryMonitor.c"
	gboolean result = FALSE;
#line 782 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 782 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1830 "DirectoryMonitor.c"
	result = g_file_has_prefix (file, self->priv->root);
#line 783 "DirectoryMonitor.vala"
	return result;
#line 1834 "DirectoryMonitor.c"
}


#line 786 "DirectoryMonitor.vala"
gboolean directory_monitor_has_started (DirectoryMonitor* self) {
#line 1840 "DirectoryMonitor.c"
	gboolean result = FALSE;
#line 786 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1844 "DirectoryMonitor.c"
	result = self->priv->started;
#line 787 "DirectoryMonitor.vala"
	return result;
#line 1848 "DirectoryMonitor.c"
}


#line 790 "DirectoryMonitor.vala"
void directory_monitor_start_discovery (DirectoryMonitor* self, GError** error) {
#line 790 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 791 "DirectoryMonitor.vala"
	g_assert (!self->priv->started);
#line 793 "DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 794 "DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 796 "DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 799 "DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 800 "DirectoryMonitor.vala"
	directory_monitor_explore_async (self, self->priv->root, NULL, TRUE, NULL, NULL);
#line 1868 "DirectoryMonitor.c"
}


#line 805 "DirectoryMonitor.vala"
static void directory_monitor_real_close (DirectoryMonitor* self) {
#line 805 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 807 "DirectoryMonitor.vala"
	g_cancellable_cancel (self->priv->cancellable);
#line 1878 "DirectoryMonitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _monitor_it;
#line 810 "DirectoryMonitor.vala"
		_monitor_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_values (GEE_MAP (self->priv->monitors)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 810 "DirectoryMonitor.vala"
		while (TRUE) {
#line 1887 "DirectoryMonitor.c"
			GFileMonitor* monitor;
#line 810 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 810 "DirectoryMonitor.vala"
				break;
#line 1893 "DirectoryMonitor.c"
			}
#line 810 "DirectoryMonitor.vala"
			monitor = (GFileMonitor*) gee_iterator_get (_monitor_it);
#line 811 "DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, monitor);
#line 1899 "DirectoryMonitor.c"
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 813 "DirectoryMonitor.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->monitors));
#line 815 "DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 1908 "DirectoryMonitor.c"
}


#line 451 "DirectoryMonitor.vala"
void directory_monitor_close (DirectoryMonitor* self) {
#line 451 "DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
#line 1916 "DirectoryMonitor.c"
}


#line 818 "DirectoryMonitor.vala"
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info) {
#line 1922 "DirectoryMonitor.c"
	DirectoryMonitorFType result = 0;
	GFileType file_type;
#line 818 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), 0);
#line 819 "DirectoryMonitor.vala"
	file_type = g_file_info_get_file_type (info);
#line 820 "DirectoryMonitor.vala"
	switch (file_type) {
#line 1931 "DirectoryMonitor.c"
		case G_FILE_TYPE_REGULAR:
		{
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 822 "DirectoryMonitor.vala"
			return result;
#line 1937 "DirectoryMonitor.c"
		}
		case G_FILE_TYPE_DIRECTORY:
		{
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 825 "DirectoryMonitor.vala"
			return result;
#line 1944 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp0_;
			char* _tmp1_;
#line 828 "DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp0_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), (int) file_type), (_tmp0_ != NULL) ? _tmp0_->value_name : NULL)));
#line 1952 "DirectoryMonitor.c"
			_g_free0 (_tmp1_);
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 829 "DirectoryMonitor.vala"
			return result;
#line 1957 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_explore_async_data_free (gpointer _data) {
	DirectoryMonitorExploreAsyncData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	_g_object_unref0 (data->dir_info);
	g_object_unref (data->self);
	g_slice_free (DirectoryMonitorExploreAsyncData, data);
}


static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_explore_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
	_data_->self = g_object_ref (self);
	_data_->dir = _g_object_ref0 (dir);
	_data_->dir_info = _g_object_ref0 (dir_info);
	_data_->in_discovery = in_discovery;
	directory_monitor_explore_async_co (_data_);
}


static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* data;
	data = _user_data_;
	data->_res_ = _res_;
	directory_monitor_explore_async_co (data);
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 6:
		goto _state_6;
		case 7:
		goto _state_7;
		case 8:
		goto _state_8;
		case 9:
		goto _state_9;
		case 10:
		goto _state_10;
	}
	_state_0:
#line 834 "DirectoryMonitor.vala"
	if (directory_monitor_file_info_map_contains (data->self->priv->files, data->dir, data->dir_info)) {
#line 835 "DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:835: Directory loop detected at %s, not explorin" \
"g", data->_tmp0_ = g_file_get_path (data->dir));
#line 2028 "DirectoryMonitor.c"
		_g_free0 (data->_tmp0_);
#line 837 "DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2032 "DirectoryMonitor.c"
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	data->local_dir_info = _g_object_ref0 (data->dir_info);
#line 844 "DirectoryMonitor.vala"
	if (data->local_dir_info == NULL) {
#line 2046 "DirectoryMonitor.c"
		{
			data->_state_ = 6;
			g_file_query_info_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
			return FALSE;
			_state_6:
			data->_tmp1_ = g_file_query_info_finish (data->dir, data->_res_, &data->_inner_error_);
			if (data->_inner_error_ != NULL) {
				goto __catch342_g_error;
			}
#line 846 "DirectoryMonitor.vala"
			data->local_dir_info = (data->_tmp2_ = data->_tmp1_, _g_object_unref0 (data->local_dir_info), data->_tmp2_);
#line 2058 "DirectoryMonitor.c"
		}
		goto __finally342;
		__catch342_g_error:
		{
			data->err = data->_inner_error_;
			data->_inner_error_ = NULL;
			{
#line 849 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:849: Unable to retrieve info on %s: %s", data->_tmp3_ = g_file_get_path (data->dir), data->err->message);
#line 2068 "DirectoryMonitor.c"
				_g_free0 (data->_tmp3_);
#line 851 "DirectoryMonitor.vala"
				directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2072 "DirectoryMonitor.c"
				_g_error_free0 (data->err);
				_g_object_unref0 (data->local_dir_info);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
				_g_error_free0 (data->err);
			}
		}
		__finally342:
		if (data->_inner_error_ != NULL) {
			_g_object_unref0 (data->local_dir_info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
			g_clear_error (&data->_inner_error_);
			return FALSE;
		}
	}
#line 857 "DirectoryMonitor.vala"
	if (g_file_info_get_is_hidden (data->local_dir_info)) {
#line 858 "DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:858: Ignoring hidden directory %s", data->_tmp4_ = g_file_get_path (data->dir));
#line 2099 "DirectoryMonitor.c"
		_g_free0 (data->_tmp4_);
#line 860 "DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2103 "DirectoryMonitor.c"
		_g_object_unref0 (data->local_dir_info);
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
#line 868 "DirectoryMonitor.vala"
	if ((data->_tmp6_ = (data->_tmp5_ = get_file_info_id (data->local_dir_info)) == NULL, _g_free0 (data->_tmp5_), data->_tmp6_)) {
#line 869 "DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:869: Unable to retrieve file ID on %s: skipping", data->_tmp7_ = g_file_get_path (data->dir));
#line 2119 "DirectoryMonitor.c"
		_g_free0 (data->_tmp7_);
#line 871 "DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2123 "DirectoryMonitor.c"
		_g_object_unref0 (data->local_dir_info);
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
#line 877 "DirectoryMonitor.vala"
	if (g_file_info_get_file_type (data->local_dir_info) != G_FILE_TYPE_DIRECTORY) {
#line 878 "DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (data->self, data->_tmp10_ = g_strdup_printf (_ ("Unable to monitor %s: Not a directory (%s)"), data->_tmp8_ = g_file_get_path (data->dir), (data->_tmp9_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), (int) g_file_info_get_file_type (data->local_dir_info)), (data->_tmp9_ != NULL) ? data->_tmp9_->value_name : NULL)));
#line 2139 "DirectoryMonitor.c"
		_g_free0 (data->_tmp10_);
		_g_free0 (data->_tmp8_);
#line 881 "DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2144 "DirectoryMonitor.c"
		_g_object_unref0 (data->local_dir_info);
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	data->dir_map = NULL;
	data->file_map = NULL;
	{
		data->_state_ = 7;
		g_file_enumerate_children_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
		return FALSE;
		_state_7:
		data->enumerator = g_file_enumerate_children_finish (data->dir, data->_res_, &data->_inner_error_);
		if (data->_inner_error_ != NULL) {
			goto __catch343_g_error;
		}
		{
			data->_tmp11_ = TRUE;
#line 896 "DirectoryMonitor.vala"
			while (TRUE) {
#line 896 "DirectoryMonitor.vala"
				if (!data->_tmp11_) {
#line 2173 "DirectoryMonitor.c"
				}
#line 896 "DirectoryMonitor.vala"
				data->_tmp11_ = FALSE;
#line 2177 "DirectoryMonitor.c"
				data->_state_ = 8;
				g_file_enumerator_next_files_async (data->enumerator, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
				return FALSE;
				_state_8:
				data->infos = g_file_enumerator_next_files_finish (data->enumerator, data->_res_, &data->_inner_error_);
				if (data->_inner_error_ != NULL) {
					_g_object_unref0 (data->enumerator);
					goto __catch343_g_error;
				}
#line 899 "DirectoryMonitor.vala"
				if (data->infos == NULL) {
#line 2189 "DirectoryMonitor.c"
					__g_list_free_g_object_unref0 (data->infos);
#line 900 "DirectoryMonitor.vala"
					break;
#line 2193 "DirectoryMonitor.c"
				}
				{
					data->info_collection = data->infos;
					for (data->info_it = data->info_collection; data->info_it != NULL; data->info_it = data->info_it->next) {
						data->info = _g_object_ref0 ((GFileInfo*) data->info_it->data);
						{
#line 904 "DirectoryMonitor.vala"
							if (g_file_info_get_is_hidden (data->info)) {
#line 905 "DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:905: Skipping hidden file/directory %s", data->_tmp13_ = g_file_get_path (data->_tmp12_ = g_file_get_child (data->dir, g_file_info_get_name (data->info))));
#line 2204 "DirectoryMonitor.c"
								_g_free0 (data->_tmp13_);
								_g_object_unref0 (data->_tmp12_);
								_g_object_unref0 (data->info);
#line 908 "DirectoryMonitor.vala"
								continue;
#line 2210 "DirectoryMonitor.c"
							}
#line 912 "DirectoryMonitor.vala"
							if (!directory_monitor_is_file_symlink_supported (data->info)) {
#line 2214 "DirectoryMonitor.c"
								_g_object_unref0 (data->info);
#line 913 "DirectoryMonitor.vala"
								continue;
#line 2218 "DirectoryMonitor.c"
							}
#line 915 "DirectoryMonitor.vala"
							switch (g_file_info_get_file_type (data->info)) {
#line 2222 "DirectoryMonitor.c"
								case G_FILE_TYPE_REGULAR:
								{
#line 917 "DirectoryMonitor.vala"
									if (data->file_map == NULL) {
#line 918 "DirectoryMonitor.vala"
										data->file_map = (data->_tmp14_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL), _g_object_unref0 (data->file_map), data->_tmp14_);
#line 2229 "DirectoryMonitor.c"
									}
#line 920 "DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (data->file_map), data->_tmp15_ = g_file_get_child (data->dir, g_file_info_get_name (data->info)), data->info);
#line 2233 "DirectoryMonitor.c"
									_g_object_unref0 (data->_tmp15_);
#line 921 "DirectoryMonitor.vala"
									break;
#line 2237 "DirectoryMonitor.c"
								}
								case G_FILE_TYPE_DIRECTORY:
								{
#line 924 "DirectoryMonitor.vala"
									if (data->dir_map == NULL) {
#line 925 "DirectoryMonitor.vala"
										data->dir_map = (data->_tmp16_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL), _g_object_unref0 (data->dir_map), data->_tmp16_);
#line 2245 "DirectoryMonitor.c"
									}
#line 927 "DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (data->dir_map), data->_tmp17_ = g_file_get_child (data->dir, g_file_info_get_name (data->info)), data->info);
#line 2249 "DirectoryMonitor.c"
									_g_object_unref0 (data->_tmp17_);
#line 928 "DirectoryMonitor.vala"
									break;
#line 2253 "DirectoryMonitor.c"
								}
								default:
								{
#line 932 "DirectoryMonitor.vala"
									break;
#line 2259 "DirectoryMonitor.c"
								}
							}
							_g_object_unref0 (data->info);
						}
					}
				}
				__g_list_free_g_object_unref0 (data->infos);
			}
		}
		_g_object_unref0 (data->enumerator);
	}
	goto __finally343;
	__catch343_g_error:
	{
		data->err2 = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
#line 937 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:937: Aborted directory traversal of %s: %s", data->_tmp18_ = g_file_get_path (data->dir), data->err2->message);
#line 2279 "DirectoryMonitor.c"
			_g_free0 (data->_tmp18_);
#line 939 "DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2283 "DirectoryMonitor.c"
			_g_error_free0 (data->err2);
			_g_object_unref0 (data->file_map);
			_g_object_unref0 (data->dir_map);
			_g_object_unref0 (data->local_dir_info);
			{
				if (data->_state_ == 0) {
					g_simple_async_result_complete_in_idle (data->_async_result);
				} else {
					g_simple_async_result_complete (data->_async_result);
				}
				g_object_unref (data->_async_result);
				return FALSE;
			}
			_g_error_free0 (data->err2);
		}
	}
	__finally343:
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->file_map);
		_g_object_unref0 (data->dir_map);
		_g_object_unref0 (data->local_dir_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
#line 945 "DirectoryMonitor.vala"
	if (data->in_discovery) {
#line 946 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (data->self, data->dir, data->local_dir_info);
#line 2313 "DirectoryMonitor.c"
	} else {
#line 948 "DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (data->self, data->dir, data->local_dir_info);
#line 2317 "DirectoryMonitor.c"
	}
#line 952 "DirectoryMonitor.vala"
	directory_monitor_add_monitor (data->self, data->dir, data->local_dir_info);
#line 955 "DirectoryMonitor.vala"
	if (data->file_map != NULL) {
#line 2323 "DirectoryMonitor.c"
		data->_state_ = 9;
		directory_monitor_notify_directory_files (data->self, GEE_MAP (data->file_map), data->in_discovery, directory_monitor_explore_async_ready, data);
		return FALSE;
		_state_9:
#line 956 "DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (data->self, data->_res_);
#line 2330 "DirectoryMonitor.c"
	}
#line 959 "DirectoryMonitor.vala"
	if (data->self->priv->recurse) {
#line 959 "DirectoryMonitor.vala"
		data->_tmp19_ = data->dir_map != NULL;
#line 2336 "DirectoryMonitor.c"
	} else {
#line 959 "DirectoryMonitor.vala"
		data->_tmp19_ = FALSE;
#line 2340 "DirectoryMonitor.c"
	}
#line 959 "DirectoryMonitor.vala"
	if (data->_tmp19_) {
#line 2344 "DirectoryMonitor.c"
		{
			data->_subdir_it = (data->_tmp21_ = gee_iterable_iterator (GEE_ITERABLE (data->_tmp20_ = gee_map_get_keys (GEE_MAP (data->dir_map)))), _g_object_unref0 (data->_tmp20_), data->_tmp21_);
#line 960 "DirectoryMonitor.vala"
			while (TRUE) {
#line 960 "DirectoryMonitor.vala"
				if (!gee_iterator_next (data->_subdir_it)) {
#line 960 "DirectoryMonitor.vala"
					break;
#line 2353 "DirectoryMonitor.c"
				}
				data->subdir = (GFile*) gee_iterator_get (data->_subdir_it);
#line 961 "DirectoryMonitor.vala"
				if ((data->self->priv->outstanding_exploration_dirs = data->self->priv->outstanding_exploration_dirs + 1) > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 2358 "DirectoryMonitor.c"
					data->_state_ = 10;
					directory_monitor_explore_async (data->self, data->subdir, data->_tmp22_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (data->dir_map), data->subdir), data->in_discovery, directory_monitor_explore_async_ready, data);
					return FALSE;
					_state_10:
#line 962 "DirectoryMonitor.vala"
					directory_monitor_explore_finish (data->self, data->_res_);
#line 2365 "DirectoryMonitor.c"
					_g_object_unref0 (data->_tmp22_);
				} else {
#line 964 "DirectoryMonitor.vala"
					directory_monitor_explore_async (data->self, data->subdir, data->_tmp23_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (data->dir_map), data->subdir), data->in_discovery, NULL, NULL);
#line 2370 "DirectoryMonitor.c"
					_g_object_unref0 (data->_tmp23_);
				}
				_g_object_unref0 (data->subdir);
			}
			_g_object_unref0 (data->_subdir_it);
		}
	}
#line 968 "DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (data->self, data->in_discovery);
#line 2380 "DirectoryMonitor.c"
	_g_object_unref0 (data->file_map);
	_g_object_unref0 (data->dir_map);
	_g_object_unref0 (data->local_dir_info);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


static void directory_monitor_notify_directory_files_data_free (gpointer _data) {
	DirectoryMonitorNotifyDirectoryFilesData* data;
	data = _data;
	_g_object_unref0 (data->map);
	g_object_unref (data->self);
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, data);
}


static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_notify_directory_files);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
	_data_->self = g_object_ref (self);
	_data_->map = _g_object_ref0 (map);
	_data_->in_discovery = in_discovery;
	directory_monitor_notify_directory_files_co (_data_);
}


static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_notify_directory_files_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorNotifyDirectoryFilesData* data;
	data = _user_data_;
	data->_res_ = _res_;
	directory_monitor_notify_directory_files_co (data);
}


#line 971 "DirectoryMonitor.vala"
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self) {
#line 2433 "DirectoryMonitor.c"
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
	return result;
}


static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 11:
		goto _state_11;
	}
	_state_0:
	data->iter = gee_map_map_iterator (data->map);
#line 973 "DirectoryMonitor.vala"
	while (TRUE) {
#line 973 "DirectoryMonitor.vala"
		if (!gee_map_iterator_next (data->iter)) {
#line 973 "DirectoryMonitor.vala"
			break;
#line 2457 "DirectoryMonitor.c"
		}
#line 974 "DirectoryMonitor.vala"
		if (data->in_discovery) {
#line 975 "DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (data->self, data->_tmp0_ = (GFile*) gee_map_iterator_get_key (data->iter), data->_tmp1_ = (GFileInfo*) gee_map_iterator_get_value (data->iter));
#line 2463 "DirectoryMonitor.c"
			_g_object_unref0 (data->_tmp1_);
			_g_object_unref0 (data->_tmp0_);
		} else {
#line 977 "DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (data->self, data->_tmp2_ = (GFile*) gee_map_iterator_get_key (data->iter), data->_tmp3_ = (GFileInfo*) gee_map_iterator_get_value (data->iter));
#line 2469 "DirectoryMonitor.c"
			_g_object_unref0 (data->_tmp3_);
			_g_object_unref0 (data->_tmp2_);
		}
#line 979 "DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, data, NULL);
#line 2475 "DirectoryMonitor.c"
		data->_state_ = 11;
		return FALSE;
		_state_11:
		;
	}
	_g_object_unref0 (data->iter);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 986 "DirectoryMonitor.vala"
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery) {
#line 2496 "DirectoryMonitor.c"
	gboolean _tmp0_ = FALSE;
#line 986 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 987 "DirectoryMonitor.vala"
	g_assert (self->priv->outstanding_exploration_dirs > 0);
#line 988 "DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs--;
#line 990 "DirectoryMonitor.vala"
	if (in_discovery) {
#line 990 "DirectoryMonitor.vala"
		_tmp0_ = self->priv->outstanding_exploration_dirs == 0;
#line 2508 "DirectoryMonitor.c"
	} else {
#line 990 "DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 2512 "DirectoryMonitor.c"
	}
#line 990 "DirectoryMonitor.vala"
	if (_tmp0_) {
#line 991 "DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 2518 "DirectoryMonitor.c"
	}
}


#line 1054 "DirectoryMonitor.vala"
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 2525 "DirectoryMonitor.c"
	directory_monitor_on_monitor_notification (self, file, other_file, event_type);
}


#line 997 "DirectoryMonitor.vala"
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 2532 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFileMonitor* monitor;
	char* _tmp3_;
	char* _tmp4_;
	GError * _inner_error_ = NULL;
#line 997 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 997 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 997 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 998 "DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 2547 "DirectoryMonitor.c"
		result = FALSE;
#line 999 "DirectoryMonitor.vala"
		return result;
#line 2551 "DirectoryMonitor.c"
	}
#line 1001 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
#line 1002 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 2557 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 1003 "DirectoryMonitor.vala"
		return result;
#line 2562 "DirectoryMonitor.c"
	}
#line 1006 "DirectoryMonitor.vala"
	if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->monitors), id)) {
#line 2566 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 1007 "DirectoryMonitor.vala"
		return result;
#line 2571 "DirectoryMonitor.c"
	}
#line 1009 "DirectoryMonitor.vala"
	monitor = NULL;
#line 2575 "DirectoryMonitor.c"
	{
		GFileMonitor* _tmp0_;
		GFileMonitor* _tmp1_;
#line 1011 "DirectoryMonitor.vala"
		_tmp0_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error_);
#line 2581 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch344_g_error;
		}
#line 1011 "DirectoryMonitor.vala"
		monitor = (_tmp1_ = _tmp0_, _g_object_unref0 (monitor), _tmp1_);
#line 2587 "DirectoryMonitor.c"
	}
	goto __finally344;
	__catch344_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp2_;
#line 1013 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1013: Unable to monitor %s: %s", _tmp2_ = g_file_get_path (dir), err->message);
#line 2599 "DirectoryMonitor.c"
			_g_free0 (_tmp2_);
			result = FALSE;
			_g_error_free0 (err);
			_g_object_unref0 (monitor);
			_g_free0 (id);
#line 1015 "DirectoryMonitor.vala"
			return result;
#line 2607 "DirectoryMonitor.c"
		}
	}
	__finally344:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (monitor);
		_g_free0 (id);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 1018 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->monitors), id, monitor);
#line 1019 "DirectoryMonitor.vala"
	g_signal_connect_object (monitor, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1021 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_ = g_strdup_printf ("Added monitor for %s", _tmp3_ = g_file_get_path (dir)));
#line 2624 "DirectoryMonitor.c"
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
#line 1023 "DirectoryMonitor.vala"
	return result;
#line 2632 "DirectoryMonitor.c"
}


#line 1027 "DirectoryMonitor.vala"
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 2638 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFileMonitor* monitor;
	gboolean removed;
	char* _tmp0_;
	char* _tmp1_;
#line 1027 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1027 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 1027 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1028 "DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 2653 "DirectoryMonitor.c"
		result = FALSE;
#line 1029 "DirectoryMonitor.vala"
		return result;
#line 2657 "DirectoryMonitor.c"
	}
#line 1031 "DirectoryMonitor.vala"
	id = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
#line 1032 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 2663 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (id);
#line 1033 "DirectoryMonitor.vala"
		return result;
#line 2668 "DirectoryMonitor.c"
	}
#line 1035 "DirectoryMonitor.vala"
	monitor = (GFileMonitor*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->monitors), id);
#line 1036 "DirectoryMonitor.vala"
	if (monitor == NULL) {
#line 2674 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (monitor);
		_g_free0 (id);
#line 1037 "DirectoryMonitor.vala"
		return result;
#line 2680 "DirectoryMonitor.c"
	}
#line 1039 "DirectoryMonitor.vala"
	removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->monitors), id, NULL);
#line 1040 "DirectoryMonitor.vala"
	g_assert (removed);
#line 1042 "DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, monitor);
#line 1044 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("Removed monitor for %s", _tmp0_ = g_file_get_path (dir)));
#line 2690 "DirectoryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
#line 1046 "DirectoryMonitor.vala"
	return result;
#line 2698 "DirectoryMonitor.c"
}


#line 1049 "DirectoryMonitor.vala"
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor) {
#line 2704 "DirectoryMonitor.c"
	guint _tmp0_;
#line 1049 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1049 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_MONITOR (monitor));
#line 1050 "DirectoryMonitor.vala"
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp0_, NULL, FALSE);
#line 1050 "DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1051 "DirectoryMonitor.vala"
	g_file_monitor_cancel (monitor);
#line 2716 "DirectoryMonitor.c"
}


#line 105 "DirectoryMonitor.vala"
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 2722 "DirectoryMonitor.c"
	directory_monitor_query_info_queue_element_on_completed (self, source_object, res);
	directory_monitor_query_info_queue_element_unref (self);
}


#line 1368 "DirectoryMonitor.vala"
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self) {
#line 2730 "DirectoryMonitor.c"
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events (self);
	return result;
}


#line 1054 "DirectoryMonitor.vala"
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 2739 "DirectoryMonitor.c"
	char* _tmp0_;
	GEnumValue* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	DirectoryMonitorQueryInfoQueueElement* query_info;
#line 1054 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1054 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1054 "DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 2751 "DirectoryMonitor.c"
	_tmp0_ = NULL;
#line 1056 "DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 2755 "DirectoryMonitor.c"
		char* _tmp1_;
#line 1056 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp1_ = g_file_get_path (other_file), _g_free0 (_tmp0_), _tmp1_);
#line 2759 "DirectoryMonitor.c"
	} else {
		char* _tmp2_;
#line 1056 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp2_ = g_strdup ("(none)"), _g_free0 (_tmp0_), _tmp2_);
#line 2764 "DirectoryMonitor.c"
	}
#line 1055 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp3_ != NULL) ? _tmp3_->value_name : NULL), _tmp4_ = g_file_get_path (file), _tmp0_));
#line 2768 "DirectoryMonitor.c"
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
#line 1065 "DirectoryMonitor.vala"
	query_info = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
#line 1066 "DirectoryMonitor.vala"
	gee_queue_offer (self->priv->query_info_queue, query_info);
#line 1068 "DirectoryMonitor.vala"
	switch (event) {
#line 2777 "DirectoryMonitor.c"
		case G_FILE_MONITOR_EVENT_CREATED:
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
#line 1071 "DirectoryMonitor.vala"
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_info));
#line 1073 "DirectoryMonitor.vala"
			break;
#line 2785 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
#line 1079 "DirectoryMonitor.vala"
			if (self->priv->delete_timer_id == 0) {
#line 1080 "DirectoryMonitor.vala"
				self->priv->delete_timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 2793 "DirectoryMonitor.c"
			}
#line 1081 "DirectoryMonitor.vala"
			break;
#line 2797 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
#line 1086 "DirectoryMonitor.vala"
			if (other_file != NULL) {
#line 1087 "DirectoryMonitor.vala"
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_info));
#line 2805 "DirectoryMonitor.c"
			} else {
#line 1090 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1090: Unable to process MOVED event: no other_fi" \
"le");
#line 1091 "DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (self->priv->query_info_queue), query_info);
#line 2811 "DirectoryMonitor.c"
			}
#line 1093 "DirectoryMonitor.vala"
			break;
#line 2815 "DirectoryMonitor.c"
		}
		default:
		{
#line 1097 "DirectoryMonitor.vala"
			query_info->completed = TRUE;
#line 1098 "DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, query_info);
#line 1099 "DirectoryMonitor.vala"
			break;
#line 2825 "DirectoryMonitor.c"
		}
	}
	_directory_monitor_query_info_queue_element_unref0 (query_info);
	_g_free0 (_tmp0_);
}


#line 1103 "DirectoryMonitor.vala"
static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info) {
#line 2835 "DirectoryMonitor.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 1103 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1103 "DirectoryMonitor.vala"
	g_return_if_fail ((query_info == NULL) || DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (query_info));
#line 1106 "DirectoryMonitor.vala"
	if (query_info != NULL) {
#line 1106 "DirectoryMonitor.vala"
		_tmp1_ = query_info->info != NULL;
#line 2846 "DirectoryMonitor.c"
	} else {
#line 1106 "DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 2850 "DirectoryMonitor.c"
	}
#line 1106 "DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1106 "DirectoryMonitor.vala"
		_tmp0_ = query_info->event == G_FILE_MONITOR_EVENT_CREATED;
#line 2856 "DirectoryMonitor.c"
	} else {
#line 1106 "DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 2860 "DirectoryMonitor.c"
	}
#line 1106 "DirectoryMonitor.vala"
	if (_tmp0_) {
#line 2864 "DirectoryMonitor.c"
		GFile* match;
#line 1109 "DirectoryMonitor.vala"
		match = directory_monitor_file_info_map_find_match (self->priv->files, query_info->info);
#line 1110 "DirectoryMonitor.vala"
		if (match != NULL) {
#line 2870 "DirectoryMonitor.c"
			gboolean matched;
#line 1111 "DirectoryMonitor.vala"
			matched = FALSE;
#line 2874 "DirectoryMonitor.c"
			{
				GeeIterator* _enqueued_it;
#line 1112 "DirectoryMonitor.vala"
				_enqueued_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->query_info_queue));
#line 1112 "DirectoryMonitor.vala"
				while (TRUE) {
#line 2881 "DirectoryMonitor.c"
					DirectoryMonitorQueryInfoQueueElement* enqueued;
					gboolean _tmp2_ = FALSE;
					gboolean _tmp3_ = FALSE;
					char* _tmp4_;
					char* _tmp5_;
					char* _tmp6_;
					GFile* _tmp7_;
					GFileInfo* _tmp8_;
#line 1112 "DirectoryMonitor.vala"
					if (!gee_iterator_next (_enqueued_it)) {
#line 1112 "DirectoryMonitor.vala"
						break;
#line 2894 "DirectoryMonitor.c"
					}
#line 1112 "DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) gee_iterator_get (_enqueued_it);
#line 1113 "DirectoryMonitor.vala"
					if (enqueued->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 1113 "DirectoryMonitor.vala"
						_tmp3_ = TRUE;
#line 2902 "DirectoryMonitor.c"
					} else {
#line 1114 "DirectoryMonitor.vala"
						_tmp3_ = enqueued->completed;
#line 2906 "DirectoryMonitor.c"
					}
#line 1113 "DirectoryMonitor.vala"
					if (_tmp3_) {
#line 1113 "DirectoryMonitor.vala"
						_tmp2_ = TRUE;
#line 2912 "DirectoryMonitor.c"
					} else {
#line 1115 "DirectoryMonitor.vala"
						_tmp2_ = !g_file_equal (match, enqueued->file);
#line 2916 "DirectoryMonitor.c"
					}
#line 1113 "DirectoryMonitor.vala"
					if (_tmp2_) {
#line 2920 "DirectoryMonitor.c"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1116 "DirectoryMonitor.vala"
						continue;
#line 2924 "DirectoryMonitor.c"
					}
#line 1119 "DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp6_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp4_ = g_file_get_path (query_info->file), _tmp5_ = g_file_get_path (enqueued->file)));
#line 2928 "DirectoryMonitor.c"
					_g_free0 (_tmp6_);
					_g_free0 (_tmp5_);
					_g_free0 (_tmp4_);
#line 1122 "DirectoryMonitor.vala"
					enqueued->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1123 "DirectoryMonitor.vala"
					enqueued->other_file = (_tmp7_ = _g_object_ref0 (query_info->file), _g_object_unref0 (enqueued->other_file), _tmp7_);
#line 1124 "DirectoryMonitor.vala"
					enqueued->info = (_tmp8_ = _g_object_ref0 (query_info->info), _g_object_unref0 (enqueued->info), _tmp8_);
#line 1125 "DirectoryMonitor.vala"
					enqueued->completed = TRUE;
#line 1127 "DirectoryMonitor.vala"
					matched = TRUE;
#line 2942 "DirectoryMonitor.c"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1129 "DirectoryMonitor.vala"
					break;
#line 2946 "DirectoryMonitor.c"
				}
				_g_object_unref0 (_enqueued_it);
			}
#line 1132 "DirectoryMonitor.vala"
			if (matched) {
#line 1133 "DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (self->priv->query_info_queue), query_info);
#line 2954 "DirectoryMonitor.c"
			}
		}
		_g_object_unref0 (match);
	}
	{
		gboolean _tmp9_;
#line 1138 "DirectoryMonitor.vala"
		_tmp9_ = TRUE;
#line 1138 "DirectoryMonitor.vala"
		while (TRUE) {
#line 2965 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* next;
			gboolean _tmp10_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* n;
			GEnumValue* _tmp11_;
			char* _tmp12_;
			char* _tmp13_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp22_ = FALSE;
#line 1138 "DirectoryMonitor.vala"
			if (!_tmp9_) {
#line 2976 "DirectoryMonitor.c"
			}
#line 1138 "DirectoryMonitor.vala"
			_tmp9_ = FALSE;
#line 1140 "DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) gee_queue_peek (self->priv->query_info_queue);
#line 1141 "DirectoryMonitor.vala"
			if (next == NULL) {
#line 1141 "DirectoryMonitor.vala"
				_tmp10_ = TRUE;
#line 2986 "DirectoryMonitor.c"
			} else {
#line 1141 "DirectoryMonitor.vala"
				_tmp10_ = !next->completed;
#line 2990 "DirectoryMonitor.c"
			}
#line 1141 "DirectoryMonitor.vala"
			if (_tmp10_) {
#line 2994 "DirectoryMonitor.c"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1142 "DirectoryMonitor.vala"
				break;
#line 2998 "DirectoryMonitor.c"
			}
#line 1145 "DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) gee_queue_poll (self->priv->query_info_queue);
#line 1146 "DirectoryMonitor.vala"
			g_assert (next == n);
#line 1148 "DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp13_ = g_strdup_printf ("Completed info query %u for %s on %s", next->position, (_tmp11_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp11_ != NULL) ? _tmp11_->value_name : NULL), _tmp12_ = g_file_get_path (next->file)));
#line 3006 "DirectoryMonitor.c"
			_g_free0 (_tmp13_);
			_g_free0 (_tmp12_);
#line 1151 "DirectoryMonitor.vala"
			if (next->err != NULL) {
#line 3011 "DirectoryMonitor.c"
				char* _tmp14_;
				GEnumValue* _tmp15_;
				char* _tmp16_;
#line 1152 "DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp16_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp14_ = g_file_get_path (next->file), (_tmp15_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp15_ != NULL) ? _tmp15_->value_name : NULL), next->err->message));
#line 3017 "DirectoryMonitor.c"
				_g_free0 (_tmp16_);
				_g_free0 (_tmp14_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1155 "DirectoryMonitor.vala"
				continue;
#line 3024 "DirectoryMonitor.c"
			}
#line 1159 "DirectoryMonitor.vala"
			if (next->info != NULL) {
#line 3028 "DirectoryMonitor.c"
				char* _tmp18_;
#line 1159 "DirectoryMonitor.vala"
				_tmp17_ = (_tmp18_ = get_file_info_id (next->info)) == NULL;
#line 3032 "DirectoryMonitor.c"
				_g_free0 (_tmp18_);
			} else {
#line 1159 "DirectoryMonitor.vala"
				_tmp17_ = FALSE;
#line 3037 "DirectoryMonitor.c"
			}
#line 1159 "DirectoryMonitor.vala"
			if (_tmp17_) {
#line 3041 "DirectoryMonitor.c"
				char* _tmp19_;
				GEnumValue* _tmp20_;
				char* _tmp21_;
#line 1160 "DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp21_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp19_ = g_file_get_path (next->file), (_tmp20_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp20_ != NULL) ? _tmp20_->value_name : NULL)));
#line 3047 "DirectoryMonitor.c"
				_g_free0 (_tmp21_);
				_g_free0 (_tmp19_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1163 "DirectoryMonitor.vala"
				continue;
#line 3054 "DirectoryMonitor.c"
			}
#line 1167 "DirectoryMonitor.vala"
			if (next->info != NULL) {
#line 1167 "DirectoryMonitor.vala"
				_tmp22_ = !directory_monitor_is_file_symlink_supported (next->info);
#line 3060 "DirectoryMonitor.c"
			} else {
#line 1167 "DirectoryMonitor.vala"
				_tmp22_ = FALSE;
#line 3064 "DirectoryMonitor.c"
			}
#line 1167 "DirectoryMonitor.vala"
			if (_tmp22_) {
#line 3068 "DirectoryMonitor.c"
				char* _tmp23_;
				GEnumValue* _tmp24_;
				char* _tmp25_;
#line 1168 "DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp25_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp23_ = g_file_get_path (next->file), (_tmp24_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) next->event), (_tmp24_ != NULL) ? _tmp24_->value_name : NULL)));
#line 3074 "DirectoryMonitor.c"
				_g_free0 (_tmp25_);
				_g_free0 (_tmp23_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1171 "DirectoryMonitor.vala"
				continue;
#line 3081 "DirectoryMonitor.c"
			}
#line 1174 "DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, next->file, next->other_file, next->info, next->event);
#line 3085 "DirectoryMonitor.c"
			_directory_monitor_query_info_queue_element_unref0 (n);
			_directory_monitor_query_info_queue_element_unref0 (next);
		}
	}
}


#line 1178 "DirectoryMonitor.vala"
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event) {
#line 3095 "DirectoryMonitor.c"
	char* _tmp0_;
	GEnumValue* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
#line 1178 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1178 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1178 "DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1178 "DirectoryMonitor.vala"
	g_return_if_fail ((info == NULL) || G_IS_FILE_INFO (info));
#line 3108 "DirectoryMonitor.c"
	_tmp0_ = NULL;
#line 1181 "DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 3112 "DirectoryMonitor.c"
		char* _tmp1_;
#line 1181 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp1_ = g_file_get_path (other_file), _g_free0 (_tmp0_), _tmp1_);
#line 3116 "DirectoryMonitor.c"
	} else {
		char* _tmp2_;
#line 1181 "DirectoryMonitor.vala"
		_tmp0_ = (_tmp2_ = g_strdup ("(null)"), _g_free0 (_tmp0_), _tmp2_);
#line 3121 "DirectoryMonitor.c"
	}
#line 1180 "DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp3_ != NULL) ? _tmp3_->value_name : NULL), _tmp4_ = g_file_get_path (file), _tmp0_));
#line 3125 "DirectoryMonitor.c"
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
#line 1185 "DirectoryMonitor.vala"
	switch (event) {
#line 3130 "DirectoryMonitor.c"
		case G_FILE_MONITOR_EVENT_CREATED:
		{
			DirectoryMonitorFType ftype;
#line 1187 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1189 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1190 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3140 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1192 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, file, info);
#line 1193 "DirectoryMonitor.vala"
					break;
#line 3147 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1200 "DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs++;
#line 1201 "DirectoryMonitor.vala"
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
#line 1202 "DirectoryMonitor.vala"
					break;
#line 3157 "DirectoryMonitor.c"
				}
				default:
				{
#line 1205 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1206 "DirectoryMonitor.vala"
					break;
#line 3165 "DirectoryMonitor.c"
				}
			}
#line 1208 "DirectoryMonitor.vala"
			break;
#line 3170 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_CHANGED:
		{
			GFileInfo* local_info;
			DirectoryMonitorFType ftype;
#line 1212 "DirectoryMonitor.vala"
			g_assert (info == NULL);
#line 1214 "DirectoryMonitor.vala"
			local_info = directory_monitor_get_file_info (self, file);
#line 1215 "DirectoryMonitor.vala"
			if (local_info == NULL) {
#line 3182 "DirectoryMonitor.c"
				char* _tmp6_;
				char* _tmp7_;
#line 1216 "DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp7_ = g_strdup_printf ("Changed event for unknown file %s", _tmp6_ = g_file_get_path (file)));
#line 3187 "DirectoryMonitor.c"
				_g_free0 (_tmp7_);
				_g_free0 (_tmp6_);
				_g_object_unref0 (local_info);
#line 1218 "DirectoryMonitor.vala"
				break;
#line 3193 "DirectoryMonitor.c"
			}
#line 1221 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (local_info);
#line 1222 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3199 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1224 "DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, file);
#line 1225 "DirectoryMonitor.vala"
					break;
#line 3206 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1228 "DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, file);
#line 1229 "DirectoryMonitor.vala"
					break;
#line 3214 "DirectoryMonitor.c"
				}
				default:
				{
#line 1232 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1233 "DirectoryMonitor.vala"
					break;
#line 3222 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (local_info);
#line 1235 "DirectoryMonitor.vala"
			break;
#line 3228 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			DirectoryMonitorFType ftype;
#line 1238 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1240 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1241 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3239 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1243 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
#line 1244 "DirectoryMonitor.vala"
					break;
#line 3246 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1247 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
#line 1248 "DirectoryMonitor.vala"
					break;
#line 3254 "DirectoryMonitor.c"
				}
				default:
				{
#line 1251 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1252 "DirectoryMonitor.vala"
					break;
#line 3262 "DirectoryMonitor.c"
				}
			}
#line 1254 "DirectoryMonitor.vala"
			break;
#line 3267 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
			DirectoryMonitorFType ftype;
#line 1257 "DirectoryMonitor.vala"
			g_assert (info != NULL);
#line 1258 "DirectoryMonitor.vala"
			g_assert (other_file != NULL);
#line 1262 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1263 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3280 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1265 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
#line 1266 "DirectoryMonitor.vala"
					break;
#line 3287 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					GFileInfo* old_dir_info;
#line 1270 "DirectoryMonitor.vala"
					old_dir_info = directory_monitor_file_info_map_get_info (self->priv->files, file);
#line 1271 "DirectoryMonitor.vala"
					if (old_dir_info == NULL) {
#line 3296 "DirectoryMonitor.c"
						char* _tmp8_;
#line 1272 "DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1272: Directory moved event for unknown file %s", _tmp8_ = g_file_get_path (file));
#line 3300 "DirectoryMonitor.c"
						_g_free0 (_tmp8_);
						_g_object_unref0 (old_dir_info);
#line 1274 "DirectoryMonitor.vala"
						break;
#line 3305 "DirectoryMonitor.c"
					}
#line 1277 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, file, old_dir_info, other_file, info);
#line 3309 "DirectoryMonitor.c"
					_g_object_unref0 (old_dir_info);
#line 1278 "DirectoryMonitor.vala"
					break;
#line 3313 "DirectoryMonitor.c"
				}
				default:
				{
#line 1281 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1282 "DirectoryMonitor.vala"
					break;
#line 3321 "DirectoryMonitor.c"
				}
			}
#line 1284 "DirectoryMonitor.vala"
			break;
#line 3326 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			GFileInfo* local_info;
			DirectoryMonitorFType ftype;
#line 1287 "DirectoryMonitor.vala"
			g_assert (info == NULL);
#line 1289 "DirectoryMonitor.vala"
			local_info = directory_monitor_get_file_info (self, file);
#line 1290 "DirectoryMonitor.vala"
			if (local_info == NULL) {
#line 3338 "DirectoryMonitor.c"
				char* _tmp9_;
#line 1291 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1291: Deleted event for unknown file %s", _tmp9_ = g_file_get_path (file));
#line 3342 "DirectoryMonitor.c"
				_g_free0 (_tmp9_);
				_g_object_unref0 (local_info);
#line 1293 "DirectoryMonitor.vala"
				break;
#line 3347 "DirectoryMonitor.c"
			}
#line 1296 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (local_info);
#line 1297 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3353 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1299 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, file);
#line 1300 "DirectoryMonitor.vala"
					break;
#line 3360 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1303 "DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, file);
#line 1304 "DirectoryMonitor.vala"
					break;
#line 3368 "DirectoryMonitor.c"
				}
				default:
				{
#line 1307 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1308 "DirectoryMonitor.vala"
					break;
#line 3376 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (local_info);
#line 1310 "DirectoryMonitor.vala"
			break;
#line 3382 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
			GFileInfo* local_info;
			DirectoryMonitorFType ftype;
#line 1314 "DirectoryMonitor.vala"
			g_assert (info == NULL);
#line 1316 "DirectoryMonitor.vala"
			local_info = directory_monitor_get_file_info (self, file);
#line 1317 "DirectoryMonitor.vala"
			if (local_info == NULL) {
#line 3394 "DirectoryMonitor.c"
				char* _tmp10_;
#line 1318 "DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1318: Attribute changed event for unknown file %" \
"s", _tmp10_ = g_file_get_path (file));
#line 3398 "DirectoryMonitor.c"
				_g_free0 (_tmp10_);
				_g_object_unref0 (local_info);
#line 1320 "DirectoryMonitor.vala"
				break;
#line 3403 "DirectoryMonitor.c"
			}
#line 1323 "DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (local_info);
#line 1324 "DirectoryMonitor.vala"
			switch (ftype) {
#line 3409 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 1326 "DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, file);
#line 1327 "DirectoryMonitor.vala"
					break;
#line 3416 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 1330 "DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, file);
#line 1331 "DirectoryMonitor.vala"
					break;
#line 3424 "DirectoryMonitor.c"
				}
				default:
				{
#line 1334 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1335 "DirectoryMonitor.vala"
					break;
#line 3432 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (local_info);
#line 1337 "DirectoryMonitor.vala"
			break;
#line 3438 "DirectoryMonitor.c"
		}
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
		{
#line 1342 "DirectoryMonitor.vala"
			break;
#line 3445 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp11_;
#line 1345 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1345: Unknown directory monitor event %s", (_tmp11_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event), (_tmp11_ != NULL) ? _tmp11_->value_name : NULL));
#line 1346 "DirectoryMonitor.vala"
			break;
#line 3454 "DirectoryMonitor.c"
		}
	}
	_g_free0 (_tmp0_);
}


#line 1352 "DirectoryMonitor.vala"
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info) {
#line 3463 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFile* match;
#line 1352 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1352 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1352 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 3472 "DirectoryMonitor.c"
	if (old_file != NULL) {
		*old_file = NULL;
	}
	if (old_file_info != NULL) {
		*old_file_info = NULL;
	}
#line 1355 "DirectoryMonitor.vala"
	match = directory_monitor_file_info_map_find_match (self->priv->parent_moved, info);
#line 1356 "DirectoryMonitor.vala"
	if (match != NULL) {
#line 3483 "DirectoryMonitor.c"
		GFile* _tmp0_;
		GFileInfo* _tmp1_;
#line 1357 "DirectoryMonitor.vala"
		*old_file = (_tmp0_ = _g_object_ref0 (match), _g_object_unref0 (*old_file), _tmp0_);
#line 1358 "DirectoryMonitor.vala"
		*old_file_info = (_tmp1_ = directory_monitor_file_info_map_get_info (self->priv->parent_moved, match), _g_object_unref0 (*old_file_info), _tmp1_);
#line 1360 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (self->priv->parent_moved, match, info);
#line 3492 "DirectoryMonitor.c"
		result = TRUE;
		_g_object_unref0 (match);
#line 1362 "DirectoryMonitor.vala"
		return result;
#line 3497 "DirectoryMonitor.c"
	}
	result = FALSE;
	_g_object_unref0 (match);
#line 1365 "DirectoryMonitor.vala"
	return result;
#line 3503 "DirectoryMonitor.c"
}


#line 1368 "DirectoryMonitor.vala"
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self) {
#line 3509 "DirectoryMonitor.c"
	gboolean result = FALSE;
	gulong expiration;
	gboolean any_deleted;
	gboolean any_expired;
#line 1368 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1369 "DirectoryMonitor.vala"
	expiration = now_ms () - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1371 "DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1372 "DirectoryMonitor.vala"
	any_expired = FALSE;
#line 3522 "DirectoryMonitor.c"
	{
		GeeIterator* _element_it;
#line 1373 "DirectoryMonitor.vala"
		_element_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->query_info_queue));
#line 1373 "DirectoryMonitor.vala"
		while (TRUE) {
#line 3529 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* element;
#line 1373 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_element_it)) {
#line 1373 "DirectoryMonitor.vala"
				break;
#line 3535 "DirectoryMonitor.c"
			}
#line 1373 "DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) gee_iterator_get (_element_it);
#line 1374 "DirectoryMonitor.vala"
			if (element->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 3541 "DirectoryMonitor.c"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1375 "DirectoryMonitor.vala"
				continue;
#line 3545 "DirectoryMonitor.c"
			}
#line 1377 "DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1379 "DirectoryMonitor.vala"
			if (element->time_created_msec > expiration) {
#line 3551 "DirectoryMonitor.c"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1380 "DirectoryMonitor.vala"
				continue;
#line 3555 "DirectoryMonitor.c"
			}
#line 1383 "DirectoryMonitor.vala"
			element->completed = TRUE;
#line 1384 "DirectoryMonitor.vala"
			any_expired = TRUE;
#line 3561 "DirectoryMonitor.c"
			_directory_monitor_query_info_queue_element_unref0 (element);
		}
		_g_object_unref0 (_element_it);
	}
#line 1387 "DirectoryMonitor.vala"
	if (any_expired) {
#line 1388 "DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 3570 "DirectoryMonitor.c"
	}
#line 1390 "DirectoryMonitor.vala"
	if (!any_deleted) {
#line 1391 "DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 3576 "DirectoryMonitor.c"
	}
	result = any_deleted;
#line 1393 "DirectoryMonitor.vala"
	return result;
#line 3581 "DirectoryMonitor.c"
}


#line 1397 "DirectoryMonitor.vala"
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file) {
#line 3587 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
#line 1397 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1397 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3593 "DirectoryMonitor.c"
	result = directory_monitor_file_info_map_get_info (self->priv->files, file);
#line 1398 "DirectoryMonitor.vala"
	return result;
#line 3597 "DirectoryMonitor.c"
}


#line 1403 "DirectoryMonitor.vala"
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self) {
#line 3603 "DirectoryMonitor.c"
	GeeCollection* result = NULL;
#line 1403 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 3607 "DirectoryMonitor.c"
	result = directory_monitor_file_info_map_get_all (self->priv->files);
#line 1404 "DirectoryMonitor.vala"
	return result;
#line 3611 "DirectoryMonitor.c"
}


#line 1410 "DirectoryMonitor.vala"
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file) {
#line 3617 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
#line 1410 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1410 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3623 "DirectoryMonitor.c"
	result = directory_monitor_file_info_map_query_info (self->priv->files, file, self->priv->cancellable);
#line 1411 "DirectoryMonitor.vala"
	return result;
#line 3627 "DirectoryMonitor.c"
}


#line 1421 "DirectoryMonitor.vala"
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info) {
#line 3633 "DirectoryMonitor.c"
	gboolean result = FALSE;
	DirectoryMonitorFType ftype;
#line 1421 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1422 "DirectoryMonitor.vala"
	if (!g_file_info_get_is_symlink (info)) {
#line 3640 "DirectoryMonitor.c"
		result = TRUE;
#line 1423 "DirectoryMonitor.vala"
		return result;
#line 3644 "DirectoryMonitor.c"
	}
#line 1425 "DirectoryMonitor.vala"
	ftype = directory_monitor_get_ftype (info);
#line 1426 "DirectoryMonitor.vala"
	switch (ftype) {
#line 3650 "DirectoryMonitor.c"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
		{
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1428 "DirectoryMonitor.vala"
			return result;
#line 3656 "DirectoryMonitor.c"
		}
		case DIRECTORY_MONITOR_FTYPE_FILE:
		{
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1431 "DirectoryMonitor.vala"
			return result;
#line 3663 "DirectoryMonitor.c"
		}
		default:
		{
#line 1434 "DirectoryMonitor.vala"
			g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 3669 "DirectoryMonitor.c"
			result = FALSE;
#line 1436 "DirectoryMonitor.vala"
			return result;
#line 3673 "DirectoryMonitor.c"
		}
	}
}


#line 373 "DirectoryMonitor.vala"
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 373 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 373 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 373 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 373 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 3689 "DirectoryMonitor.c"
}


#line 381 "DirectoryMonitor.vala"
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 381 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 381 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 3699 "DirectoryMonitor.c"
}


#line 384 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_started (DirectoryMonitor* self) {
#line 384 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 3707 "DirectoryMonitor.c"
}


#line 387 "DirectoryMonitor.vala"
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 387 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 387 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 387 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3719 "DirectoryMonitor.c"
}


#line 390 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 390 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 390 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 390 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3731 "DirectoryMonitor.c"
}


#line 395 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const char* reason) {
#line 395 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 395 "DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 3741 "DirectoryMonitor.c"
}


#line 398 "DirectoryMonitor.vala"
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self) {
#line 398 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 399 "DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 400 "DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 3753 "DirectoryMonitor.c"
}


#line 403 "DirectoryMonitor.vala"
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 403 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 403 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 403 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3765 "DirectoryMonitor.c"
}


#line 406 "DirectoryMonitor.vala"
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 406 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 406 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 406 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 406 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 3779 "DirectoryMonitor.c"
}


#line 410 "DirectoryMonitor.vala"
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file) {
#line 410 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 410 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3789 "DirectoryMonitor.c"
}


#line 415 "DirectoryMonitor.vala"
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 415 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 415 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 415 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3801 "DirectoryMonitor.c"
}


#line 418 "DirectoryMonitor.vala"
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 418 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 418 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3811 "DirectoryMonitor.c"
}


#line 421 "DirectoryMonitor.vala"
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 421 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 421 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3821 "DirectoryMonitor.c"
}


#line 425 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 425 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 425 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 425 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3833 "DirectoryMonitor.c"
}


#line 429 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 429 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 429 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 429 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 429 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 3847 "DirectoryMonitor.c"
}


#line 433 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 433 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 433 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 3857 "DirectoryMonitor.c"
}


#line 438 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 438 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3869 "DirectoryMonitor.c"
}


#line 441 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 441 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 441 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 3879 "DirectoryMonitor.c"
}


#line 445 "DirectoryMonitor.vala"
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 445 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 445 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 3889 "DirectoryMonitor.c"
}


#line 448 "DirectoryMonitor.vala"
static void directory_monitor_real_closed (DirectoryMonitor* self) {
#line 448 "DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 3897 "DirectoryMonitor.c"
}


#line 95 "DirectoryMonitor.vala"
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 3903 "DirectoryMonitor.c"
	DirectoryMonitorQueryInfoQueueElement* self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 95 "DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
#line 95 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 95 "DirectoryMonitor.vala"
	g_return_val_if_fail ((other_file == NULL) || G_IS_FILE (other_file), NULL);
#line 97 "DirectoryMonitor.vala"
	self->owner = (_tmp0_ = _g_object_ref0 (owner), _g_object_unref0 (self->owner), _tmp0_);
#line 98 "DirectoryMonitor.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 99 "DirectoryMonitor.vala"
	self->other_file = (_tmp2_ = _g_object_ref0 (other_file), _g_object_unref0 (self->other_file), _tmp2_);
#line 100 "DirectoryMonitor.vala"
	self->event = event;
#line 101 "DirectoryMonitor.vala"
	self->position = directory_monitor_query_info_queue_element_current++;
#line 102 "DirectoryMonitor.vala"
	self->time_created_msec = now_ms ();
#line 3926 "DirectoryMonitor.c"
	return self;
}


#line 95 "DirectoryMonitor.vala"
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 95 "DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 3935 "DirectoryMonitor.c"
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 105 "DirectoryMonitor.vala"
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult) {
#line 3946 "DirectoryMonitor.c"
	GFile* source_file;
	GError * _inner_error_ = NULL;
#line 105 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
#line 105 "DirectoryMonitor.vala"
	g_return_if_fail ((source == NULL) || G_IS_OBJECT (source));
#line 105 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (aresult));
#line 106 "DirectoryMonitor.vala"
	source_file = _g_object_ref0 (G_FILE (source));
#line 3957 "DirectoryMonitor.c"
	{
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
#line 110 "DirectoryMonitor.vala"
		_tmp0_ = g_file_query_info_finish (source_file, aresult, &_inner_error_);
#line 3963 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch345_g_error;
		}
#line 110 "DirectoryMonitor.vala"
		self->info = (_tmp1_ = _tmp0_, _g_object_unref0 (self->info), _tmp1_);
#line 3969 "DirectoryMonitor.c"
	}
	goto __finally345;
	__catch345_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GError* _tmp2_;
#line 112 "DirectoryMonitor.vala"
			self->err = (_tmp2_ = _g_error_copy0 (err), _g_error_free0 (self->err), _tmp2_);
#line 3981 "DirectoryMonitor.c"
			_g_error_free0 (err);
		}
	}
	__finally345:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (source_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
#line 116 "DirectoryMonitor.vala"
	self->completed = TRUE;
#line 119 "DirectoryMonitor.vala"
	directory_monitor_process_query_queue (self->owner, self);
#line 3996 "DirectoryMonitor.c"
	_g_object_unref0 (source_file);
}


static void directory_monitor_value_query_info_queue_element_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_query_info_queue_element_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_query_info_queue_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorQueryInfoQueueElement* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorQueryInfoQueueElement** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass) {
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS (klass)->finalize = directory_monitor_query_info_queue_element_finalize;
}


static void directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self) {
	self->info = NULL;
	self->err = NULL;
	self->completed = FALSE;
	self->ref_count = 1;
}


static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj) {
	DirectoryMonitorQueryInfoQueueElement * self;
	self = DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT (obj);
	_g_object_unref0 (self->owner);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->other_file);
	_g_object_unref0 (self->info);
	_g_error_free0 (self->err);
}


static GType directory_monitor_query_info_queue_element_get_type (void) {
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}


static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_query_info_queue_element_unref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 133 "DirectoryMonitor.vala"
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type) {
#line 4170 "DirectoryMonitor.c"
	DirectoryMonitorFileInfoMap* self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
	return self;
}


#line 133 "DirectoryMonitor.vala"
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void) {
#line 133 "DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 4180 "DirectoryMonitor.c"
}


#line 136 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, char** id) {
#line 4186 "DirectoryMonitor.c"
	gboolean result = FALSE;
	GFileInfo* local_info;
	char* file_id;
	GFile* known_file;
	char* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 136 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 136 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 136 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 4200 "DirectoryMonitor.c"
	if (normalized != NULL) {
		*normalized = NULL;
	}
	if (id != NULL) {
		*id = NULL;
	}
#line 139 "DirectoryMonitor.vala"
	local_info = _g_object_ref0 (info);
#line 140 "DirectoryMonitor.vala"
	if (local_info == NULL) {
#line 4211 "DirectoryMonitor.c"
		GFileInfo* _tmp0_;
#line 141 "DirectoryMonitor.vala"
		local_info = (_tmp0_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file), _g_object_unref0 (local_info), _tmp0_);
#line 142 "DirectoryMonitor.vala"
		if (local_info == NULL) {
#line 4217 "DirectoryMonitor.c"
			result = FALSE;
			_g_object_unref0 (local_info);
#line 143 "DirectoryMonitor.vala"
			return result;
#line 4222 "DirectoryMonitor.c"
		}
	}
#line 146 "DirectoryMonitor.vala"
	file_id = get_file_info_id (local_info);
#line 147 "DirectoryMonitor.vala"
	if (file_id == NULL) {
#line 4229 "DirectoryMonitor.c"
		result = FALSE;
		_g_free0 (file_id);
		_g_object_unref0 (local_info);
#line 148 "DirectoryMonitor.vala"
		return result;
#line 4235 "DirectoryMonitor.c"
	}
#line 150 "DirectoryMonitor.vala"
	known_file = (GFile*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), file_id);
#line 152 "DirectoryMonitor.vala"
	*id = (_tmp1_ = g_strdup ((const char*) file_id), _g_free0 (*id), _tmp1_);
#line 4241 "DirectoryMonitor.c"
	_tmp2_ = NULL;
#line 153 "DirectoryMonitor.vala"
	if (known_file != NULL) {
#line 153 "DirectoryMonitor.vala"
		_tmp2_ = known_file;
#line 4247 "DirectoryMonitor.c"
	} else {
#line 153 "DirectoryMonitor.vala"
		_tmp2_ = file;
#line 4251 "DirectoryMonitor.c"
	}
#line 153 "DirectoryMonitor.vala"
	*normalized = (_tmp3_ = _g_object_ref0 (_tmp2_), _g_object_unref0 (*normalized), _tmp3_);
#line 4255 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (known_file);
	_g_free0 (file_id);
	_g_object_unref0 (local_info);
#line 155 "DirectoryMonitor.vala"
	return result;
#line 4262 "DirectoryMonitor.c"
}


#line 158 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 4268 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* existing_id;
	gboolean _tmp0_ = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_;
	GFile* _tmp3_;
	char* _tmp4_ = NULL;
	gboolean _tmp5_;
	char* _tmp6_;
#line 158 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 158 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 158 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 160 "DirectoryMonitor.vala"
	if (gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), file)) {
#line 4288 "DirectoryMonitor.c"
		gboolean removed;
#line 161 "DirectoryMonitor.vala"
		removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), file, NULL);
#line 162 "DirectoryMonitor.vala"
		g_assert (removed);
#line 4294 "DirectoryMonitor.c"
	}
#line 166 "DirectoryMonitor.vala"
	existing_id = get_file_info_id (info);
#line 167 "DirectoryMonitor.vala"
	if (existing_id != NULL) {
#line 167 "DirectoryMonitor.vala"
		_tmp0_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->id_map), existing_id);
#line 4302 "DirectoryMonitor.c"
	} else {
#line 167 "DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 4306 "DirectoryMonitor.c"
	}
#line 167 "DirectoryMonitor.vala"
	if (_tmp0_) {
#line 4310 "DirectoryMonitor.c"
		gboolean removed;
#line 168 "DirectoryMonitor.vala"
		removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->id_map), existing_id, NULL);
#line 169 "DirectoryMonitor.vala"
		g_assert (removed);
#line 4316 "DirectoryMonitor.c"
	}
	id = NULL;
	normalized = NULL;
#line 174 "DirectoryMonitor.vala"
	if (!(_tmp5_ = (_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp1_, &_tmp4_), normalized = (_tmp3_ = _tmp1_, _g_object_unref0 (normalized), _tmp3_), _tmp2_), id = (_tmp6_ = _tmp4_, _g_free0 (id), _tmp6_), _tmp5_)) {
#line 4322 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_free0 (existing_id);
#line 175 "DirectoryMonitor.vala"
		return result;
#line 4329 "DirectoryMonitor.c"
	}
#line 177 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), normalized, info);
#line 178 "DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->id_map), id, normalized);
#line 4335 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_free0 (existing_id);
#line 180 "DirectoryMonitor.vala"
	return result;
#line 4342 "DirectoryMonitor.c"
}


#line 183 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 4348 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 183 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 4364 "DirectoryMonitor.c"
	id = NULL;
	normalized = NULL;
#line 186 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 4369 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 187 "DirectoryMonitor.vala"
		return result;
#line 4375 "DirectoryMonitor.c"
	}
#line 189 "DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), normalized, NULL);
#line 190 "DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->id_map), id, NULL);
#line 4381 "DirectoryMonitor.c"
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
#line 192 "DirectoryMonitor.vala"
	return result;
#line 4387 "DirectoryMonitor.c"
}


#line 197 "DirectoryMonitor.vala"
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
#line 197 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 197 "DirectoryMonitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (files));
#line 4397 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it;
#line 198 "DirectoryMonitor.vala"
		_file_it = gee_iterable_iterator (GEE_ITERABLE (files));
#line 198 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4404 "DirectoryMonitor.c"
			GFile* file;
#line 198 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 198 "DirectoryMonitor.vala"
				break;
#line 4410 "DirectoryMonitor.c"
			}
#line 198 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 199 "DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, file, NULL);
#line 4416 "DirectoryMonitor.c"
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


#line 202 "DirectoryMonitor.vala"
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 4426 "DirectoryMonitor.c"
	gboolean result = FALSE;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 202 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 202 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 202 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 4442 "DirectoryMonitor.c"
	id = NULL;
	normalized = NULL;
#line 205 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 4447 "DirectoryMonitor.c"
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 206 "DirectoryMonitor.vala"
		return result;
#line 4453 "DirectoryMonitor.c"
	}
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->id_map), id);
	_g_object_unref0 (normalized);
	_g_free0 (id);
#line 208 "DirectoryMonitor.vala"
	return result;
#line 4460 "DirectoryMonitor.c"
}


#line 211 "DirectoryMonitor.vala"
static char* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
#line 4466 "DirectoryMonitor.c"
	char* result = NULL;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 211 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 211 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 211 "DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), NULL);
#line 213 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 4484 "DirectoryMonitor.c"
		result = get_file_info_id (info);
#line 214 "DirectoryMonitor.vala"
		return result;
#line 4488 "DirectoryMonitor.c"
	}
	id = NULL;
	normalized = NULL;
#line 218 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 4494 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
#line 219 "DirectoryMonitor.vala"
		return result;
#line 4500 "DirectoryMonitor.c"
	}
	result = id;
	_g_object_unref0 (normalized);
#line 221 "DirectoryMonitor.vala"
	return result;
#line 4506 "DirectoryMonitor.c"
}


#line 224 "DirectoryMonitor.vala"
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self) {
#line 4512 "DirectoryMonitor.c"
	GeeCollection* result = NULL;
#line 224 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 4516 "DirectoryMonitor.c"
	result = GEE_COLLECTION (gee_map_get_keys (GEE_MAP (self->priv->map)));
#line 225 "DirectoryMonitor.vala"
	return result;
#line 4520 "DirectoryMonitor.c"
}


#line 228 "DirectoryMonitor.vala"
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file) {
#line 4526 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
	GFileInfo* info;
	char* id;
	GFile* normalized;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	GFile* _tmp2_;
	char* _tmp3_ = NULL;
	gboolean _tmp4_;
	char* _tmp5_;
#line 228 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 228 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 230 "DirectoryMonitor.vala"
	info = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
#line 231 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 4545 "DirectoryMonitor.c"
		result = info;
#line 232 "DirectoryMonitor.vala"
		return result;
#line 4549 "DirectoryMonitor.c"
	}
	id = NULL;
	normalized = NULL;
#line 236 "DirectoryMonitor.vala"
	if (!(_tmp4_ = (_tmp1_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp0_, &_tmp3_), normalized = (_tmp2_ = _tmp0_, _g_object_unref0 (normalized), _tmp2_), _tmp1_), id = (_tmp5_ = _tmp3_, _g_free0 (id), _tmp5_), _tmp4_)) {
#line 4555 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
#line 237 "DirectoryMonitor.vala"
		return result;
#line 4562 "DirectoryMonitor.c"
	}
	result = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), normalized);
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
#line 239 "DirectoryMonitor.vala"
	return result;
#line 4570 "DirectoryMonitor.c"
}


#line 242 "DirectoryMonitor.vala"
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable) {
#line 4576 "DirectoryMonitor.c"
	GFileInfo* result = NULL;
	GFileInfo* info;
	char* id;
	GFile* normalized;
	GError * _inner_error_ = NULL;
#line 242 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 242 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 242 "DirectoryMonitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 243 "DirectoryMonitor.vala"
	info = directory_monitor_file_info_map_get_info (self, file);
#line 244 "DirectoryMonitor.vala"
	if (info != NULL) {
#line 4592 "DirectoryMonitor.c"
		result = info;
#line 245 "DirectoryMonitor.vala"
		return result;
#line 4596 "DirectoryMonitor.c"
	}
	{
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
#line 250 "DirectoryMonitor.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, cancellable, &_inner_error_);
#line 4603 "DirectoryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch346_g_error;
		}
#line 250 "DirectoryMonitor.vala"
		info = (_tmp1_ = _tmp0_, _g_object_unref0 (info), _tmp1_);
#line 4609 "DirectoryMonitor.c"
	}
	goto __finally346;
	__catch346_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp2_;
#line 252 "DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:252: Unable to query file ID of %s: %s", _tmp2_ = g_file_get_path (file), err->message);
#line 4621 "DirectoryMonitor.c"
			_g_free0 (_tmp2_);
			result = NULL;
			_g_error_free0 (err);
			_g_object_unref0 (info);
#line 254 "DirectoryMonitor.vala"
			return result;
#line 4628 "DirectoryMonitor.c"
		}
	}
	__finally346:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 257 "DirectoryMonitor.vala"
	if (!directory_monitor_is_file_symlink_supported (info)) {
#line 4640 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (info);
#line 258 "DirectoryMonitor.vala"
		return result;
#line 4645 "DirectoryMonitor.c"
	}
#line 260 "DirectoryMonitor.vala"
	id = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE));
#line 261 "DirectoryMonitor.vala"
	if (id == NULL) {
#line 4651 "DirectoryMonitor.c"
		result = NULL;
		_g_free0 (id);
		_g_object_unref0 (info);
#line 262 "DirectoryMonitor.vala"
		return result;
#line 4657 "DirectoryMonitor.c"
	}
#line 264 "DirectoryMonitor.vala"
	normalized = (GFile*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), id);
#line 265 "DirectoryMonitor.vala"
	if (normalized == NULL) {
#line 4663 "DirectoryMonitor.c"
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
#line 266 "DirectoryMonitor.vala"
		return result;
#line 4670 "DirectoryMonitor.c"
	}
	result = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
#line 268 "DirectoryMonitor.vala"
	return result;
#line 4678 "DirectoryMonitor.c"
}


#line 271 "DirectoryMonitor.vala"
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match) {
#line 4684 "DirectoryMonitor.c"
	GFile* result = NULL;
	char* match_id;
	gint64 match_size;
	GTimeVal match_time = {0};
#line 271 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 271 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (match), NULL);
#line 272 "DirectoryMonitor.vala"
	match_id = get_file_info_id (match);
#line 273 "DirectoryMonitor.vala"
	if (match_id == NULL) {
#line 4697 "DirectoryMonitor.c"
		result = NULL;
		_g_free0 (match_id);
#line 274 "DirectoryMonitor.vala"
		return result;
#line 4702 "DirectoryMonitor.c"
	}
#line 277 "DirectoryMonitor.vala"
	match_size = g_file_info_get_size (match);
#line 279 "DirectoryMonitor.vala"
	g_file_info_get_modification_time (match, &match_time);
#line 4708 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 281 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 281 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4717 "DirectoryMonitor.c"
			GFile* file;
			GFileInfo* info;
			char* _tmp2_;
			gboolean _tmp3_;
			GTimeVal time = {0};
#line 281 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 281 "DirectoryMonitor.vala"
				break;
#line 4727 "DirectoryMonitor.c"
			}
#line 281 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 282 "DirectoryMonitor.vala"
			info = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
#line 285 "DirectoryMonitor.vala"
			if ((_tmp3_ = _vala_strcmp0 (_tmp2_ = get_file_info_id (info), match_id) == 0, _g_free0 (_tmp2_), _tmp3_)) {
#line 4735 "DirectoryMonitor.c"
				result = file;
				_g_object_unref0 (info);
				_g_object_unref0 (_file_it);
				_g_free0 (match_id);
#line 286 "DirectoryMonitor.vala"
				return result;
#line 4742 "DirectoryMonitor.c"
			}
#line 289 "DirectoryMonitor.vala"
			if (match_size != g_file_info_get_size (info)) {
#line 4746 "DirectoryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 290 "DirectoryMonitor.vala"
				continue;
#line 4751 "DirectoryMonitor.c"
			}
#line 293 "DirectoryMonitor.vala"
			g_file_info_get_modification_time (info, &time);
#line 295 "DirectoryMonitor.vala"
			if (time.tv_sec != match_time.tv_sec) {
#line 4757 "DirectoryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 296 "DirectoryMonitor.vala"
				continue;
#line 4762 "DirectoryMonitor.c"
			}
			result = file;
			_g_object_unref0 (info);
			_g_object_unref0 (_file_it);
			_g_free0 (match_id);
#line 298 "DirectoryMonitor.vala"
			return result;
#line 4770 "DirectoryMonitor.c"
		}
		_g_object_unref0 (_file_it);
	}
	result = NULL;
	_g_free0 (match_id);
#line 301 "DirectoryMonitor.vala"
	return result;
#line 4778 "DirectoryMonitor.c"
}


#line 304 "DirectoryMonitor.vala"
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents) {
#line 4784 "DirectoryMonitor.c"
	GeeArrayList* pruned;
#line 304 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 304 "DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 304 "DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
#line 305 "DirectoryMonitor.vala"
	pruned = NULL;
#line 4794 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 306 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 306 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4803 "DirectoryMonitor.c"
			GFile* file;
			GFile* parent;
#line 306 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 306 "DirectoryMonitor.vala"
				break;
#line 4810 "DirectoryMonitor.c"
			}
#line 306 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 307 "DirectoryMonitor.vala"
			parent = g_file_get_parent (file);
#line 308 "DirectoryMonitor.vala"
			while (TRUE) {
#line 4818 "DirectoryMonitor.c"
				GFile* _tmp4_;
#line 308 "DirectoryMonitor.vala"
				if (!(parent != NULL)) {
#line 308 "DirectoryMonitor.vala"
					break;
#line 4824 "DirectoryMonitor.c"
				}
#line 309 "DirectoryMonitor.vala"
				if (g_file_equal (parent, root)) {
#line 4828 "DirectoryMonitor.c"
					GFileInfo* _tmp3_;
#line 310 "DirectoryMonitor.vala"
					if (pruned == NULL) {
#line 4832 "DirectoryMonitor.c"
						GeeArrayList* _tmp2_;
#line 311 "DirectoryMonitor.vala"
						pruned = (_tmp2_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (pruned), _tmp2_);
#line 4836 "DirectoryMonitor.c"
					}
#line 313 "DirectoryMonitor.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (pruned), file);
#line 314 "DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (descendents, file, _tmp3_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file));
#line 4842 "DirectoryMonitor.c"
					_g_object_unref0 (_tmp3_);
#line 316 "DirectoryMonitor.vala"
					break;
#line 4846 "DirectoryMonitor.c"
				}
#line 319 "DirectoryMonitor.vala"
				parent = (_tmp4_ = g_file_get_parent (parent), _g_object_unref0 (parent), _tmp4_);
#line 4850 "DirectoryMonitor.c"
			}
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
#line 323 "DirectoryMonitor.vala"
	if (pruned != NULL) {
#line 324 "DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, GEE_COLLECTION (pruned));
#line 4861 "DirectoryMonitor.c"
	}
	_g_object_unref0 (pruned);
}


#line 329 "DirectoryMonitor.vala"
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs) {
#line 4869 "DirectoryMonitor.c"
	gint result = 0;
	gint count;
#line 329 "DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
#line 329 "DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), 0);
#line 329 "DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (files), 0);
#line 329 "DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (dirs), 0);
#line 330 "DirectoryMonitor.vala"
	count = 0;
#line 4882 "DirectoryMonitor.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 331 "DirectoryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 331 "DirectoryMonitor.vala"
		while (TRUE) {
#line 4891 "DirectoryMonitor.c"
			GFile* file;
			GFile* parent;
			gboolean _tmp2_ = FALSE;
			GFileInfo* _tmp3_;
			DirectoryMonitorFType _tmp4_;
			DirectoryMonitorFType ftype;
#line 331 "DirectoryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 331 "DirectoryMonitor.vala"
				break;
#line 4902 "DirectoryMonitor.c"
			}
#line 331 "DirectoryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 332 "DirectoryMonitor.vala"
			parent = g_file_get_parent (file);
#line 333 "DirectoryMonitor.vala"
			if (parent == NULL) {
#line 333 "DirectoryMonitor.vala"
				_tmp2_ = TRUE;
#line 4912 "DirectoryMonitor.c"
			} else {
#line 333 "DirectoryMonitor.vala"
				_tmp2_ = !g_file_equal (parent, root);
#line 4916 "DirectoryMonitor.c"
			}
#line 333 "DirectoryMonitor.vala"
			if (_tmp2_) {
#line 4920 "DirectoryMonitor.c"
				_g_object_unref0 (parent);
				_g_object_unref0 (file);
#line 334 "DirectoryMonitor.vala"
				continue;
#line 4925 "DirectoryMonitor.c"
			}
#line 336 "DirectoryMonitor.vala"
			ftype = (_tmp4_ = directory_monitor_get_ftype (_tmp3_ = (GFileInfo*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file)), _g_object_unref0 (_tmp3_), _tmp4_);
#line 337 "DirectoryMonitor.vala"
			switch (ftype) {
#line 4931 "DirectoryMonitor.c"
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
#line 339 "DirectoryMonitor.vala"
					gee_collection_add (files, file);
#line 340 "DirectoryMonitor.vala"
					count++;
#line 341 "DirectoryMonitor.vala"
					break;
#line 4940 "DirectoryMonitor.c"
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
#line 344 "DirectoryMonitor.vala"
					gee_collection_add (dirs, file);
#line 345 "DirectoryMonitor.vala"
					count++;
#line 346 "DirectoryMonitor.vala"
					break;
#line 4950 "DirectoryMonitor.c"
				}
				default:
				{
#line 349 "DirectoryMonitor.vala"
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 350 "DirectoryMonitor.vala"
					break;
#line 4958 "DirectoryMonitor.c"
				}
			}
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	result = count;
#line 354 "DirectoryMonitor.vala"
	return result;
#line 4969 "DirectoryMonitor.c"
}


static void directory_monitor_value_file_info_map_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_file_info_map_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_file_info_map_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_file_info_map_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_file_info_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorFileInfoMap* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_file_info_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorFileInfoMap** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecFileInfoMap* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_file_info_map (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass) {
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_file_info_map_finalize;
	g_type_class_add_private (klass, sizeof (DirectoryMonitorFileInfoMapPrivate));
}


static void directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self) {
	self->priv = DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
	self->priv->id_map = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, g_file_equal);
	self->ref_count = 1;
}


static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorFileInfoMap * self;
	self = DIRECTORY_MONITOR_FILE_INFO_MAP (obj);
	_g_object_unref0 (self->priv->map);
	_g_object_unref0 (self->priv->id_map);
}


static GType directory_monitor_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}


static gpointer directory_monitor_file_info_map_ref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_file_info_map_unref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void directory_monitor_class_init (DirectoryMonitorClass * klass) {
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DirectoryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_deleted = directory_monitor_real_notify_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_moved = directory_monitor_real_notify_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_started = directory_monitor_real_notify_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_file_discovered = directory_monitor_real_internal_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_discovered = directory_monitor_real_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_directory_discovered = directory_monitor_real_internal_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_discovered = directory_monitor_real_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_failed = directory_monitor_real_notify_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_completed = directory_monitor_real_notify_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = directory_monitor_real_notify_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = directory_monitor_real_notify_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = directory_monitor_real_notify_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = directory_monitor_real_notify_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = directory_monitor_real_notify_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = directory_monitor_real_notify_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_created = directory_monitor_real_notify_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_moved = directory_monitor_real_notify_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_altered = directory_monitor_real_notify_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_alteration_completed = directory_monitor_real_notify_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_attributes_altered = directory_monitor_real_notify_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_deleted = directory_monitor_real_notify_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_closed = directory_monitor_real_notify_closed;
	DIRECTORY_MONITOR_CLASS (klass)->close = directory_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->root_moved = directory_monitor_real_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->root_deleted = directory_monitor_real_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = directory_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = directory_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_discovered = directory_monitor_real_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_failed = directory_monitor_real_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = directory_monitor_real_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_created = directory_monitor_real_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->file_moved = directory_monitor_real_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->file_altered = directory_monitor_real_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_deleted = directory_monitor_real_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->directory_created = directory_monitor_real_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->directory_moved = directory_monitor_real_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->directory_altered = directory_monitor_real_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_deleted = directory_monitor_real_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->closed = directory_monitor_real_closed;
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
	g_signal_new ("root_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("root_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("discovery_started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("discovery_failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("discovery_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("file_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("file_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void directory_monitor_instance_init (DirectoryMonitor * self) {
	self->priv = DIRECTORY_MONITOR_GET_PRIVATE (self);
	self->priv->monitors = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	self->priv->query_info_queue = GEE_QUEUE (gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, directory_monitor_query_info_queue_element_unref, NULL));
	self->priv->files = directory_monitor_file_info_map_new ();
	self->priv->parent_moved = directory_monitor_file_info_map_new ();
	self->priv->cancellable = g_cancellable_new ();
	self->priv->outstanding_exploration_dirs = 0;
	self->priv->started = FALSE;
	self->priv->has_discovery_started = FALSE;
	self->priv->delete_timer_id = (guint) 0;
}


static void directory_monitor_finalize (GObject* obj) {
	DirectoryMonitor * self;
	self = DIRECTORY_MONITOR (obj);
	_g_object_unref0 (self->priv->root);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->query_info_queue);
	_directory_monitor_file_info_map_unref0 (self->priv->files);
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
}


GType directory_monitor_get_type (void) {
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}



