/* LibraryMonitor.c generated by valac 0.10.3, the Vala compiler
 * generated from LibraryMonitor.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* LibraryMonitor uses DirectoryMonitor to track assets in the user's library directory and make*/
/* sure they're reflected in the application.*/
/**/
/* NOTE: There appears to be a bug where prior versions of Shotwell (<= 0.6.x) were not*/
/* properly loading the file modification timestamp during import.  This was no issue*/
/* before but becomes imperative now with file monitoring.  A "proper" algorithm is*/
/* to reimport an entire photo if the modification time in the database is different*/
/* than the file's, but that's Real Bad when the user first turns on monitoring, as it*/
/* will cause a lot of reimports (think of a 10,000 photo database) and will blow away*/
/* ALL transformations, as they are now suspect.*/
/**/
/* So: If the modification time is zero and filesize is the same, simply update the*/
/* timestamp in the database and move on.*/
/**/
/* TODO: Although it seems highly unlikely that a file's timestamp could change but the file size*/
/* has not and the file really be "changed", it *is* possible, even in the case of complex little*/
/* animals like photo files.  We could be more liberal and treat this case as a metadata-changed*/
/* situation (since that's a likely case).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>
#include <gobject/gvaluecollector.h>


#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;
typedef struct _LibraryMonitorPoolPrivate LibraryMonitorPoolPrivate;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecLibraryMonitorPool ParamSpecLibraryMonitorPool;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;
typedef struct _LibraryMonitorPrivate LibraryMonitorPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_BATCH_IMPORT (batch_import_get_type ())
#define BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT, BatchImport))
#define BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT, BatchImportClass))
#define IS_BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT))
#define IS_BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT))
#define BATCH_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT, BatchImportClass))

typedef struct _BatchImport BatchImport;
typedef struct _BatchImportClass BatchImportClass;

#define TYPE_BATCH_IMPORT_ROLL (batch_import_roll_get_type ())
#define BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRoll))
#define BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))
#define IS_BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_ROLL))
#define IS_BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_ROLL))
#define BATCH_IMPORT_ROLL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))

typedef struct _BatchImportRoll BatchImportRoll;
typedef struct _BatchImportRollClass BatchImportRollClass;

#define LIBRARY_MONITOR_TYPE_VERIFY_JOB (library_monitor_verify_job_get_type ())
#define LIBRARY_MONITOR_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob))
#define LIBRARY_MONITOR_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))
#define LIBRARY_MONITOR_IS_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_IS_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))

typedef struct _LibraryMonitorVerifyJob LibraryMonitorVerifyJob;
typedef struct _LibraryMonitorVerifyJobClass LibraryMonitorVerifyJobClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _batch_import_roll_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_roll_unref (var), NULL)))

#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define MEDIA_MONITOR_TYPE_DISCOVERED_FILE (media_monitor_discovered_file_get_type ())

#define TYPE_TOMBSTONE_SOURCE_COLLECTION (tombstone_source_collection_get_type ())
#define TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollection))
#define TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))
#define IS_TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define IS_TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define TOMBSTONE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))

typedef struct _TombstoneSourceCollection TombstoneSourceCollection;
typedef struct _TombstoneSourceCollectionClass TombstoneSourceCollectionClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB (library_monitor_find_move_job_get_type ())
#define LIBRARY_MONITOR_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))

typedef struct _LibraryMonitorFindMoveJob LibraryMonitorFindMoveJob;
typedef struct _LibraryMonitorFindMoveJobClass LibraryMonitorFindMoveJobClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _LibraryMonitorAsyncDiscoveryCompletedData LibraryMonitorAsyncDiscoveryCompletedData;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _LibraryMonitorFindMoveJobPrivate LibraryMonitorFindMoveJobPrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _library_monitor_verify_job_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_verify_job_unref (var), NULL)))
typedef struct _LibraryMonitorVerifyJobPrivate LibraryMonitorVerifyJobPrivate;
typedef struct _LibraryMonitorVerifyMonitorableData LibraryMonitorVerifyMonitorableData;

#define TYPE_BATCH_IMPORT_JOB (batch_import_job_get_type ())
#define BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJob))
#define BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))
#define IS_BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_JOB))
#define IS_BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_JOB))
#define BATCH_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))

typedef struct _BatchImportJob BatchImportJob;
typedef struct _BatchImportJobClass BatchImportJobClass;

#define TYPE_FILE_IMPORT_JOB (file_import_job_get_type ())
#define FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_IMPORT_JOB, FileImportJob))
#define FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_IMPORT_JOB, FileImportJobClass))
#define IS_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_IMPORT_JOB))
#define IS_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_IMPORT_JOB))
#define FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_IMPORT_JOB, FileImportJobClass))

typedef struct _FileImportJob FileImportJob;
typedef struct _FileImportJobClass FileImportJobClass;
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))

#define TYPE_IMPORT_MANIFEST (import_manifest_get_type ())
#define IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_MANIFEST, ImportManifest))
#define IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_MANIFEST, ImportManifestClass))
#define IS_IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_MANIFEST))
#define IS_IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_MANIFEST))
#define IMPORT_MANIFEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_MANIFEST, ImportManifestClass))

typedef struct _ImportManifest ImportManifest;
typedef struct _ImportManifestClass ImportManifestClass;
typedef struct _ImportManifestPrivate ImportManifestPrivate;

#define TYPE_BATCH_IMPORT_RESULT (batch_import_result_get_type ())
#define BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResult))
#define BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))
#define IS_BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_RESULT))
#define IS_BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_RESULT))
#define BATCH_IMPORT_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))

typedef struct _BatchImportResult BatchImportResult;
typedef struct _BatchImportResultClass BatchImportResultClass;
typedef struct _BatchImportResultPrivate BatchImportResultPrivate;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))

#define TYPE_TOMBSTONED_FILE (tombstoned_file_get_type ())
#define TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONED_FILE, TombstonedFile))
#define TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONED_FILE, TombstonedFileClass))
#define IS_TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONED_FILE))
#define IS_TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONED_FILE))
#define TOMBSTONED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONED_FILE, TombstonedFileClass))

typedef struct _TombstonedFile TombstonedFile;
typedef struct _TombstonedFileClass TombstonedFileClass;
#define _tombstoned_file_unref0(var) ((var == NULL) ? NULL : (var = (tombstoned_file_unref (var), NULL)))

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())

#define LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB (library_monitor_runtime_find_move_job_get_type ())
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))

typedef struct _LibraryMonitorRuntimeFindMoveJob LibraryMonitorRuntimeFindMoveJob;
typedef struct _LibraryMonitorRuntimeFindMoveJobClass LibraryMonitorRuntimeFindMoveJobClass;
typedef struct _LibraryMonitorRuntimeFindMoveJobPrivate LibraryMonitorRuntimeFindMoveJobPrivate;

#define TYPE_TOMBSTONE (tombstone_get_type ())
#define TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE, Tombstone))
#define TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE, TombstoneClass))
#define IS_TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE))
#define IS_TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE))
#define TOMBSTONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE, TombstoneClass))

typedef struct _Tombstone Tombstone;
typedef struct _TombstoneClass TombstoneClass;
typedef struct _LibraryMonitorParamSpecVerifyJob LibraryMonitorParamSpecVerifyJob;

struct _LibraryMonitorPool {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorPoolPrivate * priv;
};

struct _LibraryMonitorPoolClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorPool *self);
};

struct _LibraryMonitorPoolPrivate {
	LibraryMonitor* monitor;
	guint timer_id;
};

struct _ParamSpecLibraryMonitorPool {
	GParamSpec parent_instance;
};

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const char* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _LibraryMonitor {
	DirectoryMonitor parent_instance;
	LibraryMonitorPrivate * priv;
};

struct _LibraryMonitorClass {
	DirectoryMonitorClass parent_class;
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryMonitorPrivate {
	Workers* workers;
	GCancellable* cancellable;
	gboolean auto_import;
	GeeHashSet* unknown_files;
	GeeList* monitors;
	GeeHashMap* discovered;
	GeeHashSet* import_queue;
	GeeHashSet* pending_imports;
	GeeArrayList* batch_import_queue;
	BatchImportRoll* current_import_roll;
	time_t last_import_roll_use;
	BatchImport* current_batch_import;
	gint checksums_completed;
	gint checksums_total;
	guint import_queue_timer_id;
	GeeQueue* verify_queue;
	gint outstanding_verify_jobs;
	gint completed_monitorable_verifies;
	gint total_monitorable_verifies;
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
typedef enum  {
	MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED,
	MEDIA_MONITOR_DISCOVERED_FILE_IGNORE,
	MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN
} MediaMonitorDiscoveredFile;

struct _LibraryMonitorAsyncDiscoveryCompletedData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	LibraryMonitor* self;
	GeeArrayList* all_candidates;
	GeeArrayList* adopted;
	GeeIterator* _file_it;
	GFile* file;
	GFileInfo* info;
	GeeCollection* candidates;
	gboolean associated;
	GeeIterator* _monitor_it;
	MediaMonitor* monitor;
	MediaMonitorDiscoveredFile _result_;
	GeeCollection* _tmp0_;
	gboolean _tmp1_;
	GeeArrayList* job_candidates;
	GeeArrayList* _tmp2_;
	LibraryMonitorFindMoveJob* _tmp3_;
	char* _tmp4_;
};

typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _LibraryMonitorFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GeeArrayList* losers;
	GError* err;
};

struct _LibraryMonitorFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorVerifyJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorVerifyJobPrivate * priv;
	Monitorable* monitorable;
	MediaMonitor* monitor;
};

struct _LibraryMonitorVerifyJobClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorVerifyJob *self);
};

struct _LibraryMonitorVerifyMonitorableData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	LibraryMonitor* self;
	Monitorable* monitorable;
	MediaMonitor* monitor;
	GFile** files;
	gint files_length1;
	gint _files_size_;
	GFile** _tmp0_;
	GFile* _tmp1_;
	GFile** aux_files;
	gint _tmp2_;
	gint aux_files_length1;
	gint _aux_files_size_;
	GFile** _tmp3_;
	GFile** aux_file_collection;
	int aux_file_collection_length1;
	int aux_file_it;
	GFile* aux_file;
	gint ctr;
	gboolean _tmp4_;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp5_;
	GFileInfo* _tmp6_;
	GError * err;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_;
};

typedef void (*BatchImportImportReporter) (ImportManifest* manifest, BatchImportRoll* import_roll, void* user_data);
struct _ImportManifest {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImportManifestPrivate * priv;
	GeeList* imported;
	GeeList* success;
	GeeList* camera_failed;
	GeeList* failed;
	GeeList* skipped_photos;
	GeeList* skipped_files;
	GeeList* aborted;
	GeeList* already_imported;
	GeeList* all;
};

struct _ImportManifestClass {
	GTypeClass parent_class;
	void (*finalize) (ImportManifest *self);
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR
} ImportResult;

struct _BatchImportResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportResultPrivate * priv;
	BatchImportJob* job;
	GFile* file;
	char* src_identifier;
	char* dest_identifier;
	ImportResult result;
	char* errmsg;
};

struct _BatchImportResultClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportResult *self);
};

typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _LibraryMonitorRuntimeFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorRuntimeFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GError* err;
};

struct _LibraryMonitorRuntimeFindMoveJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
struct _LibraryMonitorParamSpecVerifyJob {
	GParamSpec parent_instance;
};


static LibraryMonitorPool* library_monitor_pool_instance;
static LibraryMonitorPool* library_monitor_pool_instance = NULL;
static gpointer library_monitor_pool_parent_class = NULL;
static GeeHashSet* library_monitor_blacklist;
static GStaticRecMutex __lock_library_monitor_blacklist = {0};
static GeeHashSet* library_monitor_blacklist = NULL;
static HashTimedQueue* library_monitor_to_unblacklist;
static HashTimedQueue* library_monitor_to_unblacklist = NULL;
extern TombstoneSourceCollection* tombstone_global;
extern gboolean commandline_options_no_runtime_monitoring;
static gpointer library_monitor_find_move_job_parent_class = NULL;
static gpointer library_monitor_runtime_find_move_job_parent_class = NULL;
static gpointer library_monitor_verify_job_parent_class = NULL;
static gpointer library_monitor_parent_class = NULL;

gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_library_monitor_pool (GValue* value, gpointer v_object);
void value_take_library_monitor_pool (GValue* value, gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
#define LIBRARY_MONITOR_POOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolPrivate))
enum  {
	LIBRARY_MONITOR_POOL_DUMMY_PROPERTY
};
static LibraryMonitorPool* library_monitor_pool_new (void);
static LibraryMonitorPool* library_monitor_pool_construct (GType object_type);
void library_monitor_pool_init (void);
void library_monitor_pool_terminate (void);
static void library_monitor_pool_close (LibraryMonitorPool* self);
LibraryMonitorPool* library_monitor_pool_get_instance (void);
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self);
void library_monitor_pool_replace (LibraryMonitorPool* self, LibraryMonitor* replacement, gint start_msec_delay);
static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self);
static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self);
void directory_monitor_close (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self, GError** error);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
static void library_monitor_pool_finalize (LibraryMonitorPool* obj);
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
GType batch_import_get_type (void) G_GNUC_CONST;
gpointer batch_import_roll_ref (gpointer instance);
void batch_import_roll_unref (gpointer instance);
GParamSpec* param_spec_batch_import_roll (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_roll (GValue* value, gpointer v_object);
void value_take_batch_import_roll (GValue* value, gpointer v_object);
gpointer value_get_batch_import_roll (const GValue* value);
GType batch_import_roll_get_type (void) G_GNUC_CONST;
static gpointer library_monitor_verify_job_ref (gpointer instance);
static void library_monitor_verify_job_unref (gpointer instance);
static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void library_monitor_value_set_verify_job (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void library_monitor_value_take_verify_job (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer library_monitor_value_get_verify_job (const GValue* value) G_GNUC_UNUSED;
static GType library_monitor_verify_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define LIBRARY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_MONITOR, LibraryMonitorPrivate))
enum  {
	LIBRARY_MONITOR_DUMMY_PROPERTY
};
#define LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC (5 * 1000)
static void library_monitor_on_unblacklist_file (GFile* file);
static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item, gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
gint workers_thread_per_cpu_minus_one (void);
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
#define LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC 3
#define LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC (5 * 60)
#define LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS 5
LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
Config* config_get_instance (void);
gboolean config_get_auto_import_from_library (Config* self);
static void library_monitor_on_config_bool_changed (LibraryMonitor* self, const char* path, gboolean value);
static void _library_monitor_on_config_bool_changed_config_bool_changed (Config* _sender, const char* path, gboolean value, gpointer self);
static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self);
static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self);
static void library_monitor_real_close (DirectoryMonitor* base);
void media_monitor_close (MediaMonitor* self);
static void library_monitor_add_to_discovered_list (LibraryMonitor* self, MediaMonitor* monitor, Monitorable* monitorable);
static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self, Monitorable* monitorable);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
MediaSourceCollection* media_monitor_get_media_source_collection (MediaMonitor* self);
gboolean source_collection_holds_type_of_source (SourceCollection* self, DataSource* source);
char* data_object_to_string (DataObject* self);
static void library_monitor_real_discovery_started (DirectoryMonitor* base);
gpointer media_collection_registry_ref (gpointer instance);
void media_collection_registry_unref (gpointer instance);
GParamSpec* param_spec_media_collection_registry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_collection_registry (GValue* value, gpointer v_object);
void value_take_media_collection_registry (GValue* value, gpointer v_object);
gpointer value_get_media_collection_registry (const GValue* value);
GType media_collection_registry_get_type (void) G_GNUC_CONST;
MediaCollectionRegistry* media_collection_registry_get_instance (void);
GeeCollection* media_collection_registry_get_all (MediaCollectionRegistry* self);
MediaMonitor* media_source_collection_create_media_monitor (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
void media_monitor_notify_discovery_started (MediaMonitor* self);
static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info);
GType media_monitor_discovered_file_get_type (void) G_GNUC_CONST;
MediaMonitorDiscoveredFile media_monitor_notify_file_discovered (MediaMonitor* self, GFile* file, GFileInfo* info, Monitorable** monitorable);
GType tombstone_source_collection_get_type (void) G_GNUC_CONST;
gboolean tombstone_source_collection_matches (TombstoneSourceCollection* self, GFile* file);
static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self, GFile* file);
static void library_monitor_real_discovery_completed (DirectoryMonitor* base);
static void library_monitor_async_discovery_completed (LibraryMonitor* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self, GAsyncResult* _res_);
static void library_monitor_async_discovery_completed_data_free (gpointer _data);
static void library_monitor_async_discovery_completed_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* data);
static void library_monitor_discovery_stage_completed (LibraryMonitor* self);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
GeeCollection* media_monitor_candidates_for_unknown_file (MediaMonitor* self, GFile* file, GFileInfo* info, MediaMonitorDiscoveredFile* _result_);
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
void workers_enqueue (Workers* self, BackgroundJob* job);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static GType library_monitor_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self);
void directory_monitor_mdbg (const char* msg);
static void library_monitor_report_checksum_job_completed (LibraryMonitor* self);
static void library_monitor_on_find_move_completed (LibraryMonitor* self, BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
void media_monitor_update_master_file (MediaMonitor* self, Monitorable* monitorable, GFile* file);
static void library_monitor_on_find_move_cancelled (LibraryMonitor* self, BackgroundJob* j);
static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor);
GeeCollection* data_collection_get_all (DataCollection* self);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
static void library_monitor_enqueue_import_many (LibraryMonitor* self, GeeCollection* files);
void tombstone_source_collection_launch_scan (TombstoneSourceCollection* self, DirectoryMonitor* monitor, GCancellable* cancellable);
static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable, MediaMonitor* monitor);
static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type, Monitorable* monitorable, MediaMonitor* monitor);
static void library_monitor_execute_next_verify_job (LibraryMonitor* self);
static void library_monitor_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void library_monitor_verify_monitorable_finish (LibraryMonitor* self, GAsyncResult* _res_);
static void library_monitor_verify_monitorable_data_free (gpointer _data);
static void library_monitor_verify_monitorable_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* data);
GFile* media_monitor_get_master_file (MediaMonitor* self, Monitorable* monitorable);
GFile** media_monitor_get_auxilliary_backing_files (MediaMonitor* self, Monitorable* monitorable, int* result_length1);
static void _vala_array_add261 (GFile*** array, int* length, int* size, GFile* value);
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
gboolean media_monitor_is_offline (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_online (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_offline (MediaMonitor* self, Monitorable* monitorable);
void media_monitor_update_backing_file_info (MediaMonitor* self, Monitorable* monitorable, GFile* file, GFileInfo* info);
static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self);
#define CONFIG_PATH_SHOTWELL "/apps/shotwell/preferences"
#define CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY CONFIG_PATH_SHOTWELL "/files/auto_import"
static void library_monitor_import_unrepresented_files (LibraryMonitor* self);
static void library_monitor_cancel_batch_imports (LibraryMonitor* self);
static void library_monitor_enqueue_import (LibraryMonitor* self, GFile* file);
gboolean library_monitor_is_blacklisted (GFile* file);
static void library_monitor_remove_queued_import (LibraryMonitor* self, GFile* file);
gulong now_sec (void);
BatchImportRoll* batch_import_roll_new (void);
BatchImportRoll* batch_import_roll_construct (GType object_type);
gpointer batch_import_job_ref (gpointer instance);
void batch_import_job_unref (gpointer instance);
GParamSpec* param_spec_batch_import_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_job (GValue* value, gpointer v_object);
void value_take_batch_import_job (GValue* value, gpointer v_object);
gpointer value_get_batch_import_job (const GValue* value);
GType batch_import_job_get_type (void) G_GNUC_CONST;
FileImportJob* file_import_job_new (GFile* file_or_dir, gboolean copy_to_library);
FileImportJob* file_import_job_construct (GType object_type, GFile* file_or_dir, gboolean copy_to_library);
GType file_import_job_get_type (void) G_GNUC_CONST;
gpointer import_manifest_ref (gpointer instance);
void import_manifest_unref (gpointer instance);
GParamSpec* param_spec_import_manifest (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_import_manifest (GValue* value, gpointer v_object);
void value_take_import_manifest (GValue* value, gpointer v_object);
gpointer value_get_import_manifest (const GValue* value);
GType import_manifest_get_type (void) G_GNUC_CONST;
BatchImport* batch_import_new (GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable, BatchImportRoll* import_roll, ImportManifest* skip_manifest);
BatchImport* batch_import_construct (GType object_type, GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable, BatchImportRoll* import_roll, ImportManifest* skip_manifest);
void batch_import_set_untrash_duplicates (BatchImport* self, gboolean untrash_duplicates);
static void library_monitor_schedule_next_batch_import (LibraryMonitor* self);
static void library_monitor_on_import_preparing (LibraryMonitor* self);
static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender, gpointer self);
static void library_monitor_on_import_progress (LibraryMonitor* self, guint64 completed_bytes, guint64 total_bytes);
static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender, guint64 completed_bytes, guint64 total_bytes, gpointer self);
static void library_monitor_on_import_complete (LibraryMonitor* self, BatchImport* batch_import, ImportManifest* manifest, BatchImportRoll* import_roll);
static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender, ImportManifest* manifest, BatchImportRoll* import_roll, gpointer self);
void batch_import_schedule (BatchImport* self);
static void library_monitor_discard_current_batch_import (LibraryMonitor* self);
void batch_import_user_halt (BatchImport* self);
gpointer batch_import_result_ref (gpointer instance);
void batch_import_result_unref (gpointer instance);
GParamSpec* param_spec_batch_import_result (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_result (GValue* value, gpointer v_object);
void value_take_batch_import_result (GValue* value, gpointer v_object);
gpointer value_get_batch_import_result (const GValue* value);
GType batch_import_result_get_type (void) G_GNUC_CONST;
GType import_result_get_type (void) G_GNUC_CONST;
gpointer tombstoned_file_ref (gpointer instance);
void tombstoned_file_unref (gpointer instance);
GParamSpec* param_spec_tombstoned_file (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_tombstoned_file (GValue* value, gpointer v_object);
void value_take_tombstoned_file (GValue* value, gpointer v_object);
gpointer value_get_tombstoned_file (const GValue* value);
GType tombstoned_file_get_type (void) G_GNUC_CONST;
TombstonedFile* tombstoned_file_new (GFile* file, gint64 filesize, const char* md5);
TombstonedFile* tombstoned_file_construct (GType object_type, GFile* file, gint64 filesize, const char* md5);
GType tombstone_reason_get_type (void) G_GNUC_CONST;
GQuark database_error_quark (void);
void tombstone_entomb_many_files (GeeCollection* files, TombstoneReason reason, GError** error);
void app_window_database_error (GError* err);
void library_monitor_blacklist_file (GFile* file, const char* reason);
void library_monitor_unblacklist_file (GFile* file);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
MediaSourceCollection* media_collection_registry_get_collection_for_file (MediaCollectionRegistry* self, GFile* file);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
gboolean media_monitor_is_file_represented (MediaMonitor* self, GFile* file);
static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self, GFile* file);
static void library_monitor_real_notify_file_created (DirectoryMonitor* base, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
gboolean media_monitor_notify_file_created (MediaMonitor* self, GFile* file, GFileInfo* info);
char* media_monitor_to_string (MediaMonitor* self);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates);
static GType library_monitor_runtime_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self, BackgroundJob* j);
static void library_monitor_real_notify_file_moved (DirectoryMonitor* base, GFile* old_file, GFile* new_file, GFileInfo* new_info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
gboolean media_monitor_notify_file_moved (MediaMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void library_monitor_real_notify_file_altered (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_altered (MediaMonitor* self, GFile* file);
static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_attributes_altered (MediaMonitor* self, GFile* file);
static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
gboolean media_monitor_notify_file_alteration_completed (MediaMonitor* self, GFile* file, GFileInfo* info);
static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
gboolean media_monitor_notify_file_deleted (MediaMonitor* self, GFile* file);
GType tombstone_get_type (void) G_GNUC_CONST;
Tombstone* tombstone_source_collection_locate (TombstoneSourceCollection* self, GFile* file);
void tombstone_source_collection_resurrect (TombstoneSourceCollection* self, Tombstone* tombstone);
enum  {
	LIBRARY_MONITOR_FIND_MOVE_JOB_DUMMY_PROPERTY
};
static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job, gpointer self);
static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
void background_job_set_completion_priority (BackgroundJob* self, gint priority);
static void library_monitor_find_move_job_real_execute (BackgroundJob* base);
GFile* media_source_get_master_file (MediaSource* self);
char* md5_file (GFile* file, GError** error);
char* media_source_get_master_md5 (MediaSource* self);
static void library_monitor_find_move_job_finalize (BackgroundJob* obj);
enum  {
	LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_DUMMY_PROPERTY
};
static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job, gpointer self);
static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base);
static void library_monitor_runtime_find_move_job_finalize (BackgroundJob* obj);
enum  {
	LIBRARY_MONITOR_VERIFY_JOB_DUMMY_PROPERTY
};
static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob* obj);
static void library_monitor_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 38 "LibraryMonitor.vala"
static LibraryMonitorPool* library_monitor_pool_construct (GType object_type) {
#line 1059 "LibraryMonitor.c"
	LibraryMonitorPool* self = (LibraryMonitorPool*) g_type_create_instance (object_type);
	return self;
}


#line 38 "LibraryMonitor.vala"
static LibraryMonitorPool* library_monitor_pool_new (void) {
#line 38 "LibraryMonitor.vala"
	return library_monitor_pool_construct (TYPE_LIBRARY_MONITOR_POOL);
#line 1069 "LibraryMonitor.c"
}


#line 41 "LibraryMonitor.vala"
void library_monitor_pool_init (void) {
#line 1075 "LibraryMonitor.c"
}


#line 44 "LibraryMonitor.vala"
void library_monitor_pool_terminate (void) {
#line 1081 "LibraryMonitor.c"
	LibraryMonitorPool* _tmp0_;
#line 45 "LibraryMonitor.vala"
	if (library_monitor_pool_instance != NULL) {
#line 46 "LibraryMonitor.vala"
		library_monitor_pool_close (library_monitor_pool_instance);
#line 1087 "LibraryMonitor.c"
	}
#line 48 "LibraryMonitor.vala"
	library_monitor_pool_instance = (_tmp0_ = NULL, _library_monitor_pool_unref0 (library_monitor_pool_instance), _tmp0_);
#line 1091 "LibraryMonitor.c"
}


static gpointer _library_monitor_pool_ref0 (gpointer self) {
	return self ? library_monitor_pool_ref (self) : NULL;
}


#line 51 "LibraryMonitor.vala"
LibraryMonitorPool* library_monitor_pool_get_instance (void) {
#line 1102 "LibraryMonitor.c"
	LibraryMonitorPool* result = NULL;
#line 52 "LibraryMonitor.vala"
	if (library_monitor_pool_instance == NULL) {
#line 1106 "LibraryMonitor.c"
		LibraryMonitorPool* _tmp0_;
#line 53 "LibraryMonitor.vala"
		library_monitor_pool_instance = (_tmp0_ = library_monitor_pool_new (), _library_monitor_pool_unref0 (library_monitor_pool_instance), _tmp0_);
#line 1110 "LibraryMonitor.c"
	}
	result = _library_monitor_pool_ref0 (library_monitor_pool_instance);
#line 55 "LibraryMonitor.vala"
	return result;
#line 1115 "LibraryMonitor.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 58 "LibraryMonitor.vala"
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self) {
#line 1126 "LibraryMonitor.c"
	LibraryMonitor* result = NULL;
#line 58 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR_POOL (self), NULL);
#line 1130 "LibraryMonitor.c"
	result = _g_object_ref0 (self->priv->monitor);
#line 59 "LibraryMonitor.vala"
	return result;
#line 1134 "LibraryMonitor.c"
}


#line 84 "LibraryMonitor.vala"
static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self) {
#line 1140 "LibraryMonitor.c"
	gboolean result;
	result = library_monitor_pool_on_start_monitor (self);
	return result;
}


#line 63 "LibraryMonitor.vala"
void library_monitor_pool_replace (LibraryMonitorPool* self, LibraryMonitor* replacement, gint start_msec_delay) {
#line 1149 "LibraryMonitor.c"
	LibraryMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 63 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR_POOL (self));
#line 63 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (replacement));
#line 64 "LibraryMonitor.vala"
	library_monitor_pool_close (self);
#line 66 "LibraryMonitor.vala"
	self->priv->monitor = (_tmp0_ = _g_object_ref0 (replacement), _g_object_unref0 (self->priv->monitor), _tmp0_);
#line 67 "LibraryMonitor.vala"
	if (start_msec_delay > 0) {
#line 67 "LibraryMonitor.vala"
		_tmp1_ = self->priv->timer_id == 0;
#line 1164 "LibraryMonitor.c"
	} else {
#line 67 "LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 1168 "LibraryMonitor.c"
	}
#line 67 "LibraryMonitor.vala"
	if (_tmp1_) {
#line 68 "LibraryMonitor.vala"
		self->priv->timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) start_msec_delay, _library_monitor_pool_on_start_monitor_gsource_func, library_monitor_pool_ref (self), library_monitor_pool_unref);
#line 1174 "LibraryMonitor.c"
	}
#line 70 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "monitor-installed", self->priv->monitor);
#line 1178 "LibraryMonitor.c"
}


#line 73 "LibraryMonitor.vala"
static void library_monitor_pool_close (LibraryMonitorPool* self) {
#line 1184 "LibraryMonitor.c"
	LibraryMonitor* closed;
	LibraryMonitor* _tmp0_;
#line 73 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR_POOL (self));
#line 74 "LibraryMonitor.vala"
	if (self->priv->monitor == NULL) {
#line 75 "LibraryMonitor.vala"
		return;
#line 1193 "LibraryMonitor.c"
	}
#line 77 "LibraryMonitor.vala"
	directory_monitor_close (DIRECTORY_MONITOR (self->priv->monitor));
#line 78 "LibraryMonitor.vala"
	closed = _g_object_ref0 (self->priv->monitor);
#line 79 "LibraryMonitor.vala"
	self->priv->monitor = (_tmp0_ = NULL, _g_object_unref0 (self->priv->monitor), _tmp0_);
#line 81 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "monitor-destroyed", closed);
#line 1203 "LibraryMonitor.c"
	_g_object_unref0 (closed);
}


#line 84 "LibraryMonitor.vala"
static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self) {
#line 1210 "LibraryMonitor.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 84 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR_POOL (self), FALSE);
#line 86 "LibraryMonitor.vala"
	self->priv->timer_id = (guint) 0;
#line 88 "LibraryMonitor.vala"
	if (self->priv->monitor == NULL) {
#line 1219 "LibraryMonitor.c"
		result = FALSE;
#line 89 "LibraryMonitor.vala"
		return result;
#line 1223 "LibraryMonitor.c"
	}
	{
#line 92 "LibraryMonitor.vala"
		directory_monitor_start_discovery (DIRECTORY_MONITOR (self->priv->monitor), &_inner_error_);
#line 1228 "LibraryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch347_g_error;
		}
	}
	goto __finally347;
	__catch347_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GFile* _tmp0_;
			char* _tmp1_;
#line 94 "LibraryMonitor.vala"
			g_warning ("LibraryMonitor.vala:94: Unable to start discovery of %s: %s", _tmp1_ = g_file_get_path (_tmp0_ = directory_monitor_get_root (DIRECTORY_MONITOR (self->priv->monitor))), err->message);
#line 1244 "LibraryMonitor.c"
			_g_free0 (_tmp1_);
			_g_object_unref0 (_tmp0_);
			_g_error_free0 (err);
		}
	}
	__finally347:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
#line 98 "LibraryMonitor.vala"
	return result;
#line 1259 "LibraryMonitor.c"
}


static void value_library_monitor_pool_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_library_monitor_pool_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		library_monitor_pool_unref (value->data[0].v_pointer);
	}
}


static void value_library_monitor_pool_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = library_monitor_pool_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_library_monitor_pool_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_library_monitor_pool_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		LibraryMonitorPool* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = library_monitor_pool_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_library_monitor_pool_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	LibraryMonitorPool** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = library_monitor_pool_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecLibraryMonitorPool* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LIBRARY_MONITOR_POOL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_library_monitor_pool (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL), NULL);
	return value->data[0].v_pointer;
}


void value_set_library_monitor_pool (GValue* value, gpointer v_object) {
	LibraryMonitorPool* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		library_monitor_pool_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_pool_unref (old);
	}
}


void value_take_library_monitor_pool (GValue* value, gpointer v_object) {
	LibraryMonitorPool* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_pool_unref (old);
	}
}


static void library_monitor_pool_class_init (LibraryMonitorPoolClass * klass) {
	library_monitor_pool_parent_class = g_type_class_peek_parent (klass);
	LIBRARY_MONITOR_POOL_CLASS (klass)->finalize = library_monitor_pool_finalize;
	g_type_class_add_private (klass, sizeof (LibraryMonitorPoolPrivate));
	g_signal_new ("monitor_installed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
	g_signal_new ("monitor_destroyed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
}


static void library_monitor_pool_instance_init (LibraryMonitorPool * self) {
	self->priv = LIBRARY_MONITOR_POOL_GET_PRIVATE (self);
	self->priv->monitor = NULL;
	self->priv->timer_id = (guint) 0;
	self->ref_count = 1;
}


static void library_monitor_pool_finalize (LibraryMonitorPool* obj) {
	LibraryMonitorPool * self;
	self = LIBRARY_MONITOR_POOL (obj);
	_g_object_unref0 (self->priv->monitor);
}


GType library_monitor_pool_get_type (void) {
	static volatile gsize library_monitor_pool_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_pool_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_library_monitor_pool_init, value_library_monitor_pool_free_value, value_library_monitor_pool_copy_value, value_library_monitor_pool_peek_pointer, "p", value_library_monitor_pool_collect_value, "p", value_library_monitor_pool_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorPoolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_pool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorPool), 0, (GInstanceInitFunc) library_monitor_pool_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_pool_type_id;
		library_monitor_pool_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorPool", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&library_monitor_pool_type_id__volatile, library_monitor_pool_type_id);
	}
	return library_monitor_pool_type_id__volatile;
}


gpointer library_monitor_pool_ref (gpointer instance) {
	LibraryMonitorPool* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void library_monitor_pool_unref (gpointer instance) {
	LibraryMonitorPool* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		LIBRARY_MONITOR_POOL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 746 "LibraryMonitor.vala"
static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item, gpointer self) {
#line 1431 "LibraryMonitor.c"
	library_monitor_on_unblacklist_file (item);
}


#line 545 "LibraryMonitor.vala"
static void _library_monitor_on_config_bool_changed_config_bool_changed (Config* _sender, const char* path, gboolean value, gpointer self) {
#line 1438 "LibraryMonitor.c"
	library_monitor_on_config_bool_changed (self, path, value);
}


#line 575 "LibraryMonitor.vala"
static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self) {
#line 1445 "LibraryMonitor.c"
	gboolean result;
	result = library_monitor_on_flush_import_queue (self);
	return result;
}


#line 241 "LibraryMonitor.vala"
LibraryMonitor* library_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
#line 1454 "LibraryMonitor.c"
	LibraryMonitor * self = NULL;
	Config* _tmp0_;
	Config* _tmp1_;
#line 241 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 242 "LibraryMonitor.vala"
	self = (LibraryMonitor*) directory_monitor_construct (object_type, root, recurse, monitoring);
#line 245 "LibraryMonitor.vala"
	self->priv->auto_import = config_get_auto_import_from_library (_tmp0_ = config_get_instance ());
#line 1464 "LibraryMonitor.c"
	_config_unref0 (_tmp0_);
#line 246 "LibraryMonitor.vala"
	g_signal_connect_object (_tmp1_ = config_get_instance (), "bool-changed", (GCallback) _library_monitor_on_config_bool_changed_config_bool_changed, self, 0);
#line 1468 "LibraryMonitor.c"
	_config_unref0 (_tmp1_);
#line 248 "LibraryMonitor.vala"
	self->priv->import_queue_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC, _library_monitor_on_flush_import_queue_gsource_func, g_object_ref (self), g_object_unref);
#line 1472 "LibraryMonitor.c"
	return self;
}


#line 241 "LibraryMonitor.vala"
LibraryMonitor* library_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 241 "LibraryMonitor.vala"
	return library_monitor_construct (TYPE_LIBRARY_MONITOR, root, recurse, monitoring);
#line 1481 "LibraryMonitor.c"
}


#line 255 "LibraryMonitor.vala"
static void library_monitor_real_close (DirectoryMonitor* base) {
#line 1487 "LibraryMonitor.c"
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (base);
#line 256 "LibraryMonitor.vala"
	g_cancellable_cancel (self->priv->cancellable);
#line 1492 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 258 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 258 "LibraryMonitor.vala"
		while (TRUE) {
#line 1499 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 258 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 258 "LibraryMonitor.vala"
				break;
#line 1505 "LibraryMonitor.c"
			}
#line 258 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 259 "LibraryMonitor.vala"
			media_monitor_close (monitor);
#line 1511 "LibraryMonitor.c"
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 261 "LibraryMonitor.vala"
	if (self->priv->import_queue_timer_id != 0) {
#line 262 "LibraryMonitor.vala"
		g_source_remove (self->priv->import_queue_timer_id);
#line 263 "LibraryMonitor.vala"
		self->priv->import_queue_timer_id = (guint) 0;
#line 1522 "LibraryMonitor.c"
	}
#line 266 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->close (DIRECTORY_MONITOR (self));
#line 1526 "LibraryMonitor.c"
}


#line 269 "LibraryMonitor.vala"
static void library_monitor_add_to_discovered_list (LibraryMonitor* self, MediaMonitor* monitor, Monitorable* monitorable) {
#line 1532 "LibraryMonitor.c"
	GeeSet* _tmp1_;
#line 269 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 269 "LibraryMonitor.vala"
	g_return_if_fail (IS_MEDIA_MONITOR (monitor));
#line 269 "LibraryMonitor.vala"
	g_return_if_fail (IS_MONITORABLE (monitorable));
#line 270 "LibraryMonitor.vala"
	if (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->discovered), monitor)) {
#line 1542 "LibraryMonitor.c"
		GeeHashSet* _tmp0_;
#line 271 "LibraryMonitor.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->discovered), monitor, GEE_SET (_tmp0_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL)));
#line 1546 "LibraryMonitor.c"
		_g_object_unref0 (_tmp0_);
	}
#line 273 "LibraryMonitor.vala"
	gee_collection_add (GEE_COLLECTION (_tmp1_ = (GeeSet*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->discovered), monitor)), monitorable);
#line 1551 "LibraryMonitor.c"
	_g_object_unref0 (_tmp1_);
}


#line 276 "LibraryMonitor.vala"
static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self, Monitorable* monitorable) {
#line 1558 "LibraryMonitor.c"
	MediaMonitor* result = NULL;
	char* _tmp2_;
#line 276 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), NULL);
#line 276 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_MONITORABLE (monitorable), NULL);
#line 1565 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 277 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 277 "LibraryMonitor.vala"
		while (TRUE) {
#line 1572 "LibraryMonitor.c"
			MediaMonitor* monitor;
			MediaSourceCollection* _tmp0_;
			gboolean _tmp1_;
#line 277 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 277 "LibraryMonitor.vala"
				break;
#line 1580 "LibraryMonitor.c"
			}
#line 277 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 278 "LibraryMonitor.vala"
			if ((_tmp1_ = source_collection_holds_type_of_source (SOURCE_COLLECTION (_tmp0_ = media_monitor_get_media_source_collection (monitor)), DATA_SOURCE (monitorable)), _data_collection_unref0 (_tmp0_), _tmp1_)) {
#line 1586 "LibraryMonitor.c"
				result = monitor;
				_g_object_unref0 (_monitor_it);
#line 279 "LibraryMonitor.vala"
				return result;
#line 1591 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 282 "LibraryMonitor.vala"
	g_error ("LibraryMonitor.vala:282: Unable to locate MediaMonitor for %s", _tmp2_ = data_object_to_string (DATA_OBJECT (monitorable)));
#line 1599 "LibraryMonitor.c"
	_g_free0 (_tmp2_);
}


#line 285 "LibraryMonitor.vala"
static void library_monitor_real_discovery_started (DirectoryMonitor* base) {
#line 1606 "LibraryMonitor.c"
	LibraryMonitor * self;
	GeeHashMap* _tmp4_;
	GeeHashSet* _tmp5_;
	self = LIBRARY_MONITOR (base);
	{
		MediaCollectionRegistry* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _collection_it;
#line 286 "LibraryMonitor.vala"
		_collection_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = media_collection_registry_get_all (_tmp0_ = media_collection_registry_get_instance ()))), _g_object_unref0 (_tmp1_), _media_collection_registry_unref0 (_tmp0_), _tmp2_);
#line 286 "LibraryMonitor.vala"
		while (TRUE) {
#line 1620 "LibraryMonitor.c"
			MediaSourceCollection* collection;
			MediaMonitor* _tmp3_;
#line 286 "LibraryMonitor.vala"
			if (!gee_iterator_next (_collection_it)) {
#line 286 "LibraryMonitor.vala"
				break;
#line 1627 "LibraryMonitor.c"
			}
#line 286 "LibraryMonitor.vala"
			collection = (MediaSourceCollection*) gee_iterator_get (_collection_it);
#line 287 "LibraryMonitor.vala"
			gee_collection_add (GEE_COLLECTION (self->priv->monitors), _tmp3_ = media_source_collection_create_media_monitor (collection, self->priv->workers, self->priv->cancellable));
#line 1633 "LibraryMonitor.c"
			_g_object_unref0 (_tmp3_);
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
	{
		GeeIterator* _monitor_it;
#line 289 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 289 "LibraryMonitor.vala"
		while (TRUE) {
#line 1645 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 289 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 289 "LibraryMonitor.vala"
				break;
#line 1651 "LibraryMonitor.c"
			}
#line 289 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 290 "LibraryMonitor.vala"
			media_monitor_notify_discovery_started (monitor);
#line 1657 "LibraryMonitor.c"
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 292 "LibraryMonitor.vala"
	self->priv->discovered = (_tmp4_ = gee_hash_map_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->discovered), _tmp4_);
#line 293 "LibraryMonitor.vala"
	self->priv->unknown_files = (_tmp5_ = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal), _g_object_unref0 (self->priv->unknown_files), _tmp5_);
#line 295 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_started (DIRECTORY_MONITOR (self));
#line 1668 "LibraryMonitor.c"
}


#line 298 "LibraryMonitor.vala"
static void library_monitor_real_file_discovered (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
#line 1674 "LibraryMonitor.c"
	LibraryMonitor * self;
	Monitorable* representation;
	MediaMonitor* representing;
	gboolean ignore;
	self = LIBRARY_MONITOR (base);
#line 298 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 298 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 299 "LibraryMonitor.vala"
	representation = NULL;
#line 300 "LibraryMonitor.vala"
	representing = NULL;
#line 301 "LibraryMonitor.vala"
	ignore = FALSE;
#line 1690 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 302 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 302 "LibraryMonitor.vala"
		while (TRUE) {
#line 1697 "LibraryMonitor.c"
			MediaMonitor* monitor;
			Monitorable* _tmp0_ = NULL;
			MediaMonitorDiscoveredFile _tmp1_;
			Monitorable* _tmp2_;
			MediaMonitorDiscoveredFile _result_;
#line 302 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 302 "LibraryMonitor.vala"
				break;
#line 1707 "LibraryMonitor.c"
			}
#line 302 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 303 "LibraryMonitor.vala"
			_result_ = (_tmp1_ = media_monitor_notify_file_discovered (monitor, file, info, &_tmp0_), representation = (_tmp2_ = _tmp0_, _g_object_unref0 (representation), _tmp2_), _tmp1_);
#line 305 "LibraryMonitor.vala"
			if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 1715 "LibraryMonitor.c"
				MediaMonitor* _tmp3_;
#line 306 "LibraryMonitor.vala"
				representing = (_tmp3_ = _g_object_ref0 (monitor), _g_object_unref0 (representing), _tmp3_);
#line 1719 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 308 "LibraryMonitor.vala"
				break;
#line 1723 "LibraryMonitor.c"
			} else {
#line 309 "LibraryMonitor.vala"
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE) {
#line 311 "LibraryMonitor.vala"
					ignore = TRUE;
#line 1729 "LibraryMonitor.c"
					_g_object_unref0 (monitor);
#line 313 "LibraryMonitor.vala"
					break;
#line 1733 "LibraryMonitor.c"
				}
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 317 "LibraryMonitor.vala"
	if (representing != NULL) {
#line 318 "LibraryMonitor.vala"
		g_assert ((representation != NULL) && (!ignore));
#line 319 "LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, representing, representation);
#line 1746 "LibraryMonitor.c"
	} else {
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 320 "LibraryMonitor.vala"
		if (!ignore) {
#line 320 "LibraryMonitor.vala"
			_tmp5_ = !tombstone_source_collection_matches (tombstone_global, file);
#line 1754 "LibraryMonitor.c"
		} else {
#line 320 "LibraryMonitor.vala"
			_tmp5_ = FALSE;
#line 1758 "LibraryMonitor.c"
		}
#line 320 "LibraryMonitor.vala"
		if (_tmp5_) {
#line 320 "LibraryMonitor.vala"
			_tmp4_ = library_monitor_is_supported_filetype (self, file);
#line 1764 "LibraryMonitor.c"
		} else {
#line 320 "LibraryMonitor.vala"
			_tmp4_ = FALSE;
#line 1768 "LibraryMonitor.c"
		}
#line 320 "LibraryMonitor.vala"
		if (_tmp4_) {
#line 321 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->unknown_files), file);
#line 1774 "LibraryMonitor.c"
		}
	}
#line 324 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->file_discovered (DIRECTORY_MONITOR (self), file, info);
#line 1779 "LibraryMonitor.c"
	_g_object_unref0 (representing);
	_g_object_unref0 (representation);
}


#line 327 "LibraryMonitor.vala"
static void library_monitor_real_discovery_completed (DirectoryMonitor* base) {
#line 1787 "LibraryMonitor.c"
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (base);
#line 328 "LibraryMonitor.vala"
	library_monitor_async_discovery_completed (self, NULL, NULL);
#line 1792 "LibraryMonitor.c"
}


static void library_monitor_async_discovery_completed_data_free (gpointer _data) {
	LibraryMonitorAsyncDiscoveryCompletedData* data;
	data = _data;
	g_object_unref (data->self);
	g_slice_free (LibraryMonitorAsyncDiscoveryCompletedData, data);
}


static void library_monitor_async_discovery_completed (LibraryMonitor* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = g_slice_new0 (LibraryMonitorAsyncDiscoveryCompletedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, library_monitor_async_discovery_completed);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, library_monitor_async_discovery_completed_data_free);
	_data_->self = g_object_ref (self);
	library_monitor_async_discovery_completed_co (_data_);
}


static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self, GAsyncResult* _res_) {
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void library_monitor_async_discovery_completed_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	LibraryMonitorAsyncDiscoveryCompletedData* data;
	data = _user_data_;
	data->_res_ = _res_;
	library_monitor_async_discovery_completed_co (data);
}


#line 331 "LibraryMonitor.vala"
static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self) {
#line 1830 "LibraryMonitor.c"
	gboolean result;
	result = library_monitor_async_discovery_completed_co (self);
	return result;
}


static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 12:
		goto _state_12;
	}
	_state_0:
#line 336 "LibraryMonitor.vala"
	if (gee_collection_get_size (GEE_COLLECTION (data->self->priv->unknown_files)) == 0) {
#line 337 "LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (data->self);
#line 1851 "LibraryMonitor.c"
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	data->all_candidates = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	data->adopted = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	{
		data->_file_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (data->self->priv->unknown_files));
#line 344 "LibraryMonitor.vala"
		while (TRUE) {
#line 344 "LibraryMonitor.vala"
			if (!gee_iterator_next (data->_file_it)) {
#line 344 "LibraryMonitor.vala"
				break;
#line 1872 "LibraryMonitor.c"
			}
			data->file = (GFile*) gee_iterator_get (data->_file_it);
			data->info = directory_monitor_get_file_info (DIRECTORY_MONITOR (data->self), data->file);
#line 346 "LibraryMonitor.vala"
			if (data->info == NULL) {
#line 1878 "LibraryMonitor.c"
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
#line 347 "LibraryMonitor.vala"
				continue;
#line 1883 "LibraryMonitor.c"
			}
#line 350 "LibraryMonitor.vala"
			gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (data->all_candidates));
#line 1887 "LibraryMonitor.c"
			data->candidates = NULL;
			data->associated = FALSE;
			{
				data->_monitor_it = gee_iterable_iterator (GEE_ITERABLE (data->self->priv->monitors));
#line 354 "LibraryMonitor.vala"
				while (TRUE) {
#line 354 "LibraryMonitor.vala"
					if (!gee_iterator_next (data->_monitor_it)) {
#line 354 "LibraryMonitor.vala"
						break;
#line 1898 "LibraryMonitor.c"
					}
					data->monitor = (MediaMonitor*) gee_iterator_get (data->_monitor_it);
#line 356 "LibraryMonitor.vala"
					data->candidates = (data->_tmp0_ = media_monitor_candidates_for_unknown_file (data->monitor, data->file, data->info, &data->_result_), _g_object_unref0 (data->candidates), data->_tmp0_);
#line 357 "LibraryMonitor.vala"
					if (data->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 357 "LibraryMonitor.vala"
						data->_tmp1_ = TRUE;
#line 1907 "LibraryMonitor.c"
					} else {
#line 358 "LibraryMonitor.vala"
						data->_tmp1_ = data->_result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 1911 "LibraryMonitor.c"
					}
#line 357 "LibraryMonitor.vala"
					if (data->_tmp1_) {
#line 359 "LibraryMonitor.vala"
						data->associated = TRUE;
#line 1917 "LibraryMonitor.c"
						_g_object_unref0 (data->monitor);
#line 361 "LibraryMonitor.vala"
						break;
#line 1921 "LibraryMonitor.c"
					} else {
#line 362 "LibraryMonitor.vala"
						if (data->candidates != NULL) {
#line 363 "LibraryMonitor.vala"
							gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (data->all_candidates), data->candidates);
#line 1927 "LibraryMonitor.c"
						}
					}
					_g_object_unref0 (data->monitor);
				}
				_g_object_unref0 (data->_monitor_it);
			}
#line 367 "LibraryMonitor.vala"
			if (data->associated) {
#line 368 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (data->adopted), data->file);
#line 1938 "LibraryMonitor.c"
				_g_object_unref0 (data->candidates);
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
#line 370 "LibraryMonitor.vala"
				continue;
#line 1944 "LibraryMonitor.c"
			}
#line 374 "LibraryMonitor.vala"
			if (gee_collection_get_size (GEE_COLLECTION (data->all_candidates)) > 0) {
#line 1948 "LibraryMonitor.c"
				data->job_candidates = _g_object_ref0 (data->all_candidates);
#line 377 "LibraryMonitor.vala"
				data->all_candidates = (data->_tmp2_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (data->all_candidates), data->_tmp2_);
#line 379 "LibraryMonitor.vala"
				data->self->priv->checksums_total++;
#line 380 "LibraryMonitor.vala"
				workers_enqueue (data->self->priv->workers, BACKGROUND_JOB (data->_tmp3_ = library_monitor_find_move_job_new (data->self, data->file, GEE_COLLECTION (data->job_candidates))));
#line 1956 "LibraryMonitor.c"
				_background_job_unref0 (data->_tmp3_);
				_g_object_unref0 (data->job_candidates);
			}
#line 383 "LibraryMonitor.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _library_monitor_async_discovery_completed_co_gsource_func, data, NULL);
#line 1962 "LibraryMonitor.c"
			data->_state_ = 12;
			return FALSE;
			_state_12:
			;
			_g_object_unref0 (data->candidates);
			_g_object_unref0 (data->info);
			_g_object_unref0 (data->file);
		}
		_g_object_unref0 (data->_file_it);
	}
#line 388 "LibraryMonitor.vala"
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (data->self->priv->unknown_files), GEE_COLLECTION (data->adopted));
#line 390 "LibraryMonitor.vala"
	data->self->priv->checksums_completed = 0;
#line 392 "LibraryMonitor.vala"
	if (data->self->priv->checksums_total == 0) {
#line 393 "LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (data->self);
#line 1981 "LibraryMonitor.c"
	} else {
#line 395 "LibraryMonitor.vala"
		directory_monitor_mdbg (data->_tmp4_ = g_strdup_printf ("%d checksum jobs initiated to verify unknown photo files", data->self->priv->checksums_total));
#line 1985 "LibraryMonitor.c"
		_g_free0 (data->_tmp4_);
#line 396 "LibraryMonitor.vala"
		g_signal_emit_by_name (data->self, "auto-update-progress", data->self->priv->checksums_completed, data->self->priv->checksums_total);
#line 1989 "LibraryMonitor.c"
	}
	_g_object_unref0 (data->adopted);
	_g_object_unref0 (data->all_candidates);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 400 "LibraryMonitor.vala"
static void library_monitor_report_checksum_job_completed (LibraryMonitor* self) {
#line 400 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 401 "LibraryMonitor.vala"
	g_assert (self->priv->checksums_completed < self->priv->checksums_total);
#line 402 "LibraryMonitor.vala"
	self->priv->checksums_completed++;
#line 404 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "auto-update-progress", self->priv->checksums_completed, self->priv->checksums_total);
#line 406 "LibraryMonitor.vala"
	if (self->priv->checksums_completed == self->priv->checksums_total) {
#line 407 "LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (self);
#line 2019 "LibraryMonitor.c"
	}
}


static gpointer _background_job_ref0 (gpointer self) {
	return self ? background_job_ref (self) : NULL;
}


#line 410 "LibraryMonitor.vala"
static void library_monitor_on_find_move_completed (LibraryMonitor* self, BackgroundJob* j) {
#line 2031 "LibraryMonitor.c"
	LibraryMonitorFindMoveJob* job;
#line 410 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 410 "LibraryMonitor.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 411 "LibraryMonitor.vala"
	job = _background_job_ref0 (LIBRARY_MONITOR_FIND_MOVE_JOB (j));
#line 416 "LibraryMonitor.vala"
	if (job->match != NULL) {
#line 2041 "LibraryMonitor.c"
		char* _tmp0_;
		char* _tmp1_;
		char* _tmp2_;
		MediaMonitor* monitor;
#line 417 "LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp2_ = g_strdup_printf ("Found moved master file: %s matches %s", _tmp0_ = g_file_get_path (job->file), _tmp1_ = data_object_to_string (DATA_OBJECT (job->match))));
#line 2048 "LibraryMonitor.c"
		_g_free0 (_tmp2_);
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
#line 420 "LibraryMonitor.vala"
		monitor = library_monitor_get_monitor_for_monitorable (self, job->match);
#line 421 "LibraryMonitor.vala"
		media_monitor_update_master_file (monitor, job->match, job->file);
#line 422 "LibraryMonitor.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->unknown_files), job->file);
#line 423 "LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, monitor, job->match);
#line 2060 "LibraryMonitor.c"
		_g_object_unref0 (monitor);
	}
#line 426 "LibraryMonitor.vala"
	if (job->err != NULL) {
#line 2065 "LibraryMonitor.c"
		char* _tmp3_;
#line 427 "LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:427: Unable to checksum unknown media file %s: %s", _tmp3_ = g_file_get_path (job->file), job->err->message);
#line 2069 "LibraryMonitor.c"
		_g_free0 (_tmp3_);
	}
#line 429 "LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 2074 "LibraryMonitor.c"
	_background_job_unref0 (job);
}


#line 432 "LibraryMonitor.vala"
static void library_monitor_on_find_move_cancelled (LibraryMonitor* self, BackgroundJob* j) {
#line 432 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 432 "LibraryMonitor.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 433 "LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 2087 "LibraryMonitor.c"
}


#line 436 "LibraryMonitor.vala"
static void library_monitor_discovery_stage_completed (LibraryMonitor* self) {
#line 2093 "LibraryMonitor.c"
	GeeHashMap* _tmp9_;
	GeeHashSet* _tmp10_;
#line 436 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 2098 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 437 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 437 "LibraryMonitor.vala"
		while (TRUE) {
#line 2105 "LibraryMonitor.c"
			MediaMonitor* monitor;
			GeeSet* monitorables;
#line 437 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 437 "LibraryMonitor.vala"
				break;
#line 2112 "LibraryMonitor.c"
			}
#line 437 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 438 "LibraryMonitor.vala"
			monitorables = (GeeSet*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->discovered), monitor);
#line 439 "LibraryMonitor.vala"
			if (monitorables != NULL) {
#line 2120 "LibraryMonitor.c"
				{
					GeeIterator* _monitorable_it;
#line 440 "LibraryMonitor.vala"
					_monitorable_it = gee_iterable_iterator (GEE_ITERABLE (monitorables));
#line 440 "LibraryMonitor.vala"
					while (TRUE) {
#line 2127 "LibraryMonitor.c"
						Monitorable* monitorable;
#line 440 "LibraryMonitor.vala"
						if (!gee_iterator_next (_monitorable_it)) {
#line 440 "LibraryMonitor.vala"
							break;
#line 2133 "LibraryMonitor.c"
						}
#line 440 "LibraryMonitor.vala"
						monitorable = (Monitorable*) gee_iterator_get (_monitorable_it);
#line 441 "LibraryMonitor.vala"
						library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
#line 2139 "LibraryMonitor.c"
						_g_object_unref0 (monitorable);
					}
					_g_object_unref0 (_monitorable_it);
				}
			}
			{
				MediaSourceCollection* _tmp0_;
				GeeCollection* _tmp1_;
				GeeIterator* _tmp2_;
				GeeIterator* _object_it;
#line 444 "LibraryMonitor.vala"
				_object_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = data_collection_get_all (DATA_COLLECTION (_tmp0_ = media_monitor_get_media_source_collection (monitor))))), _g_object_unref0 (_tmp1_), _data_collection_unref0 (_tmp0_), _tmp2_);
#line 444 "LibraryMonitor.vala"
				while (TRUE) {
#line 2154 "LibraryMonitor.c"
					DataObject* object;
					Monitorable* monitorable;
					gboolean _tmp3_ = FALSE;
#line 444 "LibraryMonitor.vala"
					if (!gee_iterator_next (_object_it)) {
#line 444 "LibraryMonitor.vala"
						break;
#line 2162 "LibraryMonitor.c"
					}
#line 444 "LibraryMonitor.vala"
					object = (DataObject*) gee_iterator_get (_object_it);
#line 445 "LibraryMonitor.vala"
					monitorable = _g_object_ref0 (MONITORABLE (object));
#line 447 "LibraryMonitor.vala"
					if (monitorables != NULL) {
#line 447 "LibraryMonitor.vala"
						_tmp3_ = gee_collection_contains (GEE_COLLECTION (monitorables), monitorable);
#line 2172 "LibraryMonitor.c"
					} else {
#line 447 "LibraryMonitor.vala"
						_tmp3_ = FALSE;
#line 2176 "LibraryMonitor.c"
					}
#line 447 "LibraryMonitor.vala"
					if (_tmp3_) {
#line 2180 "LibraryMonitor.c"
						_g_object_unref0 (monitorable);
						_g_object_unref0 (object);
#line 448 "LibraryMonitor.vala"
						continue;
#line 2185 "LibraryMonitor.c"
					}
#line 450 "LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
#line 2189 "LibraryMonitor.c"
					_g_object_unref0 (monitorable);
					_g_object_unref0 (object);
				}
				_g_object_unref0 (_object_it);
			}
			{
				MediaSourceCollection* _tmp4_;
				MediaSourceHoldingTank* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _source_it;
#line 453 "LibraryMonitor.vala"
				_source_it = (_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (_tmp6_ = source_holding_tank_get_all (SOURCE_HOLDING_TANK (_tmp5_ = media_source_collection_get_offline_bin (_tmp4_ = media_monitor_get_media_source_collection (monitor)))))), _g_object_unref0 (_tmp6_), _source_holding_tank_unref0 (_tmp5_), _data_collection_unref0 (_tmp4_), _tmp7_);
#line 453 "LibraryMonitor.vala"
				while (TRUE) {
#line 2205 "LibraryMonitor.c"
					DataSource* source;
					Monitorable* monitorable;
					gboolean _tmp8_ = FALSE;
#line 453 "LibraryMonitor.vala"
					if (!gee_iterator_next (_source_it)) {
#line 453 "LibraryMonitor.vala"
						break;
#line 2213 "LibraryMonitor.c"
					}
#line 453 "LibraryMonitor.vala"
					source = (DataSource*) gee_iterator_get (_source_it);
#line 455 "LibraryMonitor.vala"
					monitorable = _g_object_ref0 (MONITORABLE (source));
#line 457 "LibraryMonitor.vala"
					if (monitorables != NULL) {
#line 457 "LibraryMonitor.vala"
						_tmp8_ = gee_collection_contains (GEE_COLLECTION (monitorables), monitorable);
#line 2223 "LibraryMonitor.c"
					} else {
#line 457 "LibraryMonitor.vala"
						_tmp8_ = FALSE;
#line 2227 "LibraryMonitor.c"
					}
#line 457 "LibraryMonitor.vala"
					if (_tmp8_) {
#line 2231 "LibraryMonitor.c"
						_g_object_unref0 (monitorable);
						_g_object_unref0 (source);
#line 458 "LibraryMonitor.vala"
						continue;
#line 2236 "LibraryMonitor.c"
					}
#line 460 "LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, monitorable, monitor);
#line 2240 "LibraryMonitor.c"
					_g_object_unref0 (monitorable);
					_g_object_unref0 (source);
				}
				_g_object_unref0 (_source_it);
			}
			_g_object_unref0 (monitorables);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 465 "LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 466 "LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, GEE_COLLECTION (self->priv->unknown_files));
#line 2255 "LibraryMonitor.c"
	}
#line 469 "LibraryMonitor.vala"
	self->priv->discovered = (_tmp9_ = NULL, _g_object_unref0 (self->priv->discovered), _tmp9_);
#line 470 "LibraryMonitor.vala"
	self->priv->unknown_files = (_tmp10_ = NULL, _g_object_unref0 (self->priv->unknown_files), _tmp10_);
#line 474 "LibraryMonitor.vala"
	tombstone_source_collection_launch_scan (tombstone_global, DIRECTORY_MONITOR (self), self->priv->cancellable);
#line 477 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_completed (DIRECTORY_MONITOR (self));
#line 2265 "LibraryMonitor.c"
}


#line 480 "LibraryMonitor.vala"
static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor) {
#line 2271 "LibraryMonitor.c"
	LibraryMonitorVerifyJob* _tmp0_;
	gboolean _tmp1_;
	gboolean offered;
#line 480 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 480 "LibraryMonitor.vala"
	g_return_if_fail (IS_MONITORABLE (monitorable));
#line 480 "LibraryMonitor.vala"
	g_return_if_fail (IS_MEDIA_MONITOR (monitor));
#line 481 "LibraryMonitor.vala"
	offered = (_tmp1_ = gee_queue_offer (self->priv->verify_queue, _tmp0_ = library_monitor_verify_job_new (monitorable, monitor)), _library_monitor_verify_job_unref0 (_tmp0_), _tmp1_);
#line 482 "LibraryMonitor.vala"
	g_assert (offered);
#line 484 "LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (self);
#line 2287 "LibraryMonitor.c"
}


#line 487 "LibraryMonitor.vala"
static void library_monitor_execute_next_verify_job (LibraryMonitor* self) {
#line 2293 "LibraryMonitor.c"
	gboolean _tmp0_ = FALSE;
	LibraryMonitorVerifyJob* job;
#line 487 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 488 "LibraryMonitor.vala"
	if (self->priv->outstanding_verify_jobs >= LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS) {
#line 488 "LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 2302 "LibraryMonitor.c"
	} else {
#line 488 "LibraryMonitor.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->verify_queue)) == 0;
#line 2306 "LibraryMonitor.c"
	}
#line 488 "LibraryMonitor.vala"
	if (_tmp0_) {
#line 489 "LibraryMonitor.vala"
		return;
#line 2312 "LibraryMonitor.c"
	}
#line 491 "LibraryMonitor.vala"
	job = (LibraryMonitorVerifyJob*) gee_queue_poll (self->priv->verify_queue);
#line 492 "LibraryMonitor.vala"
	g_assert (job != NULL);
#line 494 "LibraryMonitor.vala"
	self->priv->outstanding_verify_jobs++;
#line 495 "LibraryMonitor.vala"
	library_monitor_verify_monitorable (self, job->monitorable, job->monitor, NULL, NULL);
#line 2322 "LibraryMonitor.c"
	_library_monitor_verify_job_unref0 (job);
}


static void library_monitor_verify_monitorable_data_free (gpointer _data) {
	LibraryMonitorVerifyMonitorableData* data;
	data = _data;
	_g_object_unref0 (data->monitorable);
	_g_object_unref0 (data->monitor);
	g_object_unref (data->self);
	g_slice_free (LibraryMonitorVerifyMonitorableData, data);
}


static void library_monitor_verify_monitorable (LibraryMonitor* self, Monitorable* monitorable, MediaMonitor* monitor, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = g_slice_new0 (LibraryMonitorVerifyMonitorableData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, library_monitor_verify_monitorable);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, library_monitor_verify_monitorable_data_free);
	_data_->self = g_object_ref (self);
	_data_->monitorable = _g_object_ref0 (monitorable);
	_data_->monitor = _g_object_ref0 (monitor);
	library_monitor_verify_monitorable_co (_data_);
}


static void library_monitor_verify_monitorable_finish (LibraryMonitor* self, GAsyncResult* _res_) {
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void library_monitor_verify_monitorable_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	LibraryMonitorVerifyMonitorableData* data;
	data = _user_data_;
	data->_res_ = _res_;
	library_monitor_verify_monitorable_co (data);
}


static void _vala_array_add261 (GFile*** array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 498 "LibraryMonitor.vala"
static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self) {
#line 2375 "LibraryMonitor.c"
	gboolean result;
	result = library_monitor_verify_monitorable_co (self);
	return result;
}


static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 13:
		goto _state_13;
		case 14:
		goto _state_14;
	}
	_state_0:
	data->files = (data->_tmp0_ = g_new0 (GFile*, 1 + 1), data->files_length1 = 1, data->_files_size_ = data->files_length1, data->_tmp0_);
#line 500 "LibraryMonitor.vala"
	data->files[0] = (data->_tmp1_ = media_monitor_get_master_file (data->monitor, data->monitorable), _g_object_unref0 (data->files[0]), data->_tmp1_);
#line 2397 "LibraryMonitor.c"
	data->aux_files = (data->_tmp3_ = media_monitor_get_auxilliary_backing_files (data->monitor, data->monitorable, &data->_tmp2_), data->aux_files_length1 = data->_tmp2_, data->_aux_files_size_ = data->aux_files_length1, data->_tmp3_);
#line 503 "LibraryMonitor.vala"
	if (data->aux_files != NULL) {
#line 2401 "LibraryMonitor.c"
		{
			data->aux_file_collection = data->aux_files;
			data->aux_file_collection_length1 = data->aux_files_length1;
			for (data->aux_file_it = 0; data->aux_file_it < data->aux_files_length1; data->aux_file_it = data->aux_file_it + 1) {
				data->aux_file = _g_object_ref0 (data->aux_file_collection[data->aux_file_it]);
				{
#line 505 "LibraryMonitor.vala"
					_vala_array_add261 (&data->files, &data->files_length1, &data->_files_size_, _g_object_ref0 (data->aux_file));
#line 2410 "LibraryMonitor.c"
					_g_object_unref0 (data->aux_file);
				}
			}
		}
	}
	{
		data->ctr = 0;
		{
			data->_tmp4_ = TRUE;
#line 508 "LibraryMonitor.vala"
			while (TRUE) {
#line 508 "LibraryMonitor.vala"
				if (!data->_tmp4_) {
#line 508 "LibraryMonitor.vala"
					data->ctr++;
#line 2426 "LibraryMonitor.c"
				}
#line 508 "LibraryMonitor.vala"
				data->_tmp4_ = FALSE;
#line 508 "LibraryMonitor.vala"
				if (!(data->ctr < data->files_length1)) {
#line 508 "LibraryMonitor.vala"
					break;
#line 2434 "LibraryMonitor.c"
				}
				data->file = _g_object_ref0 (data->files[data->ctr]);
				data->info = directory_monitor_get_file_info (DIRECTORY_MONITOR (data->self), data->file);
#line 512 "LibraryMonitor.vala"
				if (data->info == NULL) {
#line 2440 "LibraryMonitor.c"
					{
						data->_state_ = 13;
						g_file_query_info_async (data->file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_FILE_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, library_monitor_verify_monitorable_ready, data);
						return FALSE;
						_state_13:
						data->_tmp5_ = g_file_query_info_finish (data->file, data->_res_, &data->_inner_error_);
						if (data->_inner_error_ != NULL) {
							goto __catch348_g_error;
						}
#line 514 "LibraryMonitor.vala"
						data->info = (data->_tmp6_ = data->_tmp5_, _g_object_unref0 (data->info), data->_tmp6_);
#line 2452 "LibraryMonitor.c"
					}
					goto __finally348;
					__catch348_g_error:
					{
						data->err = data->_inner_error_;
						data->_inner_error_ = NULL;
						{
							_g_error_free0 (data->err);
						}
					}
					__finally348:
					if (data->_inner_error_ != NULL) {
						_g_object_unref0 (data->info);
						_g_object_unref0 (data->file);
						data->aux_files = (_vala_array_free (data->aux_files, data->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
						data->files = (_vala_array_free (data->files, data->files_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
						g_clear_error (&data->_inner_error_);
						return FALSE;
					}
				}
#line 522 "LibraryMonitor.vala"
				if (data->ctr == 0) {
#line 523 "LibraryMonitor.vala"
					if (data->info != NULL) {
#line 523 "LibraryMonitor.vala"
						data->_tmp7_ = media_monitor_is_offline (data->monitor, data->monitorable);
#line 2480 "LibraryMonitor.c"
					} else {
#line 523 "LibraryMonitor.vala"
						data->_tmp7_ = FALSE;
#line 2484 "LibraryMonitor.c"
					}
#line 523 "LibraryMonitor.vala"
					if (data->_tmp7_) {
#line 524 "LibraryMonitor.vala"
						media_monitor_update_online (data->monitor, data->monitorable);
#line 2490 "LibraryMonitor.c"
					} else {
#line 525 "LibraryMonitor.vala"
						if (data->info == NULL) {
#line 525 "LibraryMonitor.vala"
							data->_tmp8_ = !media_monitor_is_offline (data->monitor, data->monitorable);
#line 2496 "LibraryMonitor.c"
						} else {
#line 525 "LibraryMonitor.vala"
							data->_tmp8_ = FALSE;
#line 2500 "LibraryMonitor.c"
						}
#line 525 "LibraryMonitor.vala"
						if (data->_tmp8_) {
#line 526 "LibraryMonitor.vala"
							media_monitor_update_offline (data->monitor, data->monitorable);
#line 2506 "LibraryMonitor.c"
						}
					}
				}
#line 529 "LibraryMonitor.vala"
				media_monitor_update_backing_file_info (data->monitor, data->monitorable, data->file, data->info);
#line 2512 "LibraryMonitor.c"
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->file);
			}
		}
	}
#line 532 "LibraryMonitor.vala"
	data->self->priv->completed_monitorable_verifies++;
#line 533 "LibraryMonitor.vala"
	g_signal_emit_by_name (data->self, "auto-update-progress", data->self->priv->completed_monitorable_verifies, data->self->priv->total_monitorable_verifies);
#line 535 "LibraryMonitor.vala"
	g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _library_monitor_verify_monitorable_co_gsource_func, data, NULL);
#line 2524 "LibraryMonitor.c"
	data->_state_ = 14;
	return FALSE;
	_state_14:
	;
#line 539 "LibraryMonitor.vala"
	g_assert (data->self->priv->outstanding_verify_jobs > 0);
#line 540 "LibraryMonitor.vala"
	data->self->priv->outstanding_verify_jobs--;
#line 542 "LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (data->self);
#line 2535 "LibraryMonitor.c"
	data->aux_files = (_vala_array_free (data->aux_files, data->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
	data->files = (_vala_array_free (data->files, data->files_length1, (GDestroyNotify) g_object_unref), NULL);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


#line 545 "LibraryMonitor.vala"
static void library_monitor_on_config_bool_changed (LibraryMonitor* self, const char* path, gboolean value) {
#line 545 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 545 "LibraryMonitor.vala"
	g_return_if_fail (path != NULL);
#line 546 "LibraryMonitor.vala"
	if (_vala_strcmp0 (path, CONFIG_BOOL_AUTO_IMPORT_FROM_LIBRARY) != 0) {
#line 547 "LibraryMonitor.vala"
		return;
#line 2560 "LibraryMonitor.c"
	}
#line 549 "LibraryMonitor.vala"
	if (self->priv->auto_import == value) {
#line 550 "LibraryMonitor.vala"
		return;
#line 2566 "LibraryMonitor.c"
	}
#line 552 "LibraryMonitor.vala"
	self->priv->auto_import = value;
#line 553 "LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 554 "LibraryMonitor.vala"
		if (!commandline_options_no_runtime_monitoring) {
#line 555 "LibraryMonitor.vala"
			library_monitor_import_unrepresented_files (self);
#line 2576 "LibraryMonitor.c"
		}
	} else {
#line 557 "LibraryMonitor.vala"
		library_monitor_cancel_batch_imports (self);
#line 2581 "LibraryMonitor.c"
	}
}


#line 561 "LibraryMonitor.vala"
static void library_monitor_enqueue_import (LibraryMonitor* self, GFile* file) {
#line 2588 "LibraryMonitor.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 561 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 561 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 562 "LibraryMonitor.vala"
	if (!gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file)) {
#line 562 "LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 2599 "LibraryMonitor.c"
	} else {
#line 562 "LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 2603 "LibraryMonitor.c"
	}
#line 562 "LibraryMonitor.vala"
	if (_tmp1_) {
#line 562 "LibraryMonitor.vala"
		_tmp0_ = !library_monitor_is_blacklisted (file);
#line 2609 "LibraryMonitor.c"
	} else {
#line 562 "LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 2613 "LibraryMonitor.c"
	}
#line 562 "LibraryMonitor.vala"
	if (_tmp0_) {
#line 563 "LibraryMonitor.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->import_queue), file);
#line 2619 "LibraryMonitor.c"
	}
}


#line 566 "LibraryMonitor.vala"
static void library_monitor_enqueue_import_many (LibraryMonitor* self, GeeCollection* files) {
#line 566 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 566 "LibraryMonitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (files));
#line 2630 "LibraryMonitor.c"
	{
		GeeIterator* _file_it;
#line 567 "LibraryMonitor.vala"
		_file_it = gee_iterable_iterator (GEE_ITERABLE (files));
#line 567 "LibraryMonitor.vala"
		while (TRUE) {
#line 2637 "LibraryMonitor.c"
			GFile* file;
#line 567 "LibraryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 567 "LibraryMonitor.vala"
				break;
#line 2643 "LibraryMonitor.c"
			}
#line 567 "LibraryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 568 "LibraryMonitor.vala"
			library_monitor_enqueue_import (self, file);
#line 2649 "LibraryMonitor.c"
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


#line 571 "LibraryMonitor.vala"
static void library_monitor_remove_queued_import (LibraryMonitor* self, GFile* file) {
#line 571 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 571 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 572 "LibraryMonitor.vala"
	gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->import_queue), file);
#line 2665 "LibraryMonitor.c"
}


#line 575 "LibraryMonitor.vala"
static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self) {
#line 2671 "LibraryMonitor.c"
	gboolean result = FALSE;
	char* _tmp0_;
	time_t now;
	gboolean _tmp1_ = FALSE;
	GeeArrayList* jobs;
	BatchImport* importer;
#line 575 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), FALSE);
#line 576 "LibraryMonitor.vala"
	if (g_cancellable_is_cancelled (self->priv->cancellable)) {
#line 2682 "LibraryMonitor.c"
		result = FALSE;
#line 577 "LibraryMonitor.vala"
		return result;
#line 2686 "LibraryMonitor.c"
	}
#line 579 "LibraryMonitor.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->import_queue)) == 0) {
#line 2690 "LibraryMonitor.c"
		result = TRUE;
#line 580 "LibraryMonitor.vala"
		return result;
#line 2694 "LibraryMonitor.c"
	}
#line 584 "LibraryMonitor.vala"
	if (self->priv->current_batch_import != NULL) {
#line 2698 "LibraryMonitor.c"
		result = TRUE;
#line 585 "LibraryMonitor.vala"
		return result;
#line 2702 "LibraryMonitor.c"
	}
#line 587 "LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp0_ = g_strdup_printf ("Auto-importing %d files", gee_collection_get_size (GEE_COLLECTION (self->priv->import_queue))));
#line 2706 "LibraryMonitor.c"
	_g_free0 (_tmp0_);
#line 592 "LibraryMonitor.vala"
	now = (time_t) now_sec ();
#line 593 "LibraryMonitor.vala"
	if (self->priv->current_import_roll == NULL) {
#line 593 "LibraryMonitor.vala"
		_tmp1_ = TRUE;
#line 2714 "LibraryMonitor.c"
	} else {
#line 593 "LibraryMonitor.vala"
		_tmp1_ = (now - self->priv->last_import_roll_use) >= LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC;
#line 2718 "LibraryMonitor.c"
	}
#line 593 "LibraryMonitor.vala"
	if (_tmp1_) {
#line 2722 "LibraryMonitor.c"
		BatchImportRoll* _tmp2_;
#line 594 "LibraryMonitor.vala"
		self->priv->current_import_roll = (_tmp2_ = batch_import_roll_new (), _batch_import_roll_unref0 (self->priv->current_import_roll), _tmp2_);
#line 2726 "LibraryMonitor.c"
	}
#line 595 "LibraryMonitor.vala"
	self->priv->last_import_roll_use = now;
#line 597 "LibraryMonitor.vala"
	jobs = gee_array_list_new (TYPE_BATCH_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, batch_import_job_unref, NULL);
#line 2732 "LibraryMonitor.c"
	{
		GeeIterator* _file_it;
#line 598 "LibraryMonitor.vala"
		_file_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->import_queue));
#line 598 "LibraryMonitor.vala"
		while (TRUE) {
#line 2739 "LibraryMonitor.c"
			GFile* file;
			FileImportJob* _tmp3_;
#line 598 "LibraryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 598 "LibraryMonitor.vala"
				break;
#line 2746 "LibraryMonitor.c"
			}
#line 598 "LibraryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 599 "LibraryMonitor.vala"
			if (library_monitor_is_blacklisted (file)) {
#line 2752 "LibraryMonitor.c"
				_g_object_unref0 (file);
#line 600 "LibraryMonitor.vala"
				continue;
#line 2756 "LibraryMonitor.c"
			}
#line 602 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (jobs), BATCH_IMPORT_JOB (_tmp3_ = file_import_job_new (file, FALSE)));
#line 2760 "LibraryMonitor.c"
			_batch_import_job_unref0 (_tmp3_);
#line 603 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file);
#line 2764 "LibraryMonitor.c"
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
#line 606 "LibraryMonitor.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->import_queue));
#line 608 "LibraryMonitor.vala"
	importer = batch_import_new (GEE_ITERABLE (jobs), "LibraryMonitor autoimport", NULL, NULL, NULL, NULL, NULL, self->priv->current_import_roll, NULL);
#line 610 "LibraryMonitor.vala"
	batch_import_set_untrash_duplicates (importer, FALSE);
#line 611 "LibraryMonitor.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), importer);
#line 613 "LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 2779 "LibraryMonitor.c"
	result = TRUE;
	_g_object_unref0 (importer);
	_g_object_unref0 (jobs);
#line 615 "LibraryMonitor.vala"
	return result;
#line 2785 "LibraryMonitor.c"
}


#line 669 "LibraryMonitor.vala"
static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender, gpointer self) {
#line 2791 "LibraryMonitor.c"
	library_monitor_on_import_preparing (self);
}


#line 673 "LibraryMonitor.vala"
static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender, guint64 completed_bytes, guint64 total_bytes, gpointer self) {
#line 2798 "LibraryMonitor.c"
	library_monitor_on_import_progress (self, completed_bytes, total_bytes);
}


#line 677 "LibraryMonitor.vala"
static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender, ImportManifest* manifest, BatchImportRoll* import_roll, gpointer self) {
#line 2805 "LibraryMonitor.c"
	library_monitor_on_import_complete (self, _sender, manifest, import_roll);
}


#line 618 "LibraryMonitor.vala"
static void library_monitor_schedule_next_batch_import (LibraryMonitor* self) {
#line 2812 "LibraryMonitor.c"
	gboolean _tmp0_ = FALSE;
	BatchImport* _tmp1_;
#line 618 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 619 "LibraryMonitor.vala"
	if (self->priv->current_batch_import != NULL) {
#line 619 "LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 2821 "LibraryMonitor.c"
	} else {
#line 619 "LibraryMonitor.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue)) == 0;
#line 2825 "LibraryMonitor.c"
	}
#line 619 "LibraryMonitor.vala"
	if (_tmp0_) {
#line 620 "LibraryMonitor.vala"
		return;
#line 2831 "LibraryMonitor.c"
	}
#line 622 "LibraryMonitor.vala"
	self->priv->current_batch_import = (_tmp1_ = (BatchImport*) gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), 0), _g_object_unref0 (self->priv->current_batch_import), _tmp1_);
#line 623 "LibraryMonitor.vala"
	g_signal_connect_object (self->priv->current_batch_import, "preparing", (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self, 0);
#line 624 "LibraryMonitor.vala"
	g_signal_connect_object (self->priv->current_batch_import, "progress", (GCallback) _library_monitor_on_import_progress_batch_import_progress, self, 0);
#line 625 "LibraryMonitor.vala"
	g_signal_connect_object (self->priv->current_batch_import, "import-complete", (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self, 0);
#line 626 "LibraryMonitor.vala"
	batch_import_schedule (self->priv->current_batch_import);
#line 2843 "LibraryMonitor.c"
}


#line 629 "LibraryMonitor.vala"
static void library_monitor_discard_current_batch_import (LibraryMonitor* self) {
#line 2849 "LibraryMonitor.c"
	gboolean removed;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	BatchImport* _tmp3_;
#line 629 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 630 "LibraryMonitor.vala"
	g_assert (self->priv->current_batch_import != NULL);
#line 632 "LibraryMonitor.vala"
	removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), self->priv->current_batch_import);
#line 633 "LibraryMonitor.vala"
	g_assert (removed);
#line 634 "LibraryMonitor.vala"
	g_signal_parse_name ("preparing", TYPE_BATCH_IMPORT, &_tmp0_, NULL, FALSE);
#line 634 "LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self);
#line 635 "LibraryMonitor.vala"
	g_signal_parse_name ("progress", TYPE_BATCH_IMPORT, &_tmp1_, NULL, FALSE);
#line 635 "LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _library_monitor_on_import_progress_batch_import_progress, self);
#line 636 "LibraryMonitor.vala"
	g_signal_parse_name ("import-complete", TYPE_BATCH_IMPORT, &_tmp2_, NULL, FALSE);
#line 636 "LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (self->priv->current_batch_import, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self);
#line 637 "LibraryMonitor.vala"
	self->priv->current_batch_import = (_tmp3_ = NULL, _g_object_unref0 (self->priv->current_batch_import), _tmp3_);
#line 644 "LibraryMonitor.vala"
	if (gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue)) == 0) {
#line 645 "LibraryMonitor.vala"
		gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports));
#line 2881 "LibraryMonitor.c"
	}
}


#line 648 "LibraryMonitor.vala"
static void library_monitor_cancel_batch_imports (LibraryMonitor* self) {
#line 2888 "LibraryMonitor.c"
	gint ctr;
#line 648 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 650 "LibraryMonitor.vala"
	ctr = 0;
#line 651 "LibraryMonitor.vala"
	while (TRUE) {
#line 2896 "LibraryMonitor.c"
		BatchImport* _tmp0_;
		gboolean _tmp1_;
		BatchImport* _tmp2_;
#line 651 "LibraryMonitor.vala"
		if (!(ctr < gee_collection_get_size (GEE_COLLECTION (self->priv->batch_import_queue)))) {
#line 651 "LibraryMonitor.vala"
			break;
#line 2904 "LibraryMonitor.c"
		}
#line 652 "LibraryMonitor.vala"
		if ((_tmp1_ = (_tmp0_ = (BatchImport*) gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), ctr)) == self->priv->current_batch_import, _g_object_unref0 (_tmp0_), _tmp1_)) {
#line 653 "LibraryMonitor.vala"
			ctr++;
#line 655 "LibraryMonitor.vala"
			continue;
#line 2912 "LibraryMonitor.c"
		}
#line 658 "LibraryMonitor.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->batch_import_queue), _tmp2_ = (BatchImport*) gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->batch_import_queue), ctr));
#line 2916 "LibraryMonitor.c"
		_g_object_unref0 (_tmp2_);
	}
#line 662 "LibraryMonitor.vala"
	if (self->priv->current_batch_import != NULL) {
#line 663 "LibraryMonitor.vala"
		batch_import_user_halt (self->priv->current_batch_import);
#line 2923 "LibraryMonitor.c"
	}
#line 666 "LibraryMonitor.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports));
#line 2927 "LibraryMonitor.c"
}


#line 669 "LibraryMonitor.vala"
static void library_monitor_on_import_preparing (LibraryMonitor* self) {
#line 669 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 670 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "auto-import-preparing");
#line 2937 "LibraryMonitor.c"
}


#line 673 "LibraryMonitor.vala"
static void library_monitor_on_import_progress (LibraryMonitor* self, guint64 completed_bytes, guint64 total_bytes) {
#line 673 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 674 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "auto-import-progress", completed_bytes, total_bytes);
#line 2947 "LibraryMonitor.c"
}


#line 677 "LibraryMonitor.vala"
static void library_monitor_on_import_complete (LibraryMonitor* self, BatchImport* batch_import, ImportManifest* manifest, BatchImportRoll* import_roll) {
#line 2953 "LibraryMonitor.c"
	char* _tmp0_;
	char* _tmp3_;
	GError * _inner_error_ = NULL;
#line 677 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 677 "LibraryMonitor.vala"
	g_return_if_fail (IS_BATCH_IMPORT (batch_import));
#line 677 "LibraryMonitor.vala"
	g_return_if_fail (IS_IMPORT_MANIFEST (manifest));
#line 677 "LibraryMonitor.vala"
	g_return_if_fail (IS_BATCH_IMPORT_ROLL (import_roll));
#line 679 "LibraryMonitor.vala"
	g_assert (batch_import == self->priv->current_batch_import);
#line 681 "LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp0_ = g_strdup_printf ("auto-import batch completed %d", gee_collection_get_size (GEE_COLLECTION (manifest->all))));
#line 2969 "LibraryMonitor.c"
	_g_free0 (_tmp0_);
#line 682 "LibraryMonitor.vala"
	g_signal_emit_by_name (self, "auto-import-progress", (guint64) 0, (guint64) 0);
#line 2973 "LibraryMonitor.c"
	{
		GeeIterator* _result_it;
#line 684 "LibraryMonitor.vala"
		_result_it = gee_iterable_iterator (GEE_ITERABLE (manifest->all));
#line 684 "LibraryMonitor.vala"
		while (TRUE) {
#line 2980 "LibraryMonitor.c"
			BatchImportResult* _result_;
#line 684 "LibraryMonitor.vala"
			if (!gee_iterator_next (_result_it)) {
#line 684 "LibraryMonitor.vala"
				break;
#line 2986 "LibraryMonitor.c"
			}
#line 684 "LibraryMonitor.vala"
			_result_ = (BatchImportResult*) gee_iterator_get (_result_it);
#line 687 "LibraryMonitor.vala"
			if (_result_->file != NULL) {
#line 688 "LibraryMonitor.vala"
				gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), _result_->file);
#line 2994 "LibraryMonitor.c"
			}
			_batch_import_result_unref0 (_result_);
		}
		_g_object_unref0 (_result_it);
	}
#line 691 "LibraryMonitor.vala"
	if (gee_collection_get_size (GEE_COLLECTION (manifest->already_imported)) > 0) {
#line 3002 "LibraryMonitor.c"
		GeeArrayList* to_tombstone;
#line 692 "LibraryMonitor.vala"
		to_tombstone = gee_array_list_new (TYPE_TOMBSTONED_FILE, (GBoxedCopyFunc) tombstoned_file_ref, tombstoned_file_unref, NULL);
#line 3006 "LibraryMonitor.c"
		{
			GeeIterator* _result_it;
#line 693 "LibraryMonitor.vala"
			_result_it = gee_iterable_iterator (GEE_ITERABLE (manifest->already_imported));
#line 693 "LibraryMonitor.vala"
			while (TRUE) {
#line 3013 "LibraryMonitor.c"
				BatchImportResult* _result_;
				GFileInfo* info;
				TombstonedFile* _tmp2_;
#line 693 "LibraryMonitor.vala"
				if (!gee_iterator_next (_result_it)) {
#line 693 "LibraryMonitor.vala"
					break;
#line 3021 "LibraryMonitor.c"
				}
#line 693 "LibraryMonitor.vala"
				_result_ = (BatchImportResult*) gee_iterator_get (_result_it);
#line 694 "LibraryMonitor.vala"
				info = directory_monitor_get_file_info (DIRECTORY_MONITOR (self), _result_->file);
#line 695 "LibraryMonitor.vala"
				if (info == NULL) {
#line 3029 "LibraryMonitor.c"
					char* _tmp1_;
#line 696 "LibraryMonitor.vala"
					g_warning ("LibraryMonitor.vala:696: Unable to get info for duplicate file %s", _tmp1_ = g_file_get_path (_result_->file));
#line 3033 "LibraryMonitor.c"
					_g_free0 (_tmp1_);
					_g_object_unref0 (info);
					_batch_import_result_unref0 (_result_);
#line 698 "LibraryMonitor.vala"
					continue;
#line 3039 "LibraryMonitor.c"
				}
#line 701 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_tombstone), _tmp2_ = tombstoned_file_new (_result_->file, g_file_info_get_size (info), NULL));
#line 3043 "LibraryMonitor.c"
				_tombstoned_file_unref0 (_tmp2_);
				_g_object_unref0 (info);
				_batch_import_result_unref0 (_result_);
			}
			_g_object_unref0 (_result_it);
		}
		{
#line 705 "LibraryMonitor.vala"
			tombstone_entomb_many_files (GEE_COLLECTION (to_tombstone), TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE, &_inner_error_);
#line 3053 "LibraryMonitor.c"
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					goto __catch349_database_error;
				}
				_g_object_unref0 (to_tombstone);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally349;
		__catch349_database_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
#line 707 "LibraryMonitor.vala"
				app_window_database_error (err);
#line 3073 "LibraryMonitor.c"
				_g_error_free0 (err);
			}
		}
		__finally349:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (to_tombstone);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_object_unref0 (to_tombstone);
	}
#line 711 "LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp3_ = g_strdup_printf ("%d files remain pending for auto-import", gee_collection_get_size (GEE_COLLECTION (self->priv->pending_imports))));
#line 3088 "LibraryMonitor.c"
	_g_free0 (_tmp3_);
#line 713 "LibraryMonitor.vala"
	library_monitor_discard_current_batch_import (self);
#line 714 "LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 3094 "LibraryMonitor.c"
}


#line 730 "LibraryMonitor.vala"
void library_monitor_blacklist_file (GFile* file, const char* reason) {
#line 3100 "LibraryMonitor.c"
	char* _tmp0_;
	char* _tmp1_;
	GError * _inner_error_ = NULL;
#line 730 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 730 "LibraryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 731 "LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("[%s] Blacklisting %s", reason, _tmp0_ = g_file_get_path (file)));
#line 3110 "LibraryMonitor.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
	{
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		{
#line 733 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
#line 3118 "LibraryMonitor.c"
		}
		__finally350:
		{
			g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


#line 737 "LibraryMonitor.vala"
void library_monitor_unblacklist_file (GFile* file) {
#line 3135 "LibraryMonitor.c"
	GError * _inner_error_ = NULL;
#line 737 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3139 "LibraryMonitor.c"
	{
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		{
			gboolean _tmp0_ = FALSE;
#line 741 "LibraryMonitor.vala"
			if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file)) {
#line 741 "LibraryMonitor.vala"
				_tmp0_ = !timed_queue_contains (TIMED_QUEUE (library_monitor_to_unblacklist), file);
#line 3148 "LibraryMonitor.c"
			} else {
#line 741 "LibraryMonitor.vala"
				_tmp0_ = FALSE;
#line 3152 "LibraryMonitor.c"
			}
#line 741 "LibraryMonitor.vala"
			if (_tmp0_) {
#line 742 "LibraryMonitor.vala"
				timed_queue_enqueue (TIMED_QUEUE (library_monitor_to_unblacklist), file);
#line 3158 "LibraryMonitor.c"
			}
		}
		__finally351:
		{
			g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


#line 746 "LibraryMonitor.vala"
static void library_monitor_on_unblacklist_file (GFile* file) {
#line 3176 "LibraryMonitor.c"
	gboolean removed = FALSE;
	GError * _inner_error_ = NULL;
#line 746 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3181 "LibraryMonitor.c"
	{
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		{
#line 749 "LibraryMonitor.vala"
			removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
#line 3187 "LibraryMonitor.c"
		}
		__finally352:
		{
			g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 752 "LibraryMonitor.vala"
	if (removed) {
#line 3201 "LibraryMonitor.c"
		char* _tmp0_;
		char* _tmp1_;
#line 753 "LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp1_ = g_strdup_printf ("Blacklist for %s removed", _tmp0_ = g_file_get_path (file)));
#line 3206 "LibraryMonitor.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
	} else {
		char* _tmp2_;
#line 755 "LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:755: File %s was not blacklisted but unblacklisted", _tmp2_ = g_file_get_path (file));
#line 3213 "LibraryMonitor.c"
		_g_free0 (_tmp2_);
	}
}


#line 758 "LibraryMonitor.vala"
gboolean library_monitor_is_blacklisted (GFile* file) {
#line 3221 "LibraryMonitor.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 758 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3226 "LibraryMonitor.c"
	{
		g_static_rec_mutex_lock (&__lock_library_monitor_blacklist);
		{
			result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (library_monitor_blacklist), file);
			{
				g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
			}
#line 760 "LibraryMonitor.vala"
			return result;
#line 3236 "LibraryMonitor.c"
		}
		__finally353:
		{
			g_static_rec_mutex_unlock (&__lock_library_monitor_blacklist);
		}
		{
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
}


#line 764 "LibraryMonitor.vala"
static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self, GFile* file) {
#line 3253 "LibraryMonitor.c"
	gboolean result = FALSE;
	MediaCollectionRegistry* _tmp0_;
	MediaSourceCollection* _tmp1_;
	gboolean _tmp2_;
#line 764 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR (self), FALSE);
#line 764 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3262 "LibraryMonitor.c"
	result = (_tmp2_ = (_tmp1_ = media_collection_registry_get_collection_for_file (_tmp0_ = media_collection_registry_get_instance (), file)) != NULL, _data_collection_unref0 (_tmp1_), _media_collection_registry_unref0 (_tmp0_), _tmp2_);
#line 765 "LibraryMonitor.vala"
	return result;
#line 3266 "LibraryMonitor.c"
}


#line 770 "LibraryMonitor.vala"
static void library_monitor_import_unrepresented_files (LibraryMonitor* self) {
#line 3272 "LibraryMonitor.c"
	GeeArrayList* to_import;
#line 770 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 771 "LibraryMonitor.vala"
	if (!self->priv->auto_import) {
#line 772 "LibraryMonitor.vala"
		return;
#line 3280 "LibraryMonitor.c"
	}
#line 774 "LibraryMonitor.vala"
	to_import = NULL;
#line 3284 "LibraryMonitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _file_it;
#line 775 "LibraryMonitor.vala"
		_file_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = directory_monitor_get_files (DIRECTORY_MONITOR (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 775 "LibraryMonitor.vala"
		while (TRUE) {
#line 3293 "LibraryMonitor.c"
			GFile* file;
			GFileInfo* info;
			gboolean _tmp2_ = FALSE;
			gboolean represented;
#line 775 "LibraryMonitor.vala"
			if (!gee_iterator_next (_file_it)) {
#line 775 "LibraryMonitor.vala"
				break;
#line 3302 "LibraryMonitor.c"
			}
#line 775 "LibraryMonitor.vala"
			file = (GFile*) gee_iterator_get (_file_it);
#line 776 "LibraryMonitor.vala"
			info = directory_monitor_get_file_info (DIRECTORY_MONITOR (self), file);
#line 777 "LibraryMonitor.vala"
			if (info == NULL) {
#line 777 "LibraryMonitor.vala"
				_tmp2_ = TRUE;
#line 3312 "LibraryMonitor.c"
			} else {
#line 777 "LibraryMonitor.vala"
				_tmp2_ = g_file_info_get_file_type (info) != G_FILE_TYPE_REGULAR;
#line 3316 "LibraryMonitor.c"
			}
#line 777 "LibraryMonitor.vala"
			if (_tmp2_) {
#line 3320 "LibraryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 778 "LibraryMonitor.vala"
				continue;
#line 3325 "LibraryMonitor.c"
			}
#line 780 "LibraryMonitor.vala"
			if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->pending_imports), file)) {
#line 3329 "LibraryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 781 "LibraryMonitor.vala"
				continue;
#line 3334 "LibraryMonitor.c"
			}
#line 783 "LibraryMonitor.vala"
			if (tombstone_source_collection_matches (tombstone_global, file)) {
#line 3338 "LibraryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 784 "LibraryMonitor.vala"
				continue;
#line 3343 "LibraryMonitor.c"
			}
#line 786 "LibraryMonitor.vala"
			represented = FALSE;
#line 3347 "LibraryMonitor.c"
			{
				GeeIterator* _monitor_it;
#line 787 "LibraryMonitor.vala"
				_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 787 "LibraryMonitor.vala"
				while (TRUE) {
#line 3354 "LibraryMonitor.c"
					MediaMonitor* monitor;
#line 787 "LibraryMonitor.vala"
					if (!gee_iterator_next (_monitor_it)) {
#line 787 "LibraryMonitor.vala"
						break;
#line 3360 "LibraryMonitor.c"
					}
#line 787 "LibraryMonitor.vala"
					monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 788 "LibraryMonitor.vala"
					if (media_monitor_is_file_represented (monitor, file)) {
#line 789 "LibraryMonitor.vala"
						represented = TRUE;
#line 3368 "LibraryMonitor.c"
						_g_object_unref0 (monitor);
#line 791 "LibraryMonitor.vala"
						break;
#line 3372 "LibraryMonitor.c"
					}
					_g_object_unref0 (monitor);
				}
				_g_object_unref0 (_monitor_it);
			}
#line 795 "LibraryMonitor.vala"
			if (represented) {
#line 3380 "LibraryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 796 "LibraryMonitor.vala"
				continue;
#line 3385 "LibraryMonitor.c"
			}
#line 798 "LibraryMonitor.vala"
			if (!library_monitor_is_supported_filetype (self, file)) {
#line 3389 "LibraryMonitor.c"
				_g_object_unref0 (info);
				_g_object_unref0 (file);
#line 799 "LibraryMonitor.vala"
				continue;
#line 3394 "LibraryMonitor.c"
			}
#line 801 "LibraryMonitor.vala"
			if (to_import == NULL) {
#line 3398 "LibraryMonitor.c"
				GeeArrayList* _tmp3_;
#line 802 "LibraryMonitor.vala"
				to_import = (_tmp3_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal), _g_object_unref0 (to_import), _tmp3_);
#line 3402 "LibraryMonitor.c"
			}
#line 804 "LibraryMonitor.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_import), file);
#line 3406 "LibraryMonitor.c"
			_g_object_unref0 (info);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
#line 807 "LibraryMonitor.vala"
	if (to_import != NULL) {
#line 808 "LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, GEE_COLLECTION (to_import));
#line 3416 "LibraryMonitor.c"
	}
	_g_object_unref0 (to_import);
}


#line 813 "LibraryMonitor.vala"
static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self, GFile* file) {
#line 3424 "LibraryMonitor.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 813 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 813 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 814 "LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 814 "LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 3435 "LibraryMonitor.c"
	} else {
#line 814 "LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 3439 "LibraryMonitor.c"
	}
#line 814 "LibraryMonitor.vala"
	if (_tmp1_) {
#line 814 "LibraryMonitor.vala"
		_tmp0_ = !tombstone_source_collection_matches (tombstone_global, file);
#line 3445 "LibraryMonitor.c"
	} else {
#line 814 "LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 3449 "LibraryMonitor.c"
	}
#line 814 "LibraryMonitor.vala"
	if (_tmp0_) {
#line 3453 "LibraryMonitor.c"
		char* _tmp2_;
		char* _tmp3_;
#line 815 "LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp3_ = g_strdup_printf ("Unknown file %s discovered, enqueuing for import", _tmp2_ = g_file_get_path (file)));
#line 3458 "LibraryMonitor.c"
		_g_free0 (_tmp3_);
		_g_free0 (_tmp2_);
#line 816 "LibraryMonitor.vala"
		library_monitor_enqueue_import (self, file);
#line 3463 "LibraryMonitor.c"
	}
}


#line 820 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_created (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
#line 3470 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 820 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 820 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 821 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 822 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (DIRECTORY_MONITOR (self), file, info);
#line 824 "LibraryMonitor.vala"
		return;
#line 3484 "LibraryMonitor.c"
	}
#line 827 "LibraryMonitor.vala"
	known = FALSE;
#line 3488 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 828 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 828 "LibraryMonitor.vala"
		while (TRUE) {
#line 3495 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 828 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 828 "LibraryMonitor.vala"
				break;
#line 3501 "LibraryMonitor.c"
			}
#line 828 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 829 "LibraryMonitor.vala"
			if (media_monitor_notify_file_created (monitor, file, info)) {
#line 830 "LibraryMonitor.vala"
				known = TRUE;
#line 3509 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 832 "LibraryMonitor.vala"
				break;
#line 3513 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 836 "LibraryMonitor.vala"
	if (!known) {
#line 3521 "LibraryMonitor.c"
		GeeHashSet* all_candidates;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
#line 838 "LibraryMonitor.vala"
		all_candidates = NULL;
#line 3527 "LibraryMonitor.c"
		{
			GeeIterator* _monitor_it;
#line 839 "LibraryMonitor.vala"
			_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 839 "LibraryMonitor.vala"
			while (TRUE) {
#line 3534 "LibraryMonitor.c"
				MediaMonitor* monitor;
				MediaMonitorDiscoveredFile _result_ = 0;
				GeeCollection* candidates;
				gboolean _tmp0_ = FALSE;
#line 839 "LibraryMonitor.vala"
				if (!gee_iterator_next (_monitor_it)) {
#line 839 "LibraryMonitor.vala"
					break;
#line 3543 "LibraryMonitor.c"
				}
#line 839 "LibraryMonitor.vala"
				monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 841 "LibraryMonitor.vala"
				candidates = media_monitor_candidates_for_unknown_file (monitor, file, info, &_result_);
#line 843 "LibraryMonitor.vala"
				if (_result_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 843 "LibraryMonitor.vala"
					_tmp0_ = TRUE;
#line 3553 "LibraryMonitor.c"
				} else {
#line 844 "LibraryMonitor.vala"
					_tmp0_ = _result_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 3557 "LibraryMonitor.c"
				}
#line 843 "LibraryMonitor.vala"
				if (_tmp0_) {
#line 3561 "LibraryMonitor.c"
					char* _tmp1_;
					GEnumValue* _tmp2_;
					char* _tmp3_;
					char* _tmp4_;
#line 845 "LibraryMonitor.vala"
					directory_monitor_mdbg (_tmp4_ = g_strdup_printf ("%s %s created file %s", _tmp1_ = media_monitor_to_string (monitor), (_tmp2_ = g_enum_get_value (g_type_class_ref (MEDIA_MONITOR_TYPE_DISCOVERED_FILE), (int) _result_), (_tmp2_ != NULL) ? _tmp2_->value_name : NULL), _tmp3_ = g_file_get_path (file)));
#line 3568 "LibraryMonitor.c"
					_g_free0 (_tmp4_);
					_g_free0 (_tmp3_);
					_g_free0 (_tmp1_);
#line 848 "LibraryMonitor.vala"
					known = TRUE;
#line 3574 "LibraryMonitor.c"
					_g_object_unref0 (candidates);
					_g_object_unref0 (monitor);
#line 850 "LibraryMonitor.vala"
					break;
#line 3579 "LibraryMonitor.c"
				} else {
					gboolean _tmp5_ = FALSE;
#line 851 "LibraryMonitor.vala"
					if (candidates != NULL) {
#line 851 "LibraryMonitor.vala"
						_tmp5_ = gee_collection_get_size (candidates) > 0;
#line 3586 "LibraryMonitor.c"
					} else {
#line 851 "LibraryMonitor.vala"
						_tmp5_ = FALSE;
#line 3590 "LibraryMonitor.c"
					}
#line 851 "LibraryMonitor.vala"
					if (_tmp5_) {
#line 3594 "LibraryMonitor.c"
						char* _tmp6_;
						char* _tmp7_;
						char* _tmp8_;
#line 852 "LibraryMonitor.vala"
						directory_monitor_mdbg (_tmp8_ = g_strdup_printf ("%s suggests %d candidates for created file %s", _tmp6_ = media_monitor_to_string (monitor), gee_collection_get_size (candidates), _tmp7_ = g_file_get_path (file)));
#line 3600 "LibraryMonitor.c"
						_g_free0 (_tmp8_);
						_g_free0 (_tmp7_);
						_g_free0 (_tmp6_);
#line 855 "LibraryMonitor.vala"
						if (all_candidates == NULL) {
#line 3606 "LibraryMonitor.c"
							GeeHashSet* _tmp9_;
#line 856 "LibraryMonitor.vala"
							all_candidates = (_tmp9_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (all_candidates), _tmp9_);
#line 3610 "LibraryMonitor.c"
						}
						{
							GeeIterator* _candidate_it;
#line 858 "LibraryMonitor.vala"
							_candidate_it = gee_iterable_iterator (GEE_ITERABLE (candidates));
#line 858 "LibraryMonitor.vala"
							while (TRUE) {
#line 3618 "LibraryMonitor.c"
								Monitorable* candidate;
#line 858 "LibraryMonitor.vala"
								if (!gee_iterator_next (_candidate_it)) {
#line 858 "LibraryMonitor.vala"
									break;
#line 3624 "LibraryMonitor.c"
								}
#line 858 "LibraryMonitor.vala"
								candidate = (Monitorable*) gee_iterator_get (_candidate_it);
#line 859 "LibraryMonitor.vala"
								if (media_monitor_is_offline (monitor, candidate)) {
#line 860 "LibraryMonitor.vala"
									gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (all_candidates), candidate);
#line 3632 "LibraryMonitor.c"
								}
								_g_object_unref0 (candidate);
							}
							_g_object_unref0 (_candidate_it);
						}
					}
				}
				_g_object_unref0 (candidates);
				_g_object_unref0 (monitor);
			}
			_g_object_unref0 (_monitor_it);
		}
#line 865 "LibraryMonitor.vala"
		if (!known) {
#line 865 "LibraryMonitor.vala"
			_tmp11_ = all_candidates != NULL;
#line 3649 "LibraryMonitor.c"
		} else {
#line 865 "LibraryMonitor.vala"
			_tmp11_ = FALSE;
#line 3653 "LibraryMonitor.c"
		}
#line 865 "LibraryMonitor.vala"
		if (_tmp11_) {
#line 865 "LibraryMonitor.vala"
			_tmp10_ = gee_collection_get_size (GEE_COLLECTION (all_candidates)) > 0;
#line 3659 "LibraryMonitor.c"
		} else {
#line 865 "LibraryMonitor.vala"
			_tmp10_ = FALSE;
#line 3663 "LibraryMonitor.c"
		}
#line 865 "LibraryMonitor.vala"
		if (_tmp10_) {
#line 3667 "LibraryMonitor.c"
			char* _tmp12_;
			char* _tmp13_;
			LibraryMonitorRuntimeFindMoveJob* _tmp14_;
#line 866 "LibraryMonitor.vala"
			directory_monitor_mdbg (_tmp13_ = g_strdup_printf ("%d candidates for created file %s being checksummed", gee_collection_get_size (GEE_COLLECTION (all_candidates)), _tmp12_ = g_file_get_path (file)));
#line 3673 "LibraryMonitor.c"
			_g_free0 (_tmp13_);
			_g_free0 (_tmp12_);
#line 869 "LibraryMonitor.vala"
			workers_enqueue (self->priv->workers, BACKGROUND_JOB (_tmp14_ = library_monitor_runtime_find_move_job_new (self, file, GEE_COLLECTION (all_candidates))));
#line 3678 "LibraryMonitor.c"
			_background_job_unref0 (_tmp14_);
#line 871 "LibraryMonitor.vala"
			known = TRUE;
#line 3682 "LibraryMonitor.c"
		}
		_g_object_unref0 (all_candidates);
	}
#line 875 "LibraryMonitor.vala"
	if (!known) {
#line 876 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 3690 "LibraryMonitor.c"
	}
#line 878 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (DIRECTORY_MONITOR (self), file, info);
#line 3694 "LibraryMonitor.c"
}


#line 881 "LibraryMonitor.vala"
static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self, BackgroundJob* j) {
#line 3700 "LibraryMonitor.c"
	LibraryMonitorRuntimeFindMoveJob* job;
#line 881 "LibraryMonitor.vala"
	g_return_if_fail (IS_LIBRARY_MONITOR (self));
#line 881 "LibraryMonitor.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 882 "LibraryMonitor.vala"
	job = _background_job_ref0 (LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (j));
#line 884 "LibraryMonitor.vala"
	if (job->err != NULL) {
#line 3710 "LibraryMonitor.c"
		char* _tmp0_;
#line 885 "LibraryMonitor.vala"
		g_critical ("LibraryMonitor.vala:885: Error attempting to find a match at runtime f" \
"or %s: %s", _tmp0_ = g_file_get_path (job->file), job->err->message);
#line 3714 "LibraryMonitor.c"
		_g_free0 (_tmp0_);
	}
#line 889 "LibraryMonitor.vala"
	if (job->match != NULL) {
#line 3719 "LibraryMonitor.c"
		MediaMonitor* monitor;
#line 890 "LibraryMonitor.vala"
		monitor = library_monitor_get_monitor_for_monitorable (self, job->match);
#line 891 "LibraryMonitor.vala"
		media_monitor_update_master_file (monitor, job->match, job->file);
#line 892 "LibraryMonitor.vala"
		media_monitor_update_online (monitor, job->match);
#line 3727 "LibraryMonitor.c"
		_g_object_unref0 (monitor);
	} else {
#line 895 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, job->file);
#line 3732 "LibraryMonitor.c"
	}
	_background_job_unref0 (job);
}


#line 899 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_moved (DirectoryMonitor* base, GFile* old_file, GFile* new_file, GFileInfo* new_info) {
#line 3740 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean _tmp0_ = FALSE;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 899 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 899 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 899 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_info));
#line 900 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (old_file)) {
#line 900 "LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 3755 "LibraryMonitor.c"
	} else {
#line 900 "LibraryMonitor.vala"
		_tmp0_ = library_monitor_is_blacklisted (new_file);
#line 3759 "LibraryMonitor.c"
	}
#line 900 "LibraryMonitor.vala"
	if (_tmp0_) {
#line 901 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (DIRECTORY_MONITOR (self), old_file, new_file, new_info);
#line 903 "LibraryMonitor.vala"
		return;
#line 3767 "LibraryMonitor.c"
	}
#line 906 "LibraryMonitor.vala"
	known = FALSE;
#line 3771 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 907 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 907 "LibraryMonitor.vala"
		while (TRUE) {
#line 3778 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 907 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 907 "LibraryMonitor.vala"
				break;
#line 3784 "LibraryMonitor.c"
			}
#line 907 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 908 "LibraryMonitor.vala"
			if (media_monitor_notify_file_moved (monitor, old_file, new_file, new_info)) {
#line 909 "LibraryMonitor.vala"
				known = TRUE;
#line 3792 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 911 "LibraryMonitor.vala"
				break;
#line 3796 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 915 "LibraryMonitor.vala"
	if (!known) {
#line 916 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, new_file);
#line 3806 "LibraryMonitor.c"
	}
#line 918 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (DIRECTORY_MONITOR (self), old_file, new_file, new_info);
#line 3810 "LibraryMonitor.c"
}


#line 921 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_altered (DirectoryMonitor* base, GFile* file) {
#line 3816 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 921 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 922 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 923 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (DIRECTORY_MONITOR (self), file);
#line 925 "LibraryMonitor.vala"
		return;
#line 3828 "LibraryMonitor.c"
	}
#line 928 "LibraryMonitor.vala"
	known = FALSE;
#line 3832 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 929 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 929 "LibraryMonitor.vala"
		while (TRUE) {
#line 3839 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 929 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 929 "LibraryMonitor.vala"
				break;
#line 3845 "LibraryMonitor.c"
			}
#line 929 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 930 "LibraryMonitor.vala"
			if (media_monitor_notify_file_altered (monitor, file)) {
#line 931 "LibraryMonitor.vala"
				known = TRUE;
#line 3853 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 933 "LibraryMonitor.vala"
				break;
#line 3857 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 937 "LibraryMonitor.vala"
	if (!known) {
#line 938 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 3867 "LibraryMonitor.c"
	}
#line 940 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (DIRECTORY_MONITOR (self), file);
#line 3871 "LibraryMonitor.c"
}


#line 943 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base, GFile* file) {
#line 3877 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 943 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 944 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 945 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (DIRECTORY_MONITOR (self), file);
#line 947 "LibraryMonitor.vala"
		return;
#line 3889 "LibraryMonitor.c"
	}
#line 950 "LibraryMonitor.vala"
	known = FALSE;
#line 3893 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 951 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 951 "LibraryMonitor.vala"
		while (TRUE) {
#line 3900 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 951 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 951 "LibraryMonitor.vala"
				break;
#line 3906 "LibraryMonitor.c"
			}
#line 951 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 952 "LibraryMonitor.vala"
			if (media_monitor_notify_file_attributes_altered (monitor, file)) {
#line 953 "LibraryMonitor.vala"
				known = TRUE;
#line 3914 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 955 "LibraryMonitor.vala"
				break;
#line 3918 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 959 "LibraryMonitor.vala"
	if (!known) {
#line 960 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 3928 "LibraryMonitor.c"
	}
#line 962 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (DIRECTORY_MONITOR (self), file);
#line 3932 "LibraryMonitor.c"
}


#line 965 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base, GFile* file, GFileInfo* info) {
#line 3938 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 965 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 965 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 966 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 967 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (DIRECTORY_MONITOR (self), file, info);
#line 969 "LibraryMonitor.vala"
		return;
#line 3952 "LibraryMonitor.c"
	}
#line 972 "LibraryMonitor.vala"
	known = FALSE;
#line 3956 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 973 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 973 "LibraryMonitor.vala"
		while (TRUE) {
#line 3963 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 973 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 973 "LibraryMonitor.vala"
				break;
#line 3969 "LibraryMonitor.c"
			}
#line 973 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 974 "LibraryMonitor.vala"
			if (media_monitor_notify_file_alteration_completed (monitor, file, info)) {
#line 975 "LibraryMonitor.vala"
				known = TRUE;
#line 3977 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 977 "LibraryMonitor.vala"
				break;
#line 3981 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 981 "LibraryMonitor.vala"
	if (!known) {
#line 982 "LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 3991 "LibraryMonitor.c"
	}
#line 984 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (DIRECTORY_MONITOR (self), file, info);
#line 3995 "LibraryMonitor.c"
}


#line 987 "LibraryMonitor.vala"
static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base, GFile* file) {
#line 4001 "LibraryMonitor.c"
	LibraryMonitor * self;
	gboolean known;
	self = LIBRARY_MONITOR (base);
#line 987 "LibraryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 988 "LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 989 "LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (DIRECTORY_MONITOR (self), file);
#line 991 "LibraryMonitor.vala"
		return;
#line 4013 "LibraryMonitor.c"
	}
#line 994 "LibraryMonitor.vala"
	known = FALSE;
#line 4017 "LibraryMonitor.c"
	{
		GeeIterator* _monitor_it;
#line 995 "LibraryMonitor.vala"
		_monitor_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->monitors));
#line 995 "LibraryMonitor.vala"
		while (TRUE) {
#line 4024 "LibraryMonitor.c"
			MediaMonitor* monitor;
#line 995 "LibraryMonitor.vala"
			if (!gee_iterator_next (_monitor_it)) {
#line 995 "LibraryMonitor.vala"
				break;
#line 4030 "LibraryMonitor.c"
			}
#line 995 "LibraryMonitor.vala"
			monitor = (MediaMonitor*) gee_iterator_get (_monitor_it);
#line 996 "LibraryMonitor.vala"
			if (media_monitor_notify_file_deleted (monitor, file)) {
#line 997 "LibraryMonitor.vala"
				known = TRUE;
#line 4038 "LibraryMonitor.c"
				_g_object_unref0 (monitor);
#line 999 "LibraryMonitor.vala"
				break;
#line 4042 "LibraryMonitor.c"
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
#line 1003 "LibraryMonitor.vala"
	if (!known) {
#line 4050 "LibraryMonitor.c"
		Tombstone* tombstone;
#line 1005 "LibraryMonitor.vala"
		tombstone = tombstone_source_collection_locate (tombstone_global, file);
#line 1006 "LibraryMonitor.vala"
		if (tombstone != NULL) {
#line 4056 "LibraryMonitor.c"
			char* _tmp0_;
#line 1007 "LibraryMonitor.vala"
			g_debug ("LibraryMonitor.vala:1007: Resurrecting tombstoned file %s", _tmp0_ = g_file_get_path (file));
#line 4060 "LibraryMonitor.c"
			_g_free0 (_tmp0_);
#line 1008 "LibraryMonitor.vala"
			tombstone_source_collection_resurrect (tombstone_global, tombstone);
#line 4064 "LibraryMonitor.c"
		}
#line 1012 "LibraryMonitor.vala"
		library_monitor_remove_queued_import (self, file);
#line 4068 "LibraryMonitor.c"
		_g_object_unref0 (tombstone);
	}
#line 1015 "LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (DIRECTORY_MONITOR (self), file);
#line 4073 "LibraryMonitor.c"
}


#line 410 "LibraryMonitor.vala"
static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 4079 "LibraryMonitor.c"
	library_monitor_on_find_move_completed (self, job);
}


#line 432 "LibraryMonitor.vala"
static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 4086 "LibraryMonitor.c"
	library_monitor_on_find_move_cancelled (self, job);
}


#line 115 "LibraryMonitor.vala"
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
#line 4093 "LibraryMonitor.c"
	LibraryMonitorFindMoveJob* self = NULL;
	GFile* _tmp0_;
	GeeCollection* _tmp1_;
#line 115 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR (owner), NULL);
#line 115 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 115 "LibraryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (candidates), NULL);
#line 116 "LibraryMonitor.vala"
	self = (LibraryMonitorFindMoveJob*) background_job_construct (object_type, G_OBJECT (owner), _library_monitor_on_find_move_completed_completion_callback, owner, owner->priv->cancellable, _library_monitor_on_find_move_cancelled_cancellation_callback, owner);
#line 118 "LibraryMonitor.vala"
	self->file = (_tmp0_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp0_);
#line 119 "LibraryMonitor.vala"
	self->candidates = (_tmp1_ = _g_object_ref0 (candidates), _g_object_unref0 (self->candidates), _tmp1_);
#line 121 "LibraryMonitor.vala"
	background_job_set_completion_priority (BACKGROUND_JOB (self), G_PRIORITY_LOW);
#line 4111 "LibraryMonitor.c"
	return self;
}


#line 115 "LibraryMonitor.vala"
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
#line 115 "LibraryMonitor.vala"
	return library_monitor_find_move_job_construct (LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, owner, file, candidates);
#line 4120 "LibraryMonitor.c"
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 124 "LibraryMonitor.vala"
static void library_monitor_find_move_job_real_execute (BackgroundJob* base) {
#line 4131 "LibraryMonitor.c"
	LibraryMonitorFindMoveJob * self;
	GeeIterator* iter;
	char* md5;
	GError * _inner_error_ = NULL;
	self = LIBRARY_MONITOR_FIND_MOVE_JOB (base);
#line 126 "LibraryMonitor.vala"
	iter = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
#line 127 "LibraryMonitor.vala"
	while (TRUE) {
#line 4141 "LibraryMonitor.c"
		Monitorable* _tmp0_;
		GFile* _tmp1_;
		gboolean _tmp2_;
#line 127 "LibraryMonitor.vala"
		if (!gee_iterator_next (iter)) {
#line 127 "LibraryMonitor.vala"
			break;
#line 4149 "LibraryMonitor.c"
		}
#line 128 "LibraryMonitor.vala"
		if ((_tmp2_ = g_file_query_exists (_tmp1_ = media_source_get_master_file (MEDIA_SOURCE (_tmp0_ = (Monitorable*) gee_iterator_get (iter))), NULL), _g_object_unref0 (_tmp1_), _g_object_unref0 (_tmp0_), _tmp2_)) {
#line 129 "LibraryMonitor.vala"
			gee_iterator_remove (iter);
#line 4155 "LibraryMonitor.c"
		}
	}
#line 133 "LibraryMonitor.vala"
	if (gee_collection_get_size (self->candidates) == 0) {
#line 4160 "LibraryMonitor.c"
		_g_object_unref0 (iter);
#line 134 "LibraryMonitor.vala"
		return;
#line 4164 "LibraryMonitor.c"
	}
#line 136 "LibraryMonitor.vala"
	md5 = NULL;
#line 4168 "LibraryMonitor.c"
	{
		char* _tmp3_;
		char* _tmp4_;
#line 138 "LibraryMonitor.vala"
		_tmp3_ = md5_file (self->file, &_inner_error_);
#line 4174 "LibraryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch354_g_error;
		}
#line 138 "LibraryMonitor.vala"
		md5 = (_tmp4_ = _tmp3_, _g_free0 (md5), _tmp4_);
#line 4180 "LibraryMonitor.c"
	}
	goto __finally354;
	__catch354_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GError* _tmp5_;
#line 140 "LibraryMonitor.vala"
			self->err = (_tmp5_ = _g_error_copy0 (err), _g_error_free0 (self->err), _tmp5_);
#line 4192 "LibraryMonitor.c"
			_g_error_free0 (err);
			_g_free0 (md5);
			_g_object_unref0 (iter);
#line 142 "LibraryMonitor.vala"
			return;
#line 4198 "LibraryMonitor.c"
		}
	}
	__finally354:
	if (_inner_error_ != NULL) {
		_g_free0 (md5);
		_g_object_unref0 (iter);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GeeIterator* _candidate_it;
#line 145 "LibraryMonitor.vala"
		_candidate_it = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
#line 145 "LibraryMonitor.vala"
		while (TRUE) {
#line 4215 "LibraryMonitor.c"
			Monitorable* candidate;
			char* _tmp6_;
			gboolean _tmp7_;
			Monitorable* _tmp12_;
#line 145 "LibraryMonitor.vala"
			if (!gee_iterator_next (_candidate_it)) {
#line 145 "LibraryMonitor.vala"
				break;
#line 4224 "LibraryMonitor.c"
			}
#line 145 "LibraryMonitor.vala"
			candidate = (Monitorable*) gee_iterator_get (_candidate_it);
#line 146 "LibraryMonitor.vala"
			if ((_tmp7_ = _vala_strcmp0 (_tmp6_ = media_source_get_master_md5 (MEDIA_SOURCE (candidate)), md5) != 0, _g_free0 (_tmp6_), _tmp7_)) {
#line 4230 "LibraryMonitor.c"
				_g_object_unref0 (candidate);
#line 147 "LibraryMonitor.vala"
				continue;
#line 4234 "LibraryMonitor.c"
			}
#line 149 "LibraryMonitor.vala"
			if (self->match != NULL) {
#line 4238 "LibraryMonitor.c"
				char* _tmp8_;
				char* _tmp9_;
				char* _tmp10_;
#line 150 "LibraryMonitor.vala"
				g_warning ("LibraryMonitor.vala:150: Found more than one media match for %s: %s an" \
"d %s", _tmp8_ = g_file_get_path (self->file), _tmp9_ = data_object_to_string (DATA_OBJECT (self->match)), _tmp10_ = data_object_to_string (DATA_OBJECT (candidate)));
#line 4244 "LibraryMonitor.c"
				_g_free0 (_tmp10_);
				_g_free0 (_tmp9_);
				_g_free0 (_tmp8_);
#line 153 "LibraryMonitor.vala"
				if (self->losers == NULL) {
#line 4250 "LibraryMonitor.c"
					GeeArrayList* _tmp11_;
#line 154 "LibraryMonitor.vala"
					self->losers = (_tmp11_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (self->losers), _tmp11_);
#line 4254 "LibraryMonitor.c"
				}
#line 156 "LibraryMonitor.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->losers), candidate);
#line 4258 "LibraryMonitor.c"
				_g_object_unref0 (candidate);
#line 158 "LibraryMonitor.vala"
				continue;
#line 4262 "LibraryMonitor.c"
			}
#line 161 "LibraryMonitor.vala"
			self->match = (_tmp12_ = _g_object_ref0 (candidate), _g_object_unref0 (self->match), _tmp12_);
#line 4266 "LibraryMonitor.c"
			_g_object_unref0 (candidate);
		}
		_g_object_unref0 (_candidate_it);
	}
	_g_free0 (md5);
	_g_object_unref0 (iter);
}


static void library_monitor_find_move_job_class_init (LibraryMonitorFindMoveJobClass * klass) {
	library_monitor_find_move_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = library_monitor_find_move_job_finalize;
	BACKGROUND_JOB_CLASS (klass)->execute = library_monitor_find_move_job_real_execute;
}


static void library_monitor_find_move_job_instance_init (LibraryMonitorFindMoveJob * self) {
	self->match = NULL;
	self->losers = NULL;
	self->err = NULL;
}


static void library_monitor_find_move_job_finalize (BackgroundJob* obj) {
	LibraryMonitorFindMoveJob * self;
	self = LIBRARY_MONITOR_FIND_MOVE_JOB (obj);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->candidates);
	_g_object_unref0 (self->match);
	_g_object_unref0 (self->losers);
	_g_error_free0 (self->err);
	BACKGROUND_JOB_CLASS (library_monitor_find_move_job_parent_class)->finalize (obj);
}


static GType library_monitor_find_move_job_get_type (void) {
	static volatile gsize library_monitor_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorFindMoveJob), 0, (GInstanceInitFunc) library_monitor_find_move_job_instance_init, NULL };
		GType library_monitor_find_move_job_type_id;
		library_monitor_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_find_move_job_type_id__volatile, library_monitor_find_move_job_type_id);
	}
	return library_monitor_find_move_job_type_id__volatile;
}


#line 881 "LibraryMonitor.vala"
static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 4316 "LibraryMonitor.c"
	library_monitor_on_runtime_find_move_completed (self, job);
}


#line 172 "LibraryMonitor.vala"
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type, LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
#line 4323 "LibraryMonitor.c"
	LibraryMonitorRuntimeFindMoveJob* self = NULL;
	GFile* _tmp0_;
	GeeCollection* _tmp1_;
#line 172 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_LIBRARY_MONITOR (owner), NULL);
#line 172 "LibraryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 172 "LibraryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (candidates), NULL);
#line 173 "LibraryMonitor.vala"
	self = (LibraryMonitorRuntimeFindMoveJob*) background_job_construct (object_type, G_OBJECT (owner), _library_monitor_on_runtime_find_move_completed_completion_callback, owner, owner->priv->cancellable, NULL, NULL);
#line 175 "LibraryMonitor.vala"
	self->file = (_tmp0_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp0_);
#line 176 "LibraryMonitor.vala"
	self->candidates = (_tmp1_ = _g_object_ref0 (candidates), _g_object_unref0 (self->candidates), _tmp1_);
#line 178 "LibraryMonitor.vala"
	background_job_set_completion_priority (BACKGROUND_JOB (self), G_PRIORITY_LOW);
#line 4341 "LibraryMonitor.c"
	return self;
}


#line 172 "LibraryMonitor.vala"
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner, GFile* file, GeeCollection* candidates) {
#line 172 "LibraryMonitor.vala"
	return library_monitor_runtime_find_move_job_construct (LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, owner, file, candidates);
#line 4350 "LibraryMonitor.c"
}


#line 181 "LibraryMonitor.vala"
static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base) {
#line 4356 "LibraryMonitor.c"
	LibraryMonitorRuntimeFindMoveJob * self;
	char* md5;
	GError * _inner_error_ = NULL;
	self = LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (base);
#line 182 "LibraryMonitor.vala"
	md5 = NULL;
#line 4363 "LibraryMonitor.c"
	{
		char* _tmp0_;
		char* _tmp1_;
#line 184 "LibraryMonitor.vala"
		_tmp0_ = md5_file (self->file, &_inner_error_);
#line 4369 "LibraryMonitor.c"
		if (_inner_error_ != NULL) {
			goto __catch355_g_error;
		}
#line 184 "LibraryMonitor.vala"
		md5 = (_tmp1_ = _tmp0_, _g_free0 (md5), _tmp1_);
#line 4375 "LibraryMonitor.c"
	}
	goto __finally355;
	__catch355_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			GError* _tmp2_;
#line 186 "LibraryMonitor.vala"
			self->err = (_tmp2_ = _g_error_copy0 (err), _g_error_free0 (self->err), _tmp2_);
#line 4387 "LibraryMonitor.c"
			_g_error_free0 (err);
			_g_free0 (md5);
#line 188 "LibraryMonitor.vala"
			return;
#line 4392 "LibraryMonitor.c"
		}
	}
	__finally355:
	if (_inner_error_ != NULL) {
		_g_free0 (md5);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GeeIterator* _candidate_it;
#line 191 "LibraryMonitor.vala"
		_candidate_it = gee_iterable_iterator (GEE_ITERABLE (self->candidates));
#line 191 "LibraryMonitor.vala"
		while (TRUE) {
#line 4408 "LibraryMonitor.c"
			Monitorable* candidate;
			char* _tmp3_;
			gboolean _tmp4_;
#line 191 "LibraryMonitor.vala"
			if (!gee_iterator_next (_candidate_it)) {
#line 191 "LibraryMonitor.vala"
				break;
#line 4416 "LibraryMonitor.c"
			}
#line 191 "LibraryMonitor.vala"
			candidate = (Monitorable*) gee_iterator_get (_candidate_it);
#line 192 "LibraryMonitor.vala"
			if ((_tmp4_ = _vala_strcmp0 (_tmp3_ = media_source_get_master_md5 (MEDIA_SOURCE (candidate)), md5) == 0, _g_free0 (_tmp3_), _tmp4_)) {
#line 4422 "LibraryMonitor.c"
				Monitorable* _tmp5_;
#line 193 "LibraryMonitor.vala"
				self->match = (_tmp5_ = _g_object_ref0 (candidate), _g_object_unref0 (self->match), _tmp5_);
#line 4426 "LibraryMonitor.c"
				_g_object_unref0 (candidate);
#line 195 "LibraryMonitor.vala"
				break;
#line 4430 "LibraryMonitor.c"
			}
			_g_object_unref0 (candidate);
		}
		_g_object_unref0 (_candidate_it);
	}
	_g_free0 (md5);
}


static void library_monitor_runtime_find_move_job_class_init (LibraryMonitorRuntimeFindMoveJobClass * klass) {
	library_monitor_runtime_find_move_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = library_monitor_runtime_find_move_job_finalize;
	BACKGROUND_JOB_CLASS (klass)->execute = library_monitor_runtime_find_move_job_real_execute;
}


static void library_monitor_runtime_find_move_job_instance_init (LibraryMonitorRuntimeFindMoveJob * self) {
	self->match = NULL;
	self->err = NULL;
}


static void library_monitor_runtime_find_move_job_finalize (BackgroundJob* obj) {
	LibraryMonitorRuntimeFindMoveJob * self;
	self = LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB (obj);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->candidates);
	_g_object_unref0 (self->match);
	_g_error_free0 (self->err);
	BACKGROUND_JOB_CLASS (library_monitor_runtime_find_move_job_parent_class)->finalize (obj);
}


static GType library_monitor_runtime_find_move_job_get_type (void) {
	static volatile gsize library_monitor_runtime_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_runtime_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorRuntimeFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_runtime_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorRuntimeFindMoveJob), 0, (GInstanceInitFunc) library_monitor_runtime_find_move_job_instance_init, NULL };
		GType library_monitor_runtime_find_move_job_type_id;
		library_monitor_runtime_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorRuntimeFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_runtime_find_move_job_type_id__volatile, library_monitor_runtime_find_move_job_type_id);
	}
	return library_monitor_runtime_find_move_job_type_id__volatile;
}


#line 205 "LibraryMonitor.vala"
static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type, Monitorable* monitorable, MediaMonitor* monitor) {
#line 4478 "LibraryMonitor.c"
	LibraryMonitorVerifyJob* self = (LibraryMonitorVerifyJob*) g_type_create_instance (object_type);
	Monitorable* _tmp0_;
	MediaMonitor* _tmp1_;
#line 205 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_MONITORABLE (monitorable), NULL);
#line 205 "LibraryMonitor.vala"
	g_return_val_if_fail (IS_MEDIA_MONITOR (monitor), NULL);
#line 206 "LibraryMonitor.vala"
	self->monitorable = (_tmp0_ = _g_object_ref0 (monitorable), _g_object_unref0 (self->monitorable), _tmp0_);
#line 207 "LibraryMonitor.vala"
	self->monitor = (_tmp1_ = _g_object_ref0 (monitor), _g_object_unref0 (self->monitor), _tmp1_);
#line 4490 "LibraryMonitor.c"
	return self;
}


#line 205 "LibraryMonitor.vala"
static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable, MediaMonitor* monitor) {
#line 205 "LibraryMonitor.vala"
	return library_monitor_verify_job_construct (LIBRARY_MONITOR_TYPE_VERIFY_JOB, monitorable, monitor);
#line 4499 "LibraryMonitor.c"
}


static void library_monitor_value_verify_job_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void library_monitor_value_verify_job_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		library_monitor_verify_job_unref (value->data[0].v_pointer);
	}
}


static void library_monitor_value_verify_job_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = library_monitor_verify_job_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer library_monitor_value_verify_job_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* library_monitor_value_verify_job_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		LibraryMonitorVerifyJob* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = library_monitor_verify_job_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* library_monitor_value_verify_job_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	LibraryMonitorVerifyJob** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = library_monitor_verify_job_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	LibraryMonitorParamSpecVerifyJob* spec;
	g_return_val_if_fail (g_type_is_a (object_type, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer library_monitor_value_get_verify_job (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
	return value->data[0].v_pointer;
}


static void library_monitor_value_set_verify_job (GValue* value, gpointer v_object) {
	LibraryMonitorVerifyJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		library_monitor_verify_job_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_verify_job_unref (old);
	}
}


static void library_monitor_value_take_verify_job (GValue* value, gpointer v_object) {
	LibraryMonitorVerifyJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		library_monitor_verify_job_unref (old);
	}
}


static void library_monitor_verify_job_class_init (LibraryMonitorVerifyJobClass * klass) {
	library_monitor_verify_job_parent_class = g_type_class_peek_parent (klass);
	LIBRARY_MONITOR_VERIFY_JOB_CLASS (klass)->finalize = library_monitor_verify_job_finalize;
}


static void library_monitor_verify_job_instance_init (LibraryMonitorVerifyJob * self) {
	self->ref_count = 1;
}


static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob* obj) {
	LibraryMonitorVerifyJob * self;
	self = LIBRARY_MONITOR_VERIFY_JOB (obj);
	_g_object_unref0 (self->monitorable);
	_g_object_unref0 (self->monitor);
}


static GType library_monitor_verify_job_get_type (void) {
	static volatile gsize library_monitor_verify_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_verify_job_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { library_monitor_value_verify_job_init, library_monitor_value_verify_job_free_value, library_monitor_value_verify_job_copy_value, library_monitor_value_verify_job_peek_pointer, "p", library_monitor_value_verify_job_collect_value, "p", library_monitor_value_verify_job_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorVerifyJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_verify_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorVerifyJob), 0, (GInstanceInitFunc) library_monitor_verify_job_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_verify_job_type_id;
		library_monitor_verify_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorVerifyJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&library_monitor_verify_job_type_id__volatile, library_monitor_verify_job_type_id);
	}
	return library_monitor_verify_job_type_id__volatile;
}


static gpointer library_monitor_verify_job_ref (gpointer instance) {
	LibraryMonitorVerifyJob* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void library_monitor_verify_job_unref (gpointer instance) {
	LibraryMonitorVerifyJob* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void library_monitor_class_init (LibraryMonitorClass * klass) {
	library_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LibraryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->close = library_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = library_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = library_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = library_monitor_real_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = library_monitor_real_notify_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = library_monitor_real_notify_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = library_monitor_real_notify_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = library_monitor_real_notify_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = library_monitor_real_notify_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = library_monitor_real_notify_file_deleted;
	G_OBJECT_CLASS (klass)->finalize = library_monitor_finalize;
	g_signal_new ("auto_update_progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	g_signal_new ("auto_import_preparing", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("auto_import_progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT64_UINT64, G_TYPE_NONE, 2, G_TYPE_UINT64, G_TYPE_UINT64);
	g_static_rec_mutex_init (&__lock_library_monitor_blacklist);
	library_monitor_blacklist = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	library_monitor_to_unblacklist = hash_timed_queue_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, (guint) LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC, _library_monitor_on_unblacklist_file_dequeued_callback, NULL, g_file_hash, g_file_equal, G_PRIORITY_LOW);
}


static void library_monitor_instance_init (LibraryMonitor * self) {
	self->priv = LIBRARY_MONITOR_GET_PRIVATE (self);
	self->priv->workers = workers_new (workers_thread_per_cpu_minus_one (), FALSE);
	self->priv->cancellable = g_cancellable_new ();
	self->priv->auto_import = FALSE;
	self->priv->unknown_files = NULL;
	self->priv->monitors = GEE_LIST (gee_array_list_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->priv->discovered = NULL;
	self->priv->import_queue = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	self->priv->pending_imports = gee_hash_set_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal);
	self->priv->batch_import_queue = gee_array_list_new (TYPE_BATCH_IMPORT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->priv->current_import_roll = NULL;
	self->priv->last_import_roll_use = (time_t) 0;
	self->priv->current_batch_import = NULL;
	self->priv->checksums_completed = 0;
	self->priv->checksums_total = 0;
	self->priv->import_queue_timer_id = (guint) 0;
	self->priv->verify_queue = GEE_QUEUE (gee_linked_list_new (LIBRARY_MONITOR_TYPE_VERIFY_JOB, (GBoxedCopyFunc) library_monitor_verify_job_ref, library_monitor_verify_job_unref, NULL));
	self->priv->outstanding_verify_jobs = 0;
	self->priv->completed_monitorable_verifies = 0;
	self->priv->total_monitorable_verifies = 0;
}


static void library_monitor_finalize (GObject* obj) {
	LibraryMonitor * self;
	self = LIBRARY_MONITOR (obj);
	{
		Config* _tmp0_;
		guint _tmp1_;
#line 252 "LibraryMonitor.vala"
		g_signal_parse_name ("bool-changed", TYPE_CONFIG, &_tmp1_, NULL, FALSE);
#line 252 "LibraryMonitor.vala"
		g_signal_handlers_disconnect_matched (_tmp0_ = config_get_instance (), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _library_monitor_on_config_bool_changed_config_bool_changed, self);
#line 4721 "LibraryMonitor.c"
		_config_unref0 (_tmp0_);
	}
	_workers_unref0 (self->priv->workers);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->unknown_files);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->discovered);
	_g_object_unref0 (self->priv->import_queue);
	_g_object_unref0 (self->priv->pending_imports);
	_g_object_unref0 (self->priv->batch_import_queue);
	_batch_import_roll_unref0 (self->priv->current_import_roll);
	_g_object_unref0 (self->priv->current_batch_import);
	_g_object_unref0 (self->priv->verify_queue);
	G_OBJECT_CLASS (library_monitor_parent_class)->finalize (obj);
}


GType library_monitor_get_type (void) {
	static volatile gsize library_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitor), 0, (GInstanceInitFunc) library_monitor_instance_init, NULL };
		GType library_monitor_type_id;
		library_monitor_type_id = g_type_register_static (TYPE_DIRECTORY_MONITOR, "LibraryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_type_id__volatile, library_monitor_type_id);
	}
	return library_monitor_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT64_UINT64) (gpointer data1, guint64 arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT64_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT64_UINT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint64 (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
}



